/* DUPLICATOR-LITE (PHP BUILD MODE) MYSQL SCRIPT CREATED ON : 2020-05-03 11:01:28 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_522243_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_522243_itsec_distributed_storage` (
  `storage_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `storage_group` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `storage_key` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `storage_chunk` int(11) NOT NULL DEFAULT '0',
  `storage_data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `storage_updated` datetime NOT NULL,
  PRIMARY KEY (`storage_id`),
  UNIQUE KEY `storage_group__key__chunk` (`storage_group`,`storage_key`,`storage_chunk`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_fingerprints` (
  `fingerprint_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `fingerprint_user` bigint(20) unsigned NOT NULL,
  `fingerprint_hash` char(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_created_at` datetime NOT NULL,
  `fingerprint_approved_at` datetime NOT NULL,
  `fingerprint_data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_snapshot` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_last_seen` datetime NOT NULL,
  `fingerprint_uses` int(11) NOT NULL DEFAULT '0',
  `fingerprint_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_uuid` char(36) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`fingerprint_id`),
  UNIQUE KEY `fingerprint_user__hash` (`fingerprint_user`,`fingerprint_hash`),
  UNIQUE KEY `fingerprint_uuid` (`fingerprint_uuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_geolocation_cache` (
  `location_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `location_host` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_lat` decimal(10,8) NOT NULL,
  `location_long` decimal(11,8) NOT NULL,
  `location_label` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_credit` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_time` datetime NOT NULL,
  PRIMARY KEY (`location_id`),
  UNIQUE KEY `location_host` (`location_host`),
  KEY `location_time` (`location_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_lockouts` (
  `lockout_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `lockout_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `lockout_start` datetime NOT NULL,
  `lockout_start_gmt` datetime NOT NULL,
  `lockout_expire` datetime NOT NULL,
  `lockout_expire_gmt` datetime NOT NULL,
  `lockout_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `lockout_user` bigint(20) unsigned DEFAULT NULL,
  `lockout_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `lockout_active` int(1) NOT NULL DEFAULT '1',
  `lockout_context` text COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`lockout_id`),
  KEY `lockout_expire_gmt` (`lockout_expire_gmt`),
  KEY `lockout_host` (`lockout_host`),
  KEY `lockout_user` (`lockout_user`),
  KEY `lockout_username` (`lockout_username`),
  KEY `lockout_active` (`lockout_active`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_logs` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `module` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `code` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'notice',
  `timestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `init_timestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `memory_current` bigint(20) unsigned NOT NULL DEFAULT '0',
  `memory_peak` bigint(20) unsigned NOT NULL DEFAULT '0',
  `url` varchar(500) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `blog_id` bigint(20) NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `remote_ip` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `module` (`module`),
  KEY `code` (`code`),
  KEY `type` (`type`),
  KEY `timestamp` (`timestamp`),
  KEY `user_id` (`user_id`),
  KEY `blog_id` (`blog_id`),
  KEY `init_timestamp` (`init_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_mutexes` (
  `mutex_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `mutex_name` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `mutex_expires` int(11) unsigned NOT NULL,
  PRIMARY KEY (`mutex_id`),
  UNIQUE KEY `mutex_name` (`mutex_name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_opaque_tokens` (
  `token_id` char(64) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `token_hashed` char(64) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `token_type` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `token_data` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `token_created_at` datetime NOT NULL,
  PRIMARY KEY (`token_id`),
  UNIQUE KEY `token_hashed` (`token_hashed`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_temp` (
  `temp_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `temp_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `temp_date` datetime NOT NULL,
  `temp_date_gmt` datetime NOT NULL,
  `temp_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `temp_user` bigint(20) unsigned DEFAULT NULL,
  `temp_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`temp_id`),
  KEY `temp_date_gmt` (`temp_date_gmt`),
  KEY `temp_host` (`temp_host`),
  KEY `temp_user` (`temp_user`),
  KEY `temp_username` (`temp_username`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_itsec_user_groups` (
  `group_id` char(36) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `group_label` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `group_roles` text COLLATE utf8mb4_unicode_520_ci,
  `group_canonical` text COLLATE utf8mb4_unicode_520_ci,
  `group_users` text COLLATE utf8mb4_unicode_520_ci,
  `group_min_role` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `group_created_at` datetime DEFAULT NULL,
  PRIMARY KEY (`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB AUTO_INCREMENT=661 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=637 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=407 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_rio_process_queue` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `server_id` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `object_id` bigint(20) unsigned DEFAULT NULL,
  `object_name` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `item_type` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `item_hash` char(64) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL COMMENT 'sha256 size',
  `item_hash_alternative` char(64) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL COMMENT 'sha256 size',
  `result_status` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `processing_level` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `is_backed_up` tinyint(1) NOT NULL DEFAULT '0',
  `original_size` int(11) unsigned NOT NULL,
  `final_size` int(11) unsigned NOT NULL,
  `original_mime_type` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `final_mime_type` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `extra_data` text COLLATE utf8mb4_unicode_520_ci,
  `created_at` bigint(20) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index-hash` (`item_hash`),
  KEY `index-type-status` (`item_type`,`result_status`),
  KEY `index-type-status-level` (`item_type`,`result_status`,`processing_level`),
  KEY `index-hash-alternative` (`item_hash_alternative`),
  KEY `index-type-attachments` (`object_id`,`item_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_snippets` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `name` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `description` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `code` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `tags` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `scope` varchar(15) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'global',
  `priority` smallint(6) NOT NULL DEFAULT '10',
  `active` tinyint(1) NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_522243_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


/* INSERT TABLE DATA: wp_522243_duplicator_packages */
INSERT INTO `wp_522243_duplicator_packages` VALUES("1", "20200503_nikkijames", "31b485d2a8e890fe7278_20200503110116", "21", "2020-05-03 11:01:28", "unknown", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-05-03 11:01:16\";s:7:\"Version\";s:6:\"1.3.30\";s:9:\"VersionWP\";s:5:\"5.4.1\";s:9:\"VersionDB\";s:6:\"5.7.27\";s:10:\"VersionPHP\";s:6:\"7.3.17\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";i:1;s:4:\"Name\";s:19:\"20200503_nikkijames\";s:4:\"Hash\";s:35:\"31b485d2a8e890fe7278_20200503110116\";s:8:\"NameHash\";s:55:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:74:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-snapshots/tmp\";s:8:\"StoreURL\";s:36:\"https://nikkijames.net/wp-snapshots/\";s:8:\"ScanFile\";s:65:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";s:4:\"20.8\";s:6:\"WPUser\";s:7:\"unknown\";s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:75:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/cache;\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:22:\"zip;rar;tar;gz;bz2;7z;\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:1;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:67:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:57:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-05-03 11:01:16\";s:7:\"Version\";s:6:\"1.3.30\";s:9:\"VersionWP\";s:5:\"5.4.1\";s:9:\"VersionDB\";s:6:\"5.7.27\";s:10:\"VersionPHP\";s:6:\"7.3.17\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:19:\"20200503_nikkijames\";s:4:\"Hash\";s:35:\"31b485d2a8e890fe7278_20200503110116\";s:8:\"NameHash\";s:55:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:74:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-snapshots/tmp\";s:8:\"StoreURL\";s:36:\"https://nikkijames.net/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:69:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:68:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:0;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:1:{s:21:\"wp_522243_commentmeta\";s:1:\"0\";}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";s:143:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-snapshots/tmp/20200503_nikkijames_31b485d2a8e890fe7278_20200503110116_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:66:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-admin\";i:1;s:76:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/uploads\";i:2;s:78:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/languages\";i:3;s:75:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/themes\";i:4;s:69:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:57:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames\";i:1;s:68:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content\";}}s:9:\"Installer\";r:86;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:130;}");

/* INSERT TABLE DATA: wp_522243_itsec_user_groups */
INSERT INTO `wp_522243_itsec_user_groups` VALUES("02bc00bf-5cce-4b18-a2fb-2072b4251d08", "Contributor Users", "", "contributor", "", "", "2020-05-03 09:48:11");
INSERT INTO `wp_522243_itsec_user_groups` VALUES("3d7f7da3-e285-4266-a941-7875c1a8dd01", "Editor Users", "", "editor", "", "", "2020-05-03 09:48:11");
INSERT INTO `wp_522243_itsec_user_groups` VALUES("3e4faae7-d876-437c-9039-9dd8d068c25f", "Author Users", "", "author", "", "", "2020-05-03 09:48:11");
INSERT INTO `wp_522243_itsec_user_groups` VALUES("5912c641-9efa-493d-b0dc-f391e7ffa619", "Administrator Users", "", "administrator", "", "", "2020-05-03 09:48:11");
INSERT INTO `wp_522243_itsec_user_groups` VALUES("9bfbca8a-cc02-40a5-a2ec-d5917c541a91", "Subscriber Users", "", "subscriber", "", "", "2020-05-03 09:48:11");

/* INSERT TABLE DATA: wp_522243_options */
INSERT INTO `wp_522243_options` VALUES("1", "siteurl", "http://nikkijames.net", "yes");
INSERT INTO `wp_522243_options` VALUES("2", "home", "http://nikkijames.net", "yes");
INSERT INTO `wp_522243_options` VALUES("3", "blogname", "Nikki James", "yes");
INSERT INTO `wp_522243_options` VALUES("4", "blogdescription", "", "yes");
INSERT INTO `wp_522243_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("6", "admin_email", "stickysites@protonmail.com", "yes");
INSERT INTO `wp_522243_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_522243_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_522243_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_522243_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_522243_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_522243_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("19", "default_comment_status", "open", "yes");
INSERT INTO `wp_522243_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_522243_options` VALUES("21", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_522243_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_522243_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_522243_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_522243_options` VALUES("26", "comment_moderation", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_522243_options` VALUES("29", "rewrite_rules", "a:106:{s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:38:\"aam_policy/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:48:\"aam_policy/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:68:\"aam_policy/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:63:\"aam_policy/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:63:\"aam_policy/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:44:\"aam_policy/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:27:\"aam_policy/([^/]+)/embed/?$\";s:43:\"index.php?aam_policy=$matches[1]&embed=true\";s:31:\"aam_policy/([^/]+)/trackback/?$\";s:37:\"index.php?aam_policy=$matches[1]&tb=1\";s:39:\"aam_policy/([^/]+)/page/?([0-9]{1,})/?$\";s:50:\"index.php?aam_policy=$matches[1]&paged=$matches[2]\";s:46:\"aam_policy/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?aam_policy=$matches[1]&cpage=$matches[2]\";s:35:\"aam_policy/([^/]+)(?:/([0-9]+))?/?$\";s:49:\"index.php?aam_policy=$matches[1]&page=$matches[2]\";s:27:\"aam_policy/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"aam_policy/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"aam_policy/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"aam_policy/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"aam_policy/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"aam_policy/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:13:\"favicon\\.ico$\";s:19:\"index.php?favicon=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:40:\"index.php?&page_id=287&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"([^/]+)/embed/?$\";s:37:\"index.php?name=$matches[1]&embed=true\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:24:\"([^/]+)(?:/([0-9]+))?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:22:\"[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_522243_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_522243_options` VALUES("33", "active_plugins", "a:28:{i:0;s:31:\"advanced-access-manager/aam.php\";i:1;s:61:\"all-404-redirect-to-homepage/all-404-redirect-to-homepage.php\";i:2;s:41:\"all-in-one-favicon/all-in-one-favicon.php\";i:3;s:35:\"backupwordpress/backupwordpress.php\";i:4;s:47:\"better-search-replace/better-search-replace.php\";i:5;s:41:\"better-wp-security/better-wp-security.php\";i:6;s:63:\"block-specific-plugin-updates/block-specific-plugin-updates.php\";i:7;s:33:\"classic-editor/classic-editor.php\";i:8;s:31:\"code-snippets/code-snippets.php\";i:9;s:63:\"dashboard-welcome-for-elementor/dashboard-welcome-elementor.php\";i:10;s:37:\"disable-comments/disable-comments.php\";i:11;s:35:\"disable-xml-rpc/disable-xml-rpc.php\";i:12;s:33:\"duplicate-post/duplicate-post.php\";i:13;s:25:\"duplicator/duplicator.php\";i:14;s:37:\"elementor-extras/elementor-extras.php\";i:15;s:31:\"elementor-pro/elementor-pro.php\";i:16;s:23:\"elementor/elementor.php\";i:17;s:53:\"flexible-elementor-panel/flexible-elementor-panel.php\";i:18;s:25:\"login-logo/login-logo.php\";i:19;s:53:\"mousewheel-smooth-scroll/mousewheel-smooth-scroll.php\";i:20;s:53:\"page-management-dropdown/page-management-dropdown.php\";i:21;s:41:\"password-protected/password-protected.php\";i:22;s:61:\"premium-addons-for-elementor/premium-addons-for-elementor.php\";i:23;s:37:\"rcd-right-click-disabler/rcd-main.php\";i:24;s:36:\"reusable-text-blocks/text-blocks.php\";i:25;s:47:\"robin-image-optimizer/robin-image-optimizer.php\";i:26;s:53:\"w2o-admin-drop-down-menu/w2o-admin-drop-down-menu.php\";i:27;s:21:\"wp-sweep/wp-sweep.php\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_522243_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_522243_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_522243_options` VALUES("37", "gmt_offset", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("39", "recently_edited", "", "no");
INSERT INTO `wp_522243_options` VALUES("40", "template", "hello-elementor", "yes");
INSERT INTO `wp_522243_options` VALUES("41", "stylesheet", "hello-elementor", "yes");
INSERT INTO `wp_522243_options` VALUES("42", "comment_whitelist", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("43", "blacklist_keys", "", "no");
INSERT INTO `wp_522243_options` VALUES("44", "comment_registration", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `wp_522243_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `wp_522243_options` VALUES("48", "db_version", "47018", "yes");
INSERT INTO `wp_522243_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `wp_522243_options` VALUES("51", "blog_public", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("52", "default_link_category", "2", "yes");
INSERT INTO `wp_522243_options` VALUES("53", "show_on_front", "page", "yes");
INSERT INTO `wp_522243_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `wp_522243_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `wp_522243_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `wp_522243_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_522243_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_522243_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `wp_522243_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `wp_522243_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `wp_522243_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `wp_522243_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `wp_522243_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `wp_522243_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `wp_522243_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `wp_522243_options` VALUES("69", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_522243_options` VALUES("71", "thread_comments", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_522243_options` VALUES("73", "page_comments", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `wp_522243_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `wp_522243_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `wp_522243_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("78", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("79", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("80", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("81", "uninstall_plugins", "a:6:{s:27:\"wp-super-cache/wp-cache.php\";s:22:\"wpsupercache_uninstall\";s:31:\"advanced-access-manager/aam.php\";a:2:{i:0;s:3:\"AAM\";i:1;s:9:\"uninstall\";}s:23:\"elementor/elementor.php\";a:2:{i:0;s:21:\"Elementor\\Maintenance\";i:1;s:9:\"uninstall\";}s:41:\"better-wp-security/better-wp-security.php\";a:2:{i:0;s:10:\"ITSEC_Core\";i:1;s:16:\"handle_uninstall\";}s:33:\"classic-editor/classic-editor.php\";a:2:{i:0;s:14:\"Classic_Editor\";i:1;s:9:\"uninstall\";}s:41:\"all-in-one-favicon/all-in-one-favicon.php\";a:2:{i:0;s:15:\"AllInOneFavicon\";i:1;s:19:\"uninstallAioFavicon\";}}", "no");
INSERT INTO `wp_522243_options` VALUES("82", "timezone_string", "America/Los_Angeles", "yes");
INSERT INTO `wp_522243_options` VALUES("83", "page_for_posts", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("84", "page_on_front", "287", "yes");
INSERT INTO `wp_522243_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("88", "site_icon", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_522243_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("91", "wp_page_for_privacy_policy", "3", "yes");
INSERT INTO `wp_522243_options` VALUES("92", "show_comments_cookies_opt_in", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("93", "admin_email_lifespan", "1603966248", "yes");
INSERT INTO `wp_522243_options` VALUES("94", "initial_db_version", "47018", "yes");
INSERT INTO `wp_522243_options` VALUES("95", "wp_522243_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:10:\"copy_posts\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:35:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:10:\"copy_posts\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_522243_options` VALUES("96", "fresh_site", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("97", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("98", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("99", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("100", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("101", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("102", "sidebars_widgets", "a:2:{s:19:\"wp_inactive_widgets\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_522243_options` VALUES("103", "vod_infomaniak", "a:18:{s:5:\"width\";i:480;s:6:\"height\";i:360;s:8:\"template\";s:7:\"{video}\";s:7:\"stretch\";i:0;s:4:\"loop\";i:0;s:8:\"autoplay\";i:0;s:7:\"privacy\";i:0;s:5:\"wtext\";s:0:\"\";s:6:\"wtitle\";s:0:\"\";s:3:\"tag\";s:3:\"vod\";s:6:\"iframe\";s:2:\"on\";s:18:\"updateFilterFolder\";s:0:\"\";s:17:\"vod_api_connected\";s:3:\"off\";s:21:\"vod_right_integration\";i:1;s:16:\"vod_right_upload\";i:1;s:16:\"vod_right_player\";i:1;s:18:\"vod_right_playlist\";i:1;s:22:\"vod_api_valid_callback\";s:3:\"off\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("104", "cron", "a:16:{i:1588504254;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1588543196;a:1:{s:15:\"itsec_cron_test\";a:1:{s:32:\"62a71582911b9629c133d5c1bd65c95e\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:1588543196;}}}}i:1588543855;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1588572000;a:1:{s:19:\"hmbkp_schedule_hook\";a:1:{s:32:\"028572f38e264cf3685e6e3a8ce7e1e9\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{s:2:\"id\";s:10:\"1588498857\";}s:8:\"interval\";i:86400;}}}i:1588585022;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1588585024;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1588585256;a:1:{s:28:\"elementor/tracker/send_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1588585316;a:1:{s:10:\"itsec_cron\";a:1:{s:32:\"d3ad27d223d301b6ae68ed2a88d04d71\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:12:\"health-check\";}s:8:\"interval\";i:86400;}}}i:1588586345;a:1:{s:10:\"itsec_cron\";a:1:{s:32:\"c0ae31dfe60fdb9da055aa838519db0f\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:12:\"clear-tokens\";}s:8:\"interval\";i:86400;}}}i:1588586456;a:1:{s:10:\"itsec_cron\";a:1:{s:32:\"aa768a35ceed34e467f270ebdc5d82f4\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:14:\"purge-lockouts\";}s:8:\"interval\";i:86400;}}}i:1588586996;a:1:{s:10:\"itsec_cron\";a:2:{s:32:\"3ec3d6914daf50bcdb5e5b065213e29b\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:17:\"purge-log-entries\";}s:8:\"interval\";i:86400;}s:32:\"7a0fd5d064c59cf40c3df9ad0bb6e63d\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:11:\"clear-locks\";}s:8:\"interval\";i:86400;}}}i:1588587054;a:1:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1589104800;a:1:{s:19:\"hmbkp_schedule_hook\";a:1:{s:32:\"c457dec1a6d3db72d0141ba74f9273ac\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:1:{s:2:\"id\";s:10:\"1588498858\";}s:8:\"interval\";i:604800;}}}i:1589105454;a:1:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1591006254;a:1:{s:32:\"et_core_page_resource_auto_clear\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2592000;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_522243_options` VALUES("105", "wpcaptcha_status", "disabled", "yes");
INSERT INTO `wp_522243_options` VALUES("107", "rsssl_check_redirect_dismissed", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("108", "rsssl_success_message_shown", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("109", "wpcaptcha_login", "", "yes");
INSERT INTO `wp_522243_options` VALUES("110", "wpcaptcha_register", "yes", "yes");
INSERT INTO `wp_522243_options` VALUES("111", "wpcaptcha_lost", "yes", "yes");
INSERT INTO `wp_522243_options` VALUES("112", "wpcaptcha_comments", "yes", "yes");
INSERT INTO `wp_522243_options` VALUES("113", "wpcaptcha_registered", "", "yes");
INSERT INTO `wp_522243_options` VALUES("114", "wpcaptcha_type", "alphanumeric", "yes");
INSERT INTO `wp_522243_options` VALUES("115", "wpcaptcha_letters", "capital", "yes");
INSERT INTO `wp_522243_options` VALUES("116", "wpcaptcha_total_no_of_characters", "3", "yes");
INSERT INTO `wp_522243_options` VALUES("118", "current_theme", "Hello Elementor", "yes");
INSERT INTO `wp_522243_options` VALUES("119", "theme_switched", "", "yes");
INSERT INTO `wp_522243_options` VALUES("125", "et_core_version", "4.4.4", "yes");
INSERT INTO `wp_522243_options` VALUES("127", "et_divi", "a:97:{s:39:\"static_css_custom_css_safety_check_done\";b:1;s:23:\"2_5_flush_rewrite_rules\";s:4:\"done\";s:30:\"et_flush_rewrite_rules_library\";s:5:\"4.4.4\";s:31:\"divi_previous_installed_version\";s:0:\"\";s:29:\"divi_latest_installed_version\";s:5:\"4.4.4\";s:27:\"divi_skip_font_subset_force\";b:1;s:27:\"et_pb_clear_templates_cache\";b:1;s:21:\"custom_footer_credits\";s:192:\"Powered by <a href=\'https://wordpress.org\' target=\'_blank\'>WordPress</a> and hosted on <a href=\'https://www.infomaniak.com/en/create-a-website/wordpress-hosting\' target=\'_blank\'>Infomaniak<a/>\";s:9:\"divi_logo\";s:81:\"https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/Logo.png\";s:12:\"divi_favicon\";s:0:\"\";s:14:\"divi_fixed_nav\";s:2:\"on\";s:26:\"divi_gallery_layout_enable\";s:5:\"false\";s:18:\"divi_color_palette\";s:63:\"#000000|#ffffff|#e02b20|#e09900|#edf000|#7cda24|#0c71c3|#8300e9\";s:15:\"divi_grab_image\";s:5:\"false\";s:15:\"divi_blog_style\";s:5:\"false\";s:22:\"divi_shop_page_sidebar\";s:16:\"et_right_sidebar\";s:23:\"divi_show_facebook_icon\";s:2:\"on\";s:22:\"divi_show_twitter_icon\";s:2:\"on\";s:21:\"divi_show_google_icon\";s:2:\"on\";s:18:\"divi_show_rss_icon\";s:2:\"on\";s:17:\"divi_facebook_url\";s:1:\"#\";s:16:\"divi_twitter_url\";s:1:\"#\";s:15:\"divi_google_url\";s:1:\"#\";s:12:\"divi_rss_url\";s:0:\"\";s:34:\"divi_woocommerce_archive_num_posts\";s:1:\"9\";s:17:\"divi_catnum_posts\";s:1:\"6\";s:21:\"divi_archivenum_posts\";s:1:\"5\";s:20:\"divi_searchnum_posts\";s:1:\"5\";s:17:\"divi_tagnum_posts\";s:1:\"5\";s:16:\"divi_date_format\";s:6:\"M j, Y\";s:16:\"divi_use_excerpt\";s:5:\"false\";s:26:\"divi_responsive_shortcodes\";s:2:\"on\";s:33:\"divi_gf_enable_all_character_sets\";s:5:\"false\";s:16:\"divi_back_to_top\";s:5:\"false\";s:18:\"divi_smooth_scroll\";s:5:\"false\";s:25:\"divi_disable_translations\";s:5:\"false\";s:15:\"divi_custom_css\";s:0:\"\";s:21:\"divi_enable_dropdowns\";s:2:\"on\";s:14:\"divi_home_link\";s:2:\"on\";s:15:\"divi_sort_pages\";s:10:\"post_title\";s:15:\"divi_order_page\";s:3:\"asc\";s:22:\"divi_tiers_shown_pages\";s:1:\"3\";s:32:\"divi_enable_dropdowns_categories\";s:2:\"on\";s:21:\"divi_categories_empty\";s:2:\"on\";s:27:\"divi_tiers_shown_categories\";s:1:\"3\";s:13:\"divi_sort_cat\";s:4:\"name\";s:14:\"divi_order_cat\";s:3:\"asc\";s:20:\"divi_disable_toptier\";s:5:\"false\";s:25:\"divi_scroll_to_anchor_fix\";s:5:\"false\";s:14:\"divi_postinfo2\";a:4:{i:0;s:6:\"author\";i:1;s:4:\"date\";i:2;s:10:\"categories\";i:3;s:8:\"comments\";}s:22:\"divi_show_postcomments\";s:2:\"on\";s:15:\"divi_thumbnails\";s:2:\"on\";s:20:\"divi_page_thumbnails\";s:5:\"false\";s:23:\"divi_show_pagescomments\";s:5:\"false\";s:14:\"divi_postinfo1\";a:3:{i:0;s:6:\"author\";i:1;s:4:\"date\";i:2;s:10:\"categories\";}s:21:\"divi_thumbnails_index\";s:2:\"on\";s:19:\"divi_seo_home_title\";s:5:\"false\";s:25:\"divi_seo_home_description\";s:5:\"false\";s:22:\"divi_seo_home_keywords\";s:5:\"false\";s:23:\"divi_seo_home_canonical\";s:5:\"false\";s:23:\"divi_seo_home_titletext\";s:0:\"\";s:29:\"divi_seo_home_descriptiontext\";s:0:\"\";s:26:\"divi_seo_home_keywordstext\";s:0:\"\";s:18:\"divi_seo_home_type\";s:27:\"BlogName | Blog description\";s:22:\"divi_seo_home_separate\";s:3:\" | \";s:21:\"divi_seo_single_title\";s:5:\"false\";s:27:\"divi_seo_single_description\";s:5:\"false\";s:24:\"divi_seo_single_keywords\";s:5:\"false\";s:25:\"divi_seo_single_canonical\";s:5:\"false\";s:27:\"divi_seo_single_field_title\";s:9:\"seo_title\";s:33:\"divi_seo_single_field_description\";s:15:\"seo_description\";s:30:\"divi_seo_single_field_keywords\";s:12:\"seo_keywords\";s:20:\"divi_seo_single_type\";s:21:\"Post title | BlogName\";s:24:\"divi_seo_single_separate\";s:3:\" | \";s:24:\"divi_seo_index_canonical\";s:5:\"false\";s:26:\"divi_seo_index_description\";s:5:\"false\";s:19:\"divi_seo_index_type\";s:24:\"Category name | BlogName\";s:23:\"divi_seo_index_separate\";s:3:\" | \";s:28:\"divi_integrate_header_enable\";s:2:\"on\";s:26:\"divi_integrate_body_enable\";s:2:\"on\";s:31:\"divi_integrate_singletop_enable\";s:2:\"on\";s:34:\"divi_integrate_singlebottom_enable\";s:2:\"on\";s:21:\"divi_integration_head\";s:0:\"\";s:21:\"divi_integration_body\";s:0:\"\";s:27:\"divi_integration_single_top\";s:0:\"\";s:30:\"divi_integration_single_bottom\";s:0:\"\";s:15:\"divi_468_enable\";s:5:\"false\";s:14:\"divi_468_image\";s:0:\"\";s:12:\"divi_468_url\";s:0:\"\";s:16:\"divi_468_adsense\";s:0:\"\";s:23:\"builder_custom_defaults\";O:8:\"stdClass\":0:{}s:33:\"customizer_settings_migrated_flag\";b:1;s:34:\"builder_custom_defaults_unmigrated\";b:0;s:40:\"divi_email_provider_credentials_migrated\";b:1;s:15:\"divi_1_3_images\";s:7:\"checked\";s:21:\"et_pb_layouts_updated\";b:1;s:30:\"library_removed_legacy_layouts\";b:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("128", "theme_mods_divi-photography", "a:9:{s:18:\"custom_css_post_id\";i:-1;s:16:\"et_pb_css_synced\";s:3:\"yes\";s:18:\"nav_menu_locations\";a:1:{s:12:\"primary-menu\";s:28:\"msw-primary-menu-photography\";}s:32:\"nav_menu_locations[primary-menu]\";i:3;s:21:\"et_pb_layouts_updated\";s:3:\"yes\";s:39:\"et_updated_layouts_built_for_post_types\";s:3:\"yes\";s:30:\"et_pb_predefined_layouts_added\";s:2:\"on\";s:34:\"et_pb_predefined_layouts_version_2\";s:2:\"on\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1588498689;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}}}}", "yes");
INSERT INTO `wp_522243_options` VALUES("129", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("130", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("131", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("132", "widget_media_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("133", "widget_media_gallery", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("134", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("135", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("136", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("137", "widget_custom_html", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("138", "widget_aboutmewidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("139", "widget_adsensewidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("140", "widget_advwidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("142", "et_support_site_id", "U-5qn9@keKV=4J1ZpHu#", "yes");
INSERT INTO `wp_522243_options` VALUES("143", "et_safe_mode_plugins_whitelist", "a:8:{i:0;s:15:\"etdev/etdev.php\";i:1;s:15:\"bloom/bloom.php\";i:2;s:19:\"monarch/monarch.php\";i:3;s:29:\"divi-builder/divi-builder.php\";i:4;s:27:\"ari-adminer/ari-adminer.php\";i:5;s:31:\"query-monitor/query-monitor.php\";i:6;s:27:\"woocommerce/woocommerce.php\";i:7;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("145", "et_images_temp_folder", "/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/uploads/et_temp", "yes");
INSERT INTO `wp_522243_options` VALUES("146", "et_schedule_clean_images_last_time", "1588414255", "yes");
INSERT INTO `wp_522243_options` VALUES("147", "et_bfb_settings", "a:2:{s:10:\"enable_bfb\";s:2:\"on\";s:10:\"toggle_bfb\";s:2:\"on\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("149", "et_automatic_updates_options", "a:3:{s:3:\"msf\";i:1;s:8:\"username\";s:10:\"infomaniak\";s:7:\"api_key\";s:40:\"138f1cc01db72d0d493f370fd6cf106b07d0cec3\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("152", "recovery_keys", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("170", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("171", "project_category_children", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("175", "et_google_api_settings", "a:2:{s:7:\"api_key\";s:39:\"AIzaSyCQAUxzgyd1PuZqS7yYYDWaOo7mpQOBi1E\";s:26:\"enqueue_google_maps_script\";s:2:\"on\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("185", "et_pb_builder_options", "a:2:{i:0;b:0;s:35:\"email_provider_credentials_migrated\";b:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("287", "WPLANG", "", "yes");
INSERT INTO `wp_522243_options` VALUES("305", "duplicate_post_copytitle", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("306", "duplicate_post_copydate", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("307", "duplicate_post_copystatus", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("308", "duplicate_post_copyslug", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("309", "duplicate_post_copyexcerpt", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("310", "duplicate_post_copycontent", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("311", "duplicate_post_copythumbnail", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("312", "duplicate_post_copytemplate", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("313", "duplicate_post_copyformat", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("314", "duplicate_post_copyauthor", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("315", "duplicate_post_copypassword", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("316", "duplicate_post_copyattachments", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("317", "duplicate_post_copychildren", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("318", "duplicate_post_copycomments", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("319", "duplicate_post_copymenuorder", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("320", "duplicate_post_taxonomies_blacklist", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("321", "duplicate_post_blacklist", "", "yes");
INSERT INTO `wp_522243_options` VALUES("322", "duplicate_post_types_enabled", "a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("323", "duplicate_post_show_row", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("324", "duplicate_post_show_adminbar", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("325", "duplicate_post_show_submitbox", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("326", "duplicate_post_show_bulkactions", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("327", "duplicate_post_show_original_column", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("328", "duplicate_post_show_original_in_post_states", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("329", "duplicate_post_show_original_meta_box", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("330", "duplicate_post_version", "3.2.4", "yes");
INSERT INTO `wp_522243_options` VALUES("331", "duplicate_post_show_notice", "0", "no");
INSERT INTO `wp_522243_options` VALUES("332", "shop_catalog_image_size", "a:3:{s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"400\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("333", "shop_single_image_size", "a:3:{s:5:\"width\";s:3:\"510\";s:6:\"height\";s:4:\"9999\";s:4:\"crop\";i:0;}", "yes");
INSERT INTO `wp_522243_options` VALUES("334", "shop_thumbnail_image_size", "a:3:{s:5:\"width\";s:3:\"157\";s:6:\"height\";s:3:\"157\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("340", "rsssl_activation_timestamp", "1617010624", "yes");
INSERT INTO `wp_522243_options` VALUES("341", "rsssl_before_review_notice_user", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("343", "can_compress_scripts", "0", "no");
INSERT INTO `wp_522243_options` VALUES("360", "et_account_status", "active", "no");
INSERT INTO `wp_522243_options` VALUES("362", "recently_activated", "a:6:{s:41:\"captcha-code-authentication/wpCaptcha.php\";i:1588498785;s:33:\"instant-images/instant-images.php\";i:1588498785;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";i:1588498785;s:22:\"vod-infomaniak/vod.php\";i:1588498785;s:41:\"wordpress-importer/wordpress-importer.php\";i:1588498785;s:27:\"wp-super-cache/wp-cache.php\";i:1588498785;}", "yes");
INSERT INTO `wp_522243_options` VALUES("377", "bpu_update_blocked_plugins", "google-analytics-dashboard-for-wp/gadwp.php", "yes");
INSERT INTO `wp_522243_options` VALUES("385", "theme_mods_hello-elementor", "a:3:{i:0;b:0;s:18:\"nav_menu_locations\";a:1:{s:6:\"menu-1\";s:28:\"msw-primary-menu-photography\";}s:18:\"custom_css_post_id\";i:285;}", "yes");
INSERT INTO `wp_522243_options` VALUES("406", "disable_comments_options", "a:4:{s:19:\"disabled_post_types\";a:3:{i:0;s:4:\"post\";i:1;s:4:\"page\";i:2;s:10:\"attachment\";}s:17:\"remove_everywhere\";b:1;s:16:\"extra_post_types\";b:0;s:10:\"db_version\";i:6;}", "yes");
INSERT INTO `wp_522243_options` VALUES("407", "duplicator_settings", "a:15:{s:7:\"version\";s:6:\"1.3.30\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:1;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;s:18:\"archive_build_mode\";i:2;s:17:\"skip_archive_scan\";b:0;s:21:\"unhook_third_party_js\";b:0;s:22:\"unhook_third_party_css\";b:0;s:17:\"active_package_id\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("408", "duplicator_version_plugin", "1.3.30", "yes");
INSERT INTO `wp_522243_options` VALUES("411", "elementor_extras_do_activation_redirect", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("422", "itsec_cron", "a:2:{s:6:\"single\";a:0:{}s:9:\"recurring\";a:5:{s:17:\"purge-log-entries\";a:1:{s:4:\"data\";a:0:{}}s:14:\"purge-lockouts\";a:1:{s:4:\"data\";a:0:{}}s:11:\"clear-locks\";a:1:{s:4:\"data\";a:0:{}}s:12:\"health-check\";a:1:{s:4:\"data\";a:0:{}}s:12:\"clear-tokens\";a:1:{s:4:\"data\";a:0:{}}}}", "no");
INSERT INTO `wp_522243_options` VALUES("430", "password_protected_version", "2.2.5", "yes");
INSERT INTO `wp_522243_options` VALUES("431", "wbcr_io_image_optimization_server", "server_1", "yes");
INSERT INTO `wp_522243_options` VALUES("432", "wbcr_io_backup_origin_images", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("433", "wbcr_io_save_exif_data", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("434", "wbcr_io_db_version", "2", "yes");
INSERT INTO `wp_522243_options` VALUES("435", "wbcr_io_plugin_activated", "1588498856", "yes");
INSERT INTO `wp_522243_options` VALUES("436", "wbcr_io_plugin_version", "1.4.2", "yes");
INSERT INTO `wp_522243_options` VALUES("437", "itsec-storage", "a:8:{s:6:\"global\";a:34:{s:15:\"lockout_message\";s:5:\"error\";s:20:\"user_lockout_message\";s:64:\"You have been locked out due to too many invalid login attempts.\";s:25:\"community_lockout_message\";s:77:\"Your IP address has been flagged as a threat by the iThemes Security network.\";s:9:\"blacklist\";b:1;s:15:\"blacklist_count\";i:3;s:16:\"blacklist_period\";i:7;s:14:\"lockout_period\";i:15;s:18:\"lockout_white_list\";a:0:{}s:12:\"log_rotation\";i:60;s:17:\"file_log_rotation\";i:180;s:8:\"log_type\";s:8:\"database\";s:12:\"log_location\";s:98:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/uploads/ithemes-security/logs\";s:8:\"log_info\";s:0:\"\";s:14:\"allow_tracking\";b:0;s:11:\"write_files\";b:1;s:10:\"nginx_file\";s:68:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/nginx.conf\";s:24:\"infinitewp_compatibility\";b:0;s:11:\"did_upgrade\";b:0;s:9:\"lock_file\";b:0;s:5:\"proxy\";s:14:\"security-check\";s:12:\"proxy_header\";s:20:\"HTTP_X_FORWARDED_FOR\";s:14:\"hide_admin_bar\";b:0;s:16:\"show_error_codes\";b:0;s:19:\"show_security_check\";b:0;s:5:\"build\";i:4118;s:13:\"initial_build\";i:4116;s:20:\"activation_timestamp\";i:1588498856;s:11:\"cron_status\";i:-1;s:8:\"use_cron\";b:1;s:14:\"cron_test_time\";i:1588543196;s:19:\"enable_grade_report\";b:0;s:10:\"server_ips\";a:1:{i:0;s:14:\"128.65.195.200\";}s:13:\"feature_flags\";a:0:{}s:12:\"manage_group\";a:0:{}}s:16:\"wordpress-tweaks\";a:13:{s:18:\"wlwmanifest_header\";b:0;s:14:\"edituri_header\";b:0;s:12:\"comment_spam\";b:0;s:11:\"file_editor\";b:1;s:14:\"disable_xmlrpc\";i:0;s:22:\"allow_xmlrpc_multiauth\";b:0;s:8:\"rest_api\";s:15:\"restrict-access\";s:12:\"login_errors\";b:0;s:21:\"force_unique_nicename\";b:0;s:27:\"disable_unused_author_pages\";b:0;s:16:\"block_tabnapping\";b:0;s:21:\"valid_user_login_type\";s:4:\"both\";s:26:\"patch_thumb_file_traversal\";b:1;}s:21:\"password-requirements\";a:2:{s:20:\"enabled_requirements\";a:1:{s:8:\"strength\";b:1;}s:20:\"requirement_settings\";a:1:{s:8:\"strength\";a:1:{s:5:\"group\";a:6:{i:0;s:36:\"5912c641-9efa-493d-b0dc-f391e7ffa619\";i:1;s:36:\"3d7f7da3-e285-4266-a941-7875c1a8dd01\";i:2;s:36:\"3e4faae7-d876-437c-9039-9dd8d068c25f\";i:3;s:36:\"02bc00bf-5cce-4b18-a2fb-2072b4251d08\";i:4;s:36:\"9bfbca8a-cc02-40a5-a2ec-d5917c541a91\";i:5;s:14:\"everybody-else\";}}}}s:11:\"user-groups\";a:1:{s:14:\"default_groups\";a:5:{s:13:\"administrator\";s:36:\"5912c641-9efa-493d-b0dc-f391e7ffa619\";s:6:\"editor\";s:36:\"3d7f7da3-e285-4266-a941-7875c1a8dd01\";s:6:\"author\";s:36:\"3e4faae7-d876-437c-9039-9dd8d068c25f\";s:11:\"contributor\";s:36:\"02bc00bf-5cce-4b18-a2fb-2072b4251d08\";s:10:\"subscriber\";s:36:\"9bfbca8a-cc02-40a5-a2ec-d5917c541a91\";}}s:18:\"security-check-pro\";a:6:{s:19:\"last_scan_timestamp\";N;s:15:\"remote_ip_index\";N;s:13:\"ssl_supported\";N;s:20:\"remote_ips_timestamp\";N;s:10:\"remote_ips\";a:0:{}s:8:\"key_salt\";s:60:\"U8hE`(cB*(|T(79R0@[X%wkW{nT[LnQ+KxpF#?W{7 -IZ,L{jA=cF[7&A#vr\";}s:19:\"network-brute-force\";a:5:{s:7:\"api_key\";s:32:\"d1ak3a6AaCi178cOo0A61rE299Nk803Q\";s:10:\"api_secret\";s:128:\"JSfh21SXmgxmrVnXR82i7my1mxa9H0J45bMee7Fb727qB0M5D0L3fzKCm885zRT05WKEler1qlc57FZoeMZV960VJfEumPoco0x7trIt6hT4apL4QLJNb7z0MHZgk1Le\";s:10:\"enable_ban\";b:1;s:13:\"updates_optin\";b:0;s:7:\"api_nag\";b:0;}s:11:\"brute-force\";a:4:{s:17:\"max_attempts_host\";i:2;s:17:\"max_attempts_user\";i:3;s:12:\"check_period\";i:60;s:14:\"auto_ban_admin\";b:1;}s:19:\"notification-center\";a:8:{s:10:\"from_email\";s:0:\"\";s:18:\"default_recipients\";a:1:{s:9:\"user_list\";a:1:{i:0;s:1:\"1\";}}s:13:\"notifications\";a:3:{s:6:\"backup\";a:2:{s:7:\"subject\";N;s:10:\"email_list\";a:1:{i:0;s:26:\"stickysites@protonmail.com\";}}s:6:\"digest\";a:5:{s:7:\"enabled\";b:1;s:7:\"subject\";N;s:8:\"schedule\";s:5:\"daily\";s:14:\"recipient_type\";s:7:\"default\";s:9:\"user_list\";a:1:{i:0;s:18:\"role:administrator\";}}s:7:\"lockout\";a:4:{s:7:\"enabled\";b:1;s:7:\"subject\";N;s:14:\"recipient_type\";s:7:\"default\";s:9:\"user_list\";a:1:{i:0;s:18:\"role:administrator\";}}}s:9:\"last_sent\";a:0:{}s:4:\"data\";a:0:{}s:9:\"resend_at\";a:0:{}s:12:\"admin_emails\";a:0:{}s:15:\"last_mail_error\";s:0:\"\";}}", "yes");
INSERT INTO `wp_522243_options` VALUES("438", "code_snippets_version", "2.14.0", "yes");
INSERT INTO `wp_522243_options` VALUES("439", "aam_access_settings", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("440", "aam_migrations", "a:6:{i:0;s:19:\"2019_11_20-base.php\";i:1;s:19:\"2019_06_30-base.php\";i:2;s:19:\"2019_12_01-base.php\";i:3;s:19:\"2019_12_19-base.php\";i:4;s:19:\"2020_02_01-base.php\";i:5;s:19:\"2020_03_02-base.php\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("441", "aam_addons", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("442", "itsec_temp_whitelist_ip", "a:1:{s:12:\"88.8.240.109\";i:1588588857;}", "no");
INSERT INTO `wp_522243_options` VALUES("443", "elementor_version", "2.9.8", "yes");
INSERT INTO `wp_522243_options` VALUES("444", "elementor_pro_version", "2.9.3", "yes");
INSERT INTO `wp_522243_options` VALUES("445", "widget_aam_backend_login", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("446", "widget_elementor-library", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("448", "wpmss_settings", "a:1:{s:7:\"general\";a:4:{s:9:\"timestamp\";i:1588498857;s:14:\"pulseAlgorithm\";i:1;s:15:\"keyboardSupport\";i:1;s:15:\"fixedBackground\";i:1;}}", "yes");
INSERT INTO `wp_522243_options` VALUES("449", "_elementor_pro_installed_time", "1588498857", "yes");
INSERT INTO `wp_522243_options` VALUES("450", "code_snippets_settings", "a:3:{s:7:\"general\";a:6:{s:19:\"activate_by_default\";b:1;s:21:\"snippet_scope_enabled\";b:1;s:11:\"enable_tags\";b:1;s:18:\"enable_description\";b:1;s:13:\"disable_prism\";b:0;s:18:\"complete_uninstall\";b:0;}s:18:\"description_editor\";a:3:{s:4:\"rows\";i:5;s:12:\"use_full_mce\";b:0;s:13:\"media_buttons\";b:0;}s:6:\"editor\";a:8:{s:5:\"theme\";s:7:\"default\";s:16:\"indent_with_tabs\";b:1;s:8:\"tab_size\";i:4;s:11:\"indent_unit\";i:4;s:10:\"wrap_lines\";b:1;s:12:\"line_numbers\";b:1;s:19:\"auto_close_brackets\";b:1;s:27:\"highlight_selection_matches\";b:1;}}", "yes");
INSERT INTO `wp_522243_options` VALUES("451", "hmbkp_plugin_version", "3.10", "yes");
INSERT INTO `wp_522243_options` VALUES("452", "elementor_extras_widgets", "a:28:{s:12:\"enable_posts\";s:3:\"off\";s:15:\"enable_timeline\";s:3:\"off\";s:14:\"enable_gallery\";s:2:\"on\";s:21:\"enable_gallery_slider\";s:2:\"on\";s:23:\"enable_scroll_indicator\";s:3:\"off\";s:15:\"enable_hotspots\";s:3:\"off\";s:15:\"enable_switcher\";s:3:\"off\";s:14:\"enable_devices\";s:3:\"off\";s:15:\"enable_calendar\";s:3:\"off\";s:16:\"enable_offcanvas\";s:2:\"on\";s:17:\"enable_slide_menu\";s:3:\"off\";s:18:\"enable_search_form\";s:3:\"off\";s:21:\"enable_toggle_element\";s:2:\"on\";s:17:\"enable_google_map\";s:3:\"off\";s:13:\"enable_unfold\";s:2:\"on\";s:18:\"enable_html5_video\";s:2:\"on\";s:19:\"enable_audio_player\";s:3:\"off\";s:22:\"enable_circle_progress\";s:3:\"off\";s:19:\"enable_random_image\";s:3:\"off\";s:23:\"enable_image_comparison\";s:3:\"off\";s:12:\"enable_popup\";s:2:\"on\";s:15:\"enable_age_gate\";s:3:\"off\";s:19:\"enable_button_group\";s:2:\"on\";s:17:\"enable_inline_svg\";s:2:\"on\";s:14:\"enable_heading\";s:2:\"on\";s:19:\"enable_text_divider\";s:2:\"on\";s:12:\"enable_table\";s:2:\"on\";s:18:\"enable_breadcrumbs\";s:3:\"off\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("453", "elementor_extras_extensions", "a:6:{s:25:\"enable_display_conditions\";s:3:\"off\";s:25:\"enable_portfolio_parallax\";s:3:\"off\";s:22:\"enable_sticky_elements\";s:3:\"off\";s:24:\"enable_parallax_elements\";s:3:\"off\";s:26:\"enable_parallax_background\";s:3:\"off\";s:14:\"enable_tooltip\";s:3:\"off\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("454", "elementor_extras_apis", "", "yes");
INSERT INTO `wp_522243_options` VALUES("455", "elementor_extras_advanced", "", "yes");
INSERT INTO `wp_522243_options` VALUES("458", "hmbkp_schedule_1588498857", "a:5:{s:11:\"max_backups\";i:7;s:8:\"excludes\";a:0:{}s:4:\"type\";s:8:\"database\";s:12:\"reoccurrence\";s:5:\"daily\";s:19:\"schedule_start_time\";d:1588572000;}", "yes");
INSERT INTO `wp_522243_options` VALUES("459", "hmbkp_schedule_1588498858", "a:7:{s:11:\"max_backups\";i:3;s:8:\"excludes\";a:0:{}s:4:\"type\";s:8:\"complete\";s:12:\"reoccurrence\";s:6:\"weekly\";s:19:\"schedule_start_time\";d:1588500000;s:14:\"duration_total\";i:1588500046;s:16:\"backup_run_count\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("462", "_elementor_installed_time", "1588498857", "yes");
INSERT INTO `wp_522243_options` VALUES("463", "elementor_remote_info_library", "a:3:{s:10:\"types_data\";a:2:{s:5:\"block\";a:1:{s:10:\"categories\";a:22:{i:0;s:8:\"404 page\";i:1;s:5:\"about\";i:2;s:7:\"archive\";i:3;s:14:\"call to action\";i:4;s:7:\"clients\";i:5;s:7:\"contact\";i:6;s:3:\"faq\";i:7;s:8:\"features\";i:8;s:6:\"footer\";i:9;s:6:\"header\";i:10;s:4:\"hero\";i:11;s:9:\"portfolio\";i:12;s:7:\"pricing\";i:13;s:15:\"product archive\";i:14;s:8:\"services\";i:15;s:11:\"single page\";i:16;s:11:\"single post\";i:17;s:14:\"single product\";i:18;s:5:\"stats\";i:19;s:9:\"subscribe\";i:20;s:4:\"team\";i:21;s:12:\"testimonials\";}}s:5:\"popup\";a:1:{s:10:\"categories\";a:6:{i:0;s:10:\"bottom bar\";i:1;s:7:\"classic\";i:2;s:6:\"fly-in\";i:3;s:11:\"full screen\";i:4;s:9:\"hello bar\";i:5;s:8:\"slide-in\";}}}s:10:\"categories\";s:247:\"[\"404 page\",\"about\",\"archive\",\"call to action\",\"clients\",\"contact\",\"faq\",\"features\",\"footer\",\"header\",\"hero\",\"portfolio\",\"pricing\",\"product archive\",\"services\",\"single page\",\"single post\",\"single product\",\"stats\",\"subscribe\",\"team\",\"testimonials\"]\";s:9:\"templates\";a:682:{i:0;a:14:{s:2:\"id\";s:4:\"5525\";s:5:\"title\";s:8:\"About 14\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520443532\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"11\";s:11:\"trend_index\";s:1:\"6\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:1;a:14:{s:2:\"id\";s:5:\"10107\";s:5:\"title\";s:34:\"Classic | Promotion | Announcement\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/balls_small.png\";s:12:\"tmpl_created\";s:10:\"1547851373\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/classic-promotion-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"262\";s:11:\"trend_index\";s:3:\"258\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:2;a:14:{s:2:\"id\";s:4:\"5533\";s:5:\"title\";s:8:\"About 15\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520443534\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"31\";s:11:\"trend_index\";s:2:\"14\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:3;a:14:{s:2:\"id\";s:4:\"5575\";s:5:\"title\";s:5:\"CTA 7\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443543\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"16\";s:11:\"trend_index\";s:1:\"8\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:4;a:14:{s:2:\"id\";s:4:\"5615\";s:5:\"title\";s:10:\"Features 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443551\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"33\";s:11:\"trend_index\";s:2:\"32\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:5;a:14:{s:2:\"id\";s:4:\"5624\";s:5:\"title\";s:10:\"Features 5\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443553\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"78\";s:11:\"trend_index\";s:2:\"51\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:6;a:14:{s:2:\"id\";s:4:\"5684\";s:5:\"title\";s:5:\"FAQ 8\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443565\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"71\";s:11:\"trend_index\";s:2:\"75\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:7;a:14:{s:2:\"id\";s:5:\"10158\";s:5:\"title\";s:17:\"Classic | Contact\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/coco_small.png\";s:12:\"tmpl_created\";s:10:\"1547852227\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"284\";s:11:\"trend_index\";s:3:\"251\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:8;a:14:{s:2:\"id\";s:4:\"5693\";s:5:\"title\";s:5:\"FAQ 9\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443567\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"205\";s:11:\"trend_index\";s:3:\"208\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:9;a:14:{s:2:\"id\";s:4:\"5703\";s:5:\"title\";s:6:\"FAQ 13\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443569\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/faq-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"30\";s:11:\"trend_index\";s:2:\"18\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:10;a:14:{s:2:\"id\";s:4:\"5711\";s:5:\"title\";s:5:\"FAQ 1\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443571\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"197\";s:11:\"trend_index\";s:3:\"169\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:11;a:14:{s:2:\"id\";s:5:\"10190\";s:5:\"title\";s:30:\"Classic | Register | Subscribe\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/engage_small.png\";s:12:\"tmpl_created\";s:10:\"1547885703\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"273\";s:11:\"trend_index\";s:3:\"210\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:12;a:14:{s:2:\"id\";s:4:\"5719\";s:5:\"title\";s:5:\"FAQ 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443573\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"126\";s:11:\"trend_index\";s:3:\"103\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:13;a:14:{s:2:\"id\";s:4:\"5729\";s:5:\"title\";s:5:\"FAQ 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443575\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"301\";s:11:\"trend_index\";s:3:\"302\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:14;a:14:{s:2:\"id\";s:4:\"5737\";s:5:\"title\";s:6:\"FAQ 10\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443576\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/faq-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"159\";s:11:\"trend_index\";s:3:\"152\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:15;a:14:{s:2:\"id\";s:4:\"5746\";s:5:\"title\";s:6:\"FAQ 11\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443578\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/faq-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"204\";s:11:\"trend_index\";s:3:\"241\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:16;a:14:{s:2:\"id\";s:4:\"5755\";s:5:\"title\";s:5:\"FAQ 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443580\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"94\";s:11:\"trend_index\";s:3:\"114\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:17;a:14:{s:2:\"id\";s:4:\"5764\";s:5:\"title\";s:5:\"FAQ 7\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520443582\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"308\";s:11:\"trend_index\";s:3:\"265\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:18;a:14:{s:2:\"id\";s:5:\"10256\";s:5:\"title\";s:20:\"Classic | Sale | Pop\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/fruit_small.png\";s:12:\"tmpl_created\";s:10:\"1547888909\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"428\";s:11:\"trend_index\";s:3:\"536\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:19;a:14:{s:2:\"id\";s:4:\"5773\";s:5:\"title\";s:7:\"Hero 11\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_1.png\";s:12:\"tmpl_created\";s:10:\"1520443584\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/hero-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"34\";s:11:\"trend_index\";s:2:\"33\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:20;a:14:{s:2:\"id\";s:5:\"10267\";s:5:\"title\";s:29:\"Classic | Contact | Christmas\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/christmas_small.png\";s:12:\"tmpl_created\";s:10:\"1547889047\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/classic-contact-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"319\";s:11:\"trend_index\";s:3:\"295\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:21;a:14:{s:2:\"id\";s:4:\"5783\";s:5:\"title\";s:7:\"Hero 10\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_2.png\";s:12:\"tmpl_created\";s:10:\"1520443586\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/hero-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"343\";s:11:\"trend_index\";s:3:\"315\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:22;a:14:{s:2:\"id\";s:4:\"5792\";s:5:\"title\";s:6:\"Hero 9\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_3.png\";s:12:\"tmpl_created\";s:10:\"1520443588\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"219\";s:11:\"trend_index\";s:3:\"203\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:23;a:14:{s:2:\"id\";s:4:\"5801\";s:5:\"title\";s:6:\"Hero 7\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_4.png\";s:12:\"tmpl_created\";s:10:\"1520443589\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:10:\"[\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"19\";s:11:\"trend_index\";s:2:\"10\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:24;a:14:{s:2:\"id\";s:4:\"5811\";s:5:\"title\";s:6:\"Hero 8\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_5.png\";s:12:\"tmpl_created\";s:10:\"1520443591\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"114\";s:11:\"trend_index\";s:3:\"127\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:25;a:14:{s:2:\"id\";s:5:\"10307\";s:5:\"title\";s:43:\"Fly In | Promotion | Christmas | Teddy Bear\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/teddy_small.png\";s:12:\"tmpl_created\";s:10:\"1547893266\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/fly-in-promotion-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"577\";s:11:\"trend_index\";s:3:\"640\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:26;a:14:{s:2:\"id\";s:4:\"5820\";s:5:\"title\";s:9:\"Contact 2\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443593\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"178\";s:11:\"trend_index\";s:3:\"247\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:27;a:14:{s:2:\"id\";s:5:\"10318\";s:5:\"title\";s:27:\"Classic | Contact | Bicycle\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/01/by_small.png\";s:12:\"tmpl_created\";s:10:\"1547893367\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/classic-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"353\";s:11:\"trend_index\";s:3:\"254\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:28;a:14:{s:2:\"id\";s:4:\"5828\";s:5:\"title\";s:9:\"Contact 3\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443595\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"295\";s:11:\"trend_index\";s:3:\"285\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:29;a:14:{s:2:\"id\";s:4:\"5836\";s:5:\"title\";s:10:\"Contact 10\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443597\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"115\";s:11:\"trend_index\";s:3:\"123\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:30;a:14:{s:2:\"id\";s:5:\"10339\";s:5:\"title\";s:22:\"Fly In | Contact | Spa\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/spa_small.png\";s:12:\"tmpl_created\";s:10:\"1547893603\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/fly-in-contact-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"408\";s:11:\"trend_index\";s:3:\"338\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:31;a:14:{s:2:\"id\";s:4:\"5844\";s:5:\"title\";s:10:\"Contact 11\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443599\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"285\";s:11:\"trend_index\";s:3:\"324\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:32;a:14:{s:2:\"id\";s:5:\"10352\";s:5:\"title\";s:23:\"Fly In | Contact | Wine\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/fly_wine_small.png\";s:12:\"tmpl_created\";s:10:\"1547915335\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/fly-in-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"439\";s:11:\"trend_index\";s:3:\"403\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:33;a:14:{s:2:\"id\";s:4:\"5852\";s:5:\"title\";s:6:\"CTA 34\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2018/03/form_1.png\";s:12:\"tmpl_created\";s:10:\"1520443600\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-34/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"488\";s:11:\"trend_index\";s:3:\"591\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:34;a:14:{s:2:\"id\";s:4:\"5947\";s:5:\"title\";s:7:\"Stats 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443621\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"340\";s:11:\"trend_index\";s:3:\"429\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:35;a:14:{s:2:\"id\";s:5:\"10372\";s:5:\"title\";s:29:\"Fly In | Register | Subscribe\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/phone_small.png\";s:12:\"tmpl_created\";s:10:\"1547915554\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/fly-in-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"575\";s:11:\"trend_index\";s:3:\"602\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:36;a:14:{s:2:\"id\";s:4:\"5956\";s:5:\"title\";s:7:\"Stats 7\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443623\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"482\";s:11:\"trend_index\";s:3:\"522\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:37;a:14:{s:2:\"id\";s:5:\"10382\";s:5:\"title\";s:35:\"Bottom Bar | Announcement | Cookies\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2019/01/bottom_pink_small.png\";s:12:\"tmpl_created\";s:10:\"1547916616\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/bottom-bar-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"294\";s:11:\"trend_index\";s:3:\"244\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:38;a:14:{s:2:\"id\";s:4:\"5963\";s:5:\"title\";s:10:\"Features 7\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443626\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"63\";s:11:\"trend_index\";s:2:\"71\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:39;a:14:{s:2:\"id\";s:4:\"5974\";s:5:\"title\";s:10:\"Features 4\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443629\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"62\";s:11:\"trend_index\";s:2:\"72\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:40;a:14:{s:2:\"id\";s:4:\"5983\";s:5:\"title\";s:10:\"Features 3\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443630\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:11:\"[\"featues\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"236\";s:11:\"trend_index\";s:3:\"252\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:41;a:14:{s:2:\"id\";s:4:\"5991\";s:5:\"title\";s:11:\"Features 10\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443632\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/features-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"124\";s:11:\"trend_index\";s:3:\"159\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:42;a:14:{s:2:\"id\";s:4:\"5999\";s:5:\"title\";s:7:\"Team 14\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520443634\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"83\";s:11:\"trend_index\";s:2:\"86\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:43;a:14:{s:2:\"id\";s:5:\"10434\";s:5:\"title\";s:27:\"Classic | Sale | Headphones\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/head_small.png\";s:12:\"tmpl_created\";s:10:\"1547961950\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"380\";s:11:\"trend_index\";s:3:\"398\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:44;a:14:{s:2:\"id\";s:4:\"6008\";s:5:\"title\";s:6:\"Team 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520443636\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"67\";s:11:\"trend_index\";s:2:\"57\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:45;a:14:{s:2:\"id\";s:5:\"10444\";s:5:\"title\";s:17:\"Classic | Contact\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/plant_small.png\";s:12:\"tmpl_created\";s:10:\"1547962029\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/classic-contact-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"415\";s:11:\"trend_index\";s:3:\"362\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:46;a:14:{s:2:\"id\";s:4:\"6027\";s:5:\"title\";s:7:\"About 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_1-1.png\";s:12:\"tmpl_created\";s:10:\"1520443639\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-5-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"40\";s:11:\"trend_index\";s:2:\"35\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:47;a:14:{s:2:\"id\";s:4:\"6036\";s:5:\"title\";s:7:\"About 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_1-1.png\";s:12:\"tmpl_created\";s:10:\"1520443641\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-6-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"88\";s:11:\"trend_index\";s:2:\"90\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:48;a:14:{s:2:\"id\";s:5:\"10467\";s:5:\"title\";s:27:\"Bottom Bar | Contact | Lego\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/tro_small.png\";s:12:\"tmpl_created\";s:10:\"1547962277\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/bottom-bar-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"633\";s:11:\"trend_index\";s:3:\"657\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:49;a:14:{s:2:\"id\";s:4:\"6044\";s:5:\"title\";s:11:\"Features 11\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443643\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/features-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"69\";s:11:\"trend_index\";s:2:\"41\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:50;a:14:{s:2:\"id\";s:4:\"6053\";s:5:\"title\";s:10:\"Features 1\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520443645\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"165\";s:11:\"trend_index\";s:3:\"162\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:51;a:14:{s:2:\"id\";s:5:\"10487\";s:5:\"title\";s:18:\"Slide In | Contact\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/acc_small.png\";s:12:\"tmpl_created\";s:10:\"1547964527\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"510\";s:11:\"trend_index\";s:3:\"495\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:52;a:14:{s:2:\"id\";s:4:\"6063\";s:5:\"title\";s:7:\"Stats 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443647\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"157\";s:11:\"trend_index\";s:3:\"194\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:53;a:14:{s:2:\"id\";s:5:\"10498\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/pink_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547964616\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"436\";s:11:\"trend_index\";s:3:\"482\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:54;a:14:{s:2:\"id\";s:4:\"6071\";s:5:\"title\";s:8:\"Stats 13\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443649\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"158\";s:11:\"trend_index\";s:3:\"181\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:55;a:14:{s:2:\"id\";s:4:\"6079\";s:5:\"title\";s:7:\"Stats 3\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443651\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"266\";s:11:\"trend_index\";s:3:\"228\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:56;a:14:{s:2:\"id\";s:5:\"10519\";s:5:\"title\";s:27:\"Hello Bar | Promotion | App\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/app_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547964801\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/hello-bar-promotion-app-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"537\";s:11:\"trend_index\";s:3:\"539\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:57;a:14:{s:2:\"id\";s:4:\"6089\";s:5:\"title\";s:7:\"Stats 4\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443653\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"177\";s:11:\"trend_index\";s:3:\"209\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:58;a:14:{s:2:\"id\";s:4:\"6097\";s:5:\"title\";s:7:\"Stats 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443655\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"261\";s:11:\"trend_index\";s:3:\"327\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:59;a:14:{s:2:\"id\";s:4:\"6106\";s:5:\"title\";s:7:\"Stats 2\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443657\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"330\";s:11:\"trend_index\";s:3:\"348\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:60;a:14:{s:2:\"id\";s:4:\"6114\";s:5:\"title\";s:7:\"Stats 1\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443659\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"368\";s:11:\"trend_index\";s:3:\"402\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:61;a:14:{s:2:\"id\";s:4:\"6122\";s:5:\"title\";s:7:\"About 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_2-1.png\";s:12:\"tmpl_created\";s:10:\"1520443661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"36\";s:11:\"trend_index\";s:2:\"25\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:62;a:14:{s:2:\"id\";s:5:\"10569\";s:5:\"title\";s:15:\"Slide In | Sale\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/off_small.png\";s:12:\"tmpl_created\";s:10:\"1547967812\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/popups/slide-in-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"493\";s:11:\"trend_index\";s:3:\"525\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:63;a:14:{s:2:\"id\";s:4:\"6135\";s:5:\"title\";s:8:\"About 10\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443663\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"84\";s:11:\"trend_index\";s:2:\"81\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:64;a:14:{s:2:\"id\";s:4:\"6144\";s:5:\"title\";s:7:\"Team 17\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520443664\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"149\";s:11:\"trend_index\";s:3:\"143\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:65;a:14:{s:2:\"id\";s:5:\"10590\";s:5:\"title\";s:19:\"Full Screen | Login\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/pass1_small.png\";s:12:\"tmpl_created\";s:10:\"1547967978\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"477\";s:11:\"trend_index\";s:3:\"494\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:66;a:14:{s:2:\"id\";s:4:\"6152\";s:5:\"title\";s:7:\"Stats 9\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443666\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"238\";s:11:\"trend_index\";s:3:\"263\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:67;a:14:{s:2:\"id\";s:5:\"10600\";s:5:\"title\";s:18:\"Slide In | Contact\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/orange_small.png\";s:12:\"tmpl_created\";s:10:\"1547968080\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-contact-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"460\";s:11:\"trend_index\";s:3:\"406\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:68;a:14:{s:2:\"id\";s:4:\"6162\";s:5:\"title\";s:11:\"Services 31\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443668\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-31/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"326\";s:11:\"trend_index\";s:3:\"312\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:69;a:14:{s:2:\"id\";s:4:\"6170\";s:5:\"title\";s:8:\"Stats 11\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443670\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"322\";s:11:\"trend_index\";s:3:\"399\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:70;a:14:{s:2:\"id\";s:5:\"10622\";s:5:\"title\";s:34:\"Full Screen | Contact | Headphones\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/full_hear_small.png\";s:12:\"tmpl_created\";s:10:\"1547969678\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/full-screen-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"505\";s:11:\"trend_index\";s:3:\"535\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:71;a:14:{s:2:\"id\";s:4:\"6178\";s:5:\"title\";s:8:\"Stats 10\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443676\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"375\";s:11:\"trend_index\";s:3:\"389\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:72;a:14:{s:2:\"id\";s:5:\"10633\";s:5:\"title\";s:23:\"Slide In | Login | Lego\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/tro_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547969858\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/slide-in-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"600\";s:11:\"trend_index\";s:3:\"596\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:73;a:14:{s:2:\"id\";s:4:\"6186\";s:5:\"title\";s:8:\"Stats 12\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443678\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"456\";s:11:\"trend_index\";s:3:\"468\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:74;a:14:{s:2:\"id\";s:5:\"10644\";s:5:\"title\";s:26:\"Fly In | Contact | Webinar\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/blue_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547970814\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/fly-in-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"447\";s:11:\"trend_index\";s:3:\"428\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:75;a:14:{s:2:\"id\";s:4:\"6196\";s:5:\"title\";s:10:\"Features 9\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443680\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"106\";s:11:\"trend_index\";s:3:\"107\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:76;a:14:{s:2:\"id\";s:5:\"10654\";s:5:\"title\";s:31:\"Full Screen | Login | Christmas\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/full_login_small.png\";s:12:\"tmpl_created\";s:10:\"1547970917\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/full-screen-login-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"594\";s:11:\"trend_index\";s:3:\"649\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:77;a:14:{s:2:\"id\";s:4:\"6204\";s:5:\"title\";s:10:\"Features 8\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443681\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"215\";s:11:\"trend_index\";s:3:\"202\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:78;a:14:{s:2:\"id\";s:5:\"10664\";s:5:\"title\";s:34:\"Slide In | Contact | Gym | Fitness\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/slide_gym_small.png\";s:12:\"tmpl_created\";s:10:\"1547973928\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-contact-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"499\";s:11:\"trend_index\";s:3:\"565\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:79;a:14:{s:2:\"id\";s:4:\"6212\";s:5:\"title\";s:11:\"Features 12\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443684\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/features-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"76\";s:11:\"trend_index\";s:2:\"85\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:80;a:14:{s:2:\"id\";s:5:\"10675\";s:5:\"title\";s:35:\"Full Screen | Login | Gym | Fitness\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/gym_full_small.png\";s:12:\"tmpl_created\";s:10:\"1547974110\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-login-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"490\";s:11:\"trend_index\";s:3:\"440\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:81;a:14:{s:2:\"id\";s:4:\"6220\";s:5:\"title\";s:10:\"Features 2\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443685\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"80\";s:11:\"trend_index\";s:2:\"82\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:82;a:14:{s:2:\"id\";s:4:\"6230\";s:5:\"title\";s:6:\"Hero 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443687\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"372\";s:11:\"trend_index\";s:3:\"422\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:83;a:14:{s:2:\"id\";s:4:\"9719\";s:5:\"title\";s:30:\"Classic | Subscribe | Register\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/register_small.png\";s:12:\"tmpl_created\";s:10:\"1547976107\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/classic-subscribe-register/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"437\";s:11:\"trend_index\";s:3:\"441\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:84;a:14:{s:2:\"id\";s:4:\"6239\";s:5:\"title\";s:6:\"Hero 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443689\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"26\";s:11:\"trend_index\";s:2:\"26\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:85;a:14:{s:2:\"id\";s:4:\"6249\";s:5:\"title\";s:6:\"Hero 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"56\";s:11:\"trend_index\";s:2:\"47\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:86;a:14:{s:2:\"id\";s:4:\"6258\";s:5:\"title\";s:6:\"Hero 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443693\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"405\";s:11:\"trend_index\";s:3:\"478\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:87;a:14:{s:2:\"id\";s:5:\"10137\";s:5:\"title\";s:34:\"Full Screen | Contact | Restaurant\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/rest_small.png\";s:12:\"tmpl_created\";s:10:\"1547976342\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"509\";s:11:\"trend_index\";s:3:\"550\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:88;a:14:{s:2:\"id\";s:4:\"6266\";s:5:\"title\";s:6:\"Hero 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443695\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"51\";s:11:\"trend_index\";s:2:\"50\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:89;a:14:{s:2:\"id\";s:5:\"10244\";s:5:\"title\";s:17:\"Bottom Bar | Sale\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/wow_small.png\";s:12:\"tmpl_created\";s:10:\"1547976402\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/bottom-bar-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"556\";s:11:\"trend_index\";s:3:\"517\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:90;a:14:{s:2:\"id\";s:4:\"6274\";s:5:\"title\";s:6:\"Hero 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520443698\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"98\";s:11:\"trend_index\";s:2:\"93\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:91;a:14:{s:2:\"id\";s:4:\"6017\";s:5:\"title\";s:6:\"CTA 14\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_14.png\";s:12:\"tmpl_created\";s:10:\"1520520331\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"156\";s:11:\"trend_index\";s:3:\"113\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:92;a:14:{s:2:\"id\";s:5:\"10127\";s:5:\"title\";s:35:\"Fly In | Announcement | Maintenance\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/pizza_small.png\";s:12:\"tmpl_created\";s:10:\"1547984061\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-announcement-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"610\";s:11:\"trend_index\";s:3:\"631\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:93;a:14:{s:2:\"id\";s:4:\"4826\";s:5:\"title\";s:14:\"Testimonial 24\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520520544\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/testimonial-24-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"259\";s:11:\"trend_index\";s:3:\"345\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:94;a:14:{s:2:\"id\";s:4:\"4835\";s:5:\"title\";s:14:\"Testimonial 16\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520520546\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"378\";s:11:\"trend_index\";s:3:\"442\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:95;a:14:{s:2:\"id\";s:4:\"4843\";s:5:\"title\";s:14:\"Testimonial 18\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520520548\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"396\";s:11:\"trend_index\";s:3:\"447\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:96;a:14:{s:2:\"id\";s:4:\"4854\";s:5:\"title\";s:14:\"Testimonial 13\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520520549\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"543\";s:11:\"trend_index\";s:3:\"611\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:97;a:14:{s:2:\"id\";s:4:\"4863\";s:5:\"title\";s:14:\"Testimonial 19\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520520551\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"248\";s:11:\"trend_index\";s:3:\"289\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:98;a:14:{s:2:\"id\";s:5:\"10776\";s:5:\"title\";s:33:\"Fly In | Contact | Social | Share\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/social1_small.png\";s:12:\"tmpl_created\";s:10:\"1548047055\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/fly-in-contact-social-share/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"615\";s:11:\"trend_index\";s:3:\"628\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:99;a:14:{s:2:\"id\";s:4:\"4871\";s:5:\"title\";s:14:\"Testimonial 12\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520520552\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"240\";s:11:\"trend_index\";s:3:\"261\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:100;a:14:{s:2:\"id\";s:5:\"10785\";s:5:\"title\";s:33:\"Fly In | Contact | Social | Share\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/social2_small.png\";s:12:\"tmpl_created\";s:10:\"1548047593\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/fly-in-contact-social-share-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"450\";s:11:\"trend_index\";s:3:\"510\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:101;a:14:{s:2:\"id\";s:4:\"4880\";s:5:\"title\";s:14:\"Testimonial 20\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/customers-1.jpg\";s:12:\"tmpl_created\";s:10:\"1520520554\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"386\";s:11:\"trend_index\";s:3:\"481\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:102;a:14:{s:2:\"id\";s:4:\"4889\";s:5:\"title\";s:14:\"Testimonial 11\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/customers-2.jpg\";s:12:\"tmpl_created\";s:10:\"1520520556\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"479\";s:11:\"trend_index\";s:3:\"455\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:103;a:14:{s:2:\"id\";s:4:\"4897\";s:5:\"title\";s:14:\"Testimonial 21\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520520557\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"74\";s:11:\"trend_index\";s:2:\"84\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:104;a:14:{s:2:\"id\";s:4:\"4905\";s:5:\"title\";s:14:\"Testimonial 22\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520520559\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-22/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"110\";s:11:\"trend_index\";s:2:\"97\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:105;a:14:{s:2:\"id\";s:4:\"4913\";s:5:\"title\";s:14:\"Testimonial 23\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520520561\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-23/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"228\";s:11:\"trend_index\";s:3:\"350\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:106;a:14:{s:2:\"id\";s:4:\"4921\";s:5:\"title\";s:14:\"Testimonial 10\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520520562\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"212\";s:11:\"trend_index\";s:3:\"204\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:107;a:14:{s:2:\"id\";s:4:\"4929\";s:5:\"title\";s:14:\"Testimonial 24\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520520564\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-24/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"42\";s:11:\"trend_index\";s:2:\"43\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:108;a:14:{s:2:\"id\";s:4:\"4939\";s:5:\"title\";s:13:\"Testimonial 9\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520520565\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/testimonial-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"91\";s:11:\"trend_index\";s:3:\"109\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:109;a:14:{s:2:\"id\";s:4:\"4947\";s:5:\"title\";s:14:\"Testimonial 27\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520520567\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-27/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"194\";s:11:\"trend_index\";s:3:\"217\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:110;a:14:{s:2:\"id\";s:4:\"4955\";s:5:\"title\";s:14:\"Testimonial 29\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520520569\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-29/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"334\";s:11:\"trend_index\";s:3:\"432\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:111;a:14:{s:2:\"id\";s:4:\"4963\";s:5:\"title\";s:14:\"Testimonial 25\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520520570\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/testimonial-25-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"387\";s:11:\"trend_index\";s:3:\"412\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:112;a:14:{s:2:\"id\";s:4:\"4971\";s:5:\"title\";s:14:\"Testimonial 26\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520520572\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-26/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"558\";s:11:\"trend_index\";s:3:\"593\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:113;a:14:{s:2:\"id\";s:4:\"4979\";s:5:\"title\";s:14:\"Testimonial 15\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520520573\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"498\";s:11:\"trend_index\";s:3:\"529\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:114;a:14:{s:2:\"id\";s:4:\"4987\";s:5:\"title\";s:14:\"Testimonial 17\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_12-1.png\";s:12:\"tmpl_created\";s:10:\"1520520575\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"145\";s:11:\"trend_index\";s:3:\"187\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:115;a:14:{s:2:\"id\";s:4:\"4995\";s:5:\"title\";s:14:\"Testimonial 14\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_12.png\";s:12:\"tmpl_created\";s:10:\"1520520577\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"365\";s:11:\"trend_index\";s:3:\"404\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:116;a:14:{s:2:\"id\";s:4:\"5007\";s:5:\"title\";s:11:\"Portfolio 7\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520520578\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"44\";s:11:\"trend_index\";s:2:\"24\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:117;a:14:{s:2:\"id\";s:4:\"5019\";s:5:\"title\";s:11:\"Portfolio 1\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520520580\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"164\";s:11:\"trend_index\";s:3:\"136\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:118;a:14:{s:2:\"id\";s:4:\"5027\";s:5:\"title\";s:12:\"Portfolio 11\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520520581\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"296\";s:11:\"trend_index\";s:3:\"309\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:119;a:14:{s:2:\"id\";s:5:\"10794\";s:5:\"title\";s:34:\"Classic | Contact | Social | Share\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/01/s_small.png\";s:12:\"tmpl_created\";s:10:\"1548067619\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-contact-social-share/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"434\";s:11:\"trend_index\";s:3:\"352\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:120;a:14:{s:2:\"id\";s:4:\"5037\";s:5:\"title\";s:12:\"Portfolio 12\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520520583\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"270\";s:11:\"trend_index\";s:3:\"233\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:121;a:14:{s:2:\"id\";s:4:\"5057\";s:5:\"title\";s:12:\"Portfolio 13\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520520586\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"226\";s:11:\"trend_index\";s:3:\"277\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:122;a:14:{s:2:\"id\";s:4:\"5071\";s:5:\"title\";s:12:\"Portfolio 14\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520520588\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"275\";s:11:\"trend_index\";s:3:\"303\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:123;a:14:{s:2:\"id\";s:5:\"10871\";s:5:\"title\";s:20:\"Bottom Bar | Contact\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/01/m_small.png\";s:12:\"tmpl_created\";s:10:\"1548074396\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/bottom-bar-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"617\";s:11:\"trend_index\";s:3:\"629\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:124;a:14:{s:2:\"id\";s:4:\"5082\";s:5:\"title\";s:11:\"Portfolio 4\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520520589\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"457\";s:11:\"trend_index\";s:3:\"555\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:125;a:14:{s:2:\"id\";s:5:\"10936\";s:5:\"title\";s:25:\"Full Screen | Toggle Menu\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/menu_small.png\";s:12:\"tmpl_created\";s:10:\"1548874587\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/full-screen-toggle-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"432\";s:11:\"trend_index\";s:3:\"460\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:126;a:14:{s:2:\"id\";s:4:\"5090\";s:5:\"title\";s:12:\"Portfolio 15\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520520591\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"175\";s:11:\"trend_index\";s:3:\"145\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:127;a:14:{s:2:\"id\";s:4:\"5098\";s:5:\"title\";s:12:\"Portfolio 16\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520520593\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"153\";s:11:\"trend_index\";s:3:\"117\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:128;a:14:{s:2:\"id\";s:4:\"5107\";s:5:\"title\";s:11:\"Portfolio 5\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520520594\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"358\";s:11:\"trend_index\";s:3:\"373\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:129;a:14:{s:2:\"id\";s:5:\"10964\";s:5:\"title\";s:59:\"Classic | Promotion | Coupon | Love | Valentine&#8217;s Day\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/02/love_small.png\";s:12:\"tmpl_created\";s:10:\"1550039106\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/classic-promotion-coupon/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"570\";s:11:\"trend_index\";s:3:\"520\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:130;a:14:{s:2:\"id\";s:4:\"5115\";s:5:\"title\";s:12:\"Portfolio 17\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520520596\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"25\";s:11:\"trend_index\";s:2:\"12\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:131;a:14:{s:2:\"id\";s:5:\"10992\";s:5:\"title\";s:59:\"Classic | Promotion | Coupon | Love | Valentine&#8217;s Day\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/02/h_small.png\";s:12:\"tmpl_created\";s:10:\"1550072007\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:141:\"https://library.elementor.com/popups/classic-promotion-coupon-love-valentines-day/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"606\";s:11:\"trend_index\";s:3:\"621\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:132;a:14:{s:2:\"id\";s:4:\"5125\";s:5:\"title\";s:11:\"Portfolio 6\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520520597\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"225\";s:11:\"trend_index\";s:3:\"197\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:133;a:14:{s:2:\"id\";s:5:\"11005\";s:5:\"title\";s:50:\"Classic | Promotion | Love | Valentine&#8217;s Day\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/02/bear_small.png\";s:12:\"tmpl_created\";s:10:\"1550073303\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:134:\"https://library.elementor.com/popups/classic-promotion-love-valentines-day/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"601\";s:11:\"trend_index\";s:3:\"551\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:134;a:14:{s:2:\"id\";s:4:\"5133\";s:5:\"title\";s:12:\"Portfolio 18\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520520599\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"166\";s:11:\"trend_index\";s:3:\"163\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:135;a:14:{s:2:\"id\";s:4:\"5141\";s:5:\"title\";s:12:\"Portfolio 10\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520520601\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"350\";s:11:\"trend_index\";s:3:\"501\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:136;a:14:{s:2:\"id\";s:4:\"5149\";s:5:\"title\";s:11:\"Portfolio 2\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520520602\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"347\";s:11:\"trend_index\";s:3:\"515\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:137;a:14:{s:2:\"id\";s:4:\"5542\";s:5:\"title\";s:6:\"CTA 19\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520520681\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"161\";s:11:\"trend_index\";s:3:\"115\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:138;a:14:{s:2:\"id\";s:4:\"5550\";s:5:\"title\";s:6:\"CTA 33\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520520682\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-33/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"264\";s:11:\"trend_index\";s:3:\"155\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:139;a:14:{s:2:\"id\";s:4:\"5558\";s:5:\"title\";s:5:\"CTA 1\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520520684\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"131\";s:11:\"trend_index\";s:3:\"135\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:140;a:14:{s:2:\"id\";s:4:\"5567\";s:5:\"title\";s:5:\"CTA 2\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520520685\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"160\";s:11:\"trend_index\";s:3:\"119\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:141;a:14:{s:2:\"id\";s:5:\"11231\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/07/Post_small1.png\";s:12:\"tmpl_created\";s:10:\"1564642380\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/digital-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"186\";s:11:\"trend_index\";s:2:\"88\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:142;a:14:{s:2:\"id\";s:4:\"5583\";s:5:\"title\";s:6:\"CTA 26\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520520689\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-26/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"183\";s:11:\"trend_index\";s:2:\"45\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:143;a:14:{s:2:\"id\";s:5:\"11220\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/08/Archive_small1.png\";s:12:\"tmpl_created\";s:10:\"1564642385\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"146\";s:11:\"trend_index\";s:2:\"61\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:144;a:14:{s:2:\"id\";s:4:\"5591\";s:5:\"title\";s:5:\"CTA 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520520691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"127\";s:11:\"trend_index\";s:3:\"153\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:145;a:14:{s:2:\"id\";s:5:\"11204\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/07/404_small.jpg\";s:12:\"tmpl_created\";s:10:\"1564642389\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:36:\"[\"404\",\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"357\";s:11:\"trend_index\";s:3:\"298\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:146;a:14:{s:2:\"id\";s:4:\"5599\";s:5:\"title\";s:5:\"CTA 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520520693\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"272\";s:11:\"trend_index\";s:3:\"177\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:147;a:14:{s:2:\"id\";s:5:\"11198\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/07/Header_small_3.jpg\";s:12:\"tmpl_created\";s:10:\"1564642395\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:39:\"[\"Digital Agency\",\"header\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"59\";s:11:\"trend_index\";s:2:\"15\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:148;a:14:{s:2:\"id\";s:4:\"5607\";s:5:\"title\";s:6:\"CTA 13\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520520695\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"82\";s:11:\"trend_index\";s:1:\"7\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:149;a:14:{s:2:\"id\";s:5:\"11192\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/07/Footer_small.jpg\";s:12:\"tmpl_created\";s:10:\"1564642399\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:39:\"[\"Digital Agency\",\"footer\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"224\";s:11:\"trend_index\";s:3:\"126\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:150;a:14:{s:2:\"id\";s:4:\"5634\";s:5:\"title\";s:6:\"CTA 24\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520520699\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-24/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"170\";s:11:\"trend_index\";s:3:\"170\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:151;a:14:{s:2:\"id\";s:4:\"5642\";s:5:\"title\";s:6:\"CTA 25\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520520701\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-25/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"214\";s:11:\"trend_index\";s:3:\"271\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:152;a:14:{s:2:\"id\";s:4:\"5650\";s:5:\"title\";s:5:\"CTA 9\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520520702\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"99\";s:11:\"trend_index\";s:2:\"78\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:153;a:14:{s:2:\"id\";s:4:\"5658\";s:5:\"title\";s:5:\"CTA 8\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520520704\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"190\";s:11:\"trend_index\";s:3:\"129\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:154;a:14:{s:2:\"id\";s:4:\"5667\";s:5:\"title\";s:5:\"CTA 3\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520520705\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"151\";s:11:\"trend_index\";s:3:\"182\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:155;a:14:{s:2:\"id\";s:4:\"5675\";s:5:\"title\";s:5:\"CTA 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520520707\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"361\";s:11:\"trend_index\";s:3:\"355\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:156;a:14:{s:2:\"id\";s:4:\"5860\";s:5:\"title\";s:6:\"CTA 17\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520520746\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"130\";s:11:\"trend_index\";s:2:\"89\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:157;a:14:{s:2:\"id\";s:4:\"5869\";s:5:\"title\";s:6:\"CTA 18\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520520747\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"298\";s:11:\"trend_index\";s:3:\"378\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:158;a:14:{s:2:\"id\";s:4:\"5877\";s:5:\"title\";s:6:\"CTA 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520520749\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"473\";s:11:\"trend_index\";s:3:\"537\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:159;a:14:{s:2:\"id\";s:5:\"11468\";s:5:\"title\";s:20:\"Classic | Sale | Gym\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/08/PopUp_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393182\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/classic-sale-gym/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"625\";s:11:\"trend_index\";s:3:\"617\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:160;a:14:{s:2:\"id\";s:4:\"5885\";s:5:\"title\";s:6:\"CTA 15\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520520751\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"283\";s:11:\"trend_index\";s:3:\"262\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:161;a:14:{s:2:\"id\";s:5:\"11461\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/08/Header_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393219\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:100:\"https://library.elementor.com/blocks/gym/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:16:\"[\"Gym\",\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"277\";s:11:\"trend_index\";s:3:\"161\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:162;a:14:{s:2:\"id\";s:4:\"5893\";s:5:\"title\";s:6:\"CTA 21\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_12.png\";s:12:\"tmpl_created\";s:10:\"1520520752\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"246\";s:11:\"trend_index\";s:3:\"278\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:163;a:14:{s:2:\"id\";s:5:\"11453\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/08/Footer_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393224\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:16:\"[\"footer\",\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"327\";s:11:\"trend_index\";s:3:\"198\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:164;a:14:{s:2:\"id\";s:4:\"5904\";s:5:\"title\";s:6:\"CTA 27\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_13.png\";s:12:\"tmpl_created\";s:10:\"1520520754\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-27/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"438\";s:11:\"trend_index\";s:3:\"446\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:165;a:14:{s:2:\"id\";s:5:\"11445\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/08/Post_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393229\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"443\";s:11:\"trend_index\";s:3:\"368\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:166;a:14:{s:2:\"id\";s:4:\"5912\";s:5:\"title\";s:6:\"CTA 28\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_11.png\";s:12:\"tmpl_created\";s:10:\"1520520755\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-28/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"576\";s:11:\"trend_index\";s:3:\"592\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:167;a:14:{s:2:\"id\";s:5:\"11435\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/08/Archiv_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393296\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"429\";s:11:\"trend_index\";s:3:\"294\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:168;a:14:{s:2:\"id\";s:4:\"5921\";s:5:\"title\";s:6:\"CTA 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_14.png\";s:12:\"tmpl_created\";s:10:\"1520520757\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"255\";s:11:\"trend_index\";s:3:\"221\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:169;a:14:{s:2:\"id\";s:5:\"11424\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/08/404_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393309\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:13:\"[\"404\",\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"611\";s:11:\"trend_index\";s:3:\"572\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:170;a:14:{s:2:\"id\";s:4:\"5930\";s:5:\"title\";s:6:\"CTA 11\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_15.png\";s:12:\"tmpl_created\";s:10:\"1520520758\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"72\";s:11:\"trend_index\";s:2:\"73\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:171;a:14:{s:2:\"id\";s:4:\"5939\";s:5:\"title\";s:6:\"CTA 10\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_13-1.png\";s:12:\"tmpl_created\";s:10:\"1520520760\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"176\";s:11:\"trend_index\";s:3:\"157\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:172;a:14:{s:2:\"id\";s:4:\"7596\";s:5:\"title\";s:8:\"Header 1\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.12.jpg\";s:12:\"tmpl_created\";s:10:\"1521546999\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:10:\"[\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"35\";s:11:\"trend_index\";s:2:\"34\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:173;a:14:{s:2:\"id\";s:4:\"7615\";s:5:\"title\";s:8:\"Header 2\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1521547237\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:10:\"[\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"27\";s:11:\"trend_index\";s:2:\"46\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:174;a:14:{s:2:\"id\";s:4:\"7627\";s:5:\"title\";s:8:\"Footer 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/footer_hero_1.png\";s:12:\"tmpl_created\";s:10:\"1521547332\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/footer-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:10:\"[\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"111\";s:11:\"trend_index\";s:3:\"144\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:175;a:14:{s:2:\"id\";s:5:\"11822\";s:5:\"title\";s:30:\"Full Screen | Menu | Portfolio\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/09/PopUp_small.png\";s:12:\"tmpl_created\";s:10:\"1569429896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/full-screen-menu-portfolio/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"595\";s:11:\"trend_index\";s:3:\"542\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:176;a:14:{s:2:\"id\";s:4:\"7638\";s:5:\"title\";s:8:\"Footer 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/footer_hero_2.png\";s:12:\"tmpl_created\";s:10:\"1521547502\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/footer-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:10:\"[\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"125\";s:11:\"trend_index\";s:3:\"122\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:177;a:14:{s:2:\"id\";s:5:\"11877\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 3\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project3_small.png\";s:12:\"tmpl_created\";s:10:\"1569429954\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/portfolio-project-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"604\";s:11:\"trend_index\";s:3:\"545\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:178;a:14:{s:2:\"id\";s:4:\"7663\";s:5:\"title\";s:13:\"Single Post 2\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/single_post_2_v2.jpg\";s:12:\"tmpl_created\";s:10:\"1521547761\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:24:\"[\"Blog\",\"Post\",\"Single\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"47\";s:11:\"trend_index\";s:2:\"37\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:179;a:14:{s:2:\"id\";s:5:\"11870\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 2\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project2_small.png\";s:12:\"tmpl_created\";s:10:\"1569429964\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/portfolio-project-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"584\";s:11:\"trend_index\";s:3:\"642\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:180;a:14:{s:2:\"id\";s:4:\"7650\";s:5:\"title\";s:13:\"Single Post 1\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/single_post_1_v2.jpg\";s:12:\"tmpl_created\";s:10:\"1521557736\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:24:\"[\"Blog\",\"Post\",\"Single\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"100\";s:11:\"trend_index\";s:3:\"132\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:181;a:14:{s:2:\"id\";s:5:\"11861\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 1\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project1_small.png\";s:12:\"tmpl_created\";s:10:\"1569429975\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/portfolio-project-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"579\";s:11:\"trend_index\";s:3:\"604\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:182;a:14:{s:2:\"id\";s:4:\"7686\";s:5:\"title\";s:12:\"Blog Posts 1\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2018/03/blog_posts.png\";s:12:\"tmpl_created\";s:10:\"1521558047\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/blog-posts-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:26:\"[\"archive\",\"Blog\",\"posts\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"121\";s:11:\"trend_index\";s:3:\"121\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:183;a:14:{s:2:\"id\";s:5:\"11854\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/09/Post_small.png\";s:12:\"tmpl_created\";s:10:\"1569429983\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/portfolio/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"485\";s:11:\"trend_index\";s:3:\"383\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:184;a:14:{s:2:\"id\";s:4:\"4676\";s:5:\"title\";s:8:\"Footer 7\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/footer_7.png\";s:12:\"tmpl_created\";s:10:\"1522014215\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/footer_7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:10:\"[\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"220\";s:11:\"trend_index\";s:3:\"229\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:185;a:14:{s:2:\"id\";s:5:\"11847\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Archiv_small.png\";s:12:\"tmpl_created\";s:10:\"1569430010\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"363\";s:11:\"trend_index\";s:3:\"193\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:186;a:14:{s:2:\"id\";s:4:\"7997\";s:5:\"title\";s:10:\"footer 014\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1524582343\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-014/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"89\";s:11:\"trend_index\";s:2:\"87\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:187;a:14:{s:2:\"id\";s:5:\"11839\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Header_small.png\";s:12:\"tmpl_created\";s:10:\"1569430015\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:43:\"[\"creative portfolio\",\"header\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"314\";s:11:\"trend_index\";s:3:\"192\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:188;a:14:{s:2:\"id\";s:4:\"7982\";s:5:\"title\";s:10:\"footer 013\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1524582468\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-013/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"230\";s:11:\"trend_index\";s:3:\"219\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:189;a:14:{s:2:\"id\";s:5:\"11832\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Footer_small.png\";s:12:\"tmpl_created\";s:10:\"1569430019\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:43:\"[\"creative portfolio\",\"footer\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"346\";s:11:\"trend_index\";s:3:\"183\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:190;a:14:{s:2:\"id\";s:4:\"7959\";s:5:\"title\";s:10:\"footer 012\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1524582605\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-012/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"185\";s:11:\"trend_index\";s:3:\"227\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:191;a:14:{s:2:\"id\";s:5:\"11807\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/09/404_small.png\";s:12:\"tmpl_created\";s:10:\"1569430070\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:40:\"[\"404\",\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"527\";s:11:\"trend_index\";s:3:\"365\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:192;a:14:{s:2:\"id\";s:4:\"7950\";s:5:\"title\";s:10:\"footer 011\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1524582631\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-011/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"252\";s:11:\"trend_index\";s:3:\"281\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:193;a:14:{s:2:\"id\";s:4:\"7937\";s:5:\"title\";s:10:\"footer 010\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1524582665\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-010/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"208\";s:11:\"trend_index\";s:3:\"231\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:194;a:14:{s:2:\"id\";s:5:\"11897\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 2\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project2_small.png\";s:12:\"tmpl_created\";s:10:\"1569494236\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/blocks/portfolio-project-2-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"652\";s:11:\"trend_index\";s:3:\"650\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:195;a:14:{s:2:\"id\";s:4:\"7927\";s:5:\"title\";s:9:\"footer 09\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1524582691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-09/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"179\";s:11:\"trend_index\";s:3:\"206\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:196;a:14:{s:2:\"id\";s:5:\"11890\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Header_small.png\";s:12:\"tmpl_created\";s:10:\"1571907344\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:43:\"[\"creative portfolio\",\"header\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"367\";s:11:\"trend_index\";s:3:\"167\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:197;a:14:{s:2:\"id\";s:4:\"7917\";s:5:\"title\";s:9:\"footer 08\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1524582788\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-08/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"97\";s:11:\"trend_index\";s:2:\"98\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:198;a:14:{s:2:\"id\";s:4:\"7904\";s:5:\"title\";s:9:\"footer 07\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.8.jpg\";s:12:\"tmpl_created\";s:10:\"1524582814\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-07/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"201\";s:11:\"trend_index\";s:3:\"249\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:199;a:14:{s:2:\"id\";s:4:\"7837\";s:5:\"title\";s:9:\"footer 01\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.14.jpg\";s:12:\"tmpl_created\";s:10:\"1524582852\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"433\";s:11:\"trend_index\";s:3:\"496\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:200;a:14:{s:2:\"id\";s:4:\"7852\";s:5:\"title\";s:9:\"footer 02\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.13.jpg\";s:12:\"tmpl_created\";s:10:\"1524582875\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"216\";s:11:\"trend_index\";s:3:\"220\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:201;a:14:{s:2:\"id\";s:4:\"7862\";s:5:\"title\";s:9:\"footer 03\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.12.jpg\";s:12:\"tmpl_created\";s:10:\"1524582903\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-03/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"140\";s:11:\"trend_index\";s:3:\"172\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:202;a:14:{s:2:\"id\";s:5:\"12212\";s:5:\"title\";s:28:\"Law Firm &#8211; Single Post\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/single.png\";s:12:\"tmpl_created\";s:10:\"1572846914\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/blocks/law-firm-single-post/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"416\";s:11:\"trend_index\";s:3:\"215\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:203;a:14:{s:2:\"id\";s:4:\"7871\";s:5:\"title\";s:9:\"footer 04\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.11.jpg\";s:12:\"tmpl_created\";s:10:\"1524582927\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-04/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"101\";s:11:\"trend_index\";s:3:\"146\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:204;a:14:{s:2:\"id\";s:5:\"12203\";s:5:\"title\";s:30:\"Law Firm &#8211; Search Archiv\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/11/search_result.png\";s:12:\"tmpl_created\";s:10:\"1572846925\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/law-firm-search-archiv/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"555\";s:11:\"trend_index\";s:3:\"480\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:205;a:14:{s:2:\"id\";s:4:\"7884\";s:5:\"title\";s:9:\"footer 05\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.10.jpg\";s:12:\"tmpl_created\";s:10:\"1524582944\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-05/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"73\";s:11:\"trend_index\";s:3:\"160\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:206;a:14:{s:2:\"id\";s:5:\"12194\";s:5:\"title\";s:23:\"Law Firm &#8211; Header\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/header.png\";s:12:\"tmpl_created\";s:10:\"1572846935\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/law-firm-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:27:\"[\"header\",\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"168\";s:11:\"trend_index\";s:2:\"40\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:207;a:14:{s:2:\"id\";s:4:\"7892\";s:5:\"title\";s:9:\"footer 06\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.9.jpg\";s:12:\"tmpl_created\";s:10:\"1524583015\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-06/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"116\";s:11:\"trend_index\";s:3:\"199\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:208;a:14:{s:2:\"id\";s:5:\"12179\";s:5:\"title\";s:23:\"Law Firm &#8211; Footer\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/footer.png\";s:12:\"tmpl_created\";s:10:\"1572846958\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/law-firm-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:27:\"[\"footer\",\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"454\";s:11:\"trend_index\";s:3:\"308\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:209;a:14:{s:2:\"id\";s:4:\"4212\";s:5:\"title\";s:11:\"Services 23\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443248\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-23/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"129\";s:11:\"trend_index\";s:3:\"166\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:210;a:14:{s:2:\"id\";s:4:\"7825\";s:5:\"title\";s:9:\"header 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.11.jpg\";s:12:\"tmpl_created\";s:10:\"1524583273\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"77\";s:11:\"trend_index\";s:2:\"80\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:211;a:14:{s:2:\"id\";s:5:\"12170\";s:5:\"title\";s:23:\"Law Firm &#8211; Archiv\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/archiv.png\";s:12:\"tmpl_created\";s:10:\"1572846967\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/law-firm-archiv/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"466\";s:11:\"trend_index\";s:3:\"380\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:212;a:14:{s:2:\"id\";s:4:\"4227\";s:5:\"title\";s:11:\"Services 30\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443250\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-30/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"332\";s:11:\"trend_index\";s:3:\"296\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:213;a:14:{s:2:\"id\";s:4:\"7812\";s:5:\"title\";s:9:\"header 11\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.10.jpg\";s:12:\"tmpl_created\";s:10:\"1524583298\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"109\";s:11:\"trend_index\";s:3:\"116\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:214;a:14:{s:2:\"id\";s:5:\"12164\";s:5:\"title\";s:20:\"Law Firm &#8211; 404\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/11/404.png\";s:12:\"tmpl_created\";s:10:\"1572846979\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/law-firm-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:24:\"[\"404\",\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"653\";s:11:\"trend_index\";s:3:\"608\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:215;a:14:{s:2:\"id\";s:4:\"4235\";s:5:\"title\";s:11:\"Services 18\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443251\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"286\";s:11:\"trend_index\";s:3:\"212\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:216;a:14:{s:2:\"id\";s:4:\"7724\";s:5:\"title\";s:8:\"header 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1524583367\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"32\";s:11:\"trend_index\";s:2:\"29\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:217;a:14:{s:2:\"id\";s:4:\"4244\";s:5:\"title\";s:11:\"Services 26\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443253\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-26/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"464\";s:11:\"trend_index\";s:3:\"492\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:218;a:14:{s:2:\"id\";s:4:\"7734\";s:5:\"title\";s:8:\"header 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1524583436\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"39\";s:11:\"trend_index\";s:2:\"53\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:219;a:14:{s:2:\"id\";s:4:\"4252\";s:5:\"title\";s:10:\"Services 9\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443255\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"45\";s:11:\"trend_index\";s:2:\"27\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:220;a:14:{s:2:\"id\";s:4:\"7771\";s:5:\"title\";s:8:\"header 8\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1524583540\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"103\";s:11:\"trend_index\";s:2:\"95\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:221;a:14:{s:2:\"id\";s:4:\"4260\";s:5:\"title\";s:11:\"Services 25\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443257\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-25/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"187\";s:11:\"trend_index\";s:3:\"125\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:222;a:14:{s:2:\"id\";s:4:\"7787\";s:5:\"title\";s:8:\"header 9\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.8.jpg\";s:12:\"tmpl_created\";s:10:\"1524583598\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"107\";s:11:\"trend_index\";s:3:\"140\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:223;a:14:{s:2:\"id\";s:4:\"4268\";s:5:\"title\";s:10:\"Services 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443259\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"162\";s:11:\"trend_index\";s:3:\"185\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:224;a:14:{s:2:\"id\";s:4:\"7801\";s:5:\"title\";s:9:\"header 10\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.9.jpg\";s:12:\"tmpl_created\";s:10:\"1524583659\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"55\";s:11:\"trend_index\";s:2:\"77\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:225;a:14:{s:2:\"id\";s:4:\"4276\";s:5:\"title\";s:11:\"Services 24\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443261\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-24/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"342\";s:11:\"trend_index\";s:3:\"366\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:226;a:14:{s:2:\"id\";s:4:\"7754\";s:5:\"title\";s:8:\"header 7\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1524583712\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"81\";s:11:\"trend_index\";s:3:\"156\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:227;a:14:{s:2:\"id\";s:4:\"4284\";s:5:\"title\";s:10:\"Services 7\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443263\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"48\";s:11:\"trend_index\";s:1:\"9\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:228;a:14:{s:2:\"id\";s:4:\"7713\";s:5:\"title\";s:8:\"header 3\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1524584780\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"49\";s:11:\"trend_index\";s:2:\"56\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:229;a:14:{s:2:\"id\";s:4:\"4293\";s:5:\"title\";s:10:\"Services 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443265\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"280\";s:11:\"trend_index\";s:3:\"318\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:230;a:14:{s:2:\"id\";s:4:\"7744\";s:5:\"title\";s:8:\"Header 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1524584784\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"57\";s:11:\"trend_index\";s:3:\"131\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:231;a:14:{s:2:\"id\";s:4:\"4302\";s:5:\"title\";s:10:\"Services 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443266\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"64\";s:11:\"trend_index\";s:2:\"39\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:232;a:14:{s:2:\"id\";s:5:\"12229\";s:5:\"title\";s:33:\"Slide In | Law Firm | Information\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2019/11/popup.png\";s:12:\"tmpl_created\";s:10:\"1572847842\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/slide-in-law-firm-information/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"547\";s:11:\"trend_index\";s:3:\"507\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:233;a:14:{s:2:\"id\";s:4:\"4313\";s:5:\"title\";s:11:\"Services 13\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443268\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"128\";s:11:\"trend_index\";s:2:\"94\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:234;a:14:{s:2:\"id\";s:4:\"8523\";s:5:\"title\";s:11:\"404 page 06\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/006.jpg\";s:12:\"tmpl_created\";s:10:\"1526415291\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-06/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"304\";s:11:\"trend_index\";s:3:\"421\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:235;a:14:{s:2:\"id\";s:5:\"12550\";s:5:\"title\";s:32:\"Fly-in | Sale | Travel and Tours\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/12/PopUp_s.png\";s:12:\"tmpl_created\";s:10:\"1575960263\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/flyin-sale-travel-and-tours/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"672\";s:11:\"trend_index\";s:3:\"651\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:236;a:14:{s:2:\"id\";s:4:\"4324\";s:5:\"title\";s:11:\"Services 14\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443270\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"292\";s:11:\"trend_index\";s:3:\"243\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:237;a:14:{s:2:\"id\";s:4:\"8524\";s:5:\"title\";s:11:\"404 page 07\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/007.jpg\";s:12:\"tmpl_created\";s:10:\"1526415337\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-07/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"302\";s:11:\"trend_index\";s:3:\"349\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:238;a:14:{s:2:\"id\";s:5:\"12540\";s:5:\"title\";s:33:\"Classic | Menu | Travel and tours\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/12/PopUp_Menu_s.png\";s:12:\"tmpl_created\";s:10:\"1575960267\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/classic-menu-travel-and-tours/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"632\";s:11:\"trend_index\";s:3:\"548\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:239;a:14:{s:2:\"id\";s:4:\"4332\";s:5:\"title\";s:11:\"Services 22\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520443272\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-22/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"143\";s:11:\"trend_index\";s:3:\"130\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:240;a:14:{s:2:\"id\";s:4:\"8525\";s:5:\"title\";s:11:\"404 page 08\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/008.jpg\";s:12:\"tmpl_created\";s:10:\"1526415374\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-08/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"462\";s:11:\"trend_index\";s:3:\"583\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:241;a:14:{s:2:\"id\";s:5:\"12492\";s:5:\"title\";s:14:\"Travel -Footer\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/12/Footer_s.png\";s:12:\"tmpl_created\";s:10:\"1575960358\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/travel-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:27:\"[\"footer\",\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"501\";s:11:\"trend_index\";s:3:\"316\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:242;a:14:{s:2:\"id\";s:4:\"4341\";s:5:\"title\";s:11:\"Services 21\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520443274\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"142\";s:11:\"trend_index\";s:3:\"102\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:243;a:14:{s:2:\"id\";s:4:\"8513\";s:5:\"title\";s:11:\"404 page 04\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/004.jpg\";s:12:\"tmpl_created\";s:10:\"1526415417\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-04/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"418\";s:11:\"trend_index\";s:3:\"570\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:244;a:14:{s:2:\"id\";s:5:\"12500\";s:5:\"title\";s:21:\"Travel &#8211; Header\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/12/Header_s.png\";s:12:\"tmpl_created\";s:10:\"1575960371\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/travel-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:27:\"[\"header\",\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"448\";s:11:\"trend_index\";s:3:\"305\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:245;a:14:{s:2:\"id\";s:4:\"4349\";s:5:\"title\";s:11:\"Services 29\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_11.png\";s:12:\"tmpl_created\";s:10:\"1520443275\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-29/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"312\";s:11:\"trend_index\";s:3:\"311\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:246;a:14:{s:2:\"id\";s:4:\"8512\";s:5:\"title\";s:11:\"404 page 03\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/003.jpg\";s:12:\"tmpl_created\";s:10:\"1526415449\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-03/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"458\";s:11:\"trend_index\";s:3:\"445\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:247;a:14:{s:2:\"id\";s:5:\"12509\";s:5:\"title\";s:18:\"Travel &#8211; 404\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/12/404.png\";s:12:\"tmpl_created\";s:10:\"1575960378\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/travel-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:24:\"[\"404\",\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"656\";s:11:\"trend_index\";s:3:\"618\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:248;a:14:{s:2:\"id\";s:4:\"4357\";s:5:\"title\";s:11:\"Services 20\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_12.png\";s:12:\"tmpl_created\";s:10:\"1520443277\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"46\";s:11:\"trend_index\";s:2:\"36\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:249;a:14:{s:2:\"id\";s:4:\"8526\";s:5:\"title\";s:11:\"404 page 09\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/009.jpg\";s:12:\"tmpl_created\";s:10:\"1526415474\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-09/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"461\";s:11:\"trend_index\";s:3:\"581\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:250;a:14:{s:2:\"id\";s:5:\"12516\";s:5:\"title\";s:27:\"Travel &#8211; Archive Blog\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/12/Archiv_s.png\";s:12:\"tmpl_created\";s:10:\"1575960387\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/travel-archive-blog/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"506\";s:11:\"trend_index\";s:3:\"388\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:251;a:14:{s:2:\"id\";s:4:\"4368\";s:5:\"title\";s:11:\"Services 16\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_13.png\";s:12:\"tmpl_created\";s:10:\"1520443279\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"66\";s:11:\"trend_index\";s:2:\"49\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:252;a:14:{s:2:\"id\";s:4:\"8505\";s:5:\"title\";s:11:\"404 page 01\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/001.jpg\";s:12:\"tmpl_created\";s:10:\"1526415501\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"549\";s:11:\"trend_index\";s:3:\"669\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:253;a:14:{s:2:\"id\";s:5:\"12524\";s:5:\"title\";s:26:\"Travel &#8211; Single Post\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/12/Single_Post_s.png\";s:12:\"tmpl_created\";s:10:\"1575960397\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/blocks/travel-single-post/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"572\";s:11:\"trend_index\";s:3:\"459\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:254;a:14:{s:2:\"id\";s:4:\"4376\";s:5:\"title\";s:11:\"Services 28\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_12.png\";s:12:\"tmpl_created\";s:10:\"1520443281\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-28/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"147\";s:11:\"trend_index\";s:3:\"165\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:255;a:14:{s:2:\"id\";s:4:\"8511\";s:5:\"title\";s:11:\"404 page 02\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/002.jpg\";s:12:\"tmpl_created\";s:10:\"1526415528\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"362\";s:11:\"trend_index\";s:3:\"435\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:256;a:14:{s:2:\"id\";s:5:\"12531\";s:5:\"title\";s:31:\"Travel &#8211; Single Post Tour\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/12/Single_Tour_s.png\";s:12:\"tmpl_created\";s:10:\"1575960404\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/blocks/travel-single-post-tour/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"591\";s:11:\"trend_index\";s:3:\"544\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:257;a:14:{s:2:\"id\";s:4:\"4391\";s:5:\"title\";s:11:\"Services 17\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_14.png\";s:12:\"tmpl_created\";s:10:\"1520443283\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"148\";s:11:\"trend_index\";s:3:\"151\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:258;a:14:{s:2:\"id\";s:4:\"8514\";s:5:\"title\";s:11:\"404 Page 05\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/005.jpg\";s:12:\"tmpl_created\";s:10:\"1526415558\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-05/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"414\";s:11:\"trend_index\";s:3:\"559\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:259;a:14:{s:2:\"id\";s:4:\"4400\";s:5:\"title\";s:11:\"Services 27\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_13.png\";s:12:\"tmpl_created\";s:10:\"1520443285\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-27/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"263\";s:11:\"trend_index\";s:3:\"234\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:260;a:14:{s:2:\"id\";s:4:\"8676\";s:5:\"title\";s:13:\"single page 1\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1527682423\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"333\";s:11:\"trend_index\";s:3:\"353\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:261;a:14:{s:2:\"id\";s:4:\"4411\";s:5:\"title\";s:9:\"Contact 3\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443287\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/contact-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"96\";s:11:\"trend_index\";s:3:\"141\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:262;a:14:{s:2:\"id\";s:4:\"8678\";s:5:\"title\";s:13:\"single page 2\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1527682780\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"180\";s:11:\"trend_index\";s:3:\"205\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:263;a:14:{s:2:\"id\";s:4:\"4420\";s:5:\"title\";s:9:\"Contact 1\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443289\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/contact-1-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"182\";s:11:\"trend_index\";s:3:\"238\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:264;a:14:{s:2:\"id\";s:4:\"8679\";s:5:\"title\";s:13:\"single page 3\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1527682847\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"195\";s:11:\"trend_index\";s:3:\"223\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:265;a:14:{s:2:\"id\";s:4:\"4428\";s:5:\"title\";s:9:\"Contact 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443291\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"104\";s:11:\"trend_index\";s:3:\"147\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:266;a:14:{s:2:\"id\";s:4:\"8680\";s:5:\"title\";s:13:\"single page 4\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1527682896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"404\";s:11:\"trend_index\";s:3:\"416\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:267;a:14:{s:2:\"id\";s:4:\"4436\";s:5:\"title\";s:11:\"Contact  16\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443293\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"163\";s:11:\"trend_index\";s:3:\"176\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:268;a:14:{s:2:\"id\";s:4:\"8681\";s:5:\"title\";s:13:\"single page 5\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1527682969\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"310\";s:11:\"trend_index\";s:3:\"379\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:269;a:14:{s:2:\"id\";s:4:\"4444\";s:5:\"title\";s:9:\"Contact 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443295\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"92\";s:11:\"trend_index\";s:2:\"83\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:270;a:14:{s:2:\"id\";s:4:\"8682\";s:5:\"title\";s:13:\"single page 6\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1527683026\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"435\";s:11:\"trend_index\";s:3:\"502\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:271;a:14:{s:2:\"id\";s:4:\"4452\";s:5:\"title\";s:9:\"Contact 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443296\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"144\";s:11:\"trend_index\";s:3:\"101\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:272;a:14:{s:2:\"id\";s:4:\"8703\";s:5:\"title\";s:13:\"single page 7\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1527683072\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"400\";s:11:\"trend_index\";s:3:\"475\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:273;a:14:{s:2:\"id\";s:4:\"4460\";s:5:\"title\";s:9:\"Contact 9\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443298\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"119\";s:11:\"trend_index\";s:2:\"64\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:274;a:14:{s:2:\"id\";s:4:\"8961\";s:5:\"title\";s:9:\"archive 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1528639909\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"85\";s:11:\"trend_index\";s:3:\"154\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:275;a:14:{s:2:\"id\";s:4:\"4468\";s:5:\"title\";s:9:\"Contact 7\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443301\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"136\";s:11:\"trend_index\";s:3:\"174\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:276;a:14:{s:2:\"id\";s:4:\"8969\";s:5:\"title\";s:9:\"archive 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1528700014\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"222\";s:11:\"trend_index\";s:3:\"364\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:277;a:14:{s:2:\"id\";s:5:\"12716\";s:5:\"title\";s:30:\"Magazine &#8211; Single Post 3\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/01/Post4_s.png\";s:12:\"tmpl_created\";s:10:\"1579060659\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/blocks/magazine-single-post-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"567\";s:11:\"trend_index\";s:3:\"337\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:278;a:14:{s:2:\"id\";s:4:\"4476\";s:5:\"title\";s:10:\"Contact 15\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443303\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"242\";s:11:\"trend_index\";s:3:\"299\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:279;a:14:{s:2:\"id\";s:4:\"8973\";s:5:\"title\";s:9:\"archive 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1528700205\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"174\";s:11:\"trend_index\";s:3:\"293\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:280;a:14:{s:2:\"id\";s:5:\"12707\";s:5:\"title\";s:30:\"Magazine &#8211; Single Post 3\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/01/Post1_s.png\";s:12:\"tmpl_created\";s:10:\"1579060669\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/magazine-single-post-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"551\";s:11:\"trend_index\";s:3:\"363\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:281;a:14:{s:2:\"id\";s:4:\"4484\";s:5:\"title\";s:9:\"Contact 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443305\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"323\";s:11:\"trend_index\";s:3:\"334\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:282;a:14:{s:2:\"id\";s:4:\"8977\";s:5:\"title\";s:9:\"archive 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1528700326\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"339\";s:11:\"trend_index\";s:3:\"420\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:283;a:14:{s:2:\"id\";s:5:\"12699\";s:5:\"title\";s:30:\"Magazine &#8211; Single Post 2\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/01/Post3_s.png\";s:12:\"tmpl_created\";s:10:\"1579060680\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/magazine-single-post-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"495\";s:11:\"trend_index\";s:3:\"287\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:284;a:14:{s:2:\"id\";s:4:\"4492\";s:5:\"title\";s:9:\"Contact 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443307\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/contact-5-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"43\";s:11:\"trend_index\";s:2:\"17\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:285;a:14:{s:2:\"id\";s:4:\"8981\";s:5:\"title\";s:9:\"archive 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1528700484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"307\";s:11:\"trend_index\";s:3:\"357\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:286;a:14:{s:2:\"id\";s:5:\"12688\";s:5:\"title\";s:30:\"Magazine &#8211; Single Post 1\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/01/Post2_s.png\";s:12:\"tmpl_created\";s:10:\"1579060692\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/magazine-single-post-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"481\";s:11:\"trend_index\";s:3:\"230\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:287;a:14:{s:2:\"id\";s:4:\"4500\";s:5:\"title\";s:9:\"Pricing 7\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443308\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"446\";s:11:\"trend_index\";s:3:\"461\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:288;a:14:{s:2:\"id\";s:4:\"8985\";s:5:\"title\";s:9:\"archive 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1528700612\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"207\";s:11:\"trend_index\";s:3:\"272\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:289;a:14:{s:2:\"id\";s:5:\"12678\";s:5:\"title\";s:23:\"Magazine &#8211; Header\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/01/Header_s.png\";s:12:\"tmpl_created\";s:10:\"1579060701\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/magazine-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:28:\"[\"Blog\",\"header\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"366\";s:11:\"trend_index\";s:3:\"110\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:290;a:14:{s:2:\"id\";s:4:\"4509\";s:5:\"title\";s:9:\"Pricing 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443310\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"616\";s:11:\"trend_index\";s:3:\"627\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:291;a:14:{s:2:\"id\";s:4:\"8989\";s:5:\"title\";s:9:\"archive 7\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1528701063\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"198\";s:11:\"trend_index\";s:3:\"279\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:292;a:14:{s:2:\"id\";s:5:\"12669\";s:5:\"title\";s:23:\"Magazine &#8211; Footer\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/01/Footer_s.png\";s:12:\"tmpl_created\";s:10:\"1579060715\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/magazine-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:28:\"[\"Blog\",\"footer\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"504\";s:11:\"trend_index\";s:3:\"325\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:293;a:14:{s:2:\"id\";s:4:\"4521\";s:5:\"title\";s:9:\"Pricing 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443312\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"311\";s:11:\"trend_index\";s:3:\"283\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:294;a:14:{s:2:\"id\";s:4:\"8996\";s:5:\"title\";s:9:\"archive 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.8.jpg\";s:12:\"tmpl_created\";s:10:\"1528701290\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"202\";s:11:\"trend_index\";s:3:\"291\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:295;a:14:{s:2:\"id\";s:5:\"12661\";s:5:\"title\";s:23:\"Magazine &#8211; Search\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/01/Search_s.png\";s:12:\"tmpl_created\";s:10:\"1579060722\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/magazine-search/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"515\";s:11:\"trend_index\";s:3:\"290\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:296;a:14:{s:2:\"id\";s:4:\"4529\";s:5:\"title\";s:9:\"Pricing 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443314\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"541\";s:11:\"trend_index\";s:3:\"521\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:297;a:14:{s:2:\"id\";s:4:\"9001\";s:5:\"title\";s:9:\"archive 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.9.jpg\";s:12:\"tmpl_created\";s:10:\"1528701433\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"251\";s:11:\"trend_index\";s:3:\"409\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:298;a:14:{s:2:\"id\";s:5:\"12652\";s:5:\"title\";s:17:\"Magazine- Archiv2\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2020/01/Archiv2_s.png\";s:12:\"tmpl_created\";s:10:\"1579060730\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/magazine-archiv2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"554\";s:11:\"trend_index\";s:3:\"386\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:299;a:14:{s:2:\"id\";s:4:\"4537\";s:5:\"title\";s:9:\"Pricing 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443315\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"508\";s:11:\"trend_index\";s:3:\"493\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:300;a:14:{s:2:\"id\";s:4:\"9119\";s:5:\"title\";s:10:\"footer 015\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/Footer_GetStarted_350.png\";s:12:\"tmpl_created\";s:10:\"1532428138\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/blocks/demo/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"249\";s:11:\"trend_index\";s:3:\"313\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:301;a:14:{s:2:\"id\";s:5:\"12643\";s:5:\"title\";s:24:\"Magazine &#8211; Archiv1\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2020/01/Archiv1_s.png\";s:12:\"tmpl_created\";s:10:\"1579060737\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/magazine-archiv1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"469\";s:11:\"trend_index\";s:3:\"201\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:302;a:14:{s:2:\"id\";s:4:\"4545\";s:5:\"title\";s:9:\"Pricing 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443317\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"612\";s:11:\"trend_index\";s:3:\"598\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:303;a:14:{s:2:\"id\";s:4:\"9127\";s:5:\"title\";s:9:\"header 13\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2018/07/Header_get_started_1200V3.png\";s:12:\"tmpl_created\";s:10:\"1532428699\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"54\";s:11:\"trend_index\";s:3:\"100\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:304;a:14:{s:2:\"id\";s:5:\"12635\";s:5:\"title\";s:20:\"Magazine &#8211; 404\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2020/01/404_s.png\";s:12:\"tmpl_created\";s:10:\"1579060746\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/magazine-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:25:\"[\"404\",\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"622\";s:11:\"trend_index\";s:3:\"569\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:305;a:14:{s:2:\"id\";s:4:\"4553\";s:5:\"title\";s:10:\"Pricing 10\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443319\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"463\";s:11:\"trend_index\";s:3:\"511\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:306;a:14:{s:2:\"id\";s:5:\"12736\";s:5:\"title\";s:41:\"Slide In | Contact Us | Magazine and Blog\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2020/01/PopUp_contact_s.png\";s:12:\"tmpl_created\";s:10:\"1579060978\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/slide-in-contact-us/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"669\";s:11:\"trend_index\";s:3:\"655\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:307;a:14:{s:2:\"id\";s:4:\"4562\";s:5:\"title\";s:9:\"Pricing 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443322\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"605\";s:11:\"trend_index\";s:3:\"635\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:308;a:14:{s:2:\"id\";s:5:\"12726\";s:5:\"title\";s:52:\"Classic | Newsletter | Subscribe | Magazine and Blog\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2020/01/PopUp_Newsletter_s.png\";s:12:\"tmpl_created\";s:10:\"1579061019\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:143:\"https://library.elementor.com/popups/classic-newsletter-subscribe-magazine-and-blog/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"519\";s:11:\"trend_index\";s:3:\"213\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:309;a:14:{s:2:\"id\";s:4:\"4572\";s:5:\"title\";s:10:\"Pricing 11\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443324\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"306\";s:11:\"trend_index\";s:3:\"322\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:310;a:14:{s:2:\"id\";s:4:\"9174\";s:5:\"title\";s:17:\"single product 01\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product01_350.png\";s:12:\"tmpl_created\";s:10:\"1532950125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"52\";s:11:\"trend_index\";s:2:\"22\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:311;a:14:{s:2:\"id\";s:5:\"13089\";s:5:\"title\";s:23:\"Photography &#8211; 404\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2020/02/404_s.png\";s:12:\"tmpl_created\";s:10:\"1582091623\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/photography-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:33:\"[\"404\",\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"665\";s:11:\"trend_index\";s:3:\"547\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:312;a:14:{s:2:\"id\";s:4:\"4580\";s:5:\"title\";s:10:\"Pricing 12\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443326\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"502\";s:11:\"trend_index\";s:3:\"530\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:313;a:14:{s:2:\"id\";s:4:\"9178\";s:5:\"title\";s:17:\"single product 02\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product02_350new.png\";s:12:\"tmpl_created\";s:10:\"1532951997\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"95\";s:11:\"trend_index\";s:2:\"76\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:314;a:14:{s:2:\"id\";s:5:\"13096\";s:5:\"title\";s:32:\"Photography &#8211; Archiv Media\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/02/Archiv_s.png\";s:12:\"tmpl_created\";s:10:\"1582091742\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/blocks/photography-archiv-media/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"628\";s:11:\"trend_index\";s:3:\"396\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:315;a:14:{s:2:\"id\";s:4:\"4589\";s:5:\"title\";s:9:\"Pricing 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443327\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"618\";s:11:\"trend_index\";s:3:\"664\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:316;a:14:{s:2:\"id\";s:4:\"9180\";s:5:\"title\";s:17:\"single product 03\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product03_350.png\";s:12:\"tmpl_created\";s:10:\"1532952302\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-03/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"141\";s:11:\"trend_index\";s:3:\"104\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:317;a:14:{s:2:\"id\";s:5:\"13103\";s:5:\"title\";s:26:\"Photography &#8211; Footer\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/02/Footer_s.png\";s:12:\"tmpl_created\";s:10:\"1582091903\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/blocks/photography-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:36:\"[\"footer\",\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"524\";s:11:\"trend_index\";s:3:\"195\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:318;a:14:{s:2:\"id\";s:4:\"4597\";s:5:\"title\";s:10:\"Pricing 13\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443330\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"532\";s:11:\"trend_index\";s:3:\"606\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:319;a:14:{s:2:\"id\";s:4:\"9182\";s:5:\"title\";s:17:\"single product 04\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product040_350.png\";s:12:\"tmpl_created\";s:10:\"1532952606\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-04/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"154\";s:11:\"trend_index\";s:2:\"91\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:320;a:14:{s:2:\"id\";s:5:\"13120\";s:5:\"title\";s:31:\"Photography &#8211; Single Post\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/02/Post_s.png\";s:12:\"tmpl_created\";s:10:\"1582092351\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/blocks/photography-single-post/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"655\";s:11:\"trend_index\";s:3:\"588\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:321;a:14:{s:2:\"id\";s:4:\"4605\";s:5:\"title\";s:9:\"Pricing 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520443332\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"636\";s:11:\"trend_index\";s:3:\"660\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:322;a:14:{s:2:\"id\";s:4:\"9239\";s:5:\"title\";s:17:\"product archive 1\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/product-archive-350-1.png\";s:12:\"tmpl_created\";s:10:\"1532953482\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/product-archive-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:15:\"product archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"93\";s:11:\"trend_index\";s:2:\"55\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:323;a:14:{s:2:\"id\";s:5:\"13112\";s:5:\"title\";s:26:\"Photography &#8211; Header\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/02/Header_s.png\";s:12:\"tmpl_created\";s:10:\"1582092483\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/blocks/photography-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:36:\"[\"header\",\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"407\";s:11:\"trend_index\";s:3:\"106\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:324;a:14:{s:2:\"id\";s:4:\"4613\";s:5:\"title\";s:10:\"Pricing 14\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443334\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"500\";s:11:\"trend_index\";s:3:\"527\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:325;a:14:{s:2:\"id\";s:4:\"9247\";s:5:\"title\";s:17:\"product archive 2\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/product-archive-350-2.png\";s:12:\"tmpl_created\";s:10:\"1532953793\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/product-archive-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:15:\"product archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"112\";s:11:\"trend_index\";s:2:\"60\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:326;a:14:{s:2:\"id\";s:5:\"13129\";s:5:\"title\";s:28:\"Classic | Menu | Photography\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/02/PopUp_s.png\";s:12:\"tmpl_created\";s:10:\"1582092645\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/classic-menu-photography/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"639\";s:11:\"trend_index\";s:3:\"433\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:327;a:14:{s:2:\"id\";s:4:\"9254\";s:5:\"title\";s:17:\"product archive 3\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/product-archive-350-3.png\";s:12:\"tmpl_created\";s:10:\"1532954032\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/product-archive-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:15:\"product archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"120\";s:11:\"trend_index\";s:2:\"68\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:328;a:14:{s:2:\"id\";s:4:\"9301\";s:5:\"title\";s:13:\"Single Post 4\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3003.jpg\";s:12:\"tmpl_created\";s:10:\"1537440661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"211\";s:11:\"trend_index\";s:3:\"245\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:329;a:14:{s:2:\"id\";s:4:\"9296\";s:5:\"title\";s:13:\"Single Post 3\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3002.jpg\";s:12:\"tmpl_created\";s:10:\"1537440673\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"193\";s:11:\"trend_index\";s:3:\"207\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:330;a:14:{s:2:\"id\";s:4:\"9313\";s:5:\"title\";s:13:\"Single Post 5\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3001.jpg\";s:12:\"tmpl_created\";s:10:\"1537440798\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"169\";s:11:\"trend_index\";s:3:\"307\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:331;a:14:{s:2:\"id\";s:4:\"9343\";s:5:\"title\";s:13:\"Single Post 6\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3004.jpg\";s:12:\"tmpl_created\";s:10:\"1537443531\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"191\";s:11:\"trend_index\";s:3:\"317\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:332;a:14:{s:2:\"id\";s:4:\"9349\";s:5:\"title\";s:13:\"Single Post 7\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3005.jpg\";s:12:\"tmpl_created\";s:10:\"1537443903\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"135\";s:11:\"trend_index\";s:3:\"190\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:333;a:14:{s:2:\"id\";s:4:\"4690\";s:5:\"title\";s:6:\"Team 7\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443348\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"231\";s:11:\"trend_index\";s:3:\"196\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:334;a:14:{s:2:\"id\";s:4:\"4698\";s:5:\"title\";s:7:\"Team 15\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443350\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"391\";s:11:\"trend_index\";s:3:\"411\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:335;a:14:{s:2:\"id\";s:4:\"4706\";s:5:\"title\";s:6:\"Team 5\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443352\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"139\";s:11:\"trend_index\";s:3:\"184\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:336;a:14:{s:2:\"id\";s:4:\"4718\";s:5:\"title\";s:6:\"Team 4\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443354\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"173\";s:11:\"trend_index\";s:3:\"164\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:337;a:14:{s:2:\"id\";s:4:\"4727\";s:5:\"title\";s:7:\"Team 13\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443356\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"360\";s:11:\"trend_index\";s:3:\"319\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:338;a:14:{s:2:\"id\";s:4:\"4736\";s:5:\"title\";s:7:\"Team 20\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443358\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"138\";s:11:\"trend_index\";s:3:\"137\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:339;a:14:{s:2:\"id\";s:4:\"4746\";s:5:\"title\";s:7:\"Team 23\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443360\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-23/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"260\";s:11:\"trend_index\";s:3:\"267\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:340;a:14:{s:2:\"id\";s:4:\"4759\";s:5:\"title\";s:7:\"Team 22\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443362\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-22/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"281\";s:11:\"trend_index\";s:3:\"306\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:341;a:14:{s:2:\"id\";s:4:\"4770\";s:5:\"title\";s:7:\"Team 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443364\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/team-12-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"377\";s:11:\"trend_index\";s:3:\"443\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:342;a:14:{s:2:\"id\";s:4:\"4781\";s:5:\"title\";s:7:\"Team 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443365\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"245\";s:11:\"trend_index\";s:3:\"328\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:343;a:14:{s:2:\"id\";s:4:\"9611\";s:5:\"title\";s:16:\"Hello Bar | Sale\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2019/01/Top-Bar_Sale_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546965350\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/hello-bar-sale-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"553\";s:11:\"trend_index\";s:3:\"622\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:344;a:14:{s:2:\"id\";s:5:\"13274\";s:5:\"title\";s:38:\"Interior Design &#8211; Single Project\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2020/04/Single-Project-.png\";s:12:\"tmpl_created\";s:10:\"1586148723\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/blocks/interior-design-single-project/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"663\";s:11:\"trend_index\";s:3:\"367\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:345;a:14:{s:2:\"id\";s:4:\"4793\";s:5:\"title\";s:7:\"Team 18\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443367\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"188\";s:11:\"trend_index\";s:3:\"257\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:346;a:14:{s:2:\"id\";s:4:\"9622\";s:5:\"title\";s:19:\"Classic | Promotion\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_promotion_small_02.png\";s:12:\"tmpl_created\";s:10:\"1546965896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-promotion-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"557\";s:11:\"trend_index\";s:3:\"491\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:347;a:14:{s:2:\"id\";s:5:\"13267\";s:5:\"title\";s:35:\"Interior Design &#8211; Single News\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2020/04/Post.png\";s:12:\"tmpl_created\";s:10:\"1586148728\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/blocks/interior-design-single-news/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"631\";s:11:\"trend_index\";s:3:\"297\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:348;a:14:{s:2:\"id\";s:4:\"4801\";s:5:\"title\";s:7:\"Team 11\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520443369\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"329\";s:11:\"trend_index\";s:3:\"375\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:349;a:14:{s:2:\"id\";s:4:\"9631\";s:5:\"title\";s:38:\"Slide-in | Sale | Register | Subscribe\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/Slide-in_Sale_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546968270\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/slide-in-sale-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"580\";s:11:\"trend_index\";s:3:\"636\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:350;a:14:{s:2:\"id\";s:5:\"13259\";s:5:\"title\";s:36:\"Interior Design &#8211; News Archive\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2020/04/Archiv-Blog.png\";s:12:\"tmpl_created\";s:10:\"1586148733\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/blocks/interior-design-news-archive/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"621\";s:11:\"trend_index\";s:3:\"232\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:351;a:14:{s:2:\"id\";s:4:\"4809\";s:5:\"title\";s:7:\"Team 19\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443371\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"274\";s:11:\"trend_index\";s:3:\"320\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:352;a:14:{s:2:\"id\";s:5:\"13251\";s:5:\"title\";s:27:\"Interior Design &#8211; 404\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2020/04/404.png\";s:12:\"tmpl_created\";s:10:\"1586148737\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/interior-design-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"680\";s:11:\"trend_index\";s:3:\"457\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:353;a:14:{s:2:\"id\";s:4:\"4818\";s:5:\"title\";s:7:\"Team 21\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520443373\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"430\";s:11:\"trend_index\";s:3:\"580\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:354;a:14:{s:2:\"id\";s:5:\"13244\";s:5:\"title\";s:30:\"Interior Design &#8211; Footer\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/04/Footer.png\";s:12:\"tmpl_created\";s:10:\"1586148742\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/interior-design-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:39:\"[\"business\",\"footer\",\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"585\";s:11:\"trend_index\";s:3:\"158\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:355;a:14:{s:2:\"id\";s:4:\"5045\";s:5:\"title\";s:11:\"Portfolio 3\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443423\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"540\";s:11:\"trend_index\";s:3:\"514\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:356;a:14:{s:2:\"id\";s:4:\"9662\";s:5:\"title\";s:33:\"Bottom Bar | Register | Subscribe\";s:9:\"thumbnail\";s:89:\"https://library.elementor.com/wp-content/uploads/2019/01/Bottom-Bar_Register_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547009087\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/popups/bottom-bar-register-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"602\";s:11:\"trend_index\";s:3:\"654\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:357;a:14:{s:2:\"id\";s:5:\"13236\";s:5:\"title\";s:30:\"Interior Design &#8211; Header\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/04/Header.png\";s:12:\"tmpl_created\";s:10:\"1586148746\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/interior-design-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:39:\"[\"business\",\"header\",\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"424\";s:11:\"trend_index\";s:2:\"31\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:358;a:14:{s:2:\"id\";s:4:\"5157\";s:5:\"title\";s:11:\"Subscribe 1\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443448\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"341\";s:11:\"trend_index\";s:3:\"323\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:359;a:14:{s:2:\"id\";s:5:\"13281\";s:5:\"title\";s:37:\"Hello Bar | Contact | Interior Design\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2020/04/PopUp.png\";s:12:\"tmpl_created\";s:10:\"1586148801\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:130:\"https://library.elementor.com/popups/hello-bar-contact-interior-design/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:19:\"[\"interior design\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"681\";s:11:\"trend_index\";s:3:\"625\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:360;a:14:{s:2:\"id\";s:4:\"5165\";s:5:\"title\";s:11:\"Subscribe 3\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443450\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"476\";s:11:\"trend_index\";s:3:\"567\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:361;a:14:{s:2:\"id\";s:4:\"5173\";s:5:\"title\";s:11:\"Subscribe 5\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443452\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"278\";s:11:\"trend_index\";s:3:\"280\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:362;a:14:{s:2:\"id\";s:4:\"9690\";s:5:\"title\";s:17:\"Classic | Contact\";s:9:\"thumbnail\";s:85:\"https://library.elementor.com/wp-content/uploads/2019/01/Classic_Contact_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547011716\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/classic-contact-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"383\";s:11:\"trend_index\";s:3:\"427\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:363;a:14:{s:2:\"id\";s:4:\"5181\";s:5:\"title\";s:11:\"Subscribe 2\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443454\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/subscribe-2-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"417\";s:11:\"trend_index\";s:3:\"436\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:364;a:14:{s:2:\"id\";s:4:\"9699\";s:5:\"title\";s:33:\"Classic | Contact | Gym | Fitness\";s:9:\"thumbnail\";s:85:\"https://library.elementor.com/wp-content/uploads/2019/01/Classic_Contact_small_02.png\";s:12:\"tmpl_created\";s:10:\"1547015827\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/classic-contact-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"442\";s:11:\"trend_index\";s:3:\"513\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:365;a:14:{s:2:\"id\";s:4:\"5189\";s:5:\"title\";s:6:\"CTA 29\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443456\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-29/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"406\";s:11:\"trend_index\";s:3:\"497\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:366;a:14:{s:2:\"id\";s:4:\"5198\";s:5:\"title\";s:6:\"CTA 30\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443458\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-30/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"487\";s:11:\"trend_index\";s:3:\"556\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:367;a:14:{s:2:\"id\";s:4:\"9571\";s:5:\"title\";s:14:\"Fly In | Login\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/FlyIn_Login_01_small.png\";s:12:\"tmpl_created\";s:10:\"1547726151\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/fly-in-login-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"564\";s:11:\"trend_index\";s:3:\"552\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:368;a:14:{s:2:\"id\";s:5:\"13395\";s:5:\"title\";s:34:\"Online Course &#8211; Start Lesson\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2020/04/Lesson-Start.jpg\";s:12:\"tmpl_created\";s:10:\"1587474673\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/blocks/online-course-start-lesson/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"676\";s:11:\"trend_index\";s:3:\"538\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:369;a:14:{s:2:\"id\";s:4:\"5206\";s:5:\"title\";s:6:\"CTA 31\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443459\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-31/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"517\";s:11:\"trend_index\";s:3:\"578\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:370;a:14:{s:2:\"id\";s:5:\"13387\";s:5:\"title\";s:32:\"Online Course &#8211; End Lesson\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2020/04/Lesson-End-.jpg\";s:12:\"tmpl_created\";s:10:\"1587474682\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/blocks/online-course-end-lesson/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"679\";s:11:\"trend_index\";s:3:\"469\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:371;a:14:{s:2:\"id\";s:4:\"5214\";s:5:\"title\";s:10:\"Contact 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443462\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/contact-16-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"203\";s:11:\"trend_index\";s:3:\"273\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:372;a:14:{s:2:\"id\";s:5:\"13378\";s:5:\"title\";s:28:\"Online Course &#8211; Header\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/04/Header.jpg\";s:12:\"tmpl_created\";s:10:\"1587474693\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/blocks/online-course-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:38:\"[\"Course Online\",\"Education\",\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"647\";s:11:\"trend_index\";s:3:\"186\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:373;a:14:{s:2:\"id\";s:4:\"5222\";s:5:\"title\";s:11:\"Subscribe 4\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443464\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"388\";s:11:\"trend_index\";s:3:\"438\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:374;a:14:{s:2:\"id\";s:4:\"9740\";s:5:\"title\";s:25:\"Classic | Promotion | App\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/app_small.png\";s:12:\"tmpl_created\";s:10:\"1547822836\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/classic-promotion-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"546\";s:11:\"trend_index\";s:3:\"597\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:375;a:14:{s:2:\"id\";s:5:\"13369\";s:5:\"title\";s:28:\"Online Course &#8211; Footer\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/04/Footer.jpg\";s:12:\"tmpl_created\";s:10:\"1587474701\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/blocks/online-course-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:38:\"[\"Course Online\",\"Education\",\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"650\";s:11:\"trend_index\";s:3:\"188\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:376;a:14:{s:2:\"id\";s:4:\"5230\";s:5:\"title\";s:10:\"Contact 17\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443466\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"320\";s:11:\"trend_index\";s:3:\"354\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:377;a:14:{s:2:\"id\";s:5:\"13361\";s:5:\"title\";s:25:\"Online Course &#8211; 404\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2020/04/404.jpg\";s:12:\"tmpl_created\";s:10:\"1587474710\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/online-course-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:35:\"[\"404\",\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"682\";s:11:\"trend_index\";s:3:\"506\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:378;a:14:{s:2:\"id\";s:4:\"5238\";s:5:\"title\";s:7:\"Hero 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443468\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/hero-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"535\";s:11:\"trend_index\";s:3:\"584\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:379;a:14:{s:2:\"id\";s:4:\"9762\";s:5:\"title\";s:36:\"Classic | Register | Subscribe | Spa\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2019/01/spa_small_classic.png\";s:12:\"tmpl_created\";s:10:\"1547824145\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/classic-register-subscribe-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"445\";s:11:\"trend_index\";s:3:\"454\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:380;a:14:{s:2:\"id\";s:5:\"13413\";s:5:\"title\";s:33:\"Classic | Contact | Online Course\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2020/04/PopUp-Help.jpg\";s:12:\"tmpl_created\";s:10:\"1587474761\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/classic-contact-online-course/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"675\";s:11:\"trend_index\";s:3:\"332\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:381;a:14:{s:2:\"id\";s:4:\"5249\";s:5:\"title\";s:6:\"CTA 32\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443470\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-32/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"471\";s:11:\"trend_index\";s:3:\"487\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:382;a:14:{s:2:\"id\";s:4:\"9772\";s:5:\"title\";s:27:\"Hello bar | Promotion | App\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/app_hello_small.png\";s:12:\"tmpl_created\";s:10:\"1547824279\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/hello-bar-promotion-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"654\";s:11:\"trend_index\";s:3:\"653\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:383;a:14:{s:2:\"id\";s:5:\"13402\";s:5:\"title\";s:29:\"Classic | CTA | Online Course\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2020/04/Popup-Course-Completed.jpg\";s:12:\"tmpl_created\";s:10:\"1587474772\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/classic-cta-online-course/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"678\";s:11:\"trend_index\";s:3:\"456\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:384;a:14:{s:2:\"id\";s:4:\"5257\";s:5:\"title\";s:10:\"Contact 18\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443472\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"395\";s:11:\"trend_index\";s:3:\"474\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:385;a:14:{s:2:\"id\";s:5:\"13422\";s:5:\"title\";s:30:\"Classic | Menu | Online Course\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2020/04/PopUp-Menu.jpg\";s:12:\"tmpl_created\";s:10:\"1587474782\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/classic-menu-online-course/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"671\";s:11:\"trend_index\";s:3:\"292\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"1\";}i:386;a:14:{s:2:\"id\";s:4:\"5266\";s:5:\"title\";s:9:\"Clients 4\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443474\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"113\";s:11:\"trend_index\";s:2:\"69\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:387;a:14:{s:2:\"id\";s:4:\"9793\";s:5:\"title\";s:13:\"Fly In | Sale\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_black_small.png\";s:12:\"tmpl_created\";s:10:\"1547831151\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/popups/fly-in-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"593\";s:11:\"trend_index\";s:3:\"633\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:388;a:14:{s:2:\"id\";s:4:\"5275\";s:5:\"title\";s:9:\"Clients 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443476\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"331\";s:11:\"trend_index\";s:3:\"347\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:389;a:14:{s:2:\"id\";s:4:\"5283\";s:5:\"title\";s:9:\"Clients 1\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443478\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/clients-1-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"291\";s:11:\"trend_index\";s:3:\"360\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:390;a:14:{s:2:\"id\";s:4:\"5290\";s:5:\"title\";s:9:\"Clients 3\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443480\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/clients-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"491\";s:11:\"trend_index\";s:3:\"661\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:391;a:14:{s:2:\"id\";s:4:\"5298\";s:5:\"title\";s:10:\"Clients 15\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443482\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"413\";s:11:\"trend_index\";s:3:\"558\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:392;a:14:{s:2:\"id\";s:4:\"9836\";s:5:\"title\";s:21:\"Classic | Login | Pop\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/login_b_small.png\";s:12:\"tmpl_created\";s:10:\"1547835635\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/popups/classic-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"561\";s:11:\"trend_index\";s:3:\"577\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:393;a:14:{s:2:\"id\";s:4:\"5306\";s:5:\"title\";s:10:\"Clients 10\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"578\";s:11:\"trend_index\";s:3:\"603\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:394;a:14:{s:2:\"id\";s:4:\"9847\";s:5:\"title\";s:25:\"Fly In | Promotion | Lego\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/fly_in_promotion_tro.png\";s:12:\"tmpl_created\";s:10:\"1547836956\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/fly-in-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"641\";s:11:\"trend_index\";s:3:\"638\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:395;a:14:{s:2:\"id\";s:4:\"5315\";s:5:\"title\";s:10:\"Clients 12\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_4-1.png\";s:12:\"tmpl_created\";s:10:\"1520443486\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"459\";s:11:\"trend_index\";s:3:\"489\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:396;a:14:{s:2:\"id\";s:4:\"9858\";s:5:\"title\";s:27:\"Slide In | Promotion | Wine\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2019/01/slide-in_promotion_wine_small.png\";s:12:\"tmpl_created\";s:10:\"1547837100\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"666\";s:11:\"trend_index\";s:3:\"663\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:397;a:14:{s:2:\"id\";s:4:\"5324\";s:5:\"title\";s:9:\"Clients 8\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_5-1.png\";s:12:\"tmpl_created\";s:10:\"1520443488\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"475\";s:11:\"trend_index\";s:3:\"549\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:398;a:14:{s:2:\"id\";s:4:\"5333\";s:5:\"title\";s:10:\"Clients 13\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443489\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"237\";s:11:\"trend_index\";s:3:\"274\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:399;a:14:{s:2:\"id\";s:4:\"5341\";s:5:\"title\";s:10:\"Clients 11\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443491\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"534\";s:11:\"trend_index\";s:3:\"566\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:400;a:14:{s:2:\"id\";s:4:\"5349\";s:5:\"title\";s:9:\"Clients 7\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443493\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"235\";s:11:\"trend_index\";s:3:\"236\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:401;a:14:{s:2:\"id\";s:4:\"5357\";s:5:\"title\";s:9:\"Clients 2\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520443495\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/clients-2-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"324\";s:11:\"trend_index\";s:3:\"282\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:402;a:14:{s:2:\"id\";s:4:\"5368\";s:5:\"title\";s:9:\"Clients 9\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443497\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"234\";s:11:\"trend_index\";s:3:\"275\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:403;a:14:{s:2:\"id\";s:4:\"5381\";s:5:\"title\";s:10:\"Clients 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443499\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"184\";s:11:\"trend_index\";s:3:\"259\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:404;a:14:{s:2:\"id\";s:4:\"5389\";s:5:\"title\";s:10:\"Clients 14\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520443501\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"385\";s:11:\"trend_index\";s:3:\"339\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:405;a:14:{s:2:\"id\";s:4:\"9944\";s:5:\"title\";s:33:\"Slide In | Promotion | Headphones\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_head_small.png\";s:12:\"tmpl_created\";s:10:\"1547841939\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/slide-in-promotion-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"643\";s:11:\"trend_index\";s:3:\"672\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:406;a:14:{s:2:\"id\";s:4:\"5397\";s:5:\"title\";s:8:\"About 11\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443503\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"150\";s:11:\"trend_index\";s:3:\"149\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:407;a:14:{s:2:\"id\";s:4:\"9955\";s:5:\"title\";s:14:\"Fly In | Login\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_login_lock_small.png\";s:12:\"tmpl_created\";s:10:\"1547842065\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/popups/fly-in-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"514\";s:11:\"trend_index\";s:3:\"410\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:408;a:14:{s:2:\"id\";s:4:\"5405\";s:5:\"title\";s:8:\"About 12\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443505\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"221\";s:11:\"trend_index\";s:3:\"222\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:409;a:14:{s:2:\"id\";s:4:\"9965\";s:5:\"title\";s:30:\"Classic | Register | Subscribe\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_moon_small.png\";s:12:\"tmpl_created\";s:10:\"1547842174\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"511\";s:11:\"trend_index\";s:3:\"533\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:410;a:14:{s:2:\"id\";s:4:\"5413\";s:5:\"title\";s:8:\"About 21\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443507\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"122\";s:11:\"trend_index\";s:2:\"30\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:411;a:14:{s:2:\"id\";s:4:\"5421\";s:5:\"title\";s:8:\"About 13\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443509\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"239\";s:11:\"trend_index\";s:3:\"178\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:412;a:14:{s:2:\"id\";s:4:\"5429\";s:5:\"title\";s:8:\"About 16\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443510\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"86\";s:11:\"trend_index\";s:2:\"54\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:413;a:14:{s:2:\"id\";s:4:\"9995\";s:5:\"title\";s:27:\"Slide In | Sale | Christmas\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_christmas_small.png\";s:12:\"tmpl_created\";s:10:\"1547844802\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/slide-in-sale-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"667\";s:11:\"trend_index\";s:3:\"677\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:414;a:14:{s:2:\"id\";s:4:\"5438\";s:5:\"title\";s:7:\"About 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443512\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"199\";s:11:\"trend_index\";s:3:\"108\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:415;a:14:{s:2:\"id\";s:4:\"5447\";s:5:\"title\";s:7:\"About 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443514\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"58\";s:11:\"trend_index\";s:2:\"38\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:416;a:14:{s:2:\"id\";s:5:\"10016\";s:5:\"title\";s:16:\"Hello Bar | Sale\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2019/01/Hello-Bar_Promotion_bag_small.png\";s:12:\"tmpl_created\";s:10:\"1547845062\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/hello-bar-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"677\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:417;a:14:{s:2:\"id\";s:4:\"5455\";s:5:\"title\";s:8:\"About 20\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443516\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"134\";s:11:\"trend_index\";s:3:\"173\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:418;a:14:{s:2:\"id\";s:5:\"10026\";s:5:\"title\";s:46:\"Classic | Register | Subscribe | Gym | Fitness\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_register_small.png\";s:12:\"tmpl_created\";s:10:\"1547845205\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"530\";s:11:\"trend_index\";s:3:\"586\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:419;a:14:{s:2:\"id\";s:4:\"5464\";s:5:\"title\";s:8:\"About 17\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443518\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"232\";s:11:\"trend_index\";s:3:\"211\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:420;a:14:{s:2:\"id\";s:5:\"10036\";s:5:\"title\";s:43:\"Full Screen | Sale | Promotion | Headphones\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/full_sale_head_small.png\";s:12:\"tmpl_created\";s:10:\"1547845409\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/full-screen-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"550\";s:11:\"trend_index\";s:3:\"561\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:421;a:14:{s:2:\"id\";s:4:\"5472\";s:5:\"title\";s:7:\"About 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443520\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"209\";s:11:\"trend_index\";s:3:\"218\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:422;a:14:{s:2:\"id\";s:4:\"5480\";s:5:\"title\";s:7:\"About 4\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_7-1.png\";s:12:\"tmpl_created\";s:10:\"1520443522\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-4-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"411\";s:11:\"trend_index\";s:3:\"395\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:423;a:14:{s:2:\"id\";s:5:\"10057\";s:5:\"title\";s:48:\"Hello Bar | Register | Subscribe | Gym | Fitness\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2019/01/hello-bar_register_sport_small.png\";s:12:\"tmpl_created\";s:10:\"1547847938\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/hello-bar-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"658\";s:11:\"trend_index\";s:3:\"667\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:424;a:14:{s:2:\"id\";s:4:\"5488\";s:5:\"title\";s:7:\"About 7\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443524\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"300\";s:11:\"trend_index\";s:3:\"359\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:425;a:14:{s:2:\"id\";s:4:\"5496\";s:5:\"title\";s:7:\"About 9\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_8-1.png\";s:12:\"tmpl_created\";s:10:\"1520443526\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"468\";s:11:\"trend_index\";s:3:\"504\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:426;a:14:{s:2:\"id\";s:4:\"5504\";s:5:\"title\";s:8:\"About 18\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443528\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"105\";s:11:\"trend_index\";s:2:\"92\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:427;a:14:{s:2:\"id\";s:5:\"10087\";s:5:\"title\";s:25:\"Full Screen | Login | Spa\";s:9:\"thumbnail\";s:88:\"https://library.elementor.com/wp-content/uploads/2019/01/full-screen_login_spa_small.png\";s:12:\"tmpl_created\";s:10:\"1547848301\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/full-screen-login-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"568\";s:11:\"trend_index\";s:3:\"594\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:428;a:14:{s:2:\"id\";s:4:\"5515\";s:5:\"title\";s:8:\"About 19\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520443530\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"276\";s:11:\"trend_index\";s:3:\"264\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:429;a:14:{s:2:\"id\";s:5:\"10097\";s:5:\"title\";s:37:\"Classic | Register | Subscribe | Lego\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_lego_small.png\";s:12:\"tmpl_created\";s:10:\"1547848411\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"603\";s:11:\"trend_index\";s:3:\"615\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:430;a:14:{s:2:\"id\";s:4:\"1190\";s:5:\"title\";s:26:\"Landing Page &#8211; Hotel\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/03/lp2-l.png\";s:12:\"tmpl_created\";s:10:\"1490707391\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/landing-page-hotel/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"1\";s:16:\"popularity_index\";s:1:\"4\";s:11:\"trend_index\";s:1:\"1\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:431;a:14:{s:2:\"id\";s:4:\"9816\";s:5:\"title\";s:30:\"Classic | Sale | Gym | Fitness\";s:9:\"thumbnail\";s:85:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_sale_sport_small.png\";s:12:\"tmpl_created\";s:10:\"1547991876\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"1\";s:16:\"popularity_index\";s:3:\"613\";s:11:\"trend_index\";s:3:\"624\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:432;a:14:{s:2:\"id\";s:4:\"9602\";s:5:\"title\";s:35:\"Bottom Bar | Announcement | Cookies\";s:9:\"thumbnail\";s:92:\"https://library.elementor.com/wp-content/uploads/2019/01/Bottombar_Announcement_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546964559\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/bottom-bar-announcement-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"1\";s:16:\"popularity_index\";s:3:\"542\";s:11:\"trend_index\";s:3:\"568\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:433;a:14:{s:2:\"id\";s:3:\"225\";s:5:\"title\";s:27:\"Homepage &#8211; Restaurant\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0016.png\";s:12:\"tmpl_created\";s:10:\"1470829872\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/homepage-restaurant/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Food\",\"Homepage\",\"Restaurant\"]\";s:10:\"menu_order\";s:1:\"2\";s:16:\"popularity_index\";s:1:\"1\";s:11:\"trend_index\";s:1:\"3\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:434;a:14:{s:2:\"id\";s:3:\"463\";s:5:\"title\";s:22:\"Homepage &#8211; Study\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0022.png\";s:12:\"tmpl_created\";s:10:\"1477388340\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/homepage-study/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Education\",\"Homepage\",\"Study\"]\";s:10:\"menu_order\";s:1:\"3\";s:16:\"popularity_index\";s:1:\"5\";s:11:\"trend_index\";s:1:\"4\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:435;a:14:{s:2:\"id\";s:5:\"10277\";s:5:\"title\";s:36:\"Bottom Bar | Promotion | Sale | Book\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/book_small.png\";s:12:\"tmpl_created\";s:10:\"1548055999\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/bottom-bar-promotion-book/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"3\";s:16:\"popularity_index\";s:3:\"630\";s:11:\"trend_index\";s:3:\"675\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:436;a:14:{s:2:\"id\";s:5:\"11241\";s:5:\"title\";s:36:\"Classic | Digital Agency | Marketing\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/07/PopUp_small.jpg\";s:12:\"tmpl_created\";s:10:\"1564643043\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:129:\"https://library.elementor.com/popups/classic-digital-agency-marketing/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"3\";s:16:\"popularity_index\";s:3:\"389\";s:11:\"trend_index\";s:3:\"374\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:437;a:14:{s:2:\"id\";s:3:\"181\";s:5:\"title\";s:23:\"Homepage &#8211; Agency\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0019.png\";s:12:\"tmpl_created\";s:10:\"1470826567\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/homepage-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Agency\",\"Creative\",\"Homepage\"]\";s:10:\"menu_order\";s:1:\"4\";s:16:\"popularity_index\";s:1:\"3\";s:11:\"trend_index\";s:1:\"2\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:438;a:14:{s:2:\"id\";s:4:\"9903\";s:5:\"title\";s:34:\"Bottom Bar | Promotion | Olive Oil\";s:9:\"thumbnail\";s:93:\"https://library.elementor.com/wp-content/uploads/2019/01/bottom-bar_promotion_olive_small.png\";s:12:\"tmpl_created\";s:10:\"1547838896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/bottom-bar-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"4\";s:16:\"popularity_index\";s:3:\"657\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:439;a:14:{s:2:\"id\";s:3:\"150\";s:5:\"title\";s:19:\"Product &#8211; App\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0003.png\";s:12:\"tmpl_created\";s:10:\"1470829879\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/product-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"5\";s:16:\"popularity_index\";s:1:\"8\";s:11:\"trend_index\";s:1:\"5\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:440;a:14:{s:2:\"id\";s:5:\"10549\";s:5:\"title\";s:33:\"Bottom Bar | Register | Subscribe\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/com_small.png\";s:12:\"tmpl_created\";s:10:\"1547967595\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/bottom-bar-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"6\";s:16:\"popularity_index\";s:3:\"624\";s:11:\"trend_index\";s:3:\"658\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:441;a:14:{s:2:\"id\";s:5:\"13307\";s:5:\"title\";s:26:\"Online Course &#8211; Home\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2020/04/Home.jpg\";s:12:\"tmpl_created\";s:10:\"1587474541\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/online-course-home/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"6\";s:16:\"popularity_index\";s:3:\"560\";s:11:\"trend_index\";s:2:\"65\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:442;a:14:{s:2:\"id\";s:5:\"13328\";s:5:\"title\";s:27:\"Online Course &#8211; About\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2020/04/About.jpg\";s:12:\"tmpl_created\";s:10:\"1587474558\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/online-course-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"7\";s:16:\"popularity_index\";s:3:\"646\";s:11:\"trend_index\";s:3:\"200\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:443;a:14:{s:2:\"id\";s:5:\"13338\";s:5:\"title\";s:33:\"Online Course &#8211; Course Page\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2020/04/Course-Page.png\";s:12:\"tmpl_created\";s:10:\"1587474574\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/online-course-course-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"8\";s:16:\"popularity_index\";s:3:\"588\";s:11:\"trend_index\";s:3:\"118\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:444;a:14:{s:2:\"id\";s:5:\"10529\";s:5:\"title\";s:36:\"Classic | Announcement | Maintenance\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/icon_small.png\";s:12:\"tmpl_created\";s:10:\"1548046309\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"9\";s:16:\"popularity_index\";s:3:\"440\";s:11:\"trend_index\";s:3:\"450\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:445;a:14:{s:2:\"id\";s:5:\"13352\";s:5:\"title\";s:29:\"Online Course &#8211; Contact\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2020/04/Contact-Us.jpg\";s:12:\"tmpl_created\";s:10:\"1587474591\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/online-course-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:29:\"[\"Course Online\",\"Education\"]\";s:10:\"menu_order\";s:1:\"9\";s:16:\"popularity_index\";s:3:\"659\";s:11:\"trend_index\";s:3:\"255\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:446;a:14:{s:2:\"id\";s:5:\"13187\";s:5:\"title\";s:33:\"Interior Design &#8211; Home Page\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2020/04/Home.png\";s:12:\"tmpl_created\";s:10:\"1586148661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/interior-design-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:2:\"10\";s:16:\"popularity_index\";s:3:\"539\";s:11:\"trend_index\";s:3:\"139\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:447;a:14:{s:2:\"id\";s:5:\"13199\";s:5:\"title\";s:29:\"Interior Design &#8211; About\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2020/04/About.png\";s:12:\"tmpl_created\";s:10:\"1586148666\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/interior-design-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:2:\"11\";s:16:\"popularity_index\";s:3:\"538\";s:11:\"trend_index\";s:3:\"150\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:448;a:14:{s:2:\"id\";s:5:\"13214\";s:5:\"title\";s:32:\"Interior Design &#8211; Projects\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2020/04/portfolio_s.jpg\";s:12:\"tmpl_created\";s:10:\"1586148672\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/interior-design-projects/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:2:\"12\";s:16:\"popularity_index\";s:3:\"573\";s:11:\"trend_index\";s:3:\"175\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:449;a:14:{s:2:\"id\";s:5:\"13229\";s:5:\"title\";s:31:\"Interior Design &#8211; Contact\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2020/04/Contact-Us.png\";s:12:\"tmpl_created\";s:10:\"1586148677\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/interior-design-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"business\",\"interior design\"]\";s:10:\"menu_order\";s:2:\"13\";s:16:\"popularity_index\";s:3:\"583\";s:11:\"trend_index\";s:3:\"168\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:450;a:14:{s:2:\"id\";s:5:\"12948\";s:5:\"title\";s:29:\"Photography &#8211; Home Page\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/02/Home_s.png\";s:12:\"tmpl_created\";s:10:\"1582093442\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/photography-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"14\";s:16:\"popularity_index\";s:3:\"356\";s:11:\"trend_index\";s:3:\"133\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:451;a:14:{s:2:\"id\";s:5:\"12798\";s:5:\"title\";s:25:\"Photography &#8211; About\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/02/About_s.png\";s:12:\"tmpl_created\";s:10:\"1582093446\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/photography-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"15\";s:16:\"popularity_index\";s:3:\"521\";s:11:\"trend_index\";s:3:\"269\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:452;a:14:{s:2:\"id\";s:5:\"12868\";s:5:\"title\";s:27:\"Photography &#8211; Contact\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2020/02/Contact_s.png\";s:12:\"tmpl_created\";s:10:\"1582093450\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/photography-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"16\";s:16:\"popularity_index\";s:3:\"545\";s:11:\"trend_index\";s:3:\"336\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:453;a:14:{s:2:\"id\";s:5:\"10413\";s:5:\"title\";s:28:\"Classic | Content Lock | Pop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/hot_small.png\";s:12:\"tmpl_created\";s:10:\"1547961774\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-content-lock/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"17\";s:16:\"popularity_index\";s:3:\"644\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:454;a:14:{s:2:\"id\";s:5:\"13056\";s:5:\"title\";s:28:\"Photography &#8211; Wildlife\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2020/02/Wildlife_s.png\";s:12:\"tmpl_created\";s:10:\"1582093454\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/photography-wildlife/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"17\";s:16:\"popularity_index\";s:3:\"563\";s:11:\"trend_index\";s:3:\"341\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:455;a:14:{s:2:\"id\";s:5:\"12922\";s:5:\"title\";s:37:\"Photography &#8211; Glowing Jellyfish\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2020/02/Jellyfish_S.png\";s:12:\"tmpl_created\";s:10:\"1582093457\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/photography-glowing-jellyfish/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"18\";s:16:\"popularity_index\";s:3:\"590\";s:11:\"trend_index\";s:3:\"400\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:456;a:14:{s:2:\"id\";s:5:\"10223\";s:5:\"title\";s:15:\"Classic | Login\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/welcome_small.png\";s:12:\"tmpl_created\";s:10:\"1547887343\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"19\";s:16:\"popularity_index\";s:3:\"452\";s:11:\"trend_index\";s:3:\"342\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:457;a:14:{s:2:\"id\";s:5:\"10559\";s:5:\"title\";s:33:\"Bottom Bar | Register | Subscribe\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/fly_small.png\";s:12:\"tmpl_created\";s:10:\"1547967711\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:128:\"https://library.elementor.com/popups/bottom-bar-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"19\";s:16:\"popularity_index\";s:3:\"607\";s:11:\"trend_index\";s:3:\"637\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:458;a:14:{s:2:\"id\";s:5:\"12875\";s:5:\"title\";s:36:\"Photography &#8211; Fluttering Birds\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/02/Birds_s.png\";s:12:\"tmpl_created\";s:10:\"1582093461\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/photography-fluttering-birds/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"19\";s:16:\"popularity_index\";s:3:\"640\";s:11:\"trend_index\";s:3:\"528\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:459;a:14:{s:2:\"id\";s:5:\"10403\";s:5:\"title\";s:15:\"Classic | Login\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/hello_small.png\";s:12:\"tmpl_created\";s:10:\"1548056371\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"20\";s:16:\"popularity_index\";s:3:\"548\";s:11:\"trend_index\";s:3:\"503\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:460;a:14:{s:2:\"id\";s:5:\"12962\";s:5:\"title\";s:26:\"Photography &#8211; Nature\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2020/02/Nature_s.png\";s:12:\"tmpl_created\";s:10:\"1582093465\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/photography-nature/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"20\";s:16:\"popularity_index\";s:3:\"586\";s:11:\"trend_index\";s:3:\"500\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:461;a:14:{s:2:\"id\";s:5:\"12833\";s:5:\"title\";s:38:\"Photography &#8211; Blossoming Flowers\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2020/02/Flowers_s.png\";s:12:\"tmpl_created\";s:10:\"1582093469\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/photography-blossoming-flowers/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"21\";s:16:\"popularity_index\";s:3:\"592\";s:11:\"trend_index\";s:3:\"358\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:462;a:14:{s:2:\"id\";s:4:\"9913\";s:5:\"title\";s:27:\"Classic | Login | Christmas\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/log_small.png\";s:12:\"tmpl_created\";s:10:\"1547841430\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"21\";s:16:\"popularity_index\";s:3:\"513\";s:11:\"trend_index\";s:3:\"524\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:463;a:14:{s:2:\"id\";s:5:\"12898\";s:5:\"title\";s:36:\"Photography &#8211; Forest Mushrooms\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2020/02/Mushrooms_s.png\";s:12:\"tmpl_created\";s:10:\"1582093473\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/photography-forest-mushrooms/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"22\";s:16:\"popularity_index\";s:3:\"634\";s:11:\"trend_index\";s:3:\"467\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:464;a:14:{s:2:\"id\";s:5:\"12994\";s:5:\"title\";s:24:\"Photography &#8211; Pets\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/02/Pets_s.png\";s:12:\"tmpl_created\";s:10:\"1582093477\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/photography-pets/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"23\";s:16:\"popularity_index\";s:3:\"598\";s:11:\"trend_index\";s:3:\"356\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:465;a:14:{s:2:\"id\";s:5:\"12805\";s:5:\"title\";s:38:\"Photography &#8211; B&#038;W Portraits\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2020/02/Black_s.png\";s:12:\"tmpl_created\";s:10:\"1582093481\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/photography-bw-portraits/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"24\";s:16:\"popularity_index\";s:3:\"642\";s:11:\"trend_index\";s:3:\"479\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:466;a:14:{s:2:\"id\";s:5:\"13031\";s:5:\"title\";s:33:\"Photography &#8211; Vivid Parrots\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2020/02/Parrots_s.png\";s:12:\"tmpl_created\";s:10:\"1582093484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/photography-vivid-parrots/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:27:\"[\"Photography\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"25\";s:16:\"popularity_index\";s:3:\"614\";s:11:\"trend_index\";s:3:\"534\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:467;a:14:{s:2:\"id\";s:5:\"12621\";s:5:\"title\";s:26:\"Magazine &#8211; Home Page\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2020/01/Home_s.png\";s:12:\"tmpl_created\";s:10:\"1579060604\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/magazine-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:19:\"[\"Blog\",\"Magazine\"]\";s:10:\"menu_order\";s:2:\"26\";s:16:\"popularity_index\";s:3:\"289\";s:11:\"trend_index\";s:2:\"59\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:468;a:14:{s:2:\"id\";s:4:\"9592\";s:5:\"title\";s:26:\"Classic | Promotion | Sale\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/Classic_Promotion_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546963720\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-promotion-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"26\";s:16:\"popularity_index\";s:3:\"582\";s:11:\"trend_index\";s:3:\"626\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:469;a:14:{s:2:\"id\";s:5:\"10210\";s:5:\"title\";s:29:\"Classic | Promotion | Webinar\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/web_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547886103\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/classic-promotion-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"27\";s:16:\"popularity_index\";s:3:\"673\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:470;a:14:{s:2:\"id\";s:5:\"12352\";s:5:\"title\";s:24:\"Travel &#8211; Home Page\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/12/Home_s.png\";s:12:\"tmpl_created\";s:10:\"1575960464\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/travel-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"27\";s:16:\"popularity_index\";s:3:\"321\";s:11:\"trend_index\";s:3:\"171\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:471;a:14:{s:2:\"id\";s:5:\"12400\";s:5:\"title\";s:20:\"Travel &#8211; About\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2019/12/About.png\";s:12:\"tmpl_created\";s:10:\"1575960441\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/travel-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"28\";s:16:\"popularity_index\";s:3:\"431\";s:11:\"trend_index\";s:3:\"385\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:472;a:14:{s:2:\"id\";s:5:\"12479\";s:5:\"title\";s:20:\"Travel &#8211; Tours\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/12/Tours_s.png\";s:12:\"tmpl_created\";s:10:\"1575960474\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/travel-tours/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"29\";s:16:\"popularity_index\";s:3:\"497\";s:11:\"trend_index\";s:3:\"458\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:473;a:14:{s:2:\"id\";s:5:\"12466\";s:5:\"title\";s:27:\"Travel &#8211; Testimonials\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/12/Testimonials.png\";s:12:\"tmpl_created\";s:10:\"1575960469\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/travel-testimonials/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"30\";s:16:\"popularity_index\";s:3:\"507\";s:11:\"trend_index\";s:3:\"499\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:474;a:14:{s:2:\"id\";s:5:\"10047\";s:5:\"title\";s:15:\"Classic | Login\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1547847757\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"30\";s:16:\"popularity_index\";s:3:\"486\";s:11:\"trend_index\";s:3:\"488\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:475;a:14:{s:2:\"id\";s:5:\"12443\";s:5:\"title\";s:22:\"Travel &#8211; Gallery\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/12/Gallery.png\";s:12:\"tmpl_created\";s:10:\"1575960459\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/travel-gallery/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"31\";s:16:\"popularity_index\";s:3:\"472\";s:11:\"trend_index\";s:3:\"310\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:476;a:14:{s:2:\"id\";s:4:\"9879\";s:5:\"title\";s:38:\"Classic | Register | Subscribe | Leads\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/dog_small.png\";s:12:\"tmpl_created\";s:10:\"1547838416\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/classic-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"31\";s:16:\"popularity_index\";s:3:\"587\";s:11:\"trend_index\";s:3:\"610\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:477;a:14:{s:2:\"id\";s:5:\"12431\";s:5:\"title\";s:18:\"Travel &#8211; FAQ\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/12/FAQ.png\";s:12:\"tmpl_created\";s:10:\"1575960453\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:100:\"https://library.elementor.com/travel-faq/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"32\";s:16:\"popularity_index\";s:3:\"516\";s:11:\"trend_index\";s:3:\"452\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:478;a:14:{s:2:\"id\";s:5:\"12421\";s:5:\"title\";s:27:\"Travel &#8211; Contact Page\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/12/Contsct-Us.png\";s:12:\"tmpl_created\";s:10:\"1575960445\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/travel-contact-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Tours\",\"Travel\"]\";s:10:\"menu_order\";s:2:\"33\";s:16:\"popularity_index\";s:3:\"533\";s:11:\"trend_index\";s:3:\"463\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:479;a:14:{s:2:\"id\";s:5:\"11763\";s:5:\"title\";s:27:\"Portfolio &#8211; Home Page\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Homepage_small.png\";s:12:\"tmpl_created\";s:10:\"1569428959\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/portfolio-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"34\";s:16:\"popularity_index\";s:3:\"299\";s:11:\"trend_index\";s:3:\"224\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:480;a:14:{s:2:\"id\";s:5:\"10297\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/s_yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1548056099\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"35\";s:16:\"popularity_index\";s:3:\"526\";s:11:\"trend_index\";s:3:\"471\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:481;a:14:{s:2:\"id\";s:5:\"11781\";s:5:\"title\";s:23:\"Portfolio &#8211; About\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/09/About_small.png\";s:12:\"tmpl_created\";s:10:\"1569428955\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/portfolio-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"35\";s:16:\"popularity_index\";s:3:\"364\";s:11:\"trend_index\";s:3:\"301\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:482;a:14:{s:2:\"id\";s:5:\"10393\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/blue_small.png\";s:12:\"tmpl_created\";s:10:\"1548056682\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"36\";s:16:\"popularity_index\";s:3:\"597\";s:11:\"trend_index\";s:3:\"519\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:483;a:14:{s:2:\"id\";s:5:\"11793\";s:5:\"title\";s:26:\"Portfolio &#8211; Projects\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Projects_small.png\";s:12:\"tmpl_created\";s:10:\"1569428951\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/portfolio-projects/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"36\";s:16:\"popularity_index\";s:3:\"423\";s:11:\"trend_index\";s:3:\"377\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:484;a:14:{s:2:\"id\";s:5:\"11800\";s:5:\"title\";s:25:\"Portfolio &#8211; Contact\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/09/Contact_small.png\";s:12:\"tmpl_created\";s:10:\"1569428946\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/portfolio-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:2:\"37\";s:16:\"popularity_index\";s:3:\"467\";s:11:\"trend_index\";s:3:\"390\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:485;a:14:{s:2:\"id\";s:5:\"10579\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/sale1_small.png\";s:12:\"tmpl_created\";s:10:\"1547967887\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"38\";s:16:\"popularity_index\";s:3:\"620\";s:11:\"trend_index\";s:3:\"612\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:486;a:14:{s:2:\"id\";s:5:\"11163\";s:5:\"title\";s:32:\"Digital Agency &#8211; Home Page\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/07/Home_small.png\";s:12:\"tmpl_created\";s:10:\"1564641877\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/digital-agency-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"38\";s:16:\"popularity_index\";s:2:\"90\";s:11:\"trend_index\";s:2:\"28\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:487;a:14:{s:2:\"id\";s:5:\"11129\";s:5:\"title\";s:28:\"Digital Agency &#8211; About\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/07/About_small.png\";s:12:\"tmpl_created\";s:10:\"1564641889\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/digital-agency-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"39\";s:16:\"popularity_index\";s:3:\"217\";s:11:\"trend_index\";s:3:\"142\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:488;a:14:{s:2:\"id\";s:5:\"11074\";s:5:\"title\";s:31:\"Digital Agency &#8211; Services\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/07/Services_small.png\";s:12:\"tmpl_created\";s:10:\"1564641872\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/digital-agency-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"40\";s:16:\"popularity_index\";s:3:\"181\";s:11:\"trend_index\";s:2:\"79\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:489;a:14:{s:2:\"id\";s:5:\"11056\";s:5:\"title\";s:35:\"Digital Agency &#8211; Social Media\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/07/Social-Media_small.png\";s:12:\"tmpl_created\";s:10:\"1564641867\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/digital-agency-social-media/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"41\";s:16:\"popularity_index\";s:3:\"305\";s:11:\"trend_index\";s:3:\"189\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:490;a:14:{s:2:\"id\";s:5:\"11094\";s:5:\"title\";s:30:\"Digital Agency &#8211; Clients\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/07/Clients_small.png\";s:12:\"tmpl_created\";s:10:\"1564641885\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/digital-agency-clients/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"42\";s:16:\"popularity_index\";s:3:\"410\";s:11:\"trend_index\";s:3:\"253\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:491;a:14:{s:2:\"id\";s:5:\"10180\";s:5:\"title\";s:21:\"Fly In | Announcement\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/glass_small.png\";s:12:\"tmpl_created\";s:10:\"1548045309\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-announcement-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"43\";s:16:\"popularity_index\";s:3:\"596\";s:11:\"trend_index\";s:3:\"632\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:492;a:14:{s:2:\"id\";s:5:\"11034\";s:5:\"title\";s:30:\"Digital Agency &#8211; Contact\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/07/Contsct-Us_small.png\";s:12:\"tmpl_created\";s:10:\"1564641881\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/contact-digital-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"43\";s:16:\"popularity_index\";s:3:\"218\";s:11:\"trend_index\";s:3:\"124\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:493;a:14:{s:2:\"id\";s:3:\"519\";s:5:\"title\";s:24:\"Homepage &#8211; Fitness\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0023.png\";s:12:\"tmpl_created\";s:10:\"1477388808\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/homepage-fitness/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:45:\"[\"Fitness\",\"Gym\",\"Health\",\"Homepage\",\"Sport\"]\";s:10:\"menu_order\";s:2:\"44\";s:16:\"popularity_index\";s:1:\"9\";s:11:\"trend_index\";s:2:\"19\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:494;a:14:{s:2:\"id\";s:4:\"9139\";s:5:\"title\";s:25:\"Homepage &#8211; Business\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/07/Get_Started_250.png\";s:12:\"tmpl_created\";s:10:\"1532949924\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/homepage-business/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:167:\"[\"Agency\",\"bootstrap\",\"business\",\"corporate\",\"Landing Page\",\"marketing campaign\",\"marketing landing page\",\"product launch\",\"software\",\"Startup\",\"startup landing page\"]\";s:10:\"menu_order\";s:2:\"45\";s:16:\"popularity_index\";s:1:\"6\";s:11:\"trend_index\";s:2:\"11\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:495;a:14:{s:2:\"id\";s:4:\"9731\";s:5:\"title\";s:26:\"Classic | Sale | Promotion\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/icecream_small.png\";s:12:\"tmpl_created\";s:10:\"1547976166\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/popups/classic-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"46\";s:16:\"popularity_index\";s:3:\"562\";s:11:\"trend_index\";s:3:\"616\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:496;a:14:{s:2:\"id\";s:4:\"1504\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 3\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-app2.png\";s:12:\"tmpl_created\";s:10:\"1494352112\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-mobile-app-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"46\";s:16:\"popularity_index\";s:3:\"152\";s:11:\"trend_index\";s:3:\"248\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:497;a:14:{s:2:\"id\";s:4:\"1503\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 2\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-app1.png\";s:12:\"tmpl_created\";s:10:\"1494352113\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-mobile-app-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"47\";s:16:\"popularity_index\";s:3:\"155\";s:11:\"trend_index\";s:3:\"180\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:498;a:14:{s:2:\"id\";s:4:\"1634\";s:5:\"title\";s:33:\"Landing Page &#8211; Chiropractor\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Chiropractor.png\";s:12:\"tmpl_created\";s:10:\"1494352119\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-chiropractor/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"48\";s:16:\"popularity_index\";s:3:\"206\";s:11:\"trend_index\";s:3:\"235\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:499;a:14:{s:2:\"id\";s:5:\"12155\";s:5:\"title\";s:26:\"Law Firm &#8211; Home Page\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2019/11/home.png\";s:12:\"tmpl_created\";s:10:\"1572847054\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/law-firm-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"49\";s:16:\"popularity_index\";s:3:\"265\";s:11:\"trend_index\";s:3:\"128\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:500;a:14:{s:2:\"id\";s:5:\"12143\";s:5:\"title\";s:22:\"Law Firm &#8211; About\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2019/11/about.png\";s:12:\"tmpl_created\";s:10:\"1572847069\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/law-firm-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"50\";s:16:\"popularity_index\";s:3:\"422\";s:11:\"trend_index\";s:3:\"331\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:501;a:14:{s:2:\"id\";s:5:\"12091\";s:5:\"title\";s:21:\"Law Firm &#8211; Team\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2019/11/team.png\";s:12:\"tmpl_created\";s:10:\"1572847113\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/law-firm-team/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"50\";s:16:\"popularity_index\";s:3:\"401\";s:11:\"trend_index\";s:3:\"250\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:502;a:14:{s:2:\"id\";s:5:\"11572\";s:5:\"title\";s:19:\"Gym &#8211; Trainer\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Trainer_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392934\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-trainer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"51\";s:16:\"popularity_index\";s:3:\"544\";s:11:\"trend_index\";s:3:\"540\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:503;a:14:{s:2:\"id\";s:5:\"12133\";s:5:\"title\";s:24:\"Law Firm &#8211; Careers\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/11/careers.png\";s:12:\"tmpl_created\";s:10:\"1572847078\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-careers/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"51\";s:16:\"popularity_index\";s:3:\"565\";s:11:\"trend_index\";s:3:\"630\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:504;a:14:{s:2:\"id\";s:5:\"12080\";s:5:\"title\";s:24:\"Law Firm &#8211; Partner\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/11/partner-1.png\";s:12:\"tmpl_created\";s:10:\"1572847120\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-partner/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"51\";s:16:\"popularity_index\";s:3:\"552\";s:11:\"trend_index\";s:3:\"405\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:505;a:14:{s:2:\"id\";s:5:\"11506\";s:5:\"title\";s:19:\"Gym &#8211; Classes\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Classes_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392930\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-classes/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"52\";s:16:\"popularity_index\";s:3:\"525\";s:11:\"trend_index\";s:3:\"394\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:506;a:14:{s:2:\"id\";s:5:\"12124\";s:5:\"title\";s:25:\"Law Firm &#8211; Services\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/11/services.png\";s:12:\"tmpl_created\";s:10:\"1572847096\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/law-firm-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"52\";s:16:\"popularity_index\";s:3:\"453\";s:11:\"trend_index\";s:3:\"351\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:507;a:14:{s:2:\"id\";s:5:\"12044\";s:5:\"title\";s:24:\"Law Firm &#8211; Contact\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/11/contsct_us.png\";s:12:\"tmpl_created\";s:10:\"1572847130\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"52\";s:16:\"popularity_index\";s:3:\"465\";s:11:\"trend_index\";s:3:\"391\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:508;a:14:{s:2:\"id\";s:5:\"11536\";s:5:\"title\";s:19:\"Gym &#8211; Fitness\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Fitness_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392927\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-fitness/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"53\";s:16:\"popularity_index\";s:3:\"571\";s:11:\"trend_index\";s:3:\"490\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:509;a:14:{s:2:\"id\";s:5:\"11545\";s:5:\"title\";s:21:\"Gym &#8211; Home Page\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/08/Home_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392943\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/gym-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"53\";s:16:\"popularity_index\";s:3:\"325\";s:11:\"trend_index\";s:3:\"276\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:510;a:14:{s:2:\"id\";s:5:\"12116\";s:5:\"title\";s:24:\"Law Firm &#8211; Service\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/11/family_law.png\";s:12:\"tmpl_created\";s:10:\"1572847105\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-service/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"53\";s:16:\"popularity_index\";s:3:\"484\";s:11:\"trend_index\";s:3:\"393\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:511;a:14:{s:2:\"id\";s:5:\"11563\";s:5:\"title\";s:19:\"Gym &#8211; Pricing\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Pricing_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392923\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-pricing/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"54\";s:16:\"popularity_index\";s:3:\"531\";s:11:\"trend_index\";s:3:\"574\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:512;a:14:{s:2:\"id\";s:5:\"11478\";s:5:\"title\";s:17:\"Gym &#8211; About\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/08/About_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392939\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:99:\"https://library.elementor.com/gym-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"54\";s:16:\"popularity_index\";s:3:\"455\";s:11:\"trend_index\";s:3:\"419\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:513;a:14:{s:2:\"id\";s:5:\"10005\";s:5:\"title\";s:38:\"Fly In | Promotion | Spa | Body Lotion\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/Flyin_lotion_small.png\";s:12:\"tmpl_created\";s:10:\"1547844909\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/fly-in-promotion-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"54\";s:16:\"popularity_index\";s:3:\"648\";s:11:\"trend_index\";s:3:\"659\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:514;a:14:{s:2:\"id\";s:5:\"10424\";s:5:\"title\";s:21:\"Fly In | Announcement\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/flower_small.png\";s:12:\"tmpl_created\";s:10:\"1547961866\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-announcement-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"55\";s:16:\"popularity_index\";s:3:\"581\";s:11:\"trend_index\";s:3:\"656\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:515;a:14:{s:2:\"id\";s:5:\"11528\";s:5:\"title\";s:19:\"Gym &#8211; Contact\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Contact_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392917\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"55\";s:16:\"popularity_index\";s:3:\"494\";s:11:\"trend_index\";s:3:\"505\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:516;a:14:{s:2:\"id\";s:4:\"9975\";s:5:\"title\";s:24:\"Fly In | Promotion | App\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_webinar_app_small.png\";s:12:\"tmpl_created\";s:10:\"1547842284\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/fly-in-promotion-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"55\";s:16:\"popularity_index\";s:3:\"668\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:517;a:14:{s:2:\"id\";s:3:\"487\";s:5:\"title\";s:29:\"Landing Page &#8211; Vacation\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0021.png\";s:12:\"tmpl_created\";s:10:\"1477388357\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-vacation/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"56\";s:16:\"popularity_index\";s:2:\"24\";s:11:\"trend_index\";s:2:\"63\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:518;a:14:{s:2:\"id\";s:5:\"10067\";s:5:\"title\";s:31:\"Fly In | Announcement | Cookies\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/fly-in_cookie_yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1547848075\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/fly-in-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"56\";s:16:\"popularity_index\";s:3:\"523\";s:11:\"trend_index\";s:3:\"470\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:519;a:14:{s:2:\"id\";s:3:\"855\";s:5:\"title\";s:37:\"Landing Page &#8211; Personal Trainer\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Personal-Trainer.png\";s:12:\"tmpl_created\";s:10:\"1494352061\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/landing-page-personal-trainer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"57\";s:16:\"popularity_index\";s:3:\"250\";s:11:\"trend_index\";s:3:\"408\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:520;a:14:{s:2:\"id\";s:3:\"955\";s:5:\"title\";s:31:\"Landing Page &#8211; Law Office\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Law-Office.png\";s:12:\"tmpl_created\";s:10:\"1494352069\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/landing-page-law-office/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:31:\"[\"Landing Page\",\"Law\",\"Office\"]\";s:10:\"menu_order\";s:2:\"58\";s:16:\"popularity_index\";s:3:\"167\";s:11:\"trend_index\";s:3:\"314\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:521;a:14:{s:2:\"id\";s:5:\"10329\";s:5:\"title\";s:25:\"Fly In | Sale | Promotion\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/organic_small.png\";s:12:\"tmpl_created\";s:10:\"1547893478\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"59\";s:16:\"popularity_index\";s:3:\"674\";s:11:\"trend_index\";s:3:\"670\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:522;a:14:{s:2:\"id\";s:4:\"9373\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 5\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/11/conference-250.png\";s:12:\"tmpl_created\";s:10:\"1542811219\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"59\";s:16:\"popularity_index\";s:3:\"241\";s:11:\"trend_index\";s:3:\"417\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:523;a:14:{s:2:\"id\";s:3:\"974\";s:5:\"title\";s:28:\"Landing Page &#8211; Stylist\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/03/Landing-Page-Stylist.png\";s:12:\"tmpl_created\";s:10:\"1494352071\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-stylist/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:146:\"[\"cosmetics\",\"fashion\",\"girly\",\"hairdresser\",\"lifestyle\",\"makeup\",\"manicure\",\"pedicure\",\"products\",\"salon\",\"Shop\",\"skincare\",\"stylist\",\"wellness\"]\";s:10:\"menu_order\";s:2:\"60\";s:16:\"popularity_index\";s:3:\"288\";s:11:\"trend_index\";s:3:\"321\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:524;a:14:{s:2:\"id\";s:4:\"9650\";s:5:\"title\";s:36:\"Fly In | Register | Subscribe | Sale\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2019/01/Fly-In_Register_small_01a.png\";s:12:\"tmpl_created\";s:10:\"1547007598\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/popups/fly-in-register_big-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"60\";s:16:\"popularity_index\";s:3:\"661\";s:11:\"trend_index\";s:3:\"643\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:525;a:14:{s:2:\"id\";s:5:\"11948\";s:5:\"title\";s:18:\"Maintenance Mode 3\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm3.png\";s:12:\"tmpl_created\";s:10:\"1572153978\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"61\";s:16:\"popularity_index\";s:3:\"257\";s:11:\"trend_index\";s:3:\"120\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:526;a:14:{s:2:\"id\";s:3:\"754\";s:5:\"title\";s:25:\"Services &#8211; Interior\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/01/Interior-Services.png\";s:12:\"tmpl_created\";s:10:\"1485269691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/services-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"62\";s:16:\"popularity_index\";s:3:\"227\";s:11:\"trend_index\";s:3:\"300\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:527;a:14:{s:2:\"id\";s:3:\"752\";s:5:\"title\";s:24:\"Contact &#8211; Interior\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/01/interior-contact.png\";s:12:\"tmpl_created\";s:10:\"1485269737\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/contact-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"63\";s:16:\"popularity_index\";s:3:\"293\";s:11:\"trend_index\";s:3:\"449\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:528;a:14:{s:2:\"id\";s:5:\"10200\";s:5:\"title\";s:33:\"Full Screen | Content Lock | Wine\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/lock_wine_small.png\";s:12:\"tmpl_created\";s:10:\"1548055635\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/full-screen-content-lock/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"63\";s:16:\"popularity_index\";s:3:\"626\";s:11:\"trend_index\";s:3:\"646\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:529;a:14:{s:2:\"id\";s:3:\"753\";s:5:\"title\";s:22:\"About &#8211; Interior\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/01/Interior-About.png\";s:12:\"tmpl_created\";s:10:\"1485269710\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/about-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"64\";s:16:\"popularity_index\";s:3:\"279\";s:11:\"trend_index\";s:3:\"413\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:530;a:14:{s:2:\"id\";s:5:\"10287\";s:5:\"title\";s:34:\"Full Screen | Register | Subscribe\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/glass_pink_small.png\";s:12:\"tmpl_created\";s:10:\"1547994301\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-login-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"64\";s:16:\"popularity_index\";s:3:\"536\";s:11:\"trend_index\";s:3:\"518\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:531;a:14:{s:2:\"id\";s:3:\"751\";s:5:\"title\";s:25:\"Homepage &#8211; Interior\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/01/interior-home.png\";s:12:\"tmpl_created\";s:10:\"1485269743\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/homepage-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"65\";s:16:\"popularity_index\";s:3:\"233\";s:11:\"trend_index\";s:3:\"286\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:532;a:14:{s:2:\"id\";s:4:\"2402\";s:5:\"title\";s:32:\"Homepage &#8211; Interior Design\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2017/09/Interior.png\";s:12:\"tmpl_created\";s:10:\"1506441447\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/homepage-interior-design/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:193:\"[\"Architecture\",\"building\",\"business\",\"Creative\",\"exterior design\",\"furniture design\",\"Gallery\",\"garden design\",\"house\",\"interior design\",\"landscape design\",\"multipurpose\",\"portfolio\",\"studio\"]\";s:10:\"menu_order\";s:2:\"66\";s:16:\"popularity_index\";s:2:\"87\";s:11:\"trend_index\";s:3:\"216\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:533;a:14:{s:2:\"id\";s:4:\"9889\";s:5:\"title\";s:28:\"Full Screen | Login | Cactus\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/cac_small.png\";s:12:\"tmpl_created\";s:10:\"1547838722\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/full-screen-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"66\";s:16:\"popularity_index\";s:3:\"645\";s:11:\"trend_index\";s:3:\"648\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:534;a:14:{s:2:\"id\";s:4:\"3626\";s:5:\"title\";s:30:\"Snowboard Site &#8211; Contact\";s:9:\"thumbnail\";s:62:\"https://library.elementor.com/wp-content/uploads/2017/12/3.png\";s:12:\"tmpl_created\";s:10:\"1513513193\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/snowboard-site-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"67\";s:16:\"popularity_index\";s:3:\"243\";s:11:\"trend_index\";s:3:\"381\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:535;a:14:{s:2:\"id\";s:5:\"10077\";s:5:\"title\";s:29:\"Fly In | Register | Subscribe\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_register_blue_small.png\";s:12:\"tmpl_created\";s:10:\"1547848197\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/fly-in-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"67\";s:16:\"popularity_index\";s:3:\"480\";s:11:\"trend_index\";s:3:\"430\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:536;a:14:{s:2:\"id\";s:5:\"11966\";s:5:\"title\";s:18:\"Maintenance mode 4\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm4.png\";s:12:\"tmpl_created\";s:10:\"1572154274\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"68\";s:16:\"popularity_index\";s:3:\"529\";s:11:\"trend_index\";s:3:\"369\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:537;a:14:{s:2:\"id\";s:5:\"10362\";s:5:\"title\";s:32:\"Full Screen | Login | Restaurant\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/vip_small.png\";s:12:\"tmpl_created\";s:10:\"1548056253\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-login-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"69\";s:16:\"popularity_index\";s:3:\"566\";s:11:\"trend_index\";s:3:\"553\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:538;a:14:{s:2:\"id\";s:4:\"3632\";s:5:\"title\";s:31:\"Snowboard Site &#8211; Services\";s:9:\"thumbnail\";s:62:\"https://library.elementor.com/wp-content/uploads/2017/12/2.png\";s:12:\"tmpl_created\";s:10:\"1513513171\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/snowboard-site-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"69\";s:16:\"popularity_index\";s:3:\"189\";s:11:\"trend_index\";s:3:\"284\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:539;a:14:{s:2:\"id\";s:4:\"3619\";s:5:\"title\";s:31:\"Snowboard Site &#8211; Homepage\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2017/12/home.png\";s:12:\"tmpl_created\";s:10:\"1513513137\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/snowboard-site-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"70\";s:16:\"popularity_index\";s:3:\"210\";s:11:\"trend_index\";s:3:\"239\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:540;a:14:{s:2:\"id\";s:5:\"10454\";s:5:\"title\";s:29:\"Full Screen | Promotion | App\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/appy_small.png\";s:12:\"tmpl_created\";s:10:\"1548056896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/full-screen-promotion-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"71\";s:16:\"popularity_index\";s:3:\"664\";s:11:\"trend_index\";s:3:\"671\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:541;a:14:{s:2:\"id\";s:4:\"9425\";s:5:\"title\";s:38:\"Black Friday &#8211;  80&#8217;s style\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/11/unnamed-file.png\";s:12:\"tmpl_created\";s:10:\"1542901234\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/black-friday-80s-style/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"71\";s:16:\"popularity_index\";s:3:\"315\";s:11:\"trend_index\";s:3:\"370\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:542;a:14:{s:2:\"id\";s:5:\"11973\";s:5:\"title\";s:18:\"Maintenance mode 5\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm5.png\";s:12:\"tmpl_created\";s:10:\"1572154523\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"72\";s:16:\"popularity_index\";s:3:\"492\";s:11:\"trend_index\";s:3:\"237\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:543;a:14:{s:2:\"id\";s:4:\"9803\";s:5:\"title\";s:41:\"Full Screen | Register | Contact | Meetup\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2019/01/designme_full_small.png\";s:12:\"tmpl_created\";s:10:\"1547831298\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/full-screen-register-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"72\";s:16:\"popularity_index\";s:3:\"609\";s:11:\"trend_index\";s:3:\"601\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:544;a:14:{s:2:\"id\";s:5:\"10611\";s:5:\"title\";s:18:\"Full Screen | Sale\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/fla_small.png\";s:12:\"tmpl_created\";s:10:\"1547968868\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/full-screen-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"73\";s:16:\"popularity_index\";s:3:\"670\";s:11:\"trend_index\";s:3:\"613\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:545;a:14:{s:2:\"id\";s:5:\"10508\";s:5:\"title\";s:25:\"Full Screen | Welcome Mat\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/hand_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547964711\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/full-screen-welcome-mat-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"75\";s:16:\"popularity_index\";s:3:\"619\";s:11:\"trend_index\";s:3:\"652\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:546;a:14:{s:2:\"id\";s:4:\"9934\";s:5:\"title\";s:38:\"Full Screen | Welcome Mat | Teddy Bear\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/full_mat_teddy_small.png\";s:12:\"tmpl_created\";s:10:\"1547841787\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/full-screen-welcome-mat/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"76\";s:16:\"popularity_index\";s:3:\"589\";s:11:\"trend_index\";s:3:\"605\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:547;a:14:{s:2:\"id\";s:4:\"9709\";s:5:\"title\";s:25:\"Full Screen | Welcome Mat\";s:9:\"thumbnail\";s:95:\"https://library.elementor.com/wp-content/uploads/2019/01/Full-Screen_Welcome-Mat_01_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547023834\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/full-screen-welcome-mat-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"78\";s:16:\"popularity_index\";s:3:\"627\";s:11:\"trend_index\";s:3:\"619\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:548;a:14:{s:2:\"id\";s:4:\"9671\";s:5:\"title\";s:34:\"Hello Bar | Announcement | Cookies\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2019/01/Top-Bar_Announcement_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547010259\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/hello-bar-announcement-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"79\";s:16:\"popularity_index\";s:3:\"569\";s:11:\"trend_index\";s:3:\"563\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:549;a:14:{s:2:\"id\";s:5:\"10234\";s:5:\"title\";s:38:\"Hello Bar | Announcement | Maintenance\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/pink_small.png\";s:12:\"tmpl_created\";s:10:\"1548055049\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/popups/hello-bar-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"80\";s:16:\"popularity_index\";s:3:\"649\";s:11:\"trend_index\";s:3:\"609\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:550;a:14:{s:2:\"id\";s:5:\"11981\";s:5:\"title\";s:18:\"Maintenance mode 6\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm6.png\";s:12:\"tmpl_created\";s:10:\"1572155125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"83\";s:16:\"popularity_index\";s:3:\"483\";s:11:\"trend_index\";s:3:\"401\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:551;a:14:{s:2:\"id\";s:4:\"9869\";s:5:\"title\";s:28:\"Hello Bar | Promotion | Sale\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/01/ru_small.png\";s:12:\"tmpl_created\";s:10:\"1547837269\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/hello-bar-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"83\";s:16:\"popularity_index\";s:3:\"660\";s:11:\"trend_index\";s:3:\"665\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:552;a:14:{s:2:\"id\";s:5:\"10539\";s:5:\"title\";s:19:\"Hello Bar | Contact\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/hello_pink_small.png\";s:12:\"tmpl_created\";s:10:\"1548056994\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/hello-bar-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"84\";s:16:\"popularity_index\";s:3:\"623\";s:11:\"trend_index\";s:3:\"587\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:553;a:14:{s:2:\"id\";s:3:\"147\";s:5:\"title\";s:20:\"Homepage &#8211; App\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0004.png\";s:12:\"tmpl_created\";s:10:\"1470829868\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/homepage-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"App\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"87\";s:16:\"popularity_index\";s:1:\"2\";s:11:\"trend_index\";s:2:\"16\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:554;a:14:{s:2:\"id\";s:3:\"777\";s:5:\"title\";s:28:\"Homepage &#8211; Coffee Shop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/01/rest-home.jpg\";s:12:\"tmpl_created\";s:10:\"1485273092\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/homepage-coffee-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:41:\"[\"Coffee\",\"Homepage\",\"Restaurant\",\"Shop\"]\";s:10:\"menu_order\";s:2:\"88\";s:16:\"popularity_index\";s:3:\"137\";s:11:\"trend_index\";s:3:\"333\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:555;a:14:{s:2:\"id\";s:5:\"10147\";s:5:\"title\";s:34:\"Hello Bar | Sale | Promotion | Pop\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/donut_small.png\";s:12:\"tmpl_created\";s:10:\"1548055522\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/hello-bar-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"89\";s:16:\"popularity_index\";s:3:\"662\";s:11:\"trend_index\";s:3:\"668\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:556;a:14:{s:2:\"id\";s:4:\"2404\";s:5:\"title\";s:24:\"Homepage &#8211; Product\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2017/09/product.png\";s:12:\"tmpl_created\";s:10:\"1506441452\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/homepage-product/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:103:\"[\"business\",\"colorful\",\"ecommerce\",\"flat\",\"mobile\",\"modern\",\"responsive\",\"retina\",\"Shop\",\"woocommerce\"]\";s:10:\"menu_order\";s:2:\"89\";s:16:\"popularity_index\";s:3:\"133\";s:11:\"trend_index\";s:3:\"240\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:557;a:14:{s:2:\"id\";s:3:\"492\";s:5:\"title\";s:25:\"Homepage &#8211; Law firm\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0024.png\";s:12:\"tmpl_created\";s:10:\"1477388365\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/homepage-law-firm/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:25:\"[\"Firm\",\"Homepage\",\"Law\"]\";s:10:\"menu_order\";s:2:\"90\";s:16:\"popularity_index\";s:2:\"12\";s:11:\"trend_index\";s:2:\"74\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:558;a:14:{s:2:\"id\";s:4:\"9923\";s:5:\"title\";s:23:\"Slide In | Announcement\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/slide-in_ann_italian_small.png\";s:12:\"tmpl_created\";s:10:\"1547841537\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/slide-in-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"90\";s:16:\"popularity_index\";s:3:\"599\";s:11:\"trend_index\";s:3:\"623\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:559;a:14:{s:2:\"id\";s:5:\"10117\";s:5:\"title\";s:23:\"Slide In | Announcement\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/white_small.png\";s:12:\"tmpl_created\";s:10:\"1548066998\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/slide-in-announcement-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"91\";s:16:\"popularity_index\";s:3:\"629\";s:11:\"trend_index\";s:3:\"647\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:560;a:14:{s:2:\"id\";s:4:\"3451\";s:5:\"title\";s:39:\"Homepage &#8211; Goodness meal services\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2017/11/goodness-featured-image.png\";s:12:\"tmpl_created\";s:10:\"1512054116\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/homepage-goodness-meal-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"91\";s:16:\"popularity_index\";s:3:\"213\";s:11:\"trend_index\";s:3:\"361\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:561;a:14:{s:2:\"id\";s:4:\"2152\";s:5:\"title\";s:26:\"Homepage &#8211; Cake Shop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/07/cake-home.png\";s:12:\"tmpl_created\";s:10:\"1499774132\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/homepage-cake-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:39:\"[\"Cake\",\"Homepage\",\"Restaurant\",\"Shop\"]\";s:10:\"menu_order\";s:2:\"92\";s:16:\"popularity_index\";s:3:\"317\";s:11:\"trend_index\";s:3:\"418\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:562;a:14:{s:2:\"id\";s:4:\"9826\";s:5:\"title\";s:33:\"Slide In | Announcement | webinar\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/web_small-2.png\";s:12:\"tmpl_created\";s:10:\"1547835513\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/slide-in-announcement-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"92\";s:16:\"popularity_index\";s:3:\"638\";s:11:\"trend_index\";s:3:\"674\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:563;a:14:{s:2:\"id\";s:4:\"1068\";s:5:\"title\";s:27:\"Homepage &#8211; Copywriter\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/03/copywriter.png\";s:12:\"tmpl_created\";s:10:\"1488805928\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/homepage-copywriter/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:25:\"[\"Copywriter\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"93\";s:16:\"popularity_index\";s:3:\"196\";s:11:\"trend_index\";s:3:\"344\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:564;a:14:{s:2:\"id\";s:5:\"10478\";s:5:\"title\";s:18:\"Slide In | Contact\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/slide_wow_small.png\";s:12:\"tmpl_created\";s:10:\"1548056829\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/slide-in-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"93\";s:16:\"popularity_index\";s:3:\"522\";s:11:\"trend_index\";s:3:\"462\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:565;a:14:{s:2:\"id\";s:4:\"2813\";s:5:\"title\";s:32:\"Homepage &#8211; Creative Agency\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2017/11/Creative-Agency-–-Home-Page.png\";s:12:\"tmpl_created\";s:10:\"1509615049\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/homepage-creative-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Agency\",\"Creative\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"94\";s:16:\"popularity_index\";s:3:\"102\";s:11:\"trend_index\";s:3:\"226\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:566;a:14:{s:2:\"id\";s:3:\"728\";s:5:\"title\";s:33:\"Homepage &#8211; Delivery Company\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/01/delivery-company-home-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485269993\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/homepage-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:23:\"[\"Delivery\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"95\";s:16:\"popularity_index\";s:3:\"258\";s:11:\"trend_index\";s:3:\"526\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:567;a:14:{s:2:\"id\";s:5:\"10685\";s:5:\"title\";s:32:\"Hello Bar | Register | Subscribe\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/env_small.png\";s:12:\"tmpl_created\";s:10:\"1547974729\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/hello-bar-register-subscribe-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"96\";s:16:\"popularity_index\";s:3:\"608\";s:11:\"trend_index\";s:3:\"562\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:568;a:14:{s:2:\"id\";s:4:\"2403\";s:5:\"title\";s:29:\"Homepage &#8211; Luxury Hotel\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/09/Hotel.png\";s:12:\"tmpl_created\";s:10:\"1506441428\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/homepage-luxury-hotel/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"96\";s:16:\"popularity_index\";s:3:\"247\";s:11:\"trend_index\";s:3:\"387\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:569;a:14:{s:2:\"id\";s:4:\"1903\";s:5:\"title\";s:20:\"One Page &#8211; Spa\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2017/06/spa.png\";s:12:\"tmpl_created\";s:10:\"1496822325\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/one-page-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:132:\"[\"beauty\",\"care\",\"girly\",\"hair\",\"Health\",\"hospitality\",\"massage\",\"medical\",\"parlor\",\"physiotherapy\",\"salon\",\"spa\",\"wellness\",\"yoga\"]\";s:10:\"menu_order\";s:2:\"97\";s:16:\"popularity_index\";s:3:\"171\";s:11:\"trend_index\";s:3:\"256\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:570;a:14:{s:2:\"id\";s:4:\"2123\";s:5:\"title\";s:33:\"One Page &#8211; Architect Office\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/06/architect.png\";s:12:\"tmpl_created\";s:10:\"1499772989\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/one-page-architect-office/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"98\";s:16:\"popularity_index\";s:2:\"10\";s:11:\"trend_index\";s:2:\"23\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:571;a:14:{s:2:\"id\";s:4:\"9985\";s:5:\"title\";s:20:\"Slide In | Promotion\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_promotion_av_small.png\";s:12:\"tmpl_created\";s:10:\"1547844661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/slide-in-promotion-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"98\";s:16:\"popularity_index\";s:3:\"651\";s:11:\"trend_index\";s:3:\"641\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:572;a:14:{s:2:\"id\";s:4:\"1888\";s:5:\"title\";s:32:\"One Page &#8211; Creative Meetup\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2017/06/creative-meetup.png\";s:12:\"tmpl_created\";s:10:\"1496822319\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/one-page-creative-meetup/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"99\";s:16:\"popularity_index\";s:3:\"253\";s:11:\"trend_index\";s:3:\"439\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:573;a:14:{s:2:\"id\";s:4:\"1891\";s:5:\"title\";s:35:\"One Page &#8211; Textile Convention\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/06/textile-meetup.png\";s:12:\"tmpl_created\";s:10:\"1496822323\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/one-page-textile-convention/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"100\";s:16:\"popularity_index\";s:3:\"390\";s:11:\"trend_index\";s:3:\"465\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:574;a:14:{s:2:\"id\";s:4:\"1880\";s:5:\"title\";s:24:\"One Page &#8211; Wedding\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2017/06/wedding.png\";s:12:\"tmpl_created\";s:10:\"1496822317\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/one-page-wedding/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:82:\"[\"bride\",\"ceremony\",\"cute\",\"event\",\"fancy\",\"girly\",\"groom\",\"guestbook\",\"marriage\"]\";s:10:\"menu_order\";s:3:\"101\";s:16:\"popularity_index\";s:3:\"419\";s:11:\"trend_index\";s:3:\"579\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:575;a:14:{s:2:\"id\";s:4:\"1885\";s:5:\"title\";s:29:\"One Page &#8211; Yacht Rental\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/06/yacht-home.png\";s:12:\"tmpl_created\";s:10:\"1496822321\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/one-page-yacht-rental/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"102\";s:16:\"popularity_index\";s:3:\"192\";s:11:\"trend_index\";s:3:\"372\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:576;a:14:{s:2:\"id\";s:4:\"2723\";s:5:\"title\";s:34:\"Portfolio &#8211; Graphic Designer\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2017/11/Graphic-Designer-–-Portfolio.png\";s:12:\"tmpl_created\";s:10:\"1509633883\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/portfolio-graphic-designer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"103\";s:16:\"popularity_index\";s:3:\"172\";s:11:\"trend_index\";s:3:\"304\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:577;a:14:{s:2:\"id\";s:4:\"2145\";s:5:\"title\";s:30:\"About &#8211; Delivery Company\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/07/delivery-about.png\";s:12:\"tmpl_created\";s:10:\"1499774125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/about-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:10:\"[\"moving\"]\";s:10:\"menu_order\";s:3:\"104\";s:16:\"popularity_index\";s:3:\"328\";s:11:\"trend_index\";s:3:\"424\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:578;a:14:{s:2:\"id\";s:4:\"2155\";s:5:\"title\";s:23:\"About &#8211; Cake Shop\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/07/cake-about.png\";s:12:\"tmpl_created\";s:10:\"1499774130\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/about-cake-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:8:\"[\"Food\"]\";s:10:\"menu_order\";s:3:\"105\";s:16:\"popularity_index\";s:3:\"376\";s:11:\"trend_index\";s:3:\"466\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:579;a:14:{s:2:\"id\";s:4:\"9559\";s:5:\"title\";s:16:\"Slide In | Login\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_login_01_small.png\";s:12:\"tmpl_created\";s:10:\"1546946547\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/slide-in-login-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"105\";s:16:\"popularity_index\";s:3:\"520\";s:11:\"trend_index\";s:3:\"571\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:580;a:14:{s:2:\"id\";s:4:\"1085\";s:5:\"title\";s:21:\"About &#8211; Startup\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2017/03/Startup.png\";s:12:\"tmpl_created\";s:10:\"1488810874\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/about-startup/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:19:\"[\"About\",\"Startup\"]\";s:10:\"menu_order\";s:3:\"106\";s:16:\"popularity_index\";s:1:\"7\";s:11:\"trend_index\";s:2:\"13\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:581;a:14:{s:2:\"id\";s:3:\"143\";s:5:\"title\";s:22:\"About &#8211; Personal\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0010.png\";s:12:\"tmpl_created\";s:10:\"1470820447\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/about-personal/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"About\",\"Personal\"]\";s:10:\"menu_order\";s:3:\"107\";s:16:\"popularity_index\";s:2:\"22\";s:11:\"trend_index\";s:2:\"66\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:582;a:14:{s:2:\"id\";s:4:\"9752\";s:5:\"title\";s:27:\"Slide In | Sale | Promotion\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/rush_small.png\";s:12:\"tmpl_created\";s:10:\"1547823982\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/slide-in-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"107\";s:16:\"popularity_index\";s:3:\"637\";s:11:\"trend_index\";s:3:\"673\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:583;a:14:{s:2:\"id\";s:3:\"101\";s:5:\"title\";s:16:\"About &#8211; CV\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0018.png\";s:12:\"tmpl_created\";s:10:\"1470829785\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:98:\"https://library.elementor.com/about-cv/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:77:\"[\"creative portfolio\",\"Personal\",\"portfolio\",\"professional\",\"resume\",\"vcard\"]\";s:10:\"menu_order\";s:3:\"108\";s:16:\"popularity_index\";s:2:\"37\";s:11:\"trend_index\";s:3:\"111\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:584;a:14:{s:2:\"id\";s:3:\"140\";s:5:\"title\";s:25:\"About &#8211; Art Gallery\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0009.png\";s:12:\"tmpl_created\";s:10:\"1470820463\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/about-art-gallery/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:25:\"[\"About\",\"Art\",\"Gallery\"]\";s:10:\"menu_order\";s:3:\"109\";s:16:\"popularity_index\";s:2:\"15\";s:11:\"trend_index\";s:2:\"58\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:585;a:14:{s:2:\"id\";s:3:\"213\";s:5:\"title\";s:26:\"About &#8211; Architecture\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0008.png\";s:12:\"tmpl_created\";s:10:\"1470829766\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/about-architecture/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:24:\"[\"About\",\"Architecture\"]\";s:10:\"menu_order\";s:3:\"110\";s:16:\"popularity_index\";s:2:\"18\";s:11:\"trend_index\";s:2:\"67\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:586;a:14:{s:2:\"id\";s:4:\"2802\";s:5:\"title\";s:38:\"Portfolio &#8211; Fashion Photographer\";s:9:\"thumbnail\";s:95:\"https://library.elementor.com/wp-content/uploads/2017/11/Fashion-photographer-–-Portfolio.png\";s:12:\"tmpl_created\";s:10:\"1509615440\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/portfolio-fashion-photographer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"111\";s:16:\"popularity_index\";s:3:\"200\";s:11:\"trend_index\";s:3:\"330\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:587;a:14:{s:2:\"id\";s:5:\"10169\";s:5:\"title\";s:37:\"Slide In | Register | Subscribe | App\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/slideinapp_small.png\";s:12:\"tmpl_created\";s:10:\"1547852334\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/slide-in-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"112\";s:16:\"popularity_index\";s:3:\"402\";s:11:\"trend_index\";s:3:\"585\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:588;a:14:{s:2:\"id\";s:4:\"2828\";s:5:\"title\";s:35:\"Landing Page &#8211; Law Convention\";s:9:\"thumbnail\";s:92:\"https://library.elementor.com/wp-content/uploads/2017/11/Law-Convention-–-Landing-Page.png\";s:12:\"tmpl_created\";s:10:\"1509631636\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/landing-page-law-convention/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:35:\"[\"Convention\",\"Landing Page\",\"Law\"]\";s:10:\"menu_order\";s:3:\"112\";s:16:\"popularity_index\";s:3:\"348\";s:11:\"trend_index\";s:3:\"453\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:589;a:14:{s:2:\"id\";s:4:\"1461\";s:5:\"title\";s:28:\"Landing Page &#8211; Ebook 1\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Ebook-1.png\";s:12:\"tmpl_created\";s:10:\"1494352121\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-ebook-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:127:\"[\"App\",\"author\",\"book\",\"brochure\",\"download\",\"e-book\",\"ebook\",\"marketing\",\"product\",\"publisher\",\"sell online\",\"seo\",\"showcase\"]\";s:10:\"menu_order\";s:3:\"113\";s:16:\"popularity_index\";s:3:\"338\";s:11:\"trend_index\";s:3:\"392\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:590;a:14:{s:2:\"id\";s:4:\"1460\";s:5:\"title\";s:28:\"Landing Page &#8211; Ebook 2\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Ebook-2.png\";s:12:\"tmpl_created\";s:10:\"1494352124\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-ebook-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"114\";s:16:\"popularity_index\";s:3:\"352\";s:11:\"trend_index\";s:3:\"437\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:591;a:14:{s:2:\"id\";s:4:\"1459\";s:5:\"title\";s:28:\"Landing Page &#8211; Ebook 3\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Ebook-3.png\";s:12:\"tmpl_created\";s:10:\"1494352125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-ebook-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"115\";s:16:\"popularity_index\";s:3:\"223\";s:11:\"trend_index\";s:3:\"335\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:592;a:14:{s:2:\"id\";s:4:\"9680\";s:5:\"title\";s:23:\"Slide In | Content Lock\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2019/01/Slide-in_Content-lock_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547010967\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/slide-in-content-lock-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"115\";s:16:\"popularity_index\";s:3:\"635\";s:11:\"trend_index\";s:3:\"645\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:593;a:14:{s:2:\"id\";s:4:\"1052\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 1\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2017/03/app.png\";s:12:\"tmpl_created\";s:10:\"1488810873\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/landing-page-mobile-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"116\";s:16:\"popularity_index\";s:2:\"28\";s:11:\"trend_index\";s:3:\"138\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:594;a:14:{s:2:\"id\";s:4:\"1505\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 4\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-app3.png\";s:12:\"tmpl_created\";s:10:\"1494352110\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-mobile-app-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"117\";s:16:\"popularity_index\";s:3:\"371\";s:11:\"trend_index\";s:3:\"448\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:595;a:14:{s:2:\"id\";s:4:\"9783\";s:5:\"title\";s:31:\"Slide In | Register | Subscribe\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1547831059\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/slide-in-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"117\";s:16:\"popularity_index\";s:3:\"478\";s:11:\"trend_index\";s:3:\"575\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:596;a:14:{s:2:\"id\";s:3:\"726\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 1\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2017/01/convention-landing-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485270062\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/landing-page-conference/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"118\";s:16:\"popularity_index\";s:3:\"394\";s:11:\"trend_index\";s:3:\"634\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:597;a:14:{s:2:\"id\";s:4:\"1613\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 2\";s:9:\"thumbnail\";s:109:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-International-Womens-Day-Conference.png\";s:12:\"tmpl_created\";s:10:\"1494352129\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"119\";s:16:\"popularity_index\";s:3:\"409\";s:11:\"trend_index\";s:3:\"434\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:598;a:14:{s:2:\"id\";s:4:\"1612\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 3\";s:9:\"thumbnail\";s:89:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Tech-Conference.png\";s:12:\"tmpl_created\";s:10:\"1494352127\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"120\";s:16:\"popularity_index\";s:3:\"427\";s:11:\"trend_index\";s:3:\"666\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:599;a:14:{s:2:\"id\";s:4:\"1614\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 4\";s:9:\"thumbnail\";s:99:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Sustainability-Conference.png\";s:12:\"tmpl_created\";s:10:\"1494352131\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"121\";s:16:\"popularity_index\";s:3:\"359\";s:11:\"trend_index\";s:3:\"543\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:600;a:14:{s:2:\"id\";s:3:\"906\";s:5:\"title\";s:29:\"Landing Page &#8211;  Coacher\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2017/02/Landin-Page-Coacher.png\";s:12:\"tmpl_created\";s:10:\"1494352066\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-coacher/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"122\";s:16:\"popularity_index\";s:3:\"256\";s:11:\"trend_index\";s:3:\"426\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:601;a:14:{s:2:\"id\";s:3:\"879\";s:5:\"title\";s:41:\"Landing Page &#8211; Financial Consultant\";s:9:\"thumbnail\";s:94:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Financial-consultant.png\";s:12:\"tmpl_created\";s:10:\"1494352064\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/landing-page-financial-consultant/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"123\";s:16:\"popularity_index\";s:3:\"267\";s:11:\"trend_index\";s:3:\"516\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:602;a:14:{s:2:\"id\";s:3:\"926\";s:5:\"title\";s:33:\"Landing Page &#8211; Private Chef\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Private-Chef.png\";s:12:\"tmpl_created\";s:10:\"1494352068\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-private-chef/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"124\";s:16:\"popularity_index\";s:3:\"374\";s:11:\"trend_index\";s:3:\"590\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:603;a:14:{s:2:\"id\";s:4:\"1032\";s:5:\"title\";s:27:\"Landing Page &#8211; Agency\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2017/03/Agency.png\";s:12:\"tmpl_created\";s:10:\"1488810866\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/landing-page-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"125\";s:16:\"popularity_index\";s:3:\"370\";s:11:\"trend_index\";s:3:\"512\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:604;a:14:{s:2:\"id\";s:3:\"730\";s:5:\"title\";s:24:\"Landing Page &#8211; App\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/01/app.-landing-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485273430\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/landing-page-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"126\";s:16:\"popularity_index\";s:3:\"344\";s:11:\"trend_index\";s:3:\"464\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:605;a:14:{s:2:\"id\";s:3:\"643\";s:5:\"title\";s:29:\"Landing Page &#8211; Festival\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2016/12/festival.jpg\";s:12:\"tmpl_created\";s:10:\"1481549290\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-festival/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"127\";s:16:\"popularity_index\";s:3:\"398\";s:11:\"trend_index\";s:3:\"582\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:606;a:14:{s:2:\"id\";s:3:\"542\";s:5:\"title\";s:28:\"Landing Page &#8211; Wedding\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0025.png\";s:12:\"tmpl_created\";s:10:\"1477388484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-wedding/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"128\";s:16:\"popularity_index\";s:2:\"79\";s:11:\"trend_index\";s:3:\"270\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:607;a:14:{s:2:\"id\";s:4:\"1187\";s:5:\"title\";s:32:\"Landing Page &#8211; Photography\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/03/lp1-l.png\";s:12:\"tmpl_created\";s:10:\"1490707385\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/landing-page-photography/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"129\";s:16:\"popularity_index\";s:2:\"38\";s:11:\"trend_index\";s:2:\"96\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:608;a:14:{s:2:\"id\";s:3:\"641\";s:5:\"title\";s:28:\"Landing Page &#8211; Fashion\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2016/12/fashion-landing-page.jpg\";s:12:\"tmpl_created\";s:10:\"1481549264\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-fashion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"130\";s:16:\"popularity_index\";s:3:\"303\";s:11:\"trend_index\";s:3:\"343\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:609;a:14:{s:2:\"id\";s:3:\"189\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 1\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0005.png\";s:12:\"tmpl_created\";s:10:\"1470820715\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-tourism/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"131\";s:16:\"popularity_index\";s:2:\"14\";s:11:\"trend_index\";s:2:\"42\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:610;a:14:{s:2:\"id\";s:4:\"1547\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 2\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Truism-1.png\";s:12:\"tmpl_created\";s:10:\"1494352115\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"132\";s:16:\"popularity_index\";s:3:\"316\";s:11:\"trend_index\";s:3:\"444\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:611;a:14:{s:2:\"id\";s:4:\"1546\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 3\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Truism-2.png\";s:12:\"tmpl_created\";s:10:\"1494352116\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"133\";s:16:\"popularity_index\";s:3:\"426\";s:11:\"trend_index\";s:3:\"546\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:612;a:14:{s:2:\"id\";s:4:\"1545\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 4\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Truism-3.png\";s:12:\"tmpl_created\";s:10:\"1494352118\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"134\";s:16:\"popularity_index\";s:3:\"355\";s:11:\"trend_index\";s:3:\"498\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:613;a:14:{s:2:\"id\";s:4:\"2714\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 5\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2017/11/Vacation-–-Landing-Page.png\";s:12:\"tmpl_created\";s:10:\"1509631782\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"135\";s:16:\"popularity_index\";s:3:\"349\";s:11:\"trend_index\";s:3:\"483\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:614;a:14:{s:2:\"id\";s:3:\"195\";s:5:\"title\";s:28:\"Landing Page &#8211; Product\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0006.png\";s:12:\"tmpl_created\";s:10:\"1470820765\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-product/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"136\";s:16:\"popularity_index\";s:2:\"50\";s:11:\"trend_index\";s:3:\"134\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:615;a:14:{s:2:\"id\";s:3:\"197\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 1\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0007.png\";s:12:\"tmpl_created\";s:10:\"1470825711\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/landing-page-real-estate/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"137\";s:16:\"popularity_index\";s:3:\"123\";s:11:\"trend_index\";s:3:\"288\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:616;a:14:{s:2:\"id\";s:4:\"1193\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 2\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/03/lp3-l.png\";s:12:\"tmpl_created\";s:10:\"1490707422\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"138\";s:16:\"popularity_index\";s:2:\"60\";s:11:\"trend_index\";s:3:\"179\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:617;a:14:{s:2:\"id\";s:4:\"1415\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 3\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Real-Estate-1.png\";s:12:\"tmpl_created\";s:10:\"1494352106\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"139\";s:16:\"popularity_index\";s:3:\"337\";s:11:\"trend_index\";s:3:\"415\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:618;a:14:{s:2:\"id\";s:4:\"1414\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 4\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Real-Estate-2.png\";s:12:\"tmpl_created\";s:10:\"1494352107\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"140\";s:16:\"popularity_index\";s:3:\"451\";s:11:\"trend_index\";s:3:\"620\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:619;a:14:{s:2:\"id\";s:4:\"1413\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 5\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Real-Estate-3.png\";s:12:\"tmpl_created\";s:10:\"1494352109\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:134:\"[\"Agent\",\"business\",\"clean\",\"corporate\",\"flat\",\"google maps\",\"homes\",\"listing\",\"modern\",\"real estate\",\"realestate\",\"realtor\",\"realty\"]\";s:10:\"menu_order\";s:3:\"141\";s:16:\"popularity_index\";s:3:\"399\";s:11:\"trend_index\";s:3:\"532\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:620;a:14:{s:2:\"id\";s:4:\"1573\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 1\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-02.png\";s:12:\"tmpl_created\";s:10:\"1494352133\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"142\";s:16:\"popularity_index\";s:3:\"474\";s:11:\"trend_index\";s:3:\"541\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:621;a:14:{s:2:\"id\";s:4:\"1572\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 2\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-03.png\";s:12:\"tmpl_created\";s:10:\"1494352134\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"143\";s:16:\"popularity_index\";s:3:\"512\";s:11:\"trend_index\";s:3:\"644\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:622;a:14:{s:2:\"id\";s:4:\"1570\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 3\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-01.png\";s:12:\"tmpl_created\";s:10:\"1494352136\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"144\";s:16:\"popularity_index\";s:3:\"559\";s:11:\"trend_index\";s:3:\"639\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:623;a:14:{s:2:\"id\";s:4:\"1571\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 4\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-04.png\";s:12:\"tmpl_created\";s:10:\"1494352138\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"145\";s:16:\"popularity_index\";s:3:\"528\";s:11:\"trend_index\";s:3:\"595\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:624;a:14:{s:2:\"id\";s:3:\"192\";s:5:\"title\";s:28:\"Landing Page &#8211; Webinar\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0015.png\";s:12:\"tmpl_created\";s:10:\"1470820734\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"146\";s:16:\"popularity_index\";s:3:\"108\";s:11:\"trend_index\";s:3:\"225\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:625;a:14:{s:2:\"id\";s:4:\"2141\";s:5:\"title\";s:32:\"Contact &#8211; Delivery Company\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/07/delivery-contact.png\";s:12:\"tmpl_created\";s:10:\"1499774122\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/contact-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"147\";s:16:\"popularity_index\";s:3:\"309\";s:11:\"trend_index\";s:3:\"523\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:626;a:14:{s:2:\"id\";s:3:\"137\";s:5:\"title\";s:22:\"Contact &#8211; Modern\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0013.png\";s:12:\"tmpl_created\";s:10:\"1470829828\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/contact-modern/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"148\";s:16:\"popularity_index\";s:2:\"41\";s:11:\"trend_index\";s:2:\"99\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:627;a:14:{s:2:\"id\";s:3:\"256\";s:5:\"title\";s:26:\"Contact &#8211; Restaurant\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0011.png\";s:12:\"tmpl_created\";s:10:\"1470829796\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/contact-restaurant/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"149\";s:16:\"popularity_index\";s:3:\"118\";s:11:\"trend_index\";s:3:\"266\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:628;a:14:{s:2:\"id\";s:4:\"2150\";s:5:\"title\";s:25:\"Contact &#8211; Cake Shop\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/07/cake-contact.png\";s:12:\"tmpl_created\";s:10:\"1499774127\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/contact-cake-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"150\";s:16:\"popularity_index\";s:2:\"61\";s:11:\"trend_index\";s:3:\"105\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:629;a:14:{s:2:\"id\";s:3:\"223\";s:5:\"title\";s:21:\"Contact &#8211; Hotel\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0002.png\";s:12:\"tmpl_created\";s:10:\"1470820471\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/contact-hotel/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"151\";s:16:\"popularity_index\";s:3:\"117\";s:11:\"trend_index\";s:3:\"242\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:630;a:14:{s:2:\"id\";s:2:\"24\";s:5:\"title\";s:25:\"Contact &#8211; Corporate\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0012.png\";s:12:\"tmpl_created\";s:10:\"1470248619\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/contact-corporate/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"152\";s:16:\"popularity_index\";s:2:\"13\";s:11:\"trend_index\";s:2:\"20\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:631;a:14:{s:2:\"id\";s:3:\"184\";s:5:\"title\";s:23:\"Services &#8211; Moving\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0017.png\";s:12:\"tmpl_created\";s:10:\"1470829889\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/services-moving/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"153\";s:16:\"popularity_index\";s:2:\"23\";s:11:\"trend_index\";s:2:\"44\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:632;a:14:{s:2:\"id\";s:3:\"625\";s:5:\"title\";s:31:\"Services &#8211; Cake Shop Menu\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2016/12/cake-shop-menu.jpg\";s:12:\"tmpl_created\";s:10:\"1481549196\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/services-cake-shop-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"154\";s:16:\"popularity_index\";s:3:\"518\";s:11:\"trend_index\";s:3:\"607\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:633;a:14:{s:2:\"id\";s:3:\"187\";s:5:\"title\";s:20:\"Services &#8211; Fun\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0001.png\";s:12:\"tmpl_created\";s:10:\"1470829892\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/services-fun/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"155\";s:16:\"popularity_index\";s:2:\"68\";s:11:\"trend_index\";s:3:\"246\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:634;a:14:{s:2:\"id\";s:3:\"238\";s:5:\"title\";s:27:\"Services &#8211; Consulting\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0014.png\";s:12:\"tmpl_created\";s:10:\"1470829865\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/services-consulting/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"156\";s:16:\"popularity_index\";s:2:\"21\";s:11:\"trend_index\";s:2:\"48\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:635;a:14:{s:2:\"id\";s:3:\"647\";s:5:\"title\";s:33:\"Services &#8211; Coffee Shop Menu\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2016/12/restaurant-menu.jpg\";s:12:\"tmpl_created\";s:10:\"1481549320\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/services-coffee-shop-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"157\";s:16:\"popularity_index\";s:3:\"425\";s:11:\"trend_index\";s:3:\"554\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:636;a:14:{s:2:\"id\";s:4:\"2138\";s:5:\"title\";s:33:\"Services &#8211; Delivery Company\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/07/delivery-services.png\";s:12:\"tmpl_created\";s:10:\"1499774119\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/services-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"158\";s:16:\"popularity_index\";s:3:\"369\";s:11:\"trend_index\";s:3:\"476\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:637;a:14:{s:2:\"id\";s:3:\"823\";s:5:\"title\";s:19:\"Pricing &#8211; App\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2017/01/pricing-app.jpg\";s:12:\"tmpl_created\";s:10:\"1485272966\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/pricing-app-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"159\";s:16:\"popularity_index\";s:3:\"345\";s:11:\"trend_index\";s:3:\"509\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:638;a:14:{s:2:\"id\";s:3:\"824\";s:5:\"title\";s:24:\"Pricing &#8211; Software\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/01/pricing-software.png\";s:12:\"tmpl_created\";s:10:\"1485272900\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/pricing-software-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"160\";s:16:\"popularity_index\";s:3:\"354\";s:11:\"trend_index\";s:3:\"423\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:639;a:14:{s:2:\"id\";s:3:\"825\";s:5:\"title\";s:24:\"Product &#8211; Speakers\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/01/product-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485272513\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/product-speakers/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"161\";s:16:\"popularity_index\";s:3:\"373\";s:11:\"trend_index\";s:3:\"485\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:640;a:14:{s:2:\"id\";s:3:\"245\";s:5:\"title\";s:21:\"Product &#8211; Clean\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0020.png\";s:12:\"tmpl_created\";s:10:\"1470829876\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/product-clean/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:48:\"[\"fast\",\"minimal\",\"minimalistic\",\"seo\",\"simple\"]\";s:10:\"menu_order\";s:3:\"162\";s:16:\"popularity_index\";s:2:\"75\";s:11:\"trend_index\";s:3:\"148\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:641;a:14:{s:2:\"id\";s:4:\"1075\";s:5:\"title\";s:19:\"Shop &#8211; Sweets\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2017/03/Sweets.png\";s:12:\"tmpl_created\";s:10:\"1488810871\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/shop-sweets/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:154:\"[\"bakery\",\"beverage\",\"business\",\"cafe\",\"candy bar\",\"catering\",\"delivery service\",\"Food\",\"online shop\",\"pastry\",\"Restaurant\",\"store\",\"sweet shop\",\"sweets\"]\";s:10:\"menu_order\";s:3:\"163\";s:16:\"popularity_index\";s:2:\"53\";s:11:\"trend_index\";s:2:\"70\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:642;a:14:{s:2:\"id\";s:4:\"1051\";s:5:\"title\";s:24:\"Blog Post &#8211; Launch\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/03/post-cloud.png\";s:12:\"tmpl_created\";s:10:\"1488810869\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blog-post-launch/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:210:\"[\"Agency\",\"bootstrap\",\"business\",\"corporate\",\"Landing Page\",\"launch\",\"marketing campaign\",\"marketing landing page\",\"marketing template landing page\",\"product launch\",\"software\",\"Startup\",\"startup landing page\"]\";s:10:\"menu_order\";s:3:\"164\";s:16:\"popularity_index\";s:2:\"17\";s:11:\"trend_index\";s:2:\"21\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:643;a:14:{s:2:\"id\";s:4:\"1245\";s:5:\"title\";s:13:\"Coming Soon 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-1.png\";s:12:\"tmpl_created\";s:10:\"1491207184\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"165\";s:16:\"popularity_index\";s:3:\"254\";s:11:\"trend_index\";s:3:\"371\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:644;a:14:{s:2:\"id\";s:4:\"1247\";s:5:\"title\";s:13:\"Coming Soon 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-2.png\";s:12:\"tmpl_created\";s:10:\"1491207138\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"166\";s:16:\"popularity_index\";s:2:\"29\";s:11:\"trend_index\";s:2:\"62\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:645;a:14:{s:2:\"id\";s:4:\"1248\";s:5:\"title\";s:13:\"Coming Soon 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-3.png\";s:12:\"tmpl_created\";s:10:\"1491207050\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"167\";s:16:\"popularity_index\";s:3:\"379\";s:11:\"trend_index\";s:3:\"414\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:646;a:14:{s:2:\"id\";s:4:\"1249\";s:5:\"title\";s:13:\"Coming Soon 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-4.png\";s:12:\"tmpl_created\";s:10:\"1491207380\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"168\";s:16:\"popularity_index\";s:3:\"403\";s:11:\"trend_index\";s:3:\"531\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:647;a:14:{s:2:\"id\";s:4:\"1250\";s:5:\"title\";s:13:\"Coming Soon 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-5.png\";s:12:\"tmpl_created\";s:10:\"1491207450\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"169\";s:16:\"popularity_index\";s:2:\"65\";s:11:\"trend_index\";s:3:\"112\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:648;a:14:{s:2:\"id\";s:4:\"1260\";s:5:\"title\";s:18:\"Maintenance Mode 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-6.png\";s:12:\"tmpl_created\";s:10:\"1491207507\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:3:\"170\";s:16:\"popularity_index\";s:3:\"421\";s:11:\"trend_index\";s:3:\"564\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:649;a:14:{s:2:\"id\";s:4:\"1261\";s:5:\"title\";s:18:\"Maintenance Mode 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/04/Coming-Soon-7.png\";s:12:\"tmpl_created\";s:10:\"1491207584\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:3:\"171\";s:16:\"popularity_index\";s:2:\"70\";s:11:\"trend_index\";s:3:\"191\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:650;a:14:{s:2:\"id\";s:4:\"1272\";s:5:\"title\";s:13:\"Coming Soon 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-8.png\";s:12:\"tmpl_created\";s:10:\"1491207674\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"172\";s:16:\"popularity_index\";s:3:\"282\";s:11:\"trend_index\";s:3:\"326\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:651;a:14:{s:2:\"id\";s:4:\"1279\";s:5:\"title\";s:13:\"Coming Soon 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-9.png\";s:12:\"tmpl_created\";s:10:\"1491207756\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"173\";s:16:\"popularity_index\";s:3:\"132\";s:11:\"trend_index\";s:3:\"260\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:652;a:14:{s:2:\"id\";s:4:\"1745\";s:5:\"title\";s:14:\"Coming Soon 10\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/login-002.png\";s:12:\"tmpl_created\";s:10:\"1494849745\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/coming-soon-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"174\";s:16:\"popularity_index\";s:3:\"269\";s:11:\"trend_index\";s:3:\"346\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:653;a:14:{s:2:\"id\";s:4:\"1742\";s:5:\"title\";s:12:\"Login Page 1\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/login-003.png\";s:12:\"tmpl_created\";s:10:\"1494849744\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:100:\"https://library.elementor.com/login-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"175\";s:16:\"popularity_index\";s:3:\"397\";s:11:\"trend_index\";s:3:\"473\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:654;a:14:{s:2:\"id\";s:4:\"1748\";s:5:\"title\";s:12:\"Login Page 2\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/login-001.png\";s:12:\"tmpl_created\";s:10:\"1494849742\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/login-page-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"176\";s:16:\"popularity_index\";s:3:\"290\";s:11:\"trend_index\";s:3:\"329\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:655;a:14:{s:2:\"id\";s:4:\"3963\";s:5:\"title\";s:32:\"Restaurant Site &#8211; Homepage\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/01/R.HomepageThumb.png\";s:12:\"tmpl_created\";s:10:\"1516284821\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/restaurant-site-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"177\";s:16:\"popularity_index\";s:3:\"229\";s:11:\"trend_index\";s:3:\"268\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:656;a:14:{s:2:\"id\";s:4:\"3969\";s:5:\"title\";s:28:\"Restaurant Site &#8211; Menu\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/01/R.MenuThumb.png\";s:12:\"tmpl_created\";s:10:\"1516284829\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/restaurant-site-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"178\";s:16:\"popularity_index\";s:3:\"382\";s:11:\"trend_index\";s:3:\"382\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:657;a:14:{s:2:\"id\";s:4:\"3966\";s:5:\"title\";s:29:\"Restaurant Site &#8211; About\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/01/R.AboutThumb.png.png\";s:12:\"tmpl_created\";s:10:\"1516284839\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/restaurant-site-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"179\";s:16:\"popularity_index\";s:3:\"244\";s:11:\"trend_index\";s:3:\"340\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:658;a:14:{s:2:\"id\";s:4:\"3972\";s:5:\"title\";s:31:\"Restaurant Site &#8211; Contact\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/01/R.ContactThumb.png\";s:12:\"tmpl_created\";s:10:\"1516284847\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/restaurant-site-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"180\";s:16:\"popularity_index\";s:3:\"351\";s:11:\"trend_index\";s:3:\"425\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:659;a:14:{s:2:\"id\";s:4:\"2080\";s:5:\"title\";s:27:\"Ski Resort &#8211; Homepage\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/10/Ski-Resort-Home-Page.png\";s:12:\"tmpl_created\";s:10:\"1508161124\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/ski-resort-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"181\";s:16:\"popularity_index\";s:3:\"318\";s:11:\"trend_index\";s:3:\"431\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:660;a:14:{s:2:\"id\";s:4:\"2088\";s:5:\"title\";s:24:\"Ski Resort &#8211; About\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/10/Ski-Resort-About.png\";s:12:\"tmpl_created\";s:10:\"1508161129\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/ski-resort-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"182\";s:16:\"popularity_index\";s:3:\"393\";s:11:\"trend_index\";s:3:\"397\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:661;a:14:{s:2:\"id\";s:4:\"2085\";s:5:\"title\";s:27:\"Ski Resort &#8211; Services\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2017/10/Ski-Resort-Services.png\";s:12:\"tmpl_created\";s:10:\"1508161134\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/ski-resort-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"183\";s:16:\"popularity_index\";s:3:\"503\";s:11:\"trend_index\";s:3:\"573\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:662;a:14:{s:2:\"id\";s:4:\"2462\";s:5:\"title\";s:23:\"Architect &#8211; About\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2017/10/architect-–-about.png\";s:12:\"tmpl_created\";s:10:\"1508243317\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/architect-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"184\";s:16:\"popularity_index\";s:3:\"313\";s:11:\"trend_index\";s:3:\"477\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:663;a:14:{s:2:\"id\";s:4:\"2362\";s:5:\"title\";s:26:\"Architect &#8211; Projects\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2017/10/Architect-Projects.png\";s:12:\"tmpl_created\";s:10:\"1508243335\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/architect-projects/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"185\";s:16:\"popularity_index\";s:3:\"381\";s:11:\"trend_index\";s:3:\"407\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:664;a:14:{s:2:\"id\";s:3:\"614\";s:5:\"title\";s:25:\"Architect &#8211; Contact\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2016/12/architect-contact.jpg\";s:12:\"tmpl_created\";s:10:\"1481549169\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/architect-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"186\";s:16:\"popularity_index\";s:3:\"287\";s:11:\"trend_index\";s:3:\"451\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:665;a:14:{s:2:\"id\";s:4:\"2126\";s:5:\"title\";s:37:\"Construction Company &#8211; Homepage\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2017/10/Construction-Company-Home-Page.png\";s:12:\"tmpl_created\";s:10:\"1508325849\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/construction-company-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"187\";s:16:\"popularity_index\";s:3:\"271\";s:11:\"trend_index\";s:3:\"384\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:666;a:14:{s:2:\"id\";s:4:\"2129\";s:5:\"title\";s:34:\"Construction Company &#8211; About\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/10/Construction-Company-About.png\";s:12:\"tmpl_created\";s:10:\"1508325881\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/construction-company-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"188\";s:16:\"popularity_index\";s:3:\"297\";s:11:\"trend_index\";s:3:\"486\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:667;a:14:{s:2:\"id\";s:4:\"2135\";s:5:\"title\";s:36:\"Construction Company &#8211; Contact\";s:9:\"thumbnail\";s:89:\"https://library.elementor.com/wp-content/uploads/2017/10/Construction-Company-Contact.png\";s:12:\"tmpl_created\";s:10:\"1508325922\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/construction-company-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"189\";s:16:\"popularity_index\";s:3:\"335\";s:11:\"trend_index\";s:3:\"508\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:668;a:14:{s:2:\"id\";s:4:\"2094\";s:5:\"title\";s:28:\"Plants Shop &#8211; Homepage\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/11/Plants-Shop-Home.png\";s:12:\"tmpl_created\";s:10:\"1509621053\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/plants-shop-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"190\";s:16:\"popularity_index\";s:3:\"268\";s:11:\"trend_index\";s:3:\"214\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:669;a:14:{s:2:\"id\";s:4:\"2120\";s:5:\"title\";s:25:\"Plants Shop &#8211; About\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/11/Plants-Shop-About.png\";s:12:\"tmpl_created\";s:10:\"1509631820\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/plants-shop-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"191\";s:16:\"popularity_index\";s:3:\"336\";s:11:\"trend_index\";s:3:\"376\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:670;a:14:{s:2:\"id\";s:4:\"3153\";s:5:\"title\";s:14:\"Halloween Pack\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/10/halloween.png\";s:12:\"tmpl_created\";s:10:\"1508950132\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/halloween-pack/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"192\";s:16:\"popularity_index\";s:3:\"574\";s:11:\"trend_index\";s:3:\"676\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:671;a:14:{s:2:\"id\";s:4:\"3338\";s:5:\"title\";s:31:\"Black Friday &#8211; Nature Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-1.png\";s:12:\"tmpl_created\";s:10:\"1511203351\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/black-friday-nature-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"193\";s:16:\"popularity_index\";s:3:\"496\";s:11:\"trend_index\";s:3:\"599\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:672;a:14:{s:2:\"id\";s:4:\"3339\";s:5:\"title\";s:35:\"Black Friday &#8211; Pop-Styled Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-2.png\";s:12:\"tmpl_created\";s:10:\"1511203636\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/black-friday-pop-styled-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"194\";s:16:\"popularity_index\";s:3:\"441\";s:11:\"trend_index\";s:3:\"484\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:673;a:14:{s:2:\"id\";s:4:\"3335\";s:5:\"title\";s:31:\"Black Friday &#8211; Retail Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-4.png\";s:12:\"tmpl_created\";s:10:\"1511203246\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/black-friday-retail-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"195\";s:16:\"popularity_index\";s:3:\"444\";s:11:\"trend_index\";s:3:\"589\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:674;a:14:{s:2:\"id\";s:4:\"3340\";s:5:\"title\";s:41:\"Black Friday &#8211; Software Product Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-3.png\";s:12:\"tmpl_created\";s:10:\"1511203713\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/black-friday-software-product-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"196\";s:16:\"popularity_index\";s:3:\"420\";s:11:\"trend_index\";s:3:\"576\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:675;a:14:{s:2:\"id\";s:4:\"3517\";s:5:\"title\";s:27:\"Christmas &#8211; Gift Shop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/12/XmasThumb.png\";s:12:\"tmpl_created\";s:10:\"1513877937\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/christmas-gift-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"197\";s:16:\"popularity_index\";s:3:\"489\";s:11:\"trend_index\";s:3:\"614\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:676;a:14:{s:2:\"id\";s:4:\"3734\";s:5:\"title\";s:28:\"Christmas &#8211; Car Agency\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/12/cover-lib-v3.png\";s:12:\"tmpl_created\";s:10:\"1514197794\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/christmas-car-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"198\";s:16:\"popularity_index\";s:3:\"470\";s:11:\"trend_index\";s:3:\"662\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:677;a:14:{s:2:\"id\";s:4:\"3764\";s:5:\"title\";s:33:\"Christmas &#8211; Interior Design\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/12/cover-lib-v6.png\";s:12:\"tmpl_created\";s:10:\"1514198234\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/christmas-interior-design/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"199\";s:16:\"popularity_index\";s:3:\"449\";s:11:\"trend_index\";s:3:\"557\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:678;a:14:{s:2:\"id\";s:4:\"3565\";s:5:\"title\";s:27:\"Christmas &#8211; Tree Shop\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/12/XmasTreeThumb.png\";s:12:\"tmpl_created\";s:10:\"1514204382\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/christmas-tree-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"200\";s:16:\"popularity_index\";s:3:\"392\";s:11:\"trend_index\";s:3:\"600\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:679;a:14:{s:2:\"id\";s:4:\"3862\";s:5:\"title\";s:35:\"Christmas &#8211; Design Conference\";s:9:\"thumbnail\";s:63:\"https://library.elementor.com/wp-content/uploads/2017/12/q1.png\";s:12:\"tmpl_created\";s:10:\"1514206745\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/christmas-design-conference/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"201\";s:16:\"popularity_index\";s:3:\"384\";s:11:\"trend_index\";s:3:\"560\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:680;a:14:{s:2:\"id\";s:4:\"3777\";s:5:\"title\";s:39:\"Christmas &#8211; Snowboard Competition\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/12/cover-lib-v7.png\";s:12:\"tmpl_created\";s:10:\"1514205420\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/christmas-snowboard-competition/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"202\";s:16:\"popularity_index\";s:3:\"412\";s:11:\"trend_index\";s:3:\"472\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:681;a:14:{s:2:\"id\";s:3:\"420\";s:5:\"title\";s:11:\"Hero UI Kit\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2016/09/library-ui-kit-cover.png\";s:12:\"tmpl_created\";s:10:\"1475067229\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/hero-ui-kit/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"203\";s:16:\"popularity_index\";s:2:\"20\";s:11:\"trend_index\";s:2:\"52\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}}}", "no");
INSERT INTO `wp_522243_options` VALUES("464", "elementor_remote_info_feed_data", "a:5:{i:0;a:5:{s:5:\"title\";s:58:\"The New Rank Math SEO Integration for Elementor Explained \";s:7:\"excerpt\";s:253:\"With Rank Math\'s new integration for Elementor you can get SEO suggestions, edit your meta snippet accordingly, and configure the schema markup — all from within Elementor\'s editing screen. In this article, we’ll walk you through these new features.\";s:7:\"created\";s:10:\"1588245311\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:121:\"https://elementor.com/blog/rank-math-integration/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:1;a:5:{s:5:\"title\";s:91:\"Monday Masterclass: How to Transform Any WordPress Site Into an Online Store With Elementor\";s:7:\"excerpt\";s:179:\"This week we turn a WordPress site into an online store with customizable product display, and an efficient system for shipping and registering orders, all done in 5 simple steps.\";s:7:\"created\";s:10:\"1588065572\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:135:\"https://elementor.com/blog/wordpress-site-into-an-online-store/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:2;a:5:{s:5:\"title\";s:56:\"Monthly Templates Kit #9: The Online Course Template Kit\";s:7:\"excerpt\";s:274:\"Meet our Online Course Website template kit, which we built for professionals looking to create and publish an online video course on WordPress. It only takes minutes to upload your video content and materials so that you can share your skill set with the world of learners.\";s:7:\"created\";s:10:\"1587538951\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:126:\"https://elementor.com/blog/online-course-template-kit/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:3;a:5:{s:5:\"title\";s:43:\"Elementor Sites of the Month – March 2020\";s:7:\"excerpt\";s:73:\"Here are our top picks of Elementor sites for March 2020. Check them out!\";s:7:\"created\";s:10:\"1587480146\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:119:\"https://elementor.com/blog/showcase-march-2020/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:4;a:5:{s:5:\"title\";s:61:\"How to Design Your WordPress Site Using Elementor Theme Style\";s:7:\"excerpt\";s:177:\"Elementor Theme Style allows you to customize your website easily. In this tutorial, we’ll show you how to use the theme style to quickly build a unique and compelling design.\";s:7:\"created\";s:10:\"1586863421\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:148:\"https://elementor.com/blog/design-your-wordpress-site-elementor-theme-style/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}}", "no");
INSERT INTO `wp_522243_options` VALUES("468", "elementor_extras_license_key", "9c11c4ea0cf9aa02f3d2fa31a131076c", "yes");
INSERT INTO `wp_522243_options` VALUES("471", "elementor_connect_site_key", "099e30bc7a3576cc44c5d7460f19232d", "yes");
INSERT INTO `wp_522243_options` VALUES("472", "elementor_allow_tracking", "yes", "yes");
INSERT INTO `wp_522243_options` VALUES("473", "elementor_tracker_last_send", "1588498959", "yes");
INSERT INTO `wp_522243_options` VALUES("474", "elementor_pro_license_key", "67c20af166fce49cd36baf11cb604b3a", "yes");
INSERT INTO `wp_522243_options` VALUES("477", "elementor_custom_icon_sets_config", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("478", "elementor_fonts_manager_font_types", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("479", "elementor_fonts_manager_fonts", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("480", "edd_sl_4d48928767973217de0ddada1b0adc6f", "a:2:{s:7:\"timeout\";i:1588510052;s:5:\"value\";s:183621:\"{\"new_version\":\"2.2.28\",\"stable_version\":\"2.2.28\",\"name\":\"Elementor Extras\",\"slug\":\"elementor-extras\",\"url\":\"https:\\/\\/shop.namogo.com\\/product\\/elementor-extras\\/?changelog=1\",\"last_updated\":\"4 days ago\",\"homepage\":\"https:\\/\\/shop.namogo.com\\/product\\/elementor-extras\",\"package\":\"https:\\/\\/shop.namogo.com\\/edd-sl\\/package_download\\/MTU4ODc2OTI1MTo5YzExYzRlYTBjZjlhYTAyZjNkMmZhMzFhMTMxMDc2YzoxOTowYzQxZGY4YmIyNWQzMGJkMGUzYzMwMzNhYjZiNjY4MjpodHRwQC8vbmlra2lqYW1lcy5uZXQ6MA==\",\"download_link\":\"https:\\/\\/shop.namogo.com\\/edd-sl\\/package_download\\/MTU4ODc2OTI1MTo5YzExYzRlYTBjZjlhYTAyZjNkMmZhMzFhMTMxMDc2YzoxOTowYzQxZGY4YmIyNWQzMGJkMGUzYzMwMzNhYjZiNjY4MjpodHRwQC8vbmlra2lqYW1lcy5uZXQ6MA==\",\"sections\":{\"description\":\"<p>Elementor Extras is one of the first premium Wordpress plugin for Elementor. It extends its capability with many unique widgets and extensions that make Elementor even more powerful.<\\/p>\\n<h4> Copyright and licensing <\\/h4>\\n<p>Copyright (C) 2016-2019 Elementor Ltd.<\\/p>\\n<p>This program is free software: you can redistribute it and\\/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.<\\/p>\\n<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.<\\/p>\\n<p>You should have received a copy of the GNU General Public License along with this program. If not, see <a href=\\\"https:\\/\\/www.gnu.org\\/licenses\\/\\\">https:\\/\\/www.gnu.org\\/licenses\\/<\\/a>.<\\/p>\\n<h4> Third Party Code <\\/h4>\\n<p>Elementor Extras incorporates code from:<\\/p>\\n<ul>\\n<li><strong>jquery-circle-progress<\\/strong> v1.2.2, Copyright Rostyslav Bryzgunov Licenses: MIT Source: link <a href=\\\"http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/\\\">http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/<\\/a><\\/li>\\n<li><strong>jQuery appear plugin<\\/strong> v0.3.6, Copyright 2012 Andrey Sidorov Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/morr\\/jquery.appear\\/\\\">https:\\/\\/github.com\\/morr\\/jquery.appear\\/<\\/a><\\/li>\\n<li><strong>LongShadow jQuery Plugin<\\/strong> v1.1.0, Copyright 2013 - 2016 Dang Van Thanh Licenses: MIT Source: link git:\\/\\/github.com\\/dangvanthanh\\/jquery.longShadow.git<\\/li>\\n<li><strong>HC-Sticky<\\/strong> v2.2.3, Copyright Some Web Media License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/somewebmedia\\/hc-sticky\\\">https:\\/\\/github.com\\/somewebmedia\\/hc-sticky<\\/a><\\/li>\\n<li><strong>jQuery Mobile<\\/strong> v1.4.3, Copyright 2010, 2014 jQuery Foundation, Inc. Licenses: jquery.org\\/license<\\/li>\\n<li><strong>jquery-visible<\\/strong>, Copyright 2012, Digital Fusion, License: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a> Source: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a><\\/li>\\n<li><strong>Parallax Background<\\/strong> v1.2, by Eren Suleymanoglu Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background\\\">https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background<\\/a><\\/li>\\n<li><strong>TableSorter<\\/strong> v2.0.5b, Copyright 2007 Christian Bach Licenses: Dual licensed under the MIT and GPL licenses Source: link <a href=\\\"http:\\/\\/tablesorter.com\\\">http:\\/\\/tablesorter.com<\\/a><\\/li>\\n<li><strong>Isotope<\\/strong> PACKAGED v3.0.6, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>Infinite Scroll<\\/strong> PACKAGED v3.0.2, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"https:\\/\\/infinite-scroll.com\\\">https:\\/\\/infinite-scroll.com<\\/a><\\/li>\\n<li><strong>Packery layout mode<\\/strong> PACKAGED v2.0.0 Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>javascript-detect-element-resize<\\/strong> v0.5.3 Copyright (c) 2013 Sebasti\\u00e1n D\\u00e9cima License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize\\\">https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize<\\/a><\\/li>\\n<li><strong>tilt.js<\\/strong> 1.2.1, Copyright (c) 2017 Gijs Rog\\u00e9 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/gijsroge\\/tilt.js\\\">https:\\/\\/github.com\\/gijsroge\\/tilt.js<\\/a><\\/li>\\n<li><strong>CLNDR<\\/strong> v1.4.7, Copyright Kyle Stetz (github.com\\/kylestetz) License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/kylestetz\\/CLNDR\\\">https:\\/\\/github.com\\/kylestetz\\/CLNDR<\\/a><\\/li>\\n<li><strong>GMAP3 Plugin for jQuery<\\/strong> v7.2 Copyright DEMONTE Jean-Baptiste License: GPL-3.0+ Source: link <a href=\\\"http:\\/\\/gmap3.net\\\">http:\\/\\/gmap3.net<\\/a><\\/li>\\n<li><strong>Moment.js<\\/strong> v2.22.2 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/moment\\/moment\\/\\\">https:\\/\\/github.com\\/moment\\/moment\\/<\\/a><\\/li>\\n<li><strong>Slidebars<\\/strong> v2 Copyright Adam Charles Smith License: MIT <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/<\\/a> Source: link <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/<\\/a><\\/li>\\n<li><strong>Splittext.js<\\/strong> Copyright (c) 2008-2016, GreenSock<\\/li>\\n<li><strong>Magnific Popup<\\/strong> v1.1.0 License: MIT Copyright 2016 Dmitry Semenov Soruce: link <a href=\\\"http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/\\\">http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/<\\/a><\\/li>\\n<\\/ul>\\n<h4> Important Links <\\/h4>\\n<p><a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/getting-started\\/#update-official\\\">Updating Extras<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/topic\\/elementor-extras\\/\\\">Documentation<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/\\\">Your Account<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/support\\/\\\">Support<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/frequently-asked-questions\\/\\\">FAQ<\\/a><\\/p>\",\"changelog\":\"<h4> 2.2.28 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Padding control for labels<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Control to disable structured data attributes<\\/li>\\n<li>Added: Gallery Slider, Gallery Extra, Switcher \\u2014 Option to disable slideshow in lightbox<\\/li>\\n<li>Added: Posts \\u2014 Wordpress filters for post and post wrapper classes<\\/li>\\n<li>Added: Video Player \\u2014 Control to remove Chrome\'s download option in fullscreen mode<\\/li>\\n<li>Fixed: Gallery Slider, Gallery Extra, Random Image, Switcher \\u2014 Missing lightbox captions<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Low CSS specificity for ul and li elements causing themes override<\\/li>\\n<li>Fixed: Popup \\u2014 Exit intent not working correctly<\\/li>\\n<li>Tweak: Updated translations .pot file<\\/li>\\n<\\/ul>\\n<h4> 2.2.27 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 Shortcode output condition<\\/li>\\n<li>Added: Display Conditions \\u2014 Post meta condition<\\/li>\\n<li>Added: Posts Extra \\u2014 Control to stack filters responsively<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to trigger a window resize events after each carousel slide to fix displaying issues of certain widgets when using custom post skins<\\/li>\\n<li>Added: Gallery Slider \\u2014 Option to contain centre fit images inside preview slider when custom height is set<\\/li>\\n<li>Fixed: Incorrect Breadcrumbs and Slide Menu WPML integration<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters not changing active class when using masonry<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Load more button not hidden when no pagination available<\\/li>\\n<li>Fixed: Video Player \\u2014 Trigger window resize to position correctly elements with motion effects enabled after the video is loaded<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Removed label_block from slider control that broke controls<\\/li>\\n<\\/ul>\\n<h4> 2.2.26 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Carousel pagination selector breaks pagination when multiple carousels on same page<\\/li>\\n<li>Fixed: Search Form \\u2014 Submit button icon spacing control bug<\\/li>\\n<li>Fixed: Search Form \\u2014 Beautified option fields icons not displaying properly<\\/li>\\n<li>Fixed: Gallery Slider \\u2013 Figure line height causing caption display issues<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Distance control for thumbnails carousel arrows not working<\\/li>\\n<\\/ul>\\n<h4> 2.2.25 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 If no condition value is set check to see if field is set to any value<\\/li>\\n<li>Added: Gallery Slider \\u2014 Options to set max. width and horizontal and vertical alignment for thumbnails carousel<\\/li>\\n<li>Added: Gallery Slider \\u2014 Option to set custom height for preview slides<\\/li>\\n<li>Added: Popup \\u2014 Option to disable refreshing frontend functionality for elements inside the popup<\\/li>\\n<li>Added: Offcanvas \\u2014 Option to disable refreshing frontend functionality for elements inside the panel<\\/li>\\n<li>Added: Calendar \\u2014 Typography control for header week days<\\/li>\\n<li>Added: Google Map \\u2014 Option to set zoom level when navigating to a location<\\/li>\\n<li>Fixed: Bug where one swiper slider\'s arrows control all swiper sliders on the same page<\\/li>\\n<li>Fixed: Calendar \\u2014 Separator style for header not working<\\/li>\\n<li>Fixed: Gallery \\u2014 Instagram lightbox not working for my photos<\\/li>\\n<li>Fixed: Gallery \\u2014 Instagram links bug for hashtag posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters with masonry enabled when two widgets on page breaks filtering<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Allow 0 value to be shown<\\/li>\\n<\\/ul>\\n<h4> 2.2.24 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Option to enable carousel on thumbnails<\\/li>\\n<li>Added: Posts Extra \\u2014 More swiper settings<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Compatibility with display conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Dynamic tag background styles<\\/li>\\n<li>Fixed: Don\'t include Elementor form widget in refreshable widgets due to reCaptcha reinitialisation uncaught error<\\/li>\\n<li>Fixed: Timeline \\u2014 Date entrance animation on left right and overlay alignments<\\/li>\\n<\\/ul>\\n<h4> 2.2.23 <\\/h4>\\n<ul>\\n<li>Added: Popup \\u2014 Margin control for close icon<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Instagram compatibility with new API changes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel compatibility with Elementor 2.9.4 swiper.js changes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Allow -1 as posts per page value for specific query source<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Use wp_timezone instead of timezone_string in case timezone is set as offset<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Filter post count style controls conditions<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Carousel remove deprecated Columns control<\\/li>\\n<li>Tweak: Google Map \\u2014 Convert description control from text to WYSIWYG type<\\/li>\\n<\\/ul>\\n<h4> 2.2.22 <\\/h4>\\n<ul>\\n<li>Fixed: Timeline \\u2014 Points and dates not showing when animate cards is on<\\/li>\\n<li>Fixed: Unfold \\u2014 Bug error showing button since last update<\\/li>\\n<\\/ul>\\n<h4> 2.2.21 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 Current Date &amp; Time condition<\\/li>\\n<li>Added: Timeline \\u2014 New option to reverse position of cards<\\/li>\\n<li>Added: Text Divider \\u2014 Margin control for the text<\\/li>\\n<li>Added: Toggle Element \\u2014 Option to hide all elements by default<\\/li>\\n<li>Added: Timeline \\u2014 Controls for overriding text colour in custom mode<\\/li>\\n<li>Fixed: EE widget indicator in editor panel font<\\/li>\\n<li>Fixed: Unfold \\u2014 Removed elementor-button class from button which was adding a lot of padding<\\/li>\\n<li>Fixed: Unfold \\u2014 Editor preview spacing in js template<\\/li>\\n<li>Fixed: Query control width<\\/li>\\n<li>Fixed: PHP error on updater transient data<\\/li>\\n<li>Fixed: Video Player \\u2014 Stop play when played once in viewport<\\/li>\\n<li>Fixed: Timeline \\u2014 Correct dates when using custom post skin with a template that uses Posts Extra<\\/li>\\n<li>Fixed: Tooltips \\u2014 Tooltips not closing on mobile with touchstart event<\\/li>\\n<li>Fixed: Timeline \\u2014 Entrance animation triggering on page load instead of scroll to element<\\/li>\\n<li>Fixed: Timeline \\u2014 Query section not hidden if Source is Custom<\\/li>\\n<li>Fixed: Multiple SELECT2 controls width bug (missing css) after Elementor update<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Masonry layout broken when using custom size values in manual mode<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Changing filters disrupts any Elementor entrance animations placed after widget<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Run ready triggers for section and columns on infinite scroll<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Refresh elements even if infinite scroll button is off<\\/li>\\n<li>Fixed: ACF fields not showing inside templates when ACF Extended plugin is active<\\/li>\\n<li>Tweak: Unfold \\u2014 Hide button when there is no content or visible lines exceeds number of existing lines<\\/li>\\n<li>Tweak: Tooltips \\u2014 Integrate Elementor breakpoints<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Improved buggy responsive custom sizing method<\\/li>\\n<li>Revert: Display Conditions \\u2014 Added time to Current Date conditions\' date control<\\/li>\\n<\\/ul>\\n<h4> 2.2.20 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 \'Current User\' condition<\\/li>\\n<li>Added: Display Conditions \\u2014 Added time to Current Date conditions\' date control<\\/li>\\n<li>Fixed: Some icon controls hidden due to Elementor changing label_block control attribute<\\/li>\\n<li>Fixed: Popup \\u2014 Close button control conditions<\\/li>\\n<li>Fixed: Popup \\u2014 Close icon not hiding on frontend<\\/li>\\n<\\/ul>\\n<h4> 2.2.19 <\\/h4>\\n<ul>\\n<li>Added: Popup \\u2014 Option to set max number of times a non-persistent popup should open<\\/li>\\n<li>Fixed: Posts \\u2014 Carousel compatibility with Elementor 2.9.0 swiper js upgrade<\\/li>\\n<li>Fixed: Switcher \\u2014 Title direction on RTL<\\/li>\\n<\\/ul>\\n<h4> 2.2.18 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Filters infinite scroll warning<\\/li>\\n<li>Added: Popup \\u2014 Border controls for iframe and image<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 PHP warning<\\/li>\\n<li>Fixed: Buttons \\u2014 Theme CSS override for anchors<\\/li>\\n<li>Fixed: Popup \\u2014 PHP warning when using placeholder image<\\/li>\\n<li>Fixed: Popup \\u2014 Overflow hidden missing from popup content<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Restrict refreshing widget inside offcanvas panel to refreshable list<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Clicking bullets on mobile doesn\'t scroll to section when tooltips are enabled<\\/li>\\n<li>Tweak: Scroll Indicator \\u2014 Separate control for enabling opening of tooltips on focus for better integration<\\/li>\\n<li>Tweak: Switcher \\u2014 Convert description textarea field to WYSIWYG<\\/li>\\n<li>Tweak: Slide Menu \\u2014 More specific selector typography control<\\/li>\\n<li>Tweak: Popup \\u2014 Default close button size for iframe<\\/li>\\n<li>Tweak: Make license renewal reminder dismissable<\\/li>\\n<\\/ul>\\n<h4> 2.2.17 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Option to open in new tab for Title link<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Run ready triggers for widgets inside panel when opening<\\/li>\\n<li>Tweak: Posts \\u2014 Hide Media area if no thumbnail or placeholder even if it has content parts<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Default thumbs spacing to 24<\\/li>\\n<li>Tweak: Update TweenMax version<\\/li>\\n<\\/ul>\\n<h4> 2.2.16 <\\/h4>\\n<ul>\\n<li>Added: Scroll Indicator \\u2014 Offset for scrolling to section<\\/li>\\n<li>Added: Gallery Slider \\u2014 Lazy load images in preview<\\/li>\\n<li>Added: Slide Menu \\u2014 \'elementor_extras\\/widgets\\/slide_menu\\/nav_menu\\/walker_start_el\' filter for walker_nav_menu_start_el hook<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Tilt perspective issue<\\/li>\\n<li>Fixed: Gallery \\u2014 Tilt captions depth not working<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Distance for repositioned tooltips<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Multiple tooltips appearing only in edit mode when changing tooltip position<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Remove posts per page setting for current query<\\/li>\\n<li>Fixed: Display Conditions \\u2014 GET and POST not returning true for any value<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Minor PHP warning<\\/li>\\n<li>Fixed: Random Image \\u2014 Error when using only one image<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Duplicate images in Elementor lightbox when infinite loop is enabled<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Include &quot;related&quot; source in Price position control conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Meta Key not showing when Order By is set to Meta Value (number)<\\/li>\\n<li>Fixed: Timeline \\u2014 Meta Key not showing when Order By is set to Meta Value (number)<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Disable add to cart button when used inside a linked Media area<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive entrance animation<\\/li>\\n<\\/ul>\\n<h4> 2.2.15 <\\/h4>\\n<ul>\\n<li>Fixed: Popup \\u2014 Date comparison fail for non-persistent interval setting<\\/li>\\n<li>Fixed: Tooltips \\u2014 Tooltips empty in some cases after last update<\\/li>\\n<li>Fixed: Calendar \\u2014 Support for ACF date time picker fields<\\/li>\\n<li>Tweak: Hotspots \\u2014 Better css method for disabling pulse effect<\\/li>\\n<li>Tweak: Posts Extra \\u2014 New &quot;hide&quot; icon for content parts positioning<\\/li>\\n<li>Tweak: Nicons<\\/li>\\n<\\/ul>\\n<h4> 2.2.14 <\\/h4>\\n<ul>\\n<li>Fixed: Audio Player \\u2014 Edge case bug when stopping a player inside a section stuck with Elementor sticky setting<\\/li>\\n<li>Fixed: Switcher \\u2014 Loader thickness not working in Firefox<\\/li>\\n<li>Fixed: Offcanvas \\u2014 WPML not fetching content boxes repeater fields<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Masonry missing on frontend after last update<\\/li>\\n<li>Tweak: Tooltips \\u2014 Use append method to add content to the tooltip<\\/li>\\n<\\/ul>\\n<h4> 2.2.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Media left right alignment not working<\\/li>\\n<\\/ul>\\n<h4> 2.2.12 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Post border radius control<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Safari layout bug on infinite scroll and masonry layout<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel slides to scroll on tablet bug<\\/li>\\n<li>Fixed: Timeline \\u2014 Date options not showing for custom post skin option<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Force sticky sections to flex align to start for Safari flex stretch bug<\\/li>\\n<\\/ul>\\n<h4> 2.2.11 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Infinite scroll fields for WPML<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Better support for post type archive links on archive pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Flexbox causing horizontal media layout issue on mobile<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Compatibility with wordpress 5.3<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Mode container background colour control from site settings to widget settings<\\/li>\\n<\\/ul>\\n<h4> 2.2.10 <\\/h4>\\n<ul>\\n<li>Added: Popup \\u2014 Option to open url inside popup<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Check for existing non built-in custom post types before iteration<\\/li>\\n<li>Fixed: Display Conditions \\u2014 ACF Date support for custom locale<\\/li>\\n<li>Fixed: Calendar \\u2014 ACF Date support for custom locale<\\/li>\\n<li>Fixed: Switcher \\u2014 Description not available for translation<\\/li>\\n<li>Fixed: Gallery \\u2014 Safari backface-visibility bug<\\/li>\\n<\\/ul>\\n<h4> 2.2.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Align media vertically on horizontal post layouts<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Text separator not displaying<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default horizontal layout width control to 30<\\/li>\\n<\\/ul>\\n<h4> 2.2.8 <\\/h4>\\n<ul>\\n<li>Added: Breadcrumbs \\u2014 Granular controls for crumbs settings on archive and single pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Moved images loaded container selector to ajax response<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters option not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll pagination html output rendering more links than needed<\\/li>\\n<li>Fixed: PHP notice for licensing admin notification<\\/li>\\n<li>Fixed: Switcher \\u2014 Border radius control CSS selector<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Cleanup on pagination html output needed for infinite scroll<\\/li>\\n<\\/ul>\\n<h4> 2.2.7 <\\/h4>\\n<ul>\\n<li>Fixed: Compatibility with third-party plugin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case bug when calculating anchor position<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Notices<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Overlapping items on infinite scroll when filters active<\\/li>\\n<\\/ul>\\n<h4> 2.2.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Global \'elementor_extras\\/widgets\\/posts\\/link\' filter<\\/li>\\n<li>Added: Offcanvas \\u2014 Typography control for content boxes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite Scroll stopping before all posts load<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Panel background selector<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Page jump when navigating to anchor<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case js error in nouislider script<\\/li>\\n<li>Fixed: Templates Control \\u2014 Restrict global query override for templates inside loops<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Nav menu item classes don\'t work when coming from template control<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong order for hierarchical taxonomies<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Flicker when performing infinite scroll on filtered posts<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Additional padding in some cases below sticky element<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Missing day of week condition<\\/li>\\n<li>Fixed: Hotspots \\u2014 Better handling of icon vertical alignment in css<\\/li>\\n<\\/ul>\\n<h4> 2.2.5 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Control to hide items without any content<\\/li>\\n<li>Added: Popup \\u2014 Support for usage within Posts Extra custom post skin<\\/li>\\n<li>Added: Audio Player \\u2014 Option to disable preloading of audio files<\\/li>\\n<li>Added: Calendar \\u2014 Search custom fields by field name<\\/li>\\n<li>Added: Offcanvas \\u2014 Options in widgets\' settings to fix page jump issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Certain actions not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Pods controls not fetching fields<\\/li>\\n<li>Fixed: Calendar \\u2014 Toolset controls not fetching fields<\\/li>\\n<li>Fixed: Query Control \\u2014 Return only matching queries for pods and toolset<\\/li>\\n<li>Fixed: Calendar \\u2014 Placeholder functionality<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where css width selectors get overridden by defaults<\\/li>\\n<li>Tweak: Posts Extra \\u2013 Default css order value for parts and areas in frontend css<\\/li>\\n<li>Tweak: Popup \\u2014 Replaced multiple template selection control with single control. IMPORTANT: Settings review required!<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Refactor widget code<\\/li>\\n<\\/ul>\\n<h4> 2.2.4 <\\/h4>\\n<ul>\\n<li>Added: Dynamic background image support for custom post skin<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Filter for home breadcrumb link<\\/li>\\n<li>Fixed: Timeline \\u2014 Wrong card content selector for transition control<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Broken selectors after last offcanvas update<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove default border around posts<\\/li>\\n<\\/ul>\\n<h4> 2.2.3 <\\/h4>\\n<ul>\\n<li>Added: Offcanvas \\u2014 Compatibility with templates in loops in Posts Extra and other plugins<\\/li>\\n<li>Added: Posts Extra \\u2014 Refresh all widgets scripts on appended infinite scroll items<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Button style gone when placed in linked media area<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Bug when sticky section inside page body within theme builder header template<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Tooltips not working with bullets skin<\\/li>\\n<\\/ul>\\n<h4> 2.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Scroll Indicator \\u2014 Bug when tooltips disabled on bullets skin<\\/li>\\n<li>Fixed: Timeline \\u2014 Option to hide thumbnail not working in posts mode<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Bug with before parent category filters<\\/li>\\n<li>Fixed: Bug with third party elementor addon that enqueue editor scripts on plugin load<\\/li>\\n<li>Fixed: Posts \\u2014 Default metas control to include price for previous saved settings<\\/li>\\n<li>Added: Search Form \\u2014 Compatibility with Relevanssi search results on custom templates with search form id condition<\\/li>\\n<li>Added: Timeline \\u2014 Option to set a dynamic tag instead of date, title and excerpt in posts mode<\\/li>\\n<li>Added: Timeline \\u2014 Option to set HTML element for title in posts mode<\\/li>\\n<li>Added: Posts Extra \\u2014 Filter for the media area link<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to open media and button links in new tab<\\/li>\\n<li>Added: Table \\u2014 WPML translation of header cells text<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Additional listeners for recalculating sticky<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Less restrictive css selector for the woocommerce add to cart button<\\/li>\\n<\\/ul>\\n<h4> 2.2.1 <\\/h4>\\n<ul>\\n<li>Added: Scroll Indicator \\u2014 Option to offset start and end positions<\\/li>\\n<li>Added: Posts Extra \\u2014 Responsive media width control<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Missing custom field order options<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar meta showing even if removed from metas list<\\/li>\\n<li>Fixed: Display Conditions \\u2014 ACF Choice fails for radio field<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Bug with left aligned media flex width on mobile<\\/li>\\n<\\/ul>\\n<h4> 2.2.0 <\\/h4>\\n<ul>\\n<li>Added: Google Map \\u2014 Route travel mode options<\\/li>\\n<li>Added: Global Tooltips \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Added: Global Tooltips \\u2014 z-index control in both element and global settings<\\/li>\\n<li>Added: Display Conditions \\u2014 Term archive condition<\\/li>\\n<li>Added: Display Conditions \\u2014 ACF conditions<\\/li>\\n<li>Added: Display Conditions \\u2014 POST and GET variable conditions<\\/li>\\n<li>Added: Timeline \\u2014 Custom Post Skin via Elementor templates<\\/li>\\n<li>Added: Timeline \\u2014 Replaced default query controls with related query controls<\\/li>\\n<li>Added: Timeline \\u2014 Trim custom excerpt control<\\/li>\\n<li>Added: Timeline \\u2014 Custom post skin<\\/li>\\n<li>Added: Posts Extra \\u2014 Date formatting controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Actions and filters<\\/li>\\n<li>Added: Calendar \\u2014 Actions and filters<\\/li>\\n<li>Added: Devices \\u2014 Actions<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Actions and filters<\\/li>\\n<li>Added: Scroll Indicator \\u2014 Custom html tags for title and subtitle in list skin<\\/li>\\n<li>Added: Custom implementation for Template controls<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Support for slick slider based widgets inside elements<\\/li>\\n<li>Fixed: Switcher \\u2014 Missing image link control<\\/li>\\n<li>Fixed: Timeline \\u2014 Markup improvement to allow for simpler border radius around cards<\\/li>\\n<li>Fixed: Timeline \\u2014 Custom icon replaces global if global is set<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Separator vertical alignment bug<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Icon migration markup issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Update elementor nerd box classes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom skins used on archive pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong access type for _query property<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Price conditions issue for area and editor panel section display<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Author and avatar metas additional controls conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Removed infinite scroll pages loaded limit<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Handle multiple paginations control condition bug<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Custom height control condition<\\/li>\\n<li>Fixed: Popup \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Fixed: Buttons \\u2014 Flip effect back is hidden during transition<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Remove useless icon and icon class filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Update button text filters to include \\/posts\\/<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default taxonomy order for filters<\\/li>\\n<\\/ul>\\n<h4> 2.1.8 <\\/h4>\\n<ul>\\n<li>Fixed: Missing elementor pro active condition<\\/li>\\n<\\/ul>\\n<h4> 2.1.7 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Order posts by custom fields<\\/li>\\n<li>Fixed: Calendar \\u2014 No events fetched when acf date field return format is different that display format<\\/li>\\n<li>Tweak: Better notices and plugin activation prevention for dependencies<\\/li>\\n<\\/ul>\\n<h4> 2.1.6 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Exclude category pages from previous current query fix<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom post skins used on archive pages<\\/li>\\n<\\/ul>\\n<h4> 2.1.5 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Filter for button link<\\/li>\\n<li>Added: Posts Extra \\u2014 Apply both \'button\' and \'add_to_cart\' filters to button<\\/li>\\n<li>Added: Audio Player \\u2014 Autoplay option<\\/li>\\n<li>Added: Support for new icon library in Elementor 2.6 in all widgets<\\/li>\\n<li>Added: Support for scaling SVG icon library assets when added to widgets<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to hide current page<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Template control not fetching results after Elementor Pro 2.6.0 update<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Body order on horizontal posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default query args prevent correct number of results on search templates<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters initially not working<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong hierarchical taxonomies order when using custom post types<\\/li>\\n<li>Fixed: Calendar \\u2014 Border radius overflow issue<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Progress not showing when shown below<\\/li>\\n<li>Fixed: Timeline \\u2014 Text align on tablet for RTL<\\/li>\\n<li>Fixed: Switcher \\u2014 Remove link image option when using overlay skin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where page scrolls up when panel closed on firefox<\\/li>\\n<li>Fixed: Video Player \\u2014 Play button not centered in edge cases<\\/li>\\n<li>Tweak: Search Form \\u2014 Tax query verification<\\/li>\\n<\\/ul>\\n<h4> 2.1.4 <\\/h4>\\n<ul>\\n<li>Fixed: Audio Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Video Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Search Form \\u2014 Undefined index notice<\\/li>\\n<li>Added: Offcanvas \\u2014 Custom select for the close button<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Separate control sections for title and close settings<\\/li>\\n<\\/ul>\\n<h4> 2.1.3 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Add to cart button alignment<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Pagination links on single templates<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Deprecated certain filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added button text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added add to cart text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Changed skin source terminology<\\/li>\\n<li>Tweak: Dissmisable admin licensing notices<\\/li>\\n<\\/ul>\\n<h4> 2.1.2 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 New Term Archive condition<\\/li>\\n<li>Added: Posts Extra \\u2014 Area ordering controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Add to cart button<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to use Elementor templates as custom skin for posts<\\/li>\\n<li>Added: Timeline \\u2014 Separate controls for dates in hover and focused state<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Force square avatar image<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove empty image wrapper when no image exists<\\/li>\\n<li>Fixed: Timeline \\u2014 Hover background color of arrow when focused<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show price if source is current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow Elementor custom image size<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive color controls<\\/li>\\n<\\/ul>\\n<h4> 2.1.1 <\\/h4>\\n<ul>\\n<li>Added: Tooltips \\u2014 Event for closing the tooltip by clicking anywhere<\\/li>\\n<li>Fixed: Buttons \\u2014 Text align when min width is set<\\/li>\\n<li>Tweak: Scroll Indicator \\u2014 Added options to select progress start and end calculation on scroll for sections<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Moved Infinite Scroll, Pagination and Filters activation controls to their respective sections.<\\/li>\\n<li>Tweak: Licensing \\u2014 Increase remote post request timeout value<\\/li>\\n<\\/ul>\\n<h4> 2.1.0 <\\/h4>\\n<ul>\\n<li>New Widget: Search Form \\u2014 Form widget with restrictions and filters<\\/li>\\n<li>New Widget: Scroll Indicator \\u2014 Create different types of scroll navigation indicators<\\/li>\\n<li>New Feature: Instagram \\u2014 Pull instagram feed to the Gallery widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Vertical carousel<\\/li>\\n<li>Added: Posts Extra \\u2014 New control to select breakpoint for collapsing horizontal post layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 Keep control to define page number limit for infinite scroll<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to not show the &quot;All&quot; filter<\\/li>\\n<li>Added: Posts Extra \\u2014 New control for Slides to Show and deprecated old control [ Settings Review Required ]<\\/li>\\n<li>Added: Posts Extra \\u2014 Exclude taxonomy terms from filters<\\/li>\\n<li>Added: Gallery \\u2014 New spacing control specifically for mixed masonry layout. [ Settings Review Required ]<\\/li>\\n<li>Added: Gallery Slider \\u2014 Control to hide thumbnails<\\/li>\\n<li>Added: Tooltips \\u2014 Mobile event listeners [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Responsive triggers and hide events [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Separate events for closing the tooltip [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 New offset control to adjust alignment of arrow tip to target<\\/li>\\n<li>Added: Devices \\u2014 Option for video to cover screen<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Hover colors controls<\\/li>\\n<li>Added: Calendar \\u2014 Disable links to posts<\\/li>\\n<li>Added: Calendar \\u2014 Add nofollow and open in new window on posts source<\\/li>\\n<li>Added: Buttons \\u2014 General padding control<\\/li>\\n<li>Added: Popup \\u2014 Horizontal align for inline trigger and popup close button<\\/li>\\n<li>Added: Notice for license domain mismatch<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute max values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Aligned column breakpoints to elementor default values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Better override default theme padding on post item<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS bug with overflow<\\/li>\\n<li>Fixed: Timeline \\u2014 Arrow color not working on frontend<\\/li>\\n<li>Fixed: Timeline \\u2014 Invalid code being generated in post css<\\/li>\\n<li>Fixed: Calendar \\u2014 Link target and nofollow<\\/li>\\n<li>Fixed: Devices \\u2014 Video controls conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Elementor Pro scrolling effect<\\/li>\\n<li>Fixed: Popup \\u2014 Dynamic css selector for trigger not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Link attributes in compact mode not working<\\/li>\\n<li>Fixed: Google Map \\u2014 Wrong value for default description tag<\\/li>\\n<li>Fixed: Google Map \\u2013 Set overflow to hidden to allow for advanced border radius setting<\\/li>\\n<li>Fixed: Switcher \\u2014 Rename effects section for compatibility with motion effects section name<\\/li>\\n<li>Fixed: Switcher \\u2014 Link to control should not be responsive<\\/li>\\n<li>Fixed: Unfold \\u2014 Bug with closing without focusing<\\/li>\\n<li>Fixed: Random Image \\u2014 Wrong caption<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Check correct condition value<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Text Label align controls<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Safari 12.1 CSS bug<\\/li>\\n<li>Fixed: Gallery \\u2014 Hover effects on mixed layout<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case js error<\\/li>\\n<li>Fixed: Remove duplicate empty template messages from editor panel<\\/li>\\n<li>Fixed: Check license data before mismatch check<\\/li>\\n<li>Fixed: Tooltips \\u2014 Bug with hide event prevent default<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow horizontal post layout independent of columns value<\\/li>\\n<li>Tweak: Gallery \\u2014 Better controls conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Moved settings in their own sections under Content<\\/li>\\n<li>Tweak: Gallery \\u2014 Control conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Better license management, notifications and performance<\\/li>\\n<li>Tweak: Remove extension default enable for sticky and parallax background<\\/li>\\n<li>Tweak: Remove custom panel alert classes and revert to elementor ones<\\/li>\\n<li>Tweak: Update docs and support links in extras admin pages<\\/li>\\n<li>Tweak: Streamline get_image_caption across all modules to avoid code redundancy<\\/li>\\n<li>Tweak: Toggle Element \\u2014 Better Label alignment controls<\\/li>\\n<li>Tweak: Popup \\u2014 Empty trigger css adjustments<\\/li>\\n<li>Tweak: Admin pages styles<\\/li>\\n<\\/ul>\\n<h4> 2.0.17 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Overlay horizontal alignment option<\\/li>\\n<li>Fixed: Timeline \\u2014 Icon showing twice<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default horizontal alignment to left<\\/li>\\n<\\/ul>\\n<h4> 2.0.16 <\\/h4>\\n<ul>\\n<li>Fixed: Include admin script only on extras pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL margins and arrows<\\/li>\\n<li>Fixed: Calendar \\u2014 RTL arrows<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Override current query posts per page with control setting<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel style section condition<\\/li>\\n<li>Added: Text Divider \\u2014 Control for alignment of text<\\/li>\\n<li>Added: Unfold \\u2014 Columns settings for content<\\/li>\\n<li>Added: Timeline \\u2014 New alignment controls to allow selecting layouts per breakpoint<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to align posts horizontally<\\/li>\\n<li>Tweak: Admin settings RTL<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive alignment controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive defaults for alignment controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.15 <\\/h4>\\n<ul>\\n<li>IMPORTANT: This version requires Elementor 2.5 or above<\\/li>\\n<li>IMPORTANT: If you have Elementor Pro, this version requires version 2.5 or above<\\/li>\\n<li>Added: Posts Extra \\u2014 Elementor Pro new related posts module with include \\/ exclude and date range<\\/li>\\n<li>Added: Circle Progress \\u2014 Option to turn off animation<\\/li>\\n<li>Added: Display Conditions \\u2014 Day of week condition<\\/li>\\n<li>Added: Video Player &amp; Devices \\u2014 Option to not hide bar when video is playing<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Unstick for 768px wide tablets<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Timeline \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust on resize in editor<\\/li>\\n<li>Fixed: Calendar \\u2014 Query compatibility with WPML<\\/li>\\n<li>Fixed: Hotspots \\u2014 Check spaces in hotspot links<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case where images don\'t display entirely<\\/li>\\n<li>Fixed: Timeline \\u2014 Correctly render dynamic tags<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Isotope on loading more posts when filter active<\\/li>\\n<li>Tweak: Video Player \\u2014 Automatically hide bar on mobile when playing<\\/li>\\n<\\/ul>\\n<h4> 2.0.14 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Option to select which item is active by default<\\/li>\\n<li>Fixed: Table \\u2014 Restrict cell max-width to msie<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Wrong arranging in some cases<\\/li>\\n<li>Fixed: Media Player text indicators wrapping<\\/li>\\n<\\/ul>\\n<h4> 2.0.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Carousel js error<\\/li>\\n<\\/ul>\\n<h4> 2.0.12 <\\/h4>\\n<ul>\\n<li>Added: Unfold \\u2014 Options to keep focus on content when folding or unfolding<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Make sure Gallery Extra is initiated when toggling<\\/li>\\n<li>Fixed: Table \\u2014 Min-width breakpoint bug<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Compatibility with Elementor 2.5<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues for panel<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Allow scroll on page not working<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Rare selector for anchors with link issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Rename css pulse animation<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Editor defaultView error<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust breakpoint values<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fallback to default wp posts per page option<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Make sure html element has auto height<\\/li>\\n<li>Tweak: Better wpml classes check<\\/li>\\n<\\/ul>\\n<h4> 2.0.11 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Trigger not closing after open<\\/li>\\n<li>Fixed: Posts \\u2014 Grid overlapping on safari when infinite scroll is enabled<\\/li>\\n<li>Fixed: Table \\u2014 Restrict IE hack to tablet and up<\\/li>\\n<li>Fixed: Get element settings on frontend in edit mode<\\/li>\\n<li>Fixed: Google Map \\u2014 Require resize plugin<\\/li>\\n<li>Added: Posts Extra \\u2014 Button border controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.10 <\\/h4>\\n<ul>\\n<li>Added: Parallax Elements \\u2014 Option to allow moving elements when they aren\'t visible inside viewport<\\/li>\\n<li>Fixed: Google Map \\u2014 Centering with dynamic tags not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Don\'t limit number of posts fetched<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Chrome check failing<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Responsive item aligning<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Custom size control compatibility + tweaks<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Type control condition<\\/li>\\n<li>Tweak: Google Map \\u2014 Disable fitting and centering when route is enabled<\\/li>\\n<\\/ul>\\n<h4> 2.0.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Handle multiple paginated loops<\\/li>\\n<li>Added: Posts Extra \\u2014 Nothing found message<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to turn off animation on entrance<\\/li>\\n<li>Added: Posts Extra \\u2014 Query ID filter on top of elementor pro one<\\/li>\\n<li>Added: Offcanvas \\u2014 Control to enable page scroll when offcanvas panel is open<\\/li>\\n<li>Fixed: Table \\u2014 IE cell text wrapping<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute value when multiple widget instances on same page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Wrong thumbnail order<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues<\\/li>\\n<li>Fixed: Calendar \\u2014 Convert timestamp to integer<\\/li>\\n<li>Fixed: Gallery module attachment check<\\/li>\\n<li>Tweak: Timeline \\u2014 Rename timeline script<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive row spacing control<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Compatibility with Elementor 2.4<\\/li>\\n<\\/ul>\\n<h4> 2.0.8 <\\/h4>\\n<ul>\\n<li>Fixed: Text Divider \\u2014 Selector for link color<\\/li>\\n<li>Fixed: Timeline \\u2014 Notice<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Escape jquery expression<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle invalid or undefined snazzy map style<\\/li>\\n<\\/ul>\\n<h4> 2.0.7 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Anchor navigation scroll calculation<\\/li>\\n<li>Added: Timeline \\u2014 Allow post content to be shown instead of excerpt<\\/li>\\n<li>Added: Timeline \\u2014 Control to set line progress position relative to viewport<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Anchor condition<\\/li>\\n<\\/ul>\\n<h4> 2.0.6 <\\/h4>\\n<ul>\\n<li>Fixed: Popup \\u2014 Duplicate tab control name<\\/li>\\n<li>Fixed: Popup \\u2014 Remove rtl suffix<\\/li>\\n<li>Added: Offcanvas \\u2014 Global control for offcanvas container background color<\\/li>\\n<\\/ul>\\n<h4> 2.0.5 <\\/h4>\\n<ul>\\n<li>Added: Editor panel labels for widgets<\\/li>\\n<li>Added: Calendar \\u2014 Control to customise month names<\\/li>\\n<li>Added: Offcanvas \\u2014 Link navigate to anchors on page<\\/li>\\n<li>Added: Popup \\u2014 Text trigger styling controls<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Multiple svgs have same settings<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 No parent custom taxonomy terms render all terms<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP notice<\\/li>\\n<li>Tweak: Updated language file<\\/li>\\n<\\/ul>\\n<h4> 2.0.4 <\\/h4>\\n<ul>\\n<li>Fixed: Display Conditions \\u2014 Editor section for sections actions<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Conditions evaluation per element<\\/li>\\n<\\/ul>\\n<h4> 2.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Popup Display Conditions \\u2014 Check widget visibility before opening automatically<\\/li>\\n<li>Fixed: Table \\u2014 First row has no classes<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle no snazzy maps selection<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Wrong default keys resulting in wrong display<\\/li>\\n<li>Fixed: Audio Player \\u2014 Border type selector<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Position structured data property<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Parallax column affecting child columns<\\/li>\\n<li>Fixed: Devices \\u2014 Image extending outside the widget area<\\/li>\\n<li>Fixed: Popup \\u2014 Move font family to pseudo-element<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Sub-menu links not working with link navigation turned on<\\/li>\\n<li>Tweak: Rename infinite-scroll script<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Increase typography selector specificity<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Additional conditions for areas style sections<\\/li>\\n<li>Remove widget disabling admin notif<\\/li>\\n<li>Update Wordpress stable tag to 5.0.0<\\/li>\\n<\\/ul>\\n<h4> 2.0.2 <\\/h4>\\n<ul>\\n<li>Added: New Query Control<\\/li>\\n<li>Added: Display Conditions \\u2014 Ajax powered fields<\\/li>\\n<li>Added: Display Conditions \\u2014 Current post condition<\\/li>\\n<li>Fixed: Switcher \\u2013 Autoplay not working without entrance animation<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Custom taxonomy archive crumbs<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added option for external sources<\\/li>\\n<\\/ul>\\n<h4> 2.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Google Map \\u2014 Navigation z-index<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default button position to hidden<\\/li>\\n<li>Fixed: Devices \\u2014 Video in window frame not displaying<\\/li>\\n<li>Fixed: Google Map \\u2014 JSON incorrectly reported as invalid<\\/li>\\n<li>Fixed: Switcher \\u2014 Cover picture tag with CSS<\\/li>\\n<li>Fixed: Devices \\u2014 Video css for browser frame<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button transition control<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button border control<\\/li>\\n<li>Added: Hotspots \\u2014 Individual hover controls for each hotspot<\\/li>\\n<li>Added: Audio Player \\u2014 Option to loop playlist<\\/li>\\n<li>Tweak: Google Map \\u2014 Make fields dynamic<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added custom js events<\\/li>\\n<li>Tweak: Audio Player \\u2014 Separate control for play icon size<\\/li>\\n<li>Tweak: Video Player \\u2014 Added custom js events<\\/li>\\n<\\/ul>\\n<h4> 2.0.0 <\\/h4>\\n<ul>\\n<li>New Extension: Display Conditions<\\/li>\\n<li>New Widget: Google Map<\\/li>\\n<li>New Widget: Popup<\\/li>\\n<li>New Widget: Age Gate<\\/li>\\n<li>New Widget: Toggle Element<\\/li>\\n<li>New Widget: Calendar<\\/li>\\n<li>New Widget: Audio Player<\\/li>\\n<li>New Widget: Offcanvas<\\/li>\\n<li>New Widget: Slide Menu<\\/li>\\n<li>New Widget: Random Image<\\/li>\\n<li>Added: Posts Extra \\u2014 Support for terms from multiple taxonomies<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Include blog posts page in breadcrumbs<\\/li>\\n<li>Added: Switcher \\u2014 New option to add description<\\/li>\\n<li>Added: Sticky Elements \\u2014 Completely rewritten code<\\/li>\\n<li>Added: Sticky Elements \\u2014 Offset bottom control<\\/li>\\n<li>Added: Global Tooltips \\u2014 Control to disable on breakpoint<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to show taxonomy terms for custom post types instead of CPT name<\\/li>\\n<li>Added: Tooltips \\u2014 New trigger on page load<\\/li>\\n<li>Added: Switcher \\u2014 Events to update when inside toggle element<\\/li>\\n<li>Added: Posts Extra \\u2014 Price meta for woocommerce products<\\/li>\\n<li>Added: Posts Extra \\u2014 Button content part replaces read more<\\/li>\\n<li>Added: Posts Extra \\u2014 Post count for filters<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Schema.org properties<\\/li>\\n<li>Fixed: Tooltips \\u2014 Add option to disable on breakpoint<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Destroy on editor mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Out of view sections have wrong background image positions<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Settings not being saved<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Start position option not applying<\\/li>\\n<li>Fixed: Hotspots \\u2014 Image display block<\\/li>\\n<li>Fixed: Unfold \\u2014 Button alignment<\\/li>\\n<li>Fixed: Unfold \\u2014 Button icon position and indent<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Check for woocommerce for price fields<\\/li>\\n<li>Fixed: Video Player \\u2014 Volume size undefined error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 RTL behviour on clicking thumbs<\\/li>\\n<li>Fixed: Inline SVG \\u2014 ACF image field<\\/li>\\n<li>Fixed: Update to getEditModel method<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: License not deactivating if expired<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Distance for top-aligned labels<\\/li>\\n<li>Fixed: Devices + Hotspots \\u2014 Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: Switcher \\u2014 Astra theme images css conflict<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Multiple hierarchical categories not showing<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filtered posts not found message<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong grid item width when filters are active and multiple instances on page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Breacrumbs \\u2014 Wrap crumbs automatically<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Hide fields not available for Current Query option<\\/li>\\n<li>Tweak: Hotspots \\u2014 Default hotspots for better ux<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better behaviour and interactions for video player<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better selection of video source files<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Added playback speed option<\\/li>\\n<li>Tweak: Timeline \\u2014 Support for point numbers and letter for posts<\\/li>\\n<li>Tweak: Table \\u2014 Remove render template to improve editing performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Add bottom margin to custom spacing control<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Increase options for carousel rows and slides to scroll<\\/li>\\n<li>Tweak: Enable docs link in admin settings page<\\/li>\\n<li>Tweak: Switcher \\u2014 Make description field dynamic<\\/li>\\n<li>Tweak: Google Maps \\u2013 Adjust controls structure<\\/li>\\n<li>Tweak: Table \\u2014 Control names<\\/li>\\n<li>Tweak: Text Divider \\u2014 Controls position<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added read more to translatable fields for WPML<\\/li>\\n<\\/ul>\\n<h4> 1.9.16 <\\/h4>\\n<ul>\\n<li>Fixed: Elementor 2.3.0 compatibility<\\/li>\\n<\\/ul>\\n<h4> 1.9.15 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Load more button for multiple widget instances<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Responsive speed options<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Columns above 9 don\'t become full width<\\/li>\\n<li>Tweak: Improve Elementor Pro version dependency and posts widget compatibility<\\/li>\\n<li>Tweak: Timeline \\u2014 Enable dynamic fields for custom source<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Handling of divisions operation in value control<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Option to allow numbers with decimals instead of percetanges<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Options to allow for absolute values to be shown<\\/li>\\n<li>Tweak: Hotspots \\u2014 Make hotspots size and opacity control responsive<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove swiper slide overflow hidden<\\/li>\\n<li>Tweak: Added option to enable updates to beta versions or Extras<\\/li>\\n<\\/ul>\\n<h4> 1.9.14 <\\/h4>\\n<ul>\\n<li>Fixed: Rename resize script to avoid potential conflicts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel flickering when used in Tabs widget and switching tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Date showing current date instead of post date<\\/li>\\n<li>Fixed: Extras admin page conflict with Jetpack<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Link not accessible for preview images with caption<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added query id control for server side filtering of widget queries<\\/li>\\n<li>Tweak: Hotspots \\u2014 HTML valid structure issue<\\/li>\\n<li>Tweak: Table \\u2014 Minor terminology improvements<\\/li>\\n<\\/ul>\\n<h4> 1.9.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Space under image<\\/li>\\n<li>Fixed: Extensions not showing when Elementor Pro not active<\\/li>\\n<\\/ul>\\n<h4> 1.9.12 <\\/h4>\\n<ul>\\n<li>Added: CSS filter controls for widgets<\\/li>\\n<li>Added: Global Tooltips \\u2014 Support for shortcodes and dynamic fields<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Load more button causing error when not paginated<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Content inside media not showing when no thumbnail available<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Media area display conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP warning when excerpt length is empty<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL alignment of posts in masonry mode<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Default control value to string<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Dynamic fields values not working<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Window height calculation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Repeater fields conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Breaks when dynamic field is used<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Allow offset to be used in current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow drafts and scheduled posts to be included<\\/li>\\n<\\/ul>\\n<h4> 1.9.11 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts compatibility with pagination<\\/li>\\n<li>Fixed: Compatibility with new Swiper version in Elementor 2.1<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive date padding and margin controls<\\/li>\\n<\\/ul>\\n<h4> 1.9.10 <\\/h4>\\n<ul>\\n<li>Fixed: Sticky Elements \\u2014 Options appear twice<\\/li>\\n<li>Tweak: Remove group control sticky<\\/li>\\n<\\/ul>\\n<h4> 1.9.9 <\\/h4>\\n<ul>\\n<li>Fixed: Timeline \\u2014 Points and line not aligned on mobile and tablet if size defined only on desktop<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default placeholder image overriding post thumbnail<\\/li>\\n<li>Fixed: Sticky Elements no longer working<\\/li>\\n<li>Fixed: Additional check for active Elementor Pro<\\/li>\\n<li>Tweak: Moved Extras advanced section behind Custom CSS section<\\/li>\\n<\\/ul>\\n<h4> 1.9.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Arrows controls for preview<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to show all filters when using infinite scroll<\\/li>\\n<li>Fixed: Unfold \\u2014 Icon right align not working<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.1 beta<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow excerpt in media area<\\/li>\\n<li>Tweak: Timeline \\u2014 More specific color selectors<\\/li>\\n<li>Tweak: Timeline \\u2014 Text align dates to the right for right hand items<\\/li>\\n<\\/ul>\\n<h4> 1.9.7 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Implemented work-around for warning caused by Elementor bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 images bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Time not showing<\\/li>\\n<li>Fixed: Buttons \\u2014 Wrap buttons by default<\\/li>\\n<li>Fixed: Remove too broad css declaration<\\/li>\\n<li>Fixed: Parallax background \\u2014 Correct element resize function name<\\/li>\\n<\\/ul>\\n<h4> 1.9.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Breaks if pan distance is undefined<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Read more typography control conditions<\\/li>\\n<li>Fixed: Unfold \\u2014 Force icon to show hide as inline block<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Stretch body to align all footers to bottom<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 horizontal layout for posts<\\/li>\\n<li>Fixed: Renamed jquery resize plugin function<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 CSS overflow fix<\\/li>\\n<\\/ul>\\n<h4> 1.9.5 <\\/h4>\\n<ul>\\n<li>Added: Dynamic fields support for all widgets<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Position not being overriden<\\/li>\\n<li>Fixed: Timeline \\u2014 Pointer cursor not showing on linked cards<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image bottom spacing on some themes<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Added unique classes to each item<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added control to enable muted video for autoplay<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added controls to enable or disable all elements inside the bar<\\/li>\\n<\\/ul>\\n<h4> 1.9.4 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Control to center images<\\/li>\\n<li>Added: Posts Extra \\u2014 New filters for post title, excerpt, comments and date<\\/li>\\n<li>Added: HTML5 Video \\u2014 Control to stop all other video players when current one is played.<\\/li>\\n<li>Fixed: Fixed: Column widths in post-css are rendered in the wrong order<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Posts per page doesn\'t take into account sticky posts<\\/li>\\n<li>Fixed: Buttons \\u2014 Item typography group control not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Responsive horizontal alignment for filters<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltip position not being overriden at hotspot level<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Control conditions<\\/li>\\n<li>Tweak: Updated isotope version to 3.0.6 to fix 1px grid gap<\\/li>\\n<li>Tweak: Remove default webkit left padding from list navs<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Increase plugin timeout reinit<\\/li>\\n<li>Tweak: Posts \\u2014 Increase excerpt length filter priority<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added option to show only sticky posts<\\/li>\\n<\\/ul>\\n<h4> 1.9.3 <\\/h4>\\n<ul>\\n<li>Added: Sticky Elements \\u2014 Compatibility with the Lazy Loader wordpress plugin<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Safari &lt; 10.2 layout glitch layout glitch on mobile<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v files condition<\\/li>\\n<li>Fixed: Sticky \\u2014 Sticks only when resizing browser window<\\/li>\\n<li>Fixed: Sticky \\u2014 Not working correctly with Stretched parent<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v format not sufficient<\\/li>\\n<li>Fixed: Image Comparison \\u2013 Allow 0 percent values<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Render attributes<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Control conditions<\\/li>\\n<\\/ul>\\n<h4> 1.9.2 <\\/h4>\\n<ul>\\n<li>Fixed: Switcher \\u2014 Bug with arrow loader position and stroke width in older versions of Safari<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with IE 11<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Control value undefined check<\\/li>\\n<\\/ul>\\n<h4> 1.9.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Max distance not taking into account scroll position<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters not stacking on responsive.<\\/li>\\n<li>Fixed: Switcher \\u2014 Arrow loader not displaying in firefox<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Wrong position for scroll with start position<\\/li>\\n<li>Fixed: GSAP dependencies<\\/li>\\n<\\/ul>\\n<h4> 1.9.0 <\\/h4>\\n<ul>\\n<li>Added: New Switcher Widget! \\u2014 Switch photos and text using powerful javascript driven transitions. Features menu and arrows navigation, autoplay with progress loader, entrance animations, page background color switcher, two skins (default and overlay) and much more.<\\/li>\\n<li>Added: New Feature for Parallax Elements! \\u2014 Option to parallax columns and widgets on mouse move<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to style only sticky posts<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable clicking on labels to uncover images<\\/li>\\n<li>Added: Hotspots \\u2014 Separate color controls for each hotspot<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts not working when a category is selected in the query<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Invisible gallery when preview position is top on desktop<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove labels if no text is present<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Hide carousel until properly rendered<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Added alt and title tags to image element<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Issue with negative margin resulting in right whitespace for the gallery<\\/li>\\n<li>Fixed: Timeline \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Timeline \\u2014 Item point color override<\\/li>\\n<li>Fixed: Timeline \\u2014 Properly override point content<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Removed group control<\\/li>\\n<li>Tweak: Gallery Extra, Gallery Slider, Posts Extra \\u2014 Added notice with link to blend mode browser support for blend mode controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Added repeater setting key method to card render function<\\/li>\\n<\\/ul>\\n<h4> 1.8.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Control width and ratio of each individual image in manual mode<\\/li>\\n<li>Added: Timeline \\u2014 Option for automatic numbering and letters instead of icons to points<\\/li>\\n<li>Added: Timeline \\u2014 New control to set excerpt length<\\/li>\\n<li>Added: Unfold \\u2014 Option to change icon when unfolded<\\/li>\\n<li>Added: Sticky Elements \\u2014 Option to turn off bottoming of elements inside the parent<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to enable sticky posts in query<\\/li>\\n<li>Added: Posts Extra \\u2014 Arrows sizing controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Transition control for carousel arrows and pagination<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to set how many slides to scroll<\\/li>\\n<li>Added: Image Comparison \\u2014 Control to define initial position of separator<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable moving separator by clicking anywhere on the image<\\/li>\\n<li>Added: Buttons \\u2014 Control for label min width<\\/li>\\n<li>Added: Hotspots \\u2014 Control to disable pulsating animation<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Controls not showing on inner sections<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Images wider than 100% on mobile in manual mixed masonry layout mode<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 CSS bottom whitespace<\\/li>\\n<li>Fixed: Buttons \\u2014 Remove block label for buttons icon, id and class controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Take sticky posts into consideration in query<\\/li>\\n<li>Tweak: Unfold \\u2014 Organise controls<\\/li>\\n<li>Tweak: WPML Compatibility \\u2014 Change method to fix fields not saving<\\/li>\\n<\\/ul>\\n<h4> 1.8.7 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Filtering one widget\'s posts affects all other widgets<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips have an extra space at the bottom when first hovering<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Volume functionality breaks when controls are hidden<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Video reloading after each loop<\\/li>\\n<li>Added: Global Tooltips \\u2014 Global controls for distance and width<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added width and horizontal alignment control to player<\\/li>\\n<li>Tweak: Global Tooltips \\u2014 Remove default global styling values after Elementor enqueue fix in 1.9.5<\\/li>\\n<\\/ul>\\n<h4> 1.8.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Term slug classes to filters and post terms<\\/li>\\n<li>Fixed: Replaced create_function with anonymous function for PHP 7.2 support<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Handle internal CSS in non color overriding situations<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips showing even if they have no content<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Prevent sticky on a section that is stretched with js<\\/li>\\n<li>Tweak: Buttons \\u2014 Move typography control above tabs<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Move hover animation controls to separate section for better ux<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Default font size for thumbnail captions<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fix condition<\\/li>\\n<li>Tweak: Hotspots \\u2014 Show label for tooltip content in editor<\\/li>\\n<\\/ul>\\n<h4> 1.8.5 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Missing js dependency<\\/li>\\n<\\/ul>\\n<h4> 1.8.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Random ordering not working<\\/li>\\n<li>Fixed: Timeline \\u2014 RTL optimisation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Custom image size not working on manual mode<\\/li>\\n<li>Tweak: Add dismissible notice for recommended php version<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Add title and description caption types<\\/li>\\n<li>Tweak: Timeline \\u2014 Add link control description to avoid linking cards when content already contains links<\\/li>\\n<\\/ul>\\n<h4> 1.8.3 <\\/h4>\\n<ul>\\n<li>Fixed: HTML5 Video \\u2014 Video not playing on Safari and some mobile environments<\\/li>\\n<li>Fixed: Buttons \\u2014 Safari buttons vertical alignment<\\/li>\\n<li>Fixed: Devices \\u2014 device not displaying on Safari when portrait mode is enabled<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Grid broken on Safari<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 reinit masonry when images done loading<\\/li>\\n<li>Tweak: Move all Extras admin settings into Elementor menu<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Remove default value for width control<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 default mobile and tablet gallery columns to larger numbers<\\/li>\\n<\\/ul>\\n<h4> 1.8.2 <\\/h4>\\n<ul>\\n<li>Added: Parallax Background \\u2014 Support for section resize in elementor preview mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Compatibility with stretched section<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Interface style controls conditions<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Right side white-space after thumbnails on top preview position<\\/li>\\n<li>Fixed: Unfold \\u2014 Page stops responding when entering invalid html in text editor mode<\\/li>\\n<li>Tweak: Unfold \\u2014 Allow accordions, tabs and all resizing elements inside content<\\/li>\\n<\\/ul>\\n<h4> 1.8.1 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Masonry broken when infinite scroll is enabled<\\/li>\\n<\\/ul>\\n<h4> 1.8.0 <\\/h4>\\n<ul>\\n<li>New extension: Global Tooltips \\u2014 Add a tooltip to any widget<\\/li>\\n<li>New: Disable Widgets &amp; Extensions \\u2014 You can now disable Extras widgets and extensions via the admin settings page<\\/li>\\n<li>Added: WPML compatibility \\u2014 String Translation and Translation Editor support for all widgets<\\/li>\\n<li>Added: Circle Progress \\u2014 Icon support inside circle<\\/li>\\n<li>Added: Update .pot translation file<\\/li>\\n<li>Added: Buttons \\u2014 Tooltips duration control<\\/li>\\n<li>Added: Global settings for Extras tooltips<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Widget not available on multisite installations<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll breaks when using multiple widgets on same page<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Anywhere Elementor Pro featured image background<\\/li>\\n<li>Tweak: Parallax Background \\u2014 requestAnimationFrame method for better performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Rename text align label<\\/li>\\n<li>Tweak: Update nicons font<\\/li>\\n<\\/ul>\\n<h4> 1.7.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Custom link broken and attributes not added<\\/li>\\n<\\/ul>\\n<h4> 1.7.3 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Column vertical alignment controls for carousel<\\/li>\\n<li>Added: Timeline \\u2014  Color controls for post title and excerpt<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel rows number control not impacting preview<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar vertical alignment on stretched media content<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Incorrect spacer height<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improve editing flow by with advanced controls conditioning<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Controls position<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Remove popover from group control<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Remove popover from group control<\\/li>\\n<\\/ul>\\n<h4> 1.7.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Overlay captions for preview and thumbnails<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for caption effects, layout and hover properties<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for active thumbs caption<\\/li>\\n<li>Fixed: Buttons \\u2014 Removed popover control on effects<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved carousel adapt on preview resize<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved thumbnails grid<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better controls for stacking and position of preview<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Replace background color with background control for preview captions and overlay<\\/li>\\n<li>Tweak: Gallery Slider + Gallery Extra \\u2014 Better BEM classes<\\/li>\\n<\\/ul>\\n<h4> 1.7.1 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Ratio and alignment controls to masonry layout<\\/li>\\n<li>Added: Gallery Extra \\u2014 New border and border radius controls for captions<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Bring image to front when hovered<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Images not displaying on infinite load on iOS Safari and Chrome<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Force override of modified image max-width attribute<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added extra classes to media elements<\\/li>\\n<\\/ul>\\n<h4> 1.7.0 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Masonry layout with mixed mode<\\/li>\\n<li>Added: Gallery Extra \\u2014 Tilt effect<\\/li>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay, caption and image transition controls<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay blend mode control<\\/li>\\n<li>Added: Gallery Extra \\u2014 Image scale controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay margin controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Manual mode that allows entering of every image manually and linking it to any URL<\\/li>\\n<li>Added: Inline SVG widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to disable linking for post title, media and terms<\\/li>\\n<li>Added: Posts Extra \\u2014 Control to select default applied filter for filter bar<\\/li>\\n<li>Added: Timeline \\u2014 New controls for post title typography and spacing, post excerpt typography and padding<\\/li>\\n<li>Added: Image Comparison \\u2014 Image size control<\\/li>\\n<li>Added: New css transition control for Gallery Extra, Gallery Slider, Hotspots, Posts Extra, Timeline, Table and Inline SVG widgets<\\/li>\\n<li>Added: HTML5 Video \\u2014 M4V format support<\\/li>\\n<li>Added: Devices \\u2014 M4V format support for video<\\/li>\\n<li>Fixed: Buttons \\u2014 Flicker on flip effect<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS class conflict<\\/li>\\n<li>Fixed: Table \\u2014 ID and class don\'t apply to header<\\/li>\\n<li>Tweak: Improved Elementor 1.9 compatibility for Extras group controls<\\/li>\\n<li>Tweak: Update TweenMax to latest version (1.20.2)<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Simplified CSS<\\/li>\\n<li>Tweak: Unfold \\u2014 Disconnect button and content from control alignment logic<\\/li>\\n<\\/ul>\\n<h4> 1.6.3 <\\/h4>\\n<ul>\\n<li>Fixed: Breadcrumbs \\u2014 Display correctly when used within an Elementor library template<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Condition terms separator<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Avoid naming conflict with Elementor Pro widget<\\/li>\\n<\\/ul>\\n<h4> 1.6.2 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 New autoplay, autoheight and fade effect controls<\\/li>\\n<li>Added: Posts Extra \\u2014 &quot;Top&quot; option to media position on horizontal layout<\\/li>\\n<li>Added: Posts Extra \\u2014 Allowed media to be positioned horizontally on 2 columns layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 New border controls for media<\\/li>\\n<li>Added: Table \\u2014 Allow table responsive behaviour to be turned off<\\/li>\\n<li>Tweak: Buttons \\u2014 Default button content alignment to justify<\\/li>\\n<li>Fix: Timeline \\u2014 Potential fatal error<\\/li>\\n<li>Fix: Posts Extra \\u2014 Post media position controls conditions<\\/li>\\n<li>Fix: Buttons \\u2014 Delay on transitioned properties<\\/li>\\n<li>Fix: Posts Extra \\u2014 Wrong tablet breakpoint set for number of columns<\\/li>\\n<li>Fix: Parallax Background \\u2014 Remove initial background image once parallax is activated<\\/li>\\n<\\/ul>\\n<h4> 1.6.1 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Link author name and avatar to author posts pages<\\/li>\\n<li>Added: Posts Extra \\u2014 Read more link to excerpt<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added separate hide option for Position for better UX <\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improved position icons<\\/li>\\n<\\/ul>\\n<h4> 1.6.0 <\\/h4>\\n<ul>\\n<li>New Widget \\u2014 Posts Extra - Create ANY layout for posts with masonry, infinite load, filtering and custom post type support. Works only with Elementor Pro<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Added horizontal position and text alignment controls<\\/li>\\n<li>Tweak: Buttons \\u2014 Improved CSS and better alignment and stacking options<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Error outputting separator<\\/li>\\n<li>Fixed: Buttons \\u2014 Transition on button content when effects are turned on<\\/li>\\n<\\/ul>\\n<h4> 1.5.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Replaced parallax class name to avoid future conflicts<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove flex from left aligned timeline and allow image spacing for horizontal layouts<\\/li>\\n<li>Fixed: PHP fatal error<\\/li>\\n<li>Tweak: Unfold \\u2014 Switched Settings with Content sections in editor for better UX<\\/li>\\n<\\/ul>\\n<h4> 1.5.5 <\\/h4>\\n<ul>\\n<li>Added: Buttons \\u2014 Inline editing<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Inline editing<\\/li>\\n<li>Added: Circle Progress \\u2014 Inline editing<\\/li>\\n<li>Added: Hotspots \\u2014 Inline editing<\\/li>\\n<li>Added: Image Comparison \\u2014 Inline editing<\\/li>\\n<li>Added: Table \\u2014 Inline editing<\\/li>\\n<li>Added: Text Divider \\u2014 Inline editing<\\/li>\\n<li>Added: Timeline \\u2014 Inline editing<\\/li>\\n<li>Added: Unfold \\u2014 Inline editing<\\/li>\\n<li>Fixed: Tooltips \\u2014 Error &quot;size&quot; of undefined appears for delay_in in some cases<\\/li>\\n<li>Fixed: Unfold \\u2014 Issue that resulted in wrong calculation of unfolded height<\\/li>\\n<li>Tweak: Default to text cursor for text where inline editing is available<\\/li>\\n<\\/ul>\\n<h4> 1.5.4 <\\/h4>\\n<ul>\\n<li>Added: HTML5 Video \\u2014 Option to end video at last frame<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Removed auto pausing when interacting with progress bar<\\/li>\\n<\\/ul>\\n<h4> 1.5.3 <\\/h4>\\n<ul>\\n<li>Fixed: Unfold \\u2014 Content folds back automatically when scrolling on mobile browsers that vertically resize the viewport<\\/li>\\n<\\/ul>\\n<h4> 1.5.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Allow gallery navigation in lightbox<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image box shadow not applying<\\/li>\\n<li>Fixed: Buttons \\u2014 Issue with transition delays on buttons without effects<\\/li>\\n<\\/ul>\\n<h4> 1.5.1 <\\/h4>\\n<ul>\\n<li>Added: Table \\u2014 Control to show header on mobile as a block or a column<\\/li>\\n<li>Added: Table \\u2014 Border control for table rows<\\/li>\\n<li>Added: Table \\u2014 Option to automatically try to fetch correct headers for mobile with override possibility<\\/li>\\n<li>Added: Table \\u2014 Control to set width for mobile headers<\\/li>\\n<li>Tweak: Table \\u2014 Remove column rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Removed first \\/ last child border rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Added pointer cursor on sortable header cells<\\/li>\\n<li>Tweak: Table \\u2014 Moved padding to text for better handling of responsive layout and removed negative margin technique<\\/li>\\n<li>Tweak: Table \\u2014 Responsive cells and header cells padding controls<\\/li>\\n<li>Tweak: Table \\u2014 Move cell header control to top<\\/li>\\n<li>Tweak: Table \\u2014 Added option to hide headers completely on mobile<\\/li>\\n<li>Tweak: Table \\u2014 Hide mobile headers that have no content<\\/li>\\n<li>Tweak: Sticky \\u2014 Set default z-index to 1 for stickable elements<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Separator not showing<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove space between images and widget container<\\/li>\\n<li>Fixed: Table \\u2014 PHP Warning when allowing empty on repeater fields<\\/li>\\n<li>Fixed: Table \\u2014 Width and alignment not working<\\/li>\\n<li>Fixed: Table \\u2014 Added missing custom class and id from markup<\\/li>\\n<\\/ul>\\n<h4> 1.5.0 <\\/h4>\\n<ul>\\n<li>New Widget: Table<\\/li>\\n<li>Fixed: Prefix CSS helper classes to avoid potential conflicts<\\/li>\\n<\\/ul>\\n<h4> 1.4.0 <\\/h4>\\n<ul>\\n<li>New: Buttons Effects<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Control to manually specify which post or page to generate breadcrumbs for<\\/li>\\n<li>Fixed: Devices \\u2014 Horizontal orientation image not visible<\\/li>\\n<\\/ul>\\n<h4> 1.3.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Wrong position when loading page off viewport<\\/li>\\n<li>Fixed: Timeline \\u2014 Enlarged points not aligned to line on tablet and mobile<\\/li>\\n<li>Added: Timeline \\u2014 Responsive controls for point size and icon size<\\/li>\\n<\\/ul>\\n<h4> 1.3.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 HTML5 Video<\\/li>\\n<li>Added: Devices \\u2014 Added HTML5 Video controls<\\/li>\\n<li>Added: Devices \\u2014 Added option to stretch the video to fit into the device screen<\\/li>\\n<li>Added: Devices \\u2014 Added option to choose wether or not to stop the video when leaving viewport<\\/li>\\n<li>Added: Timeline \\u2014 Hover properties for points<\\/li>\\n<li>Added: Timeline \\u2014 More style override options for each card<\\/li>\\n<li>Added: Gallery Slider \\u2014 More responsive controls for preview position and spacing<\\/li>\\n<li>Fixed: Timeline \\u2014 Removed unnecessary z-index from cards<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Preview spacing doesn\'t work on mobile when the layout is vertical<\\/li>\\n<li>Fixed: Devices \\u2014 Replaced SVG IDs with classes to avoid code invalidation<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Canvas distorted on responsive<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links concatenating from one repeater field to another<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Images move up after scrolling up and down multiple times<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Background position is off when section Stretch is turned on<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links inside tooltips appear outside of the tooltip<\\/li>\\n<li>Tweak: Timeline \\u2014 Changed &quot;Size Ratio&quot; name to &quot;Scale&quot;<\\/li>\\n<li>Tweak: Gallery Extras \\u2014 Bring 3D items to front on hover<\\/li>\\n<li>Tweak: Hotspots \\u2014 Moved tooltip content outside hotspot to avoid invalid nodes<\\/li>\\n<li>Tweak: Hotspots \\u2014 Don\'t activate tooltips that have no content set<\\/li>\\n<\\/ul>\\n<h4> 1.2.5 <\\/h4>\\n<ul>\\n<li>Tweak: Replaced text align icons with horizontal align icons where appropriate<\\/li>\\n<li>Fixed: Sticky elements not bottoming out correctly when using custom parent selector<\\/li>\\n<li>Fixed: Removing unstick for any breakpoint would break sticky functionality<\\/li>\\n<\\/ul>\\n<h4> 1.2.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky \\u2014 Custom selector for sticky parent to allow for elements to stick in any parent element<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive padding controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Refactoring and improved performance and accuracy on progress bar<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Adjust spacing method for labels and vertical alignment improvements<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Allow for widget border radius control to affect images<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Scroll breaks on mobile when hiding a parallaxed section<\\/li>\\n<li>Fixed: Timeline \\u2014 Cards not animating when first in view<\\/li>\\n<li>Fixed: Timeline \\u2014 Content wrapper present even if no card content is set<\\/li>\\n<\\/ul>\\n<h4> 1.2.3 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Section background not reverting after parallax turned on again<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Calculating wrong dimensions when using Elementor JS stretch option<\\/li>\\n<li>Fixed: Issue where updating Elementor when Extras is active would result in an error<\\/li>\\n<li>Tweak: Hotspots \\u2014 Adjusted default tooltip width<\\/li>\\n<\\/ul>\\n<h4> 1.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Complete html support<\\/li>\\n<\\/ul>\\n<h4> 1.2.1 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Gradient would show only for the first line<\\/li>\\n<li>Fixed: Parallax Background \\u2014 When using padding on sections, image position calculation would not be correct<\\/li>\\n<\\/ul>\\n<h4> 1.2.0 <\\/h4>\\n<ul>\\n<li>Added: New Feature! \\u2014 Parallax Background \\u2014 Now you can parallax section backgrounds and have it move up, down, left or right while scrolling<\\/li>\\n<li>Added: New Widget! \\u2014 Unfold \\u2014 Lets you hide content and reveal it on demand<\\/li>\\n<li>Added: New Widget! \\u2014 Breadcrumbs<\\/li>\\n<li>Added: Parallax Elements \\u2014 Allow to select whether to parallax an element relative to its own position or the middle of the viewport<\\/li>\\n<li>Added: Hotspots \\u2014 Ability to add links to hotspots if tooltips are triggered on hover<\\/li>\\n<li>Added: Tooltips \\u2014 Added left and right tooltips for both Hotspots and Button Groups<\\/li>\\n<li>Added: Tooltips \\u2014 Better handling of repositioning tooltips when they flow outside of the viewport<\\/li>\\n<li>Added: Tooltips \\u2014 Ability to override tooltip position for each button of hotspot individually<\\/li>\\n<li>Added: Heading Extra \\u2014 Text fill now supports clipped images<\\/li>\\n<li>Tweak: Heading Extra \\u2014 Allow to have both text shadow and long shadow on the same text<\\/li>\\n<li>Tweak: Text Divider \\u2014 Responsive alignment and spacing controls<\\/li>\\n<li>Tweak: Text Divider \\u2014 Proper horizontal alignment of text and separators<\\/li>\\n<li>Fixed: Heading Extra \\u2014 Multiple z-index related issues<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Fix issue where elements would jump when scrolling<\\/li>\\n<\\/ul>\\n<h4> 1.1.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky sections!<\\/li>\\n<li>Added: Sticky \\u2014 New controls to unstick for mobile and tablet<\\/li>\\n<li>Added: Parallax Elements \\u2014 New controls to set different speeds for different breakpoints<\\/li>\\n<li>Added: Gallery Slider \\u2014 Links on images and support for the new Elementor lightbox feature<\\/li>\\n<li>Tweak: Improved shortcode support for all widgets, especially tooltips<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Greatly improved performance for parallaxed items<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Changed speed control logic to allow for reverse parallax<\\/li>\\n<li>Tweak: Created custom group controls for Sticky and Parallax features<\\/li>\\n<li>Fixed: Removed z-index from sticky elements to allow z-index setting from Elementor controls<\\/li>\\n<li>Fixed: Gallery Extras \\u2014 Some styling controls were conditioned by the &quot;Link to&quot; control<\\/li>\\n<li>Fixed: Removed potentially buggy call to Elementor class<\\/li>\\n<\\/ul>\\n<h4> 1.1.3 <\\/h4>\\n<ul>\\n<li>Tweak: Devices \\u2014 Refactored and cleaned up code for editor functionality<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved distance control after parallax controls<\\/li>\\n<li>Added: Controls to add parallax to any widget or column<\\/li>\\n<li>Added: Global control for turning off parallax functionality for tablet and mobile<\\/li>\\n<li>Added: Gallery Extra \\u2014 Control for settings horizontal overlap of images<\\/li>\\n<li>Added: Image Comparison \\u2014 Separator between images<\\/li>\\n<li>Added: Global \\u2014 Implemented the new Text Shadow controls for all widgets<\\/li>\\n<li>Added: Button Groups \\u2014 Responsive control of spacing for stacked buttons<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where frames would not properly change in editor mode<\\/li>\\n<li>Fixed: Changed license page capability to \'manage_options\'<\\/li>\\n<li>Fixed: Compatibility with Elementor 1.6<\\/li>\\n<\\/ul>\\n<h4> 1.1.2 <\\/h4>\\n<ul>\\n<li>Fixed: Class namespace change in Elementor Pro 1.5.7 resulting in fatal error<\\/li>\\n<\\/ul>\\n<h4> 1.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Devices \\u2014 Overlay not visible for laptop and desktop<\\/li>\\n<li>Fixed: Timeline \\u2014 PHP empty function fatal error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Width remained 50% even if vertical layout selected<\\/li>\\n<\\/ul>\\n<h4> 1.1.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 Gallery Extra \\u2014 We\'ve taken aside the parallax functionality and created a whole new widget with nots of posibilities.<\\/li>\\n<li>Added: New Widget! \\u2014 Gallery Slider \\u2014 A gallery layout with inline preview.<\\/li>\\n<li>Added: New Feature! \\u2014 Button tooltips \\u2014 You can now use the Button Groups widget to add buttons with tooltips.<\\/li>\\n<li>Added: New Feature! \\u2014 Timeline \\u2014 Integration with Woocommerce products.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Added support for icons inside hotspots.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Ability to set the delay for both entrance close animations.<\\/li>\\n<li>Added: Circle Progress \\u2014 Control too choose start angle for the circle progress.<\\/li>\\n<li>Added: Devices \\u2014 Support for multiple video formats<\\/li>\\n<li>Added: Timeline \\u2014 Add featured images from separate control.<\\/li>\\n<li>Added: Elementor Portfolio Widget \\u2014 Speed control for parallax feature.<\\/li>\\n<li>Added: Timeline \\u2014 Turn on and off for excerpts, content, title and featured image.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle now goes all the way until the end of the image.<\\/li>\\n<li>Fixed: Timeline \\u2014 Date color wasn\'t changing properly.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<li>Fixed: Sticky - Issue where in preview mode wrong height of the element was calculated.<\\/li>\\n<li>Fixed: Image Gallery \\u2014 Issue with displaying on Firefox.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle jumps when using multiple widgets on same page.<\\/li>\\n<li>Fixed: Timeline \\u2014 Scheme style override issue for points.<\\/li>\\n<li>Fixed: Devices \\u2014 Video would not play on iOS devices<\\/li>\\n<\\/ul>\\n<h4> 1.0.5 <\\/h4>\\n<ul>\\n<li>Added: Button Groups \\u2014 Box shadow control.<\\/li>\\n<li>Fixed: Ensured compatibility with other jquery appear plugins.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<\\/ul>\\n<h4> 1.0.4 <\\/h4>\\n<ul>\\n<li>Added: Added translation support<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where controls would always display as a white rectangular shape.<\\/li>\\n<\\/ul>\\n<h4> 1.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Image Galleries \\u2014 Issue where galleries with no links would break the layout<\\/li>\\n<li>Fixed: Hotspots \\u2014 When using multiple hotspots widgets on the same page additional widgets would show the first widget\'s tooltips instead of their own<\\/li>\\n<\\/ul>\\n<h4> 1.0.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 New controls: text align, padding, border and typography<\\/li>\\n<li>Fixed: Hotspots \\u2014 Hide arrow control not working<\\/li>\\n<li>Fixed: Hotspots \\u2014 Issue where tooltips don\'t remain open on click trigger option and thus preventing clicking off links inside tooltips<\\/li>\\n<li>Fixed: Button Groups \\u2014 Replaced custom border controls with border group control<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Compability with Elementor 1.5<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Heading size not working<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Issue where colors of labels would not change colors for printed templates<\\/li>\\n<\\/ul>\\n<h4> 1.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Image Comparison \\u2014 Issue where dragging the handle on mobile would not work<\\/li>\\n<\\/ul>\\n<h4> 1.0.0 <\\/h4>\\n<ul>\\n<li>Added: New &quot;Timeline&quot; widget with posts support for Elementor Pro<\\/li>\\n<li>Added: Image Comparison \\u2014 Different colors for both labels<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Moved alignment &amp; scaling options to widget wrapper<\\/li>\\n<li>Tweak: Aligned default widgets colors to selected color scheme<\\/li>\\n<li>Tweak: Removed sticky from sections temporarily<\\/li>\\n<li>Tweak: Removed parallax scrolling from section backgrounds<\\/li>\\n<li>Tweak: Button Groups \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Tweak: Full compatibility with global color schemes for all widgets<\\/li>\\n<li>Tweak: Hotspots \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Issue where arrow colors would not apply<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Entrace animation hides the shadow when animation is complete<\\/li>\\n<li>Fixed: Devices \\u2014 Border type not present in hover state for video controls<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Removed small space after widget<\\/li>\\n<li>Fixed: Hotspots \\u2014 Syntax error in JS template<\\/li>\\n<li>Fixed: Hotspots \\u2014 JS error when adding new hotpots<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips z-index issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Bottom tooltips animated down instead of up<\\/li>\\n<li>Fixed: Hotspots \\u2014 Html being added as string when hotspots are triggered through the open_editor hook<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips not editable immediately when dragged into preview<\\/li>\\n<li>Fixed: Image Comparison \\u2014 images are not set to occupy full width<\\/li>\\n<\\/ul>\\n<h4> 0.1.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 Rewrote code entirely to allow for preview mode support, customisation of tooltips and faster rendering<\\/li>\\n<li>Added: Circle progress \\u2014 Better handling of value suffix<\\/li>\\n<li>Fixed: Scripts dependencies<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where global colors where used instead of skins<\\/li>\\n<li>Fixed: Various compatibility issues with the Elementor color scheme<\\/li>\\n<li>Fixed: Image Gallery Extension \\u2014 Styling issues when choosing to justify gallery items<\\/li>\\n<li>Fixed: Sticky Extension \\u2014 Sitcky offset would not preview correctly and sometimes having multiple sticky widgets would cause interference amongst them<\\/li>\\n<li>Fixed: Parallax Gallery \\u2014 Removed any kinds of transformation for odd children<\\/li>\\n<\\/ul>\\n<h4> 0.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Buttons groups \\u2014 Responsive alignment of buttons<\\/li>\\n<li>Added: Buttons groups \\u2014 option to stack buttons on tablet or mobile<\\/li>\\n<\\/ul>\\n<h4> 0.1.0 <\\/h4>\\n<ul>\\n<li>Initial Private Beta<\\/li>\\n<\\/ul>\",\"installation\":\"<ol>\\n<li>Make sure Elementor is installed and active on your website<\\/li>\\n<li>Activate the plugin through the \'Plugins\' menu in WordPress<\\/li>\\n<li>Edit a page (or post) using Elementor<\\/li>\\n<li>Find and use the new widgets and extensions<\\/li>\\n<\\/ol>\"},\"banners\":{\"high\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/edd\\/2019\\/09\\/Banner-2.2.png\",\"low\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/edd\\/2019\\/09\\/Banner-2.2@05x.png\"},\"icons\":{\"1x\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/2017\\/08\\/Logo@2x.png\",\"2x\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/2017\\/08\\/Logo@2x.png\"},\"tested\":\"5.4.0\",\"compatibility\":\"a:1:{s:5:\\\"4.9.8\\\";a:1:{s:6:\\\"1.5.21\\\";a:3:{i:0;s:4:\\\"100%\\\";i:1;s:1:\\\"5\\\";i:2;s:1:\\\"5\\\";}}}\",\"stable_tag\":\"2.2.28\",\"license\":\"GPLv3 or later\",\"added\":\"2017-05-31\",\"description\":[\"<p>Elementor Extras is one of the first premium Wordpress plugin for Elementor. It extends its capability with many unique widgets and extensions that make Elementor even more powerful.<\\/p>\\n<h4> Copyright and licensing <\\/h4>\\n<p>Copyright (C) 2016-2019 Elementor Ltd.<\\/p>\\n<p>This program is free software: you can redistribute it and\\/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.<\\/p>\\n<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.<\\/p>\\n<p>You should have received a copy of the GNU General Public License along with this program. If not, see <a href=\\\"https:\\/\\/www.gnu.org\\/licenses\\/\\\">https:\\/\\/www.gnu.org\\/licenses\\/<\\/a>.<\\/p>\\n<h4> Third Party Code <\\/h4>\\n<p>Elementor Extras incorporates code from:<\\/p>\\n<ul>\\n<li><strong>jquery-circle-progress<\\/strong> v1.2.2, Copyright Rostyslav Bryzgunov Licenses: MIT Source: link <a href=\\\"http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/\\\">http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/<\\/a><\\/li>\\n<li><strong>jQuery appear plugin<\\/strong> v0.3.6, Copyright 2012 Andrey Sidorov Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/morr\\/jquery.appear\\/\\\">https:\\/\\/github.com\\/morr\\/jquery.appear\\/<\\/a><\\/li>\\n<li><strong>LongShadow jQuery Plugin<\\/strong> v1.1.0, Copyright 2013 - 2016 Dang Van Thanh Licenses: MIT Source: link git:\\/\\/github.com\\/dangvanthanh\\/jquery.longShadow.git<\\/li>\\n<li><strong>HC-Sticky<\\/strong> v2.2.3, Copyright Some Web Media License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/somewebmedia\\/hc-sticky\\\">https:\\/\\/github.com\\/somewebmedia\\/hc-sticky<\\/a><\\/li>\\n<li><strong>jQuery Mobile<\\/strong> v1.4.3, Copyright 2010, 2014 jQuery Foundation, Inc. Licenses: jquery.org\\/license<\\/li>\\n<li><strong>jquery-visible<\\/strong>, Copyright 2012, Digital Fusion, License: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a> Source: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a><\\/li>\\n<li><strong>Parallax Background<\\/strong> v1.2, by Eren Suleymanoglu Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background\\\">https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background<\\/a><\\/li>\\n<li><strong>TableSorter<\\/strong> v2.0.5b, Copyright 2007 Christian Bach Licenses: Dual licensed under the MIT and GPL licenses Source: link <a href=\\\"http:\\/\\/tablesorter.com\\\">http:\\/\\/tablesorter.com<\\/a><\\/li>\\n<li><strong>Isotope<\\/strong> PACKAGED v3.0.6, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>Infinite Scroll<\\/strong> PACKAGED v3.0.2, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"https:\\/\\/infinite-scroll.com\\\">https:\\/\\/infinite-scroll.com<\\/a><\\/li>\\n<li><strong>Packery layout mode<\\/strong> PACKAGED v2.0.0 Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>javascript-detect-element-resize<\\/strong> v0.5.3 Copyright (c) 2013 Sebasti\\u00e1n D\\u00e9cima License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize\\\">https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize<\\/a><\\/li>\\n<li><strong>tilt.js<\\/strong> 1.2.1, Copyright (c) 2017 Gijs Rog\\u00e9 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/gijsroge\\/tilt.js\\\">https:\\/\\/github.com\\/gijsroge\\/tilt.js<\\/a><\\/li>\\n<li><strong>CLNDR<\\/strong> v1.4.7, Copyright Kyle Stetz (github.com\\/kylestetz) License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/kylestetz\\/CLNDR\\\">https:\\/\\/github.com\\/kylestetz\\/CLNDR<\\/a><\\/li>\\n<li><strong>GMAP3 Plugin for jQuery<\\/strong> v7.2 Copyright DEMONTE Jean-Baptiste License: GPL-3.0+ Source: link <a href=\\\"http:\\/\\/gmap3.net\\\">http:\\/\\/gmap3.net<\\/a><\\/li>\\n<li><strong>Moment.js<\\/strong> v2.22.2 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/moment\\/moment\\/\\\">https:\\/\\/github.com\\/moment\\/moment\\/<\\/a><\\/li>\\n<li><strong>Slidebars<\\/strong> v2 Copyright Adam Charles Smith License: MIT <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/<\\/a> Source: link <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/<\\/a><\\/li>\\n<li><strong>Splittext.js<\\/strong> Copyright (c) 2008-2016, GreenSock<\\/li>\\n<li><strong>Magnific Popup<\\/strong> v1.1.0 License: MIT Copyright 2016 Dmitry Semenov Soruce: link <a href=\\\"http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/\\\">http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/<\\/a><\\/li>\\n<\\/ul>\\n<h4> Important Links <\\/h4>\\n<p><a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/getting-started\\/#update-official\\\">Updating Extras<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/topic\\/elementor-extras\\/\\\">Documentation<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/\\\">Your Account<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/support\\/\\\">Support<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/frequently-asked-questions\\/\\\">FAQ<\\/a><\\/p>\"],\"changelog\":[\"<h4> 2.2.28 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Padding control for labels<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Control to disable structured data attributes<\\/li>\\n<li>Added: Gallery Slider, Gallery Extra, Switcher \\u2014 Option to disable slideshow in lightbox<\\/li>\\n<li>Added: Posts \\u2014 Wordpress filters for post and post wrapper classes<\\/li>\\n<li>Added: Video Player \\u2014 Control to remove Chrome\'s download option in fullscreen mode<\\/li>\\n<li>Fixed: Gallery Slider, Gallery Extra, Random Image, Switcher \\u2014 Missing lightbox captions<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Low CSS specificity for ul and li elements causing themes override<\\/li>\\n<li>Fixed: Popup \\u2014 Exit intent not working correctly<\\/li>\\n<li>Tweak: Updated translations .pot file<\\/li>\\n<\\/ul>\\n<h4> 2.2.27 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 Shortcode output condition<\\/li>\\n<li>Added: Display Conditions \\u2014 Post meta condition<\\/li>\\n<li>Added: Posts Extra \\u2014 Control to stack filters responsively<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to trigger a window resize events after each carousel slide to fix displaying issues of certain widgets when using custom post skins<\\/li>\\n<li>Added: Gallery Slider \\u2014 Option to contain centre fit images inside preview slider when custom height is set<\\/li>\\n<li>Fixed: Incorrect Breadcrumbs and Slide Menu WPML integration<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters not changing active class when using masonry<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Load more button not hidden when no pagination available<\\/li>\\n<li>Fixed: Video Player \\u2014 Trigger window resize to position correctly elements with motion effects enabled after the video is loaded<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Removed label_block from slider control that broke controls<\\/li>\\n<\\/ul>\\n<h4> 2.2.26 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Carousel pagination selector breaks pagination when multiple carousels on same page<\\/li>\\n<li>Fixed: Search Form \\u2014 Submit button icon spacing control bug<\\/li>\\n<li>Fixed: Search Form \\u2014 Beautified option fields icons not displaying properly<\\/li>\\n<li>Fixed: Gallery Slider \\u2013 Figure line height causing caption display issues<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Distance control for thumbnails carousel arrows not working<\\/li>\\n<\\/ul>\\n<h4> 2.2.25 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 If no condition value is set check to see if field is set to any value<\\/li>\\n<li>Added: Gallery Slider \\u2014 Options to set max. width and horizontal and vertical alignment for thumbnails carousel<\\/li>\\n<li>Added: Gallery Slider \\u2014 Option to set custom height for preview slides<\\/li>\\n<li>Added: Popup \\u2014 Option to disable refreshing frontend functionality for elements inside the popup<\\/li>\\n<li>Added: Offcanvas \\u2014 Option to disable refreshing frontend functionality for elements inside the panel<\\/li>\\n<li>Added: Calendar \\u2014 Typography control for header week days<\\/li>\\n<li>Added: Google Map \\u2014 Option to set zoom level when navigating to a location<\\/li>\\n<li>Fixed: Bug where one swiper slider\'s arrows control all swiper sliders on the same page<\\/li>\\n<li>Fixed: Calendar \\u2014 Separator style for header not working<\\/li>\\n<li>Fixed: Gallery \\u2014 Instagram lightbox not working for my photos<\\/li>\\n<li>Fixed: Gallery \\u2014 Instagram links bug for hashtag posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters with masonry enabled when two widgets on page breaks filtering<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Allow 0 value to be shown<\\/li>\\n<\\/ul>\\n<h4> 2.2.24 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Option to enable carousel on thumbnails<\\/li>\\n<li>Added: Posts Extra \\u2014 More swiper settings<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Compatibility with display conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Dynamic tag background styles<\\/li>\\n<li>Fixed: Don\'t include Elementor form widget in refreshable widgets due to reCaptcha reinitialisation uncaught error<\\/li>\\n<li>Fixed: Timeline \\u2014 Date entrance animation on left right and overlay alignments<\\/li>\\n<\\/ul>\\n<h4> 2.2.23 <\\/h4>\\n<ul>\\n<li>Added: Popup \\u2014 Margin control for close icon<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Instagram compatibility with new API changes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel compatibility with Elementor 2.9.4 swiper.js changes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Allow -1 as posts per page value for specific query source<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Use wp_timezone instead of timezone_string in case timezone is set as offset<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Filter post count style controls conditions<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Carousel remove deprecated Columns control<\\/li>\\n<li>Tweak: Google Map \\u2014 Convert description control from text to WYSIWYG type<\\/li>\\n<\\/ul>\\n<h4> 2.2.22 <\\/h4>\\n<ul>\\n<li>Fixed: Timeline \\u2014 Points and dates not showing when animate cards is on<\\/li>\\n<li>Fixed: Unfold \\u2014 Bug error showing button since last update<\\/li>\\n<\\/ul>\\n<h4> 2.2.21 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 Current Date &amp; Time condition<\\/li>\\n<li>Added: Timeline \\u2014 New option to reverse position of cards<\\/li>\\n<li>Added: Text Divider \\u2014 Margin control for the text<\\/li>\\n<li>Added: Toggle Element \\u2014 Option to hide all elements by default<\\/li>\\n<li>Added: Timeline \\u2014 Controls for overriding text colour in custom mode<\\/li>\\n<li>Fixed: EE widget indicator in editor panel font<\\/li>\\n<li>Fixed: Unfold \\u2014 Removed elementor-button class from button which was adding a lot of padding<\\/li>\\n<li>Fixed: Unfold \\u2014 Editor preview spacing in js template<\\/li>\\n<li>Fixed: Query control width<\\/li>\\n<li>Fixed: PHP error on updater transient data<\\/li>\\n<li>Fixed: Video Player \\u2014 Stop play when played once in viewport<\\/li>\\n<li>Fixed: Timeline \\u2014 Correct dates when using custom post skin with a template that uses Posts Extra<\\/li>\\n<li>Fixed: Tooltips \\u2014 Tooltips not closing on mobile with touchstart event<\\/li>\\n<li>Fixed: Timeline \\u2014 Entrance animation triggering on page load instead of scroll to element<\\/li>\\n<li>Fixed: Timeline \\u2014 Query section not hidden if Source is Custom<\\/li>\\n<li>Fixed: Multiple SELECT2 controls width bug (missing css) after Elementor update<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Masonry layout broken when using custom size values in manual mode<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Changing filters disrupts any Elementor entrance animations placed after widget<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Run ready triggers for section and columns on infinite scroll<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Refresh elements even if infinite scroll button is off<\\/li>\\n<li>Fixed: ACF fields not showing inside templates when ACF Extended plugin is active<\\/li>\\n<li>Tweak: Unfold \\u2014 Hide button when there is no content or visible lines exceeds number of existing lines<\\/li>\\n<li>Tweak: Tooltips \\u2014 Integrate Elementor breakpoints<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Improved buggy responsive custom sizing method<\\/li>\\n<li>Revert: Display Conditions \\u2014 Added time to Current Date conditions\' date control<\\/li>\\n<\\/ul>\\n<h4> 2.2.20 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 \'Current User\' condition<\\/li>\\n<li>Added: Display Conditions \\u2014 Added time to Current Date conditions\' date control<\\/li>\\n<li>Fixed: Some icon controls hidden due to Elementor changing label_block control attribute<\\/li>\\n<li>Fixed: Popup \\u2014 Close button control conditions<\\/li>\\n<li>Fixed: Popup \\u2014 Close icon not hiding on frontend<\\/li>\\n<\\/ul>\\n<h4> 2.2.19 <\\/h4>\\n<ul>\\n<li>Added: Popup \\u2014 Option to set max number of times a non-persistent popup should open<\\/li>\\n<li>Fixed: Posts \\u2014 Carousel compatibility with Elementor 2.9.0 swiper js upgrade<\\/li>\\n<li>Fixed: Switcher \\u2014 Title direction on RTL<\\/li>\\n<\\/ul>\\n<h4> 2.2.18 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Filters infinite scroll warning<\\/li>\\n<li>Added: Popup \\u2014 Border controls for iframe and image<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 PHP warning<\\/li>\\n<li>Fixed: Buttons \\u2014 Theme CSS override for anchors<\\/li>\\n<li>Fixed: Popup \\u2014 PHP warning when using placeholder image<\\/li>\\n<li>Fixed: Popup \\u2014 Overflow hidden missing from popup content<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Restrict refreshing widget inside offcanvas panel to refreshable list<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Clicking bullets on mobile doesn\'t scroll to section when tooltips are enabled<\\/li>\\n<li>Tweak: Scroll Indicator \\u2014 Separate control for enabling opening of tooltips on focus for better integration<\\/li>\\n<li>Tweak: Switcher \\u2014 Convert description textarea field to WYSIWYG<\\/li>\\n<li>Tweak: Slide Menu \\u2014 More specific selector typography control<\\/li>\\n<li>Tweak: Popup \\u2014 Default close button size for iframe<\\/li>\\n<li>Tweak: Make license renewal reminder dismissable<\\/li>\\n<\\/ul>\\n<h4> 2.2.17 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Option to open in new tab for Title link<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Run ready triggers for widgets inside panel when opening<\\/li>\\n<li>Tweak: Posts \\u2014 Hide Media area if no thumbnail or placeholder even if it has content parts<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Default thumbs spacing to 24<\\/li>\\n<li>Tweak: Update TweenMax version<\\/li>\\n<\\/ul>\\n<h4> 2.2.16 <\\/h4>\\n<ul>\\n<li>Added: Scroll Indicator \\u2014 Offset for scrolling to section<\\/li>\\n<li>Added: Gallery Slider \\u2014 Lazy load images in preview<\\/li>\\n<li>Added: Slide Menu \\u2014 \'elementor_extras\\/widgets\\/slide_menu\\/nav_menu\\/walker_start_el\' filter for walker_nav_menu_start_el hook<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Tilt perspective issue<\\/li>\\n<li>Fixed: Gallery \\u2014 Tilt captions depth not working<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Distance for repositioned tooltips<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Multiple tooltips appearing only in edit mode when changing tooltip position<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Remove posts per page setting for current query<\\/li>\\n<li>Fixed: Display Conditions \\u2014 GET and POST not returning true for any value<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Minor PHP warning<\\/li>\\n<li>Fixed: Random Image \\u2014 Error when using only one image<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Duplicate images in Elementor lightbox when infinite loop is enabled<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Include &quot;related&quot; source in Price position control conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Meta Key not showing when Order By is set to Meta Value (number)<\\/li>\\n<li>Fixed: Timeline \\u2014 Meta Key not showing when Order By is set to Meta Value (number)<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Disable add to cart button when used inside a linked Media area<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive entrance animation<\\/li>\\n<\\/ul>\\n<h4> 2.2.15 <\\/h4>\\n<ul>\\n<li>Fixed: Popup \\u2014 Date comparison fail for non-persistent interval setting<\\/li>\\n<li>Fixed: Tooltips \\u2014 Tooltips empty in some cases after last update<\\/li>\\n<li>Fixed: Calendar \\u2014 Support for ACF date time picker fields<\\/li>\\n<li>Tweak: Hotspots \\u2014 Better css method for disabling pulse effect<\\/li>\\n<li>Tweak: Posts Extra \\u2014 New &quot;hide&quot; icon for content parts positioning<\\/li>\\n<li>Tweak: Nicons<\\/li>\\n<\\/ul>\\n<h4> 2.2.14 <\\/h4>\\n<ul>\\n<li>Fixed: Audio Player \\u2014 Edge case bug when stopping a player inside a section stuck with Elementor sticky setting<\\/li>\\n<li>Fixed: Switcher \\u2014 Loader thickness not working in Firefox<\\/li>\\n<li>Fixed: Offcanvas \\u2014 WPML not fetching content boxes repeater fields<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Masonry missing on frontend after last update<\\/li>\\n<li>Tweak: Tooltips \\u2014 Use append method to add content to the tooltip<\\/li>\\n<\\/ul>\\n<h4> 2.2.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Media left right alignment not working<\\/li>\\n<\\/ul>\\n<h4> 2.2.12 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Post border radius control<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Safari layout bug on infinite scroll and masonry layout<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel slides to scroll on tablet bug<\\/li>\\n<li>Fixed: Timeline \\u2014 Date options not showing for custom post skin option<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Force sticky sections to flex align to start for Safari flex stretch bug<\\/li>\\n<\\/ul>\\n<h4> 2.2.11 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Infinite scroll fields for WPML<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Better support for post type archive links on archive pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Flexbox causing horizontal media layout issue on mobile<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Compatibility with wordpress 5.3<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Mode container background colour control from site settings to widget settings<\\/li>\\n<\\/ul>\\n<h4> 2.2.10 <\\/h4>\\n<ul>\\n<li>Added: Popup \\u2014 Option to open url inside popup<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Check for existing non built-in custom post types before iteration<\\/li>\\n<li>Fixed: Display Conditions \\u2014 ACF Date support for custom locale<\\/li>\\n<li>Fixed: Calendar \\u2014 ACF Date support for custom locale<\\/li>\\n<li>Fixed: Switcher \\u2014 Description not available for translation<\\/li>\\n<li>Fixed: Gallery \\u2014 Safari backface-visibility bug<\\/li>\\n<\\/ul>\\n<h4> 2.2.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Align media vertically on horizontal post layouts<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Text separator not displaying<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default horizontal layout width control to 30<\\/li>\\n<\\/ul>\\n<h4> 2.2.8 <\\/h4>\\n<ul>\\n<li>Added: Breadcrumbs \\u2014 Granular controls for crumbs settings on archive and single pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Moved images loaded container selector to ajax response<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters option not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll pagination html output rendering more links than needed<\\/li>\\n<li>Fixed: PHP notice for licensing admin notification<\\/li>\\n<li>Fixed: Switcher \\u2014 Border radius control CSS selector<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Cleanup on pagination html output needed for infinite scroll<\\/li>\\n<\\/ul>\\n<h4> 2.2.7 <\\/h4>\\n<ul>\\n<li>Fixed: Compatibility with third-party plugin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case bug when calculating anchor position<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Notices<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Overlapping items on infinite scroll when filters active<\\/li>\\n<\\/ul>\\n<h4> 2.2.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Global \'elementor_extras\\/widgets\\/posts\\/link\' filter<\\/li>\\n<li>Added: Offcanvas \\u2014 Typography control for content boxes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite Scroll stopping before all posts load<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Panel background selector<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Page jump when navigating to anchor<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case js error in nouislider script<\\/li>\\n<li>Fixed: Templates Control \\u2014 Restrict global query override for templates inside loops<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Nav menu item classes don\'t work when coming from template control<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong order for hierarchical taxonomies<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Flicker when performing infinite scroll on filtered posts<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Additional padding in some cases below sticky element<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Missing day of week condition<\\/li>\\n<li>Fixed: Hotspots \\u2014 Better handling of icon vertical alignment in css<\\/li>\\n<\\/ul>\\n<h4> 2.2.5 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Control to hide items without any content<\\/li>\\n<li>Added: Popup \\u2014 Support for usage within Posts Extra custom post skin<\\/li>\\n<li>Added: Audio Player \\u2014 Option to disable preloading of audio files<\\/li>\\n<li>Added: Calendar \\u2014 Search custom fields by field name<\\/li>\\n<li>Added: Offcanvas \\u2014 Options in widgets\' settings to fix page jump issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Certain actions not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Pods controls not fetching fields<\\/li>\\n<li>Fixed: Calendar \\u2014 Toolset controls not fetching fields<\\/li>\\n<li>Fixed: Query Control \\u2014 Return only matching queries for pods and toolset<\\/li>\\n<li>Fixed: Calendar \\u2014 Placeholder functionality<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where css width selectors get overridden by defaults<\\/li>\\n<li>Tweak: Posts Extra \\u2013 Default css order value for parts and areas in frontend css<\\/li>\\n<li>Tweak: Popup \\u2014 Replaced multiple template selection control with single control. IMPORTANT: Settings review required!<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Refactor widget code<\\/li>\\n<\\/ul>\\n<h4> 2.2.4 <\\/h4>\\n<ul>\\n<li>Added: Dynamic background image support for custom post skin<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Filter for home breadcrumb link<\\/li>\\n<li>Fixed: Timeline \\u2014 Wrong card content selector for transition control<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Broken selectors after last offcanvas update<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove default border around posts<\\/li>\\n<\\/ul>\\n<h4> 2.2.3 <\\/h4>\\n<ul>\\n<li>Added: Offcanvas \\u2014 Compatibility with templates in loops in Posts Extra and other plugins<\\/li>\\n<li>Added: Posts Extra \\u2014 Refresh all widgets scripts on appended infinite scroll items<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Button style gone when placed in linked media area<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Bug when sticky section inside page body within theme builder header template<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Tooltips not working with bullets skin<\\/li>\\n<\\/ul>\\n<h4> 2.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Scroll Indicator \\u2014 Bug when tooltips disabled on bullets skin<\\/li>\\n<li>Fixed: Timeline \\u2014 Option to hide thumbnail not working in posts mode<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Bug with before parent category filters<\\/li>\\n<li>Fixed: Bug with third party elementor addon that enqueue editor scripts on plugin load<\\/li>\\n<li>Fixed: Posts \\u2014 Default metas control to include price for previous saved settings<\\/li>\\n<li>Added: Search Form \\u2014 Compatibility with Relevanssi search results on custom templates with search form id condition<\\/li>\\n<li>Added: Timeline \\u2014 Option to set a dynamic tag instead of date, title and excerpt in posts mode<\\/li>\\n<li>Added: Timeline \\u2014 Option to set HTML element for title in posts mode<\\/li>\\n<li>Added: Posts Extra \\u2014 Filter for the media area link<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to open media and button links in new tab<\\/li>\\n<li>Added: Table \\u2014 WPML translation of header cells text<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Additional listeners for recalculating sticky<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Less restrictive css selector for the woocommerce add to cart button<\\/li>\\n<\\/ul>\\n<h4> 2.2.1 <\\/h4>\\n<ul>\\n<li>Added: Scroll Indicator \\u2014 Option to offset start and end positions<\\/li>\\n<li>Added: Posts Extra \\u2014 Responsive media width control<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Missing custom field order options<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar meta showing even if removed from metas list<\\/li>\\n<li>Fixed: Display Conditions \\u2014 ACF Choice fails for radio field<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Bug with left aligned media flex width on mobile<\\/li>\\n<\\/ul>\\n<h4> 2.2.0 <\\/h4>\\n<ul>\\n<li>Added: Google Map \\u2014 Route travel mode options<\\/li>\\n<li>Added: Global Tooltips \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Added: Global Tooltips \\u2014 z-index control in both element and global settings<\\/li>\\n<li>Added: Display Conditions \\u2014 Term archive condition<\\/li>\\n<li>Added: Display Conditions \\u2014 ACF conditions<\\/li>\\n<li>Added: Display Conditions \\u2014 POST and GET variable conditions<\\/li>\\n<li>Added: Timeline \\u2014 Custom Post Skin via Elementor templates<\\/li>\\n<li>Added: Timeline \\u2014 Replaced default query controls with related query controls<\\/li>\\n<li>Added: Timeline \\u2014 Trim custom excerpt control<\\/li>\\n<li>Added: Timeline \\u2014 Custom post skin<\\/li>\\n<li>Added: Posts Extra \\u2014 Date formatting controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Actions and filters<\\/li>\\n<li>Added: Calendar \\u2014 Actions and filters<\\/li>\\n<li>Added: Devices \\u2014 Actions<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Actions and filters<\\/li>\\n<li>Added: Scroll Indicator \\u2014 Custom html tags for title and subtitle in list skin<\\/li>\\n<li>Added: Custom implementation for Template controls<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Support for slick slider based widgets inside elements<\\/li>\\n<li>Fixed: Switcher \\u2014 Missing image link control<\\/li>\\n<li>Fixed: Timeline \\u2014 Markup improvement to allow for simpler border radius around cards<\\/li>\\n<li>Fixed: Timeline \\u2014 Custom icon replaces global if global is set<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Separator vertical alignment bug<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Icon migration markup issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Update elementor nerd box classes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom skins used on archive pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong access type for _query property<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Price conditions issue for area and editor panel section display<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Author and avatar metas additional controls conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Removed infinite scroll pages loaded limit<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Handle multiple paginations control condition bug<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Custom height control condition<\\/li>\\n<li>Fixed: Popup \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Fixed: Buttons \\u2014 Flip effect back is hidden during transition<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Remove useless icon and icon class filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Update button text filters to include \\/posts\\/<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default taxonomy order for filters<\\/li>\\n<\\/ul>\\n<h4> 2.1.8 <\\/h4>\\n<ul>\\n<li>Fixed: Missing elementor pro active condition<\\/li>\\n<\\/ul>\\n<h4> 2.1.7 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Order posts by custom fields<\\/li>\\n<li>Fixed: Calendar \\u2014 No events fetched when acf date field return format is different that display format<\\/li>\\n<li>Tweak: Better notices and plugin activation prevention for dependencies<\\/li>\\n<\\/ul>\\n<h4> 2.1.6 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Exclude category pages from previous current query fix<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom post skins used on archive pages<\\/li>\\n<\\/ul>\\n<h4> 2.1.5 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Filter for button link<\\/li>\\n<li>Added: Posts Extra \\u2014 Apply both \'button\' and \'add_to_cart\' filters to button<\\/li>\\n<li>Added: Audio Player \\u2014 Autoplay option<\\/li>\\n<li>Added: Support for new icon library in Elementor 2.6 in all widgets<\\/li>\\n<li>Added: Support for scaling SVG icon library assets when added to widgets<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to hide current page<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Template control not fetching results after Elementor Pro 2.6.0 update<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Body order on horizontal posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default query args prevent correct number of results on search templates<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters initially not working<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong hierarchical taxonomies order when using custom post types<\\/li>\\n<li>Fixed: Calendar \\u2014 Border radius overflow issue<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Progress not showing when shown below<\\/li>\\n<li>Fixed: Timeline \\u2014 Text align on tablet for RTL<\\/li>\\n<li>Fixed: Switcher \\u2014 Remove link image option when using overlay skin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where page scrolls up when panel closed on firefox<\\/li>\\n<li>Fixed: Video Player \\u2014 Play button not centered in edge cases<\\/li>\\n<li>Tweak: Search Form \\u2014 Tax query verification<\\/li>\\n<\\/ul>\\n<h4> 2.1.4 <\\/h4>\\n<ul>\\n<li>Fixed: Audio Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Video Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Search Form \\u2014 Undefined index notice<\\/li>\\n<li>Added: Offcanvas \\u2014 Custom select for the close button<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Separate control sections for title and close settings<\\/li>\\n<\\/ul>\\n<h4> 2.1.3 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Add to cart button alignment<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Pagination links on single templates<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Deprecated certain filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added button text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added add to cart text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Changed skin source terminology<\\/li>\\n<li>Tweak: Dissmisable admin licensing notices<\\/li>\\n<\\/ul>\\n<h4> 2.1.2 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 New Term Archive condition<\\/li>\\n<li>Added: Posts Extra \\u2014 Area ordering controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Add to cart button<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to use Elementor templates as custom skin for posts<\\/li>\\n<li>Added: Timeline \\u2014 Separate controls for dates in hover and focused state<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Force square avatar image<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove empty image wrapper when no image exists<\\/li>\\n<li>Fixed: Timeline \\u2014 Hover background color of arrow when focused<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show price if source is current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow Elementor custom image size<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive color controls<\\/li>\\n<\\/ul>\\n<h4> 2.1.1 <\\/h4>\\n<ul>\\n<li>Added: Tooltips \\u2014 Event for closing the tooltip by clicking anywhere<\\/li>\\n<li>Fixed: Buttons \\u2014 Text align when min width is set<\\/li>\\n<li>Tweak: Scroll Indicator \\u2014 Added options to select progress start and end calculation on scroll for sections<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Moved Infinite Scroll, Pagination and Filters activation controls to their respective sections.<\\/li>\\n<li>Tweak: Licensing \\u2014 Increase remote post request timeout value<\\/li>\\n<\\/ul>\\n<h4> 2.1.0 <\\/h4>\\n<ul>\\n<li>New Widget: Search Form \\u2014 Form widget with restrictions and filters<\\/li>\\n<li>New Widget: Scroll Indicator \\u2014 Create different types of scroll navigation indicators<\\/li>\\n<li>New Feature: Instagram \\u2014 Pull instagram feed to the Gallery widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Vertical carousel<\\/li>\\n<li>Added: Posts Extra \\u2014 New control to select breakpoint for collapsing horizontal post layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 Keep control to define page number limit for infinite scroll<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to not show the &quot;All&quot; filter<\\/li>\\n<li>Added: Posts Extra \\u2014 New control for Slides to Show and deprecated old control [ Settings Review Required ]<\\/li>\\n<li>Added: Posts Extra \\u2014 Exclude taxonomy terms from filters<\\/li>\\n<li>Added: Gallery \\u2014 New spacing control specifically for mixed masonry layout. [ Settings Review Required ]<\\/li>\\n<li>Added: Gallery Slider \\u2014 Control to hide thumbnails<\\/li>\\n<li>Added: Tooltips \\u2014 Mobile event listeners [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Responsive triggers and hide events [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Separate events for closing the tooltip [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 New offset control to adjust alignment of arrow tip to target<\\/li>\\n<li>Added: Devices \\u2014 Option for video to cover screen<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Hover colors controls<\\/li>\\n<li>Added: Calendar \\u2014 Disable links to posts<\\/li>\\n<li>Added: Calendar \\u2014 Add nofollow and open in new window on posts source<\\/li>\\n<li>Added: Buttons \\u2014 General padding control<\\/li>\\n<li>Added: Popup \\u2014 Horizontal align for inline trigger and popup close button<\\/li>\\n<li>Added: Notice for license domain mismatch<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute max values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Aligned column breakpoints to elementor default values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Better override default theme padding on post item<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS bug with overflow<\\/li>\\n<li>Fixed: Timeline \\u2014 Arrow color not working on frontend<\\/li>\\n<li>Fixed: Timeline \\u2014 Invalid code being generated in post css<\\/li>\\n<li>Fixed: Calendar \\u2014 Link target and nofollow<\\/li>\\n<li>Fixed: Devices \\u2014 Video controls conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Elementor Pro scrolling effect<\\/li>\\n<li>Fixed: Popup \\u2014 Dynamic css selector for trigger not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Link attributes in compact mode not working<\\/li>\\n<li>Fixed: Google Map \\u2014 Wrong value for default description tag<\\/li>\\n<li>Fixed: Google Map \\u2013 Set overflow to hidden to allow for advanced border radius setting<\\/li>\\n<li>Fixed: Switcher \\u2014 Rename effects section for compatibility with motion effects section name<\\/li>\\n<li>Fixed: Switcher \\u2014 Link to control should not be responsive<\\/li>\\n<li>Fixed: Unfold \\u2014 Bug with closing without focusing<\\/li>\\n<li>Fixed: Random Image \\u2014 Wrong caption<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Check correct condition value<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Text Label align controls<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Safari 12.1 CSS bug<\\/li>\\n<li>Fixed: Gallery \\u2014 Hover effects on mixed layout<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case js error<\\/li>\\n<li>Fixed: Remove duplicate empty template messages from editor panel<\\/li>\\n<li>Fixed: Check license data before mismatch check<\\/li>\\n<li>Fixed: Tooltips \\u2014 Bug with hide event prevent default<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow horizontal post layout independent of columns value<\\/li>\\n<li>Tweak: Gallery \\u2014 Better controls conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Moved settings in their own sections under Content<\\/li>\\n<li>Tweak: Gallery \\u2014 Control conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Better license management, notifications and performance<\\/li>\\n<li>Tweak: Remove extension default enable for sticky and parallax background<\\/li>\\n<li>Tweak: Remove custom panel alert classes and revert to elementor ones<\\/li>\\n<li>Tweak: Update docs and support links in extras admin pages<\\/li>\\n<li>Tweak: Streamline get_image_caption across all modules to avoid code redundancy<\\/li>\\n<li>Tweak: Toggle Element \\u2014 Better Label alignment controls<\\/li>\\n<li>Tweak: Popup \\u2014 Empty trigger css adjustments<\\/li>\\n<li>Tweak: Admin pages styles<\\/li>\\n<\\/ul>\\n<h4> 2.0.17 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Overlay horizontal alignment option<\\/li>\\n<li>Fixed: Timeline \\u2014 Icon showing twice<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default horizontal alignment to left<\\/li>\\n<\\/ul>\\n<h4> 2.0.16 <\\/h4>\\n<ul>\\n<li>Fixed: Include admin script only on extras pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL margins and arrows<\\/li>\\n<li>Fixed: Calendar \\u2014 RTL arrows<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Override current query posts per page with control setting<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel style section condition<\\/li>\\n<li>Added: Text Divider \\u2014 Control for alignment of text<\\/li>\\n<li>Added: Unfold \\u2014 Columns settings for content<\\/li>\\n<li>Added: Timeline \\u2014 New alignment controls to allow selecting layouts per breakpoint<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to align posts horizontally<\\/li>\\n<li>Tweak: Admin settings RTL<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive alignment controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive defaults for alignment controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.15 <\\/h4>\\n<ul>\\n<li>IMPORTANT: This version requires Elementor 2.5 or above<\\/li>\\n<li>IMPORTANT: If you have Elementor Pro, this version requires version 2.5 or above<\\/li>\\n<li>Added: Posts Extra \\u2014 Elementor Pro new related posts module with include \\/ exclude and date range<\\/li>\\n<li>Added: Circle Progress \\u2014 Option to turn off animation<\\/li>\\n<li>Added: Display Conditions \\u2014 Day of week condition<\\/li>\\n<li>Added: Video Player &amp; Devices \\u2014 Option to not hide bar when video is playing<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Unstick for 768px wide tablets<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Timeline \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust on resize in editor<\\/li>\\n<li>Fixed: Calendar \\u2014 Query compatibility with WPML<\\/li>\\n<li>Fixed: Hotspots \\u2014 Check spaces in hotspot links<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case where images don\'t display entirely<\\/li>\\n<li>Fixed: Timeline \\u2014 Correctly render dynamic tags<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Isotope on loading more posts when filter active<\\/li>\\n<li>Tweak: Video Player \\u2014 Automatically hide bar on mobile when playing<\\/li>\\n<\\/ul>\\n<h4> 2.0.14 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Option to select which item is active by default<\\/li>\\n<li>Fixed: Table \\u2014 Restrict cell max-width to msie<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Wrong arranging in some cases<\\/li>\\n<li>Fixed: Media Player text indicators wrapping<\\/li>\\n<\\/ul>\\n<h4> 2.0.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Carousel js error<\\/li>\\n<\\/ul>\\n<h4> 2.0.12 <\\/h4>\\n<ul>\\n<li>Added: Unfold \\u2014 Options to keep focus on content when folding or unfolding<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Make sure Gallery Extra is initiated when toggling<\\/li>\\n<li>Fixed: Table \\u2014 Min-width breakpoint bug<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Compatibility with Elementor 2.5<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues for panel<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Allow scroll on page not working<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Rare selector for anchors with link issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Rename css pulse animation<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Editor defaultView error<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust breakpoint values<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fallback to default wp posts per page option<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Make sure html element has auto height<\\/li>\\n<li>Tweak: Better wpml classes check<\\/li>\\n<\\/ul>\\n<h4> 2.0.11 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Trigger not closing after open<\\/li>\\n<li>Fixed: Posts \\u2014 Grid overlapping on safari when infinite scroll is enabled<\\/li>\\n<li>Fixed: Table \\u2014 Restrict IE hack to tablet and up<\\/li>\\n<li>Fixed: Get element settings on frontend in edit mode<\\/li>\\n<li>Fixed: Google Map \\u2014 Require resize plugin<\\/li>\\n<li>Added: Posts Extra \\u2014 Button border controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.10 <\\/h4>\\n<ul>\\n<li>Added: Parallax Elements \\u2014 Option to allow moving elements when they aren\'t visible inside viewport<\\/li>\\n<li>Fixed: Google Map \\u2014 Centering with dynamic tags not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Don\'t limit number of posts fetched<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Chrome check failing<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Responsive item aligning<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Custom size control compatibility + tweaks<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Type control condition<\\/li>\\n<li>Tweak: Google Map \\u2014 Disable fitting and centering when route is enabled<\\/li>\\n<\\/ul>\\n<h4> 2.0.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Handle multiple paginated loops<\\/li>\\n<li>Added: Posts Extra \\u2014 Nothing found message<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to turn off animation on entrance<\\/li>\\n<li>Added: Posts Extra \\u2014 Query ID filter on top of elementor pro one<\\/li>\\n<li>Added: Offcanvas \\u2014 Control to enable page scroll when offcanvas panel is open<\\/li>\\n<li>Fixed: Table \\u2014 IE cell text wrapping<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute value when multiple widget instances on same page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Wrong thumbnail order<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues<\\/li>\\n<li>Fixed: Calendar \\u2014 Convert timestamp to integer<\\/li>\\n<li>Fixed: Gallery module attachment check<\\/li>\\n<li>Tweak: Timeline \\u2014 Rename timeline script<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive row spacing control<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Compatibility with Elementor 2.4<\\/li>\\n<\\/ul>\\n<h4> 2.0.8 <\\/h4>\\n<ul>\\n<li>Fixed: Text Divider \\u2014 Selector for link color<\\/li>\\n<li>Fixed: Timeline \\u2014 Notice<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Escape jquery expression<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle invalid or undefined snazzy map style<\\/li>\\n<\\/ul>\\n<h4> 2.0.7 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Anchor navigation scroll calculation<\\/li>\\n<li>Added: Timeline \\u2014 Allow post content to be shown instead of excerpt<\\/li>\\n<li>Added: Timeline \\u2014 Control to set line progress position relative to viewport<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Anchor condition<\\/li>\\n<\\/ul>\\n<h4> 2.0.6 <\\/h4>\\n<ul>\\n<li>Fixed: Popup \\u2014 Duplicate tab control name<\\/li>\\n<li>Fixed: Popup \\u2014 Remove rtl suffix<\\/li>\\n<li>Added: Offcanvas \\u2014 Global control for offcanvas container background color<\\/li>\\n<\\/ul>\\n<h4> 2.0.5 <\\/h4>\\n<ul>\\n<li>Added: Editor panel labels for widgets<\\/li>\\n<li>Added: Calendar \\u2014 Control to customise month names<\\/li>\\n<li>Added: Offcanvas \\u2014 Link navigate to anchors on page<\\/li>\\n<li>Added: Popup \\u2014 Text trigger styling controls<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Multiple svgs have same settings<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 No parent custom taxonomy terms render all terms<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP notice<\\/li>\\n<li>Tweak: Updated language file<\\/li>\\n<\\/ul>\\n<h4> 2.0.4 <\\/h4>\\n<ul>\\n<li>Fixed: Display Conditions \\u2014 Editor section for sections actions<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Conditions evaluation per element<\\/li>\\n<\\/ul>\\n<h4> 2.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Popup Display Conditions \\u2014 Check widget visibility before opening automatically<\\/li>\\n<li>Fixed: Table \\u2014 First row has no classes<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle no snazzy maps selection<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Wrong default keys resulting in wrong display<\\/li>\\n<li>Fixed: Audio Player \\u2014 Border type selector<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Position structured data property<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Parallax column affecting child columns<\\/li>\\n<li>Fixed: Devices \\u2014 Image extending outside the widget area<\\/li>\\n<li>Fixed: Popup \\u2014 Move font family to pseudo-element<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Sub-menu links not working with link navigation turned on<\\/li>\\n<li>Tweak: Rename infinite-scroll script<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Increase typography selector specificity<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Additional conditions for areas style sections<\\/li>\\n<li>Remove widget disabling admin notif<\\/li>\\n<li>Update Wordpress stable tag to 5.0.0<\\/li>\\n<\\/ul>\\n<h4> 2.0.2 <\\/h4>\\n<ul>\\n<li>Added: New Query Control<\\/li>\\n<li>Added: Display Conditions \\u2014 Ajax powered fields<\\/li>\\n<li>Added: Display Conditions \\u2014 Current post condition<\\/li>\\n<li>Fixed: Switcher \\u2013 Autoplay not working without entrance animation<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Custom taxonomy archive crumbs<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added option for external sources<\\/li>\\n<\\/ul>\\n<h4> 2.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Google Map \\u2014 Navigation z-index<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default button position to hidden<\\/li>\\n<li>Fixed: Devices \\u2014 Video in window frame not displaying<\\/li>\\n<li>Fixed: Google Map \\u2014 JSON incorrectly reported as invalid<\\/li>\\n<li>Fixed: Switcher \\u2014 Cover picture tag with CSS<\\/li>\\n<li>Fixed: Devices \\u2014 Video css for browser frame<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button transition control<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button border control<\\/li>\\n<li>Added: Hotspots \\u2014 Individual hover controls for each hotspot<\\/li>\\n<li>Added: Audio Player \\u2014 Option to loop playlist<\\/li>\\n<li>Tweak: Google Map \\u2014 Make fields dynamic<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added custom js events<\\/li>\\n<li>Tweak: Audio Player \\u2014 Separate control for play icon size<\\/li>\\n<li>Tweak: Video Player \\u2014 Added custom js events<\\/li>\\n<\\/ul>\\n<h4> 2.0.0 <\\/h4>\\n<ul>\\n<li>New Extension: Display Conditions<\\/li>\\n<li>New Widget: Google Map<\\/li>\\n<li>New Widget: Popup<\\/li>\\n<li>New Widget: Age Gate<\\/li>\\n<li>New Widget: Toggle Element<\\/li>\\n<li>New Widget: Calendar<\\/li>\\n<li>New Widget: Audio Player<\\/li>\\n<li>New Widget: Offcanvas<\\/li>\\n<li>New Widget: Slide Menu<\\/li>\\n<li>New Widget: Random Image<\\/li>\\n<li>Added: Posts Extra \\u2014 Support for terms from multiple taxonomies<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Include blog posts page in breadcrumbs<\\/li>\\n<li>Added: Switcher \\u2014 New option to add description<\\/li>\\n<li>Added: Sticky Elements \\u2014 Completely rewritten code<\\/li>\\n<li>Added: Sticky Elements \\u2014 Offset bottom control<\\/li>\\n<li>Added: Global Tooltips \\u2014 Control to disable on breakpoint<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to show taxonomy terms for custom post types instead of CPT name<\\/li>\\n<li>Added: Tooltips \\u2014 New trigger on page load<\\/li>\\n<li>Added: Switcher \\u2014 Events to update when inside toggle element<\\/li>\\n<li>Added: Posts Extra \\u2014 Price meta for woocommerce products<\\/li>\\n<li>Added: Posts Extra \\u2014 Button content part replaces read more<\\/li>\\n<li>Added: Posts Extra \\u2014 Post count for filters<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Schema.org properties<\\/li>\\n<li>Fixed: Tooltips \\u2014 Add option to disable on breakpoint<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Destroy on editor mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Out of view sections have wrong background image positions<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Settings not being saved<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Start position option not applying<\\/li>\\n<li>Fixed: Hotspots \\u2014 Image display block<\\/li>\\n<li>Fixed: Unfold \\u2014 Button alignment<\\/li>\\n<li>Fixed: Unfold \\u2014 Button icon position and indent<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Check for woocommerce for price fields<\\/li>\\n<li>Fixed: Video Player \\u2014 Volume size undefined error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 RTL behviour on clicking thumbs<\\/li>\\n<li>Fixed: Inline SVG \\u2014 ACF image field<\\/li>\\n<li>Fixed: Update to getEditModel method<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: License not deactivating if expired<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Distance for top-aligned labels<\\/li>\\n<li>Fixed: Devices + Hotspots \\u2014 Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: Switcher \\u2014 Astra theme images css conflict<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Multiple hierarchical categories not showing<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filtered posts not found message<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong grid item width when filters are active and multiple instances on page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Breacrumbs \\u2014 Wrap crumbs automatically<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Hide fields not available for Current Query option<\\/li>\\n<li>Tweak: Hotspots \\u2014 Default hotspots for better ux<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better behaviour and interactions for video player<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better selection of video source files<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Added playback speed option<\\/li>\\n<li>Tweak: Timeline \\u2014 Support for point numbers and letter for posts<\\/li>\\n<li>Tweak: Table \\u2014 Remove render template to improve editing performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Add bottom margin to custom spacing control<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Increase options for carousel rows and slides to scroll<\\/li>\\n<li>Tweak: Enable docs link in admin settings page<\\/li>\\n<li>Tweak: Switcher \\u2014 Make description field dynamic<\\/li>\\n<li>Tweak: Google Maps \\u2013 Adjust controls structure<\\/li>\\n<li>Tweak: Table \\u2014 Control names<\\/li>\\n<li>Tweak: Text Divider \\u2014 Controls position<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added read more to translatable fields for WPML<\\/li>\\n<\\/ul>\\n<h4> 1.9.16 <\\/h4>\\n<ul>\\n<li>Fixed: Elementor 2.3.0 compatibility<\\/li>\\n<\\/ul>\\n<h4> 1.9.15 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Load more button for multiple widget instances<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Responsive speed options<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Columns above 9 don\'t become full width<\\/li>\\n<li>Tweak: Improve Elementor Pro version dependency and posts widget compatibility<\\/li>\\n<li>Tweak: Timeline \\u2014 Enable dynamic fields for custom source<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Handling of divisions operation in value control<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Option to allow numbers with decimals instead of percetanges<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Options to allow for absolute values to be shown<\\/li>\\n<li>Tweak: Hotspots \\u2014 Make hotspots size and opacity control responsive<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove swiper slide overflow hidden<\\/li>\\n<li>Tweak: Added option to enable updates to beta versions or Extras<\\/li>\\n<\\/ul>\\n<h4> 1.9.14 <\\/h4>\\n<ul>\\n<li>Fixed: Rename resize script to avoid potential conflicts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel flickering when used in Tabs widget and switching tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Date showing current date instead of post date<\\/li>\\n<li>Fixed: Extras admin page conflict with Jetpack<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Link not accessible for preview images with caption<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added query id control for server side filtering of widget queries<\\/li>\\n<li>Tweak: Hotspots \\u2014 HTML valid structure issue<\\/li>\\n<li>Tweak: Table \\u2014 Minor terminology improvements<\\/li>\\n<\\/ul>\\n<h4> 1.9.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Space under image<\\/li>\\n<li>Fixed: Extensions not showing when Elementor Pro not active<\\/li>\\n<\\/ul>\\n<h4> 1.9.12 <\\/h4>\\n<ul>\\n<li>Added: CSS filter controls for widgets<\\/li>\\n<li>Added: Global Tooltips \\u2014 Support for shortcodes and dynamic fields<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Load more button causing error when not paginated<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Content inside media not showing when no thumbnail available<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Media area display conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP warning when excerpt length is empty<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL alignment of posts in masonry mode<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Default control value to string<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Dynamic fields values not working<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Window height calculation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Repeater fields conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Breaks when dynamic field is used<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Allow offset to be used in current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow drafts and scheduled posts to be included<\\/li>\\n<\\/ul>\\n<h4> 1.9.11 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts compatibility with pagination<\\/li>\\n<li>Fixed: Compatibility with new Swiper version in Elementor 2.1<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive date padding and margin controls<\\/li>\\n<\\/ul>\\n<h4> 1.9.10 <\\/h4>\\n<ul>\\n<li>Fixed: Sticky Elements \\u2014 Options appear twice<\\/li>\\n<li>Tweak: Remove group control sticky<\\/li>\\n<\\/ul>\\n<h4> 1.9.9 <\\/h4>\\n<ul>\\n<li>Fixed: Timeline \\u2014 Points and line not aligned on mobile and tablet if size defined only on desktop<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default placeholder image overriding post thumbnail<\\/li>\\n<li>Fixed: Sticky Elements no longer working<\\/li>\\n<li>Fixed: Additional check for active Elementor Pro<\\/li>\\n<li>Tweak: Moved Extras advanced section behind Custom CSS section<\\/li>\\n<\\/ul>\\n<h4> 1.9.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Arrows controls for preview<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to show all filters when using infinite scroll<\\/li>\\n<li>Fixed: Unfold \\u2014 Icon right align not working<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.1 beta<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow excerpt in media area<\\/li>\\n<li>Tweak: Timeline \\u2014 More specific color selectors<\\/li>\\n<li>Tweak: Timeline \\u2014 Text align dates to the right for right hand items<\\/li>\\n<\\/ul>\\n<h4> 1.9.7 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Implemented work-around for warning caused by Elementor bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 images bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Time not showing<\\/li>\\n<li>Fixed: Buttons \\u2014 Wrap buttons by default<\\/li>\\n<li>Fixed: Remove too broad css declaration<\\/li>\\n<li>Fixed: Parallax background \\u2014 Correct element resize function name<\\/li>\\n<\\/ul>\\n<h4> 1.9.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Breaks if pan distance is undefined<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Read more typography control conditions<\\/li>\\n<li>Fixed: Unfold \\u2014 Force icon to show hide as inline block<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Stretch body to align all footers to bottom<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 horizontal layout for posts<\\/li>\\n<li>Fixed: Renamed jquery resize plugin function<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 CSS overflow fix<\\/li>\\n<\\/ul>\\n<h4> 1.9.5 <\\/h4>\\n<ul>\\n<li>Added: Dynamic fields support for all widgets<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Position not being overriden<\\/li>\\n<li>Fixed: Timeline \\u2014 Pointer cursor not showing on linked cards<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image bottom spacing on some themes<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Added unique classes to each item<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added control to enable muted video for autoplay<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added controls to enable or disable all elements inside the bar<\\/li>\\n<\\/ul>\\n<h4> 1.9.4 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Control to center images<\\/li>\\n<li>Added: Posts Extra \\u2014 New filters for post title, excerpt, comments and date<\\/li>\\n<li>Added: HTML5 Video \\u2014 Control to stop all other video players when current one is played.<\\/li>\\n<li>Fixed: Fixed: Column widths in post-css are rendered in the wrong order<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Posts per page doesn\'t take into account sticky posts<\\/li>\\n<li>Fixed: Buttons \\u2014 Item typography group control not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Responsive horizontal alignment for filters<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltip position not being overriden at hotspot level<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Control conditions<\\/li>\\n<li>Tweak: Updated isotope version to 3.0.6 to fix 1px grid gap<\\/li>\\n<li>Tweak: Remove default webkit left padding from list navs<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Increase plugin timeout reinit<\\/li>\\n<li>Tweak: Posts \\u2014 Increase excerpt length filter priority<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added option to show only sticky posts<\\/li>\\n<\\/ul>\\n<h4> 1.9.3 <\\/h4>\\n<ul>\\n<li>Added: Sticky Elements \\u2014 Compatibility with the Lazy Loader wordpress plugin<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Safari &lt; 10.2 layout glitch layout glitch on mobile<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v files condition<\\/li>\\n<li>Fixed: Sticky \\u2014 Sticks only when resizing browser window<\\/li>\\n<li>Fixed: Sticky \\u2014 Not working correctly with Stretched parent<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v format not sufficient<\\/li>\\n<li>Fixed: Image Comparison \\u2013 Allow 0 percent values<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Render attributes<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Control conditions<\\/li>\\n<\\/ul>\\n<h4> 1.9.2 <\\/h4>\\n<ul>\\n<li>Fixed: Switcher \\u2014 Bug with arrow loader position and stroke width in older versions of Safari<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with IE 11<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Control value undefined check<\\/li>\\n<\\/ul>\\n<h4> 1.9.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Max distance not taking into account scroll position<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters not stacking on responsive.<\\/li>\\n<li>Fixed: Switcher \\u2014 Arrow loader not displaying in firefox<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Wrong position for scroll with start position<\\/li>\\n<li>Fixed: GSAP dependencies<\\/li>\\n<\\/ul>\\n<h4> 1.9.0 <\\/h4>\\n<ul>\\n<li>Added: New Switcher Widget! \\u2014 Switch photos and text using powerful javascript driven transitions. Features menu and arrows navigation, autoplay with progress loader, entrance animations, page background color switcher, two skins (default and overlay) and much more.<\\/li>\\n<li>Added: New Feature for Parallax Elements! \\u2014 Option to parallax columns and widgets on mouse move<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to style only sticky posts<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable clicking on labels to uncover images<\\/li>\\n<li>Added: Hotspots \\u2014 Separate color controls for each hotspot<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts not working when a category is selected in the query<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Invisible gallery when preview position is top on desktop<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove labels if no text is present<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Hide carousel until properly rendered<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Added alt and title tags to image element<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Issue with negative margin resulting in right whitespace for the gallery<\\/li>\\n<li>Fixed: Timeline \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Timeline \\u2014 Item point color override<\\/li>\\n<li>Fixed: Timeline \\u2014 Properly override point content<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Removed group control<\\/li>\\n<li>Tweak: Gallery Extra, Gallery Slider, Posts Extra \\u2014 Added notice with link to blend mode browser support for blend mode controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Added repeater setting key method to card render function<\\/li>\\n<\\/ul>\\n<h4> 1.8.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Control width and ratio of each individual image in manual mode<\\/li>\\n<li>Added: Timeline \\u2014 Option for automatic numbering and letters instead of icons to points<\\/li>\\n<li>Added: Timeline \\u2014 New control to set excerpt length<\\/li>\\n<li>Added: Unfold \\u2014 Option to change icon when unfolded<\\/li>\\n<li>Added: Sticky Elements \\u2014 Option to turn off bottoming of elements inside the parent<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to enable sticky posts in query<\\/li>\\n<li>Added: Posts Extra \\u2014 Arrows sizing controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Transition control for carousel arrows and pagination<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to set how many slides to scroll<\\/li>\\n<li>Added: Image Comparison \\u2014 Control to define initial position of separator<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable moving separator by clicking anywhere on the image<\\/li>\\n<li>Added: Buttons \\u2014 Control for label min width<\\/li>\\n<li>Added: Hotspots \\u2014 Control to disable pulsating animation<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Controls not showing on inner sections<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Images wider than 100% on mobile in manual mixed masonry layout mode<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 CSS bottom whitespace<\\/li>\\n<li>Fixed: Buttons \\u2014 Remove block label for buttons icon, id and class controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Take sticky posts into consideration in query<\\/li>\\n<li>Tweak: Unfold \\u2014 Organise controls<\\/li>\\n<li>Tweak: WPML Compatibility \\u2014 Change method to fix fields not saving<\\/li>\\n<\\/ul>\\n<h4> 1.8.7 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Filtering one widget\'s posts affects all other widgets<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips have an extra space at the bottom when first hovering<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Volume functionality breaks when controls are hidden<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Video reloading after each loop<\\/li>\\n<li>Added: Global Tooltips \\u2014 Global controls for distance and width<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added width and horizontal alignment control to player<\\/li>\\n<li>Tweak: Global Tooltips \\u2014 Remove default global styling values after Elementor enqueue fix in 1.9.5<\\/li>\\n<\\/ul>\\n<h4> 1.8.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Term slug classes to filters and post terms<\\/li>\\n<li>Fixed: Replaced create_function with anonymous function for PHP 7.2 support<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Handle internal CSS in non color overriding situations<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips showing even if they have no content<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Prevent sticky on a section that is stretched with js<\\/li>\\n<li>Tweak: Buttons \\u2014 Move typography control above tabs<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Move hover animation controls to separate section for better ux<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Default font size for thumbnail captions<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fix condition<\\/li>\\n<li>Tweak: Hotspots \\u2014 Show label for tooltip content in editor<\\/li>\\n<\\/ul>\\n<h4> 1.8.5 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Missing js dependency<\\/li>\\n<\\/ul>\\n<h4> 1.8.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Random ordering not working<\\/li>\\n<li>Fixed: Timeline \\u2014 RTL optimisation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Custom image size not working on manual mode<\\/li>\\n<li>Tweak: Add dismissible notice for recommended php version<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Add title and description caption types<\\/li>\\n<li>Tweak: Timeline \\u2014 Add link control description to avoid linking cards when content already contains links<\\/li>\\n<\\/ul>\\n<h4> 1.8.3 <\\/h4>\\n<ul>\\n<li>Fixed: HTML5 Video \\u2014 Video not playing on Safari and some mobile environments<\\/li>\\n<li>Fixed: Buttons \\u2014 Safari buttons vertical alignment<\\/li>\\n<li>Fixed: Devices \\u2014 device not displaying on Safari when portrait mode is enabled<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Grid broken on Safari<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 reinit masonry when images done loading<\\/li>\\n<li>Tweak: Move all Extras admin settings into Elementor menu<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Remove default value for width control<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 default mobile and tablet gallery columns to larger numbers<\\/li>\\n<\\/ul>\\n<h4> 1.8.2 <\\/h4>\\n<ul>\\n<li>Added: Parallax Background \\u2014 Support for section resize in elementor preview mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Compatibility with stretched section<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Interface style controls conditions<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Right side white-space after thumbnails on top preview position<\\/li>\\n<li>Fixed: Unfold \\u2014 Page stops responding when entering invalid html in text editor mode<\\/li>\\n<li>Tweak: Unfold \\u2014 Allow accordions, tabs and all resizing elements inside content<\\/li>\\n<\\/ul>\\n<h4> 1.8.1 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Masonry broken when infinite scroll is enabled<\\/li>\\n<\\/ul>\\n<h4> 1.8.0 <\\/h4>\\n<ul>\\n<li>New extension: Global Tooltips \\u2014 Add a tooltip to any widget<\\/li>\\n<li>New: Disable Widgets &amp; Extensions \\u2014 You can now disable Extras widgets and extensions via the admin settings page<\\/li>\\n<li>Added: WPML compatibility \\u2014 String Translation and Translation Editor support for all widgets<\\/li>\\n<li>Added: Circle Progress \\u2014 Icon support inside circle<\\/li>\\n<li>Added: Update .pot translation file<\\/li>\\n<li>Added: Buttons \\u2014 Tooltips duration control<\\/li>\\n<li>Added: Global settings for Extras tooltips<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Widget not available on multisite installations<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll breaks when using multiple widgets on same page<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Anywhere Elementor Pro featured image background<\\/li>\\n<li>Tweak: Parallax Background \\u2014 requestAnimationFrame method for better performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Rename text align label<\\/li>\\n<li>Tweak: Update nicons font<\\/li>\\n<\\/ul>\\n<h4> 1.7.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Custom link broken and attributes not added<\\/li>\\n<\\/ul>\\n<h4> 1.7.3 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Column vertical alignment controls for carousel<\\/li>\\n<li>Added: Timeline \\u2014  Color controls for post title and excerpt<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel rows number control not impacting preview<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar vertical alignment on stretched media content<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Incorrect spacer height<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improve editing flow by with advanced controls conditioning<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Controls position<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Remove popover from group control<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Remove popover from group control<\\/li>\\n<\\/ul>\\n<h4> 1.7.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Overlay captions for preview and thumbnails<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for caption effects, layout and hover properties<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for active thumbs caption<\\/li>\\n<li>Fixed: Buttons \\u2014 Removed popover control on effects<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved carousel adapt on preview resize<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved thumbnails grid<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better controls for stacking and position of preview<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Replace background color with background control for preview captions and overlay<\\/li>\\n<li>Tweak: Gallery Slider + Gallery Extra \\u2014 Better BEM classes<\\/li>\\n<\\/ul>\\n<h4> 1.7.1 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Ratio and alignment controls to masonry layout<\\/li>\\n<li>Added: Gallery Extra \\u2014 New border and border radius controls for captions<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Bring image to front when hovered<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Images not displaying on infinite load on iOS Safari and Chrome<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Force override of modified image max-width attribute<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added extra classes to media elements<\\/li>\\n<\\/ul>\\n<h4> 1.7.0 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Masonry layout with mixed mode<\\/li>\\n<li>Added: Gallery Extra \\u2014 Tilt effect<\\/li>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay, caption and image transition controls<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay blend mode control<\\/li>\\n<li>Added: Gallery Extra \\u2014 Image scale controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay margin controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Manual mode that allows entering of every image manually and linking it to any URL<\\/li>\\n<li>Added: Inline SVG widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to disable linking for post title, media and terms<\\/li>\\n<li>Added: Posts Extra \\u2014 Control to select default applied filter for filter bar<\\/li>\\n<li>Added: Timeline \\u2014 New controls for post title typography and spacing, post excerpt typography and padding<\\/li>\\n<li>Added: Image Comparison \\u2014 Image size control<\\/li>\\n<li>Added: New css transition control for Gallery Extra, Gallery Slider, Hotspots, Posts Extra, Timeline, Table and Inline SVG widgets<\\/li>\\n<li>Added: HTML5 Video \\u2014 M4V format support<\\/li>\\n<li>Added: Devices \\u2014 M4V format support for video<\\/li>\\n<li>Fixed: Buttons \\u2014 Flicker on flip effect<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS class conflict<\\/li>\\n<li>Fixed: Table \\u2014 ID and class don\'t apply to header<\\/li>\\n<li>Tweak: Improved Elementor 1.9 compatibility for Extras group controls<\\/li>\\n<li>Tweak: Update TweenMax to latest version (1.20.2)<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Simplified CSS<\\/li>\\n<li>Tweak: Unfold \\u2014 Disconnect button and content from control alignment logic<\\/li>\\n<\\/ul>\\n<h4> 1.6.3 <\\/h4>\\n<ul>\\n<li>Fixed: Breadcrumbs \\u2014 Display correctly when used within an Elementor library template<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Condition terms separator<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Avoid naming conflict with Elementor Pro widget<\\/li>\\n<\\/ul>\\n<h4> 1.6.2 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 New autoplay, autoheight and fade effect controls<\\/li>\\n<li>Added: Posts Extra \\u2014 &quot;Top&quot; option to media position on horizontal layout<\\/li>\\n<li>Added: Posts Extra \\u2014 Allowed media to be positioned horizontally on 2 columns layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 New border controls for media<\\/li>\\n<li>Added: Table \\u2014 Allow table responsive behaviour to be turned off<\\/li>\\n<li>Tweak: Buttons \\u2014 Default button content alignment to justify<\\/li>\\n<li>Fix: Timeline \\u2014 Potential fatal error<\\/li>\\n<li>Fix: Posts Extra \\u2014 Post media position controls conditions<\\/li>\\n<li>Fix: Buttons \\u2014 Delay on transitioned properties<\\/li>\\n<li>Fix: Posts Extra \\u2014 Wrong tablet breakpoint set for number of columns<\\/li>\\n<li>Fix: Parallax Background \\u2014 Remove initial background image once parallax is activated<\\/li>\\n<\\/ul>\\n<h4> 1.6.1 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Link author name and avatar to author posts pages<\\/li>\\n<li>Added: Posts Extra \\u2014 Read more link to excerpt<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added separate hide option for Position for better UX <\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improved position icons<\\/li>\\n<\\/ul>\\n<h4> 1.6.0 <\\/h4>\\n<ul>\\n<li>New Widget \\u2014 Posts Extra - Create ANY layout for posts with masonry, infinite load, filtering and custom post type support. Works only with Elementor Pro<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Added horizontal position and text alignment controls<\\/li>\\n<li>Tweak: Buttons \\u2014 Improved CSS and better alignment and stacking options<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Error outputting separator<\\/li>\\n<li>Fixed: Buttons \\u2014 Transition on button content when effects are turned on<\\/li>\\n<\\/ul>\\n<h4> 1.5.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Replaced parallax class name to avoid future conflicts<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove flex from left aligned timeline and allow image spacing for horizontal layouts<\\/li>\\n<li>Fixed: PHP fatal error<\\/li>\\n<li>Tweak: Unfold \\u2014 Switched Settings with Content sections in editor for better UX<\\/li>\\n<\\/ul>\\n<h4> 1.5.5 <\\/h4>\\n<ul>\\n<li>Added: Buttons \\u2014 Inline editing<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Inline editing<\\/li>\\n<li>Added: Circle Progress \\u2014 Inline editing<\\/li>\\n<li>Added: Hotspots \\u2014 Inline editing<\\/li>\\n<li>Added: Image Comparison \\u2014 Inline editing<\\/li>\\n<li>Added: Table \\u2014 Inline editing<\\/li>\\n<li>Added: Text Divider \\u2014 Inline editing<\\/li>\\n<li>Added: Timeline \\u2014 Inline editing<\\/li>\\n<li>Added: Unfold \\u2014 Inline editing<\\/li>\\n<li>Fixed: Tooltips \\u2014 Error &quot;size&quot; of undefined appears for delay_in in some cases<\\/li>\\n<li>Fixed: Unfold \\u2014 Issue that resulted in wrong calculation of unfolded height<\\/li>\\n<li>Tweak: Default to text cursor for text where inline editing is available<\\/li>\\n<\\/ul>\\n<h4> 1.5.4 <\\/h4>\\n<ul>\\n<li>Added: HTML5 Video \\u2014 Option to end video at last frame<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Removed auto pausing when interacting with progress bar<\\/li>\\n<\\/ul>\\n<h4> 1.5.3 <\\/h4>\\n<ul>\\n<li>Fixed: Unfold \\u2014 Content folds back automatically when scrolling on mobile browsers that vertically resize the viewport<\\/li>\\n<\\/ul>\\n<h4> 1.5.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Allow gallery navigation in lightbox<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image box shadow not applying<\\/li>\\n<li>Fixed: Buttons \\u2014 Issue with transition delays on buttons without effects<\\/li>\\n<\\/ul>\\n<h4> 1.5.1 <\\/h4>\\n<ul>\\n<li>Added: Table \\u2014 Control to show header on mobile as a block or a column<\\/li>\\n<li>Added: Table \\u2014 Border control for table rows<\\/li>\\n<li>Added: Table \\u2014 Option to automatically try to fetch correct headers for mobile with override possibility<\\/li>\\n<li>Added: Table \\u2014 Control to set width for mobile headers<\\/li>\\n<li>Tweak: Table \\u2014 Remove column rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Removed first \\/ last child border rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Added pointer cursor on sortable header cells<\\/li>\\n<li>Tweak: Table \\u2014 Moved padding to text for better handling of responsive layout and removed negative margin technique<\\/li>\\n<li>Tweak: Table \\u2014 Responsive cells and header cells padding controls<\\/li>\\n<li>Tweak: Table \\u2014 Move cell header control to top<\\/li>\\n<li>Tweak: Table \\u2014 Added option to hide headers completely on mobile<\\/li>\\n<li>Tweak: Table \\u2014 Hide mobile headers that have no content<\\/li>\\n<li>Tweak: Sticky \\u2014 Set default z-index to 1 for stickable elements<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Separator not showing<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove space between images and widget container<\\/li>\\n<li>Fixed: Table \\u2014 PHP Warning when allowing empty on repeater fields<\\/li>\\n<li>Fixed: Table \\u2014 Width and alignment not working<\\/li>\\n<li>Fixed: Table \\u2014 Added missing custom class and id from markup<\\/li>\\n<\\/ul>\\n<h4> 1.5.0 <\\/h4>\\n<ul>\\n<li>New Widget: Table<\\/li>\\n<li>Fixed: Prefix CSS helper classes to avoid potential conflicts<\\/li>\\n<\\/ul>\\n<h4> 1.4.0 <\\/h4>\\n<ul>\\n<li>New: Buttons Effects<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Control to manually specify which post or page to generate breadcrumbs for<\\/li>\\n<li>Fixed: Devices \\u2014 Horizontal orientation image not visible<\\/li>\\n<\\/ul>\\n<h4> 1.3.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Wrong position when loading page off viewport<\\/li>\\n<li>Fixed: Timeline \\u2014 Enlarged points not aligned to line on tablet and mobile<\\/li>\\n<li>Added: Timeline \\u2014 Responsive controls for point size and icon size<\\/li>\\n<\\/ul>\\n<h4> 1.3.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 HTML5 Video<\\/li>\\n<li>Added: Devices \\u2014 Added HTML5 Video controls<\\/li>\\n<li>Added: Devices \\u2014 Added option to stretch the video to fit into the device screen<\\/li>\\n<li>Added: Devices \\u2014 Added option to choose wether or not to stop the video when leaving viewport<\\/li>\\n<li>Added: Timeline \\u2014 Hover properties for points<\\/li>\\n<li>Added: Timeline \\u2014 More style override options for each card<\\/li>\\n<li>Added: Gallery Slider \\u2014 More responsive controls for preview position and spacing<\\/li>\\n<li>Fixed: Timeline \\u2014 Removed unnecessary z-index from cards<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Preview spacing doesn\'t work on mobile when the layout is vertical<\\/li>\\n<li>Fixed: Devices \\u2014 Replaced SVG IDs with classes to avoid code invalidation<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Canvas distorted on responsive<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links concatenating from one repeater field to another<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Images move up after scrolling up and down multiple times<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Background position is off when section Stretch is turned on<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links inside tooltips appear outside of the tooltip<\\/li>\\n<li>Tweak: Timeline \\u2014 Changed &quot;Size Ratio&quot; name to &quot;Scale&quot;<\\/li>\\n<li>Tweak: Gallery Extras \\u2014 Bring 3D items to front on hover<\\/li>\\n<li>Tweak: Hotspots \\u2014 Moved tooltip content outside hotspot to avoid invalid nodes<\\/li>\\n<li>Tweak: Hotspots \\u2014 Don\'t activate tooltips that have no content set<\\/li>\\n<\\/ul>\\n<h4> 1.2.5 <\\/h4>\\n<ul>\\n<li>Tweak: Replaced text align icons with horizontal align icons where appropriate<\\/li>\\n<li>Fixed: Sticky elements not bottoming out correctly when using custom parent selector<\\/li>\\n<li>Fixed: Removing unstick for any breakpoint would break sticky functionality<\\/li>\\n<\\/ul>\\n<h4> 1.2.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky \\u2014 Custom selector for sticky parent to allow for elements to stick in any parent element<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive padding controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Refactoring and improved performance and accuracy on progress bar<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Adjust spacing method for labels and vertical alignment improvements<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Allow for widget border radius control to affect images<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Scroll breaks on mobile when hiding a parallaxed section<\\/li>\\n<li>Fixed: Timeline \\u2014 Cards not animating when first in view<\\/li>\\n<li>Fixed: Timeline \\u2014 Content wrapper present even if no card content is set<\\/li>\\n<\\/ul>\\n<h4> 1.2.3 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Section background not reverting after parallax turned on again<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Calculating wrong dimensions when using Elementor JS stretch option<\\/li>\\n<li>Fixed: Issue where updating Elementor when Extras is active would result in an error<\\/li>\\n<li>Tweak: Hotspots \\u2014 Adjusted default tooltip width<\\/li>\\n<\\/ul>\\n<h4> 1.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Complete html support<\\/li>\\n<\\/ul>\\n<h4> 1.2.1 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Gradient would show only for the first line<\\/li>\\n<li>Fixed: Parallax Background \\u2014 When using padding on sections, image position calculation would not be correct<\\/li>\\n<\\/ul>\\n<h4> 1.2.0 <\\/h4>\\n<ul>\\n<li>Added: New Feature! \\u2014 Parallax Background \\u2014 Now you can parallax section backgrounds and have it move up, down, left or right while scrolling<\\/li>\\n<li>Added: New Widget! \\u2014 Unfold \\u2014 Lets you hide content and reveal it on demand<\\/li>\\n<li>Added: New Widget! \\u2014 Breadcrumbs<\\/li>\\n<li>Added: Parallax Elements \\u2014 Allow to select whether to parallax an element relative to its own position or the middle of the viewport<\\/li>\\n<li>Added: Hotspots \\u2014 Ability to add links to hotspots if tooltips are triggered on hover<\\/li>\\n<li>Added: Tooltips \\u2014 Added left and right tooltips for both Hotspots and Button Groups<\\/li>\\n<li>Added: Tooltips \\u2014 Better handling of repositioning tooltips when they flow outside of the viewport<\\/li>\\n<li>Added: Tooltips \\u2014 Ability to override tooltip position for each button of hotspot individually<\\/li>\\n<li>Added: Heading Extra \\u2014 Text fill now supports clipped images<\\/li>\\n<li>Tweak: Heading Extra \\u2014 Allow to have both text shadow and long shadow on the same text<\\/li>\\n<li>Tweak: Text Divider \\u2014 Responsive alignment and spacing controls<\\/li>\\n<li>Tweak: Text Divider \\u2014 Proper horizontal alignment of text and separators<\\/li>\\n<li>Fixed: Heading Extra \\u2014 Multiple z-index related issues<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Fix issue where elements would jump when scrolling<\\/li>\\n<\\/ul>\\n<h4> 1.1.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky sections!<\\/li>\\n<li>Added: Sticky \\u2014 New controls to unstick for mobile and tablet<\\/li>\\n<li>Added: Parallax Elements \\u2014 New controls to set different speeds for different breakpoints<\\/li>\\n<li>Added: Gallery Slider \\u2014 Links on images and support for the new Elementor lightbox feature<\\/li>\\n<li>Tweak: Improved shortcode support for all widgets, especially tooltips<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Greatly improved performance for parallaxed items<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Changed speed control logic to allow for reverse parallax<\\/li>\\n<li>Tweak: Created custom group controls for Sticky and Parallax features<\\/li>\\n<li>Fixed: Removed z-index from sticky elements to allow z-index setting from Elementor controls<\\/li>\\n<li>Fixed: Gallery Extras \\u2014 Some styling controls were conditioned by the &quot;Link to&quot; control<\\/li>\\n<li>Fixed: Removed potentially buggy call to Elementor class<\\/li>\\n<\\/ul>\\n<h4> 1.1.3 <\\/h4>\\n<ul>\\n<li>Tweak: Devices \\u2014 Refactored and cleaned up code for editor functionality<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved distance control after parallax controls<\\/li>\\n<li>Added: Controls to add parallax to any widget or column<\\/li>\\n<li>Added: Global control for turning off parallax functionality for tablet and mobile<\\/li>\\n<li>Added: Gallery Extra \\u2014 Control for settings horizontal overlap of images<\\/li>\\n<li>Added: Image Comparison \\u2014 Separator between images<\\/li>\\n<li>Added: Global \\u2014 Implemented the new Text Shadow controls for all widgets<\\/li>\\n<li>Added: Button Groups \\u2014 Responsive control of spacing for stacked buttons<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where frames would not properly change in editor mode<\\/li>\\n<li>Fixed: Changed license page capability to \'manage_options\'<\\/li>\\n<li>Fixed: Compatibility with Elementor 1.6<\\/li>\\n<\\/ul>\\n<h4> 1.1.2 <\\/h4>\\n<ul>\\n<li>Fixed: Class namespace change in Elementor Pro 1.5.7 resulting in fatal error<\\/li>\\n<\\/ul>\\n<h4> 1.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Devices \\u2014 Overlay not visible for laptop and desktop<\\/li>\\n<li>Fixed: Timeline \\u2014 PHP empty function fatal error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Width remained 50% even if vertical layout selected<\\/li>\\n<\\/ul>\\n<h4> 1.1.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 Gallery Extra \\u2014 We\'ve taken aside the parallax functionality and created a whole new widget with nots of posibilities.<\\/li>\\n<li>Added: New Widget! \\u2014 Gallery Slider \\u2014 A gallery layout with inline preview.<\\/li>\\n<li>Added: New Feature! \\u2014 Button tooltips \\u2014 You can now use the Button Groups widget to add buttons with tooltips.<\\/li>\\n<li>Added: New Feature! \\u2014 Timeline \\u2014 Integration with Woocommerce products.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Added support for icons inside hotspots.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Ability to set the delay for both entrance close animations.<\\/li>\\n<li>Added: Circle Progress \\u2014 Control too choose start angle for the circle progress.<\\/li>\\n<li>Added: Devices \\u2014 Support for multiple video formats<\\/li>\\n<li>Added: Timeline \\u2014 Add featured images from separate control.<\\/li>\\n<li>Added: Elementor Portfolio Widget \\u2014 Speed control for parallax feature.<\\/li>\\n<li>Added: Timeline \\u2014 Turn on and off for excerpts, content, title and featured image.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle now goes all the way until the end of the image.<\\/li>\\n<li>Fixed: Timeline \\u2014 Date color wasn\'t changing properly.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<li>Fixed: Sticky - Issue where in preview mode wrong height of the element was calculated.<\\/li>\\n<li>Fixed: Image Gallery \\u2014 Issue with displaying on Firefox.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle jumps when using multiple widgets on same page.<\\/li>\\n<li>Fixed: Timeline \\u2014 Scheme style override issue for points.<\\/li>\\n<li>Fixed: Devices \\u2014 Video would not play on iOS devices<\\/li>\\n<\\/ul>\\n<h4> 1.0.5 <\\/h4>\\n<ul>\\n<li>Added: Button Groups \\u2014 Box shadow control.<\\/li>\\n<li>Fixed: Ensured compatibility with other jquery appear plugins.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<\\/ul>\\n<h4> 1.0.4 <\\/h4>\\n<ul>\\n<li>Added: Added translation support<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where controls would always display as a white rectangular shape.<\\/li>\\n<\\/ul>\\n<h4> 1.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Image Galleries \\u2014 Issue where galleries with no links would break the layout<\\/li>\\n<li>Fixed: Hotspots \\u2014 When using multiple hotspots widgets on the same page additional widgets would show the first widget\'s tooltips instead of their own<\\/li>\\n<\\/ul>\\n<h4> 1.0.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 New controls: text align, padding, border and typography<\\/li>\\n<li>Fixed: Hotspots \\u2014 Hide arrow control not working<\\/li>\\n<li>Fixed: Hotspots \\u2014 Issue where tooltips don\'t remain open on click trigger option and thus preventing clicking off links inside tooltips<\\/li>\\n<li>Fixed: Button Groups \\u2014 Replaced custom border controls with border group control<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Compability with Elementor 1.5<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Heading size not working<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Issue where colors of labels would not change colors for printed templates<\\/li>\\n<\\/ul>\\n<h4> 1.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Image Comparison \\u2014 Issue where dragging the handle on mobile would not work<\\/li>\\n<\\/ul>\\n<h4> 1.0.0 <\\/h4>\\n<ul>\\n<li>Added: New &quot;Timeline&quot; widget with posts support for Elementor Pro<\\/li>\\n<li>Added: Image Comparison \\u2014 Different colors for both labels<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Moved alignment &amp; scaling options to widget wrapper<\\/li>\\n<li>Tweak: Aligned default widgets colors to selected color scheme<\\/li>\\n<li>Tweak: Removed sticky from sections temporarily<\\/li>\\n<li>Tweak: Removed parallax scrolling from section backgrounds<\\/li>\\n<li>Tweak: Button Groups \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Tweak: Full compatibility with global color schemes for all widgets<\\/li>\\n<li>Tweak: Hotspots \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Issue where arrow colors would not apply<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Entrace animation hides the shadow when animation is complete<\\/li>\\n<li>Fixed: Devices \\u2014 Border type not present in hover state for video controls<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Removed small space after widget<\\/li>\\n<li>Fixed: Hotspots \\u2014 Syntax error in JS template<\\/li>\\n<li>Fixed: Hotspots \\u2014 JS error when adding new hotpots<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips z-index issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Bottom tooltips animated down instead of up<\\/li>\\n<li>Fixed: Hotspots \\u2014 Html being added as string when hotspots are triggered through the open_editor hook<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips not editable immediately when dragged into preview<\\/li>\\n<li>Fixed: Image Comparison \\u2014 images are not set to occupy full width<\\/li>\\n<\\/ul>\\n<h4> 0.1.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 Rewrote code entirely to allow for preview mode support, customisation of tooltips and faster rendering<\\/li>\\n<li>Added: Circle progress \\u2014 Better handling of value suffix<\\/li>\\n<li>Fixed: Scripts dependencies<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where global colors where used instead of skins<\\/li>\\n<li>Fixed: Various compatibility issues with the Elementor color scheme<\\/li>\\n<li>Fixed: Image Gallery Extension \\u2014 Styling issues when choosing to justify gallery items<\\/li>\\n<li>Fixed: Sticky Extension \\u2014 Sitcky offset would not preview correctly and sometimes having multiple sticky widgets would cause interference amongst them<\\/li>\\n<li>Fixed: Parallax Gallery \\u2014 Removed any kinds of transformation for odd children<\\/li>\\n<\\/ul>\\n<h4> 0.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Buttons groups \\u2014 Responsive alignment of buttons<\\/li>\\n<li>Added: Buttons groups \\u2014 option to stack buttons on tablet or mobile<\\/li>\\n<\\/ul>\\n<h4> 0.1.0 <\\/h4>\\n<ul>\\n<li>Initial Private Beta<\\/li>\\n<\\/ul>\"],\"installation\":[\"<ol>\\n<li>Make sure Elementor is installed and active on your website<\\/li>\\n<li>Activate the plugin through the \'Plugins\' menu in WordPress<\\/li>\\n<li>Edit a page (or post) using Elementor<\\/li>\\n<li>Find and use the new widgets and extensions<\\/li>\\n<\\/ol>\"]}\";}", "no");
INSERT INTO `wp_522243_options` VALUES("497", "elementor_log", "a:5:{s:32:\"da655534c69f6331e161b26abe429dc9\";O:32:\"Elementor\\Core\\Logger\\Items\\Base\":7:{s:7:\"\0*\0date\";s:19:\"2020-05-03 02:47:51\";s:7:\"\0*\0type\";s:4:\"info\";s:10:\"\0*\0message\";s:50:\"Elementor data updater process has been completed.\";s:7:\"\0*\0meta\";a:3:{s:6:\"plugin\";s:9:\"Elementor\";s:4:\"from\";s:5:\"2.9.7\";s:2:\"to\";s:5:\"2.9.8\";}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2020-05-03 02:47:51\";}s:7:\"\0*\0args\";a:3:{s:4:\"meta\";a:3:{s:6:\"plugin\";s:9:\"Elementor\";s:4:\"from\";s:5:\"2.9.7\";s:2:\"to\";s:5:\"2.9.8\";}s:7:\"message\";s:50:\"Elementor data updater process has been completed.\";s:4:\"type\";s:4:\"info\";}}s:32:\"b0dc55d449a3a0be84e0f976bb20c1e5\";O:32:\"Elementor\\Core\\Logger\\Items\\Base\":7:{s:7:\"\0*\0date\";s:19:\"2020-05-03 02:50:22\";s:7:\"\0*\0type\";s:4:\"info\";s:10:\"\0*\0message\";s:50:\"Elementor data updater process has been completed.\";s:7:\"\0*\0meta\";a:3:{s:6:\"plugin\";s:13:\"Elementor Pro\";s:4:\"from\";s:5:\"2.8.5\";s:2:\"to\";s:5:\"2.9.3\";}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2020-05-03 02:50:22\";}s:7:\"\0*\0args\";a:3:{s:4:\"meta\";a:3:{s:6:\"plugin\";s:13:\"Elementor Pro\";s:4:\"from\";s:5:\"2.8.5\";s:2:\"to\";s:5:\"2.9.3\";}s:7:\"message\";s:50:\"Elementor data updater process has been completed.\";s:4:\"type\";s:4:\"info\";}}s:32:\"51175a578ddc6a8fda02b22efdccd7eb\";O:30:\"Elementor\\Core\\Logger\\Items\\JS\":10:{s:9:\"\0*\0column\";s:4:\"2683\";s:7:\"\0*\0file\";s:104:\"https://nikkijames.net/wp-content/plugins/elementor-pro/assets/lib/sticky/jquery.sticky.min.js?ver=2.9.3\";s:7:\"\0*\0line\";s:1:\"1\";s:7:\"\0*\0date\";s:19:\"2020-05-03 10:13:20\";s:7:\"\0*\0type\";s:5:\"error\";s:10:\"\0*\0message\";s:123:\"Failed to execute \\&#039;getComputedStyle\\&#039; on \\&#039;Window\\&#039;: parameter 1 is not of type \\&#039;Element\\&#039;.\";s:7:\"\0*\0meta\";a:0:{}s:8:\"\0*\0times\";i:6;s:14:\"\0*\0times_dates\";a:6:{i:0;s:19:\"2020-05-03 10:13:20\";i:1;s:19:\"2020-05-03 10:13:22\";i:2;s:19:\"2020-05-03 10:13:24\";i:3;s:19:\"2020-05-03 10:13:31\";i:4;s:19:\"2020-05-03 10:13:56\";i:5;s:19:\"2020-05-03 10:14:00\";}s:7:\"\0*\0args\";a:6:{s:4:\"type\";s:5:\"error\";s:9:\"timestamp\";s:10:\"1588500800\";s:7:\"message\";s:93:\"Failed to execute \\\'getComputedStyle\\\' on \\\'Window\\\': parameter 1 is not of type \\\'Element\\\'.\";s:3:\"url\";s:104:\"https://nikkijames.net/wp-content/plugins/elementor-pro/assets/lib/sticky/jquery.sticky.min.js?ver=2.9.3\";s:4:\"line\";s:1:\"1\";s:6:\"column\";s:4:\"2683\";}}s:32:\"5b57413389aa43f5f1bf0ca72f9a05aa\";O:30:\"Elementor\\Core\\Logger\\Items\\JS\":10:{s:9:\"\0*\0column\";s:5:\"58852\";s:7:\"\0*\0file\";s:95:\"https://nikkijames.net/wp-content/plugins/elementor/assets/js/frontend-modules.min.js?ver=2.9.8\";s:7:\"\0*\0line\";s:1:\"2\";s:7:\"\0*\0date\";s:19:\"2020-05-03 10:28:22\";s:7:\"\0*\0type\";s:5:\"error\";s:10:\"\0*\0message\";s:58:\"Cannot read property \\&#039;attributes\\&#039; of undefined\";s:7:\"\0*\0meta\";a:0:{}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2020-05-03 10:28:22\";}s:7:\"\0*\0args\";a:6:{s:4:\"type\";s:5:\"error\";s:9:\"timestamp\";s:10:\"1588501702\";s:7:\"message\";s:48:\"Cannot read property \\\'attributes\\\' of undefined\";s:3:\"url\";s:95:\"https://nikkijames.net/wp-content/plugins/elementor/assets/js/frontend-modules.min.js?ver=2.9.8\";s:4:\"line\";s:1:\"2\";s:6:\"column\";s:5:\"58852\";}}s:32:\"102b8a48b5191cdb886507924f645c7a\";O:30:\"Elementor\\Core\\Logger\\Items\\JS\":10:{s:9:\"\0*\0column\";s:5:\"30645\";s:7:\"\0*\0file\";s:279:\"https://nikkijames.net/wp-admin/load-scripts.php?c=0&loadchunk_0=underscore,jquery-core,jquery-migrate,backbone,jquery-ui-core,jquery-ui-widget,jquery-ui-mouse,shortcode,utils,wp-util,wp-backbo&loadchunk_1=ne,media-models,moxiejs,plupload,wp-plupload,jquery-ui-sortable&ver=5.4.1\";s:7:\"\0*\0line\";s:1:\"6\";s:7:\"\0*\0date\";s:19:\"2020-05-03 10:52:55\";s:7:\"\0*\0type\";s:5:\"error\";s:10:\"\0*\0message\";s:59:\"Cannot read property \\&#039;pageYOffset\\&#039; of undefined\";s:7:\"\0*\0meta\";a:0:{}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2020-05-03 10:52:55\";}s:7:\"\0*\0args\";a:6:{s:4:\"type\";s:5:\"error\";s:9:\"timestamp\";s:10:\"1588503175\";s:7:\"message\";s:49:\"Cannot read property \\\'pageYOffset\\\' of undefined\";s:3:\"url\";s:279:\"https://nikkijames.net/wp-admin/load-scripts.php?c=0&loadchunk_0=underscore,jquery-core,jquery-migrate,backbone,jquery-ui-core,jquery-ui-widget,jquery-ui-mouse,shortcode,utils,wp-util,wp-backbo&loadchunk_1=ne,media-models,moxiejs,plupload,wp-plupload,jquery-ui-sortable&ver=5.4.1\";s:4:\"line\";s:1:\"6\";s:6:\"column\";s:5:\"30645\";}}}", "no");
INSERT INTO `wp_522243_options` VALUES("508", "itsec_highlighted_logs", "a:3:{s:11:\"highlighted\";a:0:{}s:7:\"markers\";a:0:{}s:5:\"muted\";a:1:{s:18:\"file-change-report\";i:1588499285;}}", "no");
INSERT INTO `wp_522243_options` VALUES("521", "itsec_active_modules", "a:6:{s:9:\"ban-users\";b:1;s:6:\"backup\";b:1;s:11:\"brute-force\";b:1;s:19:\"network-brute-force\";b:1;s:16:\"wordpress-tweaks\";b:1;s:18:\"security-check-pro\";b:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("522", "dashboard-welcome-for-elementor_allow_tracking", "no", "yes");
INSERT INTO `wp_522243_options` VALUES("523", "dashboard-welcome-for-elementor_tracking_notice", "hide", "yes");
INSERT INTO `wp_522243_options` VALUES("528", "_elementor_general_settings", "a:13:{s:21:\"default_generic_fonts\";s:10:\"Sans-serif\";s:15:\"container_width\";s:4:\"1260\";s:23:\"lightbox_enable_counter\";s:0:\"\";s:26:\"lightbox_enable_fullscreen\";s:0:\"\";s:20:\"lightbox_enable_zoom\";s:0:\"\";s:21:\"lightbox_enable_share\";s:0:\"\";s:18:\"lightbox_title_src\";s:0:\"\";s:24:\"lightbox_description_src\";s:0:\"\";s:14:\"lightbox_color\";s:19:\"rgba(0, 0, 0, 0.77)\";s:17:\"lightbox_ui_color\";s:7:\"#FFFFFF\";s:23:\"lightbox_ui_color_hover\";s:7:\"#FFFFFF\";s:19:\"lightbox_icons_size\";a:3:{s:4:\"unit\";s:2:\"px\";s:4:\"size\";i:15;s:5:\"sizes\";a:0:{}}s:26:\"lightbox_slider_icons_size\";a:3:{s:4:\"unit\";s:2:\"px\";s:4:\"size\";i:15;s:5:\"sizes\";a:0:{}}}", "yes");
INSERT INTO `wp_522243_options` VALUES("529", "_elementor_settings_update_time", "1588499432", "yes");
INSERT INTO `wp_522243_options` VALUES("530", "elementor_cpt_support", "a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("531", "elementor_disable_color_schemes", "", "yes");
INSERT INTO `wp_522243_options` VALUES("532", "elementor_disable_typography_schemes", "", "yes");
INSERT INTO `wp_522243_options` VALUES("533", "elementor_default_generic_fonts", "Sans-serif", "yes");
INSERT INTO `wp_522243_options` VALUES("534", "elementor_container_width", "1260", "yes");
INSERT INTO `wp_522243_options` VALUES("538", "elementor_viewport_lg", "", "yes");
INSERT INTO `wp_522243_options` VALUES("540", "elementor_viewport_md", "950", "yes");
INSERT INTO `wp_522243_options` VALUES("542", "elementor_pro_recaptcha_site_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("543", "elementor_pro_recaptcha_secret_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("544", "elementor_pro_recaptcha_v3_site_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("545", "elementor_pro_recaptcha_v3_secret_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("546", "elementor_pro_recaptcha_v3_threshold", "0.5", "yes");
INSERT INTO `wp_522243_options` VALUES("547", "elementor_pro_facebook_app_id", "", "yes");
INSERT INTO `wp_522243_options` VALUES("548", "elementor_pro_mailchimp_api_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("549", "elementor_validate_api_data", "", "yes");
INSERT INTO `wp_522243_options` VALUES("550", "elementor_pro_drip_api_token", "", "yes");
INSERT INTO `wp_522243_options` VALUES("551", "elementor_pro_activecampaign_api_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("552", "elementor_pro_activecampaign_api_url", "", "yes");
INSERT INTO `wp_522243_options` VALUES("553", "elementor_pro_getresponse_api_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("554", "elementor_pro_convertkit_api_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("555", "elementor_pro_mailerlite_api_key", "", "yes");
INSERT INTO `wp_522243_options` VALUES("556", "elementor_typekit-kit-id", "", "yes");
INSERT INTO `wp_522243_options` VALUES("557", "elementor_font_awesome_pro_kit_id", "", "yes");
INSERT INTO `wp_522243_options` VALUES("558", "elementor_css_print_method", "external", "yes");
INSERT INTO `wp_522243_options` VALUES("559", "elementor_editor_break_lines", "", "yes");
INSERT INTO `wp_522243_options` VALUES("560", "elementor_allow_svg", "", "yes");
INSERT INTO `wp_522243_options` VALUES("561", "elementor_load_fa4_shim", "", "yes");
INSERT INTO `wp_522243_options` VALUES("576", "pa_save_settings", "a:24:{s:14:\"premium-banner\";i:1;s:12:\"premium-blog\";i:0;s:16:\"premium-carousel\";i:0;s:17:\"premium-countdown\";i:0;s:15:\"premium-counter\";i:0;s:19:\"premium-dual-header\";i:0;s:17:\"premium-fancytext\";i:1;s:23:\"premium-image-separator\";i:0;s:12:\"premium-maps\";i:0;s:16:\"premium-modalbox\";i:0;s:14:\"premium-person\";i:0;s:19:\"premium-progressbar\";i:0;s:20:\"premium-testimonials\";i:0;s:13:\"premium-title\";i:1;s:16:\"premium-videobox\";i:0;s:21:\"premium-pricing-table\";i:1;s:14:\"premium-button\";i:1;s:19:\"premium-contactform\";i:0;s:20:\"premium-image-button\";i:0;s:12:\"premium-grid\";i:1;s:15:\"premium-vscroll\";i:1;s:20:\"premium-image-scroll\";i:1;s:17:\"premium-templates\";i:0;s:18:\"premium-duplicator\";i:0;}", "yes");
INSERT INTO `wp_522243_options` VALUES("577", "hscroll_notice", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("578", "elementor-custom-breakpoints-files", "a:2:{s:19:\"custom-frontend.min\";a:1:{s:4:\"time\";i:1588499841;}s:23:\"custom-pro-frontend.min\";a:1:{s:4:\"time\";i:1588500243;}}", "yes");
INSERT INTO `wp_522243_options` VALUES("579", "elementor_pro_theme_builder_conditions", "a:0:{}", "yes");
INSERT INTO `wp_522243_options` VALUES("584", "elementor_scheme_color", "a:4:{i:1;s:7:\"#6ec1e4\";i:2;s:7:\"#54595f\";i:3;s:7:\"#7a7a7a\";i:4;s:7:\"#61ce70\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("585", "elementor_scheme_typography", "a:4:{i:1;a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:11:\"font_weight\";s:3:\"600\";}i:2;a:2:{s:11:\"font_family\";s:11:\"Roboto Slab\";s:11:\"font_weight\";s:3:\"400\";}i:3;a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:11:\"font_weight\";s:3:\"400\";}i:4;a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:11:\"font_weight\";s:3:\"500\";}}", "yes");
INSERT INTO `wp_522243_options` VALUES("586", "elementor_scheme_color-picker", "a:8:{i:1;s:7:\"#6ec1e4\";i:2;s:7:\"#54595f\";i:3;s:7:\"#7a7a7a\";i:4;s:7:\"#61ce70\";i:5;s:7:\"#4054b2\";i:6;s:7:\"#23a455\";i:7;s:4:\"#000\";i:8;s:4:\"#fff\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("587", "elementor_active_kit", "290", "yes");
INSERT INTO `wp_522243_options` VALUES("588", "temp_count", "a:2:{s:11:\"Gianna page\";s:10:\"Nikki page\";s:11:\"Default Kit\";s:11:\"Default Kit\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("589", "elementor_controls_usage", "a:2:{s:4:\"page\";a:13:{s:6:\"spacer\";a:2:{s:5:\"count\";i:8;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:14:\"section_spacer\";a:3:{s:5:\"space\";i:6;s:12:\"space_mobile\";i:3;s:12:\"space_tablet\";i:3;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:1:{s:7:\"_margin\";i:3;}s:19:\"_section_background\";a:14:{s:22:\"_background_background\";i:2;s:17:\"_background_image\";i:2;s:24:\"_background_image_tablet\";i:2;s:20:\"_background_position\";i:2;s:16:\"_background_size\";i:2;s:16:\"_background_ypos\";i:2;s:24:\"_background_image_mobile\";i:2;s:27:\"_background_position_mobile\";i:2;s:22:\"_background_attachment\";i:2;s:25:\"_background_repeat_mobile\";i:2;s:23:\"_background_size_mobile\";i:2;s:27:\"_background_position_tablet\";i:2;s:25:\"_background_repeat_tablet\";i:2;s:23:\"_background_size_tablet\";i:2;}s:15:\"_section_border\";a:2:{s:14:\"_border_radius\";i:2;s:21:\"_border_radius_tablet\";i:1;}}}}s:6:\"column\";a:2:{s:5:\"count\";i:14;s:8:\"controls\";a:3:{s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:10;s:13:\"margin_mobile\";i:6;s:14:\"padding_tablet\";i:3;s:6:\"margin\";i:4;s:13:\"margin_tablet\";i:3;s:14:\"padding_mobile\";i:2;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:2;}s:15:\"section_effects\";a:1:{s:9:\"animation\";i:3;}}s:6:\"layout\";a:1:{s:6:\"layout\";a:5:{s:16:\"content_position\";i:7;s:21:\"space_between_widgets\";i:5;s:12:\"_inline_size\";i:7;s:19:\"_inline_size_tablet\";i:2;s:23:\"content_position_mobile\";i:1;}}s:5:\"style\";a:2:{s:14:\"section_border\";a:4:{s:12:\"border_width\";i:3;s:12:\"border_color\";i:3;s:13:\"border_radius\";i:2;s:13:\"border_border\";i:1;}s:13:\"section_style\";a:3:{s:16:\"background_color\";i:2;s:21:\"background_background\";i:2;s:15:\"background_size\";i:2;}}}}s:7:\"heading\";a:2:{s:5:\"count\";i:7;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:5:{s:5:\"title\";i:7;s:11:\"header_size\";i:6;s:5:\"align\";i:7;s:4:\"link\";i:2;s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:15:{s:11:\"title_color\";i:7;s:21:\"typography_typography\";i:7;s:22:\"typography_font_family\";i:7;s:20:\"typography_font_size\";i:7;s:27:\"typography_font_size_mobile\";i:5;s:22:\"typography_font_weight\";i:7;s:29:\"typography_line_height_mobile\";i:3;s:22:\"typography_line_height\";i:4;s:27:\"typography_font_size_tablet\";i:3;s:25:\"typography_letter_spacing\";i:5;s:28:\"text_shadow_text_shadow_type\";i:2;s:23:\"text_shadow_text_shadow\";i:3;s:32:\"typography_letter_spacing_mobile\";i:1;s:25:\"typography_text_transform\";i:5;s:21:\"typography_font_style\";i:2;}}s:8:\"advanced\";a:5:{s:15:\"section_effects\";a:4:{s:10:\"_animation\";i:4;s:16:\"_animation_delay\";i:3;s:6:\"sticky\";i:1;s:13:\"sticky_parent\";i:1;}s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:6;s:14:\"_margin_mobile\";i:6;s:8:\"_padding\";i:3;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:3;s:17:\"_background_color\";i:3;}s:15:\"_section_border\";a:4:{s:14:\"_border_radius\";i:2;s:14:\"_border_border\";i:1;s:13:\"_border_width\";i:1;s:13:\"_border_color\";i:1;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:2;}}}}s:11:\"text-editor\";a:2:{s:5:\"count\";i:4;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:4;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:12:{s:5:\"align\";i:4;s:12:\"align_mobile\";i:2;s:10:\"text_color\";i:3;s:21:\"typography_typography\";i:3;s:22:\"typography_font_family\";i:3;s:20:\"typography_font_size\";i:3;s:22:\"typography_line_height\";i:2;s:25:\"typography_letter_spacing\";i:1;s:27:\"typography_font_size_tablet\";i:2;s:29:\"typography_line_height_tablet\";i:2;s:22:\"typography_font_weight\";i:3;s:27:\"typography_font_size_mobile\";i:1;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:7:{s:7:\"_margin\";i:4;s:14:\"_margin_mobile\";i:3;s:8:\"_padding\";i:3;s:14:\"_margin_tablet\";i:2;s:15:\"_padding_tablet\";i:2;s:12:\"_css_classes\";i:1;s:15:\"_padding_mobile\";i:1;}s:15:\"section_effects\";a:3:{s:10:\"_animation\";i:1;s:18:\"animation_duration\";i:1;s:16:\"_animation_delay\";i:1;}s:17:\"_section_position\";a:7:{s:9:\"_position\";i:1;s:16:\"_offset_x_tablet\";i:1;s:21:\"_offset_orientation_v\";i:1;s:13:\"_offset_y_end\";i:1;s:20:\"_offset_y_end_mobile\";i:1;s:16:\"_offset_x_mobile\";i:1;s:13:\"_offset_x_end\";i:1;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:1;}}}}s:7:\"section\";a:2:{s:5:\"count\";i:9;s:8:\"controls\";a:3:{s:5:\"style\";a:4:{s:18:\"section_background\";a:21:{s:21:\"background_background\";i:5;s:16:\"background_image\";i:2;s:19:\"background_position\";i:2;s:17:\"background_repeat\";i:2;s:15:\"background_size\";i:2;s:15:\"background_ypos\";i:1;s:19:\"background_bg_width\";i:1;s:21:\"background_video_link\";i:1;s:22:\"background_video_start\";i:1;s:20:\"background_video_end\";i:1;s:22:\"background_size_mobile\";i:1;s:23:\"background_image_mobile\";i:2;s:26:\"background_position_mobile\";i:2;s:21:\"background_attachment\";i:2;s:24:\"background_repeat_mobile\";i:1;s:23:\"background_image_tablet\";i:2;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:16:\"background_color\";i:3;s:22:\"background_xpos_mobile\";i:1;s:26:\"background_position_tablet\";i:1;}s:26:\"section_background_overlay\";a:14:{s:29:\"background_overlay_background\";i:5;s:24:\"background_overlay_color\";i:2;s:26:\"background_overlay_opacity\";i:4;s:29:\"background_overlay_color_stop\";i:1;s:26:\"background_overlay_color_b\";i:1;s:33:\"background_overlay_gradient_angle\";i:1;s:32:\"background_overlay_gradient_type\";i:1;s:24:\"background_overlay_image\";i:2;s:25:\"background_overlay_repeat\";i:2;s:23:\"background_overlay_size\";i:2;s:27:\"background_overlay_bg_width\";i:2;s:27:\"background_overlay_position\";i:2;s:20:\"css_filters_contrast\";i:2;s:20:\"css_filters_saturate\";i:2;}s:14:\"section_border\";a:4:{s:12:\"border_width\";i:1;s:12:\"border_color\";i:1;s:13:\"border_radius\";i:3;s:21:\"box_shadow_box_shadow\";i:1;}s:21:\"section_shape_divider\";a:7:{s:23:\"shape_divider_top_color\";i:3;s:24:\"shape_divider_top_height\";i:3;s:20:\"shape_divider_bottom\";i:2;s:26:\"shape_divider_bottom_color\";i:2;s:26:\"shape_divider_bottom_width\";i:2;s:27:\"shape_divider_bottom_height\";i:2;s:17:\"shape_divider_top\";i:1;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:6;s:14:\"padding_tablet\";i:7;s:14:\"padding_mobile\";i:8;s:6:\"margin\";i:4;s:13:\"margin_mobile\";i:3;s:7:\"z_index\";i:1;}s:19:\"_section_responsive\";a:1:{s:20:\"reverse_order_mobile\";i:4;}}s:6:\"layout\";a:2:{s:14:\"section_layout\";a:7:{s:6:\"height\";i:1;s:13:\"custom_height\";i:1;s:15:\"column_position\";i:1;s:20:\"custom_height_tablet\";i:1;s:20:\"custom_height_mobile\";i:1;s:13:\"content_width\";i:6;s:6:\"layout\";i:2;}s:17:\"section_structure\";a:1:{s:9:\"structure\";i:5;}}}}s:6:\"button\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_button\";a:4:{s:4:\"text\";i:1;s:5:\"align\";i:1;s:4:\"size\";i:1;s:4:\"link\";i:1;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:15:{s:21:\"typography_typography\";i:1;s:22:\"typography_font_family\";i:1;s:20:\"typography_font_size\";i:1;s:22:\"typography_font_weight\";i:1;s:25:\"typography_text_transform\";i:1;s:25:\"typography_letter_spacing\";i:1;s:17:\"button_text_color\";i:1;s:16:\"background_color\";i:1;s:11:\"hover_color\";i:1;s:29:\"button_background_hover_color\";i:1;s:12:\"border_width\";i:1;s:12:\"border_color\";i:1;s:13:\"border_radius\";i:1;s:22:\"typography_line_height\";i:1;s:15:\"hover_animation\";i:1;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:1;s:14:\"_margin_mobile\";i:1;}s:15:\"section_effects\";a:2:{s:10:\"_animation\";i:1;s:16:\"_animation_delay\";i:1;}s:19:\"_section_background\";a:5:{s:22:\"_background_background\";i:1;s:20:\"_background_position\";i:1;s:18:\"_background_repeat\";i:1;s:16:\"_background_size\";i:1;s:20:\"_background_bg_width\";i:1;}}}}s:14:\"media-carousel\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:2:{s:14:\"section_slides\";a:10:{s:6:\"slides\";i:1;s:15:\"slides_per_view\";i:1;s:22:\"slides_per_view_tablet\";i:1;s:22:\"slides_per_view_mobile\";i:1;s:6:\"height\";i:1;s:13:\"height_tablet\";i:1;s:13:\"height_mobile\";i:1;s:6:\"effect\";i:1;s:15:\"centered_slides\";i:1;s:16:\"slides_to_scroll\";i:1;}s:26:\"section_additional_options\";a:6:{s:5:\"speed\";i:1;s:4:\"icon\";i:1;s:11:\"show_arrows\";i:1;s:14:\"autoplay_speed\";i:1;s:15:\"image_size_size\";i:1;s:20:\"pause_on_interaction\";i:1;}}s:5:\"style\";a:2:{s:18:\"section_navigation\";a:3:{s:12:\"arrows_color\";i:1;s:14:\"play_icon_size\";i:1;s:11:\"arrows_size\";i:1;}s:20:\"section_slides_style\";a:6:{s:13:\"space_between\";i:1;s:22:\"slide_background_color\";i:1;s:17:\"slide_border_size\";i:1;s:19:\"slide_border_radius\";i:1;s:18:\"slide_border_color\";i:1;s:13:\"slide_padding\";i:1;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:2:{s:12:\"_css_classes\";i:1;s:8:\"_padding\";i:1;}s:15:\"section_effects\";a:1:{s:10:\"_animation\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:1;s:17:\"_background_color\";i:1;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}}}}s:13:\"gallery-extra\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:2:{s:15:\"section_gallery\";a:2:{s:12:\"gallery_type\";i:1;s:7:\"gallery\";i:1;}s:24:\"section_gallery_settings\";a:5:{s:7:\"columns\";i:1;s:14:\"columns_tablet\";i:1;s:14:\"columns_mobile\";i:1;s:13:\"open_lightbox\";i:1;s:23:\"gallery_display_caption\";i:1;}}s:5:\"style\";a:3:{s:22:\"section_gallery_layout\";a:5:{s:11:\"image_align\";i:1;s:20:\"image_vertical_align\";i:1;s:24:\"image_horizontal_spacing\";i:1;s:22:\"image_vertical_spacing\";i:1;s:8:\"overflow\";i:1;}s:22:\"section_gallery_images\";a:3:{s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:21:\"section_hover_effects\";a:3:{s:27:\"image_transition_transition\";i:1;s:23:\"image_transition_easing\";i:1;s:17:\"image_scale_hover\";i:1;}}}}s:10:\"price-list\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:2;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:16:{s:13:\"heading_color\";i:2;s:29:\"heading_typography_typography\";i:2;s:30:\"heading_typography_font_family\";i:2;s:17:\"description_color\";i:2;s:33:\"description_typography_typography\";i:2;s:34:\"description_typography_font_family\";i:2;s:39:\"description_typography_font_size_tablet\";i:2;s:34:\"description_typography_line_height\";i:2;s:41:\"description_typography_line_height_tablet\";i:2;s:17:\"separator_spacing\";i:2;s:28:\"heading_typography_font_size\";i:2;s:30:\"heading_typography_font_weight\";i:2;s:29:\"heading_typography_font_style\";i:1;s:32:\"description_typography_font_size\";i:2;s:34:\"description_typography_font_weight\";i:2;s:33:\"description_typography_font_style\";i:2;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:2;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:3:{s:7:\"_margin\";i:2;s:8:\"_padding\";i:2;s:14:\"_margin_mobile\";i:2;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:2;s:17:\"_background_color\";i:2;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:2;}}}}s:12:\"social-icons\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:19:\"section_social_icon\";a:2:{s:16:\"social_icon_list\";i:1;s:5:\"align\";i:1;}}s:5:\"style\";a:2:{s:20:\"section_social_style\";a:9:{s:10:\"icon_color\";i:1;s:18:\"icon_primary_color\";i:1;s:20:\"icon_secondary_color\";i:1;s:9:\"icon_size\";i:1;s:12:\"icon_padding\";i:1;s:12:\"icon_spacing\";i:1;s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:20:\"section_social_hover\";a:3:{s:19:\"hover_primary_color\";i:1;s:21:\"hover_secondary_color\";i:1;s:15:\"hover_animation\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:1;s:14:\"_margin_tablet\";i:1;s:8:\"_z_index\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:11:\"menu-anchor\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:14:\"section_anchor\";a:1:{s:6:\"anchor\";i:1;}}}}s:4:\"form\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:1;s:13:\"mark_required\";i:1;}s:21:\"section_submit_button\";a:6:{s:11:\"button_text\";i:1;s:11:\"button_size\";i:1;s:17:\"button_icon_align\";i:1;s:18:\"button_icon_indent\";i:1;s:19:\"button_align_tablet\";i:1;s:20:\"selected_button_icon\";i:1;}s:20:\"section_form_options\";a:3:{s:15:\"success_message\";i:1;s:13:\"error_message\";i:1;s:15:\"custom_messages\";i:1;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:1;s:18:\"email_content_type\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:8:{s:7:\"row_gap\";i:1;s:11:\"label_color\";i:1;s:19:\"mark_required_color\";i:1;s:27:\"label_typography_typography\";i:1;s:26:\"label_typography_font_size\";i:1;s:28:\"label_typography_font_weight\";i:1;s:33:\"label_typography_font_size_mobile\";i:1;s:28:\"label_typography_font_family\";i:1;}s:19:\"section_field_style\";a:8:{s:16:\"field_text_color\";i:1;s:27:\"field_typography_typography\";i:1;s:26:\"field_typography_font_size\";i:1;s:18:\"field_border_color\";i:1;s:19:\"field_border_radius\";i:1;s:28:\"field_typography_font_family\";i:1;s:22:\"field_background_color\";i:1;s:28:\"field_typography_font_weight\";i:1;}s:20:\"section_button_style\";a:15:{s:23:\"button_background_color\";i:1;s:17:\"button_text_color\";i:1;s:28:\"button_typography_typography\";i:1;s:32:\"button_typography_text_transform\";i:1;s:29:\"button_background_hover_color\";i:1;s:18:\"button_hover_color\";i:1;s:20:\"button_border_radius\";i:1;s:20:\"button_border_border\";i:1;s:19:\"button_border_width\";i:1;s:19:\"button_border_color\";i:1;s:29:\"button_typography_font_family\";i:1;s:25:\"button_hover_border_color\";i:1;s:22:\"button_hover_animation\";i:1;s:27:\"button_typography_font_size\";i:1;s:29:\"button_typography_font_weight\";i:1;}}s:8:\"advanced\";a:2:{s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:1;s:8:\"_padding\";i:1;}}}}s:7:\"divider\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:15:\"section_divider\";a:1:{s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:21:\"section_divider_style\";a:1:{s:5:\"color\";i:1;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:1:{s:14:\"_margin_mobile\";i:1;}s:19:\"_section_responsive\";a:2:{s:12:\"hide_desktop\";i:1;s:11:\"hide_tablet\";i:1;}}}}}s:7:\"wp-page\";a:14:{s:6:\"spacer\";a:2:{s:5:\"count\";i:6;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:14:\"section_spacer\";a:3:{s:5:\"space\";i:4;s:12:\"space_mobile\";i:3;s:12:\"space_tablet\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:1:{s:7:\"_margin\";i:1;}}}}s:6:\"column\";a:2:{s:5:\"count\";i:14;s:8:\"controls\";a:3:{s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:10;s:13:\"margin_mobile\";i:6;s:14:\"padding_tablet\";i:3;s:6:\"margin\";i:4;s:13:\"margin_tablet\";i:3;s:14:\"padding_mobile\";i:2;}s:15:\"section_effects\";a:1:{s:9:\"animation\";i:3;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:1;}}s:6:\"layout\";a:1:{s:6:\"layout\";a:5:{s:16:\"content_position\";i:7;s:21:\"space_between_widgets\";i:5;s:12:\"_inline_size\";i:7;s:19:\"_inline_size_tablet\";i:2;s:23:\"content_position_mobile\";i:1;}}s:5:\"style\";a:2:{s:14:\"section_border\";a:4:{s:12:\"border_width\";i:3;s:12:\"border_color\";i:3;s:13:\"border_radius\";i:2;s:13:\"border_border\";i:1;}s:13:\"section_style\";a:3:{s:16:\"background_color\";i:2;s:21:\"background_background\";i:2;s:15:\"background_size\";i:2;}}}}s:7:\"heading\";a:2:{s:5:\"count\";i:7;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:5:{s:5:\"title\";i:7;s:11:\"header_size\";i:6;s:5:\"align\";i:7;s:4:\"link\";i:2;s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:15:{s:11:\"title_color\";i:7;s:21:\"typography_typography\";i:7;s:22:\"typography_font_family\";i:7;s:20:\"typography_font_size\";i:7;s:27:\"typography_font_size_mobile\";i:5;s:22:\"typography_font_weight\";i:7;s:29:\"typography_line_height_mobile\";i:3;s:22:\"typography_line_height\";i:4;s:27:\"typography_font_size_tablet\";i:3;s:25:\"typography_letter_spacing\";i:5;s:28:\"text_shadow_text_shadow_type\";i:2;s:23:\"text_shadow_text_shadow\";i:3;s:32:\"typography_letter_spacing_mobile\";i:1;s:25:\"typography_text_transform\";i:5;s:21:\"typography_font_style\";i:2;}}s:8:\"advanced\";a:5:{s:15:\"section_effects\";a:4:{s:10:\"_animation\";i:4;s:16:\"_animation_delay\";i:3;s:6:\"sticky\";i:1;s:13:\"sticky_parent\";i:1;}s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:6;s:14:\"_margin_mobile\";i:6;s:8:\"_padding\";i:3;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:3;s:17:\"_background_color\";i:3;}s:15:\"_section_border\";a:4:{s:14:\"_border_radius\";i:2;s:14:\"_border_border\";i:1;s:13:\"_border_width\";i:1;s:13:\"_border_color\";i:1;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:2;}}}}s:7:\"section\";a:2:{s:5:\"count\";i:9;s:8:\"controls\";a:3:{s:5:\"style\";a:4:{s:18:\"section_background\";a:26:{s:21:\"background_background\";i:5;s:16:\"background_image\";i:2;s:19:\"background_position\";i:2;s:17:\"background_repeat\";i:2;s:15:\"background_size\";i:2;s:15:\"background_ypos\";i:1;s:19:\"background_bg_width\";i:1;s:21:\"background_video_link\";i:1;s:22:\"background_video_start\";i:1;s:20:\"background_video_end\";i:1;s:22:\"background_size_mobile\";i:1;s:23:\"background_image_mobile\";i:2;s:26:\"background_position_mobile\";i:2;s:21:\"background_attachment\";i:2;s:24:\"background_repeat_mobile\";i:1;s:23:\"background_image_tablet\";i:2;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:40:\"background_motion_fx_motion_fx_scrolling\";i:1;s:38:\"background_motion_fx_translateY_effect\";i:1;s:37:\"background_motion_fx_translateY_speed\";i:1;s:37:\"background_motion_fx_translateX_speed\";i:1;s:16:\"background_color\";i:4;s:22:\"background_xpos_mobile\";i:1;s:26:\"background_position_tablet\";i:1;s:22:\"background_ypos_mobile\";i:1;}s:26:\"section_background_overlay\";a:14:{s:29:\"background_overlay_background\";i:5;s:24:\"background_overlay_color\";i:2;s:26:\"background_overlay_opacity\";i:5;s:29:\"background_overlay_color_stop\";i:1;s:26:\"background_overlay_color_b\";i:1;s:33:\"background_overlay_gradient_angle\";i:1;s:32:\"background_overlay_gradient_type\";i:1;s:24:\"background_overlay_image\";i:2;s:25:\"background_overlay_repeat\";i:2;s:23:\"background_overlay_size\";i:2;s:27:\"background_overlay_bg_width\";i:2;s:27:\"background_overlay_position\";i:2;s:20:\"css_filters_contrast\";i:2;s:20:\"css_filters_saturate\";i:2;}s:14:\"section_border\";a:4:{s:12:\"border_width\";i:1;s:12:\"border_color\";i:1;s:13:\"border_radius\";i:3;s:21:\"box_shadow_box_shadow\";i:1;}s:21:\"section_shape_divider\";a:7:{s:23:\"shape_divider_top_color\";i:3;s:24:\"shape_divider_top_height\";i:3;s:20:\"shape_divider_bottom\";i:2;s:26:\"shape_divider_bottom_color\";i:2;s:26:\"shape_divider_bottom_width\";i:2;s:27:\"shape_divider_bottom_height\";i:2;s:17:\"shape_divider_top\";i:1;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:6;s:14:\"padding_tablet\";i:7;s:14:\"padding_mobile\";i:8;s:6:\"margin\";i:4;s:13:\"margin_mobile\";i:3;s:7:\"z_index\";i:1;}s:19:\"_section_responsive\";a:1:{s:20:\"reverse_order_mobile\";i:4;}}s:6:\"layout\";a:2:{s:14:\"section_layout\";a:7:{s:6:\"height\";i:1;s:13:\"custom_height\";i:1;s:15:\"column_position\";i:1;s:20:\"custom_height_tablet\";i:1;s:20:\"custom_height_mobile\";i:1;s:13:\"content_width\";i:6;s:6:\"layout\";i:2;}s:17:\"section_structure\";a:1:{s:9:\"structure\";i:5;}}}}s:11:\"text-editor\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:2;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:11:{s:5:\"align\";i:2;s:10:\"text_color\";i:2;s:21:\"typography_typography\";i:2;s:22:\"typography_font_family\";i:2;s:20:\"typography_font_size\";i:2;s:22:\"typography_line_height\";i:1;s:27:\"typography_font_size_tablet\";i:1;s:29:\"typography_line_height_tablet\";i:1;s:22:\"typography_font_weight\";i:2;s:12:\"align_mobile\";i:2;s:27:\"typography_font_size_mobile\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:7:{s:7:\"_margin\";i:2;s:14:\"_margin_mobile\";i:2;s:8:\"_padding\";i:2;s:14:\"_margin_tablet\";i:1;s:15:\"_padding_tablet\";i:1;s:12:\"_css_classes\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:6:\"button\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_button\";a:6:{s:4:\"text\";i:2;s:5:\"align\";i:2;s:4:\"size\";i:2;s:4:\"link\";i:2;s:12:\"align_mobile\";i:1;s:13:\"selected_icon\";i:1;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:15:{s:21:\"typography_typography\";i:2;s:22:\"typography_font_family\";i:2;s:20:\"typography_font_size\";i:2;s:22:\"typography_font_weight\";i:2;s:25:\"typography_text_transform\";i:2;s:25:\"typography_letter_spacing\";i:2;s:17:\"button_text_color\";i:2;s:16:\"background_color\";i:2;s:11:\"hover_color\";i:2;s:29:\"button_background_hover_color\";i:2;s:12:\"border_width\";i:2;s:12:\"border_color\";i:2;s:13:\"border_radius\";i:2;s:22:\"typography_line_height\";i:2;s:15:\"hover_animation\";i:2;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:2;s:14:\"_margin_mobile\";i:2;}s:15:\"section_effects\";a:2:{s:10:\"_animation\";i:2;s:16:\"_animation_delay\";i:2;}s:19:\"_section_background\";a:5:{s:22:\"_background_background\";i:2;s:20:\"_background_position\";i:2;s:18:\"_background_repeat\";i:2;s:16:\"_background_size\";i:2;s:20:\"_background_bg_width\";i:2;}s:19:\"_section_responsive\";a:3:{s:11:\"hide_mobile\";i:1;s:12:\"hide_desktop\";i:1;s:11:\"hide_tablet\";i:1;}}}}s:14:\"media-carousel\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:2:{s:14:\"section_slides\";a:10:{s:6:\"slides\";i:1;s:15:\"slides_per_view\";i:1;s:22:\"slides_per_view_tablet\";i:1;s:22:\"slides_per_view_mobile\";i:1;s:6:\"height\";i:1;s:13:\"height_tablet\";i:1;s:13:\"height_mobile\";i:1;s:6:\"effect\";i:1;s:15:\"centered_slides\";i:1;s:16:\"slides_to_scroll\";i:1;}s:26:\"section_additional_options\";a:6:{s:5:\"speed\";i:1;s:4:\"icon\";i:1;s:11:\"show_arrows\";i:1;s:14:\"autoplay_speed\";i:1;s:15:\"image_size_size\";i:1;s:20:\"pause_on_interaction\";i:1;}}s:5:\"style\";a:2:{s:18:\"section_navigation\";a:3:{s:12:\"arrows_color\";i:1;s:14:\"play_icon_size\";i:1;s:11:\"arrows_size\";i:1;}s:20:\"section_slides_style\";a:6:{s:13:\"space_between\";i:1;s:22:\"slide_background_color\";i:1;s:17:\"slide_border_size\";i:1;s:19:\"slide_border_radius\";i:1;s:18:\"slide_border_color\";i:1;s:13:\"slide_padding\";i:1;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:2:{s:12:\"_css_classes\";i:1;s:8:\"_padding\";i:1;}s:15:\"section_effects\";a:1:{s:10:\"_animation\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:1;s:17:\"_background_color\";i:1;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}}}}s:7:\"gallery\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:8:\"settings\";a:8:{s:7:\"gallery\";i:1;s:9:\"galleries\";i:1;s:8:\"order_by\";i:1;s:8:\"lazyload\";i:1;s:14:\"columns_mobile\";i:1;s:10:\"gap_mobile\";i:1;s:12:\"aspect_ratio\";i:1;s:20:\"thumbnail_image_size\";i:1;}}}}s:20:\"premium-image-scroll\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:16:\"general_settings\";a:3:{s:5:\"image\";i:2;s:12:\"image_height\";i:2;s:19:\"image_height_mobile\";i:1;}}}}s:10:\"price-list\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:2;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:16:{s:13:\"heading_color\";i:2;s:29:\"heading_typography_typography\";i:2;s:30:\"heading_typography_font_family\";i:2;s:17:\"description_color\";i:2;s:33:\"description_typography_typography\";i:2;s:34:\"description_typography_font_family\";i:2;s:39:\"description_typography_font_size_tablet\";i:2;s:34:\"description_typography_line_height\";i:2;s:41:\"description_typography_line_height_tablet\";i:2;s:17:\"separator_spacing\";i:2;s:28:\"heading_typography_font_size\";i:2;s:30:\"heading_typography_font_weight\";i:2;s:29:\"heading_typography_font_style\";i:1;s:32:\"description_typography_font_size\";i:2;s:34:\"description_typography_font_weight\";i:2;s:33:\"description_typography_font_style\";i:2;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:2;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:3:{s:7:\"_margin\";i:2;s:8:\"_padding\";i:2;s:14:\"_margin_mobile\";i:2;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:2;s:17:\"_background_color\";i:2;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:2;}}}}s:12:\"social-icons\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:19:\"section_social_icon\";a:2:{s:16:\"social_icon_list\";i:1;s:5:\"align\";i:1;}}s:5:\"style\";a:2:{s:20:\"section_social_style\";a:9:{s:10:\"icon_color\";i:1;s:18:\"icon_primary_color\";i:1;s:20:\"icon_secondary_color\";i:1;s:9:\"icon_size\";i:1;s:12:\"icon_padding\";i:1;s:12:\"icon_spacing\";i:1;s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:20:\"section_social_hover\";a:3:{s:19:\"hover_primary_color\";i:1;s:21:\"hover_secondary_color\";i:1;s:15:\"hover_animation\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:1;s:14:\"_margin_tablet\";i:1;s:8:\"_z_index\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:11:\"menu-anchor\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:14:\"section_anchor\";a:1:{s:6:\"anchor\";i:1;}}}}s:4:\"form\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:1;s:13:\"mark_required\";i:1;}s:21:\"section_submit_button\";a:7:{s:11:\"button_text\";i:1;s:11:\"button_size\";i:1;s:17:\"button_icon_align\";i:1;s:18:\"button_icon_indent\";i:1;s:19:\"button_align_tablet\";i:1;s:20:\"selected_button_icon\";i:1;s:19:\"button_align_mobile\";i:1;}s:20:\"section_form_options\";a:3:{s:15:\"success_message\";i:1;s:13:\"error_message\";i:1;s:15:\"custom_messages\";i:1;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:1;s:18:\"email_content_type\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:8:{s:7:\"row_gap\";i:1;s:11:\"label_color\";i:1;s:19:\"mark_required_color\";i:1;s:27:\"label_typography_typography\";i:1;s:26:\"label_typography_font_size\";i:1;s:28:\"label_typography_font_weight\";i:1;s:33:\"label_typography_font_size_mobile\";i:1;s:28:\"label_typography_font_family\";i:1;}s:19:\"section_field_style\";a:8:{s:16:\"field_text_color\";i:1;s:27:\"field_typography_typography\";i:1;s:26:\"field_typography_font_size\";i:1;s:18:\"field_border_color\";i:1;s:19:\"field_border_radius\";i:1;s:28:\"field_typography_font_family\";i:1;s:22:\"field_background_color\";i:1;s:28:\"field_typography_font_weight\";i:1;}s:20:\"section_button_style\";a:15:{s:23:\"button_background_color\";i:1;s:17:\"button_text_color\";i:1;s:28:\"button_typography_typography\";i:1;s:32:\"button_typography_text_transform\";i:1;s:29:\"button_background_hover_color\";i:1;s:18:\"button_hover_color\";i:1;s:20:\"button_border_radius\";i:1;s:20:\"button_border_border\";i:1;s:19:\"button_border_width\";i:1;s:19:\"button_border_color\";i:1;s:29:\"button_typography_font_family\";i:1;s:25:\"button_hover_border_color\";i:1;s:22:\"button_hover_animation\";i:1;s:27:\"button_typography_font_size\";i:1;s:29:\"button_typography_font_weight\";i:1;}}s:8:\"advanced\";a:2:{s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:1;s:8:\"_padding\";i:1;}}}}s:7:\"divider\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:15:\"section_divider\";a:1:{s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:21:\"section_divider_style\";a:1:{s:5:\"color\";i:1;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:1:{s:14:\"_margin_mobile\";i:1;}s:19:\"_section_responsive\";a:2:{s:12:\"hide_desktop\";i:1;s:11:\"hide_tablet\";i:1;}}}}}}", "no");
INSERT INTO `wp_522243_options` VALUES("590", "_elementor_fep_settings", "a:14:{s:15:\"draggable_panel\";s:3:\"yes\";s:14:\"use_grid_ruler\";s:3:\"yes\";s:23:\"minimize_category_space\";s:3:\"yes\";s:11:\"editor_skin\";s:7:\"default\";s:30:\"display_vertical_collaspe_icon\";s:3:\"yes\";s:18:\"display_reset_icon\";s:0:\"\";s:17:\"display_exit_icon\";s:3:\"yes\";s:15:\"exit_link_point\";s:15:\"admin_dashboard\";s:17:\"exit_link_new_tab\";s:0:\"\";s:24:\"hide_elements_responsive\";s:2:\"no\";s:37:\"maintain_obscured_elements_responsive\";s:3:\"yes\";s:36:\"disable_obscured_elements_responsive\";s:2:\"no\";s:32:\"alternative_responsive_indicator\";s:3:\"yes\";s:17:\"accordion_options\";s:3:\"yes\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("591", "_elementor_global_css", "a:5:{s:4:\"time\";i:1588501504;s:5:\"fonts\";a:2:{i:0;s:6:\"Roboto\";i:4;s:11:\"Roboto Slab\";}s:5:\"icons\";a:0:{}s:6:\"status\";s:4:\"file\";i:0;b:0;}", "yes");
INSERT INTO `wp_522243_options` VALUES("592", "password_protected_status", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("593", "password_protected_feeds", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("594", "password_protected_rest", "0", "yes");
INSERT INTO `wp_522243_options` VALUES("595", "password_protected_administrators", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("596", "password_protected_users", "1", "yes");
INSERT INTO `wp_522243_options` VALUES("597", "password_protected_password", "1b17522bd26421e0700b73ee33d8432b", "yes");
INSERT INTO `wp_522243_options` VALUES("598", "password_protected_allowed_ip_addresses", "", "yes");
INSERT INTO `wp_522243_options` VALUES("599", "password_protected_remember_me_lifetime", "14", "yes");
INSERT INTO `wp_522243_options` VALUES("606", "options-404-redirect-group", "a:5:{s:16:\"p404_redirect_to\";s:21:\"http://nikkijames.net\";s:11:\"p404_status\";s:1:\"1\";s:5:\"links\";i:6;s:12:\"install_date\";s:19:\"2020-05-03 10:17 am\";s:16:\"redirected_links\";a:6:{i:0;a:2:{s:4:\"link\";s:55:\"http://www.nikkijames.net/images/200_20080811_s_-24.jpg\";s:4:\"date\";s:19:\"2020-05-03 10:34 am\";}i:1;a:2:{s:4:\"link\";s:51:\"http://www.nikkijames.net/images/LaurenMoore(1).jpg\";s:4:\"date\";s:19:\"2020-05-03 10:34 am\";}i:2;a:2:{s:4:\"link\";s:46:\"http://www.nikkijames.net/images/500_angel.jpg\";s:4:\"date\";s:19:\"2020-05-03 10:17 am\";}i:3;a:2:{s:4:\"link\";s:55:\"http://www.nikkijames.net/images/200_20080811_s_-24.jpg\";s:4:\"date\";s:19:\"2020-05-03 10:17 am\";}i:4;a:2:{s:4:\"link\";s:51:\"http://www.nikkijames.net/images/LaurenMoore(1).jpg\";s:4:\"date\";s:19:\"2020-05-03 10:17 am\";}i:5;a:2:{s:4:\"link\";s:55:\"http://www.nikkijames.net/images/500_20080811_s_-57.jpg\";s:4:\"date\";s:19:\"2020-05-03 10:17 am\";}}}", "yes");
INSERT INTO `wp_522243_options` VALUES("607", "elementor_lightbox_enable_counter", "", "yes");
INSERT INTO `wp_522243_options` VALUES("608", "elementor_lightbox_enable_fullscreen", "", "yes");
INSERT INTO `wp_522243_options` VALUES("609", "elementor_lightbox_enable_zoom", "", "yes");
INSERT INTO `wp_522243_options` VALUES("610", "elementor_lightbox_enable_share", "", "yes");
INSERT INTO `wp_522243_options` VALUES("611", "elementor_lightbox_title_src", "", "yes");
INSERT INTO `wp_522243_options` VALUES("612", "elementor_lightbox_description_src", "", "yes");
INSERT INTO `wp_522243_options` VALUES("613", "elementor_lightbox_color", "rgba(0, 0, 0, 0.77)", "yes");
INSERT INTO `wp_522243_options` VALUES("614", "elementor_lightbox_ui_color", "#FFFFFF", "yes");
INSERT INTO `wp_522243_options` VALUES("615", "elementor_lightbox_ui_color_hover", "#FFFFFF", "yes");
INSERT INTO `wp_522243_options` VALUES("616", "lightbox_icons_size", "a:3:{s:4:\"unit\";s:2:\"px\";s:4:\"size\";i:15;s:5:\"sizes\";a:0:{}}", "yes");
INSERT INTO `wp_522243_options` VALUES("617", "lightbox_slider_icons_size", "a:3:{s:4:\"unit\";s:2:\"px\";s:4:\"size\";i:15;s:5:\"sizes\";a:0:{}}", "yes");
INSERT INTO `wp_522243_options` VALUES("624", "widget_textblockswidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_522243_options` VALUES("639", "bsr_data", "a:8:{s:13:\"select_tables\";a:24:{i:0;s:21:\"wp_522243_commentmeta\";i:1;s:18:\"wp_522243_comments\";i:2;s:29:\"wp_522243_duplicator_packages\";i:3;s:35:\"wp_522243_itsec_distributed_storage\";i:4;s:28:\"wp_522243_itsec_fingerprints\";i:5;s:33:\"wp_522243_itsec_geolocation_cache\";i:6;s:24:\"wp_522243_itsec_lockouts\";i:7;s:20:\"wp_522243_itsec_logs\";i:8;s:23:\"wp_522243_itsec_mutexes\";i:9;s:29:\"wp_522243_itsec_opaque_tokens\";i:10;s:20:\"wp_522243_itsec_temp\";i:11;s:27:\"wp_522243_itsec_user_groups\";i:12;s:15:\"wp_522243_links\";i:13;s:17:\"wp_522243_options\";i:14;s:18:\"wp_522243_postmeta\";i:15;s:15:\"wp_522243_posts\";i:16;s:27:\"wp_522243_rio_process_queue\";i:17;s:18:\"wp_522243_snippets\";i:18;s:28:\"wp_522243_term_relationships\";i:19;s:23:\"wp_522243_term_taxonomy\";i:20;s:18:\"wp_522243_termmeta\";i:21;s:15:\"wp_522243_terms\";i:22;s:18:\"wp_522243_usermeta\";i:23;s:15:\"wp_522243_users\";}s:16:\"case_insensitive\";s:2:\"on\";s:13:\"replace_guids\";s:3:\"off\";s:7:\"dry_run\";s:3:\"off\";s:10:\"search_for\";s:4:\"Grey\";s:12:\"replace_with\";s:5:\"James\";s:15:\"completed_pages\";i:24;s:11:\"total_pages\";i:24;}", "yes");
INSERT INTO `wp_522243_options` VALUES("640", "_site_transient_timeout_itsec_wp_upload_dir", "1588590054", "no");
INSERT INTO `wp_522243_options` VALUES("641", "_site_transient_itsec_wp_upload_dir", "a:6:{s:4:\"path\";s:84:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/uploads/2020/05\";s:3:\"url\";s:48:\"http://nikkijames.net/wp-content/uploads/2020/05\";s:6:\"subdir\";s:8:\"/2020/05\";s:7:\"basedir\";s:76:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/uploads\";s:7:\"baseurl\";s:40:\"http://nikkijames.net/wp-content/uploads\";s:5:\"error\";b:0;}", "no");
INSERT INTO `wp_522243_options` VALUES("642", "_transient_timeout_elementor_extras_license_data", "1588546855", "no");
INSERT INTO `wp_522243_options` VALUES("643", "_transient_elementor_extras_license_data", "a:13:{s:7:\"success\";b:1;s:7:\"license\";s:5:\"valid\";s:7:\"item_id\";b:0;s:9:\"item_name\";s:16:\"Elementor+Extras\";s:8:\"checksum\";s:32:\"50e83c93f565d8a8efe86cc3100b627c\";s:7:\"expires\";s:19:\"2020-11-18 23:59:59\";s:10:\"payment_id\";i:50916;s:13:\"customer_name\";s:12:\"Simon Verdon\";s:14:\"customer_email\";s:14:\"simv@pobox.com\";s:13:\"license_limit\";i:0;s:10:\"site_count\";i:121;s:16:\"activations_left\";s:9:\"unlimited\";s:8:\"price_id\";s:1:\"2\";}", "no");
INSERT INTO `wp_522243_options` VALUES("644", "_transient_timeout_hmbkp_schedules", "1589108455", "no");
INSERT INTO `wp_522243_options` VALUES("645", "_transient_hmbkp_schedules", "a:2:{i:0;s:25:\"hmbkp_schedule_1588498857\";i:1;s:25:\"hmbkp_schedule_1588498858\";}", "no");
INSERT INTO `wp_522243_options` VALUES("646", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.4.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.4.1.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-5.4.1-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-5.4.1-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"5.4.1\";s:7:\"version\";s:5:\"5.4.1\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1588503659;s:15:\"version_checked\";s:5:\"5.4.1\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_522243_options` VALUES("647", "_site_transient_update_plugins", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1588503659;s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:35:{s:31:\"advanced-access-manager/aam.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:37:\"w.org/plugins/advanced-access-manager\";s:4:\"slug\";s:23:\"advanced-access-manager\";s:6:\"plugin\";s:31:\"advanced-access-manager/aam.php\";s:11:\"new_version\";s:5:\"6.4.3\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/advanced-access-manager/\";s:7:\"package\";s:72:\"https://downloads.wordpress.org/plugin/advanced-access-manager.6.4.3.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:76:\"https://ps.w.org/advanced-access-manager/assets/icon-256x256.png?rev=2199546\";s:2:\"1x\";s:76:\"https://ps.w.org/advanced-access-manager/assets/icon-128x128.png?rev=2199546\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/advanced-access-manager/assets/banner-1544x500.png?rev=2197012\";s:2:\"1x\";s:78:\"https://ps.w.org/advanced-access-manager/assets/banner-772x250.png?rev=2197012\";}s:11:\"banners_rtl\";a:0:{}}s:61:\"all-404-redirect-to-homepage/all-404-redirect-to-homepage.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:42:\"w.org/plugins/all-404-redirect-to-homepage\";s:4:\"slug\";s:28:\"all-404-redirect-to-homepage\";s:6:\"plugin\";s:61:\"all-404-redirect-to-homepage/all-404-redirect-to-homepage.php\";s:11:\"new_version\";s:4:\"1.19\";s:3:\"url\";s:59:\"https://wordpress.org/plugins/all-404-redirect-to-homepage/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/all-404-redirect-to-homepage.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:81:\"https://ps.w.org/all-404-redirect-to-homepage/assets/icon-256x256.png?rev=1515215\";s:2:\"1x\";s:81:\"https://ps.w.org/all-404-redirect-to-homepage/assets/icon-128x128.png?rev=1515215\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:83:\"https://ps.w.org/all-404-redirect-to-homepage/assets/banner-772x250.png?rev=2281110\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"all-in-one-favicon/all-in-one-favicon.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/all-in-one-favicon\";s:4:\"slug\";s:18:\"all-in-one-favicon\";s:6:\"plugin\";s:41:\"all-in-one-favicon/all-in-one-favicon.php\";s:11:\"new_version\";s:3:\"4.7\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/all-in-one-favicon/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/all-in-one-favicon.4.7.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:71:\"https://ps.w.org/all-in-one-favicon/assets/icon-256x256.jpg?rev=2223081\";s:2:\"1x\";s:71:\"https://ps.w.org/all-in-one-favicon/assets/icon-128x128.jpg?rev=2223081\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:73:\"https://ps.w.org/all-in-one-favicon/assets/banner-772x250.jpg?rev=2223081\";}s:11:\"banners_rtl\";a:0:{}}s:35:\"backupwordpress/backupwordpress.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/backupwordpress\";s:4:\"slug\";s:15:\"backupwordpress\";s:6:\"plugin\";s:35:\"backupwordpress/backupwordpress.php\";s:11:\"new_version\";s:4:\"3.10\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/backupwordpress/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/backupwordpress.3.10.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/backupwordpress/assets/icon-256x256.jpg?rev=1105225\";s:2:\"1x\";s:68:\"https://ps.w.org/backupwordpress/assets/icon-128x128.png?rev=1105225\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/backupwordpress/assets/banner-1544x500.jpg?rev=904756\";s:2:\"1x\";s:69:\"https://ps.w.org/backupwordpress/assets/banner-772x250.jpg?rev=904756\";}s:11:\"banners_rtl\";a:0:{}}s:47:\"better-search-replace/better-search-replace.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:35:\"w.org/plugins/better-search-replace\";s:4:\"slug\";s:21:\"better-search-replace\";s:6:\"plugin\";s:47:\"better-search-replace/better-search-replace.php\";s:11:\"new_version\";s:5:\"1.3.3\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/better-search-replace/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/better-search-replace.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/better-search-replace/assets/icon-256x256.png?rev=1238934\";s:2:\"1x\";s:74:\"https://ps.w.org/better-search-replace/assets/icon-128x128.png?rev=1238934\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/better-search-replace/assets/banner-1544x500.png?rev=1238934\";s:2:\"1x\";s:76:\"https://ps.w.org/better-search-replace/assets/banner-772x250.png?rev=1238934\";}s:11:\"banners_rtl\";a:0:{}}s:63:\"block-specific-plugin-updates/block-specific-plugin-updates.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:43:\"w.org/plugins/block-specific-plugin-updates\";s:4:\"slug\";s:29:\"block-specific-plugin-updates\";s:6:\"plugin\";s:63:\"block-specific-plugin-updates/block-specific-plugin-updates.php\";s:11:\"new_version\";s:3:\"3.0\";s:3:\"url\";s:60:\"https://wordpress.org/plugins/block-specific-plugin-updates/\";s:7:\"package\";s:76:\"https://downloads.wordpress.org/plugin/block-specific-plugin-updates.3.0.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:82:\"https://ps.w.org/block-specific-plugin-updates/assets/icon-128x128.png?rev=1120473\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:84:\"https://ps.w.org/block-specific-plugin-updates/assets/banner-772x250.png?rev=1120473\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"brozzme-scroll-top/brozzme_scroll_top.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/brozzme-scroll-top\";s:4:\"slug\";s:18:\"brozzme-scroll-top\";s:6:\"plugin\";s:41:\"brozzme-scroll-top/brozzme_scroll_top.php\";s:11:\"new_version\";s:5:\"1.8.5\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/brozzme-scroll-top/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/brozzme-scroll-top.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:71:\"https://ps.w.org/brozzme-scroll-top/assets/icon-128x128.png?rev=1487748\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:73:\"https://ps.w.org/brozzme-scroll-top/assets/banner-772x250.png?rev=1487748\";}s:11:\"banners_rtl\";a:0:{}}s:31:\"cache-enabler/cache-enabler.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:27:\"w.org/plugins/cache-enabler\";s:4:\"slug\";s:13:\"cache-enabler\";s:6:\"plugin\";s:31:\"cache-enabler/cache-enabler.php\";s:11:\"new_version\";s:5:\"1.3.5\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/cache-enabler/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/cache-enabler.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:66:\"https://ps.w.org/cache-enabler/assets/icon-256x256.png?rev=1270483\";s:2:\"1x\";s:66:\"https://ps.w.org/cache-enabler/assets/icon-128x128.png?rev=1270483\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/cache-enabler/assets/banner-1544x500.png?rev=1270483\";s:2:\"1x\";s:68:\"https://ps.w.org/cache-enabler/assets/banner-772x250.png?rev=1270483\";}s:11:\"banners_rtl\";a:0:{}}s:33:\"classic-editor/classic-editor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:28:\"w.org/plugins/classic-editor\";s:4:\"slug\";s:14:\"classic-editor\";s:6:\"plugin\";s:33:\"classic-editor/classic-editor.php\";s:11:\"new_version\";s:3:\"1.5\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/classic-editor/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/classic-editor.1.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/classic-editor/assets/icon-256x256.png?rev=1998671\";s:2:\"1x\";s:67:\"https://ps.w.org/classic-editor/assets/icon-128x128.png?rev=1998671\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/classic-editor/assets/banner-1544x500.png?rev=1998671\";s:2:\"1x\";s:69:\"https://ps.w.org/classic-editor/assets/banner-772x250.png?rev=1998676\";}s:11:\"banners_rtl\";a:0:{}}s:31:\"code-snippets/code-snippets.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:27:\"w.org/plugins/code-snippets\";s:4:\"slug\";s:13:\"code-snippets\";s:6:\"plugin\";s:31:\"code-snippets/code-snippets.php\";s:11:\"new_version\";s:6:\"2.14.0\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/code-snippets/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/code-snippets.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:58:\"https://ps.w.org/code-snippets/assets/icon.svg?rev=2148878\";s:3:\"svg\";s:58:\"https://ps.w.org/code-snippets/assets/icon.svg?rev=2148878\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/code-snippets/assets/banner-1544x500.png?rev=2260997\";s:2:\"1x\";s:68:\"https://ps.w.org/code-snippets/assets/banner-772x250.png?rev=2256244\";}s:11:\"banners_rtl\";a:0:{}}s:63:\"dashboard-welcome-for-elementor/dashboard-welcome-elementor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:45:\"w.org/plugins/dashboard-welcome-for-elementor\";s:4:\"slug\";s:31:\"dashboard-welcome-for-elementor\";s:6:\"plugin\";s:63:\"dashboard-welcome-for-elementor/dashboard-welcome-elementor.php\";s:11:\"new_version\";s:5:\"1.0.5\";s:3:\"url\";s:62:\"https://wordpress.org/plugins/dashboard-welcome-for-elementor/\";s:7:\"package\";s:74:\"https://downloads.wordpress.org/plugin/dashboard-welcome-for-elementor.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:84:\"https://ps.w.org/dashboard-welcome-for-elementor/assets/icon-256x256.png?rev=1910112\";s:2:\"1x\";s:84:\"https://ps.w.org/dashboard-welcome-for-elementor/assets/icon-128x128.png?rev=1910112\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:86:\"https://ps.w.org/dashboard-welcome-for-elementor/assets/banner-772x250.png?rev=1910112\";}s:11:\"banners_rtl\";a:0:{}}s:37:\"disable-comments/disable-comments.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:30:\"w.org/plugins/disable-comments\";s:4:\"slug\";s:16:\"disable-comments\";s:6:\"plugin\";s:37:\"disable-comments/disable-comments.php\";s:11:\"new_version\";s:6:\"1.10.2\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/disable-comments/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/disable-comments.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/disable-comments/assets/icon-256x256.png?rev=971176\";s:2:\"1x\";s:68:\"https://ps.w.org/disable-comments/assets/icon-128x128.png?rev=971176\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:72:\"https://ps.w.org/disable-comments/assets/banner-1544x500.png?rev=1652560\";s:2:\"1x\";s:71:\"https://ps.w.org/disable-comments/assets/banner-772x250.png?rev=1652560\";}s:11:\"banners_rtl\";a:0:{}}s:35:\"disable-xml-rpc/disable-xml-rpc.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/disable-xml-rpc\";s:4:\"slug\";s:15:\"disable-xml-rpc\";s:6:\"plugin\";s:35:\"disable-xml-rpc/disable-xml-rpc.php\";s:11:\"new_version\";s:5:\"1.0.1\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/disable-xml-rpc/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/disable-xml-rpc.1.0.1.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:59:\"https://s.w.org/plugins/geopattern-icon/disable-xml-rpc.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:33:\"duplicate-post/duplicate-post.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:28:\"w.org/plugins/duplicate-post\";s:4:\"slug\";s:14:\"duplicate-post\";s:6:\"plugin\";s:33:\"duplicate-post/duplicate-post.php\";s:11:\"new_version\";s:5:\"3.2.4\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/duplicate-post/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/duplicate-post.3.2.4.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/duplicate-post/assets/icon-256x256.png?rev=1612753\";s:2:\"1x\";s:67:\"https://ps.w.org/duplicate-post/assets/icon-128x128.png?rev=1612753\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:69:\"https://ps.w.org/duplicate-post/assets/banner-772x250.png?rev=1612986\";}s:11:\"banners_rtl\";a:0:{}}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"1.3.30\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.1.3.30.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/duplicator/assets/icon-256x256.png?rev=2083921\";s:2:\"1x\";s:63:\"https://ps.w.org/duplicator/assets/icon-128x128.png?rev=2083921\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/duplicator/assets/banner-772x250.png?rev=2085472\";}s:11:\"banners_rtl\";a:0:{}}s:23:\"elementor/elementor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:23:\"w.org/plugins/elementor\";s:4:\"slug\";s:9:\"elementor\";s:6:\"plugin\";s:23:\"elementor/elementor.php\";s:11:\"new_version\";s:5:\"2.9.8\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/elementor/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/elementor.2.9.8.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:62:\"https://ps.w.org/elementor/assets/icon-256x256.png?rev=1427768\";s:2:\"1x\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";s:3:\"svg\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:11:\"banners_rtl\";a:0:{}}s:23:\"email-log/email-log.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:23:\"w.org/plugins/email-log\";s:4:\"slug\";s:9:\"email-log\";s:6:\"plugin\";s:23:\"email-log/email-log.php\";s:11:\"new_version\";s:5:\"2.3.2\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/email-log/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/email-log.2.3.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:62:\"https://ps.w.org/email-log/assets/icon-256x256.png?rev=1710920\";s:2:\"1x\";s:62:\"https://ps.w.org/email-log/assets/icon-128x128.png?rev=1710920\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/email-log/assets/banner-1544x500.png?rev=1708230\";s:2:\"1x\";s:64:\"https://ps.w.org/email-log/assets/banner-772x250.png?rev=1708230\";}s:11:\"banners_rtl\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/email-log/assets/banner-1544x500-rtl.png?rev=1708230\";s:2:\"1x\";s:68:\"https://ps.w.org/email-log/assets/banner-772x250-rtl.png?rev=1708230\";}}s:43:\"email-notification-on-admin-login/index.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:47:\"w.org/plugins/email-notification-on-admin-login\";s:4:\"slug\";s:33:\"email-notification-on-admin-login\";s:6:\"plugin\";s:43:\"email-notification-on-admin-login/index.php\";s:11:\"new_version\";s:3:\"1.1\";s:3:\"url\";s:64:\"https://wordpress.org/plugins/email-notification-on-admin-login/\";s:7:\"package\";s:76:\"https://downloads.wordpress.org/plugin/email-notification-on-admin-login.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:86:\"https://ps.w.org/email-notification-on-admin-login/assets/icon-256x256.jpg?rev=1951088\";s:2:\"1x\";s:86:\"https://ps.w.org/email-notification-on-admin-login/assets/icon-256x256.jpg?rev=1951088\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:53:\"flexible-elementor-panel/flexible-elementor-panel.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/flexible-elementor-panel\";s:4:\"slug\";s:24:\"flexible-elementor-panel\";s:6:\"plugin\";s:53:\"flexible-elementor-panel/flexible-elementor-panel.php\";s:11:\"new_version\";s:5:\"2.1.1\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/flexible-elementor-panel/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/flexible-elementor-panel.2.1.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/flexible-elementor-panel/assets/icon-256x256.png?rev=1803032\";s:2:\"1x\";s:77:\"https://ps.w.org/flexible-elementor-panel/assets/icon-128x128.png?rev=1803032\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:80:\"https://ps.w.org/flexible-elementor-panel/assets/banner-1544x500.png?rev=2125925\";s:2:\"1x\";s:79:\"https://ps.w.org/flexible-elementor-panel/assets/banner-772x250.png?rev=2125922\";}s:11:\"banners_rtl\";a:0:{}}s:19:\"folders/folders.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:21:\"w.org/plugins/folders\";s:4:\"slug\";s:7:\"folders\";s:6:\"plugin\";s:19:\"folders/folders.php\";s:11:\"new_version\";s:5:\"2.4.8\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/folders/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/folders.2.4.8.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:60:\"https://ps.w.org/folders/assets/icon-256x256.png?rev=2027272\";s:2:\"1x\";s:60:\"https://ps.w.org/folders/assets/icon-128x128.png?rev=2027272\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/folders/assets/banner-1544x500.png?rev=2062199\";s:2:\"1x\";s:62:\"https://ps.w.org/folders/assets/banner-772x250.png?rev=2062199\";}s:11:\"banners_rtl\";a:0:{}}s:36:\"google-sitemap-generator/sitemap.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/google-sitemap-generator\";s:4:\"slug\";s:24:\"google-sitemap-generator\";s:6:\"plugin\";s:36:\"google-sitemap-generator/sitemap.php\";s:11:\"new_version\";s:5:\"4.1.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/google-sitemap-generator/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/google-sitemap-generator.4.1.0.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/google-sitemap-generator/assets/icon-256x256.png?rev=1701944\";s:2:\"1x\";s:77:\"https://ps.w.org/google-sitemap-generator/assets/icon-128x128.png?rev=1701944\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/google-sitemap-generator/assets/banner-772x250.png?rev=1701944\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"better-wp-security/better-wp-security.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/better-wp-security\";s:4:\"slug\";s:18:\"better-wp-security\";s:6:\"plugin\";s:41:\"better-wp-security/better-wp-security.php\";s:11:\"new_version\";s:5:\"7.7.1\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/better-wp-security/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/better-wp-security.7.7.1.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:70:\"https://ps.w.org/better-wp-security/assets/icon-256x256.jpg?rev=969999\";s:2:\"1x\";s:62:\"https://ps.w.org/better-wp-security/assets/icon.svg?rev=970042\";s:3:\"svg\";s:62:\"https://ps.w.org/better-wp-security/assets/icon.svg?rev=970042\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:72:\"https://ps.w.org/better-wp-security/assets/banner-772x250.png?rev=881897\";}s:11:\"banners_rtl\";a:0:{}}s:25:\"login-logo/login-logo.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/login-logo\";s:4:\"slug\";s:10:\"login-logo\";s:6:\"plugin\";s:25:\"login-logo/login-logo.php\";s:11:\"new_version\";s:6:\"0.10.0\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/login-logo/\";s:7:\"package\";s:53:\"https://downloads.wordpress.org/plugin/login-logo.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:54:\"https://s.w.org/plugins/geopattern-icon/login-logo.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:29:\"mainwp-child/mainwp-child.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:26:\"w.org/plugins/mainwp-child\";s:4:\"slug\";s:12:\"mainwp-child\";s:6:\"plugin\";s:29:\"mainwp-child/mainwp-child.php\";s:11:\"new_version\";s:7:\"4.0.7.1\";s:3:\"url\";s:43:\"https://wordpress.org/plugins/mainwp-child/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/mainwp-child.4.0.7.1.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/mainwp-child/assets/icon-128x128.png?rev=2147214\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/mainwp-child/assets/banner-1544x500.jpg?rev=2150284\";s:2:\"1x\";s:67:\"https://ps.w.org/mainwp-child/assets/banner-772x250.jpg?rev=2150284\";}s:11:\"banners_rtl\";a:2:{s:2:\"2x\";s:72:\"https://ps.w.org/mainwp-child/assets/banner-1544x500-rtl.jpg?rev=2150284\";s:2:\"1x\";s:71:\"https://ps.w.org/mainwp-child/assets/banner-772x250-rtl.jpg?rev=2150284\";}}s:53:\"mousewheel-smooth-scroll/mousewheel-smooth-scroll.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/mousewheel-smooth-scroll\";s:4:\"slug\";s:24:\"mousewheel-smooth-scroll\";s:6:\"plugin\";s:53:\"mousewheel-smooth-scroll/mousewheel-smooth-scroll.php\";s:11:\"new_version\";s:3:\"5.5\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/mousewheel-smooth-scroll/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/mousewheel-smooth-scroll.5.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/mousewheel-smooth-scroll/assets/icon-256x256.png?rev=1063217\";s:2:\"1x\";s:77:\"https://ps.w.org/mousewheel-smooth-scroll/assets/icon-128x128.png?rev=1063217\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/mousewheel-smooth-scroll/assets/banner-772x250.jpg?rev=1063217\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"page-management-dropdown/page-management-dropdown.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/page-management-dropdown\";s:4:\"slug\";s:24:\"page-management-dropdown\";s:6:\"plugin\";s:53:\"page-management-dropdown/page-management-dropdown.php\";s:11:\"new_version\";s:3:\"2.7\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/page-management-dropdown/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/page-management-dropdown.2.7.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:68:\"https://s.w.org/plugins/geopattern-icon/page-management-dropdown.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:41:\"password-protected/password-protected.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/password-protected\";s:4:\"slug\";s:18:\"password-protected\";s:6:\"plugin\";s:41:\"password-protected/password-protected.php\";s:11:\"new_version\";s:5:\"2.2.5\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/password-protected/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/password-protected.2.2.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/password-protected/assets/icon-256x256.png?rev=993628\";s:2:\"1x\";s:70:\"https://ps.w.org/password-protected/assets/icon-128x128.png?rev=993628\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/password-protected/assets/banner-1544x500.png?rev=993628\";s:2:\"1x\";s:72:\"https://ps.w.org/password-protected/assets/banner-772x250.png?rev=993628\";}s:11:\"banners_rtl\";a:0:{}}s:61:\"premium-addons-for-elementor/premium-addons-for-elementor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:42:\"w.org/plugins/premium-addons-for-elementor\";s:4:\"slug\";s:28:\"premium-addons-for-elementor\";s:6:\"plugin\";s:61:\"premium-addons-for-elementor/premium-addons-for-elementor.php\";s:11:\"new_version\";s:6:\"3.12.2\";s:3:\"url\";s:59:\"https://wordpress.org/plugins/premium-addons-for-elementor/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/premium-addons-for-elementor.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:81:\"https://ps.w.org/premium-addons-for-elementor/assets/icon-256x256.png?rev=1799730\";s:2:\"1x\";s:73:\"https://ps.w.org/premium-addons-for-elementor/assets/icon.svg?rev=1799730\";s:3:\"svg\";s:73:\"https://ps.w.org/premium-addons-for-elementor/assets/icon.svg?rev=1799730\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:84:\"https://ps.w.org/premium-addons-for-elementor/assets/banner-1544x500.jpg?rev=1876380\";s:2:\"1x\";s:83:\"https://ps.w.org/premium-addons-for-elementor/assets/banner-772x250.jpg?rev=1876380\";}s:11:\"banners_rtl\";a:0:{}}s:37:\"rcd-right-click-disabler/rcd-main.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/rcd-right-click-disabler\";s:4:\"slug\";s:24:\"rcd-right-click-disabler\";s:6:\"plugin\";s:37:\"rcd-right-click-disabler/rcd-main.php\";s:11:\"new_version\";s:3:\"1.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/rcd-right-click-disabler/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/rcd-right-click-disabler.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/rcd-right-click-disabler/assets/icon-256x256.png?rev=1770776\";s:2:\"1x\";s:77:\"https://ps.w.org/rcd-right-click-disabler/assets/icon-128x128.png?rev=1770776\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/rcd-right-click-disabler/assets/banner-772x250.jpg?rev=1770750\";}s:11:\"banners_rtl\";a:0:{}}s:36:\"reusable-text-blocks/text-blocks.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:34:\"w.org/plugins/reusable-text-blocks\";s:4:\"slug\";s:20:\"reusable-text-blocks\";s:6:\"plugin\";s:36:\"reusable-text-blocks/text-blocks.php\";s:11:\"new_version\";s:5:\"1.5.3\";s:3:\"url\";s:51:\"https://wordpress.org/plugins/reusable-text-blocks/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/reusable-text-blocks.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/reusable-text-blocks/assets/icon-256x256.png?rev=1082000\";s:2:\"1x\";s:73:\"https://ps.w.org/reusable-text-blocks/assets/icon-128x128.png?rev=1082000\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:75:\"https://ps.w.org/reusable-text-blocks/assets/banner-772x250.jpg?rev=1089723\";}s:11:\"banners_rtl\";a:0:{}}s:27:\"updraftplus/updraftplus.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/updraftplus\";s:4:\"slug\";s:11:\"updraftplus\";s:6:\"plugin\";s:27:\"updraftplus/updraftplus.php\";s:11:\"new_version\";s:7:\"1.16.23\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/updraftplus/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/updraftplus.1.16.23.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-256x256.jpg?rev=1686200\";s:2:\"1x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-128x128.jpg?rev=1686200\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/updraftplus/assets/banner-1544x500.png?rev=1686200\";s:2:\"1x\";s:66:\"https://ps.w.org/updraftplus/assets/banner-772x250.png?rev=1686200\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"w2o-admin-drop-down-menu/w2o-admin-drop-down-menu.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/w2o-admin-drop-down-menu\";s:4:\"slug\";s:24:\"w2o-admin-drop-down-menu\";s:6:\"plugin\";s:53:\"w2o-admin-drop-down-menu/w2o-admin-drop-down-menu.php\";s:11:\"new_version\";s:3:\"3.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/w2o-admin-drop-down-menu/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/w2o-admin-drop-down-menu.3.0.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:77:\"https://ps.w.org/w2o-admin-drop-down-menu/assets/icon-128x128.png?rev=1347375\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/w2o-admin-drop-down-menu/assets/banner-772x250.png?rev=1577854\";}s:11:\"banners_rtl\";a:0:{}}s:47:\"robin-image-optimizer/robin-image-optimizer.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:35:\"w.org/plugins/robin-image-optimizer\";s:4:\"slug\";s:21:\"robin-image-optimizer\";s:6:\"plugin\";s:47:\"robin-image-optimizer/robin-image-optimizer.php\";s:11:\"new_version\";s:5:\"1.4.2\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/robin-image-optimizer/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/robin-image-optimizer.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/robin-image-optimizer/assets/icon-256x256.png?rev=1927108\";s:2:\"1x\";s:74:\"https://ps.w.org/robin-image-optimizer/assets/icon-128x128.png?rev=1927108\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:41:\"wordpress-importer/wordpress-importer.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/wordpress-importer\";s:4:\"slug\";s:18:\"wordpress-importer\";s:6:\"plugin\";s:41:\"wordpress-importer/wordpress-importer.php\";s:11:\"new_version\";s:3:\"0.7\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/wordpress-importer/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/wordpress-importer.0.7.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:71:\"https://ps.w.org/wordpress-importer/assets/icon-256x256.png?rev=1908375\";s:2:\"1x\";s:63:\"https://ps.w.org/wordpress-importer/assets/icon.svg?rev=1908375\";s:3:\"svg\";s:63:\"https://ps.w.org/wordpress-importer/assets/icon.svg?rev=1908375\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:72:\"https://ps.w.org/wordpress-importer/assets/banner-772x250.png?rev=547654\";}s:11:\"banners_rtl\";a:0:{}}s:21:\"wp-sweep/wp-sweep.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:22:\"w.org/plugins/wp-sweep\";s:4:\"slug\";s:8:\"wp-sweep\";s:6:\"plugin\";s:21:\"wp-sweep/wp-sweep.php\";s:11:\"new_version\";s:5:\"1.1.1\";s:3:\"url\";s:39:\"https://wordpress.org/plugins/wp-sweep/\";s:7:\"package\";s:57:\"https://downloads.wordpress.org/plugin/wp-sweep.1.1.1.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:53:\"https://ps.w.org/wp-sweep/assets/icon.svg?rev=1098912\";s:3:\"svg\";s:53:\"https://ps.w.org/wp-sweep/assets/icon.svg?rev=1098912\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/wp-sweep/assets/banner-1544x500.jpg?rev=1098912\";s:2:\"1x\";s:63:\"https://ps.w.org/wp-sweep/assets/banner-772x250.jpg?rev=1098912\";}s:11:\"banners_rtl\";a:0:{}}}}", "no");
INSERT INTO `wp_522243_options` VALUES("648", "_site_transient_timeout_elementor_pro_remote_info_api_data_2.9.3", "1588546860", "no");
INSERT INTO `wp_522243_options` VALUES("649", "_site_transient_elementor_pro_remote_info_api_data_2.9.3", "a:16:{s:14:\"stable_version\";s:5:\"2.9.3\";s:12:\"last_updated\";s:19:\"2020-04-19 15:16:29\";s:8:\"sections\";s:99427:\"a:2:{s:11:\"description\";s:161:\"Elementor Pro adds new features to the Elementor Page Builder plugin. Control your conversions, your user engagement, your entire website, from one page builder.\";s:9:\"changelog\";s:99205:\"<h4>2.9.3 - 2020-04-19</h4>\n<ul>\n<li>Fix: Form shortcode IDs are not wrapped in double-quotes (<a href=\"https://github.com/elementor/elementor/issues/11023\">#11023</a>, <a href=\"https://github.com/elementor/elementor/issues/10932\">#10932</a>, <a href=\"https://github.com/elementor/elementor/issues/10967\">#10967</a>, <a href=\"https://github.com/elementor/elementor/issues/11000\">#11000</a>, <a href=\"https://github.com/elementor/elementor/issues/11049\">#11049</a>)</li>\n<li>Fix: Escaped Form records metadata to prevent security vulnerability</li>\n<li>Fix: Closing &quot;Save Changes&quot; document confirmation modal causes Panel infinite loading</li>\n<li>Fix: Ken Burns effect not working when there is only one slide in Slides widget</li>\n<li>Fix: Document handles UI glitch</li>\n</ul>\n<h4>2.9.2 - 2020-03-25</h4>\n<ul>\n<li>Tweak: Added compatibility with WordPress v5.4 (<a href=\"https://github.com/elementor/elementor/issues/10745\">#10745</a>)</li>\n<li>Fix: Image ratio number is displayed under the Archive Posts widget (<a href=\"https://github.com/elementor/elementor/issues/10874\">#10874</a>)</li>\n<li>Fix: Theme Style Link color setting overrides the Table of Content list style</li>\n<li>Fix: PHP notice when using dynamic user info <code>id</code></li>\n<li>Fix: Navigation arrows direction is crossed on first drag in Slides Widget</li>\n<li>Fix: &quot;No headings were found on this page&quot; message was not displayed in the frontend in Table of Contents widget</li>\n<li>Fix: Container includes Popup tags by default in Table of Contents widget</li>\n<li>Fix: Twitter icon display issue when Font Awesome 4 support is disabled in Blockquote widget</li>\n<li>Fix: ACF Dynamic tag not working in Form widget Redirect action</li>\n</ul>\n<h4>2.9.1 - 2020-03-16</h4>\n<ul>\n<li>Fix: Can\'t access Elementor Editor when there is Page Title widget in the page</li>\n<li>Fix: Applying styling to Post Content widget affects the Page and Post editing handles</li>\n</ul>\n<h4>2.9.0 - 2020-03-15</h4>\n<ul>\n<li>New: Introducing Full Site Editing: Design header, footer, and content all in one place! (<a href=\"https://github.com/elementor/elementor/issues/4985\">#4985</a>)</li>\n<li>New: Added Global Custom CSS for Your Entire Site in Theme Style (<a href=\"https://github.com/elementor/elementor/issues/3345\">#3345</a>)</li>\n<li>New: Added Dynamic Colors tag (<a href=\"https://github.com/elementor/elementor/issues/6485\">#6485</a>)</li>\n<li>Tweak: Added option to set the Site Part HTML Wrapper Tags (<a href=\"https://github.com/elementor/elementor/issues/9293\">#9293</a>)</li>\n<li>Tweak: Added Link Attributes support to Pro widgets (<a href=\"https://github.com/elementor/elementor/issues/5716\">#5716</a>, <a href=\"https://github.com/elementor/elementor/issues/3642\">#3642</a>, <a href=\"https://github.com/elementor/elementor/issues/9225\">#9225</a>, <a href=\"https://github.com/elementor/elementor/issues/9079\">#9079</a>)</li>\n<li>Tweak: Added Theme Style support in Theme Builder parts (<a href=\"https://github.com/elementor/elementor/issues/10564\">#10564</a>)</li>\n<li>Tweak: Avoid creating empty Custom Font</li>\n<li>Tweak: Added <code>aria-expanded</code> attribute to Menu Cart widget</li>\n<li>Tweak: Moved Link Actions module to Core plugin</li>\n<li>Tweak: Changed the name of “TypeKit Web Fonts by Adobe” to “Adobe Fonts”</li>\n<li>Tweak: Removed redundant display conditions from Blockquote, Flipbox, Price Table, and Search Form widgets</li>\n<li>Tweak: Pro widgets are not draggable unless Elementor license has been activated</li>\n<li>Tweak: Remove redundant <code>label_block</code> parameters from several controls</li>\n<li>Tweak: Converted controls selectors to CSS variables in Gallery widget</li>\n<li>Tweak: Replaced Stumbleupon with Mix in Reviews widget recommended icons (<a href=\"https://github.com/elementor/elementor/issues/10099\">#10099</a>)</li>\n<li>Tweak: Added Mix to the Share Buttons network list (<a href=\"https://github.com/elementor/elementor/issues/10099\">#10099</a>)</li>\n<li>Tweak: Added &quot;Open in new tab&quot; option to Posts widget (<a href=\"https://github.com/elementor/elementor/issues/7924\">#7924</a>)</li>\n<li>Tweak: Upgraded Font Awesome Pro library to v5.12.0</li>\n<li>Tweak: Added new Lightbox compatibility for Gallery and Media Carousel widgets</li>\n<li>Tweak: Expose external API for Swiper instances</li>\n<li>Tweak: Added compatibility to JS API in Theme Builder, Popups, Form widget and Global widget</li>\n<li>Tweak: Replaced nerd icons with new Elementor emojis</li>\n<li>Tweak: Added specific <code>color</code> attribute to header title in Table of Contents widget</li>\n<li>Fix: Line break issues in Animated Headline widget (<a href=\"https://github.com/elementor/elementor/issues/10585\">#10585</a>)</li>\n<li>Fix: Theme Style Link color overrides the Table of Content list style</li>\n<li>Fix: Active state glitches when using Table of contents widget with Sticky mode</li>\n<li>Fix: &quot;Graphic Element&quot; section appears as empty in case of unmarked Graphic Element in Call to Action widget</li>\n<li>Fix: Page Title widget render glitches in the Editor</li>\n<li>Fix: Image ratio parameter visible in some edge cases in Posts widget</li>\n<li>Fix: Image missing when sharing to Pinterest using Share Buttons widget</li>\n<li>Fix: Theme Style Link color setting override the list style in Table of Contents widget</li>\n<li>Deprecated: See all deprecations to this version in our <a href=\"https://developers.elementor.com/v2-9-0-planned-deprecations/\">Developers Deprecations Post</a></li>\n</ul>\n<h4>2.8.5 - 2020-03-08</h4>\n<ul>\n<li>Tweak: Added new Swiper parameter to all Pro carousels to allow 3rd party integration</li>\n<li>Fix: Missing closing bracket in Animated Headline widget</li>\n<li>Fix: Share buttons widgets show Font Awesome 4 icons on first drag in Editor</li>\n</ul>\n<h4>2.8.4 - 2020-02-16</h4>\n<ul>\n<li>Tweak: Added Lightbox Title &amp; Description support to Gallery widget</li>\n<li>Tweak: Added RTL support for Slides widget</li>\n<li>Tweak: Display Lightbox images in Full size in Gallery widget</li>\n<li>Fix: Template with Slides widget not working properly when placed inside Tabs, Accordion and Toggle widget</li>\n<li>Fix: Dropdown menu lost styling after Elementor Pro v2.8 upgrade in Nav Menu widget</li>\n<li>Fix: Indent doesn\'t work on RTL websites in Table of Contents widget</li>\n<li>Fix: Query Control throws <code>Undefined index: q</code> error</li>\n<li>Fix: Typography control not affecting dropdown menu in Nav Menu widget</li>\n<li>Fix: Discord forms integration fails to send submissions in some server configurations</li>\n<li>Fix: Rotating headlines don\'t align center in Animated Headline widget</li>\n<li>Fix: Custom secondary color displayed when not needed in Share buttons widget</li>\n<li>Fix: Motion Effects of certain objects are not functioning properly on Safari browser</li>\n<li>Fix: Missing eye icon in Single template footer preview button</li>\n</ul>\n<h4>2.8.3 - 2020-01-01</h4>\n<ul>\n<li>Tweak: Updated Table of Contents widget panel location</li>\n<li>Fix: ACF URL Dynamic field throws <code>undefined index</code> PHP notice (<a href=\"https://github.com/elementor/elementor/issues/9929\">#9929</a>)</li>\n<li>Fix: Gallery lightbox pagination shows images from all tabs</li>\n<li>Fix: &quot;Reply To&quot; option not working in Form widget &quot;Email 2&quot; Action</li>\n<li>Fix: ACF Dynamic tag not working in Form widget Redirect action</li>\n<li>Fix: Underline option not working in Table of Contents widget Normal state</li>\n<li>Fix: Query Control <code>Undefined index: autocomplete</code> notice in some cases</li>\n<li>Fix: Missing display condition to Read More Spacing control in Posts widget</li>\n</ul>\n<h4>2.8.2 - 2019-12-19</h4>\n<ul>\n<li>Tweak: Improved scroll-spy and collapsing functionality in Table of Contents widget</li>\n<li>Fix: &quot;No products were found&quot; message not being displayed in an empty Products Archive</li>\n<li>Fix: Redundant <code>&lt;br&gt;</code> tags in Single theme template (<a href=\"https://github.com/elementor/elementor/issues/9927\">#9927</a>, <a href=\"https://github.com/elementor/elementor/issues/9928\">#9928</a>)</li>\n<li>Fix: Draft Popup shows up in Dynamic tag dropdown</li>\n</ul>\n<h4>2.8.1 - 2019-12-18</h4>\n<ul>\n<li>Fix: Share Buttons widget not working (<a href=\"https://github.com/elementor/elementor/issues/9920\">#9920</a>)</li>\n<li>Fix: Redundant <code>&lt;p&gt;</code> tags added to Single Template posts</li>\n</ul>\n<h4>2.8.0 - 2019-12-18</h4>\n<ul>\n<li>New: Table of Contents Widget (<a href=\"https://github.com/elementor/elementor/issues/5171\">#5171</a>)</li>\n<li>New: Added Font Awesome Pro Duotone font family support (<a href=\"https://github.com/elementor/elementor/issues/9578\">#9578</a>)</li>\n<li>Tweak: Added Lazy Load option to Gallery widget (<a href=\"https://github.com/elementor/elementor/issues/9763\">#9763</a>)</li>\n<li>Tweak: Added Random order option to Gallery widget (<a href=\"https://github.com/elementor/elementor/issues/9269\">#9269</a>)</li>\n<li>Tweak: Updated Font Awesome Pro to v5.11.2 (<a href=\"https://github.com/elementor/elementor/issues/9578\">#9578</a>)</li>\n<li>Tweak: Added preselect support for multiple default select values in Forms Widget (<a href=\"https://github.com/elementor/elementor/issues/9324\">#9324</a>)</li>\n<li>Tweak: Avoid duplicate queries for Custom Icons (<a href=\"https://github.com/elementor/elementor/issues/9579\">#9579</a>)</li>\n<li>Tweak: Major performance improvements to Gallery widget</li>\n<li>Tweak: Avoid non-existing images in Gallery widget</li>\n<li>Tweak: Added <code>tabindex</code>, <code>aria-expanded</code>, <code>aria-hidden</code> and <code>role=\"navigation\"</code> accessibility attributes to Nav Menu widget</li>\n<li>Tweak: Changed button HTML tag from <code>button</code> to <code>span</code> in Call to Action and Flip Box widgets for better W3C compliance and accessibility</li>\n<li>Tweak: Removed Google+ from default networks in Share Buttons widget</li>\n<li>Tweak: Added compatibility for Library Connect</li>\n<li>Tweak: Added i18n to Toolset date dynamic tag</li>\n<li>Tweak: Added external link support to Gallery widget</li>\n<li>Tweak: Changed the link external attributes implementation to use <code>add_link_attributes()</code> in Gallery widget</li>\n<li>Tweak: Updated references to the new Schemes system location</li>\n<li>Tweak: Avoid running Gallery handler when the gallery is empty</li>\n<li>Tweak: UI Tweaks in Editor Panel</li>\n<li>Tweak: Added responsive capabilities to Pointer Width control in Nav Menu widget</li>\n<li>Tweak: Added mobile support for responsive controls in Nav Menu widget</li>\n<li>Tweak: Refactor <code>register_controls()</code> method in Posts widget skin trait</li>\n<li>Fix: ACF URL &quot;undefined Index&quot; notice (<a href=\"https://github.com/elementor/elementor/issues/7646\">#7646</a>)</li>\n<li>Fix: WooCommerce Mini-Cart widget causes fatal error in edge cases (<a href=\"https://github.com/elementor/elementor/issues/9304\">#9304</a>)</li>\n<li>Fix: <code>PHP Notice: Undefined index</code> display for Author query (<a href=\"https://github.com/elementor/elementor/issues/9864\">#9864</a>)</li>\n<li>Fix: Added compatibility for Button widget placed inside Swiper carousel (<a href=\"https://wordpress.org/support/topic/broken-buttons-since-elementor-2-8/\">Topic</a>)</li>\n<li>Fix: Avoid empty spaces in Post info widget</li>\n<li>Tweak: Always show &quot;Custom label&quot; control in Login widget</li>\n<li>Fix: Nav Menu item typography selector in Nav Menu widget</li>\n<li>Fix: Facebook Like Button widget causes flickering</li>\n<li>Fix: WooCommerce mini-cart behaviour when using <code>plain</code> permalinks format</li>\n<li>Fix: Avoid running Popup triggers when set without conditions</li>\n<li>Fix: Removed &quot;Date&quot; query from Products widget</li>\n<li>Fix: Slides widget when used as a Shortcode and is hidden</li>\n<li>Fix: Custom URL being accessed on swipe in Media Carousel</li>\n<li>Fix: Media Carousel widget Cube effect glitch</li>\n<li>Fix: Lightbox shows images from multiple Gallery widgets in the same page</li>\n<li>Fix: Image <code>alt</code> Text not displayed on overlay in Gallery widget</li>\n<li>Fix: Gallery widget not visible in Posts widget Full Content skin</li>\n<li>Fix: WooCommerce mini-cart remove unnecessary hooks registration when WooCommerce integration set to <code>Disable</code></li>\n<li>Fix: Slides widget button wrapping breaks in mobile view</li>\n<li>Fix: Dynamic capabilities with the Reviews widget</li>\n<li>Fix: Disabling autoplay doesn\'t work in Slides widget</li>\n<li>Fix: Posts widget Full Content skin not working on Single template</li>\n<li>Fix: Autocomplete not working for &quot;By Author&quot; condition in Display Conditions screen</li>\n<li>Fix: Posts widget alignment issue</li>\n<li>Fix: Product Variations Clear button not working in edge cases</li>\n<li>Fix: Styling issues in Form widget submit button</li>\n</ul>\n<h4>2.7.3 - 2019-10-28</h4>\n<ul>\n<li>Tweak: Added RTL support to Galleries widget (<a href=\"https://github.com/elementor/elementor/issues/9213\">#9213</a>)</li>\n<li>Tweak: Added Custom Icons compatibility for WordPress 5.3</li>\n<li>Fix: Missing template function declaration causes fatal error in WC mini-cart widget</li>\n<li>Fix: Pause on hover doesn\'t work in Carousel widgets</li>\n<li>Fix: Link-actions conflict with <code>?action=</code> parameter in the URL</li>\n<li>Fix: Lightbox navigation not working in Gallery widget Single mode</li>\n<li>Fix: Ken burns effect not working on the 1st slide if Infinite Loop option is turned off in Carousel widgets</li>\n<li>Fix: Popup Advanced Rules detects internal links as external if current URL starts with <code>www</code></li>\n</ul>\n<h4>2.7.2 - 2019-10-06</h4>\n<ul>\n<li>Fix: Slide Overlay not working when applying Ken burns effect in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9209\">#9209</a>)</li>\n<li>Fix: Content width glitch in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9180\">#9180</a>)</li>\n<li>Fix: Horizontal Alignment not working when applying custom style per slide in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9180\">#9180</a>)</li>\n<li>Fix: Missing semicolon in Custom Fonts <code>font-display</code> CSS</li>\n</ul>\n<h4>2.7.1 - 2019-09-26</h4>\n<ul>\n<li>Fix: Background Overlay layer is over the slide content in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9180\">#9180</a>)</li>\n<li>Fix: Duplicate images under &quot;All&quot; filter in Multiple Gallery</li>\n</ul>\n<h4>2.7.0 - 2019-09-24</h4>\n<ul>\n<li>New: Enhanced Galleries widget (<a href=\"https://github.com/elementor/elementor/issues/1898\">#1898</a>, <a href=\"https://github.com/elementor/elementor/issues/3103\">#3103</a>, <a href=\"https://github.com/elementor/elementor/issues/4279\">#4279</a>, <a href=\"https://github.com/elementor/elementor/issues/7631\">#7631</a>)</li>\n<li>New: Dynamic Number (<a href=\"https://github.com/elementor/elementor/issues/5952\">#5952</a>)</li>\n<li>New: Full content skin for Posts and Archive-posts widgets (<a href=\"https://github.com/elementor/elementor/issues/4617\">#4617</a>)</li>\n<li>Tweak: Added dynamic number capability to Price List, Price Table, Counter, Star Rating, Progress Bar widgets</li>\n<li>Tweak: Added tags support to forms Mailchimp action (<a href=\"https://github.com/elementor/elementor/issues/5418\">#5418</a>)</li>\n<li>Tweak: User Profile Picture Dynamic Tag (<a href=\"https://github.com/elementor/elementor/issues/7947\">#7947</a>, <a href=\"https://github.com/elementor/elementor/issues/8740\">#8740</a>)</li>\n<li>Tweak: Added <code>font-display</code> support to custom fonts (<a href=\"https://github.com/elementor/elementor/issues/5993\">#5993</a>, <a href=\"https://developers.elementor.com/elementor-pro-2-7-custom-fonts-font-display-support/\">Developers Blog Post</a>)</li>\n<li>Tweak: Added Text Shadow control to Slides widget (<a href=\"https://github.com/elementor/elementor/issues/8800\">#8800</a>)</li>\n<li>Tweak: Added Re-subscribe support to MailerLite (<a href=\"https://github.com/elementor/elementor/issues/8799\">#8799</a>)</li>\n<li>Tweak: Added Dynamic capabilities to Facebook Embed widget (<a href=\"https://github.com/elementor/elementor/issues/9030\">#9030</a>)</li>\n<li>Tweak: Use <code>swiper.js</code> instead of <code>slick.js</code> in Slides widget (<a href=\"https://developers.elementor.com/elementor-2-7-moving-sliders-from-slick-to-swiper/\">Developers Blog Post</a>)</li>\n<li>Tweak: Added <code>elementor_pro/search_form/before_input</code> action hook to Search Form widget (<a href=\"https://github.com/elementor/elementor/issues/5598\">#5598</a>)</li>\n<li>Tweak: Added <code>elementor_pro/search_form/after_input</code> action hook to Search Form widget (<a href=\"https://github.com/elementor/elementor/issues/5598\">#5598</a>)</li>\n<li>Tweak: Added dynamic support for Custom field key (<a href=\"https://github.com/elementor/elementor/issues/7789\">#7789</a>)</li>\n<li>Tweak: Increased expired license notice bar frequency</li>\n<li>Tweak: Changed the icon name of Slides widget</li>\n<li>Tweak: Added designated Finder\'s Icons for Custom icons &amp; Custom fonts</li>\n<li>Tweak: Use Ken Burns Effect as an external module</li>\n<li>Tweak: Remove Fontello conflicting CSS on import to Custom Icons sets</li>\n<li>Tweak: Editor Panel UI tweaks</li>\n<li>Tweak: Added DOM events on Popup show/hide (<a href=\"https://developers.elementor.com/elementor-pro-2-7-popup-events/\">Developers Blog Post</a>)</li>\n<li>Tweak: Added option to change the variations field width in Add to Cart widget</li>\n<li>Tweak: Use select control instead of select2 in Menu Cart widget</li>\n<li>Tweak: Added conditions to the tabs instead of to each control in Share Buttons widget</li>\n<li>Tweak: Added Typography controls to HTML field in Forms widget</li>\n<li>Tweak: Allow edit selected Font file in Custom Font</li>\n<li>Tweak: Changed reCAPTCHA v3 error message</li>\n<li>Tweak: Remove the &quot;Save as Global&quot; option on Global widget context menu</li>\n<li>Fix: Corrected selector for <code>removeControlSpinner()</code> (<a href=\"https://github.com/elementor/elementor/issues/8790\">#8790</a>)</li>\n<li>Fix: Slides widget navigation icons misplacement (<a href=\"https://github.com/elementor/elementor/issues/8533\">#8533</a>)</li>\n<li>Fix: Horizontal Scrollbar when Slider widget is set to Full Width (<a href=\"https://github.com/elementor/elementor/issues/8527\">#8527</a>)</li>\n<li>Fix: Inconsistent behavior when &quot;Infinite Loop&quot; enabled with &quot;Autoplay&quot; in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/6726\">#6726</a>)</li>\n<li>Fix: Ken Burns effect on Chrome transition glitches (<a href=\"https://github.com/elementor/elementor/issues/1671\">#1671</a>)</li>\n<li>Fix: Nothing found message shows up inside the columns set in Posts Archive widget (<a href=\"https://github.com/elementor/elementor/issues/7347\">#7347</a>)</li>\n<li>Fix: Responsive UI glitch in Popup Conditions modal tabs</li>\n<li>Fix: Removed unnecessary divider in Call to Action widget</li>\n<li>Fix: Custom Add To Cart * button style (size, position and background color) when <code>quantity</code> is enabled.</li>\n<li>Fix: Add support for Document/PageBase in Theme Builder (Core &gt;=2.7.0)</li>\n<li>Fix: Ampersand character breaks email link in Share Buttons widget</li>\n<li>Fix: Correct custom font attachment <code>mime-type</code> to show uploaded Custom Fonts</li>\n<li>Fix: Mini-Cart not refreshing in Menu Cart widget</li>\n<li>Fix: Cart drawer not working when WC Subscriptions plugin is activated</li>\n<li>Fix:  Querying CPT with custom taxonomies does not show the taxonomies before saving</li>\n<li>Fix: Double rendering on change caused console error in Theme Builder\'s conditions screen</li>\n<li>Fix: Translations and Strings in Share Buttons widget</li>\n<li>Fix: Avoid using offset if the source is Manual selection in Query Control</li>\n<li>Fix: Form being submitted although reCAPTCHA v3 validation failed in Forms widget</li>\n</ul>\n<h4>2.6.5 - 2019-08-26</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.7</li>\n<li>Fix: Button style not working when <code>quantity</code> is enabled in Custom Add To Cart widget</li>\n<li>Fix: Updated minified JS file fixed WhatsApp base URL in Share Buttons widget</li>\n</ul>\n<h4>2.6.4 - 2019-08-21</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.7</li>\n<li>Fix: Changed WhatsApp base URL in Share Buttons widget for cross-device compatibility</li>\n<li>Fix: Random slides order after several clicks on pagination in Testimonial Carousel widget</li>\n</ul>\n<h4>2.6.3 - 2019-08-18</h4>\n<ul>\n<li>Fix: Core version rollback to <code>&gt;2.6.0</code> causes a fatal error</li>\n<li>Fix: Duplicate images when slideshow skin is selected in Media Carousel lightbox</li>\n<li>Fix: Default bottom margin added to reCAPTCHA V3 badge</li>\n<li>Fix: Input glitch in reCAPTCHA V3 threshold settings</li>\n</ul>\n<h4>2.6.2 - 2019-07-30</h4>\n<ul>\n<li>Tweak: Better accessibility support in Search Form widget</li>\n<li>Fix: UI glitched in Popup publish screen (<a href=\"https://github.com/elementor/elementor/issues/8616\">#8616</a>)</li>\n<li>Fix: &quot;Child of Term&quot; and &quot;Any child of term&quot; conditions (<a href=\"https://github.com/elementor/elementor/issues/8695\">#8695</a>)</li>\n<li>Fix: Restored <code>library_widget_templates</code> action hook for 3rd party compatibility (<a href=\"https://github.com/elementor/elementor/issues/8687\">#8687</a>)</li>\n<li>Fix: Twitter Icon missing in Blockquote widget</li>\n<li>Fix: Form reCAPTCHA v3 badge position not working</li>\n<li>Fix: Renewal notice bar appears in wrong situations</li>\n<li>Fix: Draft Icon Set loads empty Icon Library</li>\n</ul>\n<h4>2.6.1 - 2019-07-24</h4>\n<ul>\n<li>Fix: Query Control autocomplete not retrieving results (<a href=\"https://github.com/elementor/elementor/issues/8672\">#8672</a>, <a href=\"https://github.com/elementor/elementor/issues/8661\">#8661</a>)</li>\n<li>Fix: Price Table features section not working (<a href=\"https://github.com/elementor/elementor/issues/8660\">#8660</a>)</li>\n</ul>\n<h4>2.6.0 - 2019-07-23</h4>\n<ul>\n<li>New: Introducing Custom Icon sets - including Fontello, IcoMoon and Fontastic support (<a href=\"https://github.com/elementor/elementor/issues/110\">#110</a>)</li>\n<li>New: Added Font Awesome 5 Pro integration including 5,300+ icons (<a href=\"https://github.com/elementor/elementor/issues/4430\">#4430</a>)</li>\n<li>New: Added reCAPTCHA v3 integration to Form widget (<a href=\"https://github.com/elementor/elementor/issues/8213\">#8213</a>, <a href=\"https://github.com/elementor/elementor/issues/6039\">#6039</a>, <a href=\"https://github.com/elementor/elementor/issues/7165\">#7165</a>)</li>\n<li>Tweak: Added Exit Animation for Popups (<a href=\"https://github.com/elementor/elementor/issues/7063\">#7063</a>)</li>\n<li>Tweak: Added ACF Dynamic tag support for archive pages (<a href=\"https://github.com/elementor/elementor/issues/5147\">#5147</a>)</li>\n<li>Tweak: Added Navigator Indicators for Custom CSS &amp; Motion Effects (<a href=\"https://github.com/elementor/elementor/issues/2180\">#2180</a>)</li>\n<li>Tweak: Added Dynamic capabilities for Form Redirect action (<a href=\"https://github.com/elementor/elementor/issues/7552\">#7552</a>)</li>\n<li>Tweak: Added Logged In Message styling options for Login widget (<a href=\"https://github.com/elementor/elementor/issues/7928\">#7928</a>)</li>\n<li>Tweak: Added <code>none</code> breakpoint option to Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/7916\">#7916</a>)</li>\n<li>Tweak: Added option to place Post Terms dynamic tag without links (<a href=\"https://github.com/elementor/elementor/issues/8366\">#8366</a>)</li>\n<li>Tweak: Added <code>elementor/query/query_results</code> hook to Query Control to allow full control over results (<a href=\"https://github.com/elementor/elementor/issues/7912\">#7912</a>)</li>\n<li>Tweak: Allow choosing Heading HTML tag in Price Table widget (<a href=\"https://github.com/elementor/elementor/issues/8090\">#8090</a>)</li>\n<li>Tweak: Show popup on dynamic click even when <code>Avoid Multiple Popups</code> option is selected (<a href=\"https://github.com/elementor/elementor/issues/8189\">#8189</a>)</li>\n<li>Tweak: Added condition option to all of archive child pages (<a href=\"https://github.com/elementor/elementor/issues/8256\">#8256</a>)</li>\n<li>Tweak: Added <code>Effects Relative To</code> control to Scrolling Effects</li>\n<li>Tweak: Allow shortcodes in HTML Form field</li>\n<li>Tweak: Removed donReach integration from Share Buttons widget due to service inconsistent stability</li>\n<li>Tweak: Changed MailChimp <code>List</code> label to <code>Audience</code></li>\n<li>Tweak: Improved Entrance and Exit animation behavior in Popup</li>\n<li>Tweak: Added <code>Deprecated Notice</code> control to <code>Archive Products</code> and <code>Woo Products</code> widgets</li>\n<li>Tweak: Added default dynamic title for archives in Theme Builder</li>\n<li>Tweak: Added condition to show <code>Centered Slides</code> control in Media Carousel widget</li>\n<li>Tweak: Added notice bar in the Editor when the license is expired or not activated</li>\n<li>Tweak: Replaced <code>select</code> control with <code>choose</code> control in Price List widget</li>\n<li>Tweak: Removed Font Awesome 4 dependencies from the Editor</li>\n<li>Tweak: Minor styling tweaks in the Popup publish modal</li>\n<li>Tweak: Hide ordering form in Products widget on front page</li>\n<li>Tweak: Removed page title markup when \'Hide Title\' is active</li>\n<li>Tweak: Added style controls for HTML field in Form widget</li>\n<li>Fix: Form widget Date picker makes the Popup builder disappear (<a href=\"https://github.com/elementor/elementor/issues/7240\">#7240</a>)</li>\n<li>Fix: Sticky element stop point stops working on viewport resize (<a href=\"https://github.com/elementor/elementor/issues/7884\">#7884</a>)</li>\n<li>Fix: Copy-Paste style not pasting the Pointer option in Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/8497\">#8497</a>)</li>\n<li>Fix: Missing Print icon in Share Buttons (<a href=\"https://github.com/elementor/elementor/issues/8506\">#8506</a>)</li>\n<li>Fix: UI style glitch in Blockquote widget when viewing from iPad</li>\n<li>Deprecated: <code>DB::save_editor()</code> - Remove usage of this method (<a href=\"https://developers.elementor.com/v2-6-0-planned-deprecations/\">Deprecation Post</a>)</li>\n<li>Deprecated: <code>DB::get_plain_editor()</code> - Remove usage of this method (<a href=\"https://developers.elementor.com/v2-6-0-planned-deprecations/\">Deprecation Post</a>)</li>\n</ul>\n<h4>2.5.14 - 2019-07-14</h4>\n<ul>\n<li>Fix: Better WC Related Product grid support to various themes (<a href=\"https://github.com/elementor/elementor/issues/8555\">#8555</a>)</li>\n</ul>\n<h4>2.5.13 - 2019-07-11</h4>\n<ul>\n<li>Fix: Better WC grid support to various themes</li>\n</ul>\n<h4>2.5.12 - 2019-07-10</h4>\n<ul>\n<li>Fix: Grid for WooCommerce Archive Product widget</li>\n<li>Fix: Remove redundant <code>whitespace</code> CSS property causes style glitch in iPad</li>\n<li>Tweak: Added more compatibility for Elementor v2.6</li>\n</ul>\n<h4>2.5.11 - 2019-07-02</h4>\n<ul>\n<li>Fix: Close icon missing from Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/8460\">#8460</a>)</li>\n<li>Fix: Elementor Pro v2.5.10 shows PHP notice regarding notice bar (<a href=\"https://github.com/elementor/elementor/issues/8461\">#8461</a>)</li>\n<li>Fix: Fatal error when deleting used Pods fields (<a href=\"https://github.com/elementor/elementor/issues/8396\">#8396</a>)</li>\n<li>Fix: Missing dropdown icon in conditions screen</li>\n</ul>\n<h4>2.5.10 - 2019-05-28</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.6</li>\n<li>Tweak: Error caused by empty Rows &amp; Columns values in Products widget (<a href=\"https://github.com/elementor/elementor/issues/8261\">#8261</a>)</li>\n<li>Fix: Do not unset <code>product</code> CPT if it\'s not from WooCommerce (<a href=\"https://github.com/elementor/elementor/issues/8160\">#8160</a>)</li>\n<li>Fix: Column Spacing not working in WooCommerce Archive Products widget (<a href=\"https://github.com/elementor/elementor/issues/8285\">#8285</a>)</li>\n<li>Fix: Title styling not working in Products Categories widget</li>\n<li>Fix: Empty value in Dynamic Pods Gallery dropdown using Safari browser</li>\n<li>Fix: WooCommerce archives included in &quot;All Archives&quot; condition</li>\n</ul>\n<h4>2.5.9 - 2019-05-28</h4>\n<ul>\n<li>Tweak: Removed <code>auto-confirm</code> control from MailPoet to support new version of MailPoet</li>\n<li>Fix: Multiple Custom Fonts not rendered in the editor</li>\n<li>Fix: Products <code>sale</code> query - handle exclude by manual selection.</li>\n<li>Fix: Product Categories grid row &amp; column style</li>\n<li>Fix: Form integration AJAX cache override</li>\n<li>Fix: Removed redundant CSS on Canvas &amp; Header-Footer page templates</li>\n</ul>\n<h4>2.5.8 - 2019-05-06</h4>\n<ul>\n<li>Fix: Popup entrance animation not working in frontend</li>\n<li>Fix: Popup Exit Intent trigger activated multiple times</li>\n</ul>\n<h4>2.5.7 - 2019-05-05</h4>\n<ul>\n<li>Fix: Embedded video keeps playing after a Popup is closed (<a href=\"https://github.com/elementor/elementor/issues/7875\">#7875</a>)</li>\n<li>Fix: Maximum call stack size exceeded error in Safari (<a href=\"https://github.com/elementor/elementor/issues/7824\">#7824</a>)</li>\n<li>Fix: Entrance animations not appearing on Popup reopen (<a href=\"https://github.com/elementor/elementor/issues/7395\">#7395</a>)</li>\n<li>Fix: WC variations select style glitch in several themes (<a href=\"https://github.com/elementor/elementor/issues/8008\">#8008</a>)</li>\n<li>Fix: Theme Builder taxonomy conditions not retrieving proper results in edge cases</li>\n</ul>\n<h4>2.5.6 - 2019-04-29</h4>\n<ul>\n<li>Tweak: Removed <code>Shortcode</code> dynamic from Image, Gallery and Media control</li>\n<li>Fix: Popup not inheriting entrance animation in responsive mode (<a href=\"https://github.com/elementor/elementor/issues/7809\">#7809</a>)</li>\n<li>Fix: Terms autocomplete retrieves wrong results in Query Control</li>\n<li>Fix: Query Control Related by author glitches in edge cases</li>\n<li>Fix: Query Control using terms for Products widget</li>\n<li>Fix: Posts cards style glitch in small screens</li>\n<li>Fix: Display conditions delete icon missing in small screens</li>\n<li>Fix: Avoid rendering Menu Cart widget in WordPress native editor</li>\n</ul>\n<h4>2.5.5 - 2019-04-08</h4>\n<ul>\n<li>Tweak: Allow text selection inside a Popup</li>\n<li>Fix: Added backwards compatibility for <code>tax_query</code> in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7751\">#7751</a>)</li>\n<li>Fix: Missing arguments for <code>widget_title</code> filter (<a href=\"https://github.com/elementor/elementor/issues/7745\">#7745</a>)</li>\n</ul>\n<h4>2.5.4 - 2019-04-03</h4>\n<ul>\n<li>Fix: Move Query from using <code>term_id</code> to <code>term_taxonomy_id</code> (<a href=\"https://github.com/elementor/elementor/issues/7653\">#7653</a>)</li>\n<li>Fix: Offset manipulation hook removal in Query control</li>\n<li>Fix: Missing form field <code>ID</code> in some edge cases (<a href=\"https://github.com/elementor/elementor/issues/7711\">#7711</a>, <a href=\"https://github.com/elementor/elementor/issues/7660\">#7660</a>)</li>\n</ul>\n<h4>2.5.3 - 2019-03-31</h4>\n<ul>\n<li>Tweak: Updated Google Calendar dynamic tag URL (<a href=\"https://github.com/elementor/elementor/issues/7673\">#7673</a>)</li>\n<li>Fix: Missing form field names (<a href=\"https://github.com/elementor/elementor/issues/7651\">#7651</a>)</li>\n<li>Fix: PHP 5.4 backward compatibility in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7633\">#7633</a>)</li>\n<li>Fix: <code>products_deprecated</code> Query Control module compatibility (<a href=\"https://github.com/elementor/elementor/issues/7654\">#7654</a>)</li>\n<li>Fix: Changed query method from <code>term_id</code> to <code>term_taxonomy_id</code> (<a href=\"https://github.com/elementor/elementor/issues/7653\">#7653</a>)</li>\n</ul>\n<h4>2.5.2 - 2019-03-27</h4>\n<ul>\n<li>Fix: Overwrite parent widget type in Global Widget (<a href=\"https://github.com/elementor/elementor/issues/7632\">#7632</a>)</li>\n<li>Fix: Avoid Duplicates option not working in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7635\">#7635</a>)</li>\n<li>Fix: Manual Selection option not working in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7634\">#7634</a>)</li>\n<li>Fix: Incorrect condition caused handlers issues inside popup</li>\n</ul>\n<h4>2.5.1 - 2019-03-26</h4>\n<ul>\n<li>Fix: Query Control invalid call to deprecated action (<a href=\"https://github.com/elementor/elementor/issues/7619\">#7619</a>)</li>\n<li>Tweak: Renamed action hook from <code>elementor_pro/{$widget_name}/query/{$query_id}</code> to <code>elementor/query/{$query_id}</code></li>\n<li>Tweak: Renamed filter hook from <code>elementor_pro/query_control/get_query_args/current_query</code> to <code>elementor/query/get_query_args/current_query</code></li>\n</ul>\n<h4>2.5.0 - 2019-03-26</h4>\n<ul>\n<li>New: Introducing Motion Effects including Scrolling &amp; Mouse effects (<a href=\"https://github.com/elementor/elementor/issues/72\">#72</a>)</li>\n<li>New: Introducing Related Posts for Query Control (<a href=\"https://github.com/elementor/elementor/issues/7306\">#7306</a>, <a href=\"https://github.com/elementor/elementor/issues/7490\">#7490</a>)</li>\n<li>New: Introducing Date query for Query Control</li>\n<li>New: Introducing Sticky Posts support for Query Control (<a href=\"https://github.com/elementor/elementor/issues/2501\">#2501</a>)</li>\n<li>Tweak: Added option to open a Popup by a custom selector (<a href=\"https://github.com/elementor/elementor/issues/6871\">#6871</a>, <a href=\"https://github.com/elementor/elementor/issues/6876\">#6876</a>, <a href=\"https://github.com/elementor/elementor/issues/7258\">#7258</a>)</li>\n<li>Tweak: Option to count when Popup is closed in &quot;Show up to X times&quot; Advanced Rule</li>\n<li>Tweak: Added full border radius control options inside Popup</li>\n<li>Tweak: Changed exit intent icon in Popups</li>\n<li>Tweak: Show only one popup in its own preview</li>\n<li>Tweak: Added responsive support to Popup entrance animation control</li>\n<li>Tweak: Conditions - Singular <code>All Pages</code> string changed to <code>Pages</code></li>\n<li>Tweak: Added form field shortcode support for Drip tags (<a href=\"https://github.com/elementor/elementor/issues/7000\">#7000</a>)</li>\n<li>Tweak: Added dynamic capabilities to Price List widget (<a href=\"https://github.com/elementor/elementor/issues/7258\">#7258</a>)</li>\n<li>Tweak: Added Dynamic capabilities to Custom Attributes (<a href=\"https://github.com/elementor/elementor/issues/6779\">#6779</a>)</li>\n<li>Tweak: Added dynamic capabilities to Flip Box widget (<a href=\"https://github.com/elementor/elementor/issues/6986\">#6986</a>)</li>\n<li>Tweak: Decrease <code>z-index</code> for Nav Menu (<a href=\"https://github.com/elementor/elementor/issues/6869\">#6869</a>)</li>\n<li>Tweak: Changed &quot;Scrolling Effects&quot; section label to &quot;Motion Effects&quot;</li>\n<li>Tweak: Use filter <code>get_meta_viewport</code> for header templates (<a href=\"https://github.com/elementor/elementor/issues/7043\">#7043</a>)</li>\n<li>Tweak: use filterable <code>Util::get_public_post_types()</code> in Theme Builder (<a href=\"https://github.com/elementor/elementor/issues/7172\">#7172</a>)</li>\n<li>Tweak: Added Cloudflare rocket-loader support (<a href=\"https://github.com/elementor/elementor/issues/7443\">#7443</a>)</li>\n<li>Tweak: Added responsive support to WC Products Columns &amp; Rows Gap controls (<a href=\"https://github.com/elementor/elementor/issues/6913\">#6913</a>)</li>\n<li>Tweak: WC Menu cart &quot;View Cart&quot; &amp; &quot;Checkout&quot; buttons styling</li>\n<li>Fix: Custom ID reset to default when dragging repeater</li>\n<li>Fix: Conflict between archive-products widget and WC customizer</li>\n<li>Fix: Add to Cart widget <code>spacing</code> and <code>space-between</code></li>\n<li>Fix: Library view when creating a new Header or Footer</li>\n<li>Fix: Post types labels missing on Add New Template modal</li>\n</ul>\n<h4>2.4.8 - 2019-03-11</h4>\n<ul>\n<li>Fix: Missing query section in Products widget</li>\n<li>Fix: Missing Taxonomy controls in Products widget in edge cases</li>\n</ul>\n<h4>2.4.7 - 2019-03-06</h4>\n<ul>\n<li>Fix: Compatibility Global Widget with Elementor v2.5.0+</li>\n</ul>\n<h4>2.4.6 - 2019-03-04</h4>\n<ul>\n<li>Fix: Pods gallery dynamic when empty (<a href=\"https://github.com/elementor/elementor/issues/7127\">#7127</a>)</li>\n<li>Fix: Duplicate call for conditions screen issue</li>\n<li>Fix: Compatibility with Elementor v2.5.0</li>\n</ul>\n<h4>2.4.5 - 2019-02-18</h4>\n<ul>\n<li>Fix: Image size issue in Testimonial Carousel (<a href=\"https://github.com/elementor/elementor/issues/7058\">#7058</a>)</li>\n<li>Fix: MailChimp groups not saved in a form integration (<a href=\"https://github.com/elementor/elementor/issues/7083\">#7083</a>)</li>\n<li>Fix: Show popup preview only on it\'s own preview</li>\n<li>Fix: Elementor dashboard templates URL corrupted links in edge cases</li>\n</ul>\n<h4>2.4.4 - 2019-02-11</h4>\n<ul>\n<li>Tweak: Added ACF Date Time Picker field support (<a href=\"https://github.com/elementor/elementor/issues/6690\">#6690</a>)</li>\n<li>Tweak: Changed the term of <code>All Posts</code> condition to <code>Posts</code></li>\n<li>Fix: Added <code>&lt;IfModule&gt;</code> to avoid 500 error when <code>mod-headers</code> is missing (<a href=\"https://github.com/elementor/elementor/issues/7034\">#7034</a>)</li>\n<li>Fix: Include post CSS deletion in Global Widget update (<a href=\"https://github.com/elementor/elementor/issues/6856\">#6856</a>)</li>\n<li>Fix: <code>Textarea</code> default value in Forms Widget (<a href=\"https://github.com/elementor/elementor/issues/6934\">#6934</a>)</li>\n<li>Fix: MailPoet latest version caused fatal error (<a href=\"https://github.com/elementor/elementor/issues/6996\">#6996</a>)</li>\n<li>Fix: Fatal Error caused by calling MailPoet deleted method</li>\n<li>Notice: MailPoet <code>Auto Confirm</code> option will now default to &quot;On&quot;</li>\n</ul>\n<h4>2.4.3 - 2019-01-30</h4>\n<ul>\n<li>Fix: Custom Add to Cart widget responsive alignment settings</li>\n<li>Fix: Links in Post Info widget</li>\n<li>Fix: WooCommerce <code>View Cart</code> string translate</li>\n<li>Fix: Wrapper classes for header/footer templates (<a href=\"https://github.com/elementor/elementor/issues/6884\">#6884</a>)</li>\n</ul>\n<h4>2.4.2 - 2019-01-25</h4>\n<ul>\n<li>Tweak: Added pixel units to Close Button position control in Popups</li>\n<li>Fix: Exclude error in WC Products widget</li>\n</ul>\n<h4>2.4.1 - 2019-01-24</h4>\n<ul>\n<li>Tweak: Added CSS classes control to Popup (<a href=\"https://github.com/elementor/elementor/issues/6826\">#6826</a>)</li>\n<li>Tweak: Added responsive image size to Testimonial Carousel widget</li>\n<li>Fix: PHP warning when Toolset Date dynamic is empty (<a href=\"https://github.com/elementor/elementor/issues/6842\">#6842</a>)</li>\n<li>Fix: Support of exclude-ids in WC Products widget</li>\n<li>Fix: Popup close button not clickable</li>\n<li>Fix: Alignment justify issue of Add to Cart widget (<a href=\"https://github.com/elementor/elementor/issues/6749\">#6749</a>)</li>\n<li>Fix: Bad anchors breaks the page JS</li>\n<li>Fix: Popup overlay shown when turned off</li>\n</ul>\n<h4>2.4.0 - 2019-01-21</h4>\n<ul>\n<li>New: Introducing Popup Builder (<a href=\"https://github.com/elementor/elementor/issues/628\">#628</a>)</li>\n<li>New: Added <code>Popup</code> Dynamic Tag</li>\n<li>New: Added <code>Popup</code> forms action after submit</li>\n<li>New: Added User Info dynamic tag (<a href=\"https://github.com/elementor/elementor/issues/6322\">#6322</a>)</li>\n<li>Tweak: Added dynamic capabilities for &quot;Nothing Found&quot; message</li>\n<li>Tweak: Added <code>elementor_pro/theme_builder/archive/escape_nothing_found_message</code> Filter to avoid HTML escaping in &quot;Nothing Found&quot; message (<a href=\"https://github.com/elementor/elementor/issues/6053\">#6053</a>)</li>\n<li>Tweak: Added <code>add_doc_to_location</code> method to Allow insertion of a document to a location</li>\n<li>Fix: <code>z-index</code> issue with CTA widget (<a href=\"https://github.com/elementor/elementor/issues/6486\">#6486</a>)</li>\n<li>Fix: Hide the Post Content widget and show it only in a Single document</li>\n<li>Fix: <code>selector</code> replacement in Custom CSS</li>\n<li>Fix: Apply <code>the_content</code> on the real content only</li>\n<li>Fix: CSS for WC products selector (<a href=\"https://github.com/elementor/elementor/issues/6559\">#6559</a>)</li>\n<li>Fix: Odnoklassniki share URL (<a href=\"https://github.com/elementor/elementor/issues/6638\">#6638</a>)</li>\n<li>Fix: Custom link new tab in Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/5766\">#5766</a>)</li>\n<li>Fix: <code>nofollow</code> link in Flip Box &amp; CTA widgets</li>\n<li>Fix: Post Terms in Post Info widget</li>\n<li>Fix: Added screen reader to some icons &amp; buttons for better accessibility (<a href=\"https://github.com/elementor/elementor/issues/5386\">#5386</a>)</li>\n<li>Fix: Accessibility labels in Reviews widget (<a href=\"https://github.com/elementor/elementor/issues/6630\">#6630</a>)</li>\n<li>Fix: Link to cart page not working when WooCommerce Subscriptions is active</li>\n<li>Fix: MailChimp Selected list not showing on reloading in Form widget</li>\n<li>Fix: Sub-menu arrow position in Nav Menu widget</li>\n<li>Fix: Conflict with WP Security Audit Log plugin (<a href=\"https://github.com/elementor/elementor/issues/6648\">#6648</a>)</li>\n</ul>\n<h4>2.3.1 - 2018-12-19</h4>\n<ul>\n<li>Fix: Template widget search functionality (<a href=\"https://github.com/elementor/elementor/issues/6473\">#6473</a>)</li>\n<li>Fix: Apply <code>the_content</code> filter to post content in theme builder</li>\n</ul>\n<h4>2.3.0 - 2018-12-17</h4>\n<ul>\n<li>New: Introducing Discord Integration for Forms (<a href=\"https://github.com/elementor/elementor/issues/4218\">#4218</a>)</li>\n<li>New: Introducing Slack Integration for Forms</li>\n<li>New: Introducing MailerLite Integration for Forms (<a href=\"https://github.com/elementor/elementor/issues/4462\">#4462</a>)</li>\n<li>New: Activate Elementor Pro plugin by connecting to Elementor account</li>\n<li>Tweak: Added <code>elementor_pro/utils/get_public_post_types</code> filter hook (<a href=\"https://github.com/elementor/elementor/issues/5900\">#5900</a>)</li>\n<li>Tweak: Added <code>loop_start</code> &amp; <code>the_content</code> hooks for Post Content (<a href=\"https://github.com/elementor/elementor/issues/6173\">#6173</a>)</li>\n<li>Tweak: Removed Custom Attributes from Page Settings</li>\n<li>Tweak: Always add the Custom CSS control to the Advanced tab</li>\n<li>Fix: In sub Term condition false positive in edge cases</li>\n<li>Fix: ToolSet Dynamic Image fallback</li>\n<li>Fix: Style glitch with the dropdown color in Nav Menu widget</li>\n<li>Fix: Style glitch in the Conditions screen in Safari browser</li>\n<li>Fix: Ribbon in the CTA widget obscures drop down menu (<a href=\"https://github.com/elementor/elementor/issues/6080\">#6080</a>)</li>\n<li>Fix: The color of label won\'t change color in Widget login</li>\n</ul>\n<h4>2.2.5 - 2018-12-11</h4>\n<ul>\n<li>New: Add Style Tab &amp; Custom CSS for Header &amp; Footer Templates.</li>\n<li>Tweak: Added a better identifier for subpages (<a href=\"https://github.com/elementor/elementor/issues/6362\">#6362</a>)</li>\n<li>Tweak: Removed Custom Attributes from page settings</li>\n<li>Fix: Yahoo event URL date issue (<a href=\"https://github.com/elementor/elementor/issues/6354\">#6354</a>)</li>\n<li>Fix: Allow timezone settings in Google event URL (<a href=\"https://github.com/elementor/elementor/issues/6354\">#6354</a>)</li>\n<li>Fix: Avoid <code>z-index</code> changes by <code>nanocss</code> in build process</li>\n<li>Fix: Added missing WC upsells products CSS</li>\n<li>Fix: Nav Menu dropdown losing color on hover</li>\n<li>Fix: WC Product Add-ons CSS compatibility</li>\n</ul>\n<h4>2.2.4 - 2018-12-04</h4>\n<ul>\n<li>Fix: Global widget not saving changes (<a href=\"https://github.com/elementor/elementor/issues/6340\">#6340</a>)</li>\n<li>Fix: Dynamic tags support in Blockquote widget (<a href=\"https://github.com/elementor/elementor/issues/6334\">#6334</a>)</li>\n<li>Fix: Forms Redirect URL action when using form field values with spaces</li>\n</ul>\n<h4>2.2.3 - 2018-11-29</h4>\n<ul>\n<li>Fix: Missing &quot;Edit Template&quot; in Template widget (<a href=\"https://github.com/elementor/elementor/issues/6271\">#6271</a>)</li>\n<li>Fix: Follow menu anchors with UTF8 characters in Nav Menu</li>\n<li>Fix: Show only supported templates in Template widget</li>\n<li>Fix: Revert conflicting fix for a default order for WC archive</li>\n</ul>\n<h4>2.2.2 - 2018-11-28</h4>\n<ul>\n<li>Fix: Lightbox dynamic tag crashes the editor</li>\n</ul>\n<h4>2.2.1 - 2018-11-28</h4>\n<ul>\n<li>New: Added <code>ACF File</code> Dynamic tag to support text controls.</li>\n<li>Tweak: Added option to hide item count bubble when cart is empty in Menu Cart widget (<a href=\"https://github.com/elementor/elementor/issues/6223\">#6223</a>)</li>\n<li>Tweak: Added Actions group for Lightbox and Contact URL tags</li>\n<li>Tweak: Added filter <code>elementor_pro/dynamic_tags/shortcode/should_escape</code> to avoid escaping in Shortcode dynamic tag</li>\n<li>Tweak: MailPoet3 integration allow Subscriber to to subscribe to multiple lists</li>\n<li>Tweak: Added front-end max file size validation for upload fields</li>\n<li>Tweak: Added <code>by-author</code> per Post-Type condition for theme builder</li>\n<li>Fix: Template widget panel not showing the selected template (<a href=\"https://github.com/elementor/elementor/issues/6271\">#6271</a>)</li>\n<li>Fix: Conflict between ACF with Safari browser on Select option in Dynamic tag</li>\n<li>Fix: Add post classes only for the Single template</li>\n<li>Fix: Set document type as not editable for unsupported document like Global widget</li>\n<li>Fix: Avoid duplicate query for current WC product query</li>\n<li>Fix: Product Archive showing oldest products instead of latest</li>\n<li>Fix: CSS reset in Posts widget using cards skin</li>\n</ul>\n<h4>2.2.0 - 2018-11-19</h4>\n<ul>\n<li>New: Introducing Custom Attributes (<a href=\"https://github.com/elementor/elementor/issues/290\">#290</a>, <a href=\"https://github.com/elementor/elementor/issues/3990\">#3990</a>)</li>\n<li>New: Added evergreen option for Countdown widget (<a href=\"https://github.com/elementor/elementor/issues/4459\">#4459</a>)</li>\n<li>New: Added expire actions option for Countdown widget (<a href=\"https://github.com/elementor/elementor/issues/5242\">#5242</a>)</li>\n<li>New: Introducing Reviews widget (<a href=\"https://github.com/elementor/elementor/issues/3854\">#3854</a>)</li>\n<li>New: Introducing Sitemap widget (<a href=\"https://github.com/elementor/elementor/issues/5594\">#5594</a>)</li>\n<li>New: Added Request Parameter dynamic tag (<a href=\"https://github.com/elementor/elementor/issues/4934\">#4934</a>)</li>\n<li>New: Added Shortcode dynamic tag</li>\n<li>New: Added Image and Video Lightbox dynamic tag</li>\n<li>New: Added Contact URL dynamic tag</li>\n<li>New: Added Featured Image Data dynamic tag</li>\n<li>New: Added default value to each field in the Form widget (<a href=\"https://github.com/elementor/elementor/issues/4268\">#4268</a>)</li>\n<li>New: Added &quot;Any Child Of&quot; condition to template conditions (<a href=\"https://github.com/elementor/elementor/issues/5321\">#5321</a>)</li>\n<li>New: Added &quot;In Child&quot; condition to template conditions (<a href=\"https://github.com/elementor/elementor/issues/5587\">#5587</a>)</li>\n<li>Tweak: Added Form Redirect URL with form values (<a href=\"https://github.com/elementor/elementor/issues/2564\">#2564</a>)</li>\n<li>Tweak: Added default post classes to template wrapper (<a href=\"https://github.com/elementor/elementor/issues/5959\">#5959</a>)</li>\n<li>Tweak: Better labels for terms in Query control (<a href=\"https://github.com/elementor/elementor/issues/6092\">#6092</a>)</li>\n<li>Tweak: Renamed &quot;Child Of&quot; templates condition to &quot;Direct Child Of&quot;</li>\n<li>Tweak: Added <code>elementor/theme/get_location_templates/condition_sub_id</code> filter hook to allow template condition translations</li>\n<li>Tweak: Load the Template Library widget via Ajax for better performance</li>\n<li>Tweak: Added 404 page title for Page Title dynamic tag</li>\n<li>Fix: Menu Cart Toggle has # URL link (<a href=\"https://github.com/elementor/elementor/issues/6141\">#6141</a>)</li>\n<li>Fix: Alignment issue in Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/5790\">#5790</a>)</li>\n<li>Fix: Avoid potential security risk in forms</li>\n<li>Fix: Template By Author condition conflicts with 404 page</li>\n<li>Fix: Restored WC Product Content widget in Single Product template</li>\n<li>Fix: Theme Builder Preview URLs for date archives and 404 pages</li>\n<li>Fix: Highlight active menu anchor items only when scrolled into view</li>\n<li>Fix: Carousel Pagination Progress style to support new Swiper version</li>\n</ul>\n<h4>2.1.13 - 2018-11-12</h4>\n<ul>\n<li>Tweak: Added compatibility for new brand Finder in v2.3.0</li>\n<li>Fix: Settings conflict when there are multiple carousels in the page</li>\n</ul>\n<h4>2.1.12 - 2018-11-05</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.3</li>\n<li>Tweak: Better performance for Template Library widget</li>\n<li>Fix: Fatal error if a taxonomy used in a dynamic field is removed (<a href=\"https://github.com/elementor/elementor/issues/6029\">#6029</a>)</li>\n<li>Fix: Date Time dynamic tag now respect site language (<a href=\"https://github.com/elementor/elementor/issues/6001\">#6001</a>)</li>\n<li>Fix: Custom CSS printed twice in the front-end</li>\n<li>Fix: ACF Image field PHP warning (<a href=\"https://github.com/elementor/elementor/issues/6051\">#6051</a>)</li>\n</ul>\n<h4>2.1.11 - 2018-10-22</h4>\n<ul>\n<li>New: Added ACF local fields compatibility</li>\n<li>Tweak: Re-brand TypeKit by Adobe Fonts integration</li>\n<li>Fix: Exclude <code>is_embed</code> from Singular condition (<a href=\"https://github.com/elementor/elementor/issues/5915\">#5915</a>)</li>\n<li>Fix: Avoid conflict with Ad Blockers and Share Buttons</li>\n<li>Fix: Current date time dynamic tag now shows local time</li>\n<li>Fix: Avoid conflict with 3rd party plugins that filter the permalink</li>\n<li>Fix: Avoid PHP warning when no groups are selected for MailChimp integration</li>\n<li>Fix: Avoid PHP warning if checkbox field is empty for ACF</li>\n<li>Fix: Respect password protected for a WC single product template</li>\n<li>Fix: Respect <code>order</code> settings for WC archive also without pagination</li>\n</ul>\n<h4>2.1.10 - 2018-10-09</h4>\n<ul>\n<li>Tweak: Added responsive alignment control for Share Buttons widget (<a href=\"https://github.com/elementor/elementor/issues/5821\">#5821</a>)</li>\n<li>Tweak: Added link control to Animated Headline widget</li>\n<li>Fix: Mobile nav menu jump on RTL (<a href=\"https://github.com/elementor/elementor/issues/5711\">#5711</a>)</li>\n<li>Fix: Responsive alignment control in Add to Cart widget (<a href=\"https://github.com/elementor/elementor/issues/5830\">#5830</a>)</li>\n<li>Fix: Added IE compatibility for Animated Headline widget</li>\n<li>Fix: Post Content widget is now shown only on <code>Single</code> templates</li>\n<li>Fix: Query Control Pagination with offset</li>\n</ul>\n<h4>2.1.9 - 2018-09-17</h4>\n<ul>\n<li>Tweak: Added Centered Slides option for Slideshow carousel</li>\n<li>Fix: Allow only public CPT for Manual Selection in Query Control (<a href=\"https://github.com/elementor/elementor/issues/5091\">#5091</a>)</li>\n<li>Fix: ACF Gallery option support (<a href=\"https://github.com/elementor/elementor/issues/5344\">#5344</a>)</li>\n<li>Fix: Page scrolling on resize when sticky is active (<a href=\"https://github.com/elementor/elementor/issues/5740\">#5740</a>)</li>\n<li>Fix: Edit custom name for Global Widget in the Navigator (<a href=\"https://github.com/elementor/elementor/issues/5689\">#5689</a>)</li>\n<li>Fix: Coverflow transition effect in Carousel</li>\n<li>Fix: Weird mobile behavior with Cube effect in Carousel</li>\n<li>Fix: Show the first thumbnail in the Slideshow carousel correctly</li>\n</ul>\n<h4>2.1.8 - 2018-09-12</h4>\n<ul>\n<li>Tweak: Added styling options for WC Additional Information widget</li>\n<li>Tweak: Added styling options for \'View Cart\' link in Products widget</li>\n<li>Fix: 3rd party plugin support for WC single product template (<a href=\"https://github.com/elementor/elementor/issues/5338\">#5338</a>)</li>\n<li>Fix: Layout of Related Product widget with WC native style</li>\n</ul>\n<h4>2.1.7 - 2018-09-03</h4>\n<ul>\n<li>New: WC Archive Description widget</li>\n<li>Tweak: Added blend mode to Slides widget background overlay (<a href=\"https://github.com/elementor/elementor/issues/5555\">#5555</a>)</li>\n<li>Tweak: Added \'Current Subcategories\' option to Product Categories widget</li>\n<li>Fix: Added default vertical alignment in Author Box widget (<a href=\"https://github.com/elementor/elementor/issues/5589\">#5589</a>)</li>\n<li>Tweak: Added more blend mode options for CTA widget</li>\n<li>Tweak: Improved plugin updater method based on WordPress version</li>\n<li>Fix: Improved IE compatibility for Posts and Portfolio widgets</li>\n<li>Fix: Added default gap for products pagination</li>\n<li>Fix: Post thumbnail flickering in Safari browser</li>\n<li>Fix: Close mobile nav menu on click only in full-width mode</li>\n<li>Fix: Added trailing slash to pagination links in Posts widget</li>\n</ul>\n<h4>2.1.6 - 2018-08-28</h4>\n<ul>\n<li>New: WC Product Category Image widget and Dynamic tag (<a href=\"https://github.com/elementor/elementor/issues/5117\">#5117</a>)</li>\n<li>Tweak: Allow HTML in Excerpt widget (<a href=\"https://github.com/elementor/elementor/issues/5491\">#5491</a>)</li>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.2</li>\n<li>Tweak: Deprecated Follow option in the Facebook Button widget</li>\n<li>Fix: Posts widget grid in Safari &amp; IE11 (Depended on Elementor v2.2)</li>\n<li>Fix: Posts widget CSS when using cards skin in masonry mode</li>\n<li>Fix: ACF Image &amp; ACF URL option support (<a href=\"https://github.com/elementor/elementor/issues/5344\">#5344</a>)</li>\n<li>Fix: WC product gallery links in RTL</li>\n<li>Fix: Dynamic tags in Call To Action widget</li>\n</ul>\n<h4>2.1.5 - 2018-08-21</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.2</li>\n<li>Fix: Posts Widget layout theme compatibility</li>\n<li>Fix: Added compatibility for WooCommerce native style</li>\n</ul>\n<h4>2.1.4 - 2018-08-19</h4>\n<ul>\n<li>Fix: Layout issue compatibility with themes caused by v2.1 (<a href=\"https://github.com/elementor/elementor/issues/5442\">#5442</a>)</li>\n<li>Fix: Dynamic setting in Pricing Table widget (<a href=\"https://github.com/elementor/elementor/issues/5460\">#5460</a>)</li>\n<li>Fix: Hide Target URL control if is not necessary in Blockquote widget</li>\n<li>Fix: Selector specificity for WooCommerce Products widget</li>\n<li>Fix: WooCommerce conflicts in the editor in edge cases</li>\n</ul>\n<h4>2.1.3 - 2018-08-15</h4>\n<ul>\n<li>Fix: Thumbnails in the Posts widget jumping (<a href=\"https://github.com/elementor/elementor/issues/5350\">#5350</a>)</li>\n<li>Fix: Responsive grid in the Share Buttons widget (<a href=\"https://github.com/elementor/elementor/issues/5375\">#5375</a>)</li>\n<li>Fix: Added missing <code>setup_postdata</code> for Product Data Tabs widget</li>\n<li>Fix: Rollback to older version of Flip Box widget to resolve 3D depth issue (<a href=\"https://github.com/elementor/elementor/issues/5399\">#5399</a>)</li>\n<li>Fix: Allowed types in the Upload File field are now case-insensitive (<a href=\"https://github.com/elementor/elementor/issues/5254\">#5254</a>)</li>\n<li>Fix: Carousel behavior when using a single slide</li>\n</ul>\n<h4>2.1.2 - 2018-08-12</h4>\n<ul>\n<li>Fix: Error when ACF Pro is not installed (<a href=\"https://github.com/elementor/elementor/issues/5367\">#5367</a>)</li>\n<li>Fix: Edge cases in Inspector where document is a boolean</li>\n<li>Fix: Edge cases for incorrect file fields in PODS</li>\n</ul>\n<h4>2.1.1 - 2018-08-09</h4>\n<ul>\n<li>Fix: Highlighted text in Animated Headline widget (<a href=\"https://github.com/elementor/elementor/issues/5345\">#5345</a>)</li>\n<li>Fix: Flip Box effect issues</li>\n<li>Fix: ACF Options page fields support (<a href=\"https://github.com/elementor/elementor/issues/5329\">#5329</a>)</li>\n<li>Fix: Import Pro templates in edge cases</li>\n</ul>\n<h4>2.1.0 - 2018-08-07</h4>\n<ul>\n<li>New: Introducing WooCommerce Builder (<a href=\"https://github.com/elementor/elementor/issues/1690\">#1690</a>)</li>\n<li>New: Introducing 12 new dynamic tags &amp; widgets for WooCommerce: Gallery, Image, Price, Rating, Description, Breadcrumbs, Data Tabs, Stock, Related, Upsell, Title &amp; Archive</li>\n<li>New: Introducing Cart Menu widget (<a href=\"https://github.com/elementor/elementor/issues/4220\">#4220</a>, <a href=\"https://github.com/elementor/elementor/issues/4600\">#4600</a>)</li>\n<li>New: Added integration with Toolset (<a href=\"https://github.com/elementor/elementor/issues/2949\">#2949</a>)</li>\n<li>New: Added integration with Pods (<a href=\"https://github.com/elementor/elementor/issues/4129\">#4129</a>)</li>\n<li>New: Added stick to bottom in scrolling effects (<a href=\"https://github.com/elementor/elementor/issues/4799\">#4799</a>)</li>\n<li>New: Added Scrolling Effect to Widgets under advanced tab</li>\n<li>New: Introducing Internal URL Dynamic Tag</li>\n<li>Tweak: Added a Last Updated Date in the Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/4597\">#4597</a>)</li>\n<li>Tweak: Added Redirect after Logout option for Login widget (<a href=\"https://github.com/elementor/elementor/issues/4447\">#4447</a>)</li>\n<li>Tweak: Avoid repeating posts when using more than one in the Posts widget (<a href=\"https://github.com/elementor/elementor/issues/1878\">#1878</a>)</li>\n<li>Tweak: Add Custom Query hook for Query control (<a href=\"https://developers.elementor.com/custom-query-filter/\">More Info</a>) (<a href=\"https://github.com/elementor/elementor/issues/1748\">#1748</a>)</li>\n<li>Tweak: Added form-message style (<a href=\"https://github.com/elementor/elementor/issues/1180\">#1180</a>)</li>\n<li>Tweak: Added dynamic tag for button on the Price Table widget (<a href=\"https://github.com/elementor/elementor/issues/4242\">#4242</a>)</li>\n<li>Tweak: Added dynamic tag for Call to action widget (<a href=\"https://github.com/elementor/elementor/issues/4767\">#4767</a>)</li>\n<li>Tweak: Added Dynamic Tags support for Google Map field (<a href=\"https://github.com/elementor/elementor/issues/4602\">#4602</a>)</li>\n<li>Tweak: Added an support for <code>label|value</code> in options field (<a href=\"https://github.com/elementor/elementor/issues/4594\">#4594</a>)</li>\n<li>Tweak: Added <code>by-author</code> condition for theme builder (<a href=\"https://github.com/elementor/elementor/issues/4681\">#4681</a>)</li>\n<li>Tweak: Added Activate/Deactivate license key via WP-CLI command (<a href=\"https://github.com/elementor/elementor/issues/4149\">#4149</a>)</li>\n<li>Tweak: Added <code>is_scroll</code> trigger to scrolling effect (<a href=\"https://github.com/elementor/elementor/issues/4340\">#4340</a>)</li>\n<li>Tweak: Added In Same Term support for Post Navigation widget (<a href=\"https://github.com/elementor/elementor/issues/4177\">#4177</a>)</li>\n<li>Tweak: Added responsive control for Slides To Scroll control in all carousel widgets (<a href=\"https://github.com/elementor/elementor/issues/3697\">#3697</a>)</li>\n<li>Tweak: Added style options for Posts widget (<a href=\"https://github.com/elementor/elementor/issues/1335\">#1335</a>)</li>\n<li>Tweak: Added button CSS ID for Forms widget</li>\n<li>Tweak: Added pixel units to Post-Info divider height control</li>\n<li>Tweak: Rewrite sticky library to handle with stretch section, auto scroller &amp; more bugs</li>\n<li>Tweak: Re-organize the panel categories per document type</li>\n<li>Tweak: Added ACF support for <code>options-page</code> fields</li>\n<li>Tweak: Added dynamic tag for Animated headlines</li>\n<li>Tweak: Added dynamic tag for BlockQuote widget</li>\n<li>Fix: Elementor Full Width template in GeneratePress theme (<a href=\"https://github.com/elementor/elementor/issues/4817\">#4817</a>)</li>\n<li>Fix: Checkbox fields can accidentally be set to required (<a href=\"https://github.com/elementor/elementor/issues/4324\">#4324</a>)</li>\n<li>Fix: Initial slide in Carousel widget</li>\n<li>Fix: Stay on current slide while editing in Carousel widget</li>\n<li>Fix: Default slides per device in Carousel widget</li>\n<li>Deprecated: Woo Products, Woo Elements &amp; Single elements widgets</li>\n</ul>\n<h4>2.0.18 - 2018-07-27</h4>\n<ul>\n<li>Fix: Global widget error on saving page</li>\n</ul>\n<h4>2.0.17 - 2018-07-26</h4>\n<ul>\n<li>Fix: Sub menu indicator direction in Nav Menu widget</li>\n<li>Fix: Change the title and icon for Global Widget when is moving</li>\n<li>Fix: CSS wrapper selector for Page Document</li>\n</ul>\n<h4>2.0.16 - 2018-07-16</h4>\n<ul>\n<li>Tweak: CSS Filter Control module is now included in Elementor</li>\n<li>Fix: Border gap in Portfolio widget when item gap set as <code>0</code> (<a href=\"https://github.com/elementor/elementor/issues/5077\">#5077</a>)</li>\n<li>Fix: Restore current query after get Global Widget data</li>\n<li>Fix: Add action item in History on unlink Global widget</li>\n</ul>\n<h4>2.0.15 - 2018-07-10</h4>\n<ul>\n<li>Fix: Dropdown menu items collapsing when activated (<a href=\"https://github.com/elementor/elementor/issues/4996\">#4996</a>)</li>\n<li>Fix: GMT offset in Countdown widget (<a href=\"https://github.com/elementor/elementor/issues/4997\">#4997</a>)</li>\n</ul>\n<h4>2.0.14 - 2018-07-08</h4>\n<ul>\n<li>Tweak: Added set method to form record for developers (<a href=\"https://github.com/elementor/elementor/issues/4983\">#4983</a>)</li>\n<li>Fix: Autoplay option for Carousels</li>\n<li>Fix: Close mobile menu on item click in the Nav Menu widget</li>\n</ul>\n<h4>2.0.13 - 2018-07-03</h4>\n<ul>\n<li>Tweak: Added compatibility for Elementor v2.1</li>\n</ul>\n<h4>2.0.12 - 2018-07-02</h4>\n<ul>\n<li>Fix: Global widget PHP notices</li>\n<li>Fix: Slides widget active slide lost focus when clicking Editor tabs</li>\n<li>Fix: Form select field send all selected values on multiple selection</li>\n<li>Fix: Validate time field only if it\'s not empty</li>\n<li>Fix: ConvertKit API not saving name field</li>\n</ul>\n<h4>2.0.11 - 2018-06-12</h4>\n<ul>\n<li>Fix: Theme Builder <code>author</code> archive condition (<a href=\"https://github.com/elementor/elementor/issues/4593\">#4593</a>)</li>\n<li>Fix: Respect password protected posts in Post Content widget</li>\n<li>Fix: Custom Fonts redirect to post edit screen in edge cases.</li>\n</ul>\n<h4>2.0.10 - 2018-06-05</h4>\n<ul>\n<li>Tweak: Added <code>elementor/theme/get_location_templates/template_id</code> filter hook for multi-language plugins</li>\n<li>Fix: Dynamic Post Terms missing taxonomies if the taxonomy is registered to more then one post types (#4386)</li>\n<li>Fix: Fields shortcode missing after removing a field in Form widget</li>\n<li>Deprecated: <code>get_theme_templates_by_location</code> is replaced by <code>get_location_templates</code></li>\n</ul>\n<h4>2.0.9 - 2018-05-28</h4>\n<ul>\n<li>Fix: Compatibility for PHP version 5.4</li>\n</ul>\n<h4>2.0.8 - 2018-05-28</h4>\n<ul>\n<li>Tweak: Added Active state for Nav Menu dropdown</li>\n<li>Tweak: Added style for &quot;Nothing Found&quot; Message for Archive Posts widget</li>\n<li>Tweak: Removed caption control in Site Logo widget</li>\n<li>Tweak: Added option to position currency symbol before/after In Price Table widget</li>\n<li>Fix: Query control manual selection does not show more than 10 items (<a href=\"https://github.com/elementor/elementor/issues/4479\">#4479</a>)</li>\n<li>Fix: Styling glitch with terms list in Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/4342\">#4342</a>)</li>\n<li>Fix: Sub terms missing in Query control in edge cases (<a href=\"https://github.com/elementor/elementor/issues/4527\">#4527</a>)</li>\n<li>Fix: Avoid rendering a template if it\'s not published</li>\n<li>Fix: 404 Page style not working</li>\n<li>Fix: Price Table button with hover animation not working in editor</li>\n<li>Fix: Styling conflict in Call to Action widget</li>\n<li>Fix: Global Widget tab translation</li>\n<li>Fix: Adding parent wrapper class to Site Title widget</li>\n</ul>\n<h4>2.0.7 - 2018-05-16</h4>\n<ul>\n<li>Fix: Content not found on section when single is set to &quot;All Singular&quot;</li>\n<li>Fix: Open 404 template library for 404 page</li>\n<li>Tweak: Added CSS prefix for dev files</li>\n<li>Tweak: Removed product post type from display conditions</li>\n</ul>\n<h4>2.0.6 - 2018-05-15</h4>\n<ul>\n<li>Tweak: Set type on create new single template</li>\n<li>Tweak: Always show the conditions dialog in the Draft status</li>\n<li>Tweak: Added document type <code>widget</code></li>\n<li>Tweak: Added Post Custom Field tag to URL category</li>\n<li>Fix: When ACF Field Groups are Empty (<a href=\"https://github.com/elementor/elementor/issues/4428\">#4428</a>)</li>\n<li>Fix: Links inside carousel in edge cases</li>\n<li>Fix: Responsive issue in My Templates area</li>\n<li>Fix: Image alignment for post content with text alignment</li>\n<li>Fix: Post Content widget when preview post is missing</li>\n<li>Fix: Global Widget tab translation</li>\n<li>Fix: Style settings for Post / Archive Title widgets</li>\n</ul>\n<h4>2.0.5 - 2018-05-08</h4>\n<ul>\n<li>Fix: Creating a CPT with name like document-type breaks the editor (<a href=\"https://github.com/elementor/elementor/issues/4203\">#4203</a>)</li>\n<li>Fix: Added support for new version of reCAPTCHA</li>\n<li>Fix: Added fallback for controls after <code>post_status</code></li>\n<li>Fix: Required field in forms widget</li>\n<li>Fix: Media Carousel in the Coverflow skin</li>\n<li>Fix: 404 Page show wrong template in edge cases</li>\n<li>Fix: Save the default menu in the Nav Menu widget</li>\n</ul>\n<h4>2.0.4 - 2018-05-02</h4>\n<ul>\n<li>Tweak: Added parent\'s class for extended widgets</li>\n<li>Tweak: Set entire-site as default to avoid conflict with save without conditions</li>\n<li>Tweak: Initialize global model when it\'s needed</li>\n<li>Tweak: Removed some duplicate strings</li>\n<li>Tweak: Query control now includes empty terms</li>\n<li>Tweak: Design polish for conditions dialog</li>\n<li>Tweak: Decreasing <code>minimumInputLength</code> to 1 of select2</li>\n<li>Fix: Editor not loading for single templates in edge cases</li>\n<li>Fix: Select2 in Safari takes it\'s time to get the original select width (<a href=\"https://github.com/elementor/elementor/issues/4310\">#4310</a>)</li>\n<li>Fix: Slides per view not working for some effects</li>\n<li>Fix: New slides not showing in the editor</li>\n<li>Fix: Editor for section without a defined location, defaults to content area</li>\n</ul>\n<h4>2.0.3 - 2018-04-24</h4>\n<ul>\n<li>Tweak: Optimize CSS for Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/4214\">#4214</a>, <a href=\"https://github.com/elementor/elementor/issues/4216\">#4216</a>, <a href=\"https://github.com/elementor/elementor/issues/4225\">#4225</a>)</li>\n<li>Fix: Double render on frontend view in core locations</li>\n<li>Fix: Masonry not working in edge cases</li>\n<li>Fix: Added default setting for Author Info tag</li>\n</ul>\n<h4>2.0.2 - 2018-04-18</h4>\n<ul>\n<li>Fix: Regenerate conditions to include all templates</li>\n</ul>\n<h4>2.0.1 - 2018-04-17</h4>\n<ul>\n<li>Tweak: Added div wrapper for Nothing Found massage (<a href=\"https://github.com/elementor/elementor/issues/4136\">#4136</a>)</li>\n<li>Tweak: Show empty categories in Query Control &amp; Display Conditions (<a href=\"https://github.com/elementor/elementor/issues/4127\">#4127</a>)</li>\n<li>Tweak: Added Divider control for Post Info widget</li>\n<li>Fix: Update admin links in Yoast Breadcrumbs widget</li>\n<li>Fix: Sticky element conflict with clearfix CSS</li>\n<li>Fix: Compatibility for PHP version 5.4.32 &amp; 5.5.16 and below</li>\n<li>Fix: Avoid running <code>wp_head</code> hooks twice</li>\n</ul>\n<h4>2.0.0 - 2018-04-16</h4>\n<ul>\n<li>New: Introducing Theme Builder - <a href=\"https://elementor.com/introducing-theme-builder/\">Release Post</a> (<a href=\"https://github.com/elementor/elementor/issues/417\">#417</a>)</li>\n<li>New: Introducing Locations API to inject custom location templates</li>\n<li>New: Introducing Display Conditions for all dynamic templates</li>\n<li>New: Introducing Dynamic Tag feature - a new way to add dynamic content to your design</li>\n<li>New: Introducing Role manager to allow &quot;Content Only mode&quot; (<a href=\"https://github.com/elementor/elementor/issues/483\">#483</a>, <a href=\"https://github.com/elementor/elementor/issues/653\">#653</a>, <a href=\"https://github.com/elementor/elementor/issues/885\">#885</a>)</li>\n<li>New: Introducing 9 new dynamic widgets: Archive Posts, Archive Title, Post Content, Post Info, Post Title, Post Excerpt, Featured Image, Site Logo &amp; Site Name (<a href=\"https://github.com/elementor/elementor/issues/543\">#543</a>)</li>\n<li>New: Introducing Developers area with guides and API documentation - <a href=\"https://elementor.com/introducing-elementor-developer-api/\">Release Post</a> (<a href=\"https://github.com/elementor/elementor/issues/451\">#451</a>)</li>\n<li>New: Introducing <a href=\"https://github.com/elementor/elementor-hello-theme\">Elementor Hello Theme</a> - A demonstration theme for developers</li>\n<li>New: Added new type of templates: Header, Footer, Single and Archive (<a href=\"https://github.com/elementor/elementor/issues/2761\">#2761</a>, <a href=\"https://github.com/elementor/elementor/issues/2623\">#2623</a>, <a href=\"https://github.com/elementor/elementor/issues/2109\">#2109</a>, <a href=\"https://github.com/elementor/elementor/issues/2061\">#2061</a>, <a href=\"https://github.com/elementor/elementor/issues/2439\">#2439</a>)</li>\n<li>New: Design 404 page with Single template (<a href=\"https://github.com/elementor/elementor/issues/1558\">#1558</a>)</li>\n<li>New: Design Search Results with Archive template (<a href=\"https://github.com/elementor/elementor/issues/3196\">#3196</a>, <a href=\"https://github.com/elementor/elementor/issues/2590\">#2590</a>)</li>\n<li>New: Added Scrolling Effect for sections including <em>Sticky Element</em> per device (<a href=\"https://github.com/elementor/elementor/issues/2412\">#2412</a>)</li>\n<li>New: Integration with Custom Fields (<a href=\"https://github.com/elementor/elementor/issues/2054\">#2054</a>)</li>\n<li>New: Partial support for Toolset integration (<a href=\"https://github.com/elementor/elementor/issues/2949\">#2949</a>)</li>\n<li>New: Partial support for Pods integration (<a href=\"https://github.com/elementor/elementor/issues/2169\">#2169</a>)</li>\n<li>New: Partial support for ACF integration (<a href=\"https://github.com/elementor/elementor/issues/2041\">#2041</a>, <a href=\"https://github.com/elementor/elementor/issues/2059\">#2059</a>)</li>\n<li>Tweak: Add custom fields support for ActiveCampaign (<a href=\"https://github.com/elementor/elementor/issues/3531\">#3531</a>)</li>\n<li>Tweak: Allow brackets in Forms Tel field</li>\n<li>Tweak: Added currency format control for Price Table widget</li>\n<li>Tweak: Reduced API request for some servers</li>\n<li>Fix: Dropdown <code>border-radius</code> in Nav Menu widget</li>\n<li>Fix: Price List widget layout breaks in edge cases</li>\n<li>Note: This version requires Elementor v2.0.6</li>\n</ul>\n<h4>1.15.6 - 2018-03-28</h4>\n<ul>\n<li>Fix: Removed duplicate Custom CSS section (<a href=\"https://github.com/elementor/elementor/issues/3938\">#3938</a>)</li>\n<li>Fix: <code>box-shadow</code> issue with cards skin (<a href=\"https://github.com/elementor/elementor/issues/3940\">#3940</a>)</li>\n</ul>\n<h4>1.15.5 - 2018-03-27</h4>\n<ul>\n<li>Fix: Added global widget compatibility for Elementor v2.0</li>\n<li>Fix: Reduced API request for some servers</li>\n</ul>\n<h4>1.15.4 - 2018-03-26</h4>\n<ul>\n<li>Tweak: Allow brackets in phone field</li>\n<li>Tweak: Added compatibility with Yoast 7.0.+</li>\n<li>Tweak: Added compatibility for the future release of Elementor v2.0</li>\n<li>Fix: Support for multiple carousel setting in editor</li>\n<li>Fix: <code>on_export</code> issue in forms widget (<a href=\"https://github.com/elementor/elementor/issues/3890\">#3890</a>)</li>\n</ul>\n<h4>1.15.3 - 2018-03-07</h4>\n<ul>\n<li>Tweak: Added unique class to field group div (<a href=\"https://github.com/elementor/elementor/issues/3595\">#3595</a>)</li>\n<li>Fix: Screen Options missing when Pro is active (<a href=\"https://github.com/elementor/elementor/issues/3622\">#3622</a>)</li>\n<li>Fix: Allow label styling even when <code>show labels</code> is set hide (<a href=\"https://github.com/elementor/elementor/issues/3544\">#3544</a>)</li>\n<li>Fix: Typography control not working in edge cases</li>\n<li>Fix: Safari compatibility for Search widget</li>\n</ul>\n<h4>1.15.2 - 2018-02-27</h4>\n<ul>\n<li>Fix: Only add support mine-type if needed (<a href=\"https://github.com/elementor/elementor/issues/3543\">#3543</a>)</li>\n<li>Fix: Better support for Old Typekit kits</li>\n</ul>\n<h4>1.15.1 - 2018-02-21</h4>\n<ul>\n<li>Tweak: Custom font title placeholder is not <code>enter font family</code></li>\n<li>Tweak: Custom font title set as required</li>\n<li>Fix: Custom font, <code>font-face</code> enqueued only once if used in global (<a href=\"https://github.com/elementor/elementor/issues/3513\">#3513</a>)</li>\n<li>Fix: Added workaround for upload validation which relies on a PHP extension (fileinfo) with inconsistent reporting behavior.</li>\n</ul>\n<h4>1.15.0 - 2018-02-19</h4>\n<ul>\n<li>New: Added custom fonts manager for self hosted fonts (<a href=\"https://github.com/elementor/elementor/issues/852\">#852</a>)</li>\n<li>New: Integration with Adobe TypeKit fonts (<a href=\"https://github.com/elementor/elementor/issues/631\">#631</a>)</li>\n<li>Tweak: Clear menu from Nav Menu widget on template export</li>\n<li>Tweak: Allow zero for GetResponse integration as <code>day of cycle</code></li>\n</ul>\n<h4>1.14.2 - 2018-02-13</h4>\n<ul>\n<li>Fix: Global widget content that got affected by previous update</li>\n</ul>\n<h4>1.14.1 - 2018-02-13</h4>\n<ul>\n<li>Tweak: Added <code>none</code> option to content animation in CTA widget</li>\n<li>Tweak: Added <code>form_id</code> to ActiveCampaign integration (<a href=\"https://github.com/elementor/elementor/issues/3422\">#3422</a>)</li>\n<li>Fix: Page crashed when Global widget not found.</li>\n</ul>\n<h4>1.14.0 - 2018-02-12</h4>\n<ul>\n<li>New: Added Call to Action widget</li>\n<li>Tweak: MailPoet pull field mapping from MailPoet instead of hardcoded</li>\n<li>Tweak: Added compatibility for the future release of Elementor v2.0</li>\n<li>Fix: Allow zero (0) to be accepted as a field value</li>\n<li>Fix: Login form when custom login URL is set</li>\n<li>Fix: Added Day of cycle control to GetResponse integration</li>\n</ul>\n<h4>1.13.2 - 2018-01-23</h4>\n<ul>\n<li>Tweak: Added placeholder to Password field</li>\n<li>Tweak: Removed <code>subscriber_already_exists_message</code> control to prevent potential data leakage</li>\n<li>Fix: MailPoet Subscriber Already Exists error validation against translated string directly from MailPoet</li>\n<li>Fix: Changed <code>imagesLoaded()</code> to Vanilla JS to avoid compatibility issues with some themes</li>\n<li>Fix: Only validate Tel field if not empty</li>\n<li>Fix: Stop slider while editing</li>\n</ul>\n<h4>1.13.1 - 2018-01-16</h4>\n<ul>\n<li>Fix: Added compatibility with old PHP versions</li>\n</ul>\n<h4>1.13.0 - 2018-01-16</h4>\n<ul>\n<li>New: Added File Upload field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1482\">#1482</a>, <a href=\"https://github.com/elementor/elementor/issues/2974\">#2974</a>)</li>\n<li>New: Added Acceptance field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1693\">#1693</a>, <a href=\"https://github.com/elementor/elementor/issues/2974\">#2974</a>)</li>\n<li>New: Added Date field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1868\">#1868</a>)</li>\n<li>New: Added Time field for Forms widget</li>\n<li>New: Added Password field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/2164\">#2164</a>)</li>\n<li>New: Added HTML field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1500\">#1500</a>)</li>\n<li>Tweak: Added characters validation for Tel field</li>\n<li>Tweak: Added min &amp; max validation for Number field</li>\n<li>Tweak: Added multiple selection for Select field</li>\n<li>Tweak: Added donReach integration for Share Buttons widget</li>\n</ul>\n<h4>1.12.3 - 2018-01-09</h4>\n<ul>\n<li>Fix: Render element plain content instead of parsed content when not needed in global widget</li>\n<li>Fix: Apply <code>url-encoding</code> to &quot;Tweet&quot; button text in Blockquote widget to prevent unexpected corruption of the tweet text</li>\n<li>Fix: Removed My Account link from dashboard widget</li>\n</ul>\n<h4>1.12.2 - 2018-01-03</h4>\n<ul>\n<li>Tweak: Added animation none for Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/2964\">#2964</a>)</li>\n<li>Fix: Active license button style</li>\n</ul>\n<h4>1.12.1 - 2018-01-02</h4>\n<ul>\n<li>Tweak: Removed theme-element widgets from plain content</li>\n<li>Tweak: Set all theme-element widgets to extend same widget Base</li>\n<li>Tweak: Removed credit URL in forms meta data</li>\n<li>Tweak: Added compatibility for the future release of Elementor v1.9</li>\n<li>Fix: Validate Get response Error as real error</li>\n<li>Fix: Removed responsive height control from Facebook Page widget</li>\n</ul>\n<h4>1.12.0 - 2017-12-20</h4>\n<ul>\n<li>New: Added Drip integration to Forms</li>\n<li>New: Added ActiveCampaign integration to Forms</li>\n<li>New: Added ConverKit integration to Forms</li>\n<li>New: Added GetResponse integration to Forms</li>\n<li>New: Added form <code>id</code>, <code>name</code> attributes to handle integration with auto collectors like HubSpot</li>\n<li>New: Added Global API key for MailChimp to improve the workflow</li>\n<li>Tweak: Better error handling and message display for Forms</li>\n<li>Fix: PHP notice Undefined variable <code>$cc_header</code> (<a href=\"https://github.com/elementor/elementor/issues/2934\">#2934</a>)</li>\n</ul>\n<h4>1.11.0 - 2017-12-11</h4>\n<ul>\n<li>New: Added a native Comments widget (<a href=\"https://github.com/elementor/elementor/issues/543\">#543</a>)</li>\n<li>New: Added an Author Box widget</li>\n<li>New: Added a Post Navigation widget</li>\n<li>New: Added a Yoast Breadcrumbs widget (<a href=\"https://github.com/elementor/elementor/issues/2749\">#2749</a>)</li>\n<li>Tweak: Added a close button to search widget under Full Screen skin (<a href=\"https://github.com/elementor/elementor/issues/2762\">#2762</a>)</li>\n<li>Fix: Allow currency symbol to appear even if price isn\'t numeric</li>\n<li>Fix: Edge cases when the nav menu is empty in a stretched section</li>\n<li>Fix: Added fallback when you remove the <code>space-between</code> on Swiper carousel</li>\n</ul>\n<h4>1.10.2 - 2017-12-03</h4>\n<ul>\n<li>Fix: Missing save widget icon (<a href=\"https://github.com/elementor/elementor/issues/2878\">#2878</a>)</li>\n<li>Fix: Global widgets not saving edits (<a href=\"https://github.com/elementor/elementor/issues/2874\">#2874</a>)</li>\n<li>Fix: Removed <code>white-space: nowrap;</code> property from vertical menu in Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/2815\">#2815</a>)</li>\n</ul>\n<h4>1.10.1 - 2017-11-30</h4>\n<ul>\n<li>Tweak: Added default value for search form</li>\n<li>Tweak: Order template list A-Z in the library widget</li>\n<li>Tweak: get_users/authors query is now done using AJAX only, for better performance in Query Control (<a href=\"https://github.com/elementor/elementor/issues/2865\">#2865</a>)</li>\n<li>Fix: When adding <code>.00</code> it is not displayed on the front</li>\n<li>Fix: Make sure space between is numeric for carousel control</li>\n<li>Fix: Added space for radio &amp; checkbox fields in form widget</li>\n</ul>\n<h4>1.10.0 - 2017-11-15</h4>\n<ul>\n<li>New: Added native Search form widget (<a href=\"https://github.com/elementor/elementor/issues/2576\">#2576</a>)</li>\n<li>Tweak: Added Slides To Scroll &amp; Loop controls to Media Carousel and Testimonials widgets</li>\n<li>Tweak: Added Inline editing to Blockquote widget</li>\n<li>Fix: Animated Headline color bug (<a href=\"https://github.com/elementor/elementor/issues/2516\">#2516</a>)</li>\n<li>Fix: Animated Headline with Rotating skin</li>\n<li>Fix: RTL fix for Animated Headline widget in \'typing\' and \'clip\' animations</li>\n<li>Fix: Empty menu cause jQuery to crash in Menu widget (<a href=\"https://github.com/elementor/elementor/issues/2662\">#2662</a>)</li>\n<li>Fix: Custom CSS gone after reloading the editor</li>\n</ul>\n<h4>1.9.5 - 2017-10-27</h4>\n<ul>\n<li>Fix: Broken Global widget with JS (<a href=\"https://github.com/elementor/elementor/issues/2639\">#2639</a>)</li>\n</ul>\n<h4>1.9.4 - 2017-10-24</h4>\n<ul>\n<li>Tweak: Improved UI for notices and license page</li>\n<li>Fix: Update system conflict with other EDD plugins</li>\n<li>Fix: WooCommerce frontend hooks on Elementor editor (<a href=\"https://github.com/elementor/elementor/issues/2577\">#2577</a>)</li>\n<li>Fix: Removed default border left in Nav Menu dropdown CSS (<a href=\"https://github.com/elementor/elementor/issues/2496\">#2496</a>)</li>\n<li>Fix: Increased submenu max-width (<a href=\"https://github.com/elementor/elementor/issues/2558\">#2558</a>)</li>\n<li>Fix: Save global templates without their defaults</li>\n<li>Fix: Horizontal scrolling issue with posts grid</li>\n</ul>\n<h4>1.9.3 - 2017-10-03</h4>\n<ul>\n<li>Fix: Condition slide style that got affected by previous update</li>\n</ul>\n<h4>1.9.2 - 2017-10-02</h4>\n<ul>\n<li>New: Added integration with MailPoet 3 for Forms actions</li>\n<li>Fix: Removed height control from Testimonial carousel in mobile editing mode</li>\n<li>Fix: Removed bottom padding when there\'s no pagination in Testimonial carousel</li>\n<li>Fix: Added condition for slides style section in skin bubble mode</li>\n<li>Fix: Slides per view control for mobile editing in Testimonial carousel</li>\n<li>Fix: Navigation Arrows icons matched with common Elementor Navigation Arrows</li>\n</ul>\n<h4>1.9.1 - 2017-09-28</h4>\n<ul>\n<li>Fix: Slides per view for slideshow carousel</li>\n<li>Fix: Final polish for the new Testimonial Carousel widget</li>\n<li>Fix: Don\'t play video if slide type is not video</li>\n<li>Fix: Removed slides style section condition (<a href=\"https://github.com/elementor/elementor/issues/2497\">#2497</a>)</li>\n<li>Fix: Set cursor as pointer for slideshow thumbnails</li>\n</ul>\n<h4>1.9.0 - 2017-09-26</h4>\n<ul>\n<li>New: Added Media Carousel widget (<a href=\"https://github.com/elementor/elementor/issues/216\">#216</a>, <a href=\"https://github.com/elementor/elementor/issues/347\">#347</a>, <a href=\"https://github.com/elementor/elementor/issues/2209\">#2209</a>)</li>\n<li>New: Added Testimonial Carousel widget (<a href=\"https://github.com/elementor/elementor/issues/715\">#715</a>)</li>\n</ul>\n<h4>1.8.3 - 2017-09-24</h4>\n<ul>\n<li>Fix: Added compatibility for WordPress 4.8.2 &amp; 4.7.6</li>\n<li>Fix: Remove slashes from Form sent data</li>\n</ul>\n<h4>1.8.2 - 2017-09-19</h4>\n<ul>\n<li>Tweak: Added target URL for the tweet message in Blockquote widget</li>\n<li>Tweak: Render the slide height before the slider is finished loading</li>\n<li>Fix: Space between words for Animated Headline widget</li>\n<li>Fix: RTL compatibility for Animated Headline widget</li>\n<li>Fix: Italic font style for Animated Headline widget</li>\n<li>Fix: Excluded Menu widget from the WP Editor text rendering</li>\n</ul>\n<h4>1.8.1 - 2017-09-18</h4>\n<ul>\n<li>Fix: WCAG Compatible &quot;required&quot; field attribute for W3C validation (<a href=\"https://github.com/elementor/elementor/issues/2391\">#2391</a>)</li>\n<li>Fix: Print the main menu only when is necessary in Menu widget</li>\n<li>Fix: Use CSS media query instead of JS to hide items in Menu widget to avoid flickering on page load (<a href=\"https://github.com/elementor/elementor/issues/2381\">#2381</a>)</li>\n</ul>\n<h4>1.8.0 - 2017-09-12</h4>\n<ul>\n<li>New: Added Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/1406\">#1406</a>)</li>\n<li>Fix: Field ID for checkbox control in Form widget (<a href=\"https://github.com/elementor/elementor/issues/2279\">#2279</a>)</li>\n<li>Fix: Style for Blockquote widget included</li>\n</ul>\n<h4>1.7.2 - 2017-09-07</h4>\n<ul>\n<li>Tweak: Loading Facebook SDK via JS for better compatibility with caching plugins</li>\n<li>Fix: Responsive Embed Facebook post widget for Safari iOS (<a href=\"https://github.com/elementor/elementor/issues/2340\">#2340</a>)</li>\n</ul>\n<h4>1.7.1 - 2017-09-05</h4>\n<ul>\n<li>Fix: Facebook SDK version</li>\n</ul>\n<h4>1.7.0 - 2017-09-05</h4>\n<ul>\n<li>New: Added Facebook Button widget for Like, Recommend, Share and Follow</li>\n<li>New: Added Facebook Embed widget for Post, Video and Comment</li>\n<li>New: Added Facebook Comments widget</li>\n<li>New: Added Facebook Page widget (Previously known as Like Box)</li>\n<li>New: Added Blockquote widget with Tweet button</li>\n<li>Tweak: Added Facebook SDK integration for all Facebook widgets</li>\n<li>Fix: Animated headline rotating with long words</li>\n</ul>\n<h4>1.6.1 - 2017-08-28</h4>\n<ul>\n<li>Fix: Animated Headline marker gets in front of neighboring spans even when &quot;Bring to Front&quot; is not set</li>\n<li>Fix: Stroke animation in Animated Headline for MS Edge browser</li>\n<li>Fix: Animated headline with more than 1-word per rotation</li>\n<li>Fix: Animated Headline in two lines</li>\n<li>Fix: Some errors in Global widget</li>\n</ul>\n<h4>1.6.0 - 2017-08-22</h4>\n<ul>\n<li>New: Added Animated Headline widget</li>\n<li>New: Added Hidden field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/2038\">#2038</a>)</li>\n<li>Tweak: Added notice to update Elementor to v1.6.5 or higher</li>\n<li>Fix: CSS Animations names no longer minified, in order to prevent unexpected conflicts</li>\n</ul>\n<h4>1.5.9 - 2017-08-16</h4>\n<ul>\n<li>Tweak: Added compatibility for the future release of Elementor v1.7</li>\n<li>Fix: Portfolio compatibility for GeneratePress theme</li>\n<li>Fix: Portfolio filter compatibility for RTL</li>\n<li>Fix: Pagination apply for all posts widget in the page</li>\n<li>Fix: Global form widget with MailChimp integration not saving</li>\n</ul>\n<h4>1.5.8 - 2017-07-25</h4>\n<ul>\n<li>Tweak: Added compatibility for the future release of Elementor v1.6</li>\n<li>Fix: Improved backward compatibility for query control rename</li>\n</ul>\n<h4>1.5.7 - 2017-07-24</h4>\n<ul>\n<li>Tweak: Moved JS render of reCAPTCHA to a separate file</li>\n<li>Tweak: Display the label in the reCAPTCHA field for better experience</li>\n<li>Tweak: Rename <code>panel-posts-control</code> to <code>query-control</code> and added fallback support</li>\n<li>Tweak: Added compatibility for the future release of Elementor with history feature</li>\n<li>Fix: reCAPTCHA preview on the editor</li>\n<li>Fix: Manual selection (query control) has stopped working after saving (<a href=\"https://github.com/elementor/elementor/issues/2000\">#2000</a>)</li>\n<li>Fix: Added condition for icon size control in Share Buttons widget</li>\n</ul>\n<h4>1.5.6 - 2017-07-12</h4>\n<ul>\n<li>Fix: Query Control correction for taxonomies (<a href=\"https://github.com/elementor/elementor/issues/1963\">#1963</a>)</li>\n<li>Fix: Custom CSS override scheme color in the editor</li>\n<li>Fix: Added order by Menu Order for Query Control in WC widget</li>\n<li>Fix: Glitch with Flip Box background overlay</li>\n</ul>\n<h4>1.5.5 - 2017-07-03</h4>\n<ul>\n<li>Tweak: Moved reCAPTCHA render to handler &amp; load only if a form is exist</li>\n<li>Fix: MailChimp integration: Default number of items returned by API increased to 999</li>\n<li>Fix: MailChimp integration: Refresh the groups list if API is changed</li>\n<li>Fix: Sorted items in filter bar by A-Z</li>\n<li>Fix: Editor glitch with Elementor v1.5 (<a href=\"https://github.com/elementor/elementor/issues/1927\">#1927</a>)</li>\n</ul>\n<h4>1.5.4 - 2017-06-22</h4>\n<ul>\n<li>Tweak: Improved compatibility for Elementor v1.5</li>\n<li>Fix: URL default for Add To Cart widget</li>\n<li>Fix: Allowed <code>date</code> and <code>birthday</code> fields as text for MailChimp integration</li>\n</ul>\n<h4>1.5.3 - 2017-06-19</h4>\n<ul>\n<li>Tweak: Make flip-box height responsive control</li>\n<li>Fix: Facebook share count now gets retrieved by Elementor (<a href=\"https://github.com/elementor/elementor/issues/1829\">#1829</a>)</li>\n<li>Fix: Global form widget with MailChimp integration not saving</li>\n</ul>\n<h4>1.5.2 - 2017-06-13</h4>\n<ul>\n<li>Fix: Custom CSS panel location compatibility for the old versions</li>\n</ul>\n<h4>1.5.1 - 2017-06-12</h4>\n<ul>\n<li>Fix: MailChimp update existing user registration</li>\n<li>Fix: Global widget with JS in the editor mode</li>\n<li>Fix: Label section condition in Login widget</li>\n<li>Fix: Changes to unlinked global widget do not appear in the editor</li>\n</ul>\n<h4>1.5.0 - 2017-05-23</h4>\n<ul>\n<li>New: Added Cards, a new skin for Posts widget</li>\n<li>New: Added Exclude option to post query control group</li>\n<li>Tweak: Added <code>post_class()</code> for each post in the loop</li>\n<li>Tweak: Added <code>.elementor-posts-masonry</code> class when Masonry layout is enabled</li>\n<li>Tweak: Added compatibility for the next release of Elementor v1.5.0</li>\n<li>Tweak: CSS <code>autoprefixer</code> now supports last 5 versions of browsers</li>\n<li>Tweak: Added <code>imageLoaded</code> library for Posts &amp; Portfolio widgets</li>\n</ul>\n<h4>1.4.4 - 2017-05-18</h4>\n<ul>\n<li>Fix: Force Mailchimp API to return all lists and not just 10 (<a href=\"https://github.com/elementor/elementor/issues/1683\">#1683</a>)</li>\n<li>Fix: Added <code>.elementor-form</code> class to Login form to fix style glitch</li>\n</ul>\n<h4>1.4.3 - 2017-05-14</h4>\n<ul>\n<li>Tweak: Added Redirect After Login option to Login widget</li>\n<li>Tweak: Stay in the current page after logout in Login widget</li>\n<li>Tweak: Preparation for Elementor settings tabs in future version</li>\n<li>Fix: Pinterest in Share Buttons widget now sharing the URL alone</li>\n<li>Fix: Bug with <code>active</code> class in portfolio filter item</li>\n<li>Fix: Higher specific list-style-type <code>none</code> for filter items to override some theme style</li>\n</ul>\n<h4>1.4.2 - 2017-05-06</h4>\n<ul>\n<li>Fix: Temporary patch for form field shortcode in some servers</li>\n</ul>\n<h4>1.4.1 - 2017-05-03</h4>\n<ul>\n<li>Fix: Bug with custom success message in form widget</li>\n<li>Fix: Bug with meta data in email action</li>\n</ul>\n<h4>1.4.0 - 2017-05-03</h4>\n<ul>\n<li>New: Forms: integration with MailChimp</li>\n<li>New: Forms: integration with MailPoet</li>\n<li>New: Forms: Added Email 2 action for email confirmation</li>\n<li>New: Forms: Added shortcodes for fields</li>\n<li>New: Forms: Added custom ID for fields</li>\n<li>New: Forms: Added option to edit email HTML template (<a href=\"https://github.com/elementor/elementor/issues/1180\">#1180</a>)</li>\n<li>New: Added Login widget</li>\n<li>Tweak: Move <code>send_html</code> control to <code>email_content_type</code></li>\n<li>Fix: Email still sent even if validation failed in form widget</li>\n</ul>\n<h4>1.3.2 - 2017-05-01</h4>\n<ul>\n<li>New: Added action <code>elementor_pro/init</code> for better integration with Elementor Pro</li>\n<li>Fix: Posts without featured image in Posts widget (<a href=\"https://github.com/elementor/elementor/issues/1234\">#1234</a>, <a href=\"https://github.com/elementor/elementor/issues/1382\">#1382</a>)</li>\n<li>Fix: reCAPTCHA &amp; Honeypot fields with new method</li>\n<li>Fix: Added border width control in Share Buttons to avoid a glitch on Chrome browser</li>\n<li>Fix: Border radius glitch on hover in Share Buttons</li>\n</ul>\n<h4>1.3.1 - 2017-04-25</h4>\n<ul>\n<li>Fix: Conflict update with revision history module</li>\n</ul>\n<h4>1.3.0 - 2017-04-25</h4>\n<ul>\n<li>New: Added Share Buttons widget (<a href=\"https://wordpress.org/support/topic/social-sharing-buttons-is-it-possible/\">Topic</a>)</li>\n<li>New: Added Custom CSS for Page Settings</li>\n<li>New: Added Masonry layout for Portfolio widget</li>\n<li>New: Added Cc &amp; Bcc options to email action (<a href=\"https://github.com/elementor/elementor/issues/1181\">#1181</a>)</li>\n<li>New: Introduced <code>ElementorPro\\Modules\\Forms\\Classes\\Action_Base</code> class for better 3rd party integration for forms</li>\n<li>Tweak: Debugger module now also shows errors from Pro</li>\n<li>Tweak: Added options for Elementor Library</li>\n<li>Tweak: New base posts module for optimized performance</li>\n<li>Tweak: Adjusting Posts / Portfolio to the new structure</li>\n<li>Fix: Export for posts / portfolio</li>\n<li>Fix: Duplicate repeater field with switcher control (<a href=\"https://github.com/elementor/elementor/issues/1442\">#1442</a>)</li>\n<li>Fix: Post per Page in the query control</li>\n<li>Fix: Metadata does not come through on form emails (<a href=\"https://github.com/elementor/elementor/issues/1566\">#1566</a>)</li>\n</ul>\n<h4>1.2.6 - 2017-04-19</h4>\n<ul>\n<li>Fix: Added compatibility with WooCommerce 3.0 - Products &amp; Add to Cart widgets</li>\n</ul>\n<h4>1.2.5 - 2017-04-18</h4>\n<ul>\n<li>Fix: Offset query for posts widgets (Posts, Portfolio and Products)</li>\n</ul>\n<h4>1.2.4 - 2017-03-21</h4>\n<ul>\n<li>Tweak: Added Indian Rupee sign to Price Table widget</li>\n<li>Fix: Portfolio grid for IE11</li>\n<li>Fix: Link target blank in Price List widget</li>\n<li>Fix: Active item for filter bar in Portfolio widget</li>\n</ul>\n<h4>1.2.3 - 2017-03-06</h4>\n<ul>\n<li>Tweak: Fully compatible with Elementor v1.3.0</li>\n<li>Tweak: Added trigger for after form submission in Forms widget</li>\n<li>Tweak: Changed handle name in reCAPTCHA field to avoid conflict with other contact forms</li>\n<li>Fix: Portfolio filter syntax in Non-Latin languages</li>\n<li>Fix: Added <code>no-repeat</code> property for slide with <code>background-size:contain</code></li>\n<li>Fix: Condition control &amp; Import value in Posts widgets</li>\n<li>Fix: Offset and Pagination in WordPress (<a href=\"https://codex.wordpress.org/Making_Custom_Queries_using_Offset_and_Pagination\">More Info</a>)</li>\n<li>Fix: Submit handler bubbling for custom events in Forms widget</li>\n</ul>\n<h4>1.2.2 - 2017-02-23</h4>\n<ul>\n<li>Tweak: Change name from Side A/B to Front and Back in Flip Box widget</li>\n<li>Fix: Error when saving third party widgets in the global widget</li>\n<li>Fix: Image position &quot;none&quot; remains visible in editor preview (Posts)</li>\n<li>Fix: Hide the pagination when there are no links</li>\n</ul>\n<h4>1.2.1 - 2017-02-21</h4>\n<ul>\n<li>Fix: Firefox Flip Box 3D compatibility</li>\n</ul>\n<h4>1.2.0 - 2017-02-21</h4>\n<ul>\n<li>New: Added Flip Box widget</li>\n<li>New: Added Ken Burns effect for slides</li>\n<li>New: Added Masonry layout for Posts widget</li>\n<li>New: Added Pagination option for Posts widget</li>\n<li>Tweak: Added background size contain to slides</li>\n<li>Tweak: Improve Query control by preload items</li>\n<li>Fix: Text color for Checkbox and Radio fields</li>\n</ul>\n<h4>1.1.2 - 2017-02-05</h4>\n<ul>\n<li>Tweak: Added <code>aria-required</code> for better accessibility in forms widget</li>\n<li>Fix: Conflict Call to <code>undefined</code> method in Posts &amp; Portfolio widgets (<a href=\"https://github.com/elementor/elementor/issues/1271\">#1271</a>, <a href=\"https://github.com/elementor/elementor/issues/1266\">#1266</a>)</li>\n<li>Fix: Submit button HTML after error sending</li>\n<li>Fix: Success message for <code>skip_email</code> function</li>\n<li>Notice: Elementor 1.2.0 or later now required</li>\n</ul>\n<h4>1.1.1 - 2017-01-24</h4>\n<ul>\n<li>Fix: Can\'t save global widgets when <code>WP_DEBUG</code> is <code>true</code></li>\n<li>Fix: Undefined variable in WC widgets</li>\n<li>Fix: Removed duplicate strings</li>\n</ul>\n<h4>1.1.0 - 2017-01-24</h4>\n<ul>\n<li>New: Price Table widget (<a href=\"https://github.com/elementor/elementor/issues/102\">#102</a>)</li>\n<li>New: WooCommerce Add to Cart widget</li>\n<li>New: WooCommerce Categories widget</li>\n<li>New: WooCommerce Elements widget</li>\n<li>New: Honeypot field for Forms widgets</li>\n<li>Tweak: Added inline options for taxonomies &amp; authors if is less than 15 items</li>\n<li>Tweak: Added Required Mark for fields in Forms widget</li>\n<li>Fix: CSS selectors priority in Slides widget</li>\n<li>Fix: CSS bug in Price List widget</li>\n<li>Fix: Update all Post CSS files that includes specific Global Widget</li>\n</ul>\n<h4>1.0.9 - 2017-01-18</h4>\n<ul>\n<li>Fix: Auto complete bug in query controls</li>\n<li>Fix: Render template with escaping slashes</li>\n<li>Fix: Reply-to field in Forms widget</li>\n</ul>\n<h4>1.0.8 - 2017-01-11</h4>\n<ul>\n<li>Tweak: Code adjustments for Elementor API</li>\n<li>Fix: Removed go pro link from plugins page in admin</li>\n</ul>\n<h4>1.0.7 - 2017-01-05</h4>\n<ul>\n<li>Tweak: Added filter by featured / sale for WC Products widget</li>\n<li>Tweak: Added author control in Portfolio widget</li>\n<li>Tweak: Code adjustments for Elementor API</li>\n<li>Fix: Added support for empty image ratio</li>\n<li>Fix: Avoid nesting a sidebar within a template that will appear in the sidebar itself</li>\n</ul>\n<h4>1.0.6 - 2017-01-01</h4>\n<ul>\n<li>Tweak: Added Auto-updates for local translation files</li>\n<li>Fix: Custom CSS for Global widgets</li>\n<li>Fix: Remove <code>nonce</code> field (Fix some cache plugins)</li>\n</ul>\n<h4>1.0.5 - 2016-12-27</h4>\n<ul>\n<li>Fix: Slide element bug fix - \'Link apply on\' logic</li>\n<li>Fix: Removed unique wrapper for Custom CSS in order to allow media queries (<a href=\"https://github.com/elementor/elementor/issues/1086\">#1086</a>)</li>\n</ul>\n<h4>1.0.4 - 2016-12-21</h4>\n<ul>\n<li>Tweak: Mobile Editing for fields in the form widget</li>\n<li>Tweak: Mobile Editing for posts</li>\n<li>Tweak: Allow send form as HTML</li>\n<li>Tweak: Improved auto upgrades for Multisite installation</li>\n<li>Tweak: Improve editor rendering experience for Portfolio widget</li>\n<li>Fix: Posts widget check if image exist</li>\n<li>Fix: Changed the clone method for global widget (<a href=\"https://github.com/elementor/elementor/issues/1042\">#1042</a>)</li>\n<li>Fix: Bug slides in RTL (removed direction control)</li>\n<li>Fix: Slides with no height jumps when changing slides</li>\n</ul>\n<h4>1.0.3 - 2016-12-13</h4>\n<ul>\n<li>Fix: Added escape placeholder for HTML Entities in form widget</li>\n<li>Fix: Countdown widget RTL bug</li>\n<li>Fix: Remove redundant #elementor selector for control style</li>\n<li>Fix: Added prefixing with \'0\' for one digit number in Countdown widget</li>\n</ul>\n<h4>1.0.2 - 2016-12-12</h4>\n<ul>\n<li>Fix: Page layout collapses when inserting reCAPTCHA field in Form</li>\n</ul>\n<h4>1.0.1 - 2016-12-12</h4>\n<ul>\n<li>Fix: WordPress widgets disappear from Editor when Elementor Pro active</li>\n</ul>\n<h4>1.0.0 - 2016-12-12</h4>\n<ul>\n<li>Initial release</li>\n</ul>\";}\";s:11:\"new_version\";s:5:\"2.9.3\";s:4:\"name\";s:13:\"Elementor Pro\";s:4:\"slug\";s:13:\"elementor-pro\";s:3:\"url\";s:36:\"https://elementor.com/pro/changelog/\";s:8:\"homepage\";s:26:\"https://elementor.com/pro/\";s:8:\"requires\";s:3:\"5.0\";s:6:\"tested\";s:5:\"5.4.1\";s:7:\"package\";s:184:\"http://my.elementor.com/edd-sl/package_download/MTU4ODU5MDA2MDo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOjhkZTlmMTc5M2RhM2UyYzc2MTk3NDliN2I2NjdhZmIyOmh0dHBALy9uaWtraWphbWVzLm5ldDow\";s:13:\"download_link\";s:184:\"http://my.elementor.com/edd-sl/package_download/MTU4ODU5MDA2MDo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOjhkZTlmMTc5M2RhM2UyYzc2MTk3NDliN2I2NjdhZmIyOmh0dHBALy9uaWtraWphbWVzLm5ldDow\";s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:5:\"icons\";a:1:{s:3:\"svg\";s:42:\"https://ps.w.org/elementor/assets/icon.svg\";}s:17:\"canary_deployment\";a:2:{s:11:\"plugin_info\";a:11:{s:11:\"new_version\";s:5:\"2.9.1\";s:4:\"name\";s:13:\"Elementor Pro\";s:4:\"slug\";s:13:\"elementor-pro\";s:3:\"url\";s:36:\"https://elementor.com/pro/changelog/\";s:8:\"homepage\";s:26:\"https://elementor.com/pro/\";s:8:\"requires\";s:3:\"5.0\";s:6:\"tested\";s:5:\"5.4.1\";s:7:\"package\";s:193:\"http://my.elementor.com/edd-sl/previous_download/MTU4ODU5MDA2MDo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOjIuOS4xOjg1ZmZhYmNjOTc4ZDE3ZTI4YTYxMmQ0ZTNjMmM1ZTdmOmh0dHBALy9uaWtraWphbWVzLm5ldA==\";s:13:\"download_link\";s:193:\"http://my.elementor.com/edd-sl/previous_download/MTU4ODU5MDA2MDo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOjIuOS4xOjg1ZmZhYmNjOTc4ZDE3ZTI4YTYxMmQ0ZTNjMmM1ZTdmOmh0dHBALy9uaWtraWphbWVzLm5ldA==\";s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:5:\"icons\";a:1:{s:3:\"svg\";s:42:\"https://ps.w.org/elementor/assets/icon.svg\";}}s:10:\"conditions\";a:1:{i:0;a:1:{i:0;a:3:{s:4:\"type\";s:8:\"language\";s:9:\"languages\";a:26:{i:0;s:5:\"he_IL\";i:1;s:5:\"en_GB\";i:2;s:5:\"en_NZ\";i:3;s:5:\"en_ZA\";i:4;s:5:\"en_AU\";i:5;s:5:\"en_CA\";i:6;s:5:\"sv_SE\";i:7;s:5:\"da_DK\";i:8;s:5:\"fr_FR\";i:9;s:5:\"nl_NL\";i:10;s:5:\"nb_NO\";i:11;s:5:\"de_AT\";i:12;s:2:\"fi\";i:13;s:5:\"it_IT\";i:14;s:5:\"nn_NO\";i:15;s:5:\"de_CH\";i:16;s:5:\"en_GB\";i:17;s:5:\"is_IS\";i:18;s:2:\"ga\";i:19;s:5:\"fr_BE\";i:20;s:5:\"nl_BE\";i:21;s:3:\"ast\";i:22;s:5:\"lb_LU\";i:23;s:5:\"es_ES\";i:24;s:5:\"pt_PT\";i:25;s:3:\"mlt\";}s:8:\"operator\";s:2:\"in\";}}}}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_522243_options` VALUES("650", "_transient_timeout_elementor_remote_info_api_data_2.9.8", "1588546860", "no");
INSERT INTO `wp_522243_options` VALUES("651", "_transient_elementor_remote_info_api_data_2.9.8", "a:4:{s:9:\"timestamp\";i:1588500606;s:14:\"upgrade_notice\";a:3:{s:7:\"version\";s:5:\"2.0.0\";s:7:\"message\";s:0:\"\";s:11:\"update_link\";s:0:\"\";}s:11:\"pro_widgets\";a:59:{i:0;a:4:{s:4:\"name\";s:5:\"posts\";s:5:\"title\";s:5:\"Posts\";s:4:\"icon\";s:15:\"eicon-post-list\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:1;a:4:{s:4:\"name\";s:9:\"portfolio\";s:5:\"title\";s:9:\"Portfolio\";s:4:\"icon\";s:18:\"eicon-gallery-grid\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:2;a:4:{s:4:\"name\";s:7:\"gallery\";s:5:\"title\";s:7:\"Gallery\";s:4:\"icon\";s:23:\"eicon-gallery-justified\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:3;a:4:{s:4:\"name\";s:4:\"form\";s:5:\"title\";s:4:\"Form\";s:4:\"icon\";s:21:\"eicon-form-horizontal\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:4;a:4:{s:4:\"name\";s:5:\"login\";s:5:\"title\";s:5:\"Login\";s:4:\"icon\";s:15:\"eicon-lock-user\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:5;a:4:{s:4:\"name\";s:6:\"slides\";s:5:\"title\";s:6:\"Slides\";s:4:\"icon\";s:12:\"eicon-slides\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:6;a:4:{s:4:\"name\";s:8:\"nav-menu\";s:5:\"title\";s:8:\"Nav Menu\";s:4:\"icon\";s:14:\"eicon-nav-menu\";s:10:\"categories\";s:33:\"[\"pro-elements\",\"theme-elements\"]\";}i:7;a:4:{s:4:\"name\";s:17:\"animated-headline\";s:5:\"title\";s:17:\"Animated Headline\";s:4:\"icon\";s:23:\"eicon-animated-headline\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:8;a:4:{s:4:\"name\";s:10:\"price-list\";s:5:\"title\";s:10:\"Price List\";s:4:\"icon\";s:16:\"eicon-price-list\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:9;a:4:{s:4:\"name\";s:11:\"price-table\";s:5:\"title\";s:11:\"Price Table\";s:4:\"icon\";s:17:\"eicon-price-table\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:10;a:4:{s:4:\"name\";s:8:\"flip-box\";s:5:\"title\";s:8:\"Flip Box\";s:4:\"icon\";s:14:\"eicon-flip-box\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:11;a:4:{s:4:\"name\";s:14:\"call-to-action\";s:5:\"title\";s:14:\"Call to Action\";s:4:\"icon\";s:20:\"eicon-image-rollover\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:12;a:4:{s:4:\"name\";s:14:\"media-carousel\";s:5:\"title\";s:14:\"Media Carousel\";s:4:\"icon\";s:20:\"eicon-media-carousel\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:13;a:4:{s:4:\"name\";s:20:\"testimonial-carousel\";s:5:\"title\";s:20:\"Testimonial Carousel\";s:4:\"icon\";s:26:\"eicon-testimonial-carousel\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:14;a:4:{s:4:\"name\";s:7:\"reviews\";s:5:\"title\";s:7:\"Reviews\";s:4:\"icon\";s:12:\"eicon-review\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:15;a:4:{s:4:\"name\";s:17:\"table-of-contents\";s:5:\"title\";s:17:\"Table of Contents\";s:4:\"icon\";s:23:\"eicon-table-of-contents\";s:10:\"categories\";s:33:\"[\"pro-elements\",\"theme-elements\"]\";}i:16;a:4:{s:4:\"name\";s:9:\"countdown\";s:5:\"title\";s:9:\"Countdown\";s:4:\"icon\";s:15:\"eicon-countdown\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:17;a:4:{s:4:\"name\";s:13:\"share-buttons\";s:5:\"title\";s:13:\"Share Buttons\";s:4:\"icon\";s:11:\"eicon-share\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:18;a:4:{s:4:\"name\";s:11:\"search-form\";s:5:\"title\";s:11:\"Search Form\";s:4:\"icon\";s:17:\"eicon-site-search\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:19;a:4:{s:4:\"name\";s:10:\"author-box\";s:5:\"title\";s:10:\"Author Box\";s:4:\"icon\";s:12:\"eicon-person\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:20;a:4:{s:4:\"name\";s:13:\"post-comments\";s:5:\"title\";s:13:\"Post Comments\";s:4:\"icon\";s:14:\"eicon-comments\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:21;a:4:{s:4:\"name\";s:15:\"post-navigation\";s:5:\"title\";s:15:\"Post Navigation\";s:4:\"icon\";s:21:\"eicon-post-navigation\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:22;a:4:{s:4:\"name\";s:9:\"post-info\";s:5:\"title\";s:9:\"Post Info\";s:4:\"icon\";s:15:\"eicon-post-info\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:23;a:4:{s:4:\"name\";s:7:\"sitemap\";s:5:\"title\";s:7:\"Sitemap\";s:4:\"icon\";s:13:\"eicon-sitemap\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:24;a:4:{s:4:\"name\";s:11:\"breadcrumbs\";s:5:\"title\";s:11:\"Breadcrumbs\";s:4:\"icon\";s:11:\"eicon-yoast\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:25;a:4:{s:4:\"name\";s:10:\"blockquote\";s:5:\"title\";s:10:\"Blockquote\";s:4:\"icon\";s:16:\"eicon-blockquote\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:26;a:4:{s:4:\"name\";s:19:\"wc-archive-products\";s:5:\"title\";s:16:\"Archive Products\";s:4:\"icon\";s:14:\"eicon-products\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:27;a:4:{s:4:\"name\";s:31:\"woocommerce-archive-description\";s:5:\"title\";s:19:\"Archive Description\";s:4:\"icon\";s:25:\"eicon-product-description\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:28;a:4:{s:4:\"name\";s:20:\"woocommerce-products\";s:5:\"title\";s:8:\"Products\";s:4:\"icon\";s:14:\"eicon-products\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:29;a:4:{s:4:\"name\";s:22:\"woocommerce-breadcrumb\";s:5:\"title\";s:23:\"WooCommerce Breadcrumbs\";s:4:\"icon\";s:25:\"eicon-product-breadcrumbs\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:30;a:4:{s:4:\"name\";s:14:\"wc-add-to-cart\";s:5:\"title\";s:18:\"Custom Add To Cart\";s:4:\"icon\";s:17:\"eicon-woocommerce\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:31;a:4:{s:4:\"name\";s:11:\"wc-elements\";s:5:\"title\";s:17:\"WooCommerce Pages\";s:4:\"icon\";s:19:\"eicon-product-pages\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:32;a:4:{s:4:\"name\";s:13:\"wc-categories\";s:5:\"title\";s:18:\"Product Categories\";s:4:\"icon\";s:24:\"eicon-product-categories\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:33;a:4:{s:4:\"name\";s:21:\"woocommerce-menu-cart\";s:5:\"title\";s:9:\"Menu Cart\";s:4:\"icon\";s:10:\"eicon-cart\";s:10:\"categories\";s:41:\"[\"theme-elements\",\"woocommerce-elements\"]\";}i:34;a:4:{s:4:\"name\";s:25:\"woocommerce-product-title\";s:5:\"title\";s:13:\"Product Title\";s:4:\"icon\";s:19:\"eicon-product-title\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:35;a:4:{s:4:\"name\";s:26:\"woocommerce-product-images\";s:5:\"title\";s:14:\"Product Images\";s:4:\"icon\";s:20:\"eicon-product-images\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:36;a:4:{s:4:\"name\";s:25:\"woocommerce-product-price\";s:5:\"title\";s:13:\"Product Price\";s:4:\"icon\";s:19:\"eicon-product-price\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:37;a:4:{s:4:\"name\";s:31:\"woocommerce-product-add-to-cart\";s:5:\"title\";s:11:\"Add To Cart\";s:4:\"icon\";s:25:\"eicon-product-add-to-cart\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:38;a:4:{s:4:\"name\";s:26:\"woocommerce-product-rating\";s:5:\"title\";s:14:\"Product Rating\";s:4:\"icon\";s:20:\"eicon-product-rating\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:39;a:4:{s:4:\"name\";s:25:\"woocommerce-product-stock\";s:5:\"title\";s:13:\"Product Stock\";s:4:\"icon\";s:19:\"eicon-product-stock\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:40;a:4:{s:4:\"name\";s:24:\"woocommerce-product-meta\";s:5:\"title\";s:12:\"Product Meta\";s:4:\"icon\";s:18:\"eicon-product-meta\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:41;a:4:{s:4:\"name\";s:37:\"woocommerce-product-short-description\";s:5:\"title\";s:17:\"Short Description\";s:4:\"icon\";s:25:\"eicon-product-description\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:42;a:4:{s:4:\"name\";s:29:\"woocommerce-product-data-tabs\";s:5:\"title\";s:17:\"Product Data Tabs\";s:4:\"icon\";s:18:\"eicon-product-tabs\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:43;a:4:{s:4:\"name\";s:42:\"woocommerce-product-additional-information\";s:5:\"title\";s:22:\"Additional Information\";s:4:\"icon\";s:19:\" eicon-product-info\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:44;a:4:{s:4:\"name\";s:27:\"woocommerce-product-related\";s:5:\"title\";s:15:\"Product Related\";s:4:\"icon\";s:21:\"eicon-product-related\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:45;a:4:{s:4:\"name\";s:26:\"woocommerce-product-upsell\";s:5:\"title\";s:7:\"Upsells\";s:4:\"icon\";s:20:\"eicon-product-upsell\";s:10:\"categories\";s:24:\"[\"woocommerce-elements\"]\";}i:46;a:4:{s:4:\"name\";s:15:\"facebook-button\";s:5:\"title\";s:15:\"Facebook Button\";s:4:\"icon\";s:23:\"eicon-facebook-like-box\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:47;a:4:{s:4:\"name\";s:17:\"facebook-comments\";s:5:\"title\";s:17:\"Facebook Comments\";s:4:\"icon\";s:23:\"eicon-facebook-comments\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:48;a:4:{s:4:\"name\";s:14:\"facebook-embed\";s:5:\"title\";s:14:\"Facebook Embed\";s:4:\"icon\";s:14:\"eicon-fb-embed\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:49;a:4:{s:4:\"name\";s:13:\"facebook-page\";s:5:\"title\";s:13:\"Facebook Page\";s:4:\"icon\";s:13:\"eicon-fb-feed\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:50;a:4:{s:4:\"name\";s:8:\"template\";s:5:\"title\";s:8:\"Template\";s:4:\"icon\";s:19:\"eicon-document-file\";s:10:\"categories\";s:16:\"[\"pro-elements\"]\";}i:51;a:4:{s:4:\"name\";s:15:\"theme-site-logo\";s:5:\"title\";s:9:\"Site Logo\";s:4:\"icon\";s:15:\"eicon-site-logo\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:52;a:4:{s:4:\"name\";s:16:\"theme-site-title\";s:5:\"title\";s:10:\"Site Title\";s:4:\"icon\";s:16:\"eicon-site-title\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:53;a:4:{s:4:\"name\";s:16:\"theme-page-title\";s:5:\"title\";s:10:\"Page Title\";s:4:\"icon\";s:19:\"eicon-archive-title\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:54;a:4:{s:4:\"name\";s:16:\"theme-post-title\";s:5:\"title\";s:10:\"Post Title\";s:4:\"icon\";s:16:\"eicon-post-title\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:55;a:4:{s:4:\"name\";s:18:\"theme-post-excerpt\";s:5:\"title\";s:12:\"Post Excerpt\";s:4:\"icon\";s:18:\"eicon-post-excerpt\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:56;a:4:{s:4:\"name\";s:25:\"theme-post-featured-image\";s:5:\"title\";s:14:\"Featured Image\";s:4:\"icon\";s:20:\"eicon-featured-image\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:57;a:4:{s:4:\"name\";s:19:\"theme-archive-title\";s:5:\"title\";s:13:\"Archive Title\";s:4:\"icon\";s:19:\"eicon-archive-title\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}i:58;a:4:{s:4:\"name\";s:13:\"archive-posts\";s:5:\"title\";s:13:\"Archive Posts\";s:4:\"icon\";s:19:\"eicon-archive-posts\";s:10:\"categories\";s:18:\"[\"theme-elements\"]\";}}s:17:\"canary_deployment\";a:2:{s:11:\"plugin_info\";a:11:{s:2:\"id\";s:23:\"w.org/plugins/elementor\";s:4:\"slug\";s:9:\"elementor\";s:6:\"plugin\";s:23:\"elementor/elementor.php\";s:11:\"new_version\";s:5:\"2.9.1\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/elementor.2.9.1.zip\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/elementor/\";s:5:\"icons\";a:3:{s:2:\"2x\";s:62:\"https://ps.w.org/elementor/assets/icon-256x256.png?rev=1427768\";s:2:\"1x\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";s:3:\"svg\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:11:\"banners_rtl\";a:0:{}s:6:\"tested\";s:3:\"5.4\";s:12:\"requires_php\";s:3:\"5.6\";}s:10:\"conditions\";a:1:{i:0;a:1:{i:0;a:3:{s:4:\"type\";s:8:\"language\";s:9:\"languages\";a:27:{i:0;s:5:\"he_IL\";i:1;s:5:\"en_GB\";i:2;s:5:\"en_NZ\";i:3;s:5:\"en_ZA\";i:4;s:5:\"en_AU\";i:5;s:5:\"en_CA\";i:6;s:5:\"sv_SE\";i:7;s:5:\"da_DK\";i:8;s:5:\"fr_FR\";i:9;s:5:\"de_DE\";i:10;s:5:\"nl_NL\";i:11;s:5:\"nb_NO\";i:12;s:5:\"de_AT\";i:13;s:2:\"fi\";i:14;s:5:\"it_IT\";i:15;s:5:\"nn_NO\";i:16;s:5:\"de_CH\";i:17;s:5:\"en_GB\";i:18;s:5:\"is_IS\";i:19;s:2:\"ga\";i:20;s:5:\"fr_BE\";i:21;s:5:\"nl_BE\";i:22;s:3:\"ast\";i:23;s:5:\"lb_LU\";i:24;s:5:\"es_ES\";i:25;s:5:\"pt_PT\";i:26;s:3:\"mlt\";}s:8:\"operator\";s:2:\"in\";}}}}}", "no");
INSERT INTO `wp_522243_options` VALUES("652", "_site_transient_timeout_theme_roots", "1588505460", "no");
INSERT INTO `wp_522243_options` VALUES("653", "_site_transient_theme_roots", "a:7:{s:4:\"Divi\";s:7:\"/themes\";s:10:\"blankslate\";s:7:\"/themes\";s:16:\"divi-photography\";s:7:\"/themes\";s:15:\"hello-elementor\";s:7:\"/themes\";s:14:\"twentynineteen\";s:7:\"/themes\";s:15:\"twentyseventeen\";s:7:\"/themes\";s:12:\"twentytwenty\";s:7:\"/themes\";}", "no");
INSERT INTO `wp_522243_options` VALUES("654", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1588503661;s:7:\"checked\";a:7:{s:4:\"Divi\";s:5:\"4.4.4\";s:10:\"blankslate\";s:6:\"2019.1\";s:16:\"divi-photography\";s:5:\"1.0.0\";s:15:\"hello-elementor\";s:5:\"2.3.0\";s:14:\"twentynineteen\";s:3:\"1.5\";s:15:\"twentyseventeen\";s:3:\"2.3\";s:12:\"twentytwenty\";s:3:\"1.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_522243_options` VALUES("655", "_transient_timeout_elementor_pro_license_data", "1588546861", "no");
INSERT INTO `wp_522243_options` VALUES("656", "_transient_elementor_pro_license_data", "a:14:{s:7:\"success\";b:1;s:7:\"license\";s:5:\"valid\";s:7:\"item_id\";b:0;s:9:\"item_name\";s:13:\"Elementor Pro\";s:8:\"checksum\";s:32:\"0d3f5b04daa035c6c58effca2dc8bf1c\";s:7:\"expires\";s:19:\"2020-10-30 23:59:59\";s:10:\"payment_id\";i:45491;s:13:\"customer_name\";s:12:\"Simon Verdon\";s:14:\"customer_email\";s:20:\"kwebmaster@pobox.com\";s:13:\"license_limit\";i:1000;s:10:\"site_count\";i:148;s:16:\"activations_left\";i:852;s:8:\"price_id\";s:1:\"3\";s:13:\"subscriptions\";s:6:\"enable\";}", "no");
INSERT INTO `wp_522243_options` VALUES("657", "_transient_timeout_premium_notice_3.12.2", "1589108465", "no");
INSERT INTO `wp_522243_options` VALUES("658", "_transient_premium_notice_3.12.2", "1", "no");
INSERT INTO `wp_522243_options` VALUES("659", "duplicator_ui_view_state", "a:1:{s:22:\"dup-pack-archive-panel\";s:1:\"1\";}", "yes");
INSERT INTO `wp_522243_options` VALUES("660", "duplicator_package_active", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-05-03 11:01:16\";s:7:\"Version\";s:6:\"1.3.30\";s:9:\"VersionWP\";s:5:\"5.4.1\";s:9:\"VersionDB\";s:6:\"5.7.27\";s:10:\"VersionPHP\";s:6:\"7.3.17\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:19:\"20200503_nikkijames\";s:4:\"Hash\";s:35:\"31b485d2a8e890fe7278_20200503110116\";s:8:\"NameHash\";s:55:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:74:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-snapshots/tmp\";s:8:\"StoreURL\";s:36:\"https://nikkijames.net/wp-snapshots/\";s:8:\"ScanFile\";s:65:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:75:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/cache;\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:22:\"zip;rar;tar;gz;bz2;7z;\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:1;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:57:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-05-03 11:01:16\";s:7:\"Version\";s:6:\"1.3.30\";s:9:\"VersionWP\";s:5:\"5.4.1\";s:9:\"VersionDB\";s:6:\"5.7.27\";s:10:\"VersionPHP\";s:6:\"7.3.17\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:19:\"20200503_nikkijames\";s:4:\"Hash\";s:35:\"31b485d2a8e890fe7278_20200503110116\";s:8:\"NameHash\";s:55:\"20200503_nikkijames_31b485d2a8e890fe7278_20200503110116\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:74:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-snapshots/tmp\";s:8:\"StoreURL\";s:36:\"https://nikkijames.net/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":14:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:0;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:63;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:66:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-admin\";i:1;s:76:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/uploads\";i:2;s:78:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/languages\";i:3;s:75:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content/themes\";i:4;s:69:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:57:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames\";i:1;s:68:\"/home/clients/658bb1a911d292db2b77b6125d19066c/nikkijames/wp-content\";}}s:9:\"Installer\";r:86;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:128;}", "yes");

/* INSERT TABLE DATA: wp_522243_postmeta */
INSERT INTO `wp_522243_postmeta` VALUES("3", "45", "_wp_attached_file", "2017/02/CAMERAS.png");
INSERT INTO `wp_522243_postmeta` VALUES("4", "45", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:96;s:6:\"height\";i:75;s:4:\"file\";s:19:\"2017/02/CAMERAS.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("5", "46", "_wp_attached_file", "2017/02/LENSES-1.png");
INSERT INTO `wp_522243_postmeta` VALUES("6", "46", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:91;s:6:\"height\";i:92;s:4:\"file\";s:20:\"2017/02/LENSES-1.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("7", "47", "_wp_attached_file", "2017/02/MEMORY-CARDS.png");
INSERT INTO `wp_522243_postmeta` VALUES("8", "47", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:65;s:6:\"height\";i:81;s:4:\"file\";s:24:\"2017/02/MEMORY-CARDS.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("9", "48", "_wp_attached_file", "2017/02/LAPTOP.png");
INSERT INTO `wp_522243_postmeta` VALUES("10", "48", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:101;s:6:\"height\";i:76;s:4:\"file\";s:18:\"2017/02/LAPTOP.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("11", "49", "_wp_attached_file", "2017/02/timwilliamsslomosfmp4.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("12", "49", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"file\";s:33:\"2017/02/timwilliamsslomosfmp4.jpg\";s:5:\"sizes\";a:12:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-300x169.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:169;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:34:\"timwilliamsslomosfmp4-1024x576.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-768x432.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:432;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:34:\"timwilliamsslomosfmp4-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:34:\"timwilliamsslomosfmp4-1080x608.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:608;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-980x551.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:551;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:33:\"timwilliamsslomosfmp4-480x270.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:270;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("13", "134", "_wp_attached_file", "2017/02/wheel_header.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("14", "134", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:900;s:4:\"file\";s:24:\"2017/02/wheel_header.jpg\";s:5:\"sizes\";a:14:{s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"wheel_header-300x141.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:141;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"wheel_header-1024x480.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:480;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"wheel_header-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"wheel_header-768x360.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:25:\"wheel_header-1536x720.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:24:\"wheel_header-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:25:\"wheel_header-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:24:\"wheel_header-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:24:\"wheel_header-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:25:\"wheel_header-1080x506.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:506;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:24:\"wheel_header-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:25:\"wheel_header-1280x600.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:24:\"wheel_header-980x459.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:459;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:24:\"wheel_header-480x225.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("15", "135", "_wp_attached_file", "2017/02/about_1.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("16", "135", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:278;s:6:\"height\";i:520;s:4:\"file\";s:19:\"2017/02/about_1.jpg\";s:5:\"sizes\";a:6:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"about_1-160x300.jpg\";s:5:\"width\";i:160;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"about_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:19:\"about_1-278x250.jpg\";s:5:\"width\";i:278;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:19:\"about_1-278x284.jpg\";s:5:\"width\";i:278;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:19:\"about_1-278x382.jpg\";s:5:\"width\";i:278;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:19:\"about_1-278x516.jpg\";s:5:\"width\";i:278;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("17", "136", "_wp_attached_file", "2017/02/about_2.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("18", "136", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:278;s:6:\"height\";i:260;s:4:\"file\";s:19:\"2017/02/about_2.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"about_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:19:\"about_2-278x250.jpg\";s:5:\"width\";i:278;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("19", "137", "_wp_attached_file", "2017/02/about_3.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("20", "137", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:278;s:6:\"height\";i:260;s:4:\"file\";s:19:\"2017/02/about_3.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"about_3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:19:\"about_3-278x250.jpg\";s:5:\"width\";i:278;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("21", "138", "_wp_attached_file", "2017/02/materials.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("22", "138", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:720;s:4:\"file\";s:21:\"2017/02/materials.jpg\";s:5:\"sizes\";a:14:{s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"materials-300x113.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:113;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"materials-1024x384.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:384;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"materials-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"materials-768x288.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:288;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:22:\"materials-1536x576.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:21:\"materials-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:22:\"materials-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:21:\"materials-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:21:\"materials-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:22:\"materials-1080x405.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:405;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:21:\"materials-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:22:\"materials-1280x480.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:480;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:21:\"materials-980x368.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:368;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:21:\"materials-480x180.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:180;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("23", "139", "_wp_attached_file", "2017/02/blog.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("24", "139", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:720;s:4:\"file\";s:16:\"2017/02/blog.jpg\";s:5:\"sizes\";a:14:{s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"blog-300x113.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:113;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:17:\"blog-1024x384.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:384;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"blog-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:16:\"blog-768x288.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:288;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:17:\"blog-1536x576.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:16:\"blog-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:17:\"blog-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:16:\"blog-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:16:\"blog-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:17:\"blog-1080x405.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:405;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:16:\"blog-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:17:\"blog-1280x480.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:480;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:16:\"blog-980x368.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:368;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:16:\"blog-480x180.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:180;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("25", "149", "_wp_attached_file", "2017/02/portfolio_1.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("26", "149", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:1145;s:4:\"file\";s:23:\"2017/02/portfolio_1.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_1-300x245.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:245;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_1-1024x837.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:837;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_1-768x628.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:628;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_1-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_1-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_1-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_1-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_1-1080x883.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:883;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_1-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:25:\"portfolio_1-1280x1047.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:1047;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_1-980x802.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:802;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_1-480x393.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:393;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("27", "150", "_wp_attached_file", "2017/02/portfolio_2.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("28", "150", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:933;s:4:\"file\";s:23:\"2017/02/portfolio_2.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_2-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_2-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_2-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_2-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_2-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_2-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_2-1080x720.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_2-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:24:\"portfolio_2-1280x853.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:853;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_2-980x653.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:653;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_2-480x320.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("29", "151", "_wp_attached_file", "2017/02/portfolio_3.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("30", "151", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:933;s:4:\"file\";s:23:\"2017/02/portfolio_3.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_3-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_3-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_3-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_3-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_3-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_3-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_3-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_3-1080x720.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_3-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:24:\"portfolio_3-1280x853.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:853;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_3-980x653.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:653;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_3-480x320.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("31", "152", "_wp_attached_file", "2017/02/portfolio_4.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("32", "152", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:2100;s:4:\"file\";s:23:\"2017/02/portfolio_4.jpg\";s:5:\"sizes\";a:16:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_4-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_4-683x1024.jpg\";s:5:\"width\";i:683;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"portfolio_4-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:25:\"portfolio_4-1024x1536.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:25:\"portfolio_4-1365x2048.jpg\";s:5:\"width\";i:1365;s:6:\"height\";i:2048;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_4-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_4-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_4-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_4-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:25:\"portfolio_4-1080x1620.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:1620;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_4-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:37:\"et-pb-post-main-image-fullwidth-large\";a:4:{s:4:\"file\";s:25:\"portfolio_4-1400x1800.jpg\";s:5:\"width\";i:1400;s:6:\"height\";i:1800;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:25:\"portfolio_4-1280x1920.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:1920;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:24:\"portfolio_4-980x1470.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:1470;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_4-480x720.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("33", "153", "_wp_attached_file", "2017/02/portfolio_5.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("34", "153", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:933;s:4:\"file\";s:23:\"2017/02/portfolio_5.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_5-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_5-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_5-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_5-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_5-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_5-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_5-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_5-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_5-1080x720.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_5-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:24:\"portfolio_5-1280x853.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:853;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_5-980x653.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:653;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_5-480x320.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("35", "154", "_wp_attached_file", "2017/02/portfolio_6.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("36", "154", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:1000;s:4:\"file\";s:23:\"2017/02/portfolio_6.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_6-300x214.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:214;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_6-1024x731.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:731;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_6-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_6-768x549.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:549;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_6-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_6-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_6-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_6-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_6-1080x771.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:771;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_6-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:24:\"portfolio_6-1280x914.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:914;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_6-980x700.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:700;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_6-480x343.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:343;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("37", "155", "_wp_attached_file", "2017/02/portfolio_7.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("38", "155", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:933;s:4:\"file\";s:23:\"2017/02/portfolio_7.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_7-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_7-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_7-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_7-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_7-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_7-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_7-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_7-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_7-1080x720.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_7-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:24:\"portfolio_7-1280x853.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:853;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_7-980x653.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:653;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_7-480x320.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("39", "156", "_wp_attached_file", "2017/02/portfolio_8.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("40", "156", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:927;s:4:\"file\";s:23:\"2017/02/portfolio_8.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"portfolio_8-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"portfolio_8-1024x678.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:678;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"portfolio_8-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"portfolio_8-768x509.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:509;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"portfolio_8-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"portfolio_8-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"portfolio_8-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"portfolio_8-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"portfolio_8-1080x715.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:715;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"portfolio_8-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:24:\"portfolio_8-1280x848.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:848;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"portfolio_8-980x649.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:649;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"portfolio_8-480x318.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:318;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("41", "157", "_wp_attached_file", "2017/02/blog_1.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("42", "157", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:933;s:4:\"file\";s:18:\"2017/02/blog_1.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"blog_1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"blog_1-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"blog_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"blog_1-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"blog_1-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"blog_1-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"blog_1-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"blog_1-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:19:\"blog_1-1080x720.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"blog_1-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:19:\"blog_1-1280x853.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:853;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"blog_1-980x653.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:653;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"blog_1-480x320.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("78", "158", "_wp_attached_file", "2017/02/blog_2.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("79", "158", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:933;s:4:\"file\";s:18:\"2017/02/blog_2.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"blog_2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"blog_2-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"blog_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"blog_2-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"blog_2-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"blog_2-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"blog_2-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"blog_2-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:19:\"blog_2-1080x720.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:720;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"blog_2-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:19:\"blog_2-1280x853.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:853;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"blog_2-980x653.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:653;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"blog_2-480x320.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("80", "159", "_wp_attached_file", "2017/02/blog_3.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("81", "159", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1400;s:6:\"height\";i:955;s:4:\"file\";s:18:\"2017/02/blog_3.jpg\";s:5:\"sizes\";a:13:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"blog_3-300x205.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:205;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"blog_3-1024x699.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:699;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"blog_3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"blog_3-768x524.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:524;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"blog_3-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"blog_3-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"blog_3-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"blog_3-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:19:\"blog_3-1080x737.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:737;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"blog_3-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:19:\"blog_3-1280x873.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:873;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"blog_3-980x669.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:669;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"blog_3-480x327.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:327;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("122", "184", "_menu_item_type", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("123", "184", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_522243_postmeta` VALUES("124", "184", "_menu_item_object_id", "184");
INSERT INTO `wp_522243_postmeta` VALUES("125", "184", "_menu_item_object", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("126", "184", "_menu_item_target", "");
INSERT INTO `wp_522243_postmeta` VALUES("127", "184", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("128", "184", "_menu_item_xfn", "");
INSERT INTO `wp_522243_postmeta` VALUES("129", "184", "_menu_item_url", "#aboutme");
INSERT INTO `wp_522243_postmeta` VALUES("130", "185", "_menu_item_type", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("131", "185", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_522243_postmeta` VALUES("132", "185", "_menu_item_object_id", "185");
INSERT INTO `wp_522243_postmeta` VALUES("133", "185", "_menu_item_object", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("134", "185", "_menu_item_target", "");
INSERT INTO `wp_522243_postmeta` VALUES("135", "185", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("136", "185", "_menu_item_xfn", "");
INSERT INTO `wp_522243_postmeta` VALUES("137", "185", "_menu_item_url", "#materials");
INSERT INTO `wp_522243_postmeta` VALUES("138", "186", "_menu_item_type", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("139", "186", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_522243_postmeta` VALUES("140", "186", "_menu_item_object_id", "186");
INSERT INTO `wp_522243_postmeta` VALUES("141", "186", "_menu_item_object", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("142", "186", "_menu_item_target", "");
INSERT INTO `wp_522243_postmeta` VALUES("143", "186", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("144", "186", "_menu_item_xfn", "");
INSERT INTO `wp_522243_postmeta` VALUES("145", "186", "_menu_item_url", "#portfolio");
INSERT INTO `wp_522243_postmeta` VALUES("146", "187", "_menu_item_type", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("147", "187", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_522243_postmeta` VALUES("148", "187", "_menu_item_object_id", "187");
INSERT INTO `wp_522243_postmeta` VALUES("149", "187", "_menu_item_object", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("150", "187", "_menu_item_target", "");
INSERT INTO `wp_522243_postmeta` VALUES("151", "187", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("152", "187", "_menu_item_xfn", "");
INSERT INTO `wp_522243_postmeta` VALUES("153", "187", "_menu_item_url", "#video");
INSERT INTO `wp_522243_postmeta` VALUES("154", "188", "_menu_item_type", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("155", "188", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_522243_postmeta` VALUES("156", "188", "_menu_item_object_id", "188");
INSERT INTO `wp_522243_postmeta` VALUES("157", "188", "_menu_item_object", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("158", "188", "_menu_item_target", "");
INSERT INTO `wp_522243_postmeta` VALUES("159", "188", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("160", "188", "_menu_item_xfn", "");
INSERT INTO `wp_522243_postmeta` VALUES("161", "188", "_menu_item_url", "#blog");
INSERT INTO `wp_522243_postmeta` VALUES("162", "189", "_menu_item_type", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("163", "189", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_522243_postmeta` VALUES("164", "189", "_menu_item_object_id", "189");
INSERT INTO `wp_522243_postmeta` VALUES("165", "189", "_menu_item_object", "custom");
INSERT INTO `wp_522243_postmeta` VALUES("166", "189", "_menu_item_target", "");
INSERT INTO `wp_522243_postmeta` VALUES("167", "189", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("168", "189", "_menu_item_xfn", "");
INSERT INTO `wp_522243_postmeta` VALUES("169", "189", "_menu_item_url", "#contact");
INSERT INTO `wp_522243_postmeta` VALUES("170", "271", "_wp_attached_file", "2017/02/Instagram.png");
INSERT INTO `wp_522243_postmeta` VALUES("171", "271", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:140;s:6:\"height\";i:138;s:4:\"file\";s:21:\"2017/02/Instagram.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("172", "273", "_wp_attached_file", "2017/02/500px-1.png");
INSERT INTO `wp_522243_postmeta` VALUES("173", "273", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:152;s:6:\"height\";i:152;s:4:\"file\";s:19:\"2017/02/500px-1.png\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"500px-1-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("174", "274", "_wp_attached_file", "2017/02/Phone-1.png");
INSERT INTO `wp_522243_postmeta` VALUES("175", "274", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:88;s:6:\"height\";i:162;s:4:\"file\";s:19:\"2017/02/Phone-1.png\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"Phone-1-88x150.png\";s:5:\"width\";i:88;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("176", "275", "_wp_attached_file", "2017/02/Instagram_footer.png");
INSERT INTO `wp_522243_postmeta` VALUES("177", "275", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:28;s:6:\"height\";i:30;s:4:\"file\";s:28:\"2017/02/Instagram_footer.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("178", "276", "_wp_attached_file", "2017/02/tweeter_footer-1.png");
INSERT INTO `wp_522243_postmeta` VALUES("179", "276", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:34;s:6:\"height\";i:30;s:4:\"file\";s:28:\"2017/02/tweeter_footer-1.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("180", "277", "_wp_attached_file", "2017/02/Facebook_footer.png");
INSERT INTO `wp_522243_postmeta` VALUES("181", "277", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:16;s:6:\"height\";i:30;s:4:\"file\";s:27:\"2017/02/Facebook_footer.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("182", "281", "_wp_attached_file", "2017/02/Logo.png");
INSERT INTO `wp_522243_postmeta` VALUES("183", "281", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:274;s:6:\"height\";i:108;s:4:\"file\";s:16:\"2017/02/Logo.png\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"Logo-150x108.png\";s:5:\"width\";i:150;s:6:\"height\";i:108;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("186", "287", "_edit_last", "1");
INSERT INTO `wp_522243_postmeta` VALUES("187", "287", "_edit_lock", "1588503179:1");
INSERT INTO `wp_522243_postmeta` VALUES("188", "287", "_wp_page_template", "elementor_canvas");
INSERT INTO `wp_522243_postmeta` VALUES("191", "287", "_elementor_edit_mode", "builder");
INSERT INTO `wp_522243_postmeta` VALUES("192", "287", "_elementor_template_type", "wp-page");
INSERT INTO `wp_522243_postmeta` VALUES("193", "287", "_elementor_version", "2.9.8");
INSERT INTO `wp_522243_postmeta` VALUES("194", "287", "_elementor_pro_version", "2.9.3");
INSERT INTO `wp_522243_postmeta` VALUES("195", "290", "_elementor_edit_mode", "builder");
INSERT INTO `wp_522243_postmeta` VALUES("196", "290", "_elementor_template_type", "kit");
INSERT INTO `wp_522243_postmeta` VALUES("197", "290", "_elementor_version", "2.9.8");
INSERT INTO `wp_522243_postmeta` VALUES("198", "290", "_elementor_pro_version", "2.9.3");
INSERT INTO `wp_522243_postmeta` VALUES("199", "290", "_elementor_css", "a:6:{s:4:\"time\";i:1588500243;s:5:\"fonts\";a:0:{}s:5:\"icons\";a:0:{}s:6:\"status\";s:5:\"empty\";i:0;s:0:\"\";s:3:\"css\";s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("200", "291", "_wp_attached_file", "2020/05/Nikki_M_WEB_2.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("201", "291", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_2.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_2-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_2-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_2-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("202", "291", "_elementor_source_image_hash", "8221f3a99a6a1a125f126f35ce04d2fee3d486d1");
INSERT INTO `wp_522243_postmeta` VALUES("203", "292", "_wp_attached_file", "2020/05/Nikki_M_WEB_16.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("204", "292", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_16.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_16-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_16-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_16-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_16-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("205", "292", "_elementor_source_image_hash", "8151b1cb2fcaf87a6d4365a4d924a52528f36e1b");
INSERT INTO `wp_522243_postmeta` VALUES("206", "293", "_wp_attached_file", "2020/05/Nikki_M_WEB_4.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("207", "293", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_4.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_4-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_4-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_4-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("208", "293", "_elementor_source_image_hash", "4cdb8cb345b5ac4032bfe1658a5ad1f4615c4f0f");
INSERT INTO `wp_522243_postmeta` VALUES("209", "294", "_wp_attached_file", "2020/05/hex-texture-custom-cc0.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("210", "294", "_elementor_source_image_hash", "f60f333db59bf83f90cd721d66ef0dbe699de90f");
INSERT INTO `wp_522243_postmeta` VALUES("211", "295", "_wp_attached_file", "2020/05/Nikki_M_WEB_8.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("212", "295", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_8.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_8-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_8-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_8-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_8-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("213", "295", "_elementor_source_image_hash", "406e90e4db77a6202167e50d620dedf6182266ab");
INSERT INTO `wp_522243_postmeta` VALUES("214", "296", "_wp_attached_file", "2020/05/Nikki_M_WEB_7.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("215", "296", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_7.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_7-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_7-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_7-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_7-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("216", "296", "_elementor_source_image_hash", "7b586a621209045f724ff12b9e9cd1edf911bb8f");
INSERT INTO `wp_522243_postmeta` VALUES("217", "297", "_wp_attached_file", "2020/05/Nikki_M_WEB_15.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("218", "297", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_15.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_15-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_15-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_15-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_15-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("219", "297", "_elementor_source_image_hash", "edadbcf1cf74906cacf52752e869dc9236024f7e");
INSERT INTO `wp_522243_postmeta` VALUES("220", "298", "_wp_attached_file", "2020/05/Nikki_M_WEB_10.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("221", "298", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_10.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_10-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_10-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_10-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("222", "298", "_elementor_source_image_hash", "7a324ed90ebc9ca83c734bf42d3b9a2432b240ba");
INSERT INTO `wp_522243_postmeta` VALUES("223", "299", "_wp_attached_file", "2020/05/Nikki_M_WEB_14.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("224", "299", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_14.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_14-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_14-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_14-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_14-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("225", "299", "_elementor_source_image_hash", "03a9228d84fa09bcd5c060173cbf9cdac31071eb");
INSERT INTO `wp_522243_postmeta` VALUES("226", "300", "_wp_attached_file", "2020/05/Nikki_M_WEB_1.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("227", "300", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_1.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_1-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_1-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_1-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("228", "300", "_elementor_source_image_hash", "c25dd075c3734b4c4d2521c320012876e49885c5");
INSERT INTO `wp_522243_postmeta` VALUES("229", "301", "_wp_attached_file", "2020/05/Nikki_M_WEB_13.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("230", "301", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_13.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_13-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_13-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_13-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_13-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("231", "301", "_elementor_source_image_hash", "52c9327b9d35fde98f894ca9f1ca818daaf1290d");
INSERT INTO `wp_522243_postmeta` VALUES("232", "302", "_wp_attached_file", "2020/05/Nikki_M_WEB_11.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("233", "302", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_11.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_11-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_11-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_11-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_11-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("234", "302", "_elementor_source_image_hash", "d30689e27bcaad7a7104dceafd0b0608c49e0783");
INSERT INTO `wp_522243_postmeta` VALUES("235", "303", "_wp_attached_file", "2020/05/Nikki_M_WEB_5.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("236", "303", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_5.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_5-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_5-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_5-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_5-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("237", "303", "_elementor_source_image_hash", "52b55412c814be461acfea31aeda07508134081b");
INSERT INTO `wp_522243_postmeta` VALUES("238", "304", "_wp_attached_file", "2020/05/Nikki_M_WEB_9.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("239", "304", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_9.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_9-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_9-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_9-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_9-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("240", "304", "_elementor_source_image_hash", "aabc24d8ac61a0823ebbb641592c01e5355c347f");
INSERT INTO `wp_522243_postmeta` VALUES("241", "305", "_wp_attached_file", "2020/05/Nikki_M_WEB_6.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("242", "305", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_6.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_6-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_6-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_6-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_6-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("243", "305", "_elementor_source_image_hash", "6fe87f945e0b107455a429eda696f7c511276ffc");
INSERT INTO `wp_522243_postmeta` VALUES("244", "306", "_wp_attached_file", "2020/05/Nikki_M_WEB_12.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("245", "306", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:26:\"2020/05/Nikki_M_WEB_12.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_12-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_12-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_12-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"Nikki_M_WEB_12-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("246", "306", "_elementor_source_image_hash", "6f7e61911da0c30457ec6565da7de8029bf2330c");
INSERT INTO `wp_522243_postmeta` VALUES("247", "307", "_wp_attached_file", "2020/05/Nikki_M_WEB_3.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("248", "307", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2020/05/Nikki_M_WEB_3.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_3-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_3-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Nikki_M_WEB_3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"Nikki_M_WEB_3-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("249", "307", "_elementor_source_image_hash", "11d17533558ce11d11cffaf820c3aa16fac3b539");
INSERT INTO `wp_522243_postmeta` VALUES("250", "308", "_elementor_edit_mode", "builder");
INSERT INTO `wp_522243_postmeta` VALUES("251", "308", "_elementor_template_type", "page");
INSERT INTO `wp_522243_postmeta` VALUES("252", "308", "_elementor_version", "2.9.8");
INSERT INTO `wp_522243_postmeta` VALUES("253", "308", "_elementor_pro_version", "2.9.3");
INSERT INTO `wp_522243_postmeta` VALUES("254", "308", "_elementor_data", "[{\"id\":\"5a56efa\",\"elType\":\"section\",\"settings\":{\"background_background\":\"classic\",\"background_image\":{\"id\":291,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_2.jpg\"},\"background_position\":\"initial\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"background_overlay_background\":\"gradient\",\"background_overlay_color\":\"rgba(255,255,255,0)\",\"padding\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"60\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"15\",\"bottom\":\"80\",\"left\":\"15\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"025\",\"right\":\"15\",\"bottom\":\"50\",\"left\":\"15\",\"isLinked\":\"\"},\"height\":\"min-height\",\"custom_height\":{\"unit\":\"vh\",\"size\":120},\"background_ypos\":{\"unit\":\"px\",\"size\":-165},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":1},\"column_position\":\"stretch\",\"structure\":\"20\",\"background_bg_width\":{\"unit\":\"%\",\"size\":\"120\"},\"background_video_link\":\"https:\\/\\/www.youtube.com\\/watch?v=dxhbld4paug\",\"background_video_start\":\"330\",\"background_video_end\":\"343\",\"background_overlay_color_stop\":{\"unit\":\"%\",\"size\":\"69\"},\"background_overlay_color_b\":\"rgba(255,255,255,0.68)\",\"background_overlay_gradient_angle\":{\"unit\":\"deg\",\"size\":\"60\"},\"border_width\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"30\",\"bottom\":\"30\",\"left\":\"30\",\"isLinked\":\"1\"},\"border_color\":\"#ffffff\",\"custom_height_tablet\":{\"unit\":\"vh\",\"size\":90},\"background_size_mobile\":\"cover\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"fa94338\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"reverse_order_mobile\":\"reverse-mobile\",\"background_image_mobile\":{\"id\":291,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_2.jpg\"},\"custom_height_mobile\":{\"unit\":\"px\",\"size\":650,\"sizes\":[]},\"background_position_mobile\":\"center right\",\"background_attachment\":\"scroll\",\"background_repeat_mobile\":\"no-repeat\",\"background_overlay_gradient_type\":\"radial\",\"background_image_tablet\":{\"id\":291,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_2.jpg\"},\"background_repeat_tablet\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"76fb016c\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"padding\":{\"unit\":\"px\",\"top\":\"60\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"content_position\":\"top\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"46f0073c\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":\"23\"},\"space_mobile\":{\"unit\":\"px\",\"size\":\"10\"},\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"4135c016\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":\"23\"},\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"460e620c\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":\"197\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"5\",\"left\":\"0\",\"isLinked\":\"\"},\"space_tablet\":{\"unit\":\"px\",\"size\":\"10\"},\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"}],\"isInner\":\"\"},{\"id\":\"1b83857\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"7a374665\",\"elType\":\"widget\",\"settings\":{\"title\":\"Nikki\",\"header_size\":\"h1\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"em\",\"size\":5},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":2.70000000000000017763568394002504646778106689453125},\"typography_font_weight\":\"600\",\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":\"1.2\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"300\",\"typography_line_height\":{\"unit\":\"em\",\"size\":\"1.4\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":4},\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"2\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"-20\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":-1,\"vertical\":1,\"blur\":0,\"color\":\"#000000\"},\"tooltip_content\":\"I am a tooltip\",\"typography_letter_spacing_mobile\":{\"unit\":\"px\",\"size\":-0.59999999999999997779553950749686919152736663818359375,\"sizes\":[]},\"sticky\":\"top\",\"sticky_parent\":\"yes\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"b902917\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p><a href=\\\"https:\\/\\/theeroticreview.com\\\" target=\\\"_blank\\\" rel=\\\"noopener\\\"><img class=\\\"alignnone wp-image-382\\\" src=\\\"https:\\/\\/NikkiJames.net\\/wp-content\\/uploads\\/2020\\/02\\/TER_WL_176x132_CC.png\\\" alt=\\\"\\\" width=\\\"107\\\" height=\\\"80\\\" \\/><\\/a> <a href=\\\"https:\\/\\/preferred411.com\\\" target=\\\"_blank\\\" rel=\\\"noopener\\\"><img class=\\\"alignnone wp-image-296\\\" src=\\\"https:\\/\\/NikkiJames.net\\/wp-content\\/uploads\\/2020\\/01\\/preferredSeal-bw-1-1.png\\\" alt=\\\"\\\" width=\\\"73\\\" height=\\\"80\\\" \\/><\\/a><\\/p>\",\"align\":\"right\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_animation\":\"fadeIn\",\"animation_duration\":\"slow\",\"_animation_delay\":1000,\"_position\":\"absolute\",\"_offset_x_tablet\":{\"unit\":\"vw\",\"size\":-50,\"sizes\":[]},\"_offset_orientation_v\":\"end\",\"_offset_y_end\":{\"unit\":\"vh\",\"size\":0,\"sizes\":[]},\"_offset_y_end_mobile\":{\"unit\":\"vh\",\"size\":-55,\"sizes\":[]},\"custom_css\":\"@media only screen and (max-width: 900px) {\\nselector img {\\ndisplay: block;\\n  margin-left: 70vw;\\n  margin-right: auto;\\n  margin-bottom:10px;\\n  padding-top:10px;\\n  width: 100%;\\n  height: auto;\\n  max-width: 60px;}\\n}\",\"tooltip_content\":\"I am a tooltip\",\"align_mobile\":\"right\",\"_offset_x_mobile\":{\"unit\":\"vw\",\"size\":-2,\"sizes\":[]},\"_offset_x_end\":{\"unit\":\"vw\",\"size\":-10,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"7d0ce545\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"padding\":{\"unit\":\"px\",\"top\":\"120\",\"right\":\"0\",\"bottom\":\"120\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"em\",\"top\":\"4\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"background_background\":\"classic\",\"background_color\":\"#f4f4f4\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":294,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/hex-texture-custom-cc0.jpg\"},\"background_overlay_repeat\":\"repeat\",\"background_overlay_size\":\"initial\",\"background_overlay_bg_width\":{\"unit\":\"%\",\"size\":\"40\"},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":\"0.38\"},\"shape_divider_top_color\":\"#ffffff\",\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":\"26\"},\"background_overlay_position\":\"top center\",\"css_filters_contrast\":{\"unit\":\"px\",\"size\":\"177\"},\"css_filters_saturate\":{\"unit\":\"px\",\"size\":\"0\"},\"shape_divider_bottom\":\"zigzag\",\"shape_divider_bottom_color\":\"#ffffff\",\"shape_divider_bottom_width\":{\"unit\":\"%\",\"size\":\"100\"},\"shape_divider_bottom_height\":{\"unit\":\"px\",\"size\":\"23\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"4cca42d\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"61676afc\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"100\",\"border_width\":{\"unit\":\"px\",\"top\":\"2\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":\"1\"},\"border_color\":\"#d3cfc6\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"background_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"30\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"40\",\"left\":\"0\",\"isLinked\":\"\"},\"animation\":\"fadeInUp\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"7cd395e8\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"structure\":\"20\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"50\",\"left\":\"0\",\"isLinked\":\"\"},\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"7f38d69\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"32214408\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"content_position\":\"center\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"60\",\"bottom\":\"0\",\"left\":\"60\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"40\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":\"\"},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"640fab7\",\"elType\":\"widget\",\"settings\":{\"title\":\"Get To Know Me\",\"align\":\"center\",\"title_color\":\"#080808\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"px\",\"size\":\"35\"},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":\"35\"},\"typography_font_weight\":\"bold\",\"_animation\":\"fadeInUp\",\"typography_text_transform\":\"uppercase\",\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"1685c93d\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Visit me in Orange County<\\/p>\",\"align\":\"center\",\"text_color\":\"#000000\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.399999999999999911182158029987476766109466552734375},\"typography_line_height\":{\"unit\":\"em\",\"size\":\"1.8\"},\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"0.32\"},\"_margin\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"45\",\"bottom\":\"0\",\"left\":\"45\",\"isLinked\":\"\"},\"typography_font_size_tablet\":{\"unit\":\"px\",\"size\":\"16\"},\"typography_line_height_tablet\":{\"unit\":\"px\",\"size\":\"28\"},\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"typography_font_weight\":\"300\",\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"724ff977\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Hi my name is Nikki.<\\/p><p>I am a brunette bombshell from Orange County, at the young age of just 21... standing 5 foot 4 inches with exotic features. I have new fun enhanced assets reaching double D\'s.<\\/p><p>I live a healthy lifestyle and enjoy being on the water - whether it be boating, beach, traveling to tropical beaches all over the world. I have a tight body and sexy kitten light brown eyes. I exercise almost everyday.<\\/p><p>I present myself with superior first-rate standards; I am highly confident that you will enjoy our time together. I consider new ideas and look for a connection that is real. I am attentive sensual, passionate and I look forward to stimulating you every way possible. I look forward to meeting you in person...<\\/p>\",\"align\":\"center\",\"text_color\":\"#080808\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"rem\",\"size\":1.100000000000000088817841970012523233890533447265625},\"typography_line_height\":{\"unit\":\"em\",\"size\":1.399999999999999911182158029987476766109466552734375},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"45\",\"bottom\":\"0\",\"left\":\"45\",\"isLinked\":\"\"},\"typography_font_size_tablet\":{\"unit\":\"rem\",\"size\":\"0.8\"},\"typography_line_height_tablet\":{\"unit\":\"em\",\"size\":\"1.6\"},\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"_css_classes\":\"bio\",\"tooltip_content\":\"I am a tooltip\",\"typography_font_weight\":\"300\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"4f1369e5\",\"elType\":\"widget\",\"settings\":{\"text\":\"Book Me\",\"align\":\"center\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":16},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"4\"},\"button_text_color\":\"#000000\",\"background_color\":\"rgba(255,255,255,0)\",\"hover_color\":\"#282828\",\"button_background_hover_color\":\"rgba(255,255,255,0)\",\"border_width\":{\"unit\":\"px\",\"top\":\"4\",\"right\":\"4\",\"bottom\":\"4\",\"left\":\"4\",\"isLinked\":\"1\"},\"border_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"60\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"700\",\"size\":\"md\",\"typography_line_height\":{\"unit\":\"em\",\"size\":\"2.5\"},\"hover_animation\":\"shrink\",\"_background_background\":\"classic\",\"_background_position\":\"center center\",\"_background_repeat\":\"no-repeat\",\"_background_size\":\"initial\",\"_background_bg_width\":{\"unit\":\"px\",\"size\":\"205\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"selected_icon\":{\"value\":\"\",\"library\":\"\"},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"button\"}],\"isInner\":\"1\"},{\"id\":\"2c341ec8\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"content_position\":\"center\",\"hide_mobile\":\"hidden-phone\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"334220de\",\"elType\":\"widget\",\"settings\":{\"slides\":[{\"image\":{\"id\":292,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_16.jpg\"},\"_id\":\"e0b6430\",\"type\":\"image\",\"image_link_to_type\":\"\",\"image_link_to\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"video\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"}},{\"image\":{\"id\":293,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_4.jpg\"},\"_id\":\"c658c7d\",\"type\":\"image\",\"image_link_to_type\":\"\",\"image_link_to\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"video\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"}}],\"slides_per_view\":\"1\",\"slides_per_view_tablet\":\"1\",\"slides_per_view_mobile\":\"1\",\"height\":{\"unit\":\"vh\",\"size\":100},\"height_tablet\":{\"unit\":\"vh\",\"size\":80},\"height_mobile\":{\"unit\":\"px\",\"size\":\"447\"},\"arrows_color\":\"#ffffff\",\"play_icon_size\":{\"unit\":\"px\",\"size\":\"20\"},\"_css_classes\":\"envato-kit-116-slider\",\"_animation\":\"fadeIn\",\"effect\":\"fade\",\"centered_slides\":\"yes\",\"slides_to_scroll\":\"1\",\"speed\":800,\"icon\":\"plus-circle\",\"space_between\":{\"unit\":\"px\",\"size\":\"30\"},\"slide_background_color\":\"#d3cfc6\",\"slide_border_size\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"30\",\"bottom\":\"30\",\"left\":\"30\",\"isLinked\":\"1\"},\"slide_border_radius\":{\"unit\":\"px\",\"size\":\"0\"},\"slide_border_color\":\"#ffffff\",\"slide_padding\":{\"unit\":\"px\",\"top\":\"4\",\"right\":\"4\",\"bottom\":\"4\",\"left\":\"4\",\"isLinked\":\"1\"},\"arrows_size\":{\"unit\":\"px\",\"size\":\"40\"},\"_padding\":{\"unit\":\"em\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_color\":\"#ffffff\",\"show_arrows\":\"\",\"autoplay_speed\":3000,\"image_size_size\":\"medium_large\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"pause_on_interaction\":\"\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"media-carousel\"}],\"isInner\":\"1\"}],\"isInner\":\"1\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"135a1f9a\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"120\",\"right\":\"60\",\"bottom\":\"0\",\"left\":\"60\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"15\",\"bottom\":\"80\",\"left\":\"15\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"50\",\"left\":\"15\",\"isLinked\":\"\"},\"background_background\":\"classic\",\"background_color\":\"#f4f4f4\",\"background_overlay_background\":\"classic\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":\"0.1\"},\"shape_divider_top\":\"zigzag\",\"shape_divider_top_color\":\"#f9f9f9\",\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":\"27\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"1add6b4\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"715d8318\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"space_between_widgets\":\"0\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"animation\":\"fadeInLeft\",\"_inline_size\":null,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"6050e582\",\"elType\":\"widget\",\"settings\":{\"gallery_type\":\"manual\",\"gallery\":[{\"_id\":\"a7ddeba\",\"image\":{\"id\":295,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_8.jpg\"},\"custom_size\":\"\",\"height_ratio\":{\"unit\":\"px\",\"size\":70,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"9c1c20a\",\"image\":{\"id\":296,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_7.jpg\"},\"custom_size\":\"\",\"height_ratio\":{\"unit\":\"px\",\"size\":70,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"7017400\",\"image\":{\"id\":297,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_15.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":70,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"100%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"5a659cc\",\"image\":{\"id\":298,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_10.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":70,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"100%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"b2404b9\",\"image\":{\"id\":299,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_14.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"cd04016\",\"image\":{\"id\":300,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_1.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"f643ca4\",\"image\":{\"id\":301,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_13.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"c3c8025\",\"image\":{\"id\":302,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_11.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"fc79d07\",\"image\":{\"id\":292,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_16.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"86c330b\",\"image\":{\"id\":303,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_5.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"8849520\",\"image\":{\"id\":291,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_2.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"_id\":\"1e3990e\",\"image\":{\"id\":293,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_4.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"image\":{\"id\":304,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_9.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"0999cbb\",\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"image\":{\"id\":305,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_6.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"85f5664\",\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"image\":{\"id\":306,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_12.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"ca68410\",\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"},{\"image\":{\"id\":307,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_3.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":140,\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/NikkiJames.net\\/\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"505fc7e\",\"custom_size_tablet\":\"\",\"custom_size_mobile\":\"\"}],\"columns\":\"4\",\"columns_tablet\":\"4\",\"columns_mobile\":\"2\",\"open_lightbox\":\"yes\",\"image_align\":\"center\",\"image_vertical_align\":\"middle\",\"image_horizontal_spacing\":{\"unit\":\"px\",\"size\":6,\"sizes\":[]},\"image_vertical_spacing\":{\"unit\":\"px\",\"size\":6,\"sizes\":[]},\"overflow\":\"yes\",\"tooltip_content\":\"I am a tooltip\",\"gallery_display_caption\":\"none\",\"image_border_border\":\"solid\",\"image_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"image_border_color\":\"#7a7a7a\",\"image_transition_transition\":\"custom\",\"image_transition_easing\":\"ease-in-out\",\"image_scale_hover\":{\"unit\":\"px\",\"size\":1.0500000000000000444089209850062616169452667236328125,\"sizes\":[]},\"wp_gallery\":[],\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"gallery-extra\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"41a97ccf\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"padding\":{\"unit\":\"px\",\"top\":\"120\",\"right\":\"0\",\"bottom\":\"120\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"em\",\"top\":\"4\",\"right\":\"2\",\"bottom\":\"4\",\"left\":\"2\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"background_background\":\"classic\",\"background_color\":\"#f4f4f4\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":294,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/hex-texture-custom-cc0.jpg\"},\"background_overlay_repeat\":\"repeat\",\"background_overlay_size\":\"initial\",\"background_overlay_bg_width\":{\"unit\":\"%\",\"size\":\"40\"},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":\"0.38\"},\"shape_divider_top_color\":\"#ffffff\",\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":\"26\"},\"background_overlay_position\":\"top center\",\"css_filters_contrast\":{\"unit\":\"px\",\"size\":\"177\"},\"css_filters_saturate\":{\"unit\":\"px\",\"size\":\"0\"},\"shape_divider_bottom\":\"zigzag\",\"shape_divider_bottom_color\":\"#ffffff\",\"shape_divider_bottom_width\":{\"unit\":\"%\",\"size\":\"100\"},\"shape_divider_bottom_height\":{\"unit\":\"px\",\"size\":\"26\"},\"box_shadow_box_shadow\":{\"horizontal\":\"0\",\"vertical\":\"0\",\"blur\":\"11\",\"spread\":\"3\",\"color\":\"rgba(0,0,0,0.14)\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"cd1c841\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"37364a48\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"100\",\"border_width\":{\"unit\":\"px\",\"top\":\"2\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":\"1\"},\"border_color\":\"#d3cfc6\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"background_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"30\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"40\",\"left\":\"0\",\"isLinked\":\"\"},\"animation\":\"fadeInUp\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"79a5084d\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"\"},\"structure\":\"20\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"60\",\"left\":\"0\",\"isLinked\":\"\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"3c9316f\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"1aeb7439\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"49.957\",\"padding\":{\"unit\":\"em\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"content_position\":\"top\",\"space_between_widgets\":\"0\",\"background_background\":\"classic\",\"background_size\":\"cover\",\"_inline_size_tablet\":48,\"hide_mobile\":\"hidden-phone\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"6243b9ba\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":600},\"_margin\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_image\":{\"id\":304,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_9.jpg\"},\"_background_image_tablet\":{\"id\":304,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_9.jpg\"},\"_background_position\":\"bottom center\",\"_background_size\":\"cover\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_border_radius_tablet\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"_background_ypos\":{\"unit\":\"px\",\"size\":-39,\"sizes\":[]},\"_background_image_mobile\":{\"id\":304,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_9.jpg\"},\"_background_position_mobile\":\"top center\",\"_background_attachment\":\"scroll\",\"_background_repeat_mobile\":\"no-repeat\",\"_background_size_mobile\":\"cover\",\"_background_position_tablet\":\"top center\",\"_background_repeat_tablet\":\"no-repeat\",\"_background_size_tablet\":\"cover\",\"space_tablet\":{\"unit\":\"px\",\"size\":650,\"sizes\":[]},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"7aabc545\",\"elType\":\"widget\",\"settings\":{\"tooltip_content\":\"I am a tooltip\",\"space_mobile\":{\"unit\":\"px\",\"size\":0,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"}],\"isInner\":\"1\"},{\"id\":\"395d44d7\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"50.043\",\"space_between_widgets\":\"0\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"_inline_size_tablet\":50,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"31b51e9c\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"One hour\",\"item_description\":\"\",\"price\":\"$600\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"54ba866\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"90 minutes\",\"item_description\":\"\",\"price\":\"$750\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"f7694ef\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Two hours\",\"item_description\":\"\",\"price\":\"$1000\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"4ebdb94\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Three hours\",\"item_description\":\"\",\"price\":\"$1500\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"8368410\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Twelve hours\",\"item_description\":\"LA and San Diego - 2hr minimum<br \\/>\\nFly me to you for 6 hours plus travel costs\",\"price\":\"$5000\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"e94d71f\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Same day cancelation\",\"item_description\":\"\",\"price\":\"$200 fee\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"0be7791\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Facetime online\",\"item_description\":\"\",\"price\":\"$200 for 20mins\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"0fc18ec\"}],\"heading_color\":\"#000000\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_family\":\"Lato\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"row_gap\":{\"unit\":\"px\",\"size\":\"32\"},\"_padding\":{\"unit\":\"em\",\"top\":\"3\",\"right\":\"3\",\"bottom\":\"3\",\"left\":\"3\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"description_color\":\"#000000\",\"description_typography_typography\":\"custom\",\"description_typography_font_family\":\"Lato\",\"description_typography_font_size_tablet\":{\"unit\":\"rem\",\"size\":\"0.8\"},\"description_typography_line_height\":{\"unit\":\"em\",\"size\":\"1.7\"},\"description_typography_line_height_tablet\":{\"unit\":\"em\",\"size\":\"1.6\"},\"separator_spacing\":{\"unit\":\"px\",\"size\":\"32\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_color\":\"#ffffff\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"heading_typography_font_size\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]},\"heading_typography_font_weight\":\"300\",\"heading_typography_font_style\":\"italic\",\"description_typography_font_size\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625,\"sizes\":[]},\"description_typography_font_weight\":\"300\",\"description_typography_font_style\":\"italic\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"5e20513\",\"elType\":\"widget\",\"settings\":{\"title\":\"Book Me\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":\"16\"},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"3.2\"},\"_padding\":{\"unit\":\"px\",\"top\":\"28\",\"right\":\"0\",\"bottom\":\"26\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_color\":\"#23211e\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"hide_mobile\":\"hidden-phone\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":\"1\"}],\"isInner\":\"1\"},{\"id\":\"79c70d51\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"structure\":\"20\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"layout\":\"full_width\",\"reverse_order_mobile\":\"reverse-mobile\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"86dccb7\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"4df06a84\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"50.043\",\"space_between_widgets\":\"0\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"4c6a035a\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"Location\",\"item_description\":\"LA & San Diego by appointment\",\"price\":\"Orange County\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"54ba866\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Age\",\"item_description\":\"\",\"price\":\"21\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"4fc77ee\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Bust\",\"item_description\":\"\",\"price\":\"34DD (enhanced)\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"f7694ef\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Waist\",\"item_description\":\"\",\"price\":\"24\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"9a37d75\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Hips\",\"item_description\":\"\",\"price\":\"34\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"9422203\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Height\",\"item_description\":\"\",\"price\":\"5\' 4\\\"\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"8541f47\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Weight\",\"item_description\":\"\",\"price\":\"120lbs\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"1822b84\",\"image\":{\"url\":\"\",\"id\":\"\"}}],\"heading_color\":\"#000000\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_family\":\"Lato\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"row_gap\":{\"unit\":\"px\",\"size\":\"32\"},\"_padding\":{\"unit\":\"em\",\"top\":\"3\",\"right\":\"3\",\"bottom\":\"3\",\"left\":\"3\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"description_color\":\"#000000\",\"description_typography_typography\":\"custom\",\"description_typography_font_family\":\"Lato\",\"description_typography_font_size_tablet\":{\"unit\":\"rem\",\"size\":\"0.8\"},\"description_typography_line_height\":{\"unit\":\"em\",\"size\":\"1.7\"},\"description_typography_line_height_tablet\":{\"unit\":\"em\",\"size\":\"1.6\"},\"separator_spacing\":{\"unit\":\"px\",\"size\":\"32\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_color\":\"#ffffff\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"heading_typography_font_size\":{\"unit\":\"px\",\"size\":16,\"sizes\":[]},\"heading_typography_font_weight\":\"300\",\"description_typography_font_size\":{\"unit\":\"px\",\"size\":14,\"sizes\":[]},\"description_typography_font_weight\":\"300\",\"description_typography_font_style\":\"italic\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"63d40e35\",\"elType\":\"widget\",\"settings\":{\"title\":\"Book Me\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":\"16\"},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"3.2\"},\"_padding\":{\"unit\":\"px\",\"top\":\"28\",\"right\":\"0\",\"bottom\":\"26\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_color\":\"#23211e\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"9\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"hide_mobile\":\"hidden-phone\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":\"1\"},{\"id\":\"2a485bca\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"49.957\",\"padding\":{\"unit\":\"em\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"content_position\":\"top\",\"space_between_widgets\":\"0\",\"background_background\":\"classic\",\"background_size\":\"cover\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"25375583\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":600},\"_margin\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_image\":{\"id\":307,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_3.jpg\"},\"_background_position\":\"initial\",\"_background_size\":\"cover\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"_background_ypos\":{\"unit\":\"px\",\"size\":-127,\"sizes\":[]},\"_background_position_mobile\":\"top center\",\"_background_attachment\":\"scroll\",\"_background_repeat_mobile\":\"no-repeat\",\"_background_size_mobile\":\"cover\",\"_background_image_tablet\":{\"id\":307,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_3.jpg\"},\"_background_position_tablet\":\"top center\",\"_background_repeat_tablet\":\"no-repeat\",\"_background_size_tablet\":\"cover\",\"_background_image_mobile\":{\"id\":307,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_3.jpg\"},\"space_tablet\":{\"unit\":\"px\",\"size\":650,\"sizes\":[]},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"15c35e87\",\"elType\":\"widget\",\"settings\":{\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"}],\"isInner\":\"1\"}],\"isInner\":\"1\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"1fb2f5f7\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"c6e0aeb\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_image\":{\"id\":296,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_7.jpg\"},\"background_position\":\"center right\",\"background_attachment\":\"scroll\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"margin\":{\"unit\":\"px\",\"top\":\"50\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"background_image_mobile\":{\"id\":301,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_13.jpg\"},\"background_position_mobile\":\"initial\",\"background_xpos_mobile\":{\"unit\":\"em\",\"size\":-30.89999999999999857891452847979962825775146484375,\"sizes\":[]},\"reverse_order_mobile\":\"reverse-mobile\",\"background_image_tablet\":{\"id\":296,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_7.jpg\"},\"background_position_tablet\":\"center center\",\"background_repeat_tablet\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"z_index\":9,\"background_overlay_background\":\"classic\",\"background_overlay_color\":\"#000000\",\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"720470d7\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"1a21a450\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"34fe6eb\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"structure\":\"20\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"reverse_order_mobile\":\"reverse-mobile\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"2c85fdb\",\"elType\":\"column\",\"settings\":{\"_column_size\":50,\"_inline_size\":null,\"content_position\":\"bottom\",\"border_border\":\"solid\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"01\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#ffffff\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"4242e9e6\",\"elType\":\"widget\",\"settings\":{\"title\":\"Touring\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"em\",\"size\":2},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":\"19\"},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_line_height\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625},\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":\"1.2\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"300\",\"tooltip_content\":\"I am a tooltip\",\"typography_font_size_tablet\":{\"unit\":\"px\",\"size\":\"23\"},\"typography_font_style\":\"italic\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"2\"},\"text_shadow_text_shadow\":{\"horizontal\":-1,\"vertical\":1,\"blur\":0,\"color\":\"#000000\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"3b174737\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>[text-blocks id=\\\"touring\\\"]<br \\/>Sign up with this form to be advised when I\\u2019m touring.<\\/p><p>[newsletter_form form=1]<\\/p>\",\"text_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"20\",\"left\":\"20\",\"isLinked\":false},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"10\",\"left\":\"05\",\"isLinked\":false},\"align_mobile\":\"center\",\"typography_font_weight\":\"300\",\"tooltip_content\":\"I am a tooltip\",\"align\":\"center\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"61a88083\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":300},\"tooltip_content\":\"I am a tooltip\",\"space_mobile\":{\"unit\":\"px\",\"size\":50,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"71efe6a0\",\"elType\":\"widget\",\"settings\":{\"social_icon_list\":[{\"social\":\"fa fa-twitter\",\"_id\":\"4818363\",\"link\":{\"url\":\"https:\\/\\/twitter.com\\/\",\"is_external\":\"true\",\"nofollow\":\"on\",\"custom_attributes\":\"\"},\"social_icon\":{\"value\":\"fab fa-twitter\",\"library\":\"fa-brands\"},\"item_icon_color\":\"default\",\"item_icon_primary_color\":\"\",\"item_icon_secondary_color\":\"\",\"__fa4_migrated\":{\"social_icon\":true}}],\"icon_color\":\"custom\",\"icon_primary_color\":\"#ffffff\",\"icon_secondary_color\":\"#54595f\",\"icon_size\":{\"unit\":\"px\",\"size\":22},\"icon_padding\":{\"unit\":\"em\",\"size\":0.5},\"icon_spacing\":{\"unit\":\"px\",\"size\":\"32\"},\"hover_primary_color\":\"rgba(255,255,255,0)\",\"hover_secondary_color\":\"#ffffff\",\"hover_animation\":\"grow\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":\"\"},\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"image_border_border\":\"solid\",\"image_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"image_border_color\":\"#000000\",\"align\":\"left\",\"_z_index\":9,\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"05\",\"isLinked\":false},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"social-icons\"},{\"id\":\"570205c\",\"elType\":\"widget\",\"settings\":{\"title\":\"\\u00a9 NikkiJames.net<br \\/>\\nBookNikkiJames@gmail.com<br \\/>Design by <a href=https:\\/\\/StickySites.ch target=new>StickySites.ch<\\/a>\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1},\"typography_font_weight\":\"300\",\"align\":\"center\",\"align_mobile\":\"center\",\"header_size\":\"p\",\"_margin\":{\"unit\":\"px\",\"top\":\"-80\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"tooltip_content\":\"I am a tooltip\",\"typography_font_family\":\"Lato\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"-78\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"05\",\"right\":\"05\",\"bottom\":\"05\",\"left\":\"05\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"05\",\"right\":\"0\",\"bottom\":\"5\",\"left\":\"15\",\"isLinked\":false},\"typography_line_height\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875,\"sizes\":[]},\"_border_border\":\"solid\",\"_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"_border_color\":\"#ffffff\",\"_background_background\":\"classic\",\"_background_color\":\"rgba(0,0,0,0.35)\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":true},{\"id\":\"b56fa8b\",\"elType\":\"column\",\"settings\":{\"_column_size\":50,\"_inline_size\":null,\"content_position\":\"bottom\",\"margin\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"content_position_mobile\":\"top\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"7cd071dd\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"booking\",\"tooltip_content\":\"I am a tooltip\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"3534b3c3\",\"elType\":\"widget\",\"settings\":{\"title\":\"Book Now\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"em\",\"size\":5},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":2},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_line_height\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625},\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":\"1.2\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"300\",\"tooltip_content\":\"I am a tooltip\",\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3},\"typography_font_style\":\"italic\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"2\"},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":-1,\"vertical\":1,\"blur\":0,\"color\":\"#000000\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"46e3c7a9\",\"elType\":\"widget\",\"settings\":{\"form_name\":\"New Form\",\"form_fields\":[{\"_id\":\"name\",\"field_type\":\"text\",\"field_label\":\"\",\"placeholder\":\"First name*\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"name\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"last\",\"field_type\":\"text\",\"field_label\":\"\",\"placeholder\":\"Last Name*\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"last\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"email\",\"field_type\":\"email\",\"required\":\"true\",\"field_label\":\"\",\"placeholder\":\"Email*\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"email\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_2\",\"field_type\":\"tel\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Tel\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_2\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_4\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em;font-family:Lato;color:#ffffff\\\"><u>Booking details<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_4\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"date\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Date\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"date\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_6\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Time [eg 9:00pm]\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_6\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_7\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Time together\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_7\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_8\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Place\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_8\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"message\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Other comments\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":2,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"message\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_9\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em;font-family:Lato;color:#ffffff\\\"><br \\/><u>Screening & References<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_9\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_10\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Preferred 411 or LinkedIn account\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_10\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"96cb7ef\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Reference #1: Contact information from another meeting\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"96cb7ef\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"bd1bf55\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Reference #2: Contact information from another meeting\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"bd1bf55\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"8c29381\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Work: Website, Email, Phone #\",\"width\":\"66\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"8c29381\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"969c485\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Age & Race\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"969c485\",\"recaptcha_badge\":\"bottomright\"}],\"mark_required\":\"yes\",\"button_text\":\"SEND BOOKING\",\"button_size\":\"md\",\"button_icon_align\":\"right\",\"button_icon_indent\":{\"unit\":\"px\",\"size\":12},\"email_content\":\"[all-fields]\",\"email_content_2\":\"[all-fields]\",\"success_message\":\"<center><p style=\\\"background-color:white;\\\"><strong>The form was sent successfully!<\\/strong><\\/p><\\/center>\",\"error_message\":\"An errors occurred.\",\"required_field_message\":\"This field is required.\",\"invalid_message\":\"There\'s something wrong. The form is invalid.\",\"row_gap\":{\"unit\":\"px\",\"size\":13},\"label_color\":\"#ffffff\",\"mark_required_color\":\"#ffffff\",\"label_typography_typography\":\"custom\",\"label_typography_font_size\":{\"unit\":\"em\",\"size\":1},\"field_text_color\":\"#ffffff\",\"field_typography_typography\":\"custom\",\"field_typography_font_size\":{\"unit\":\"em\",\"size\":1},\"field_border_color\":\"#ffffff\",\"button_background_color\":\"rgba(0,0,0,0.3)\",\"button_text_color\":\"#ffffff\",\"button_typography_typography\":\"custom\",\"button_typography_text_transform\":\"uppercase\",\"button_background_hover_color\":\"#000000\",\"button_hover_color\":\"#ffffff\",\"field_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"form_metadata\":[\"date\",\"time\",\"page_url\",\"user_agent\",\"remote_ip\"],\"email_content_type\":\"plain\",\"custom_messages\":\"yes\",\"label_typography_font_weight\":\"300\",\"label_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1},\"button_border_border\":\"solid\",\"button_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"button_border_color\":\"#ffffff\",\"_background_background\":\"classic\",\"button_align_tablet\":\"start\",\"button_icon\":\"fa fa-send\",\"label_typography_font_family\":\"Lato\",\"field_typography_font_family\":\"Lato\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_typography_font_family\":\"Lato\",\"button_hover_border_color\":\"#ffffff\",\"tooltip_content\":\"I am a tooltip\",\"selected_button_icon\":{\"value\":\"fas fa-paper-plane\",\"library\":\"fa-solid\"},\"field_background_color\":\"rgba(0,0,0,0.3)\",\"button_hover_animation\":\"grow\",\"__fa4_migrated\":{\"selected_button_icon\":true},\"field_typography_font_weight\":\"300\",\"button_typography_font_size\":{\"unit\":\"px\",\"size\":16,\"sizes\":[]},\"button_typography_font_weight\":\"bold\",\"mailchimp_fields_map\":[],\"drip_fields_map\":[],\"activecampaign_fields_map\":[],\"getresponse_fields_map\":[],\"convertkit_fields_map\":[],\"mailerlite_fields_map\":[],\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"form\"},{\"id\":\"35f372d6\",\"elType\":\"widget\",\"settings\":{\"align_mobile\":\"center\",\"text\":\"Divider\",\"color\":\"#ffffff\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"hide_desktop\":\"hidden-desktop\",\"hide_tablet\":\"hidden-tablet\",\"tooltip_content\":\"I am a tooltip\",\"icon\":{\"value\":\"fas fa-star\",\"library\":\"fa-solid\"},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"divider\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false}]");
INSERT INTO `wp_522243_postmeta` VALUES("260", "308", "_elementor_controls_usage", "a:13:{s:6:\"spacer\";a:3:{s:5:\"count\";i:8;s:15:\"control_percent\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:14:\"section_spacer\";a:3:{s:5:\"space\";i:6;s:12:\"space_mobile\";i:3;s:12:\"space_tablet\";i:3;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:1:{s:7:\"_margin\";i:3;}s:19:\"_section_background\";a:14:{s:22:\"_background_background\";i:2;s:17:\"_background_image\";i:2;s:24:\"_background_image_tablet\";i:2;s:20:\"_background_position\";i:2;s:16:\"_background_size\";i:2;s:16:\"_background_ypos\";i:2;s:24:\"_background_image_mobile\";i:2;s:27:\"_background_position_mobile\";i:2;s:22:\"_background_attachment\";i:2;s:25:\"_background_repeat_mobile\";i:2;s:23:\"_background_size_mobile\";i:2;s:27:\"_background_position_tablet\";i:2;s:25:\"_background_repeat_tablet\";i:2;s:23:\"_background_size_tablet\";i:2;}s:15:\"_section_border\";a:2:{s:14:\"_border_radius\";i:2;s:21:\"_border_radius_tablet\";i:1;}}}}s:6:\"column\";a:3:{s:5:\"count\";i:14;s:15:\"control_percent\";i:0;s:8:\"controls\";a:3:{s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:10;s:13:\"margin_mobile\";i:6;s:14:\"padding_tablet\";i:3;s:6:\"margin\";i:4;s:13:\"margin_tablet\";i:3;s:14:\"padding_mobile\";i:2;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:2;}s:15:\"section_effects\";a:1:{s:9:\"animation\";i:3;}}s:6:\"layout\";a:1:{s:6:\"layout\";a:5:{s:16:\"content_position\";i:7;s:21:\"space_between_widgets\";i:5;s:12:\"_inline_size\";i:7;s:19:\"_inline_size_tablet\";i:2;s:23:\"content_position_mobile\";i:1;}}s:5:\"style\";a:2:{s:14:\"section_border\";a:4:{s:12:\"border_width\";i:3;s:12:\"border_color\";i:3;s:13:\"border_radius\";i:2;s:13:\"border_border\";i:1;}s:13:\"section_style\";a:3:{s:16:\"background_color\";i:2;s:21:\"background_background\";i:2;s:15:\"background_size\";i:2;}}}}s:7:\"heading\";a:3:{s:5:\"count\";i:7;s:15:\"control_percent\";i:8;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:5:{s:5:\"title\";i:7;s:11:\"header_size\";i:6;s:5:\"align\";i:7;s:4:\"link\";i:2;s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:15:{s:11:\"title_color\";i:7;s:21:\"typography_typography\";i:7;s:22:\"typography_font_family\";i:7;s:20:\"typography_font_size\";i:7;s:27:\"typography_font_size_mobile\";i:5;s:22:\"typography_font_weight\";i:7;s:29:\"typography_line_height_mobile\";i:3;s:22:\"typography_line_height\";i:4;s:27:\"typography_font_size_tablet\";i:3;s:25:\"typography_letter_spacing\";i:5;s:28:\"text_shadow_text_shadow_type\";i:2;s:23:\"text_shadow_text_shadow\";i:3;s:32:\"typography_letter_spacing_mobile\";i:1;s:25:\"typography_text_transform\";i:5;s:21:\"typography_font_style\";i:2;}}s:8:\"advanced\";a:5:{s:15:\"section_effects\";a:4:{s:10:\"_animation\";i:4;s:16:\"_animation_delay\";i:3;s:6:\"sticky\";i:1;s:13:\"sticky_parent\";i:1;}s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:6;s:14:\"_margin_mobile\";i:6;s:8:\"_padding\";i:3;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:3;s:17:\"_background_color\";i:3;}s:15:\"_section_border\";a:4:{s:14:\"_border_radius\";i:2;s:14:\"_border_border\";i:1;s:13:\"_border_width\";i:1;s:13:\"_border_color\";i:1;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:2;}}}}s:11:\"text-editor\";a:3:{s:5:\"count\";i:4;s:15:\"control_percent\";i:5;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:4;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:12:{s:5:\"align\";i:4;s:12:\"align_mobile\";i:2;s:10:\"text_color\";i:3;s:21:\"typography_typography\";i:3;s:22:\"typography_font_family\";i:3;s:20:\"typography_font_size\";i:3;s:22:\"typography_line_height\";i:2;s:25:\"typography_letter_spacing\";i:1;s:27:\"typography_font_size_tablet\";i:2;s:29:\"typography_line_height_tablet\";i:2;s:22:\"typography_font_weight\";i:3;s:27:\"typography_font_size_mobile\";i:1;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:7:{s:7:\"_margin\";i:4;s:14:\"_margin_mobile\";i:3;s:8:\"_padding\";i:3;s:14:\"_margin_tablet\";i:2;s:15:\"_padding_tablet\";i:2;s:12:\"_css_classes\";i:1;s:15:\"_padding_mobile\";i:1;}s:15:\"section_effects\";a:3:{s:10:\"_animation\";i:1;s:18:\"animation_duration\";i:1;s:16:\"_animation_delay\";i:1;}s:17:\"_section_position\";a:7:{s:9:\"_position\";i:1;s:16:\"_offset_x_tablet\";i:1;s:21:\"_offset_orientation_v\";i:1;s:13:\"_offset_y_end\";i:1;s:20:\"_offset_y_end_mobile\";i:1;s:16:\"_offset_x_mobile\";i:1;s:13:\"_offset_x_end\";i:1;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:1;}}}}s:7:\"section\";a:3:{s:5:\"count\";i:9;s:15:\"control_percent\";i:5;s:8:\"controls\";a:3:{s:5:\"style\";a:4:{s:18:\"section_background\";a:21:{s:21:\"background_background\";i:5;s:16:\"background_image\";i:2;s:19:\"background_position\";i:2;s:17:\"background_repeat\";i:2;s:15:\"background_size\";i:2;s:15:\"background_ypos\";i:1;s:19:\"background_bg_width\";i:1;s:21:\"background_video_link\";i:1;s:22:\"background_video_start\";i:1;s:20:\"background_video_end\";i:1;s:22:\"background_size_mobile\";i:1;s:23:\"background_image_mobile\";i:2;s:26:\"background_position_mobile\";i:2;s:21:\"background_attachment\";i:2;s:24:\"background_repeat_mobile\";i:1;s:23:\"background_image_tablet\";i:2;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:16:\"background_color\";i:3;s:22:\"background_xpos_mobile\";i:1;s:26:\"background_position_tablet\";i:1;}s:26:\"section_background_overlay\";a:14:{s:29:\"background_overlay_background\";i:5;s:24:\"background_overlay_color\";i:2;s:26:\"background_overlay_opacity\";i:4;s:29:\"background_overlay_color_stop\";i:1;s:26:\"background_overlay_color_b\";i:1;s:33:\"background_overlay_gradient_angle\";i:1;s:32:\"background_overlay_gradient_type\";i:1;s:24:\"background_overlay_image\";i:2;s:25:\"background_overlay_repeat\";i:2;s:23:\"background_overlay_size\";i:2;s:27:\"background_overlay_bg_width\";i:2;s:27:\"background_overlay_position\";i:2;s:20:\"css_filters_contrast\";i:2;s:20:\"css_filters_saturate\";i:2;}s:14:\"section_border\";a:4:{s:12:\"border_width\";i:1;s:12:\"border_color\";i:1;s:13:\"border_radius\";i:3;s:21:\"box_shadow_box_shadow\";i:1;}s:21:\"section_shape_divider\";a:7:{s:23:\"shape_divider_top_color\";i:3;s:24:\"shape_divider_top_height\";i:3;s:20:\"shape_divider_bottom\";i:2;s:26:\"shape_divider_bottom_color\";i:2;s:26:\"shape_divider_bottom_width\";i:2;s:27:\"shape_divider_bottom_height\";i:2;s:17:\"shape_divider_top\";i:1;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:6;s:14:\"padding_tablet\";i:7;s:14:\"padding_mobile\";i:8;s:6:\"margin\";i:4;s:13:\"margin_mobile\";i:3;s:7:\"z_index\";i:1;}s:19:\"_section_responsive\";a:1:{s:20:\"reverse_order_mobile\";i:4;}}s:6:\"layout\";a:2:{s:14:\"section_layout\";a:7:{s:6:\"height\";i:1;s:13:\"custom_height\";i:1;s:15:\"column_position\";i:1;s:20:\"custom_height_tablet\";i:1;s:20:\"custom_height_mobile\";i:1;s:13:\"content_width\";i:6;s:6:\"layout\";i:2;}s:17:\"section_structure\";a:1:{s:9:\"structure\";i:5;}}}}s:6:\"button\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:10;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_button\";a:4:{s:4:\"text\";i:1;s:5:\"align\";i:1;s:4:\"size\";i:1;s:4:\"link\";i:1;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:15:{s:21:\"typography_typography\";i:1;s:22:\"typography_font_family\";i:1;s:20:\"typography_font_size\";i:1;s:22:\"typography_font_weight\";i:1;s:25:\"typography_text_transform\";i:1;s:25:\"typography_letter_spacing\";i:1;s:17:\"button_text_color\";i:1;s:16:\"background_color\";i:1;s:11:\"hover_color\";i:1;s:29:\"button_background_hover_color\";i:1;s:12:\"border_width\";i:1;s:12:\"border_color\";i:1;s:13:\"border_radius\";i:1;s:22:\"typography_line_height\";i:1;s:15:\"hover_animation\";i:1;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:1;s:14:\"_margin_mobile\";i:1;}s:15:\"section_effects\";a:2:{s:10:\"_animation\";i:1;s:16:\"_animation_delay\";i:1;}s:19:\"_section_background\";a:5:{s:22:\"_background_background\";i:1;s:20:\"_background_position\";i:1;s:18:\"_background_repeat\";i:1;s:16:\"_background_size\";i:1;s:20:\"_background_bg_width\";i:1;}}}}s:14:\"media-carousel\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:10;s:8:\"controls\";a:3:{s:7:\"content\";a:2:{s:14:\"section_slides\";a:10:{s:6:\"slides\";i:1;s:15:\"slides_per_view\";i:1;s:22:\"slides_per_view_tablet\";i:1;s:22:\"slides_per_view_mobile\";i:1;s:6:\"height\";i:1;s:13:\"height_tablet\";i:1;s:13:\"height_mobile\";i:1;s:6:\"effect\";i:1;s:15:\"centered_slides\";i:1;s:16:\"slides_to_scroll\";i:1;}s:26:\"section_additional_options\";a:6:{s:5:\"speed\";i:1;s:4:\"icon\";i:1;s:11:\"show_arrows\";i:1;s:14:\"autoplay_speed\";i:1;s:15:\"image_size_size\";i:1;s:20:\"pause_on_interaction\";i:1;}}s:5:\"style\";a:2:{s:18:\"section_navigation\";a:3:{s:12:\"arrows_color\";i:1;s:14:\"play_icon_size\";i:1;s:11:\"arrows_size\";i:1;}s:20:\"section_slides_style\";a:6:{s:13:\"space_between\";i:1;s:22:\"slide_background_color\";i:1;s:17:\"slide_border_size\";i:1;s:19:\"slide_border_radius\";i:1;s:18:\"slide_border_color\";i:1;s:13:\"slide_padding\";i:1;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:2:{s:12:\"_css_classes\";i:1;s:8:\"_padding\";i:1;}s:15:\"section_effects\";a:1:{s:10:\"_animation\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:1;s:17:\"_background_color\";i:1;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}}}}s:13:\"gallery-extra\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:4;s:8:\"controls\";a:2:{s:7:\"content\";a:2:{s:15:\"section_gallery\";a:2:{s:12:\"gallery_type\";i:1;s:7:\"gallery\";i:1;}s:24:\"section_gallery_settings\";a:5:{s:7:\"columns\";i:1;s:14:\"columns_tablet\";i:1;s:14:\"columns_mobile\";i:1;s:13:\"open_lightbox\";i:1;s:23:\"gallery_display_caption\";i:1;}}s:5:\"style\";a:3:{s:22:\"section_gallery_layout\";a:5:{s:11:\"image_align\";i:1;s:20:\"image_vertical_align\";i:1;s:24:\"image_horizontal_spacing\";i:1;s:22:\"image_vertical_spacing\";i:1;s:8:\"overflow\";i:1;}s:22:\"section_gallery_images\";a:3:{s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:21:\"section_hover_effects\";a:3:{s:27:\"image_transition_transition\";i:1;s:23:\"image_transition_easing\";i:1;s:17:\"image_scale_hover\";i:1;}}}}s:10:\"price-list\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:8;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:2;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:16:{s:13:\"heading_color\";i:2;s:29:\"heading_typography_typography\";i:2;s:30:\"heading_typography_font_family\";i:2;s:17:\"description_color\";i:2;s:33:\"description_typography_typography\";i:2;s:34:\"description_typography_font_family\";i:2;s:39:\"description_typography_font_size_tablet\";i:2;s:34:\"description_typography_line_height\";i:2;s:41:\"description_typography_line_height_tablet\";i:2;s:17:\"separator_spacing\";i:2;s:28:\"heading_typography_font_size\";i:2;s:30:\"heading_typography_font_weight\";i:2;s:29:\"heading_typography_font_style\";i:1;s:32:\"description_typography_font_size\";i:2;s:34:\"description_typography_font_weight\";i:2;s:33:\"description_typography_font_style\";i:2;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:2;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:3:{s:7:\"_margin\";i:2;s:8:\"_padding\";i:2;s:14:\"_margin_mobile\";i:2;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:2;s:17:\"_background_color\";i:2;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:2;}}}}s:12:\"social-icons\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:7;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:19:\"section_social_icon\";a:2:{s:16:\"social_icon_list\";i:1;s:5:\"align\";i:1;}}s:5:\"style\";a:2:{s:20:\"section_social_style\";a:9:{s:10:\"icon_color\";i:1;s:18:\"icon_primary_color\";i:1;s:20:\"icon_secondary_color\";i:1;s:9:\"icon_size\";i:1;s:12:\"icon_padding\";i:1;s:12:\"icon_spacing\";i:1;s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:20:\"section_social_hover\";a:3:{s:19:\"hover_primary_color\";i:1;s:21:\"hover_secondary_color\";i:1;s:15:\"hover_animation\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:1;s:14:\"_margin_tablet\";i:1;s:8:\"_z_index\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:11:\"menu-anchor\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:0;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:14:\"section_anchor\";a:1:{s:6:\"anchor\";i:1;}}}}s:4:\"form\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:10;s:8:\"controls\";a:3:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:1;s:13:\"mark_required\";i:1;}s:21:\"section_submit_button\";a:6:{s:11:\"button_text\";i:1;s:11:\"button_size\";i:1;s:17:\"button_icon_align\";i:1;s:18:\"button_icon_indent\";i:1;s:19:\"button_align_tablet\";i:1;s:20:\"selected_button_icon\";i:1;}s:20:\"section_form_options\";a:3:{s:15:\"success_message\";i:1;s:13:\"error_message\";i:1;s:15:\"custom_messages\";i:1;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:1;s:18:\"email_content_type\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:8:{s:7:\"row_gap\";i:1;s:11:\"label_color\";i:1;s:19:\"mark_required_color\";i:1;s:27:\"label_typography_typography\";i:1;s:26:\"label_typography_font_size\";i:1;s:28:\"label_typography_font_weight\";i:1;s:33:\"label_typography_font_size_mobile\";i:1;s:28:\"label_typography_font_family\";i:1;}s:19:\"section_field_style\";a:8:{s:16:\"field_text_color\";i:1;s:27:\"field_typography_typography\";i:1;s:26:\"field_typography_font_size\";i:1;s:18:\"field_border_color\";i:1;s:19:\"field_border_radius\";i:1;s:28:\"field_typography_font_family\";i:1;s:22:\"field_background_color\";i:1;s:28:\"field_typography_font_weight\";i:1;}s:20:\"section_button_style\";a:15:{s:23:\"button_background_color\";i:1;s:17:\"button_text_color\";i:1;s:28:\"button_typography_typography\";i:1;s:32:\"button_typography_text_transform\";i:1;s:29:\"button_background_hover_color\";i:1;s:18:\"button_hover_color\";i:1;s:20:\"button_border_radius\";i:1;s:20:\"button_border_border\";i:1;s:19:\"button_border_width\";i:1;s:19:\"button_border_color\";i:1;s:29:\"button_typography_font_family\";i:1;s:25:\"button_hover_border_color\";i:1;s:22:\"button_hover_animation\";i:1;s:27:\"button_typography_font_size\";i:1;s:29:\"button_typography_font_weight\";i:1;}}s:8:\"advanced\";a:2:{s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:1;s:8:\"_padding\";i:1;}}}}s:7:\"divider\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:15:\"section_divider\";a:1:{s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:21:\"section_divider_style\";a:1:{s:5:\"color\";i:1;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:1:{s:14:\"_margin_mobile\";i:1;}s:19:\"_section_responsive\";a:2:{s:12:\"hide_desktop\";i:1;s:11:\"hide_tablet\";i:1;}}}}}");
INSERT INTO `wp_522243_postmeta` VALUES("261", "287", "_elementor_data", "[{\"id\":\"281e8dde\",\"elType\":\"section\",\"settings\":{\"background_background\":\"classic\",\"background_image\":{\"id\":345,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-23.jpg\"},\"background_position\":\"top center\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"background_overlay_background\":\"gradient\",\"background_overlay_color\":\"rgba(255,255,255,0)\",\"padding\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"60\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"15\",\"bottom\":\"80\",\"left\":\"15\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"025\",\"right\":\"15\",\"bottom\":\"50\",\"left\":\"15\",\"isLinked\":\"\"},\"height\":\"min-height\",\"custom_height\":{\"unit\":\"vh\",\"size\":160},\"background_ypos\":{\"unit\":\"px\",\"size\":-165},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":1},\"column_position\":\"stretch\",\"structure\":\"20\",\"background_bg_width\":{\"unit\":\"%\",\"size\":\"120\"},\"background_video_link\":\"https:\\/\\/www.youtube.com\\/watch?v=dxhbld4paug\",\"background_video_start\":\"330\",\"background_video_end\":\"343\",\"background_overlay_color_stop\":{\"unit\":\"%\",\"size\":\"69\"},\"background_overlay_color_b\":\"rgba(255,255,255,0.68)\",\"background_overlay_gradient_angle\":{\"unit\":\"deg\",\"size\":\"60\"},\"border_width\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"30\",\"bottom\":\"30\",\"left\":\"30\",\"isLinked\":\"1\"},\"border_color\":\"#ffffff\",\"custom_height_tablet\":{\"unit\":\"vh\",\"size\":90},\"background_size_mobile\":\"cover\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"fa94338\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"reverse_order_mobile\":\"reverse-mobile\",\"background_image_mobile\":{\"id\":345,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-23.jpg\"},\"custom_height_mobile\":{\"unit\":\"px\",\"size\":650,\"sizes\":[]},\"background_position_mobile\":\"center right\",\"background_attachment\":\"scroll\",\"background_repeat_mobile\":\"no-repeat\",\"background_overlay_gradient_type\":\"radial\",\"background_image_tablet\":{\"id\":291,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_2.jpg\"},\"background_repeat_tablet\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"background_motion_fx_motion_fx_scrolling\":\"yes\",\"background_motion_fx_translateY_effect\":\"yes\",\"background_motion_fx_translateY_speed\":{\"unit\":\"px\",\"size\":3,\"sizes\":[]},\"background_motion_fx_translateX_speed\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]}},\"elements\":[{\"id\":\"76405347\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"padding\":{\"unit\":\"px\",\"top\":\"60\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"content_position\":\"top\"},\"elements\":[{\"id\":\"41ffe4b7\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":\"23\"},\"space_mobile\":{\"unit\":\"px\",\"size\":\"10\"},\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"42136e0\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":\"23\"},\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"10fefb9e\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":\"197\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"5\",\"left\":\"0\",\"isLinked\":\"\"},\"space_tablet\":{\"unit\":\"px\",\"size\":\"10\"},\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"spacer\"}],\"isInner\":\"\"},{\"id\":\"c87e0a3\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\"},\"elements\":[{\"id\":\"72a7db18\",\"elType\":\"widget\",\"settings\":{\"title\":\"Nikki\",\"header_size\":\"h1\",\"align\":\"right\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"em\",\"size\":5},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":2.70000000000000017763568394002504646778106689453125},\"typography_font_weight\":\"600\",\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":\"1.2\"},\"_animation\":\"fadeInRight\",\"_animation_delay\":\"300\",\"typography_line_height\":{\"unit\":\"em\",\"size\":\"1.4\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":4},\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"2\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"-20\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":-1,\"vertical\":1,\"blur\":0,\"color\":\"#000000\"},\"tooltip_content\":\"I am a tooltip\",\"typography_letter_spacing_mobile\":{\"unit\":\"px\",\"size\":-0.59999999999999997779553950749686919152736663818359375,\"sizes\":[]},\"sticky\":\"top\",\"sticky_parent\":\"yes\"},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"2052f7d3\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"padding\":{\"unit\":\"px\",\"top\":\"120\",\"right\":\"0\",\"bottom\":\"120\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"em\",\"top\":\"4\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"background_background\":\"classic\",\"background_color\":\"#f4f4f4\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":294,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/hex-texture-custom-cc0.jpg\"},\"background_overlay_repeat\":\"repeat\",\"background_overlay_size\":\"initial\",\"background_overlay_bg_width\":{\"unit\":\"%\",\"size\":\"40\"},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":\"0.38\"},\"shape_divider_top_color\":\"#ffffff\",\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":\"26\"},\"background_overlay_position\":\"top center\",\"css_filters_contrast\":{\"unit\":\"px\",\"size\":\"177\"},\"css_filters_saturate\":{\"unit\":\"px\",\"size\":\"0\"},\"shape_divider_bottom\":\"zigzag\",\"shape_divider_bottom_color\":\"#ffffff\",\"shape_divider_bottom_width\":{\"unit\":\"%\",\"size\":\"100\"},\"shape_divider_bottom_height\":{\"unit\":\"px\",\"size\":\"23\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"4cca42d\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}]},\"elements\":[{\"id\":\"2da35507\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"100\",\"border_width\":{\"unit\":\"px\",\"top\":\"2\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":\"1\"},\"border_color\":\"#d3cfc6\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"background_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"30\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"40\",\"left\":\"0\",\"isLinked\":\"\"},\"animation\":\"fadeInUp\"},\"elements\":[{\"id\":\"19646a4\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"structure\":\"20\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"50\",\"left\":\"0\",\"isLinked\":\"\"},\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"7f38d69\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}]},\"elements\":[{\"id\":\"a9ecd6e\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"content_position\":\"center\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"60\",\"bottom\":\"0\",\"left\":\"60\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"40\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":\"\"}},\"elements\":[{\"id\":\"3add39b6\",\"elType\":\"widget\",\"settings\":{\"title\":\"Get To Know Me\",\"align\":\"center\",\"title_color\":\"#080808\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"px\",\"size\":\"35\"},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":\"35\"},\"typography_font_weight\":\"bold\",\"_animation\":\"fadeInUp\",\"typography_text_transform\":\"uppercase\",\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"634994b5\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>I do hope you enjoy my website and that it gives you a flavour of who I am and what excites me.<\\/p><p>I am educated and intelligent, call Sydney home and love living here. I\'m fortunate to have been blessed with breathtaking 34D-24-34 curves on a toned, tanned, 5\'9\\\" dancer\'s frame. I am a perfect size 8 with fashionably short dark hair and hazel eyes. My soft lips and coy smile promise much and deliver more...<\\/p><p>I enjoy passion, fun, and intimacy in equal measure, and like to think this shines through in all my encounters. My primary desire is to help you feel relaxed, refreshed, reinvigorated ~ and to find the most enjoyable path to that result. Of one thing you may be absolutely certain ~ when our encounter ends you will find yourself happier and satiated.<\\/p><p>We\'re both adults and we both know what this is about.<br \\/>You\'re reading this because you want intimacy without complication. Intense pleasure without the burden of guilt.<br \\/>You want the beautiful woman you\'ve desired in magazines, or lingerie and swimsuit catalogues. The girlfriend you want for a night, or a weekend, or a few days. I\'m the forbidden fruit you can taste. It\'s who I am. It\'s what I do. It\'s a gift only a woman like me can give.<\\/p><p>I have a primary income which meets my needs, so I entertain because I choose to.<br \\/>It is something I genuinely enjoy doing.<br \\/>I do what I do because I enjoy uncomplicated intimacy as much as you do.<br \\/>Sex doesn\'t scare me - indeed, quite the opposite, it excites me.<\\/p>\",\"align\":\"center\",\"text_color\":\"#080808\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"rem\",\"size\":1.100000000000000088817841970012523233890533447265625},\"typography_line_height\":{\"unit\":\"em\",\"size\":1.399999999999999911182158029987476766109466552734375},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"45\",\"bottom\":\"0\",\"left\":\"45\",\"isLinked\":\"\"},\"typography_font_size_tablet\":{\"unit\":\"rem\",\"size\":\"0.8\"},\"typography_line_height_tablet\":{\"unit\":\"em\",\"size\":\"1.6\"},\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"_css_classes\":\"bio\",\"tooltip_content\":\"I am a tooltip\",\"typography_font_weight\":\"300\",\"align_mobile\":\"left\"},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"57629296\",\"elType\":\"widget\",\"settings\":{\"text\":\"Book Me\",\"align\":\"center\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":16},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"4\"},\"button_text_color\":\"#000000\",\"background_color\":\"rgba(255,255,255,0)\",\"hover_color\":\"#282828\",\"button_background_hover_color\":\"rgba(255,255,255,0)\",\"border_width\":{\"unit\":\"px\",\"top\":\"4\",\"right\":\"4\",\"bottom\":\"4\",\"left\":\"4\",\"isLinked\":\"1\"},\"border_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"60\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"700\",\"size\":\"md\",\"typography_line_height\":{\"unit\":\"em\",\"size\":\"2.5\"},\"hover_animation\":\"shrink\",\"_background_background\":\"classic\",\"_background_position\":\"center center\",\"_background_repeat\":\"no-repeat\",\"_background_size\":\"initial\",\"_background_bg_width\":{\"unit\":\"px\",\"size\":\"205\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"hide_mobile\":\"hidden-phone\"},\"elements\":[],\"widgetType\":\"button\"}],\"isInner\":\"1\"},{\"id\":\"246ad8ec\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"content_position\":\"center\"},\"elements\":[{\"id\":\"773c9599\",\"elType\":\"widget\",\"settings\":{\"slides\":[{\"image\":{\"id\":360,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-08.jpg\"},\"_id\":\"e0b6430\",\"type\":\"image\",\"image_link_to_type\":\"\",\"image_link_to\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"video\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"}},{\"image\":{\"id\":356,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-12.jpg\"},\"_id\":\"c658c7d\",\"type\":\"image\",\"image_link_to_type\":\"\",\"image_link_to\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"video\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"}},{\"image\":{\"id\":364,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-04.jpg\"},\"type\":\"image\",\"image_link_to_type\":\"\",\"image_link_to\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"video\":{\"url\":\"\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"26d19b5\"}],\"slides_per_view\":\"1\",\"slides_per_view_tablet\":\"1\",\"slides_per_view_mobile\":\"1\",\"height\":{\"unit\":\"vh\",\"size\":100},\"height_tablet\":{\"unit\":\"vh\",\"size\":80},\"height_mobile\":{\"unit\":\"px\",\"size\":550},\"arrows_color\":\"#ffffff\",\"play_icon_size\":{\"unit\":\"px\",\"size\":\"20\"},\"_css_classes\":\"envato-kit-116-slider\",\"_animation\":\"fadeIn\",\"effect\":\"fade\",\"centered_slides\":\"yes\",\"slides_to_scroll\":\"1\",\"speed\":800,\"icon\":\"plus-circle\",\"space_between\":{\"unit\":\"px\",\"size\":\"30\"},\"slide_background_color\":\"#d3cfc6\",\"slide_border_size\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"30\",\"bottom\":\"30\",\"left\":\"30\",\"isLinked\":\"1\"},\"slide_border_radius\":{\"unit\":\"px\",\"size\":\"0\"},\"slide_border_color\":\"#ffffff\",\"slide_padding\":{\"unit\":\"px\",\"top\":\"4\",\"right\":\"4\",\"bottom\":\"4\",\"left\":\"4\",\"isLinked\":\"1\"},\"arrows_size\":{\"unit\":\"px\",\"size\":\"40\"},\"_padding\":{\"unit\":\"em\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_color\":\"#ffffff\",\"show_arrows\":\"\",\"autoplay_speed\":3000,\"image_size_size\":\"medium_large\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"pause_on_interaction\":\"\"},\"elements\":[],\"widgetType\":\"media-carousel\"},{\"id\":\"1509193\",\"elType\":\"widget\",\"settings\":{\"text\":\"Book Me\",\"align\":\"center\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":16},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"4\"},\"button_text_color\":\"#000000\",\"background_color\":\"rgba(255,255,255,0)\",\"hover_color\":\"#282828\",\"button_background_hover_color\":\"#FFFFFF\",\"border_width\":{\"unit\":\"px\",\"top\":\"4\",\"right\":\"4\",\"bottom\":\"4\",\"left\":\"4\",\"isLinked\":\"1\"},\"border_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"60\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"700\",\"size\":\"md\",\"typography_line_height\":{\"unit\":\"em\",\"size\":\"2.5\"},\"hover_animation\":\"shrink\",\"_background_background\":\"classic\",\"_background_position\":\"center center\",\"_background_repeat\":\"no-repeat\",\"_background_size\":\"initial\",\"_background_bg_width\":{\"unit\":\"px\",\"size\":\"205\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"align_mobile\":\"center\",\"selected_icon\":{\"value\":\"far fa-calendar-check\",\"library\":\"fa-regular\"},\"hide_desktop\":\"hidden-desktop\",\"hide_tablet\":\"hidden-tablet\"},\"elements\":[],\"widgetType\":\"button\"}],\"isInner\":\"1\"}],\"isInner\":\"1\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"74644325\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"120\",\"right\":\"60\",\"bottom\":\"0\",\"left\":\"60\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"15\",\"bottom\":\"80\",\"left\":\"15\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"50\",\"left\":\"15\",\"isLinked\":\"\"},\"background_background\":\"classic\",\"background_color\":\"#f4f4f4\",\"background_overlay_background\":\"classic\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":\"0.1\"},\"shape_divider_top\":\"zigzag\",\"shape_divider_top_color\":\"#f9f9f9\",\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":\"27\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"1add6b4\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}]},\"elements\":[{\"id\":\"6f5de728\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"space_between_widgets\":\"0\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"animation\":\"fadeInLeft\",\"_inline_size\":null},\"elements\":[{\"id\":\"86dc2e2\",\"elType\":\"widget\",\"settings\":{\"gallery\":[{\"id\":367,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-01.jpg\"},{\"id\":366,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-02.jpg\"},{\"id\":364,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-04.jpg\"},{\"id\":363,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-05.jpg\"},{\"id\":362,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-06.jpg\"},{\"id\":361,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-07.jpg\"},{\"id\":353,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-15.jpg\"},{\"id\":354,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-14.jpg\"},{\"id\":352,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-16.jpg\"},{\"id\":350,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-18.jpg\"},{\"id\":348,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-20.jpg\"},{\"id\":347,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-21.jpg\"},{\"id\":346,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-22.jpg\"},{\"id\":344,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-24.jpg\"},{\"id\":343,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-25.jpg\"},{\"id\":341,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-27.jpg\"}],\"galleries\":[{\"gallery_title\":\"New Gallery\",\"_id\":\"b25a264\",\"multiple_gallery\":[]}],\"order_by\":\"random\",\"lazyload\":\"\",\"columns_mobile\":2,\"gap_mobile\":{\"unit\":\"px\",\"size\":5,\"sizes\":[]},\"aspect_ratio\":\"1:1\",\"thumbnail_image_size\":\"full\",\"show_all_galleries_label\":\"All\"},\"elements\":[],\"widgetType\":\"gallery\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"b8e011e\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"padding\":{\"unit\":\"px\",\"top\":\"120\",\"right\":\"0\",\"bottom\":\"120\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"em\",\"top\":\"4\",\"right\":\"2\",\"bottom\":\"4\",\"left\":\"2\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"15\",\"bottom\":\"0\",\"left\":\"15\",\"isLinked\":\"\"},\"background_background\":\"classic\",\"background_color\":\"#f4f4f4\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":294,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/hex-texture-custom-cc0.jpg\"},\"background_overlay_repeat\":\"repeat\",\"background_overlay_size\":\"initial\",\"background_overlay_bg_width\":{\"unit\":\"%\",\"size\":\"40\"},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":\"0.38\"},\"shape_divider_top_color\":\"#ffffff\",\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":\"26\"},\"background_overlay_position\":\"top center\",\"css_filters_contrast\":{\"unit\":\"px\",\"size\":\"177\"},\"css_filters_saturate\":{\"unit\":\"px\",\"size\":\"0\"},\"shape_divider_bottom\":\"zigzag\",\"shape_divider_bottom_color\":\"#ffffff\",\"shape_divider_bottom_width\":{\"unit\":\"%\",\"size\":\"100\"},\"shape_divider_bottom_height\":{\"unit\":\"px\",\"size\":\"26\"},\"box_shadow_box_shadow\":{\"horizontal\":\"0\",\"vertical\":\"0\",\"blur\":\"11\",\"spread\":\"3\",\"color\":\"rgba(0,0,0,0.14)\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"cd1c841\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}]},\"elements\":[{\"id\":\"51ecbd76\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"100\",\"border_width\":{\"unit\":\"px\",\"top\":\"2\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":\"1\"},\"border_color\":\"#d3cfc6\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"background_color\":\"#ffffff\",\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"30\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"40\",\"left\":\"0\",\"isLinked\":\"\"},\"animation\":\"fadeInUp\"},\"elements\":[{\"id\":\"aa2c273\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"\"},\"structure\":\"20\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"60\",\"left\":\"0\",\"isLinked\":\"\"},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"3c9316f\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}]},\"elements\":[{\"id\":\"38a6b38b\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"49.957\",\"padding\":{\"unit\":\"em\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"content_position\":\"top\",\"space_between_widgets\":\"0\",\"background_background\":\"classic\",\"background_size\":\"cover\",\"_inline_size_tablet\":48,\"hide_mobile\":\"hidden-phone\"},\"elements\":[{\"id\":\"7f26972\",\"elType\":\"widget\",\"settings\":{\"image\":{\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-15.jpg\",\"id\":353},\"image_height\":{\"unit\":\"px\",\"size\":600,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"premium-image-scroll\"},{\"id\":\"404ccb6\",\"elType\":\"widget\",\"settings\":{\"tooltip_content\":\"I am a tooltip\",\"space_mobile\":{\"unit\":\"px\",\"size\":0,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"spacer\"}],\"isInner\":\"1\"},{\"id\":\"28d32eb4\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"50.043\",\"space_between_widgets\":\"0\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"_inline_size_tablet\":50},\"elements\":[{\"id\":\"327ba6df\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"One hour\",\"item_description\":\"\",\"price\":\"$600\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"54ba866\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"90 minutes\",\"item_description\":\"\",\"price\":\"$800\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"f7694ef\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Two hours\",\"item_description\":\"\",\"price\":\"$1000\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"4ebdb94\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Three hours\",\"item_description\":\"\",\"price\":\"$1400\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"8368410\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Four hours\",\"item_description\":\"\",\"price\":\"$1700\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"eda8edc\"},{\"title\":\"Overnight\",\"item_description\":\"12 hours with relaxation time\",\"price\":\"$3800\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"e94d71f\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Whole day\",\"item_description\":\"24 hours with relaxation time\",\"price\":\"$5500\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"1804ceb\"}],\"heading_color\":\"#000000\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_family\":\"Lato\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"row_gap\":{\"unit\":\"px\",\"size\":\"32\"},\"_padding\":{\"unit\":\"em\",\"top\":\"3\",\"right\":\"3\",\"bottom\":\"3\",\"left\":\"3\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"description_color\":\"#000000\",\"description_typography_typography\":\"custom\",\"description_typography_font_family\":\"Lato\",\"description_typography_font_size_tablet\":{\"unit\":\"rem\",\"size\":\"0.8\"},\"description_typography_line_height\":{\"unit\":\"em\",\"size\":\"1.7\"},\"description_typography_line_height_tablet\":{\"unit\":\"em\",\"size\":\"1.6\"},\"separator_spacing\":{\"unit\":\"px\",\"size\":\"32\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_color\":\"#ffffff\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"heading_typography_font_size\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]},\"heading_typography_font_weight\":\"300\",\"heading_typography_font_style\":\"italic\",\"description_typography_font_size\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625,\"sizes\":[]},\"description_typography_font_weight\":\"300\",\"description_typography_font_style\":\"italic\"},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"275de058\",\"elType\":\"widget\",\"settings\":{\"title\":\"Book Me\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":\"16\"},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"3.2\"},\"_padding\":{\"unit\":\"px\",\"top\":\"28\",\"right\":\"0\",\"bottom\":\"26\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_color\":\"#23211e\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"hide_mobile\":\"hidden-phone\"},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":\"1\"}],\"isInner\":\"1\"},{\"id\":\"68e36a3b\",\"elType\":\"section\",\"settings\":{\"content_width\":{\"unit\":\"px\",\"size\":\"1175\"},\"structure\":\"20\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"border_radius\":{\"unit\":\"px\",\"top\":\"9\",\"right\":\"0\",\"bottom\":\"9\",\"left\":\"0\",\"isLinked\":\"\"},\"layout\":\"full_width\",\"reverse_order_mobile\":\"reverse-mobile\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"86dccb7\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true}},\"elements\":[{\"id\":\"3ce34e22\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"50.043\",\"space_between_widgets\":\"0\",\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"}},\"elements\":[{\"id\":\"5077b8a3\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"Location\",\"item_description\":\"Fly me to you by appointment\",\"price\":\"Sydney\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"54ba866\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Age\",\"item_description\":\"\",\"price\":\"35\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"4fc77ee\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Bust\",\"item_description\":\"\",\"price\":\"34D (enhanced)\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"f7694ef\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Waist\",\"item_description\":\"\",\"price\":\"24\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"9a37d75\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Hips\",\"item_description\":\"\",\"price\":\"34\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"9422203\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Height\",\"item_description\":\"\",\"price\":\"5\' 9\\\"\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"8541f47\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Dress size\",\"item_description\":\"\",\"price\":\"2\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"_id\":\"1822b84\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"Shoe size\",\"item_description\":\"\",\"price\":\"7\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\",\"custom_attributes\":\"\"},\"image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"c0b23ce\"}],\"heading_color\":\"#000000\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_family\":\"Lato\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"row_gap\":{\"unit\":\"px\",\"size\":\"32\"},\"_padding\":{\"unit\":\"em\",\"top\":\"3\",\"right\":\"3\",\"bottom\":\"3\",\"left\":\"3\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"description_color\":\"#000000\",\"description_typography_typography\":\"custom\",\"description_typography_font_family\":\"Lato\",\"description_typography_font_size_tablet\":{\"unit\":\"rem\",\"size\":\"0.8\"},\"description_typography_line_height\":{\"unit\":\"em\",\"size\":\"1.7\"},\"description_typography_line_height_tablet\":{\"unit\":\"em\",\"size\":\"1.6\"},\"separator_spacing\":{\"unit\":\"px\",\"size\":\"32\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_background_color\":\"#ffffff\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"heading_typography_font_size\":{\"unit\":\"px\",\"size\":16,\"sizes\":[]},\"heading_typography_font_weight\":\"300\",\"description_typography_font_size\":{\"unit\":\"px\",\"size\":14,\"sizes\":[]},\"description_typography_font_weight\":\"300\",\"description_typography_font_style\":\"italic\"},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"361f85c7\",\"elType\":\"widget\",\"settings\":{\"title\":\"Book Me\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"px\",\"size\":\"16\"},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"3.2\"},\"_padding\":{\"unit\":\"px\",\"top\":\"28\",\"right\":\"0\",\"bottom\":\"26\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_background\":\"classic\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_background_color\":\"#23211e\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"9\",\"isLinked\":\"\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"tooltip_content\":\"I am a tooltip\",\"link\":{\"url\":\"#booking\",\"is_external\":\"\",\"nofollow\":\"\"},\"hide_mobile\":\"hidden-phone\"},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":\"1\"},{\"id\":\"74e91323\",\"elType\":\"column\",\"settings\":{\"_column_size\":\"50\",\"_inline_size\":\"49.957\",\"padding\":{\"unit\":\"em\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"},\"content_position\":\"top\",\"space_between_widgets\":\"0\",\"background_background\":\"classic\",\"background_size\":\"cover\"},\"elements\":[{\"id\":\"12aa4de\",\"elType\":\"widget\",\"settings\":{\"image\":{\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-16.jpg\",\"id\":352},\"image_height\":{\"unit\":\"px\",\"size\":600,\"sizes\":[]},\"image_height_mobile\":{\"unit\":\"px\",\"size\":500,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"premium-image-scroll\"},{\"id\":\"59d165bd\",\"elType\":\"widget\",\"settings\":{\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"spacer\"}],\"isInner\":\"1\"}],\"isInner\":\"1\"}],\"isInner\":\"\"}],\"isInner\":\"\"},{\"id\":\"32f72deb\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"c6e0aeb\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_image\":{\"id\":354,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-14.jpg\"},\"background_position\":\"center right\",\"background_attachment\":\"scroll\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"margin\":{\"unit\":\"px\",\"top\":\"50\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"background_image_mobile\":{\"id\":354,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/NikkiJames-prof-14.jpg\"},\"background_position_mobile\":\"initial\",\"background_xpos_mobile\":{\"unit\":\"em\",\"size\":-11.5,\"sizes\":[]},\"reverse_order_mobile\":\"reverse-mobile\",\"background_image_tablet\":{\"id\":296,\"url\":\"http:\\/\\/nikkijames.net\\/wp-content\\/uploads\\/2020\\/05\\/Nikki_M_WEB_7.jpg\"},\"background_position_tablet\":\"center center\",\"background_repeat_tablet\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"z_index\":9,\"background_overlay_background\":\"classic\",\"background_overlay_color\":\"#000000\",\"background_color\":\"#000000\",\"background_ypos_mobile\":{\"unit\":\"px\",\"size\":-163,\"sizes\":[]},\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.460000000000000019984014443252817727625370025634765625,\"sizes\":[]}},\"elements\":[{\"id\":\"6acd3193\",\"elType\":\"column\",\"settings\":{\"_column_size\":100},\"elements\":[{\"id\":\"1fffaae3\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"34fe6eb\",\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"structure\":\"20\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"reverse_order_mobile\":\"reverse-mobile\"},\"elements\":[{\"id\":\"3c323c03\",\"elType\":\"column\",\"settings\":{\"_column_size\":50,\"_inline_size\":null,\"content_position\":\"bottom\",\"border_border\":\"solid\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"01\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#ffffff\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[{\"id\":\"172d827d\",\"elType\":\"widget\",\"settings\":{\"title\":\"Touring\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"em\",\"size\":2},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":\"19\"},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_line_height\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625},\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":\"1.2\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"300\",\"tooltip_content\":\"I am a tooltip\",\"typography_font_size_tablet\":{\"unit\":\"px\",\"size\":\"23\"},\"typography_font_style\":\"italic\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"2\"},\"text_shadow_text_shadow\":{\"horizontal\":-1,\"vertical\":1,\"blur\":0,\"color\":\"#000000\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"4b4a6b6e\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>[text-blocks id=\\\"touring\\\"]<br \\/>Sign up with this form to be advised when I\\u2019m touring.<\\/p><p>[newsletter_form form=1]<\\/p>\",\"text_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Lato\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"20\",\"left\":\"20\",\"isLinked\":false},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"10\",\"left\":\"05\",\"isLinked\":false},\"align_mobile\":\"center\",\"typography_font_weight\":\"300\",\"tooltip_content\":\"I am a tooltip\",\"align\":\"center\"},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"1e82e914\",\"elType\":\"widget\",\"settings\":{\"space\":{\"unit\":\"px\",\"size\":300},\"tooltip_content\":\"I am a tooltip\",\"space_mobile\":{\"unit\":\"px\",\"size\":50,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"spacer\"},{\"id\":\"521cc29a\",\"elType\":\"widget\",\"settings\":{\"social_icon_list\":[{\"social\":\"fa fa-twitter\",\"_id\":\"4818363\",\"link\":{\"url\":\"https:\\/\\/twitter.com\\/\",\"is_external\":\"true\",\"nofollow\":\"on\",\"custom_attributes\":\"\"},\"social_icon\":{\"value\":\"fab fa-twitter\",\"library\":\"fa-brands\"},\"item_icon_color\":\"default\",\"item_icon_primary_color\":\"\",\"item_icon_secondary_color\":\"\",\"__fa4_migrated\":{\"social_icon\":true}}],\"icon_color\":\"custom\",\"icon_primary_color\":\"#ffffff\",\"icon_secondary_color\":\"#54595f\",\"icon_size\":{\"unit\":\"px\",\"size\":22},\"icon_padding\":{\"unit\":\"em\",\"size\":0.5},\"icon_spacing\":{\"unit\":\"px\",\"size\":\"32\"},\"hover_primary_color\":\"rgba(255,255,255,0)\",\"hover_secondary_color\":\"#ffffff\",\"hover_animation\":\"grow\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":\"\"},\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":\"\"},\"tooltip_content\":\"I am a tooltip\",\"image_border_border\":\"solid\",\"image_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"image_border_color\":\"#000000\",\"align\":\"left\",\"_z_index\":9,\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"05\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"social-icons\"},{\"id\":\"291019fc\",\"elType\":\"widget\",\"settings\":{\"title\":\"\\u00a9 NikkiJames.net<br \\/>\\nBookNikkiJames@gmail.com<br \\/>Design by <a href=https:\\/\\/StickySites.ch target=new>StickySites.ch<\\/a>\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1},\"typography_font_weight\":\"300\",\"align\":\"center\",\"align_mobile\":\"center\",\"header_size\":\"p\",\"_margin\":{\"unit\":\"px\",\"top\":\"-80\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"tooltip_content\":\"I am a tooltip\",\"typography_font_family\":\"Lato\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"-78\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"05\",\"right\":\"05\",\"bottom\":\"05\",\"left\":\"05\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"05\",\"right\":\"0\",\"bottom\":\"5\",\"left\":\"15\",\"isLinked\":false},\"typography_line_height\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875,\"sizes\":[]},\"_border_border\":\"solid\",\"_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"_border_color\":\"#ffffff\",\"_background_background\":\"classic\",\"_background_color\":\"rgba(0,0,0,0.35)\"},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":true},{\"id\":\"6fc0310b\",\"elType\":\"column\",\"settings\":{\"_column_size\":50,\"_inline_size\":null,\"content_position\":\"bottom\",\"margin\":{\"unit\":\"px\",\"top\":\"80\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"content_position_mobile\":\"top\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[{\"id\":\"51691ef3\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"booking\",\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"51fcad89\",\"elType\":\"widget\",\"settings\":{\"title\":\"Book Now\",\"header_size\":\"h3\",\"align\":\"center\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Bungee Hairline\",\"typography_font_size\":{\"unit\":\"em\",\"size\":5},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":2},\"typography_font_weight\":\"bold\",\"typography_text_transform\":\"uppercase\",\"typography_line_height\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625},\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":\"1.2\"},\"_animation\":\"fadeInUp\",\"_animation_delay\":\"300\",\"tooltip_content\":\"I am a tooltip\",\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3},\"typography_font_style\":\"italic\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":\"2\"},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":-1,\"vertical\":1,\"blur\":0,\"color\":\"#000000\"},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"\"},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":\"1\"}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"65458125\",\"elType\":\"widget\",\"settings\":{\"form_name\":\"New Form\",\"form_fields\":[{\"_id\":\"name\",\"field_type\":\"text\",\"field_label\":\"\",\"placeholder\":\"First name*\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"name\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"last\",\"field_type\":\"text\",\"field_label\":\"\",\"placeholder\":\"Last Name*\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"last\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"email\",\"field_type\":\"email\",\"required\":\"true\",\"field_label\":\"\",\"placeholder\":\"Email*\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"email\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_2\",\"field_type\":\"tel\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Tel\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_2\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_4\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em;font-family:Lato;color:#ffffff\\\"><u>Booking details<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_4\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"date\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Date\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"date\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_6\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Time [eg 9:00pm]\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_6\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_7\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Time together\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_7\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_8\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Place\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_8\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"message\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Other comments\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":2,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"message\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_9\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em;font-family:Lato;color:#ffffff\\\"><br \\/><u>Screening & References<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_9\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"96cb7ef\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Reference #1: Contact information from another meeting\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"96cb7ef\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"bd1bf55\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Reference #2: Contact information from another meeting\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"bd1bf55\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"8c29381\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Work: Website, Email, Phone #\",\"width\":\"66\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"75\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"8c29381\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"969c485\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"Age\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"25\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"969c485\",\"recaptcha_badge\":\"bottomright\"},{\"field_type\":\"honeypot\",\"required\":\"\",\"field_label\":\"message\",\"placeholder\":\"Age & Race\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_2c1834f\",\"recaptcha_badge\":\"bottomright\",\"_id\":\"2c1834f\"}],\"mark_required\":\"yes\",\"button_text\":\"SEND BOOKING\",\"button_size\":\"md\",\"button_icon_align\":\"right\",\"button_icon_indent\":{\"unit\":\"px\",\"size\":12},\"email_content\":\"[all-fields]\",\"email_content_2\":\"[all-fields]\",\"success_message\":\"<center><p style=\\\"background-color:white;\\\"><strong>The form was sent successfully!<\\/strong><\\/p><\\/center>\",\"error_message\":\"An errors occurred.\",\"required_field_message\":\"This field is required.\",\"invalid_message\":\"There\'s something wrong. The form is invalid.\",\"row_gap\":{\"unit\":\"px\",\"size\":13},\"label_color\":\"#ffffff\",\"mark_required_color\":\"#ffffff\",\"label_typography_typography\":\"custom\",\"label_typography_font_size\":{\"unit\":\"em\",\"size\":1},\"field_text_color\":\"#ffffff\",\"field_typography_typography\":\"custom\",\"field_typography_font_size\":{\"unit\":\"em\",\"size\":1},\"field_border_color\":\"#ffffff\",\"button_background_color\":\"rgba(0,0,0,0.3)\",\"button_text_color\":\"#ffffff\",\"button_typography_typography\":\"custom\",\"button_typography_text_transform\":\"uppercase\",\"button_background_hover_color\":\"#000000\",\"button_hover_color\":\"#ffffff\",\"field_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"form_metadata\":[\"date\",\"time\",\"page_url\",\"user_agent\",\"remote_ip\"],\"email_content_type\":\"plain\",\"custom_messages\":\"yes\",\"label_typography_font_weight\":\"300\",\"label_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1},\"button_border_border\":\"solid\",\"button_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"button_border_color\":\"#ffffff\",\"_background_background\":\"classic\",\"button_align_tablet\":\"start\",\"button_icon\":\"fa fa-send\",\"label_typography_font_family\":\"Lato\",\"field_typography_font_family\":\"Lato\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_typography_font_family\":\"Lato\",\"button_hover_border_color\":\"#ffffff\",\"tooltip_content\":\"I am a tooltip\",\"selected_button_icon\":{\"value\":\"fas fa-paper-plane\",\"library\":\"fa-solid\"},\"field_background_color\":\"rgba(0,0,0,0.3)\",\"button_hover_animation\":\"grow\",\"__fa4_migrated\":{\"selected_button_icon\":true},\"field_typography_font_weight\":\"300\",\"button_typography_font_size\":{\"unit\":\"px\",\"size\":16,\"sizes\":[]},\"button_typography_font_weight\":\"bold\",\"email_to\":\"stickysites@protonmail.com\",\"email_subject\":\"New message from \\\"Nikki James\\\"\",\"email_from\":\"email@nikkijames.net\",\"email_from_name\":\"Nikki James\",\"email_to_2\":\"stickysites@protonmail.com\",\"email_subject_2\":\"New message from \\\"Nikki James\\\"\",\"email_from_2\":\"email@nikkijames.net\",\"email_from_name_2\":\"Nikki James\",\"email_reply_to_2\":\"stickysites@protonmail.com\",\"button_align_mobile\":\"stretch\"},\"elements\":[],\"widgetType\":\"form\"},{\"id\":\"5491edfa\",\"elType\":\"widget\",\"settings\":{\"align_mobile\":\"center\",\"text\":\"Divider\",\"color\":\"#ffffff\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"50\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"hide_desktop\":\"hidden-desktop\",\"hide_tablet\":\"hidden-tablet\",\"tooltip_content\":\"I am a tooltip\"},\"elements\":[],\"widgetType\":\"divider\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false}]");
INSERT INTO `wp_522243_postmeta` VALUES("271", "311", "_wp_attached_file", "2020/05/NikkiJames-selfies-11.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("272", "311", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:470;s:6:\"height\";i:280;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-11.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-11-300x179.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:179;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-11-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("273", "312", "_wp_attached_file", "2020/05/NikkiJames-selfies-10.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("274", "312", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:409;s:6:\"height\";i:280;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-10.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-10-300x205.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:205;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("275", "313", "_wp_attached_file", "2020/05/NikkiJames-selfies-09.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("276", "313", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:384;s:6:\"height\";i:232;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-09.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-09-300x181.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:181;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-09-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("277", "314", "_wp_attached_file", "2020/05/NikkiJames-selfies-08.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("278", "314", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:360;s:6:\"height\";i:480;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-08.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-08-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-08-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("279", "315", "_wp_attached_file", "2020/05/NikkiJames-selfies-07.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("280", "315", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:342;s:6:\"height\";i:512;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-07.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-07-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-07-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("281", "316", "_wp_attached_file", "2020/05/NikkiJames-selfies-06.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("282", "316", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:280;s:6:\"height\";i:391;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-06.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-06-215x300.jpg\";s:5:\"width\";i:215;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-06-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("283", "317", "_wp_attached_file", "2020/05/NikkiJames-selfies-05.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("284", "317", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:280;s:6:\"height\";i:378;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-05.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-05-222x300.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-05-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("285", "318", "_wp_attached_file", "2020/05/NikkiJames-selfies-04.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("286", "318", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:280;s:6:\"height\";i:373;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-04.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-04-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-04-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("287", "319", "_wp_attached_file", "2020/05/NikkiJames-selfies-03.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("288", "319", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:280;s:6:\"height\";i:373;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-03.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-03-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-03-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("289", "320", "_wp_attached_file", "2020/05/NikkiJames-selfies-02.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("290", "320", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:280;s:6:\"height\";i:373;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-02.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-02-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-02-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("291", "321", "_wp_attached_file", "2020/05/NikkiJames-selfies-01.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("292", "321", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:280;s:6:\"height\";i:280;s:4:\"file\";s:33:\"2020/05/NikkiJames-selfies-01.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"NikkiJames-selfies-01-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("293", "322", "_wp_attached_file", "2020/05/NikkiJames-prof-46.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("294", "322", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:960;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-46.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-46-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-46-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-46-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-46-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"EX-Z850\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1139429194\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"7.9\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("295", "323", "_wp_attached_file", "2020/05/NikkiJames-prof-45.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("296", "323", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:960;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-45.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-45-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-45-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-45-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-45-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"EX-Z850\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1139429176\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"7.9\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("297", "324", "_wp_attached_file", "2020/05/NikkiJames-prof-44.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("298", "324", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:960;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-44.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-44-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-44-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-44-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-44-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"EX-Z850\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1139429167\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"7.9\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("299", "325", "_wp_attached_file", "2020/05/NikkiJames-prof-43.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("300", "325", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:960;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-43.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-43-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-43-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-43-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-43-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"EX-Z850\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1139428902\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"7.9\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("301", "326", "_wp_attached_file", "2020/05/NikkiJames-prof-42.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("302", "326", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:622;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-42.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-42-300x146.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:146;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-42-1024x498.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:498;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-42-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-42-768x373.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:373;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("303", "327", "_wp_attached_file", "2020/05/NikkiJames-prof-41.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("304", "327", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-41.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-41-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:32:\"NikkiJames-prof-41-1024x1024.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-41-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-41-768x768.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("305", "328", "_wp_attached_file", "2020/05/NikkiJames-prof-40.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("306", "328", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1279;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-40.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-40-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:32:\"NikkiJames-prof-40-1024x1024.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-40-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-40-768x769.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:769;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("307", "329", "_wp_attached_file", "2020/05/NikkiJames-prof-39.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("308", "329", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1279;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-39.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-39-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:32:\"NikkiJames-prof-39-1024x1024.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-39-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-39-768x769.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:769;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("309", "330", "_wp_attached_file", "2020/05/NikkiJames-prof-38.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("310", "330", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1206;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-38.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-38-283x300.jpg\";s:5:\"width\";i:283;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-38-965x1024.jpg\";s:5:\"width\";i:965;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-38-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-38-768x815.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:815;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("311", "331", "_wp_attached_file", "2020/05/NikkiJames-prof-37.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("312", "331", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-37.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-37-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-37-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-37-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-37-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:21:\"Canon EOS-1Ds Mark II\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1201264304\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:1:{i:0;s:10:\"sexy naomi\";}}}");
INSERT INTO `wp_522243_postmeta` VALUES("313", "332", "_wp_attached_file", "2020/05/NikkiJames-prof-36.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("314", "332", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:622;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-36.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-36-300x146.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:146;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-36-1024x498.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:498;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-36-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-36-768x373.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:373;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("315", "333", "_wp_attached_file", "2020/05/NikkiJames-prof-35.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("316", "333", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:759;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-35.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-35-178x300.jpg\";s:5:\"width\";i:178;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-35-607x1024.jpg\";s:5:\"width\";i:607;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-35-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("317", "334", "_wp_attached_file", "2020/05/NikkiJames-prof-34.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("318", "334", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:852;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-34.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-34-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-34-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-34-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-34-768x511.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:511;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("319", "335", "_wp_attached_file", "2020/05/NikkiJames-prof-33.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("320", "335", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:851;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-33.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-33-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-33-1024x681.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:681;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-33-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-33-768x511.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:511;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("321", "336", "_wp_attached_file", "2020/05/NikkiJames-prof-32.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("322", "336", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:851;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-32.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-32-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-32-1024x681.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:681;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-32-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-32-768x511.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:511;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("323", "337", "_wp_attached_file", "2020/05/NikkiJames-prof-31.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("324", "337", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:835;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-31.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-31-300x196.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:196;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-31-1024x668.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:668;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-31-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-31-768x501.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:501;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("325", "338", "_wp_attached_file", "2020/05/NikkiJames-prof-30.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("326", "338", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:622;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-30.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-30-146x300.jpg\";s:5:\"width\";i:146;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-30-498x1024.jpg\";s:5:\"width\";i:498;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-30-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("327", "339", "_wp_attached_file", "2020/05/NikkiJames-prof-29.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("328", "339", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:620;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-29.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-29-145x300.jpg\";s:5:\"width\";i:145;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-29-496x1024.jpg\";s:5:\"width\";i:496;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-29-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("329", "340", "_wp_attached_file", "2020/05/NikkiJames-prof-28.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("330", "340", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:620;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-28.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-28-145x300.jpg\";s:5:\"width\";i:145;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-28-496x1024.jpg\";s:5:\"width\";i:496;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-28-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("331", "341", "_wp_attached_file", "2020/05/NikkiJames-prof-27.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("332", "341", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:1029;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-27.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-27-300x241.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:241;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-27-1024x823.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:823;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-27-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-27-768x617.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:617;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("333", "342", "_wp_attached_file", "2020/05/NikkiJames-prof-26.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("334", "342", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:1248;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-26.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-26-300x293.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:293;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-26-1024x998.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:998;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-26-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-26-768x749.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:749;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("335", "343", "_wp_attached_file", "2020/05/NikkiJames-prof-25.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("336", "343", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:854;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-25.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-25-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-25-683x1024.jpg\";s:5:\"width\";i:683;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-25-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-25-768x1151.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1151;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("337", "344", "_wp_attached_file", "2020/05/NikkiJames-prof-24.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("338", "344", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:852;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-24.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-24-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-24-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-24-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-24-768x1154.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1154;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("339", "345", "_wp_attached_file", "2020/05/NikkiJames-prof-23.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("340", "345", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:852;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-23.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-23-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-23-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-23-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-23-768x1154.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1154;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("341", "346", "_wp_attached_file", "2020/05/NikkiJames-prof-22.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("342", "346", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:851;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-22.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-22-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-22-681x1024.jpg\";s:5:\"width\";i:681;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-22-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-22-768x1155.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("343", "347", "_wp_attached_file", "2020/05/NikkiJames-prof-21.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("344", "347", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:851;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-21.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-21-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-21-681x1024.jpg\";s:5:\"width\";i:681;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-21-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-21-768x1155.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("345", "348", "_wp_attached_file", "2020/05/NikkiJames-prof-20.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("346", "348", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:851;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-20.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-20-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-20-681x1024.jpg\";s:5:\"width\";i:681;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-20-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-20-768x1155.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("347", "349", "_wp_attached_file", "2020/05/NikkiJames-prof-19.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("348", "349", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:851;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-19.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-19-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-19-681x1024.jpg\";s:5:\"width\";i:681;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-19-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-19-768x1155.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("349", "350", "_wp_attached_file", "2020/05/NikkiJames-prof-18.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("350", "350", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:851;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-18.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-18-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-18-681x1024.jpg\";s:5:\"width\";i:681;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-18-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-18-768x1155.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("351", "351", "_wp_attached_file", "2020/05/NikkiJames-prof-17.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("352", "351", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:960;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-17.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-17-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-17-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-17-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-17-768x1024.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("353", "352", "_wp_attached_file", "2020/05/NikkiJames-prof-16.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("354", "352", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-16.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-16-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-16-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-16-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-16-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:13:\"Canon EOS 40D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1259851381\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:1:{i:0;s:22:\"Cheryl\'s Birthday 2009\";}}}");
INSERT INTO `wp_522243_postmeta` VALUES("355", "353", "_wp_attached_file", "2020/05/NikkiJames-prof-15.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("356", "353", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-15.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-15-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-15-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-15-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-15-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:13:\"Canon EOS 40D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1259850996\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:1:{i:0;s:2:\"NV\";}}}");
INSERT INTO `wp_522243_postmeta` VALUES("357", "354", "_wp_attached_file", "2020/05/NikkiJames-prof-14.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("358", "354", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-14.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-14-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-14-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-14-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-14-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"7.1\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:13:\"Canon EOS 40D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1259850566\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.008\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:1:{i:0;s:2:\"NV\";}}}");
INSERT INTO `wp_522243_postmeta` VALUES("359", "355", "_wp_attached_file", "2020/05/NikkiJames-prof-13.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("360", "355", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-13.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-13-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-13-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-13-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-13-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"3.5\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235832437\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"41\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("361", "356", "_wp_attached_file", "2020/05/NikkiJames-prof-12.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("362", "356", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-12.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-12-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-12-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-12-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-12-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"3.5\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235832428\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:17:\"0.016666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("363", "357", "_wp_attached_file", "2020/05/NikkiJames-prof-11.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("364", "357", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-11.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-11-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-11-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-11-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-11-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235831295\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"40\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.005\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("365", "358", "_wp_attached_file", "2020/05/NikkiJames-prof-10.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("366", "358", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-10.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-10-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-10-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-10-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235831261\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"41\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.005\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("367", "359", "_wp_attached_file", "2020/05/NikkiJames-prof-09.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("368", "359", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-09.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-09-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-09-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-09-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-09-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235831226\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"29\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.005\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("369", "360", "_wp_attached_file", "2020/05/NikkiJames-prof-08.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("370", "360", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-08.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-08-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-08-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-08-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-08-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235831208\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"44\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.005\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("371", "361", "_wp_attached_file", "2020/05/NikkiJames-prof-07.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("372", "361", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-07.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-07-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-07-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-07-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-07-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:7:\"unknown\";s:6:\"camera\";s:13:\"Canon EOS 20D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1235831157\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"31\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:3:\"0.1\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("373", "362", "_wp_attached_file", "2020/05/NikkiJames-prof-06.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("374", "362", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-06.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-06-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-06-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-06-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-06-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("375", "363", "_wp_attached_file", "2020/05/NikkiJames-prof-05.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("376", "363", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-05.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-05-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-05-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-05-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-05-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("377", "364", "_wp_attached_file", "2020/05/NikkiJames-prof-04.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("378", "364", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-04.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-04-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-04-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-04-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-04-768x1152.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:13:\"Canon EOS 40D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1186859172\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:5:\"0.008\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("379", "365", "_wp_attached_file", "2020/05/NikkiJames-prof-03.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("380", "365", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:855;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-03.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-03-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-03-1024x684.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:684;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-03-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-03-768x513.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:513;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("381", "366", "_wp_attached_file", "2020/05/NikkiJames-prof-02.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("382", "366", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:855;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-02.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-02-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-02-1024x684.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:684;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-02-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-02-768x513.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:513;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("383", "367", "_wp_attached_file", "2020/05/NikkiJames-prof-01.jpg");
INSERT INTO `wp_522243_postmeta` VALUES("384", "367", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:878;s:4:\"file\";s:30:\"2020/05/NikkiJames-prof-01.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-01-300x206.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:206;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:31:\"NikkiJames-prof-01-1024x702.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:702;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-01-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:30:\"NikkiJames-prof-01-768x527.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:527;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_522243_postmeta` VALUES("633", "287", "_elementor_controls_usage", "a:14:{s:6:\"spacer\";a:3:{s:5:\"count\";i:6;s:15:\"control_percent\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:14:\"section_spacer\";a:3:{s:5:\"space\";i:4;s:12:\"space_mobile\";i:3;s:12:\"space_tablet\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:1:{s:7:\"_margin\";i:1;}}}}s:6:\"column\";a:3:{s:5:\"count\";i:14;s:15:\"control_percent\";i:0;s:8:\"controls\";a:3:{s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:10;s:13:\"margin_mobile\";i:6;s:14:\"padding_tablet\";i:3;s:6:\"margin\";i:4;s:13:\"margin_tablet\";i:3;s:14:\"padding_mobile\";i:2;}s:15:\"section_effects\";a:1:{s:9:\"animation\";i:3;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:1;}}s:6:\"layout\";a:1:{s:6:\"layout\";a:5:{s:16:\"content_position\";i:7;s:21:\"space_between_widgets\";i:5;s:12:\"_inline_size\";i:7;s:19:\"_inline_size_tablet\";i:2;s:23:\"content_position_mobile\";i:1;}}s:5:\"style\";a:2:{s:14:\"section_border\";a:4:{s:12:\"border_width\";i:3;s:12:\"border_color\";i:3;s:13:\"border_radius\";i:2;s:13:\"border_border\";i:1;}s:13:\"section_style\";a:3:{s:16:\"background_color\";i:2;s:21:\"background_background\";i:2;s:15:\"background_size\";i:2;}}}}s:7:\"heading\";a:3:{s:5:\"count\";i:7;s:15:\"control_percent\";i:8;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:5:{s:5:\"title\";i:7;s:11:\"header_size\";i:6;s:5:\"align\";i:7;s:4:\"link\";i:2;s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:15:{s:11:\"title_color\";i:7;s:21:\"typography_typography\";i:7;s:22:\"typography_font_family\";i:7;s:20:\"typography_font_size\";i:7;s:27:\"typography_font_size_mobile\";i:5;s:22:\"typography_font_weight\";i:7;s:29:\"typography_line_height_mobile\";i:3;s:22:\"typography_line_height\";i:4;s:27:\"typography_font_size_tablet\";i:3;s:25:\"typography_letter_spacing\";i:5;s:28:\"text_shadow_text_shadow_type\";i:2;s:23:\"text_shadow_text_shadow\";i:3;s:32:\"typography_letter_spacing_mobile\";i:1;s:25:\"typography_text_transform\";i:5;s:21:\"typography_font_style\";i:2;}}s:8:\"advanced\";a:5:{s:15:\"section_effects\";a:4:{s:10:\"_animation\";i:4;s:16:\"_animation_delay\";i:3;s:6:\"sticky\";i:1;s:13:\"sticky_parent\";i:1;}s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:6;s:14:\"_margin_mobile\";i:6;s:8:\"_padding\";i:3;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:3;s:17:\"_background_color\";i:3;}s:15:\"_section_border\";a:4:{s:14:\"_border_radius\";i:2;s:14:\"_border_border\";i:1;s:13:\"_border_width\";i:1;s:13:\"_border_color\";i:1;}s:19:\"_section_responsive\";a:1:{s:11:\"hide_mobile\";i:2;}}}}s:7:\"section\";a:3:{s:5:\"count\";i:9;s:15:\"control_percent\";i:6;s:8:\"controls\";a:3:{s:5:\"style\";a:4:{s:18:\"section_background\";a:26:{s:21:\"background_background\";i:5;s:16:\"background_image\";i:2;s:19:\"background_position\";i:2;s:17:\"background_repeat\";i:2;s:15:\"background_size\";i:2;s:15:\"background_ypos\";i:1;s:19:\"background_bg_width\";i:1;s:21:\"background_video_link\";i:1;s:22:\"background_video_start\";i:1;s:20:\"background_video_end\";i:1;s:22:\"background_size_mobile\";i:1;s:23:\"background_image_mobile\";i:2;s:26:\"background_position_mobile\";i:2;s:21:\"background_attachment\";i:2;s:24:\"background_repeat_mobile\";i:1;s:23:\"background_image_tablet\";i:2;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:40:\"background_motion_fx_motion_fx_scrolling\";i:1;s:38:\"background_motion_fx_translateY_effect\";i:1;s:37:\"background_motion_fx_translateY_speed\";i:1;s:37:\"background_motion_fx_translateX_speed\";i:1;s:16:\"background_color\";i:4;s:22:\"background_xpos_mobile\";i:1;s:26:\"background_position_tablet\";i:1;s:22:\"background_ypos_mobile\";i:1;}s:26:\"section_background_overlay\";a:14:{s:29:\"background_overlay_background\";i:5;s:24:\"background_overlay_color\";i:2;s:26:\"background_overlay_opacity\";i:5;s:29:\"background_overlay_color_stop\";i:1;s:26:\"background_overlay_color_b\";i:1;s:33:\"background_overlay_gradient_angle\";i:1;s:32:\"background_overlay_gradient_type\";i:1;s:24:\"background_overlay_image\";i:2;s:25:\"background_overlay_repeat\";i:2;s:23:\"background_overlay_size\";i:2;s:27:\"background_overlay_bg_width\";i:2;s:27:\"background_overlay_position\";i:2;s:20:\"css_filters_contrast\";i:2;s:20:\"css_filters_saturate\";i:2;}s:14:\"section_border\";a:4:{s:12:\"border_width\";i:1;s:12:\"border_color\";i:1;s:13:\"border_radius\";i:3;s:21:\"box_shadow_box_shadow\";i:1;}s:21:\"section_shape_divider\";a:7:{s:23:\"shape_divider_top_color\";i:3;s:24:\"shape_divider_top_height\";i:3;s:20:\"shape_divider_bottom\";i:2;s:26:\"shape_divider_bottom_color\";i:2;s:26:\"shape_divider_bottom_width\";i:2;s:27:\"shape_divider_bottom_height\";i:2;s:17:\"shape_divider_top\";i:1;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:6:{s:7:\"padding\";i:6;s:14:\"padding_tablet\";i:7;s:14:\"padding_mobile\";i:8;s:6:\"margin\";i:4;s:13:\"margin_mobile\";i:3;s:7:\"z_index\";i:1;}s:19:\"_section_responsive\";a:1:{s:20:\"reverse_order_mobile\";i:4;}}s:6:\"layout\";a:2:{s:14:\"section_layout\";a:7:{s:6:\"height\";i:1;s:13:\"custom_height\";i:1;s:15:\"column_position\";i:1;s:20:\"custom_height_tablet\";i:1;s:20:\"custom_height_mobile\";i:1;s:13:\"content_width\";i:6;s:6:\"layout\";i:2;}s:17:\"section_structure\";a:1:{s:9:\"structure\";i:5;}}}}s:11:\"text-editor\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:5;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:2;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:11:{s:5:\"align\";i:2;s:10:\"text_color\";i:2;s:21:\"typography_typography\";i:2;s:22:\"typography_font_family\";i:2;s:20:\"typography_font_size\";i:2;s:22:\"typography_line_height\";i:1;s:27:\"typography_font_size_tablet\";i:1;s:29:\"typography_line_height_tablet\";i:1;s:22:\"typography_font_weight\";i:2;s:12:\"align_mobile\";i:2;s:27:\"typography_font_size_mobile\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:7:{s:7:\"_margin\";i:2;s:14:\"_margin_mobile\";i:2;s:8:\"_padding\";i:2;s:14:\"_margin_tablet\";i:1;s:15:\"_padding_tablet\";i:1;s:12:\"_css_classes\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:6:\"button\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:11;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_button\";a:6:{s:4:\"text\";i:2;s:5:\"align\";i:2;s:4:\"size\";i:2;s:4:\"link\";i:2;s:12:\"align_mobile\";i:1;s:13:\"selected_icon\";i:1;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:15:{s:21:\"typography_typography\";i:2;s:22:\"typography_font_family\";i:2;s:20:\"typography_font_size\";i:2;s:22:\"typography_font_weight\";i:2;s:25:\"typography_text_transform\";i:2;s:25:\"typography_letter_spacing\";i:2;s:17:\"button_text_color\";i:2;s:16:\"background_color\";i:2;s:11:\"hover_color\";i:2;s:29:\"button_background_hover_color\";i:2;s:12:\"border_width\";i:2;s:12:\"border_color\";i:2;s:13:\"border_radius\";i:2;s:22:\"typography_line_height\";i:2;s:15:\"hover_animation\";i:2;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:2;s:14:\"_margin_mobile\";i:2;}s:15:\"section_effects\";a:2:{s:10:\"_animation\";i:2;s:16:\"_animation_delay\";i:2;}s:19:\"_section_background\";a:5:{s:22:\"_background_background\";i:2;s:20:\"_background_position\";i:2;s:18:\"_background_repeat\";i:2;s:16:\"_background_size\";i:2;s:20:\"_background_bg_width\";i:2;}s:19:\"_section_responsive\";a:3:{s:11:\"hide_mobile\";i:1;s:12:\"hide_desktop\";i:1;s:11:\"hide_tablet\";i:1;}}}}s:14:\"media-carousel\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:10;s:8:\"controls\";a:3:{s:7:\"content\";a:2:{s:14:\"section_slides\";a:10:{s:6:\"slides\";i:1;s:15:\"slides_per_view\";i:1;s:22:\"slides_per_view_tablet\";i:1;s:22:\"slides_per_view_mobile\";i:1;s:6:\"height\";i:1;s:13:\"height_tablet\";i:1;s:13:\"height_mobile\";i:1;s:6:\"effect\";i:1;s:15:\"centered_slides\";i:1;s:16:\"slides_to_scroll\";i:1;}s:26:\"section_additional_options\";a:6:{s:5:\"speed\";i:1;s:4:\"icon\";i:1;s:11:\"show_arrows\";i:1;s:14:\"autoplay_speed\";i:1;s:15:\"image_size_size\";i:1;s:20:\"pause_on_interaction\";i:1;}}s:5:\"style\";a:2:{s:18:\"section_navigation\";a:3:{s:12:\"arrows_color\";i:1;s:14:\"play_icon_size\";i:1;s:11:\"arrows_size\";i:1;}s:20:\"section_slides_style\";a:6:{s:13:\"space_between\";i:1;s:22:\"slide_background_color\";i:1;s:17:\"slide_border_size\";i:1;s:19:\"slide_border_radius\";i:1;s:18:\"slide_border_color\";i:1;s:13:\"slide_padding\";i:1;}}s:8:\"advanced\";a:4:{s:14:\"_section_style\";a:2:{s:12:\"_css_classes\";i:1;s:8:\"_padding\";i:1;}s:15:\"section_effects\";a:1:{s:10:\"_animation\";i:1;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:1;s:17:\"_background_color\";i:1;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}}}}s:7:\"gallery\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:2;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:8:\"settings\";a:8:{s:7:\"gallery\";i:1;s:9:\"galleries\";i:1;s:8:\"order_by\";i:1;s:8:\"lazyload\";i:1;s:14:\"columns_mobile\";i:1;s:10:\"gap_mobile\";i:1;s:12:\"aspect_ratio\";i:1;s:20:\"thumbnail_image_size\";i:1;}}}}s:20:\"premium-image-scroll\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:1;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:16:\"general_settings\";a:3:{s:5:\"image\";i:2;s:12:\"image_height\";i:2;s:19:\"image_height_mobile\";i:1;}}}}s:10:\"price-list\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:8;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:2;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:16:{s:13:\"heading_color\";i:2;s:29:\"heading_typography_typography\";i:2;s:30:\"heading_typography_font_family\";i:2;s:17:\"description_color\";i:2;s:33:\"description_typography_typography\";i:2;s:34:\"description_typography_font_family\";i:2;s:39:\"description_typography_font_size_tablet\";i:2;s:34:\"description_typography_line_height\";i:2;s:41:\"description_typography_line_height_tablet\";i:2;s:17:\"separator_spacing\";i:2;s:28:\"heading_typography_font_size\";i:2;s:30:\"heading_typography_font_weight\";i:2;s:29:\"heading_typography_font_style\";i:1;s:32:\"description_typography_font_size\";i:2;s:34:\"description_typography_font_weight\";i:2;s:33:\"description_typography_font_style\";i:2;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:2;}}s:8:\"advanced\";a:3:{s:14:\"_section_style\";a:3:{s:7:\"_margin\";i:2;s:8:\"_padding\";i:2;s:14:\"_margin_mobile\";i:2;}s:19:\"_section_background\";a:2:{s:22:\"_background_background\";i:2;s:17:\"_background_color\";i:2;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:2;}}}}s:12:\"social-icons\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:7;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:19:\"section_social_icon\";a:2:{s:16:\"social_icon_list\";i:1;s:5:\"align\";i:1;}}s:5:\"style\";a:2:{s:20:\"section_social_style\";a:9:{s:10:\"icon_color\";i:1;s:18:\"icon_primary_color\";i:1;s:20:\"icon_secondary_color\";i:1;s:9:\"icon_size\";i:1;s:12:\"icon_padding\";i:1;s:12:\"icon_spacing\";i:1;s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:20:\"section_social_hover\";a:3:{s:19:\"hover_primary_color\";i:1;s:21:\"hover_secondary_color\";i:1;s:15:\"hover_animation\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:1;s:14:\"_margin_tablet\";i:1;s:8:\"_z_index\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:11:\"menu-anchor\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:0;s:8:\"controls\";a:1:{s:7:\"content\";a:1:{s:14:\"section_anchor\";a:1:{s:6:\"anchor\";i:1;}}}}s:4:\"form\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:10;s:8:\"controls\";a:3:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:1;s:13:\"mark_required\";i:1;}s:21:\"section_submit_button\";a:7:{s:11:\"button_text\";i:1;s:11:\"button_size\";i:1;s:17:\"button_icon_align\";i:1;s:18:\"button_icon_indent\";i:1;s:19:\"button_align_tablet\";i:1;s:20:\"selected_button_icon\";i:1;s:19:\"button_align_mobile\";i:1;}s:20:\"section_form_options\";a:3:{s:15:\"success_message\";i:1;s:13:\"error_message\";i:1;s:15:\"custom_messages\";i:1;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:1;s:18:\"email_content_type\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:8:{s:7:\"row_gap\";i:1;s:11:\"label_color\";i:1;s:19:\"mark_required_color\";i:1;s:27:\"label_typography_typography\";i:1;s:26:\"label_typography_font_size\";i:1;s:28:\"label_typography_font_weight\";i:1;s:33:\"label_typography_font_size_mobile\";i:1;s:28:\"label_typography_font_family\";i:1;}s:19:\"section_field_style\";a:8:{s:16:\"field_text_color\";i:1;s:27:\"field_typography_typography\";i:1;s:26:\"field_typography_font_size\";i:1;s:18:\"field_border_color\";i:1;s:19:\"field_border_radius\";i:1;s:28:\"field_typography_font_family\";i:1;s:22:\"field_background_color\";i:1;s:28:\"field_typography_font_weight\";i:1;}s:20:\"section_button_style\";a:15:{s:23:\"button_background_color\";i:1;s:17:\"button_text_color\";i:1;s:28:\"button_typography_typography\";i:1;s:32:\"button_typography_text_transform\";i:1;s:29:\"button_background_hover_color\";i:1;s:18:\"button_hover_color\";i:1;s:20:\"button_border_radius\";i:1;s:20:\"button_border_border\";i:1;s:19:\"button_border_width\";i:1;s:19:\"button_border_color\";i:1;s:29:\"button_typography_font_family\";i:1;s:25:\"button_hover_border_color\";i:1;s:22:\"button_hover_animation\";i:1;s:27:\"button_typography_font_size\";i:1;s:29:\"button_typography_font_weight\";i:1;}}s:8:\"advanced\";a:2:{s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}s:14:\"_section_style\";a:2:{s:7:\"_margin\";i:1;s:8:\"_padding\";i:1;}}}}s:7:\"divider\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:15:\"section_divider\";a:1:{s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:1:{s:21:\"section_divider_style\";a:1:{s:5:\"color\";i:1;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:1:{s:14:\"_margin_mobile\";i:1;}s:19:\"_section_responsive\";a:2:{s:12:\"hide_desktop\";i:1;s:11:\"hide_tablet\";i:1;}}}}}");
INSERT INTO `wp_522243_postmeta` VALUES("634", "287", "_elementor_css", "a:5:{s:4:\"time\";i:1588503142;s:5:\"fonts\";a:2:{i:0;s:15:\"Bungee Hairline\";i:2;s:4:\"Lato\";}s:5:\"icons\";a:4:{i:0;s:0:\"\";i:1;s:10:\"fa-regular\";i:2;s:9:\"fa-brands\";i:3;s:8:\"fa-solid\";}s:6:\"status\";s:4:\"file\";i:0;s:0:\"\";}");
INSERT INTO `wp_522243_postmeta` VALUES("635", "405", "_edit_last", "1");
INSERT INTO `wp_522243_postmeta` VALUES("636", "405", "_edit_lock", "1588503357:1");

/* INSERT TABLE DATA: wp_522243_posts */
INSERT INTO `wp_522243_posts` VALUES("45", "0", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "CAMERAS", "", "inherit", "open", "closed", "", "cameras", "", "", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/CAMERAS.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("46", "0", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "LENSES-1", "", "inherit", "open", "closed", "", "lenses-1", "", "", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/LENSES-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("47", "0", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "MEMORY-CARDS", "", "inherit", "open", "closed", "", "memory-cards", "", "", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/MEMORY-CARDS.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("48", "0", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "LAPTOP", "", "inherit", "open", "closed", "", "laptop", "", "", "2017-02-23 12:33:45", "2017-02-23 12:33:45", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/LAPTOP.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("49", "0", "2017-02-23 12:33:46", "2017-02-23 12:33:46", "", "timwilliamsslomosfmp4", "", "inherit", "open", "closed", "", "timwilliamsslomosfmp4", "", "", "2017-02-23 12:33:46", "2017-02-23 12:33:46", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/timwilliamsslomosfmp4.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("134", "0", "2017-02-23 13:08:10", "2017-02-23 13:08:10", "", "wheel_header", "", "inherit", "open", "closed", "", "wheel_header-2", "", "", "2017-02-23 13:08:10", "2017-02-23 13:08:10", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/wheel_header.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("135", "0", "2017-02-23 13:08:29", "2017-02-23 13:08:29", "", "about_1", "", "inherit", "open", "closed", "", "about_1-2", "", "", "2017-02-23 13:08:29", "2017-02-23 13:08:29", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/about_1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("136", "0", "2017-02-23 13:08:30", "2017-02-23 13:08:30", "", "about_2", "", "inherit", "open", "closed", "", "about_2-2", "", "", "2017-02-23 13:08:30", "2017-02-23 13:08:30", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/about_2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("137", "0", "2017-02-23 13:08:30", "2017-02-23 13:08:30", "", "about_3", "", "inherit", "open", "closed", "", "about_3-2", "", "", "2017-02-23 13:08:30", "2017-02-23 13:08:30", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/about_3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("138", "0", "2017-02-23 13:09:02", "2017-02-23 13:09:02", "", "materials", "", "inherit", "open", "closed", "", "materials-3", "", "", "2017-02-23 13:09:02", "2017-02-23 13:09:02", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/materials.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("139", "0", "2017-02-23 13:09:53", "2017-02-23 13:09:53", "", "blog", "", "inherit", "open", "closed", "", "blog-3", "", "", "2017-02-23 13:09:53", "2017-02-23 13:09:53", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/blog.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("149", "0", "2017-02-23 13:34:02", "2017-02-23 13:34:02", "", "portfolio_1", "", "inherit", "open", "closed", "", "portfolio_1", "", "", "2017-02-23 13:34:02", "2017-02-23 13:34:02", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("150", "0", "2017-02-23 13:34:03", "2017-02-23 13:34:03", "", "portfolio_2", "", "inherit", "open", "closed", "", "portfolio_2", "", "", "2017-02-23 13:34:03", "2017-02-23 13:34:03", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("151", "0", "2017-02-23 13:34:04", "2017-02-23 13:34:04", "", "portfolio_3", "", "inherit", "open", "closed", "", "portfolio_3", "", "", "2017-02-23 13:34:04", "2017-02-23 13:34:04", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("152", "0", "2017-02-23 13:34:06", "2017-02-23 13:34:06", "", "portfolio_4", "", "inherit", "open", "closed", "", "portfolio_4", "", "", "2017-02-23 13:34:06", "2017-02-23 13:34:06", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_4.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("153", "0", "2017-02-23 13:34:08", "2017-02-23 13:34:08", "", "portfolio_5", "", "inherit", "open", "closed", "", "portfolio_5", "", "", "2017-02-23 13:34:08", "2017-02-23 13:34:08", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_5.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("154", "0", "2017-02-23 13:34:09", "2017-02-23 13:34:09", "", "portfolio_6", "", "inherit", "open", "closed", "", "portfolio_6", "", "", "2017-02-23 13:34:09", "2017-02-23 13:34:09", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_6.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("155", "0", "2017-02-23 13:34:11", "2017-02-23 13:34:11", "", "portfolio_7", "", "inherit", "open", "closed", "", "portfolio_7", "", "", "2017-02-23 13:34:11", "2017-02-23 13:34:11", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_7.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("156", "0", "2017-02-23 13:34:12", "2017-02-23 13:34:12", "", "portfolio_8", "", "inherit", "open", "closed", "", "portfolio_8", "", "", "2017-02-23 13:34:12", "2017-02-23 13:34:12", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/portfolio_8.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("157", "0", "2017-02-23 13:34:14", "2017-02-23 13:34:14", "", "blog_1", "", "inherit", "open", "closed", "", "blog_1", "", "", "2017-02-23 13:34:14", "2017-02-23 13:34:14", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/blog_1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("158", "0", "2017-02-23 13:34:15", "2017-02-23 13:34:15", "", "blog_2", "", "inherit", "open", "closed", "", "blog_2", "", "", "2017-02-23 13:34:15", "2017-02-23 13:34:15", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/blog_2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("159", "0", "2017-02-23 13:34:17", "2017-02-23 13:34:17", "", "blog_3", "", "inherit", "open", "closed", "", "blog_3", "", "", "2017-02-23 13:34:17", "2017-02-23 13:34:17", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/blog_3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("183", "0", "2017-02-23 14:16:20", "2017-02-23 14:16:20", "", "divi", "", "publish", "closed", "closed", "", "divi", "", "", "2017-02-23 14:16:20", "2017-02-23 14:16:20", "", "0", "https://demo.infomaniak.com/divi-onepage/2017/02/23/divi/", "0", "custom_css", "", "0");
INSERT INTO `wp_522243_posts` VALUES("184", "0", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "ABOUT ME", "", "publish", "closed", "closed", "", "about-me", "", "", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/about-me/", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_522243_posts` VALUES("185", "0", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "MATERIALS", "", "publish", "closed", "closed", "", "materials", "", "", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/materials/", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_522243_posts` VALUES("186", "0", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "PORTFOLIO", "", "publish", "closed", "closed", "", "portfolio", "", "", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/portfolio/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_522243_posts` VALUES("187", "0", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "VIDEO", "", "publish", "closed", "closed", "", "video", "", "", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/video/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_522243_posts` VALUES("188", "0", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "BLOG", "", "publish", "closed", "closed", "", "blog", "", "", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/blog/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_522243_posts` VALUES("189", "0", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "CONTACT", "", "publish", "closed", "closed", "", "contact", "", "", "2020-05-02 03:11:18", "2020-05-02 10:11:18", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/contact/", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_522243_posts` VALUES("271", "0", "2017-02-27 12:35:10", "2017-02-27 12:35:10", "", "Instagram", "", "inherit", "open", "closed", "", "instagram", "", "", "2017-02-27 12:35:10", "2017-02-27 12:35:10", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/Instagram.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("273", "0", "2017-02-27 12:36:35", "2017-02-27 12:36:35", "", "500px", "", "inherit", "open", "closed", "", "500px-2", "", "", "2017-02-27 12:36:35", "2017-02-27 12:36:35", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/500px-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("274", "0", "2017-02-27 12:37:20", "2017-02-27 12:37:20", "", "Phone", "", "inherit", "open", "closed", "", "phone-2", "", "", "2017-02-27 12:37:20", "2017-02-27 12:37:20", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/Phone-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("275", "0", "2017-02-27 12:46:15", "2017-02-27 12:46:15", "", "Instagram_footer", "", "inherit", "open", "closed", "", "instagram_footer-2", "", "", "2017-02-27 12:46:15", "2017-02-27 12:46:15", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/Instagram_footer.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("276", "0", "2017-02-27 12:47:24", "2017-02-27 12:47:24", "", "tweeter_footer", "", "inherit", "open", "closed", "", "tweeter_footer-2", "", "", "2017-02-27 12:47:24", "2017-02-27 12:47:24", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/tweeter_footer-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("277", "0", "2017-02-27 12:48:00", "2017-02-27 12:48:00", "", "Facebook_footer", "", "inherit", "open", "closed", "", "facebook_footer-2", "", "", "2017-02-27 12:48:00", "2017-02-27 12:48:00", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/Facebook_footer.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("281", "0", "2017-02-27 13:12:49", "2017-02-27 13:12:49", "", "Logo", "", "inherit", "open", "closed", "", "logo", "", "", "2017-02-27 13:12:49", "2017-02-27 13:12:49", "", "0", "https://rz7i9acrnh.preview.infomaniak.website/wp-content/uploads/2017/02/Logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_522243_posts` VALUES("285", "1", "2020-05-03 02:39:21", "2020-05-03 09:39:21", "html, body {margin:0px;padding:0;}\n.entry-content {margin-top:0;margin-bottom:0;}\n.bio p {padding-bottom:0.5em;}\n\n@media screen and (orientation:portrait) {\n	    .elementor-lightbox .elementor-lightbox-item {\n    padding: 0;\n}\n    .dialog-type-lightbox .dialog-header, .dialog-type-lightbox .dialog-message{\n        padding:0;\n    }\n}\n@media screen and (orientation:landscape) {\n    .elementor-lightbox-image{min-height:100vh!important;\n			overflow:hidden;}\n}\n@media screen and (min-width:1450) {\n.elementor-widget-text-editor {\n    font-size:1.1rem;}\n}\n", "hello-elementor", "", "publish", "closed", "closed", "", "hello-elementor", "", "", "2020-05-03 02:39:21", "2020-05-03 09:39:21", "", "0", "https://nikkijames.net/hello-elementor/", "0", "custom_css", "", "0");
INSERT INTO `wp_522243_posts` VALUES("287", "1", "2020-05-03 02:56:08", "2020-05-03 09:56:08", "<h1>Nikki</h1>		\n			<h2>Get To Know Me</h2>		\n		<p>I do hope you enjoy my website and that it gives you a flavour of who I am and what excites me.</p><p>I am educated and intelligent, call Sydney home and love living here. I\'m fortunate to have been blessed with breathtaking 34D-24-34 curves on a toned, tanned, 5\'9\" dancer\'s frame. I am a perfect size 8 with fashionably short dark hair and hazel eyes. My soft lips and coy smile promise much and deliver more...</p><p>I enjoy passion, fun, and intimacy in equal measure, and like to think this shines through in all my encounters. My primary desire is to help you feel relaxed, refreshed, reinvigorated ~ and to find the most enjoyable path to that result. Of one thing you may be absolutely certain ~ when our encounter ends you will find yourself happier and satiated.</p><p>We\'re both adults and we both know what this is about.<br />You\'re reading this because you want intimacy without complication. Intense pleasure without the burden of guilt.<br />You want the beautiful woman you\'ve desired in magazines, or lingerie and swimsuit catalogues. The girlfriend you want for a night, or a weekend, or a few days. I\'m the forbidden fruit you can taste. It\'s who I am. It\'s what I do. It\'s a gift only a woman like me can give.</p><p>I have a primary income which meets my needs, so I entertain because I choose to.<br />It is something I genuinely enjoy doing.<br />I do what I do because I enjoy uncomplicated intimacy as much as you do.<br />Sex doesn\'t scare me - indeed, quite the opposite, it excites me.</p>		\n			<a href=\"#booking\" role=\"button\">\n						Book Me\n					</a>\n			<a href=\"#booking\" role=\"button\">\n						Book Me\n					</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-25.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-04.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-22.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-07.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-06.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-18.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-24.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-21.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-01.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-14.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-20.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-27.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-02.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n							<a href=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-05.jpg\" data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"all-86dc2e2\">\n														</a>\n                        <img width=\"853\" height=\"1280\" src=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15.jpg\" alt=\"\" srcset=\"https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15.jpg 853w, https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15-200x300.jpg 200w, https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15-682x1024.jpg 682w, https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15-768x1152.jpg 768w\" sizes=\"(max-width: 853px) 100vw, 853px\" />                    \n		<ul>\n									<li><a href=\"#\">				\n											One hour\n																			$600\n				</a></li>												<li><a href=\"#\">				\n											90 minutes\n																			$800\n				</a></li>												<li><a href=\"#\">				\n											Two hours\n																			$1000\n				</a></li>												<li><a href=\"#\">				\n											Three hours\n																			$1400\n				</a></li>												<li><a href=\"#\">				\n											Four hours\n																			$1700\n				</a></li>												<li><a href=\"#\">				\n											Overnight\n																			$3800\n															<p>12 hours with relaxation time</p>\n				</a></li>												<li><a href=\"#\">				\n											Whole day\n																			$5500\n															<p>24 hours with relaxation time</p>\n				</a></li>					\n		</ul>\n			<h3><a href=\"#booking\">Book Me</a></h3>		\n		<ul>\n									<li><a href=\"#\">				\n											Location\n																			Sydney\n															<p>Fly me to you by appointment</p>\n				</a></li>												<li><a href=\"#\">				\n											Age\n																			35\n				</a></li>												<li><a href=\"#\">				\n											Bust\n																			34D (enhanced)\n				</a></li>												<li><a href=\"#\">				\n											Waist\n																			24\n				</a></li>												<li><a href=\"#\">				\n											Hips\n																			34\n				</a></li>												<li><a href=\"#\">				\n											Height\n																			5\' 9\"\n				</a></li>												<li><a href=\"#\">				\n											Dress size\n																			2\n				</a></li>												<li><a href=\"#\">				\n											Shoe size\n																			7\n				</a></li>					\n		</ul>\n			<h3><a href=\"#booking\">Book Me</a></h3>		\n                        <img width=\"853\" height=\"1280\" src=\"http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16.jpg\" alt=\"\" srcset=\"https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16.jpg 853w, https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16-200x300.jpg 200w, https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16-682x1024.jpg 682w, https://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16-768x1152.jpg 768w\" sizes=\"(max-width: 853px) 100vw, 853px\" />                    \n			<h3>Touring</h3>		\n		<p>[text-blocks id=\"touring\"]<br />Sign up with this form to be advised when I’m touring.</p><p>[newsletter_form form=1]</p>		\n							<a href=\"https://twitter.com/\" target=\"_blank\" rel=\"nofollow noopener noreferrer\">\n					Twitter\n									</a>\n			<p>© NikkiJames.net<br />\nBookNikkiJames@gmail.com<br />Design by <a href=\"https://StickySites.ch\" target=\"new\" rel=\"noopener noreferrer\">StickySites.ch</a></p>		\n			<h3>Book Now</h3>", "Nikki James", "", "publish", "closed", "closed", "", "nikki-james", "", "", "2020-05-03 03:52:18", "2020-05-03 10:52:18", "", "0", "http://nikkijames.net/?page_id=287", "0", "page", "", "0");
INSERT INTO `wp_522243_posts` VALUES("290", "1", "2020-05-03 03:04:01", "2020-05-03 10:04:01", "", "Default Kit", "", "publish", "closed", "closed", "", "default-kit", "", "", "2020-05-03 03:04:01", "2020-05-03 10:04:01", "", "0", "http://nikkijames.net/?elementor_library=default-kit", "0", "elementor_library", "", "0");
INSERT INTO `wp_522243_posts` VALUES("291", "1", "2020-05-03 03:04:21", "2020-05-03 10:04:21", "", "Nikki_M_WEB_2.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_2-jpg", "", "", "2020-05-03 03:04:21", "2020-05-03 10:04:21", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("292", "1", "2020-05-03 03:04:22", "2020-05-03 10:04:22", "", "Nikki_M_WEB_16.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_16-jpg", "", "", "2020-05-03 03:04:22", "2020-05-03 10:04:22", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_16.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("293", "1", "2020-05-03 03:04:22", "2020-05-03 10:04:22", "", "Nikki_M_WEB_4.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_4-jpg", "", "", "2020-05-03 03:04:22", "2020-05-03 10:04:22", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_4.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("294", "1", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "hex-texture-custom-cc0.jpg", "", "inherit", "closed", "closed", "", "hex-texture-custom-cc0-jpg", "", "", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/hex-texture-custom-cc0.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("295", "1", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "Nikki_M_WEB_8.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_8-jpg", "", "", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_8.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("296", "1", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "Nikki_M_WEB_7.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_7-jpg", "", "", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_7.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("297", "1", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "Nikki_M_WEB_15.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_15-jpg", "", "", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_15.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("298", "1", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "Nikki_M_WEB_10.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_10-jpg", "", "", "2020-05-03 03:04:23", "2020-05-03 10:04:23", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("299", "1", "2020-05-03 03:04:24", "2020-05-03 10:04:24", "", "Nikki_M_WEB_14.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_14-jpg", "", "", "2020-05-03 03:04:24", "2020-05-03 10:04:24", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_14.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("300", "1", "2020-05-03 03:04:24", "2020-05-03 10:04:24", "", "Nikki_M_WEB_1.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_1-jpg", "", "", "2020-05-03 03:04:24", "2020-05-03 10:04:24", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("301", "1", "2020-05-03 03:04:24", "2020-05-03 10:04:24", "", "Nikki_M_WEB_13.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_13-jpg", "", "", "2020-05-03 03:04:24", "2020-05-03 10:04:24", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_13.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("302", "1", "2020-05-03 03:04:25", "2020-05-03 10:04:25", "", "Nikki_M_WEB_11.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_11-jpg", "", "", "2020-05-03 03:04:25", "2020-05-03 10:04:25", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_11.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("303", "1", "2020-05-03 03:04:25", "2020-05-03 10:04:25", "", "Nikki_M_WEB_5.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_5-jpg", "", "", "2020-05-03 03:04:25", "2020-05-03 10:04:25", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_5.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("304", "1", "2020-05-03 03:04:26", "2020-05-03 10:04:26", "", "Nikki_M_WEB_9.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_9-jpg", "", "", "2020-05-03 03:04:26", "2020-05-03 10:04:26", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_9.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("305", "1", "2020-05-03 03:04:26", "2020-05-03 10:04:26", "", "Nikki_M_WEB_6.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_6-jpg", "", "", "2020-05-03 03:04:26", "2020-05-03 10:04:26", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_6.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("306", "1", "2020-05-03 03:04:26", "2020-05-03 10:04:26", "", "Nikki_M_WEB_12.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_12-jpg", "", "", "2020-05-03 03:04:26", "2020-05-03 10:04:26", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_12.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("307", "1", "2020-05-03 03:04:27", "2020-05-03 10:04:27", "", "Nikki_M_WEB_3.jpg", "", "inherit", "closed", "closed", "", "Nikki_m_web_3-jpg", "", "", "2020-05-03 03:04:27", "2020-05-03 10:04:27", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/Gianna_M_WEB_3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("308", "1", "2020-05-03 03:04:27", "2020-05-03 10:04:27", "<h1>Nikki</h1>		\n		<p><a href=\"https://theeroticreview.com\" target=\"_blank\" rel=\"noopener noreferrer\"><img src=\"https://NikkiJames.net/wp-content/uploads/2020/02/TER_WL_176x132_CC.png\" alt=\"\" width=\"107\" height=\"80\" /></a> <a href=\"https://preferred411.com\" target=\"_blank\" rel=\"noopener noreferrer\"><img src=\"https://NikkiJames.net/wp-content/uploads/2020/01/preferredSeal-bw-1-1.png\" alt=\"\" width=\"73\" height=\"80\" /></a></p>		\n			<h2>Get To Know Me</h2>		\n		<p>Visit me in Orange County</p><p>Hi my name is Nikki.</p><p>I am a brunette bombshell from Orange County, at the young age of just 21... standing 5 foot 4 inches with exotic features. I have new fun enhanced assets reaching double D\'s.</p><p>I live a healthy lifestyle and enjoy being on the water - whether it be boating, beach, traveling to tropical beaches all over the world. I have a tight body and sexy kitten light brown eyes. I exercise almost everyday.</p><p>I present myself with superior first-rate standards; I am highly confident that you will enjoy our time together. I consider new ideas and look for a connection that is real. I am attentive sensual, passionate and I look forward to stimulating you every way possible. I look forward to meeting you in person...</p>		\n			<a href=\"#booking\" role=\"button\">\n						Book Me\n					</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_8.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_8.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_8.jpg\" title=\"Nikki_M_WEB_8.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_7.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_7.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_7.jpg\" title=\"Nikki_M_WEB_7.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_15.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_15.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_15.jpg\" title=\"Nikki_M_WEB_15.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_10.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_10.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_10.jpg\" title=\"Nikki_M_WEB_10.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_14.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_14.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_14.jpg\" title=\"Nikki_M_WEB_14.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_1.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_1.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_1.jpg\" title=\"Nikki_M_WEB_1.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_13.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_13.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_13.jpg\" title=\"Nikki_M_WEB_13.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_11.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_11.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_11.jpg\" title=\"Nikki_M_WEB_11.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_16.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_16.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_16.jpg\" title=\"Nikki_M_WEB_16.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_5.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_5.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_5.jpg\" title=\"Nikki_M_WEB_5.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_2.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_2.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_2.jpg\" title=\"Nikki_M_WEB_2.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_4.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_4.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_4.jpg\" title=\"Nikki_M_WEB_4.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_9.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_9.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_9.jpg\" title=\"Nikki_M_WEB_9.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_6.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_6.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_6.jpg\" title=\"Nikki_M_WEB_6.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_12.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_12.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_12.jpg\" title=\"Nikki_M_WEB_12.jpg\" />\n				</a>\n				<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6050e582\" data-elementor-lightbox-title=\"Nikki_M_WEB_3.jpg\" href=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_3.jpg\">\n			<img src=\"http://nikkijames.net/wp-content/uploads/2020/05/Nikki_M_WEB_3.jpg\" title=\"Nikki_M_WEB_3.jpg\" />\n				</a>\n		<ul>\n									<li><a href=\"#\">				\n											One hour\n																			$600\n				</a></li>												<li><a href=\"#\">				\n											90 minutes\n																			$750\n				</a></li>												<li><a href=\"#\">				\n											Two hours\n																			$1000\n				</a></li>												<li><a href=\"#\">				\n											Three hours\n																			$1500\n				</a></li>												<li><a href=\"#\">				\n											Twelve hours\n																			$5000\n															<p>LA and San Diego - 2hr minimum<br />\nFly me to you for 6 hours plus travel costs</p>\n				</a></li>												<li><a href=\"#\">				\n											Same day cancelation\n																			$200 fee\n				</a></li>												<li><a href=\"#\">				\n											Facetime online\n																			$200 for 20mins\n				</a></li>					\n		</ul>\n			<h3><a href=\"#booking\">Book Me</a></h3>		\n		<ul>\n									<li><a href=\"#\">				\n											Location\n																			Orange County\n															<p>LA & San Diego by appointment</p>\n				</a></li>												<li><a href=\"#\">				\n											Age\n																			21\n				</a></li>												<li><a href=\"#\">				\n											Bust\n																			34DD (enhanced)\n				</a></li>												<li><a href=\"#\">				\n											Waist\n																			24\n				</a></li>												<li><a href=\"#\">				\n											Hips\n																			34\n				</a></li>												<li><a href=\"#\">				\n											Height\n																			5\' 4\"\n				</a></li>												<li><a href=\"#\">				\n											Weight\n																			120lbs\n				</a></li>					\n		</ul>\n			<h3><a href=\"#booking\">Book Me</a></h3>		\n			<h3>Touring</h3>		\n		<p>[text-blocks id=\"touring\"]<br />Sign up with this form to be advised when I’m touring.</p><p>[newsletter_form form=1]</p>		\n							<a href=\"https://twitter.com/\" target=\"_blank\" rel=\"nofollow noopener noreferrer\">\n					Twitter\n									</a>\n			<p>© NikkiJames.net<br />\nBookNikkiJames@gmail.com<br />Design by <a href=\"https://StickySites.ch\" target=\"new\" rel=\"noopener noreferrer\">StickySites.ch</a></p>		\n			<h3>Book Now</h3>", "Nikki page", "", "publish", "closed", "closed", "", "Nikki-page", "", "", "2020-05-03 03:04:27", "2020-05-03 10:04:27", "", "0", "http://nikkijames.net/?elementor_library=gianna-page", "0", "elementor_library", "", "0");
INSERT INTO `wp_522243_posts` VALUES("311", "1", "2020-05-03 03:06:33", "2020-05-03 10:06:33", "", "NikkiJames-selfies-11", "", "inherit", "closed", "closed", "", "nikkijames-selfies-11", "", "", "2020-05-03 03:06:33", "2020-05-03 10:06:33", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-11.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("312", "1", "2020-05-03 03:06:34", "2020-05-03 10:06:34", "", "NikkiJames-selfies-10", "", "inherit", "closed", "closed", "", "nikkijames-selfies-10", "", "", "2020-05-03 03:06:34", "2020-05-03 10:06:34", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("313", "1", "2020-05-03 03:06:35", "2020-05-03 10:06:35", "", "NikkiJames-selfies-09", "", "inherit", "closed", "closed", "", "nikkijames-selfies-09", "", "", "2020-05-03 03:06:35", "2020-05-03 10:06:35", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-09.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("314", "1", "2020-05-03 03:06:35", "2020-05-03 10:06:35", "", "NikkiJames-selfies-08", "", "inherit", "closed", "closed", "", "nikkijames-selfies-08", "", "", "2020-05-03 03:06:35", "2020-05-03 10:06:35", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-08.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("315", "1", "2020-05-03 03:06:36", "2020-05-03 10:06:36", "", "NikkiJames-selfies-07", "", "inherit", "closed", "closed", "", "nikkijames-selfies-07", "", "", "2020-05-03 03:06:36", "2020-05-03 10:06:36", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-07.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("316", "1", "2020-05-03 03:06:37", "2020-05-03 10:06:37", "", "NikkiJames-selfies-06", "", "inherit", "closed", "closed", "", "nikkijames-selfies-06", "", "", "2020-05-03 03:06:37", "2020-05-03 10:06:37", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-06.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("317", "1", "2020-05-03 03:06:37", "2020-05-03 10:06:37", "", "NikkiJames-selfies-05", "", "inherit", "closed", "closed", "", "nikkijames-selfies-05", "", "", "2020-05-03 03:06:37", "2020-05-03 10:06:37", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-05.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("318", "1", "2020-05-03 03:06:38", "2020-05-03 10:06:38", "", "NikkiJames-selfies-04", "", "inherit", "closed", "closed", "", "nikkijames-selfies-04", "", "", "2020-05-03 03:06:38", "2020-05-03 10:06:38", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-04.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("319", "1", "2020-05-03 03:06:38", "2020-05-03 10:06:38", "", "NikkiJames-selfies-03", "", "inherit", "closed", "closed", "", "nikkijames-selfies-03", "", "", "2020-05-03 03:06:38", "2020-05-03 10:06:38", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-03.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("320", "1", "2020-05-03 03:06:39", "2020-05-03 10:06:39", "", "NikkiJames-selfies-02", "", "inherit", "closed", "closed", "", "nikkijames-selfies-02", "", "", "2020-05-03 03:06:39", "2020-05-03 10:06:39", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-02.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("321", "1", "2020-05-03 03:06:39", "2020-05-03 10:06:39", "", "NikkiJames-selfies-01", "", "inherit", "closed", "closed", "", "nikkijames-selfies-01", "", "", "2020-05-03 03:06:39", "2020-05-03 10:06:39", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-selfies-01.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("322", "1", "2020-05-03 03:06:40", "2020-05-03 10:06:40", "", "NikkiJames-prof-46", "", "inherit", "closed", "closed", "", "nikkijames-prof-46", "", "", "2020-05-03 03:06:40", "2020-05-03 10:06:40", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-46.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("323", "1", "2020-05-03 03:06:41", "2020-05-03 10:06:41", "", "NikkiJames-prof-45", "", "inherit", "closed", "closed", "", "nikkijames-prof-45", "", "", "2020-05-03 03:06:41", "2020-05-03 10:06:41", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-45.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("324", "1", "2020-05-03 03:06:42", "2020-05-03 10:06:42", "", "NikkiJames-prof-44", "", "inherit", "closed", "closed", "", "nikkijames-prof-44", "", "", "2020-05-03 03:06:42", "2020-05-03 10:06:42", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-44.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("325", "1", "2020-05-03 03:06:43", "2020-05-03 10:06:43", "", "NikkiJames-prof-43", "", "inherit", "closed", "closed", "", "nikkijames-prof-43", "", "", "2020-05-03 03:06:43", "2020-05-03 10:06:43", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-43.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("326", "1", "2020-05-03 03:06:44", "2020-05-03 10:06:44", "", "NikkiJames-prof-42", "", "inherit", "closed", "closed", "", "nikkijames-prof-42", "", "", "2020-05-03 03:06:44", "2020-05-03 10:06:44", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-42.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("327", "1", "2020-05-03 03:06:45", "2020-05-03 10:06:45", "", "NikkiJames-prof-41", "", "inherit", "closed", "closed", "", "nikkijames-prof-41", "", "", "2020-05-03 03:06:45", "2020-05-03 10:06:45", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-41.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("328", "1", "2020-05-03 03:06:46", "2020-05-03 10:06:46", "", "NikkiJames-prof-40", "", "inherit", "closed", "closed", "", "nikkijames-prof-40", "", "", "2020-05-03 03:06:46", "2020-05-03 10:06:46", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-40.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("329", "1", "2020-05-03 03:06:47", "2020-05-03 10:06:47", "", "NikkiJames-prof-39", "", "inherit", "closed", "closed", "", "nikkijames-prof-39", "", "", "2020-05-03 03:06:47", "2020-05-03 10:06:47", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-39.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("330", "1", "2020-05-03 03:06:48", "2020-05-03 10:06:48", "", "NikkiJames-prof-38", "", "inherit", "closed", "closed", "", "nikkijames-prof-38", "", "", "2020-05-03 03:06:48", "2020-05-03 10:06:48", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-38.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("331", "1", "2020-05-03 03:06:49", "2020-05-03 10:06:49", "", "NikkiJames-prof-37", "", "inherit", "closed", "closed", "", "nikkijames-prof-37", "", "", "2020-05-03 03:06:49", "2020-05-03 10:06:49", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-37.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("332", "1", "2020-05-03 03:06:50", "2020-05-03 10:06:50", "", "NikkiJames-prof-36", "", "inherit", "closed", "closed", "", "nikkijames-prof-36", "", "", "2020-05-03 03:06:50", "2020-05-03 10:06:50", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-36.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("333", "1", "2020-05-03 03:06:50", "2020-05-03 10:06:50", "", "NikkiJames-prof-35", "", "inherit", "closed", "closed", "", "nikkijames-prof-35", "", "", "2020-05-03 03:06:50", "2020-05-03 10:06:50", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-35.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("334", "1", "2020-05-03 03:06:51", "2020-05-03 10:06:51", "", "NikkiJames-prof-34", "", "inherit", "closed", "closed", "", "nikkijames-prof-34", "", "", "2020-05-03 03:06:51", "2020-05-03 10:06:51", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-34.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("335", "1", "2020-05-03 03:06:52", "2020-05-03 10:06:52", "", "NikkiJames-prof-33", "", "inherit", "closed", "closed", "", "nikkijames-prof-33", "", "", "2020-05-03 03:06:52", "2020-05-03 10:06:52", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-33.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("336", "1", "2020-05-03 03:06:52", "2020-05-03 10:06:52", "", "NikkiJames-prof-32", "", "inherit", "closed", "closed", "", "nikkijames-prof-32", "", "", "2020-05-03 03:06:52", "2020-05-03 10:06:52", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-32.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("337", "1", "2020-05-03 03:06:53", "2020-05-03 10:06:53", "", "NikkiJames-prof-31", "", "inherit", "closed", "closed", "", "nikkijames-prof-31", "", "", "2020-05-03 03:06:53", "2020-05-03 10:06:53", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-31.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("338", "1", "2020-05-03 03:06:54", "2020-05-03 10:06:54", "", "NikkiJames-prof-30", "", "inherit", "closed", "closed", "", "nikkijames-prof-30", "", "", "2020-05-03 03:06:54", "2020-05-03 10:06:54", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-30.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("339", "1", "2020-05-03 03:06:54", "2020-05-03 10:06:54", "", "NikkiJames-prof-29", "", "inherit", "closed", "closed", "", "nikkijames-prof-29", "", "", "2020-05-03 03:06:54", "2020-05-03 10:06:54", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-29.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("340", "1", "2020-05-03 03:06:55", "2020-05-03 10:06:55", "", "NikkiJames-prof-28", "", "inherit", "closed", "closed", "", "nikkijames-prof-28", "", "", "2020-05-03 03:06:55", "2020-05-03 10:06:55", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-28.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("341", "1", "2020-05-03 03:06:56", "2020-05-03 10:06:56", "", "NikkiJames-prof-27", "", "inherit", "closed", "closed", "", "nikkijames-prof-27", "", "", "2020-05-03 03:06:56", "2020-05-03 10:06:56", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-27.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("342", "1", "2020-05-03 03:06:57", "2020-05-03 10:06:57", "", "NikkiJames-prof-26", "", "inherit", "closed", "closed", "", "nikkijames-prof-26", "", "", "2020-05-03 03:06:57", "2020-05-03 10:06:57", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-26.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("343", "1", "2020-05-03 03:06:57", "2020-05-03 10:06:57", "", "NikkiJames-prof-25", "", "inherit", "closed", "closed", "", "nikkijames-prof-25", "", "", "2020-05-03 03:06:57", "2020-05-03 10:06:57", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-25.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("344", "1", "2020-05-03 03:06:58", "2020-05-03 10:06:58", "", "NikkiJames-prof-24", "", "inherit", "closed", "closed", "", "nikkijames-prof-24", "", "", "2020-05-03 03:06:58", "2020-05-03 10:06:58", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-24.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("345", "1", "2020-05-03 03:06:59", "2020-05-03 10:06:59", "", "NikkiJames-prof-23", "", "inherit", "closed", "closed", "", "nikkijames-prof-23", "", "", "2020-05-03 03:06:59", "2020-05-03 10:06:59", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-23.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("346", "1", "2020-05-03 03:07:00", "2020-05-03 10:07:00", "", "NikkiJames-prof-22", "", "inherit", "closed", "closed", "", "nikkijames-prof-22", "", "", "2020-05-03 03:07:00", "2020-05-03 10:07:00", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-22.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("347", "1", "2020-05-03 03:07:01", "2020-05-03 10:07:01", "", "NikkiJames-prof-21", "", "inherit", "closed", "closed", "", "nikkijames-prof-21", "", "", "2020-05-03 03:07:01", "2020-05-03 10:07:01", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-21.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("348", "1", "2020-05-03 03:07:02", "2020-05-03 10:07:02", "", "NikkiJames-prof-20", "", "inherit", "closed", "closed", "", "nikkijames-prof-20", "", "", "2020-05-03 03:07:02", "2020-05-03 10:07:02", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-20.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("349", "1", "2020-05-03 03:07:02", "2020-05-03 10:07:02", "", "NikkiJames-prof-19", "", "inherit", "closed", "closed", "", "nikkijames-prof-19", "", "", "2020-05-03 03:07:02", "2020-05-03 10:07:02", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-19.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("350", "1", "2020-05-03 03:07:03", "2020-05-03 10:07:03", "", "NikkiJames-prof-18", "", "inherit", "closed", "closed", "", "nikkijames-prof-18", "", "", "2020-05-03 03:07:03", "2020-05-03 10:07:03", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-18.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("351", "1", "2020-05-03 03:07:05", "2020-05-03 10:07:05", "", "NikkiJames-prof-17", "", "inherit", "closed", "closed", "", "nikkijames-prof-17", "", "", "2020-05-03 03:07:05", "2020-05-03 10:07:05", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-17.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("352", "1", "2020-05-03 03:07:06", "2020-05-03 10:07:06", "", "NikkiJames-prof-16", "", "inherit", "closed", "closed", "", "nikkijames-prof-16", "", "", "2020-05-03 03:07:06", "2020-05-03 10:07:06", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-16.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("353", "1", "2020-05-03 03:07:07", "2020-05-03 10:07:07", "", "NikkiJames-prof-15", "", "inherit", "closed", "closed", "", "nikkijames-prof-15", "", "", "2020-05-03 03:07:07", "2020-05-03 10:07:07", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-15.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("354", "1", "2020-05-03 03:07:07", "2020-05-03 10:07:07", "", "NikkiJames-prof-14", "", "inherit", "closed", "closed", "", "nikkijames-prof-14", "", "", "2020-05-03 03:07:07", "2020-05-03 10:07:07", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-14.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("355", "1", "2020-05-03 03:07:08", "2020-05-03 10:07:08", "", "NikkiJames-prof-13", "", "inherit", "closed", "closed", "", "nikkijames-prof-13", "", "", "2020-05-03 03:07:08", "2020-05-03 10:07:08", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-13.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("356", "1", "2020-05-03 03:07:09", "2020-05-03 10:07:09", "", "NikkiJames-prof-12", "", "inherit", "closed", "closed", "", "nikkijames-prof-12", "", "", "2020-05-03 03:07:09", "2020-05-03 10:07:09", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-12.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("357", "1", "2020-05-03 03:07:10", "2020-05-03 10:07:10", "", "NikkiJames-prof-11", "", "inherit", "closed", "closed", "", "nikkijames-prof-11", "", "", "2020-05-03 03:07:10", "2020-05-03 10:07:10", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-11.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("358", "1", "2020-05-03 03:07:11", "2020-05-03 10:07:11", "", "NikkiJames-prof-10", "", "inherit", "closed", "closed", "", "nikkijames-prof-10", "", "", "2020-05-03 03:07:11", "2020-05-03 10:07:11", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("359", "1", "2020-05-03 03:07:12", "2020-05-03 10:07:12", "", "NikkiJames-prof-09", "", "inherit", "closed", "closed", "", "nikkijames-prof-09", "", "", "2020-05-03 03:07:12", "2020-05-03 10:07:12", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-09.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("360", "1", "2020-05-03 03:07:13", "2020-05-03 10:07:13", "", "NikkiJames-prof-08", "", "inherit", "closed", "closed", "", "nikkijames-prof-08", "", "", "2020-05-03 03:07:13", "2020-05-03 10:07:13", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-08.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("361", "1", "2020-05-03 03:07:14", "2020-05-03 10:07:14", "", "NikkiJames-prof-07", "", "inherit", "closed", "closed", "", "nikkijames-prof-07", "", "", "2020-05-03 03:07:14", "2020-05-03 10:07:14", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-07.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("362", "1", "2020-05-03 03:07:15", "2020-05-03 10:07:15", "", "NikkiJames-prof-06", "", "inherit", "closed", "closed", "", "nikkijames-prof-06", "", "", "2020-05-03 03:07:15", "2020-05-03 10:07:15", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-06.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("363", "1", "2020-05-03 03:07:16", "2020-05-03 10:07:16", "", "NikkiJames-prof-05", "", "inherit", "closed", "closed", "", "nikkijames-prof-05", "", "", "2020-05-03 03:07:16", "2020-05-03 10:07:16", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-05.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("364", "1", "2020-05-03 03:07:17", "2020-05-03 10:07:17", "", "NikkiJames-prof-04", "", "inherit", "closed", "closed", "", "nikkijames-prof-04", "", "", "2020-05-03 03:07:17", "2020-05-03 10:07:17", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-04.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("365", "1", "2020-05-03 03:07:18", "2020-05-03 10:07:18", "", "NikkiJames-prof-03", "", "inherit", "closed", "closed", "", "nikkijames-prof-03", "", "", "2020-05-03 03:07:18", "2020-05-03 10:07:18", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-03.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("366", "1", "2020-05-03 03:07:19", "2020-05-03 10:07:19", "", "NikkiJames-prof-02", "", "inherit", "closed", "closed", "", "nikkijames-prof-02", "", "", "2020-05-03 03:07:19", "2020-05-03 10:07:19", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-02.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("367", "1", "2020-05-03 03:07:20", "2020-05-03 10:07:20", "", "NikkiJames-prof-01", "", "inherit", "closed", "closed", "", "nikkijames-prof-01", "", "", "2020-05-03 03:07:20", "2020-05-03 10:07:20", "", "0", "http://nikkijames.net/wp-content/uploads/2020/05/NikkiJames-prof-01.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_522243_posts` VALUES("405", "1", "2020-05-03 03:58:00", "2020-05-03 10:58:00", "Watch this space for my touring plans", "Touring", "", "publish", "closed", "closed", "", "touring", "", "", "2020-05-03 03:58:00", "2020-05-03 10:58:00", "", "0", "http://nikkijames.net/?post_type=text-blocks&#038;p=405", "0", "text-blocks", "", "0");

/* INSERT TABLE DATA: wp_522243_snippets */
INSERT INTO `wp_522243_snippets` VALUES("1", "Example HTML shortcode", "This is an example snippet for demonstrating how to add an HTML shortcode.\n\nYou can remove it, or edit it to add your own content.", "\nadd_shortcode( \'shortcode_name\', function () {\n\n	$out = \'<p>write your HTML shortcode content here</p>\';\n\n	return $out;\n} );", "shortcode", "global", "10", "0", "2020-05-03 09:40:57");
INSERT INTO `wp_522243_snippets` VALUES("2", "Example CSS snippet", "This is an example snippet for demonstrating how to add custom CSS code to your website.\n\nYou can remove it, or edit it to add your own content.", "\nadd_action( \'wp_head\', function () { ?>\n<style>\n\n	/* write your CSS code here */\n\n</style>\n<?php } );\n", "css", "front-end", "10", "0", "2020-05-03 09:40:57");
INSERT INTO `wp_522243_snippets` VALUES("3", "Example JavaScript snippet", "This is an example snippet for demonstrating how to add custom JavaScript code to your website.\n\nYou can remove it, or edit it to add your own content.", "\nadd_action( \'wp_head\', function () { ?>\n<script>\n\n	/* write your JavaScript code here */\n\n</script>\n<?php } );\n", "javascript", "front-end", "10", "0", "2020-05-03 09:40:57");
INSERT INTO `wp_522243_snippets` VALUES("4", "Order snippets by name", "Order snippets by name by default in the snippets table.", "\nadd_filter( \'code_snippets/list_table/default_orderby\', function () {\n	return \'name\';\n} );\n", "code-snippets-plugin", "admin", "10", "0", "2020-05-03 09:40:57");
INSERT INTO `wp_522243_snippets` VALUES("5", "Order snippets by date", "Order snippets by last modification date by default in the snippets table.", "\nadd_filter( \'code_snippets/list_table/default_orderby\', function () {\n	return \'modified\';\n} );\n\nadd_filter( \'code_snippets/list_table/default_order\', function () {\n	return \'desc\';\n} );\n", "code-snippets-plugin", "admin", "10", "0", "2020-05-03 09:40:57");

/* INSERT TABLE DATA: wp_522243_term_relationships */
INSERT INTO `wp_522243_term_relationships` VALUES("184", "3", "0");
INSERT INTO `wp_522243_term_relationships` VALUES("185", "3", "0");
INSERT INTO `wp_522243_term_relationships` VALUES("186", "3", "0");
INSERT INTO `wp_522243_term_relationships` VALUES("187", "3", "0");
INSERT INTO `wp_522243_term_relationships` VALUES("188", "3", "0");
INSERT INTO `wp_522243_term_relationships` VALUES("189", "3", "0");
INSERT INTO `wp_522243_term_relationships` VALUES("308", "4", "0");

/* INSERT TABLE DATA: wp_522243_term_taxonomy */
INSERT INTO `wp_522243_term_taxonomy` VALUES("1", "1", "category", "", "0", "0");
INSERT INTO `wp_522243_term_taxonomy` VALUES("2", "2", "category", "", "0", "0");
INSERT INTO `wp_522243_term_taxonomy` VALUES("3", "3", "nav_menu", "", "0", "6");
INSERT INTO `wp_522243_term_taxonomy` VALUES("4", "4", "elementor_library_type", "", "0", "1");

/* INSERT TABLE DATA: wp_522243_terms */
INSERT INTO `wp_522243_terms` VALUES("1", "Uncategorized", "uncategorized", "0");
INSERT INTO `wp_522243_terms` VALUES("2", "Blog", "blog", "0");
INSERT INTO `wp_522243_terms` VALUES("3", "MSW-PRIMARY-MENU-PHOTOGRAPHY", "msw-primary-menu-photography", "0");
INSERT INTO `wp_522243_terms` VALUES("4", "page", "page", "0");

/* INSERT TABLE DATA: wp_522243_usermeta */
INSERT INTO `wp_522243_usermeta` VALUES("1", "1", "nickname", "svadmin");
INSERT INTO `wp_522243_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_522243_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_522243_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_522243_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_522243_usermeta` VALUES("6", "1", "syntax_highlighting", "true");
INSERT INTO `wp_522243_usermeta` VALUES("7", "1", "comment_shortcuts", "false");
INSERT INTO `wp_522243_usermeta` VALUES("8", "1", "admin_color", "fresh");
INSERT INTO `wp_522243_usermeta` VALUES("9", "1", "use_ssl", "0");
INSERT INTO `wp_522243_usermeta` VALUES("10", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_522243_usermeta` VALUES("11", "1", "locale", "");
INSERT INTO `wp_522243_usermeta` VALUES("12", "1", "wp_522243_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_522243_usermeta` VALUES("13", "1", "wp_522243_user_level", "10");
INSERT INTO `wp_522243_usermeta` VALUES("14", "1", "dismissed_wp_pointers", "");
INSERT INTO `wp_522243_usermeta` VALUES("15", "1", "show_welcome_panel", "0");
INSERT INTO `wp_522243_usermeta` VALUES("16", "1", "session_tokens", "a:2:{s:64:\"098de9e40e0405808347b9ab57bc559cd12c9ebe4ee974d8138a8d15e292216c\";a:4:{s:10:\"expiration\";i:1588671387;s:2:\"ip\";s:12:\"88.8.240.109\";s:2:\"ua\";s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.129 Safari/537.36\";s:5:\"login\";i:1588498587;}s:64:\"d2a052aff5c2a775797bf52f20db85a1eb46e217b099407fe7f121844a8c7dc0\";a:4:{s:10:\"expiration\";i:1588671422;s:2:\"ip\";s:12:\"88.8.240.109\";s:2:\"ua\";s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.129 Safari/537.36\";s:5:\"login\";i:1588498622;}}");
INSERT INTO `wp_522243_usermeta` VALUES("17", "1", "wp_522243_dashboard_quick_press_last_post_id", "283");
INSERT INTO `wp_522243_usermeta` VALUES("18", "1", "community-events-location", "a:1:{s:2:\"ip\";s:10:\"88.8.240.0\";}");
INSERT INTO `wp_522243_usermeta` VALUES("19", "1", "_hello_elementor_install_notice", "true");
INSERT INTO `wp_522243_usermeta` VALUES("20", "1", "itsec_user_activity_last_seen", "1588502458");
INSERT INTO `wp_522243_usermeta` VALUES("21", "1", "wp_522243_elementor_connect_common_data", "a:7:{s:9:\"client_id\";s:32:\"2Z9gSU770MlacoYnIO7CAQqQXIerCwh9\";s:11:\"auth_secret\";s:32:\"E2DtTPnqYvsSft4g3MjZdoBZLwqWWSy6\";s:12:\"access_token\";s:32:\"p8pu3ykbASGD2e1UFYYHvxCP8K99KDnF\";s:19:\"access_token_secret\";s:32:\"hPEVUdxeBnnKLKmIV1VA7X1xBrEKSroy\";s:10:\"token_type\";s:6:\"bearer\";s:4:\"user\";O:8:\"stdClass\":1:{s:5:\"email\";s:20:\"kwebmaster@pobox.com\";}s:19:\"data_share_opted_in\";b:1;}");
INSERT INTO `wp_522243_usermeta` VALUES("22", "1", "itsec-settings-view", "grid");
INSERT INTO `wp_522243_usermeta` VALUES("23", "1", "elementor_preferences", "a:1:{s:8:\"ui_theme\";s:4:\"dark\";}");
INSERT INTO `wp_522243_usermeta` VALUES("24", "1", "elementor_introduction", "a:2:{s:10:\"rightClick\";b:1;s:19:\"colorPickerDropping\";b:1;}");
INSERT INTO `wp_522243_usermeta` VALUES("25", "1", "wp_522243_user-settings", "libraryContent=browse&editor=tinymce");
INSERT INTO `wp_522243_usermeta` VALUES("26", "1", "wp_522243_user-settings-time", "1588503174");

/* INSERT TABLE DATA: wp_522243_users */
INSERT INTO `wp_522243_users` VALUES("1", "svadmin", "$P$B3vHzhGCPsg4hQj8ppCc/7PtfC/2Oj.", "svadmin", "stickysites@protonmail.com", "https://rz7i9acrnh.preview.infomaniak.website", "2020-05-02 10:10:49", "", "0", "svadmin");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2020-05-03 11:01:28*/
/* DUPLICATOR_MYSQLDUMP_EOF */
